// Copyright 2012-2014 The Rust Project Developers. See the COPYRIGHT
// file at the top-level directory of this distribution and at
// http://rust-lang.org/COPYRIGHT.
//
// Licensed under the Apache License, Version 2.0 <LICENSE-APACHE or
// http://www.apache.org/licenses/LICENSE-2.0> or the MIT license
// <LICENSE-MIT or http://opensource.org/licenses/MIT>, at your
// option. This file may not be copied, modified, or distributed
// except according to those terms.

use std::io::process::Command;
use std::os;

fn main() {
    let args = os::args();
    let args = args.as_slice();
    if args.len() > 1 && args[1].as_slice() == "segfault" {
        unsafe { *(0 as *mut int) = 1 }; // trigger a segfault
    } else {
        let segfault = Command::new(args[0].as_slice()).arg("segfault").output().unwrap();
        assert!(!segfault.status.success());
        let error = String::from_utf8_lossy(segfault.error.as_slice());
        assert!(!error.as_slice().contains("has overflowed its stack"));
    }
}
