// Copyright 2012-2014 The Rust Project Developers. See the COPYRIGHT
// file at the top-level directory of this distribution and at
// http://rust-lang.org/COPYRIGHT.
//
// Licensed under the Apache License, Version 2.0 <LICENSE-APACHE or
// http://www.apache.org/licenses/LICENSE-2.0> or the MIT license
// <LICENSE-MIT or http://opensource.org/licenses/MIT>, at your
// option. This file may not be copied, modified, or distributed
// except according to those terms.

// NOTE: The following code was generated by "src/etc/unicode.py", do not edit directly

#![allow(missing_docs, non_upper_case_globals, non_snake_case)]

/// The version of [Unicode](http://www.unicode.org/)
/// that the `UnicodeChar` and `UnicodeStrPrelude` traits are based on.
pub const UNICODE_VERSION: (uint, uint, uint) = (7, 0, 0);

fn bsearch_range_table(c: char, r: &'static [(char,char)]) -> bool {
    use core::cmp::{Equal, Less, Greater};
    use core::slice::SlicePrelude;
    r.binary_search(|&(lo,hi)| {
        if lo <= c && c <= hi { Equal }
        else if hi < c { Less }
        else { Greater }
    }).found().is_some()
}

pub mod general_category {
    pub static C_table: &'static [(char, char)] = &[
        ('\x00', '\x1f'), ('\x7f', '\u009f'), ('\u00ad', '\u00ad'), ('\u0378', '\u0379'), ('\u0380',
        '\u0383'), ('\u038b', '\u038b'), ('\u038d', '\u038d'), ('\u03a2', '\u03a2'), ('\u0530',
        '\u0530'), ('\u0557', '\u0558'), ('\u0560', '\u0560'), ('\u0588', '\u0588'), ('\u058b',
        '\u058c'), ('\u0590', '\u0590'), ('\u05c8', '\u05cf'), ('\u05eb', '\u05ef'), ('\u05f5',
        '\u0605'), ('\u061c', '\u061d'), ('\u06dd', '\u06dd'), ('\u070e', '\u070f'), ('\u074b',
        '\u074c'), ('\u07b2', '\u07bf'), ('\u07fb', '\u07ff'), ('\u082e', '\u082f'), ('\u083f',
        '\u083f'), ('\u085c', '\u085d'), ('\u085f', '\u089f'), ('\u08b3', '\u08e3'), ('\u0984',
        '\u0984'), ('\u098d', '\u098e'), ('\u0991', '\u0992'), ('\u09a9', '\u09a9'), ('\u09b1',
        '\u09b1'), ('\u09b3', '\u09b5'), ('\u09ba', '\u09bb'), ('\u09c5', '\u09c6'), ('\u09c9',
        '\u09ca'), ('\u09cf', '\u09d6'), ('\u09d8', '\u09db'), ('\u09de', '\u09de'), ('\u09e4',
        '\u09e5'), ('\u09fc', '\u0a00'), ('\u0a04', '\u0a04'), ('\u0a0b', '\u0a0e'), ('\u0a11',
        '\u0a12'), ('\u0a29', '\u0a29'), ('\u0a31', '\u0a31'), ('\u0a34', '\u0a34'), ('\u0a37',
        '\u0a37'), ('\u0a3a', '\u0a3b'), ('\u0a3d', '\u0a3d'), ('\u0a43', '\u0a46'), ('\u0a49',
        '\u0a4a'), ('\u0a4e', '\u0a50'), ('\u0a52', '\u0a58'), ('\u0a5d', '\u0a5d'), ('\u0a5f',
        '\u0a65'), ('\u0a76', '\u0a80'), ('\u0a84', '\u0a84'), ('\u0a8e', '\u0a8e'), ('\u0a92',
        '\u0a92'), ('\u0aa9', '\u0aa9'), ('\u0ab1', '\u0ab1'), ('\u0ab4', '\u0ab4'), ('\u0aba',
        '\u0abb'), ('\u0ac6', '\u0ac6'), ('\u0aca', '\u0aca'), ('\u0ace', '\u0acf'), ('\u0ad1',
        '\u0adf'), ('\u0ae4', '\u0ae5'), ('\u0af2', '\u0b00'), ('\u0b04', '\u0b04'), ('\u0b0d',
        '\u0b0e'), ('\u0b11', '\u0b12'), ('\u0b29', '\u0b29'), ('\u0b31', '\u0b31'), ('\u0b34',
        '\u0b34'), ('\u0b3a', '\u0b3b'), ('\u0b45', '\u0b46'), ('\u0b49', '\u0b4a'), ('\u0b4e',
        '\u0b55'), ('\u0b58', '\u0b5b'), ('\u0b5e', '\u0b5e'), ('\u0b64', '\u0b65'), ('\u0b78',
        '\u0b81'), ('\u0b84', '\u0b84'), ('\u0b8b', '\u0b8d'), ('\u0b91', '\u0b91'), ('\u0b96',
        '\u0b98'), ('\u0b9b', '\u0b9b'), ('\u0b9d', '\u0b9d'), ('\u0ba0', '\u0ba2'), ('\u0ba5',
        '\u0ba7'), ('\u0bab', '\u0bad'), ('\u0bba', '\u0bbd'), ('\u0bc3', '\u0bc5'), ('\u0bc9',
        '\u0bc9'), ('\u0bce', '\u0bcf'), ('\u0bd1', '\u0bd6'), ('\u0bd8', '\u0be5'), ('\u0bfb',
        '\u0bff'), ('\u0c04', '\u0c04'), ('\u0c0d', '\u0c0d'), ('\u0c11', '\u0c11'), ('\u0c29',
        '\u0c29'), ('\u0c3a', '\u0c3c'), ('\u0c45', '\u0c45'), ('\u0c49', '\u0c49'), ('\u0c4e',
        '\u0c54'), ('\u0c57', '\u0c57'), ('\u0c5a', '\u0c5f'), ('\u0c64', '\u0c65'), ('\u0c70',
        '\u0c77'), ('\u0c80', '\u0c80'), ('\u0c84', '\u0c84'), ('\u0c8d', '\u0c8d'), ('\u0c91',
        '\u0c91'), ('\u0ca9', '\u0ca9'), ('\u0cb4', '\u0cb4'), ('\u0cba', '\u0cbb'), ('\u0cc5',
        '\u0cc5'), ('\u0cc9', '\u0cc9'), ('\u0cce', '\u0cd4'), ('\u0cd7', '\u0cdd'), ('\u0cdf',
        '\u0cdf'), ('\u0ce4', '\u0ce5'), ('\u0cf0', '\u0cf0'), ('\u0cf3', '\u0d00'), ('\u0d04',
        '\u0d04'), ('\u0d0d', '\u0d0d'), ('\u0d11', '\u0d11'), ('\u0d3b', '\u0d3c'), ('\u0d45',
        '\u0d45'), ('\u0d49', '\u0d49'), ('\u0d4f', '\u0d56'), ('\u0d58', '\u0d5f'), ('\u0d64',
        '\u0d65'), ('\u0d76', '\u0d78'), ('\u0d80', '\u0d81'), ('\u0d84', '\u0d84'), ('\u0d97',
        '\u0d99'), ('\u0db2', '\u0db2'), ('\u0dbc', '\u0dbc'), ('\u0dbe', '\u0dbf'), ('\u0dc7',
        '\u0dc9'), ('\u0dcb', '\u0dce'), ('\u0dd5', '\u0dd5'), ('\u0dd7', '\u0dd7'), ('\u0de0',
        '\u0de5'), ('\u0df0', '\u0df1'), ('\u0df5', '\u0e00'), ('\u0e3b', '\u0e3e'), ('\u0e5c',
        '\u0e80'), ('\u0e83', '\u0e83'), ('\u0e85', '\u0e86'), ('\u0e89', '\u0e89'), ('\u0e8b',
        '\u0e8c'), ('\u0e8e', '\u0e93'), ('\u0e98', '\u0e98'), ('\u0ea0', '\u0ea0'), ('\u0ea4',
        '\u0ea4'), ('\u0ea6', '\u0ea6'), ('\u0ea8', '\u0ea9'), ('\u0eac', '\u0eac'), ('\u0eba',
        '\u0eba'), ('\u0ebe', '\u0ebf'), ('\u0ec5', '\u0ec5'), ('\u0ec7', '\u0ec7'), ('\u0ece',
        '\u0ecf'), ('\u0eda', '\u0edb'), ('\u0ee0', '\u0eff'), ('\u0f48', '\u0f48'), ('\u0f6d',
        '\u0f70'), ('\u0f98', '\u0f98'), ('\u0fbd', '\u0fbd'), ('\u0fcd', '\u0fcd'), ('\u0fdb',
        '\u0fff'), ('\u10c6', '\u10c6'), ('\u10c8', '\u10cc'), ('\u10ce', '\u10cf'), ('\u1249',
        '\u1249'), ('\u124e', '\u124f'), ('\u1257', '\u1257'), ('\u1259', '\u1259'), ('\u125e',
        '\u125f'), ('\u1289', '\u1289'), ('\u128e', '\u128f'), ('\u12b1', '\u12b1'), ('\u12b6',
        '\u12b7'), ('\u12bf', '\u12bf'), ('\u12c1', '\u12c1'), ('\u12c6', '\u12c7'), ('\u12d7',
        '\u12d7'), ('\u1311', '\u1311'), ('\u1316', '\u1317'), ('\u135b', '\u135c'), ('\u137d',
        '\u137f'), ('\u139a', '\u139f'), ('\u13f5', '\u13ff'), ('\u169d', '\u169f'), ('\u16f9',
        '\u16ff'), ('\u170d', '\u170d'), ('\u1715', '\u171f'), ('\u1737', '\u173f'), ('\u1754',
        '\u175f'), ('\u176d', '\u176d'), ('\u1771', '\u1771'), ('\u1774', '\u177f'), ('\u17de',
        '\u17df'), ('\u17ea', '\u17ef'), ('\u17fa', '\u17ff'), ('\u180e', '\u180f'), ('\u181a',
        '\u181f'), ('\u1878', '\u187f'), ('\u18ab', '\u18af'), ('\u18f6', '\u18ff'), ('\u191f',
        '\u191f'), ('\u192c', '\u192f'), ('\u193c', '\u193f'), ('\u1941', '\u1943'), ('\u196e',
        '\u196f'), ('\u1975', '\u197f'), ('\u19ac', '\u19af'), ('\u19ca', '\u19cf'), ('\u19db',
        '\u19dd'), ('\u1a1c', '\u1a1d'), ('\u1a5f', '\u1a5f'), ('\u1a7d', '\u1a7e'), ('\u1a8a',
        '\u1a8f'), ('\u1a9a', '\u1a9f'), ('\u1aae', '\u1aaf'), ('\u1abf', '\u1aff'), ('\u1b4c',
        '\u1b4f'), ('\u1b7d', '\u1b7f'), ('\u1bf4', '\u1bfb'), ('\u1c38', '\u1c3a'), ('\u1c4a',
        '\u1c4c'), ('\u1c80', '\u1cbf'), ('\u1cc8', '\u1ccf'), ('\u1cf7', '\u1cf7'), ('\u1cfa',
        '\u1cff'), ('\u1df6', '\u1dfb'), ('\u1f16', '\u1f17'), ('\u1f1e', '\u1f1f'), ('\u1f46',
        '\u1f47'), ('\u1f4e', '\u1f4f'), ('\u1f58', '\u1f58'), ('\u1f5a', '\u1f5a'), ('\u1f5c',
        '\u1f5c'), ('\u1f5e', '\u1f5e'), ('\u1f7e', '\u1f7f'), ('\u1fb5', '\u1fb5'), ('\u1fc5',
        '\u1fc5'), ('\u1fd4', '\u1fd5'), ('\u1fdc', '\u1fdc'), ('\u1ff0', '\u1ff1'), ('\u1ff5',
        '\u1ff5'), ('\u1fff', '\u1fff'), ('\u200b', '\u200f'), ('\u202a', '\u202e'), ('\u2060',
        '\u206f'), ('\u2072', '\u2073'), ('\u208f', '\u208f'), ('\u209d', '\u209f'), ('\u20be',
        '\u20cf'), ('\u20f1', '\u20ff'), ('\u218a', '\u218f'), ('\u23fb', '\u23ff'), ('\u2427',
        '\u243f'), ('\u244b', '\u245f'), ('\u2b74', '\u2b75'), ('\u2b96', '\u2b97'), ('\u2bba',
        '\u2bbc'), ('\u2bc9', '\u2bc9'), ('\u2bd2', '\u2bff'), ('\u2c2f', '\u2c2f'), ('\u2c5f',
        '\u2c5f'), ('\u2cf4', '\u2cf8'), ('\u2d26', '\u2d26'), ('\u2d28', '\u2d2c'), ('\u2d2e',
        '\u2d2f'), ('\u2d68', '\u2d6e'), ('\u2d71', '\u2d7e'), ('\u2d97', '\u2d9f'), ('\u2da7',
        '\u2da7'), ('\u2daf', '\u2daf'), ('\u2db7', '\u2db7'), ('\u2dbf', '\u2dbf'), ('\u2dc7',
        '\u2dc7'), ('\u2dcf', '\u2dcf'), ('\u2dd7', '\u2dd7'), ('\u2ddf', '\u2ddf'), ('\u2e43',
        '\u2e7f'), ('\u2e9a', '\u2e9a'), ('\u2ef4', '\u2eff'), ('\u2fd6', '\u2fef'), ('\u2ffc',
        '\u2fff'), ('\u3040', '\u3040'), ('\u3097', '\u3098'), ('\u3100', '\u3104'), ('\u312e',
        '\u3130'), ('\u318f', '\u318f'), ('\u31bb', '\u31bf'), ('\u31e4', '\u31ef'), ('\u321f',
        '\u321f'), ('\u32ff', '\u32ff'), ('\u3401', '\u4db4'), ('\u4db6', '\u4dbf'), ('\u4e01',
        '\u9fcb'), ('\u9fcd', '\u9fff'), ('\ua48d', '\ua48f'), ('\ua4c7', '\ua4cf'), ('\ua62c',
        '\ua63f'), ('\ua69e', '\ua69e'), ('\ua6f8', '\ua6ff'), ('\ua78f', '\ua78f'), ('\ua7ae',
        '\ua7af'), ('\ua7b2', '\ua7f6'), ('\ua82c', '\ua82f'), ('\ua83a', '\ua83f'), ('\ua878',
        '\ua87f'), ('\ua8c5', '\ua8cd'), ('\ua8da', '\ua8df'), ('\ua8fc', '\ua8ff'), ('\ua954',
        '\ua95e'), ('\ua97d', '\ua97f'), ('\ua9ce', '\ua9ce'), ('\ua9da', '\ua9dd'), ('\ua9ff',
        '\ua9ff'), ('\uaa37', '\uaa3f'), ('\uaa4e', '\uaa4f'), ('\uaa5a', '\uaa5b'), ('\uaac3',
        '\uaada'), ('\uaaf7', '\uab00'), ('\uab07', '\uab08'), ('\uab0f', '\uab10'), ('\uab17',
        '\uab1f'), ('\uab27', '\uab27'), ('\uab2f', '\uab2f'), ('\uab60', '\uab63'), ('\uab66',
        '\uabbf'), ('\uabee', '\uabef'), ('\uabfa', '\uabff'), ('\uac01', '\ud7a2'), ('\ud7a4',
        '\ud7af'), ('\ud7c7', '\ud7ca'), ('\ud7fc', '\ud7ff'), ('\ue000', '\uf8ff'), ('\ufa6e',
        '\ufa6f'), ('\ufada', '\ufaff'), ('\ufb07', '\ufb12'), ('\ufb18', '\ufb1c'), ('\ufb37',
        '\ufb37'), ('\ufb3d', '\ufb3d'), ('\ufb3f', '\ufb3f'), ('\ufb42', '\ufb42'), ('\ufb45',
        '\ufb45'), ('\ufbc2', '\ufbd2'), ('\ufd40', '\ufd4f'), ('\ufd90', '\ufd91'), ('\ufdc8',
        '\ufdef'), ('\ufdfe', '\ufdff'), ('\ufe1a', '\ufe1f'), ('\ufe2e', '\ufe2f'), ('\ufe53',
        '\ufe53'), ('\ufe67', '\ufe67'), ('\ufe6c', '\ufe6f'), ('\ufe75', '\ufe75'), ('\ufefd',
        '\uff00'), ('\uffbf', '\uffc1'), ('\uffc8', '\uffc9'), ('\uffd0', '\uffd1'), ('\uffd8',
        '\uffd9'), ('\uffdd', '\uffdf'), ('\uffe7', '\uffe7'), ('\uffef', '\ufffb'), ('\ufffe',
        '\uffff'), ('\U0001000c', '\U0001000c'), ('\U00010027', '\U00010027'), ('\U0001003b',
        '\U0001003b'), ('\U0001003e', '\U0001003e'), ('\U0001004e', '\U0001004f'), ('\U0001005e',
        '\U0001007f'), ('\U000100fb', '\U000100ff'), ('\U00010103', '\U00010106'), ('\U00010134',
        '\U00010136'), ('\U0001018d', '\U0001018f'), ('\U0001019c', '\U0001019f'), ('\U000101a1',
        '\U000101cf'), ('\U000101fe', '\U0001027f'), ('\U0001029d', '\U0001029f'), ('\U000102d1',
        '\U000102df'), ('\U000102fc', '\U000102ff'), ('\U00010324', '\U0001032f'), ('\U0001034b',
        '\U0001034f'), ('\U0001037b', '\U0001037f'), ('\U0001039e', '\U0001039e'), ('\U000103c4',
        '\U000103c7'), ('\U000103d6', '\U000103ff'), ('\U0001049e', '\U0001049f'), ('\U000104aa',
        '\U000104ff'), ('\U00010528', '\U0001052f'), ('\U00010564', '\U0001056e'), ('\U00010570',
        '\U000105ff'), ('\U00010737', '\U0001073f'), ('\U00010756', '\U0001075f'), ('\U00010768',
        '\U000107ff'), ('\U00010806', '\U00010807'), ('\U00010809', '\U00010809'), ('\U00010836',
        '\U00010836'), ('\U00010839', '\U0001083b'), ('\U0001083d', '\U0001083e'), ('\U00010856',
        '\U00010856'), ('\U0001089f', '\U000108a6'), ('\U000108b0', '\U000108ff'), ('\U0001091c',
        '\U0001091e'), ('\U0001093a', '\U0001093e'), ('\U00010940', '\U0001097f'), ('\U000109b8',
        '\U000109bd'), ('\U000109c0', '\U000109ff'), ('\U00010a04', '\U00010a04'), ('\U00010a07',
        '\U00010a0b'), ('\U00010a14', '\U00010a14'), ('\U00010a18', '\U00010a18'), ('\U00010a34',
        '\U00010a37'), ('\U00010a3b', '\U00010a3e'), ('\U00010a48', '\U00010a4f'), ('\U00010a59',
        '\U00010a5f'), ('\U00010aa0', '\U00010abf'), ('\U00010ae7', '\U00010aea'), ('\U00010af7',
        '\U00010aff'), ('\U00010b36', '\U00010b38'), ('\U00010b56', '\U00010b57'), ('\U00010b73',
        '\U00010b77'), ('\U00010b92', '\U00010b98'), ('\U00010b9d', '\U00010ba8'), ('\U00010bb0',
        '\U00010bff'), ('\U00010c49', '\U00010e5f'), ('\U00010e7f', '\U00010fff'), ('\U0001104e',
        '\U00011051'), ('\U00011070', '\U0001107e'), ('\U000110bd', '\U000110bd'), ('\U000110c2',
        '\U000110cf'), ('\U000110e9', '\U000110ef'), ('\U000110fa', '\U000110ff'), ('\U00011135',
        '\U00011135'), ('\U00011144', '\U0001114f'), ('\U00011177', '\U0001117f'), ('\U000111c9',
        '\U000111cc'), ('\U000111ce', '\U000111cf'), ('\U000111db', '\U000111e0'), ('\U000111f5',
        '\U000111ff'), ('\U00011212', '\U00011212'), ('\U0001123e', '\U000112af'), ('\U000112eb',
        '\U000112ef'), ('\U000112fa', '\U00011300'), ('\U00011304', '\U00011304'), ('\U0001130d',
        '\U0001130e'), ('\U00011311', '\U00011312'), ('\U00011329', '\U00011329'), ('\U00011331',
        '\U00011331'), ('\U00011334', '\U00011334'), ('\U0001133a', '\U0001133b'), ('\U00011345',
        '\U00011346'), ('\U00011349', '\U0001134a'), ('\U0001134e', '\U00011356'), ('\U00011358',
        '\U0001135c'), ('\U00011364', '\U00011365'), ('\U0001136d', '\U0001136f'), ('\U00011375',
        '\U0001147f'), ('\U000114c8', '\U000114cf'), ('\U000114da', '\U0001157f'), ('\U000115b6',
        '\U000115b7'), ('\U000115ca', '\U000115ff'), ('\U00011645', '\U0001164f'), ('\U0001165a',
        '\U0001167f'), ('\U000116b8', '\U000116bf'), ('\U000116ca', '\U0001189f'), ('\U000118f3',
        '\U000118fe'), ('\U00011900', '\U00011abf'), ('\U00011af9', '\U00011fff'), ('\U00012399',
        '\U000123ff'), ('\U0001246f', '\U0001246f'), ('\U00012475', '\U00012fff'), ('\U0001342f',
        '\U000167ff'), ('\U00016a39', '\U00016a3f'), ('\U00016a5f', '\U00016a5f'), ('\U00016a6a',
        '\U00016a6d'), ('\U00016a70', '\U00016acf'), ('\U00016aee', '\U00016aef'), ('\U00016af6',
        '\U00016aff'), ('\U00016b46', '\U00016b4f'), ('\U00016b5a', '\U00016b5a'), ('\U00016b62',
        '\U00016b62'), ('\U00016b78', '\U00016b7c'), ('\U00016b90', '\U00016eff'), ('\U00016f45',
        '\U00016f4f'), ('\U00016f7f', '\U00016f8e'), ('\U00016fa0', '\U0001afff'), ('\U0001b002',
        '\U0001bbff'), ('\U0001bc6b', '\U0001bc6f'), ('\U0001bc7d', '\U0001bc7f'), ('\U0001bc89',
        '\U0001bc8f'), ('\U0001bc9a', '\U0001bc9b'), ('\U0001bca0', '\U0001cfff'), ('\U0001d0f6',
        '\U0001d0ff'), ('\U0001d127', '\U0001d128'), ('\U0001d173', '\U0001d17a'), ('\U0001d1de',
        '\U0001d1ff'), ('\U0001d246', '\U0001d2ff'), ('\U0001d357', '\U0001d35f'), ('\U0001d372',
        '\U0001d3ff'), ('\U0001d455', '\U0001d455'), ('\U0001d49d', '\U0001d49d'), ('\U0001d4a0',
        '\U0001d4a1'), ('\U0001d4a3', '\U0001d4a4'), ('\U0001d4a7', '\U0001d4a8'), ('\U0001d4ad',
        '\U0001d4ad'), ('\U0001d4ba', '\U0001d4ba'), ('\U0001d4bc', '\U0001d4bc'), ('\U0001d4c4',
        '\U0001d4c4'), ('\U0001d506', '\U0001d506'), ('\U0001d50b', '\U0001d50c'), ('\U0001d515',
        '\U0001d515'), ('\U0001d51d', '\U0001d51d'), ('\U0001d53a', '\U0001d53a'), ('\U0001d53f',
        '\U0001d53f'), ('\U0001d545', '\U0001d545'), ('\U0001d547', '\U0001d549'), ('\U0001d551',
        '\U0001d551'), ('\U0001d6a6', '\U0001d6a7'), ('\U0001d7cc', '\U0001d7cd'), ('\U0001d800',
        '\U0001e7ff'), ('\U0001e8c5', '\U0001e8c6'), ('\U0001e8d7', '\U0001edff'), ('\U0001ee04',
        '\U0001ee04'), ('\U0001ee20', '\U0001ee20'), ('\U0001ee23', '\U0001ee23'), ('\U0001ee25',
        '\U0001ee26'), ('\U0001ee28', '\U0001ee28'), ('\U0001ee33', '\U0001ee33'), ('\U0001ee38',
        '\U0001ee38'), ('\U0001ee3a', '\U0001ee3a'), ('\U0001ee3c', '\U0001ee41'), ('\U0001ee43',
        '\U0001ee46'), ('\U0001ee48', '\U0001ee48'), ('\U0001ee4a', '\U0001ee4a'), ('\U0001ee4c',
        '\U0001ee4c'), ('\U0001ee50', '\U0001ee50'), ('\U0001ee53', '\U0001ee53'), ('\U0001ee55',
        '\U0001ee56'), ('\U0001ee58', '\U0001ee58'), ('\U0001ee5a', '\U0001ee5a'), ('\U0001ee5c',
        '\U0001ee5c'), ('\U0001ee5e', '\U0001ee5e'), ('\U0001ee60', '\U0001ee60'), ('\U0001ee63',
        '\U0001ee63'), ('\U0001ee65', '\U0001ee66'), ('\U0001ee6b', '\U0001ee6b'), ('\U0001ee73',
        '\U0001ee73'), ('\U0001ee78', '\U0001ee78'), ('\U0001ee7d', '\U0001ee7d'), ('\U0001ee7f',
        '\U0001ee7f'), ('\U0001ee8a', '\U0001ee8a'), ('\U0001ee9c', '\U0001eea0'), ('\U0001eea4',
        '\U0001eea4'), ('\U0001eeaa', '\U0001eeaa'), ('\U0001eebc', '\U0001eeef'), ('\U0001eef2',
        '\U0001efff'), ('\U0001f02c', '\U0001f02f'), ('\U0001f094', '\U0001f09f'), ('\U0001f0af',
        '\U0001f0b0'), ('\U0001f0c0', '\U0001f0c0'), ('\U0001f0d0', '\U0001f0d0'), ('\U0001f0f6',
        '\U0001f0ff'), ('\U0001f10d', '\U0001f10f'), ('\U0001f12f', '\U0001f12f'), ('\U0001f16c',
        '\U0001f16f'), ('\U0001f19b', '\U0001f1e5'), ('\U0001f203', '\U0001f20f'), ('\U0001f23b',
        '\U0001f23f'), ('\U0001f249', '\U0001f24f'), ('\U0001f252', '\U0001f2ff'), ('\U0001f32d',
        '\U0001f32f'), ('\U0001f37e', '\U0001f37f'), ('\U0001f3cf', '\U0001f3d3'), ('\U0001f3f8',
        '\U0001f3ff'), ('\U0001f4ff', '\U0001f4ff'), ('\U0001f54b', '\U0001f54f'), ('\U0001f57a',
        '\U0001f57a'), ('\U0001f5a4', '\U0001f5a4'), ('\U0001f643', '\U0001f644'), ('\U0001f6d0',
        '\U0001f6df'), ('\U0001f6ed', '\U0001f6ef'), ('\U0001f6f4', '\U0001f6ff'), ('\U0001f774',
        '\U0001f77f'), ('\U0001f7d5', '\U0001f7ff'), ('\U0001f80c', '\U0001f80f'), ('\U0001f848',
        '\U0001f84f'), ('\U0001f85a', '\U0001f85f'), ('\U0001f888', '\U0001f88f'), ('\U0001f8ae',
        '\U0001ffff'), ('\U00020001', '\U0002a6d5'), ('\U0002a6d7', '\U0002a6ff'), ('\U0002a701',
        '\U0002b733'), ('\U0002b735', '\U0002b73f'), ('\U0002b741', '\U0002b81c'), ('\U0002b81e',
        '\U0002f7ff'), ('\U0002fa1e', '\U000e00ff'), ('\U000e01f0', '\U0010ffff')
    ];

    pub static Cc_table: &'static [(char, char)] = &[
        ('\x00', '\x1f'), ('\x7f', '\u009f')
    ];

    pub fn Cc(c: char) -> bool {
        super::bsearch_range_table(c, Cc_table)
    }

    pub static Cf_table: &'static [(char, char)] = &[
        ('\u00ad', '\u00ad'), ('\u0600', '\u0605'), ('\u061c', '\u061c'), ('\u06dd', '\u06dd'),
        ('\u070f', '\u070f'), ('\u180e', '\u180e'), ('\u200b', '\u200f'), ('\u202a', '\u202e'),
        ('\u2060', '\u2064'), ('\u2066', '\u206f'), ('\ufeff', '\ufeff'), ('\ufff9', '\ufffb'),
        ('\U000110bd', '\U000110bd'), ('\U0001bca0', '\U0001bca3'), ('\U0001d173', '\U0001d17a'),
        ('\U000e0001', '\U000e0001'), ('\U000e0020', '\U000e007f')
    ];

    pub static Cn_table: &'static [(char, char)] = &[
        ('\u0378', '\u0379'), ('\u0380', '\u0383'), ('\u038b', '\u038b'), ('\u038d', '\u038d'),
        ('\u03a2', '\u03a2'), ('\u0530', '\u0530'), ('\u0557', '\u0558'), ('\u0560', '\u0560'),
        ('\u0588', '\u0588'), ('\u058b', '\u058c'), ('\u0590', '\u0590'), ('\u05c8', '\u05cf'),
        ('\u05eb', '\u05ef'), ('\u05f5', '\u05ff'), ('\u061d', '\u061d'), ('\u070e', '\u070e'),
        ('\u074b', '\u074c'), ('\u07b2', '\u07bf'), ('\u07fb', '\u07ff'), ('\u082e', '\u082f'),
        ('\u083f', '\u083f'), ('\u085c', '\u085d'), ('\u085f', '\u089f'), ('\u08b3', '\u08e3'),
        ('\u0984', '\u0984'), ('\u098d', '\u098e'), ('\u0991', '\u0992'), ('\u09a9', '\u09a9'),
        ('\u09b1', '\u09b1'), ('\u09b3', '\u09b5'), ('\u09ba', '\u09bb'), ('\u09c5', '\u09c6'),
        ('\u09c9', '\u09ca'), ('\u09cf', '\u09d6'), ('\u09d8', '\u09db'), ('\u09de', '\u09de'),
        ('\u09e4', '\u09e5'), ('\u09fc', '\u0a00'), ('\u0a04', '\u0a04'), ('\u0a0b', '\u0a0e'),
        ('\u0a11', '\u0a12'), ('\u0a29', '\u0a29'), ('\u0a31', '\u0a31'), ('\u0a34', '\u0a34'),
        ('\u0a37', '\u0a37'), ('\u0a3a', '\u0a3b'), ('\u0a3d', '\u0a3d'), ('\u0a43', '\u0a46'),
        ('\u0a49', '\u0a4a'), ('\u0a4e', '\u0a50'), ('\u0a52', '\u0a58'), ('\u0a5d', '\u0a5d'),
        ('\u0a5f', '\u0a65'), ('\u0a76', '\u0a80'), ('\u0a84', '\u0a84'), ('\u0a8e', '\u0a8e'),
        ('\u0a92', '\u0a92'), ('\u0aa9', '\u0aa9'), ('\u0ab1', '\u0ab1'), ('\u0ab4', '\u0ab4'),
        ('\u0aba', '\u0abb'), ('\u0ac6', '\u0ac6'), ('\u0aca', '\u0aca'), ('\u0ace', '\u0acf'),
        ('\u0ad1', '\u0adf'), ('\u0ae4', '\u0ae5'), ('\u0af2', '\u0b00'), ('\u0b04', '\u0b04'),
        ('\u0b0d', '\u0b0e'), ('\u0b11', '\u0b12'), ('\u0b29', '\u0b29'), ('\u0b31', '\u0b31'),
        ('\u0b34', '\u0b34'), ('\u0b3a', '\u0b3b'), ('\u0b45', '\u0b46'), ('\u0b49', '\u0b4a'),
        ('\u0b4e', '\u0b55'), ('\u0b58', '\u0b5b'), ('\u0b5e', '\u0b5e'), ('\u0b64', '\u0b65'),
        ('\u0b78', '\u0b81'), ('\u0b84', '\u0b84'), ('\u0b8b', '\u0b8d'), ('\u0b91', '\u0b91'),
        ('\u0b96', '\u0b98'), ('\u0b9b', '\u0b9b'), ('\u0b9d', '\u0b9d'), ('\u0ba0', '\u0ba2'),
        ('\u0ba5', '\u0ba7'), ('\u0bab', '\u0bad'), ('\u0bba', '\u0bbd'), ('\u0bc3', '\u0bc5'),
        ('\u0bc9', '\u0bc9'), ('\u0bce', '\u0bcf'), ('\u0bd1', '\u0bd6'), ('\u0bd8', '\u0be5'),
        ('\u0bfb', '\u0bff'), ('\u0c04', '\u0c04'), ('\u0c0d', '\u0c0d'), ('\u0c11', '\u0c11'),
        ('\u0c29', '\u0c29'), ('\u0c3a', '\u0c3c'), ('\u0c45', '\u0c45'), ('\u0c49', '\u0c49'),
        ('\u0c4e', '\u0c54'), ('\u0c57', '\u0c57'), ('\u0c5a', '\u0c5f'), ('\u0c64', '\u0c65'),
        ('\u0c70', '\u0c77'), ('\u0c80', '\u0c80'), ('\u0c84', '\u0c84'), ('\u0c8d', '\u0c8d'),
        ('\u0c91', '\u0c91'), ('\u0ca9', '\u0ca9'), ('\u0cb4', '\u0cb4'), ('\u0cba', '\u0cbb'),
        ('\u0cc5', '\u0cc5'), ('\u0cc9', '\u0cc9'), ('\u0cce', '\u0cd4'), ('\u0cd7', '\u0cdd'),
        ('\u0cdf', '\u0cdf'), ('\u0ce4', '\u0ce5'), ('\u0cf0', '\u0cf0'), ('\u0cf3', '\u0d00'),
        ('\u0d04', '\u0d04'), ('\u0d0d', '\u0d0d'), ('\u0d11', '\u0d11'), ('\u0d3b', '\u0d3c'),
        ('\u0d45', '\u0d45'), ('\u0d49', '\u0d49'), ('\u0d4f', '\u0d56'), ('\u0d58', '\u0d5f'),
        ('\u0d64', '\u0d65'), ('\u0d76', '\u0d78'), ('\u0d80', '\u0d81'), ('\u0d84', '\u0d84'),
        ('\u0d97', '\u0d99'), ('\u0db2', '\u0db2'), ('\u0dbc', '\u0dbc'), ('\u0dbe', '\u0dbf'),
        ('\u0dc7', '\u0dc9'), ('\u0dcb', '\u0dce'), ('\u0dd5', '\u0dd5'), ('\u0dd7', '\u0dd7'),
        ('\u0de0', '\u0de5'), ('\u0df0', '\u0df1'), ('\u0df5', '\u0e00'), ('\u0e3b', '\u0e3e'),
        ('\u0e5c', '\u0e80'), ('\u0e83', '\u0e83'), ('\u0e85', '\u0e86'), ('\u0e89', '\u0e89'),
        ('\u0e8b', '\u0e8c'), ('\u0e8e', '\u0e93'), ('\u0e98', '\u0e98'), ('\u0ea0', '\u0ea0'),
        ('\u0ea4', '\u0ea4'), ('\u0ea6', '\u0ea6'), ('\u0ea8', '\u0ea9'), ('\u0eac', '\u0eac'),
        ('\u0eba', '\u0eba'), ('\u0ebe', '\u0ebf'), ('\u0ec5', '\u0ec5'), ('\u0ec7', '\u0ec7'),
        ('\u0ece', '\u0ecf'), ('\u0eda', '\u0edb'), ('\u0ee0', '\u0eff'), ('\u0f48', '\u0f48'),
        ('\u0f6d', '\u0f70'), ('\u0f98', '\u0f98'), ('\u0fbd', '\u0fbd'), ('\u0fcd', '\u0fcd'),
        ('\u0fdb', '\u0fff'), ('\u10c6', '\u10c6'), ('\u10c8', '\u10cc'), ('\u10ce', '\u10cf'),
        ('\u1249', '\u1249'), ('\u124e', '\u124f'), ('\u1257', '\u1257'), ('\u1259', '\u1259'),
        ('\u125e', '\u125f'), ('\u1289', '\u1289'), ('\u128e', '\u128f'), ('\u12b1', '\u12b1'),
        ('\u12b6', '\u12b7'), ('\u12bf', '\u12bf'), ('\u12c1', '\u12c1'), ('\u12c6', '\u12c7'),
        ('\u12d7', '\u12d7'), ('\u1311', '\u1311'), ('\u1316', '\u1317'), ('\u135b', '\u135c'),
        ('\u137d', '\u137f'), ('\u139a', '\u139f'), ('\u13f5', '\u13ff'), ('\u169d', '\u169f'),
        ('\u16f9', '\u16ff'), ('\u170d', '\u170d'), ('\u1715', '\u171f'), ('\u1737', '\u173f'),
        ('\u1754', '\u175f'), ('\u176d', '\u176d'), ('\u1771', '\u1771'), ('\u1774', '\u177f'),
        ('\u17de', '\u17df'), ('\u17ea', '\u17ef'), ('\u17fa', '\u17ff'), ('\u180f', '\u180f'),
        ('\u181a', '\u181f'), ('\u1878', '\u187f'), ('\u18ab', '\u18af'), ('\u18f6', '\u18ff'),
        ('\u191f', '\u191f'), ('\u192c', '\u192f'), ('\u193c', '\u193f'), ('\u1941', '\u1943'),
        ('\u196e', '\u196f'), ('\u1975', '\u197f'), ('\u19ac', '\u19af'), ('\u19ca', '\u19cf'),
        ('\u19db', '\u19dd'), ('\u1a1c', '\u1a1d'), ('\u1a5f', '\u1a5f'), ('\u1a7d', '\u1a7e'),
        ('\u1a8a', '\u1a8f'), ('\u1a9a', '\u1a9f'), ('\u1aae', '\u1aaf'), ('\u1abf', '\u1aff'),
        ('\u1b4c', '\u1b4f'), ('\u1b7d', '\u1b7f'), ('\u1bf4', '\u1bfb'), ('\u1c38', '\u1c3a'),
        ('\u1c4a', '\u1c4c'), ('\u1c80', '\u1cbf'), ('\u1cc8', '\u1ccf'), ('\u1cf7', '\u1cf7'),
        ('\u1cfa', '\u1cff'), ('\u1df6', '\u1dfb'), ('\u1f16', '\u1f17'), ('\u1f1e', '\u1f1f'),
        ('\u1f46', '\u1f47'), ('\u1f4e', '\u1f4f'), ('\u1f58', '\u1f58'), ('\u1f5a', '\u1f5a'),
        ('\u1f5c', '\u1f5c'), ('\u1f5e', '\u1f5e'), ('\u1f7e', '\u1f7f'), ('\u1fb5', '\u1fb5'),
        ('\u1fc5', '\u1fc5'), ('\u1fd4', '\u1fd5'), ('\u1fdc', '\u1fdc'), ('\u1ff0', '\u1ff1'),
        ('\u1ff5', '\u1ff5'), ('\u1fff', '\u1fff'), ('\u2065', '\u2065'), ('\u2072', '\u2073'),
        ('\u208f', '\u208f'), ('\u209d', '\u209f'), ('\u20be', '\u20cf'), ('\u20f1', '\u20ff'),
        ('\u218a', '\u218f'), ('\u23fb', '\u23ff'), ('\u2427', '\u243f'), ('\u244b', '\u245f'),
        ('\u2b74', '\u2b75'), ('\u2b96', '\u2b97'), ('\u2bba', '\u2bbc'), ('\u2bc9', '\u2bc9'),
        ('\u2bd2', '\u2bff'), ('\u2c2f', '\u2c2f'), ('\u2c5f', '\u2c5f'), ('\u2cf4', '\u2cf8'),
        ('\u2d26', '\u2d26'), ('\u2d28', '\u2d2c'), ('\u2d2e', '\u2d2f'), ('\u2d68', '\u2d6e'),
        ('\u2d71', '\u2d7e'), ('\u2d97', '\u2d9f'), ('\u2da7', '\u2da7'), ('\u2daf', '\u2daf'),
        ('\u2db7', '\u2db7'), ('\u2dbf', '\u2dbf'), ('\u2dc7', '\u2dc7'), ('\u2dcf', '\u2dcf'),
        ('\u2dd7', '\u2dd7'), ('\u2ddf', '\u2ddf'), ('\u2e43', '\u2e7f'), ('\u2e9a', '\u2e9a'),
        ('\u2ef4', '\u2eff'), ('\u2fd6', '\u2fef'), ('\u2ffc', '\u2fff'), ('\u3040', '\u3040'),
        ('\u3097', '\u3098'), ('\u3100', '\u3104'), ('\u312e', '\u3130'), ('\u318f', '\u318f'),
        ('\u31bb', '\u31bf'), ('\u31e4', '\u31ef'), ('\u321f', '\u321f'), ('\u32ff', '\u32ff'),
        ('\u3401', '\u4db4'), ('\u4db6', '\u4dbf'), ('\u4e01', '\u9fcb'), ('\u9fcd', '\u9fff'),
        ('\ua48d', '\ua48f'), ('\ua4c7', '\ua4cf'), ('\ua62c', '\ua63f'), ('\ua69e', '\ua69e'),
        ('\ua6f8', '\ua6ff'), ('\ua78f', '\ua78f'), ('\ua7ae', '\ua7af'), ('\ua7b2', '\ua7f6'),
        ('\ua82c', '\ua82f'), ('\ua83a', '\ua83f'), ('\ua878', '\ua87f'), ('\ua8c5', '\ua8cd'),
        ('\ua8da', '\ua8df'), ('\ua8fc', '\ua8ff'), ('\ua954', '\ua95e'), ('\ua97d', '\ua97f'),
        ('\ua9ce', '\ua9ce'), ('\ua9da', '\ua9dd'), ('\ua9ff', '\ua9ff'), ('\uaa37', '\uaa3f'),
        ('\uaa4e', '\uaa4f'), ('\uaa5a', '\uaa5b'), ('\uaac3', '\uaada'), ('\uaaf7', '\uab00'),
        ('\uab07', '\uab08'), ('\uab0f', '\uab10'), ('\uab17', '\uab1f'), ('\uab27', '\uab27'),
        ('\uab2f', '\uab2f'), ('\uab60', '\uab63'), ('\uab66', '\uabbf'), ('\uabee', '\uabef'),
        ('\uabfa', '\uabff'), ('\uac01', '\ud7a2'), ('\ud7a4', '\ud7af'), ('\ud7c7', '\ud7ca'),
        ('\ud7fc', '\ud7ff'), ('\ue001', '\uf8fe'), ('\ufa6e', '\ufa6f'), ('\ufada', '\ufaff'),
        ('\ufb07', '\ufb12'), ('\ufb18', '\ufb1c'), ('\ufb37', '\ufb37'), ('\ufb3d', '\ufb3d'),
        ('\ufb3f', '\ufb3f'), ('\ufb42', '\ufb42'), ('\ufb45', '\ufb45'), ('\ufbc2', '\ufbd2'),
        ('\ufd40', '\ufd4f'), ('\ufd90', '\ufd91'), ('\ufdc8', '\ufdef'), ('\ufdfe', '\ufdff'),
        ('\ufe1a', '\ufe1f'), ('\ufe2e', '\ufe2f'), ('\ufe53', '\ufe53'), ('\ufe67', '\ufe67'),
        ('\ufe6c', '\ufe6f'), ('\ufe75', '\ufe75'), ('\ufefd', '\ufefe'), ('\uff00', '\uff00'),
        ('\uffbf', '\uffc1'), ('\uffc8', '\uffc9'), ('\uffd0', '\uffd1'), ('\uffd8', '\uffd9'),
        ('\uffdd', '\uffdf'), ('\uffe7', '\uffe7'), ('\uffef', '\ufff8'), ('\ufffe', '\uffff'),
        ('\U0001000c', '\U0001000c'), ('\U00010027', '\U00010027'), ('\U0001003b', '\U0001003b'),
        ('\U0001003e', '\U0001003e'), ('\U0001004e', '\U0001004f'), ('\U0001005e', '\U0001007f'),
        ('\U000100fb', '\U000100ff'), ('\U00010103', '\U00010106'), ('\U00010134', '\U00010136'),
        ('\U0001018d', '\U0001018f'), ('\U0001019c', '\U0001019f'), ('\U000101a1', '\U000101cf'),
        ('\U000101fe', '\U0001027f'), ('\U0001029d', '\U0001029f'), ('\U000102d1', '\U000102df'),
        ('\U000102fc', '\U000102ff'), ('\U00010324', '\U0001032f'), ('\U0001034b', '\U0001034f'),
        ('\U0001037b', '\U0001037f'), ('\U0001039e', '\U0001039e'), ('\U000103c4', '\U000103c7'),
        ('\U000103d6', '\U000103ff'), ('\U0001049e', '\U0001049f'), ('\U000104aa', '\U000104ff'),
        ('\U00010528', '\U0001052f'), ('\U00010564', '\U0001056e'), ('\U00010570', '\U000105ff'),
        ('\U00010737', '\U0001073f'), ('\U00010756', '\U0001075f'), ('\U00010768', '\U000107ff'),
        ('\U00010806', '\U00010807'), ('\U00010809', '\U00010809'), ('\U00010836', '\U00010836'),
        ('\U00010839', '\U0001083b'), ('\U0001083d', '\U0001083e'), ('\U00010856', '\U00010856'),
        ('\U0001089f', '\U000108a6'), ('\U000108b0', '\U000108ff'), ('\U0001091c', '\U0001091e'),
        ('\U0001093a', '\U0001093e'), ('\U00010940', '\U0001097f'), ('\U000109b8', '\U000109bd'),
        ('\U000109c0', '\U000109ff'), ('\U00010a04', '\U00010a04'), ('\U00010a07', '\U00010a0b'),
        ('\U00010a14', '\U00010a14'), ('\U00010a18', '\U00010a18'), ('\U00010a34', '\U00010a37'),
        ('\U00010a3b', '\U00010a3e'), ('\U00010a48', '\U00010a4f'), ('\U00010a59', '\U00010a5f'),
        ('\U00010aa0', '\U00010abf'), ('\U00010ae7', '\U00010aea'), ('\U00010af7', '\U00010aff'),
        ('\U00010b36', '\U00010b38'), ('\U00010b56', '\U00010b57'), ('\U00010b73', '\U00010b77'),
        ('\U00010b92', '\U00010b98'), ('\U00010b9d', '\U00010ba8'), ('\U00010bb0', '\U00010bff'),
        ('\U00010c49', '\U00010e5f'), ('\U00010e7f', '\U00010fff'), ('\U0001104e', '\U00011051'),
        ('\U00011070', '\U0001107e'), ('\U000110c2', '\U000110cf'), ('\U000110e9', '\U000110ef'),
        ('\U000110fa', '\U000110ff'), ('\U00011135', '\U00011135'), ('\U00011144', '\U0001114f'),
        ('\U00011177', '\U0001117f'), ('\U000111c9', '\U000111cc'), ('\U000111ce', '\U000111cf'),
        ('\U000111db', '\U000111e0'), ('\U000111f5', '\U000111ff'), ('\U00011212', '\U00011212'),
        ('\U0001123e', '\U000112af'), ('\U000112eb', '\U000112ef'), ('\U000112fa', '\U00011300'),
        ('\U00011304', '\U00011304'), ('\U0001130d', '\U0001130e'), ('\U00011311', '\U00011312'),
        ('\U00011329', '\U00011329'), ('\U00011331', '\U00011331'), ('\U00011334', '\U00011334'),
        ('\U0001133a', '\U0001133b'), ('\U00011345', '\U00011346'), ('\U00011349', '\U0001134a'),
        ('\U0001134e', '\U00011356'), ('\U00011358', '\U0001135c'), ('\U00011364', '\U00011365'),
        ('\U0001136d', '\U0001136f'), ('\U00011375', '\U0001147f'), ('\U000114c8', '\U000114cf'),
        ('\U000114da', '\U0001157f'), ('\U000115b6', '\U000115b7'), ('\U000115ca', '\U000115ff'),
        ('\U00011645', '\U0001164f'), ('\U0001165a', '\U0001167f'), ('\U000116b8', '\U000116bf'),
        ('\U000116ca', '\U0001189f'), ('\U000118f3', '\U000118fe'), ('\U00011900', '\U00011abf'),
        ('\U00011af9', '\U00011fff'), ('\U00012399', '\U000123ff'), ('\U0001246f', '\U0001246f'),
        ('\U00012475', '\U00012fff'), ('\U0001342f', '\U000167ff'), ('\U00016a39', '\U00016a3f'),
        ('\U00016a5f', '\U00016a5f'), ('\U00016a6a', '\U00016a6d'), ('\U00016a70', '\U00016acf'),
        ('\U00016aee', '\U00016aef'), ('\U00016af6', '\U00016aff'), ('\U00016b46', '\U00016b4f'),
        ('\U00016b5a', '\U00016b5a'), ('\U00016b62', '\U00016b62'), ('\U00016b78', '\U00016b7c'),
        ('\U00016b90', '\U00016eff'), ('\U00016f45', '\U00016f4f'), ('\U00016f7f', '\U00016f8e'),
        ('\U00016fa0', '\U0001afff'), ('\U0001b002', '\U0001bbff'), ('\U0001bc6b', '\U0001bc6f'),
        ('\U0001bc7d', '\U0001bc7f'), ('\U0001bc89', '\U0001bc8f'), ('\U0001bc9a', '\U0001bc9b'),
        ('\U0001bca4', '\U0001cfff'), ('\U0001d0f6', '\U0001d0ff'), ('\U0001d127', '\U0001d128'),
        ('\U0001d1de', '\U0001d1ff'), ('\U0001d246', '\U0001d2ff'), ('\U0001d357', '\U0001d35f'),
        ('\U0001d372', '\U0001d3ff'), ('\U0001d455', '\U0001d455'), ('\U0001d49d', '\U0001d49d'),
        ('\U0001d4a0', '\U0001d4a1'), ('\U0001d4a3', '\U0001d4a4'), ('\U0001d4a7', '\U0001d4a8'),
        ('\U0001d4ad', '\U0001d4ad'), ('\U0001d4ba', '\U0001d4ba'), ('\U0001d4bc', '\U0001d4bc'),
        ('\U0001d4c4', '\U0001d4c4'), ('\U0001d506', '\U0001d506'), ('\U0001d50b', '\U0001d50c'),
        ('\U0001d515', '\U0001d515'), ('\U0001d51d', '\U0001d51d'), ('\U0001d53a', '\U0001d53a'),
        ('\U0001d53f', '\U0001d53f'), ('\U0001d545', '\U0001d545'), ('\U0001d547', '\U0001d549'),
        ('\U0001d551', '\U0001d551'), ('\U0001d6a6', '\U0001d6a7'), ('\U0001d7cc', '\U0001d7cd'),
        ('\U0001d800', '\U0001e7ff'), ('\U0001e8c5', '\U0001e8c6'), ('\U0001e8d7', '\U0001edff'),
        ('\U0001ee04', '\U0001ee04'), ('\U0001ee20', '\U0001ee20'), ('\U0001ee23', '\U0001ee23'),
        ('\U0001ee25', '\U0001ee26'), ('\U0001ee28', '\U0001ee28'), ('\U0001ee33', '\U0001ee33'),
        ('\U0001ee38', '\U0001ee38'), ('\U0001ee3a', '\U0001ee3a'), ('\U0001ee3c', '\U0001ee41'),
        ('\U0001ee43', '\U0001ee46'), ('\U0001ee48', '\U0001ee48'), ('\U0001ee4a', '\U0001ee4a'),
        ('\U0001ee4c', '\U0001ee4c'), ('\U0001ee50', '\U0001ee50'), ('\U0001ee53', '\U0001ee53'),
        ('\U0001ee55', '\U0001ee56'), ('\U0001ee58', '\U0001ee58'), ('\U0001ee5a', '\U0001ee5a'),
        ('\U0001ee5c', '\U0001ee5c'), ('\U0001ee5e', '\U0001ee5e'), ('\U0001ee60', '\U0001ee60'),
        ('\U0001ee63', '\U0001ee63'), ('\U0001ee65', '\U0001ee66'), ('\U0001ee6b', '\U0001ee6b'),
        ('\U0001ee73', '\U0001ee73'), ('\U0001ee78', '\U0001ee78'), ('\U0001ee7d', '\U0001ee7d'),
        ('\U0001ee7f', '\U0001ee7f'), ('\U0001ee8a', '\U0001ee8a'), ('\U0001ee9c', '\U0001eea0'),
        ('\U0001eea4', '\U0001eea4'), ('\U0001eeaa', '\U0001eeaa'), ('\U0001eebc', '\U0001eeef'),
        ('\U0001eef2', '\U0001efff'), ('\U0001f02c', '\U0001f02f'), ('\U0001f094', '\U0001f09f'),
        ('\U0001f0af', '\U0001f0b0'), ('\U0001f0c0', '\U0001f0c0'), ('\U0001f0d0', '\U0001f0d0'),
        ('\U0001f0f6', '\U0001f0ff'), ('\U0001f10d', '\U0001f10f'), ('\U0001f12f', '\U0001f12f'),
        ('\U0001f16c', '\U0001f16f'), ('\U0001f19b', '\U0001f1e5'), ('\U0001f203', '\U0001f20f'),
        ('\U0001f23b', '\U0001f23f'), ('\U0001f249', '\U0001f24f'), ('\U0001f252', '\U0001f2ff'),
        ('\U0001f32d', '\U0001f32f'), ('\U0001f37e', '\U0001f37f'), ('\U0001f3cf', '\U0001f3d3'),
        ('\U0001f3f8', '\U0001f3ff'), ('\U0001f4ff', '\U0001f4ff'), ('\U0001f54b', '\U0001f54f'),
        ('\U0001f57a', '\U0001f57a'), ('\U0001f5a4', '\U0001f5a4'), ('\U0001f643', '\U0001f644'),
        ('\U0001f6d0', '\U0001f6df'), ('\U0001f6ed', '\U0001f6ef'), ('\U0001f6f4', '\U0001f6ff'),
        ('\U0001f774', '\U0001f77f'), ('\U0001f7d5', '\U0001f7ff'), ('\U0001f80c', '\U0001f80f'),
        ('\U0001f848', '\U0001f84f'), ('\U0001f85a', '\U0001f85f'), ('\U0001f888', '\U0001f88f'),
        ('\U0001f8ae', '\U0001ffff'), ('\U00020001', '\U0002a6d5'), ('\U0002a6d7', '\U0002a6ff'),
        ('\U0002a701', '\U0002b733'), ('\U0002b735', '\U0002b73f'), ('\U0002b741', '\U0002b81c'),
        ('\U0002b81e', '\U0002f7ff'), ('\U0002fa1e', '\U000e0000'), ('\U000e0002', '\U000e001f'),
        ('\U000e0080', '\U000e00ff'), ('\U000e01f0', '\U000effff'), ('\U000f0001', '\U000ffffc'),
        ('\U000ffffe', '\U000fffff'), ('\U00100001', '\U0010fffc'), ('\U0010fffe', '\U0010ffff')
    ];

    pub static Co_table: &'static [(char, char)] = &[
        ('\ue000', '\ue000'), ('\uf8ff', '\uf8ff'), ('\U000f0000', '\U000f0000'), ('\U000ffffd',
        '\U000ffffd'), ('\U00100000', '\U00100000'), ('\U0010fffd', '\U0010fffd')
    ];

    pub static L_table: &'static [(char, char)] = &[
        ('\x41', '\x5a'), ('\x61', '\x7a'), ('\u00aa', '\u00aa'), ('\u00b5', '\u00b5'), ('\u00ba',
        '\u00ba'), ('\u00c0', '\u00d6'), ('\u00d8', '\u00f6'), ('\u00f8', '\u02c1'), ('\u02c6',
        '\u02d1'), ('\u02e0', '\u02e4'), ('\u02ec', '\u02ec'), ('\u02ee', '\u02ee'), ('\u0370',
        '\u0374'), ('\u0376', '\u0377'), ('\u037a', '\u037d'), ('\u037f', '\u037f'), ('\u0386',
        '\u0386'), ('\u0388', '\u038a'), ('\u038c', '\u038c'), ('\u038e', '\u03a1'), ('\u03a3',
        '\u03f5'), ('\u03f7', '\u0481'), ('\u048a', '\u052f'), ('\u0531', '\u0556'), ('\u0559',
        '\u0559'), ('\u0561', '\u0587'), ('\u05d0', '\u05ea'), ('\u05f0', '\u05f2'), ('\u0620',
        '\u064a'), ('\u066e', '\u066f'), ('\u0671', '\u06d3'), ('\u06d5', '\u06d5'), ('\u06e5',
        '\u06e6'), ('\u06ee', '\u06ef'), ('\u06fa', '\u06fc'), ('\u06ff', '\u06ff'), ('\u0710',
        '\u0710'), ('\u0712', '\u072f'), ('\u074d', '\u07a5'), ('\u07b1', '\u07b1'), ('\u07ca',
        '\u07ea'), ('\u07f4', '\u07f5'), ('\u07fa', '\u07fa'), ('\u0800', '\u0815'), ('\u081a',
        '\u081a'), ('\u0824', '\u0824'), ('\u0828', '\u0828'), ('\u0840', '\u0858'), ('\u08a0',
        '\u08b2'), ('\u0904', '\u0939'), ('\u093d', '\u093d'), ('\u0950', '\u0950'), ('\u0958',
        '\u0961'), ('\u0971', '\u0980'), ('\u0985', '\u098c'), ('\u098f', '\u0990'), ('\u0993',
        '\u09a8'), ('\u09aa', '\u09b0'), ('\u09b2', '\u09b2'), ('\u09b6', '\u09b9'), ('\u09bd',
        '\u09bd'), ('\u09ce', '\u09ce'), ('\u09dc', '\u09dd'), ('\u09df', '\u09e1'), ('\u09f0',
        '\u09f1'), ('\u0a05', '\u0a0a'), ('\u0a0f', '\u0a10'), ('\u0a13', '\u0a28'), ('\u0a2a',
        '\u0a30'), ('\u0a32', '\u0a33'), ('\u0a35', '\u0a36'), ('\u0a38', '\u0a39'), ('\u0a59',
        '\u0a5c'), ('\u0a5e', '\u0a5e'), ('\u0a72', '\u0a74'), ('\u0a85', '\u0a8d'), ('\u0a8f',
        '\u0a91'), ('\u0a93', '\u0aa8'), ('\u0aaa', '\u0ab0'), ('\u0ab2', '\u0ab3'), ('\u0ab5',
        '\u0ab9'), ('\u0abd', '\u0abd'), ('\u0ad0', '\u0ad0'), ('\u0ae0', '\u0ae1'), ('\u0b05',
        '\u0b0c'), ('\u0b0f', '\u0b10'), ('\u0b13', '\u0b28'), ('\u0b2a', '\u0b30'), ('\u0b32',
        '\u0b33'), ('\u0b35', '\u0b39'), ('\u0b3d', '\u0b3d'), ('\u0b5c', '\u0b5d'), ('\u0b5f',
        '\u0b61'), ('\u0b71', '\u0b71'), ('\u0b83', '\u0b83'), ('\u0b85', '\u0b8a'), ('\u0b8e',
        '\u0b90'), ('\u0b92', '\u0b95'), ('\u0b99', '\u0b9a'), ('\u0b9c', '\u0b9c'), ('\u0b9e',
        '\u0b9f'), ('\u0ba3', '\u0ba4'), ('\u0ba8', '\u0baa'), ('\u0bae', '\u0bb9'), ('\u0bd0',
        '\u0bd0'), ('\u0c05', '\u0c0c'), ('\u0c0e', '\u0c10'), ('\u0c12', '\u0c28'), ('\u0c2a',
        '\u0c39'), ('\u0c3d', '\u0c3d'), ('\u0c58', '\u0c59'), ('\u0c60', '\u0c61'), ('\u0c85',
        '\u0c8c'), ('\u0c8e', '\u0c90'), ('\u0c92', '\u0ca8'), ('\u0caa', '\u0cb3'), ('\u0cb5',
        '\u0cb9'), ('\u0cbd', '\u0cbd'), ('\u0cde', '\u0cde'), ('\u0ce0', '\u0ce1'), ('\u0cf1',
        '\u0cf2'), ('\u0d05', '\u0d0c'), ('\u0d0e', '\u0d10'), ('\u0d12', '\u0d3a'), ('\u0d3d',
        '\u0d3d'), ('\u0d4e', '\u0d4e'), ('\u0d60', '\u0d61'), ('\u0d7a', '\u0d7f'), ('\u0d85',
        '\u0d96'), ('\u0d9a', '\u0db1'), ('\u0db3', '\u0dbb'), ('\u0dbd', '\u0dbd'), ('\u0dc0',
        '\u0dc6'), ('\u0e01', '\u0e30'), ('\u0e32', '\u0e33'), ('\u0e40', '\u0e46'), ('\u0e81',
        '\u0e82'), ('\u0e84', '\u0e84'), ('\u0e87', '\u0e88'), ('\u0e8a', '\u0e8a'), ('\u0e8d',
        '\u0e8d'), ('\u0e94', '\u0e97'), ('\u0e99', '\u0e9f'), ('\u0ea1', '\u0ea3'), ('\u0ea5',
        '\u0ea5'), ('\u0ea7', '\u0ea7'), ('\u0eaa', '\u0eab'), ('\u0ead', '\u0eb0'), ('\u0eb2',
        '\u0eb3'), ('\u0ebd', '\u0ebd'), ('\u0ec0', '\u0ec4'), ('\u0ec6', '\u0ec6'), ('\u0edc',
        '\u0edf'), ('\u0f00', '\u0f00'), ('\u0f40', '\u0f47'), ('\u0f49', '\u0f6c'), ('\u0f88',
        '\u0f8c'), ('\u1000', '\u102a'), ('\u103f', '\u103f'), ('\u1050', '\u1055'), ('\u105a',
        '\u105d'), ('\u1061', '\u1061'), ('\u1065', '\u1066'), ('\u106e', '\u1070'), ('\u1075',
        '\u1081'), ('\u108e', '\u108e'), ('\u10a0', '\u10c5'), ('\u10c7', '\u10c7'), ('\u10cd',
        '\u10cd'), ('\u10d0', '\u10fa'), ('\u10fc', '\u1248'), ('\u124a', '\u124d'), ('\u1250',
        '\u1256'), ('\u1258', '\u1258'), ('\u125a', '\u125d'), ('\u1260', '\u1288'), ('\u128a',
        '\u128d'), ('\u1290', '\u12b0'), ('\u12b2', '\u12b5'), ('\u12b8', '\u12be'), ('\u12c0',
        '\u12c0'), ('\u12c2', '\u12c5'), ('\u12c8', '\u12d6'), ('\u12d8', '\u1310'), ('\u1312',
        '\u1315'), ('\u1318', '\u135a'), ('\u1380', '\u138f'), ('\u13a0', '\u13f4'), ('\u1401',
        '\u166c'), ('\u166f', '\u167f'), ('\u1681', '\u169a'), ('\u16a0', '\u16ea'), ('\u16f1',
        '\u16f8'), ('\u1700', '\u170c'), ('\u170e', '\u1711'), ('\u1720', '\u1731'), ('\u1740',
        '\u1751'), ('\u1760', '\u176c'), ('\u176e', '\u1770'), ('\u1780', '\u17b3'), ('\u17d7',
        '\u17d7'), ('\u17dc', '\u17dc'), ('\u1820', '\u1877'), ('\u1880', '\u18a8'), ('\u18aa',
        '\u18aa'), ('\u18b0', '\u18f5'), ('\u1900', '\u191e'), ('\u1950', '\u196d'), ('\u1970',
        '\u1974'), ('\u1980', '\u19ab'), ('\u19c1', '\u19c7'), ('\u1a00', '\u1a16'), ('\u1a20',
        '\u1a54'), ('\u1aa7', '\u1aa7'), ('\u1b05', '\u1b33'), ('\u1b45', '\u1b4b'), ('\u1b83',
        '\u1ba0'), ('\u1bae', '\u1baf'), ('\u1bba', '\u1be5'), ('\u1c00', '\u1c23'), ('\u1c4d',
        '\u1c4f'), ('\u1c5a', '\u1c7d'), ('\u1ce9', '\u1cec'), ('\u1cee', '\u1cf1'), ('\u1cf5',
        '\u1cf6'), ('\u1d00', '\u1dbf'), ('\u1e00', '\u1f15'), ('\u1f18', '\u1f1d'), ('\u1f20',
        '\u1f45'), ('\u1f48', '\u1f4d'), ('\u1f50', '\u1f57'), ('\u1f59', '\u1f59'), ('\u1f5b',
        '\u1f5b'), ('\u1f5d', '\u1f5d'), ('\u1f5f', '\u1f7d'), ('\u1f80', '\u1fb4'), ('\u1fb6',
        '\u1fbc'), ('\u1fbe', '\u1fbe'), ('\u1fc2', '\u1fc4'), ('\u1fc6', '\u1fcc'), ('\u1fd0',
        '\u1fd3'), ('\u1fd6', '\u1fdb'), ('\u1fe0', '\u1fec'), ('\u1ff2', '\u1ff4'), ('\u1ff6',
        '\u1ffc'), ('\u2071', '\u2071'), ('\u207f', '\u207f'), ('\u2090', '\u209c'), ('\u2102',
        '\u2102'), ('\u2107', '\u2107'), ('\u210a', '\u2113'), ('\u2115', '\u2115'), ('\u2119',
        '\u211d'), ('\u2124', '\u2124'), ('\u2126', '\u2126'), ('\u2128', '\u2128'), ('\u212a',
        '\u212d'), ('\u212f', '\u2139'), ('\u213c', '\u213f'), ('\u2145', '\u2149'), ('\u214e',
        '\u214e'), ('\u2183', '\u2184'), ('\u2c00', '\u2c2e'), ('\u2c30', '\u2c5e'), ('\u2c60',
        '\u2ce4'), ('\u2ceb', '\u2cee'), ('\u2cf2', '\u2cf3'), ('\u2d00', '\u2d25'), ('\u2d27',
        '\u2d27'), ('\u2d2d', '\u2d2d'), ('\u2d30', '\u2d67'), ('\u2d6f', '\u2d6f'), ('\u2d80',
        '\u2d96'), ('\u2da0', '\u2da6'), ('\u2da8', '\u2dae'), ('\u2db0', '\u2db6'), ('\u2db8',
        '\u2dbe'), ('\u2dc0', '\u2dc6'), ('\u2dc8', '\u2dce'), ('\u2dd0', '\u2dd6'), ('\u2dd8',
        '\u2dde'), ('\u2e2f', '\u2e2f'), ('\u3005', '\u3006'), ('\u3031', '\u3035'), ('\u303b',
        '\u303c'), ('\u3041', '\u3096'), ('\u309d', '\u309f'), ('\u30a1', '\u30fa'), ('\u30fc',
        '\u30ff'), ('\u3105', '\u312d'), ('\u3131', '\u318e'), ('\u31a0', '\u31ba'), ('\u31f0',
        '\u31ff'), ('\u3400', '\u3400'), ('\u4db5', '\u4db5'), ('\u4e00', '\u4e00'), ('\u9fcc',
        '\u9fcc'), ('\ua000', '\ua48c'), ('\ua4d0', '\ua4fd'), ('\ua500', '\ua60c'), ('\ua610',
        '\ua61f'), ('\ua62a', '\ua62b'), ('\ua640', '\ua66e'), ('\ua67f', '\ua69d'), ('\ua6a0',
        '\ua6e5'), ('\ua717', '\ua71f'), ('\ua722', '\ua788'), ('\ua78b', '\ua78e'), ('\ua790',
        '\ua7ad'), ('\ua7b0', '\ua7b1'), ('\ua7f7', '\ua801'), ('\ua803', '\ua805'), ('\ua807',
        '\ua80a'), ('\ua80c', '\ua822'), ('\ua840', '\ua873'), ('\ua882', '\ua8b3'), ('\ua8f2',
        '\ua8f7'), ('\ua8fb', '\ua8fb'), ('\ua90a', '\ua925'), ('\ua930', '\ua946'), ('\ua960',
        '\ua97c'), ('\ua984', '\ua9b2'), ('\ua9cf', '\ua9cf'), ('\ua9e0', '\ua9e4'), ('\ua9e6',
        '\ua9ef'), ('\ua9fa', '\ua9fe'), ('\uaa00', '\uaa28'), ('\uaa40', '\uaa42'), ('\uaa44',
        '\uaa4b'), ('\uaa60', '\uaa76'), ('\uaa7a', '\uaa7a'), ('\uaa7e', '\uaaaf'), ('\uaab1',
        '\uaab1'), ('\uaab5', '\uaab6'), ('\uaab9', '\uaabd'), ('\uaac0', '\uaac0'), ('\uaac2',
        '\uaac2'), ('\uaadb', '\uaadd'), ('\uaae0', '\uaaea'), ('\uaaf2', '\uaaf4'), ('\uab01',
        '\uab06'), ('\uab09', '\uab0e'), ('\uab11', '\uab16'), ('\uab20', '\uab26'), ('\uab28',
        '\uab2e'), ('\uab30', '\uab5a'), ('\uab5c', '\uab5f'), ('\uab64', '\uab65'), ('\uabc0',
        '\uabe2'), ('\uac00', '\uac00'), ('\ud7a3', '\ud7a3'), ('\ud7b0', '\ud7c6'), ('\ud7cb',
        '\ud7fb'), ('\uf900', '\ufa6d'), ('\ufa70', '\ufad9'), ('\ufb00', '\ufb06'), ('\ufb13',
        '\ufb17'), ('\ufb1d', '\ufb1d'), ('\ufb1f', '\ufb28'), ('\ufb2a', '\ufb36'), ('\ufb38',
        '\ufb3c'), ('\ufb3e', '\ufb3e'), ('\ufb40', '\ufb41'), ('\ufb43', '\ufb44'), ('\ufb46',
        '\ufbb1'), ('\ufbd3', '\ufd3d'), ('\ufd50', '\ufd8f'), ('\ufd92', '\ufdc7'), ('\ufdf0',
        '\ufdfb'), ('\ufe70', '\ufe74'), ('\ufe76', '\ufefc'), ('\uff21', '\uff3a'), ('\uff41',
        '\uff5a'), ('\uff66', '\uffbe'), ('\uffc2', '\uffc7'), ('\uffca', '\uffcf'), ('\uffd2',
        '\uffd7'), ('\uffda', '\uffdc'), ('\U00010000', '\U0001000b'), ('\U0001000d', '\U00010026'),
        ('\U00010028', '\U0001003a'), ('\U0001003c', '\U0001003d'), ('\U0001003f', '\U0001004d'),
        ('\U00010050', '\U0001005d'), ('\U00010080', '\U000100fa'), ('\U00010280', '\U0001029c'),
        ('\U000102a0', '\U000102d0'), ('\U00010300', '\U0001031f'), ('\U00010330', '\U00010340'),
        ('\U00010342', '\U00010349'), ('\U00010350', '\U00010375'), ('\U00010380', '\U0001039d'),
        ('\U000103a0', '\U000103c3'), ('\U000103c8', '\U000103cf'), ('\U00010400', '\U0001049d'),
        ('\U00010500', '\U00010527'), ('\U00010530', '\U00010563'), ('\U00010600', '\U00010736'),
        ('\U00010740', '\U00010755'), ('\U00010760', '\U00010767'), ('\U00010800', '\U00010805'),
        ('\U00010808', '\U00010808'), ('\U0001080a', '\U00010835'), ('\U00010837', '\U00010838'),
        ('\U0001083c', '\U0001083c'), ('\U0001083f', '\U00010855'), ('\U00010860', '\U00010876'),
        ('\U00010880', '\U0001089e'), ('\U00010900', '\U00010915'), ('\U00010920', '\U00010939'),
        ('\U00010980', '\U000109b7'), ('\U000109be', '\U000109bf'), ('\U00010a00', '\U00010a00'),
        ('\U00010a10', '\U00010a13'), ('\U00010a15', '\U00010a17'), ('\U00010a19', '\U00010a33'),
        ('\U00010a60', '\U00010a7c'), ('\U00010a80', '\U00010a9c'), ('\U00010ac0', '\U00010ac7'),
        ('\U00010ac9', '\U00010ae4'), ('\U00010b00', '\U00010b35'), ('\U00010b40', '\U00010b55'),
        ('\U00010b60', '\U00010b72'), ('\U00010b80', '\U00010b91'), ('\U00010c00', '\U00010c48'),
        ('\U00011003', '\U00011037'), ('\U00011083', '\U000110af'), ('\U000110d0', '\U000110e8'),
        ('\U00011103', '\U00011126'), ('\U00011150', '\U00011172'), ('\U00011176', '\U00011176'),
        ('\U00011183', '\U000111b2'), ('\U000111c1', '\U000111c4'), ('\U000111da', '\U000111da'),
        ('\U00011200', '\U00011211'), ('\U00011213', '\U0001122b'), ('\U000112b0', '\U000112de'),
        ('\U00011305', '\U0001130c'), ('\U0001130f', '\U00011310'), ('\U00011313', '\U00011328'),
        ('\U0001132a', '\U00011330'), ('\U00011332', '\U00011333'), ('\U00011335', '\U00011339'),
        ('\U0001133d', '\U0001133d'), ('\U0001135d', '\U00011361'), ('\U00011480', '\U000114af'),
        ('\U000114c4', '\U000114c5'), ('\U000114c7', '\U000114c7'), ('\U00011580', '\U000115ae'),
        ('\U00011600', '\U0001162f'), ('\U00011644', '\U00011644'), ('\U00011680', '\U000116aa'),
        ('\U000118a0', '\U000118df'), ('\U000118ff', '\U000118ff'), ('\U00011ac0', '\U00011af8'),
        ('\U00012000', '\U00012398'), ('\U00013000', '\U0001342e'), ('\U00016800', '\U00016a38'),
        ('\U00016a40', '\U00016a5e'), ('\U00016ad0', '\U00016aed'), ('\U00016b00', '\U00016b2f'),
        ('\U00016b40', '\U00016b43'), ('\U00016b63', '\U00016b77'), ('\U00016b7d', '\U00016b8f'),
        ('\U00016f00', '\U00016f44'), ('\U00016f50', '\U00016f50'), ('\U00016f93', '\U00016f9f'),
        ('\U0001b000', '\U0001b001'), ('\U0001bc00', '\U0001bc6a'), ('\U0001bc70', '\U0001bc7c'),
        ('\U0001bc80', '\U0001bc88'), ('\U0001bc90', '\U0001bc99'), ('\U0001d400', '\U0001d454'),
        ('\U0001d456', '\U0001d49c'), ('\U0001d49e', '\U0001d49f'), ('\U0001d4a2', '\U0001d4a2'),
        ('\U0001d4a5', '\U0001d4a6'), ('\U0001d4a9', '\U0001d4ac'), ('\U0001d4ae', '\U0001d4b9'),
        ('\U0001d4bb', '\U0001d4bb'), ('\U0001d4bd', '\U0001d4c3'), ('\U0001d4c5', '\U0001d505'),
        ('\U0001d507', '\U0001d50a'), ('\U0001d50d', '\U0001d514'), ('\U0001d516', '\U0001d51c'),
        ('\U0001d51e', '\U0001d539'), ('\U0001d53b', '\U0001d53e'), ('\U0001d540', '\U0001d544'),
        ('\U0001d546', '\U0001d546'), ('\U0001d54a', '\U0001d550'), ('\U0001d552', '\U0001d6a5'),
        ('\U0001d6a8', '\U0001d6c0'), ('\U0001d6c2', '\U0001d6da'), ('\U0001d6dc', '\U0001d6fa'),
        ('\U0001d6fc', '\U0001d714'), ('\U0001d716', '\U0001d734'), ('\U0001d736', '\U0001d74e'),
        ('\U0001d750', '\U0001d76e'), ('\U0001d770', '\U0001d788'), ('\U0001d78a', '\U0001d7a8'),
        ('\U0001d7aa', '\U0001d7c2'), ('\U0001d7c4', '\U0001d7cb'), ('\U0001e800', '\U0001e8c4'),
        ('\U0001ee00', '\U0001ee03'), ('\U0001ee05', '\U0001ee1f'), ('\U0001ee21', '\U0001ee22'),
        ('\U0001ee24', '\U0001ee24'), ('\U0001ee27', '\U0001ee27'), ('\U0001ee29', '\U0001ee32'),
        ('\U0001ee34', '\U0001ee37'), ('\U0001ee39', '\U0001ee39'), ('\U0001ee3b', '\U0001ee3b'),
        ('\U0001ee42', '\U0001ee42'), ('\U0001ee47', '\U0001ee47'), ('\U0001ee49', '\U0001ee49'),
        ('\U0001ee4b', '\U0001ee4b'), ('\U0001ee4d', '\U0001ee4f'), ('\U0001ee51', '\U0001ee52'),
        ('\U0001ee54', '\U0001ee54'), ('\U0001ee57', '\U0001ee57'), ('\U0001ee59', '\U0001ee59'),
        ('\U0001ee5b', '\U0001ee5b'), ('\U0001ee5d', '\U0001ee5d'), ('\U0001ee5f', '\U0001ee5f'),
        ('\U0001ee61', '\U0001ee62'), ('\U0001ee64', '\U0001ee64'), ('\U0001ee67', '\U0001ee6a'),
        ('\U0001ee6c', '\U0001ee72'), ('\U0001ee74', '\U0001ee77'), ('\U0001ee79', '\U0001ee7c'),
        ('\U0001ee7e', '\U0001ee7e'), ('\U0001ee80', '\U0001ee89'), ('\U0001ee8b', '\U0001ee9b'),
        ('\U0001eea1', '\U0001eea3'), ('\U0001eea5', '\U0001eea9'), ('\U0001eeab', '\U0001eebb'),
        ('\U00020000', '\U00020000'), ('\U0002a6d6', '\U0002a6d6'), ('\U0002a700', '\U0002a700'),
        ('\U0002b734', '\U0002b734'), ('\U0002b740', '\U0002b740'), ('\U0002b81d', '\U0002b81d'),
        ('\U0002f800', '\U0002fa1d')
    ];

    pub static LC_table: &'static [(char, char)] = &[
        ('\x41', '\x5a'), ('\x61', '\x7a'), ('\u00b5', '\u00b5'), ('\u00c0', '\u00d6'), ('\u00d8',
        '\u00f6'), ('\u00f8', '\u01ba'), ('\u01bc', '\u01bf'), ('\u01c4', '\u0293'), ('\u0295',
        '\u02af'), ('\u0370', '\u0373'), ('\u0376', '\u0377'), ('\u037b', '\u037d'), ('\u037f',
        '\u037f'), ('\u0386', '\u0386'), ('\u0388', '\u038a'), ('\u038c', '\u038c'), ('\u038e',
        '\u03a1'), ('\u03a3', '\u03f5'), ('\u03f7', '\u0481'), ('\u048a', '\u052f'), ('\u0531',
        '\u0556'), ('\u0561', '\u0587'), ('\u10a0', '\u10c5'), ('\u10c7', '\u10c7'), ('\u10cd',
        '\u10cd'), ('\u1d00', '\u1d2b'), ('\u1d6b', '\u1d77'), ('\u1d79', '\u1d9a'), ('\u1e00',
        '\u1f15'), ('\u1f18', '\u1f1d'), ('\u1f20', '\u1f45'), ('\u1f48', '\u1f4d'), ('\u1f50',
        '\u1f57'), ('\u1f59', '\u1f59'), ('\u1f5b', '\u1f5b'), ('\u1f5d', '\u1f5d'), ('\u1f5f',
        '\u1f7d'), ('\u1f80', '\u1fb4'), ('\u1fb6', '\u1fbc'), ('\u1fbe', '\u1fbe'), ('\u1fc2',
        '\u1fc4'), ('\u1fc6', '\u1fcc'), ('\u1fd0', '\u1fd3'), ('\u1fd6', '\u1fdb'), ('\u1fe0',
        '\u1fec'), ('\u1ff2', '\u1ff4'), ('\u1ff6', '\u1ffc'), ('\u2102', '\u2102'), ('\u2107',
        '\u2107'), ('\u210a', '\u2113'), ('\u2115', '\u2115'), ('\u2119', '\u211d'), ('\u2124',
        '\u2124'), ('\u2126', '\u2126'), ('\u2128', '\u2128'), ('\u212a', '\u212d'), ('\u212f',
        '\u2134'), ('\u2139', '\u2139'), ('\u213c', '\u213f'), ('\u2145', '\u2149'), ('\u214e',
        '\u214e'), ('\u2183', '\u2184'), ('\u2c00', '\u2c2e'), ('\u2c30', '\u2c5e'), ('\u2c60',
        '\u2c7b'), ('\u2c7e', '\u2ce4'), ('\u2ceb', '\u2cee'), ('\u2cf2', '\u2cf3'), ('\u2d00',
        '\u2d25'), ('\u2d27', '\u2d27'), ('\u2d2d', '\u2d2d'), ('\ua640', '\ua66d'), ('\ua680',
        '\ua69b'), ('\ua722', '\ua76f'), ('\ua771', '\ua787'), ('\ua78b', '\ua78e'), ('\ua790',
        '\ua7ad'), ('\ua7b0', '\ua7b1'), ('\ua7fa', '\ua7fa'), ('\uab30', '\uab5a'), ('\uab64',
        '\uab65'), ('\ufb00', '\ufb06'), ('\ufb13', '\ufb17'), ('\uff21', '\uff3a'), ('\uff41',
        '\uff5a'), ('\U00010400', '\U0001044f'), ('\U000118a0', '\U000118df'), ('\U0001d400',
        '\U0001d454'), ('\U0001d456', '\U0001d49c'), ('\U0001d49e', '\U0001d49f'), ('\U0001d4a2',
        '\U0001d4a2'), ('\U0001d4a5', '\U0001d4a6'), ('\U0001d4a9', '\U0001d4ac'), ('\U0001d4ae',
        '\U0001d4b9'), ('\U0001d4bb', '\U0001d4bb'), ('\U0001d4bd', '\U0001d4c3'), ('\U0001d4c5',
        '\U0001d505'), ('\U0001d507', '\U0001d50a'), ('\U0001d50d', '\U0001d514'), ('\U0001d516',
        '\U0001d51c'), ('\U0001d51e', '\U0001d539'), ('\U0001d53b', '\U0001d53e'), ('\U0001d540',
        '\U0001d544'), ('\U0001d546', '\U0001d546'), ('\U0001d54a', '\U0001d550'), ('\U0001d552',
        '\U0001d6a5'), ('\U0001d6a8', '\U0001d6c0'), ('\U0001d6c2', '\U0001d6da'), ('\U0001d6dc',
        '\U0001d6fa'), ('\U0001d6fc', '\U0001d714'), ('\U0001d716', '\U0001d734'), ('\U0001d736',
        '\U0001d74e'), ('\U0001d750', '\U0001d76e'), ('\U0001d770', '\U0001d788'), ('\U0001d78a',
        '\U0001d7a8'), ('\U0001d7aa', '\U0001d7c2'), ('\U0001d7c4', '\U0001d7cb')
    ];

    pub static Ll_table: &'static [(char, char)] = &[
        ('\x61', '\x7a'), ('\u00b5', '\u00b5'), ('\u00df', '\u00f6'), ('\u00f8', '\u00ff'),
        ('\u0101', '\u0101'), ('\u0103', '\u0103'), ('\u0105', '\u0105'), ('\u0107', '\u0107'),
        ('\u0109', '\u0109'), ('\u010b', '\u010b'), ('\u010d', '\u010d'), ('\u010f', '\u010f'),
        ('\u0111', '\u0111'), ('\u0113', '\u0113'), ('\u0115', '\u0115'), ('\u0117', '\u0117'),
        ('\u0119', '\u0119'), ('\u011b', '\u011b'), ('\u011d', '\u011d'), ('\u011f', '\u011f'),
        ('\u0121', '\u0121'), ('\u0123', '\u0123'), ('\u0125', '\u0125'), ('\u0127', '\u0127'),
        ('\u0129', '\u0129'), ('\u012b', '\u012b'), ('\u012d', '\u012d'), ('\u012f', '\u012f'),
        ('\u0131', '\u0131'), ('\u0133', '\u0133'), ('\u0135', '\u0135'), ('\u0137', '\u0138'),
        ('\u013a', '\u013a'), ('\u013c', '\u013c'), ('\u013e', '\u013e'), ('\u0140', '\u0140'),
        ('\u0142', '\u0142'), ('\u0144', '\u0144'), ('\u0146', '\u0146'), ('\u0148', '\u0149'),
        ('\u014b', '\u014b'), ('\u014d', '\u014d'), ('\u014f', '\u014f'), ('\u0151', '\u0151'),
        ('\u0153', '\u0153'), ('\u0155', '\u0155'), ('\u0157', '\u0157'), ('\u0159', '\u0159'),
        ('\u015b', '\u015b'), ('\u015d', '\u015d'), ('\u015f', '\u015f'), ('\u0161', '\u0161'),
        ('\u0163', '\u0163'), ('\u0165', '\u0165'), ('\u0167', '\u0167'), ('\u0169', '\u0169'),
        ('\u016b', '\u016b'), ('\u016d', '\u016d'), ('\u016f', '\u016f'), ('\u0171', '\u0171'),
        ('\u0173', '\u0173'), ('\u0175', '\u0175'), ('\u0177', '\u0177'), ('\u017a', '\u017a'),
        ('\u017c', '\u017c'), ('\u017e', '\u0180'), ('\u0183', '\u0183'), ('\u0185', '\u0185'),
        ('\u0188', '\u0188'), ('\u018c', '\u018d'), ('\u0192', '\u0192'), ('\u0195', '\u0195'),
        ('\u0199', '\u019b'), ('\u019e', '\u019e'), ('\u01a1', '\u01a1'), ('\u01a3', '\u01a3'),
        ('\u01a5', '\u01a5'), ('\u01a8', '\u01a8'), ('\u01aa', '\u01ab'), ('\u01ad', '\u01ad'),
        ('\u01b0', '\u01b0'), ('\u01b4', '\u01b4'), ('\u01b6', '\u01b6'), ('\u01b9', '\u01ba'),
        ('\u01bd', '\u01bf'), ('\u01c6', '\u01c6'), ('\u01c9', '\u01c9'), ('\u01cc', '\u01cc'),
        ('\u01ce', '\u01ce'), ('\u01d0', '\u01d0'), ('\u01d2', '\u01d2'), ('\u01d4', '\u01d4'),
        ('\u01d6', '\u01d6'), ('\u01d8', '\u01d8'), ('\u01da', '\u01da'), ('\u01dc', '\u01dd'),
        ('\u01df', '\u01df'), ('\u01e1', '\u01e1'), ('\u01e3', '\u01e3'), ('\u01e5', '\u01e5'),
        ('\u01e7', '\u01e7'), ('\u01e9', '\u01e9'), ('\u01eb', '\u01eb'), ('\u01ed', '\u01ed'),
        ('\u01ef', '\u01f0'), ('\u01f3', '\u01f3'), ('\u01f5', '\u01f5'), ('\u01f9', '\u01f9'),
        ('\u01fb', '\u01fb'), ('\u01fd', '\u01fd'), ('\u01ff', '\u01ff'), ('\u0201', '\u0201'),
        ('\u0203', '\u0203'), ('\u0205', '\u0205'), ('\u0207', '\u0207'), ('\u0209', '\u0209'),
        ('\u020b', '\u020b'), ('\u020d', '\u020d'), ('\u020f', '\u020f'), ('\u0211', '\u0211'),
        ('\u0213', '\u0213'), ('\u0215', '\u0215'), ('\u0217', '\u0217'), ('\u0219', '\u0219'),
        ('\u021b', '\u021b'), ('\u021d', '\u021d'), ('\u021f', '\u021f'), ('\u0221', '\u0221'),
        ('\u0223', '\u0223'), ('\u0225', '\u0225'), ('\u0227', '\u0227'), ('\u0229', '\u0229'),
        ('\u022b', '\u022b'), ('\u022d', '\u022d'), ('\u022f', '\u022f'), ('\u0231', '\u0231'),
        ('\u0233', '\u0239'), ('\u023c', '\u023c'), ('\u023f', '\u0240'), ('\u0242', '\u0242'),
        ('\u0247', '\u0247'), ('\u0249', '\u0249'), ('\u024b', '\u024b'), ('\u024d', '\u024d'),
        ('\u024f', '\u0293'), ('\u0295', '\u02af'), ('\u0371', '\u0371'), ('\u0373', '\u0373'),
        ('\u0377', '\u0377'), ('\u037b', '\u037d'), ('\u0390', '\u0390'), ('\u03ac', '\u03ce'),
        ('\u03d0', '\u03d1'), ('\u03d5', '\u03d7'), ('\u03d9', '\u03d9'), ('\u03db', '\u03db'),
        ('\u03dd', '\u03dd'), ('\u03df', '\u03df'), ('\u03e1', '\u03e1'), ('\u03e3', '\u03e3'),
        ('\u03e5', '\u03e5'), ('\u03e7', '\u03e7'), ('\u03e9', '\u03e9'), ('\u03eb', '\u03eb'),
        ('\u03ed', '\u03ed'), ('\u03ef', '\u03f3'), ('\u03f5', '\u03f5'), ('\u03f8', '\u03f8'),
        ('\u03fb', '\u03fc'), ('\u0430', '\u045f'), ('\u0461', '\u0461'), ('\u0463', '\u0463'),
        ('\u0465', '\u0465'), ('\u0467', '\u0467'), ('\u0469', '\u0469'), ('\u046b', '\u046b'),
        ('\u046d', '\u046d'), ('\u046f', '\u046f'), ('\u0471', '\u0471'), ('\u0473', '\u0473'),
        ('\u0475', '\u0475'), ('\u0477', '\u0477'), ('\u0479', '\u0479'), ('\u047b', '\u047b'),
        ('\u047d', '\u047d'), ('\u047f', '\u047f'), ('\u0481', '\u0481'), ('\u048b', '\u048b'),
        ('\u048d', '\u048d'), ('\u048f', '\u048f'), ('\u0491', '\u0491'), ('\u0493', '\u0493'),
        ('\u0495', '\u0495'), ('\u0497', '\u0497'), ('\u0499', '\u0499'), ('\u049b', '\u049b'),
        ('\u049d', '\u049d'), ('\u049f', '\u049f'), ('\u04a1', '\u04a1'), ('\u04a3', '\u04a3'),
        ('\u04a5', '\u04a5'), ('\u04a7', '\u04a7'), ('\u04a9', '\u04a9'), ('\u04ab', '\u04ab'),
        ('\u04ad', '\u04ad'), ('\u04af', '\u04af'), ('\u04b1', '\u04b1'), ('\u04b3', '\u04b3'),
        ('\u04b5', '\u04b5'), ('\u04b7', '\u04b7'), ('\u04b9', '\u04b9'), ('\u04bb', '\u04bb'),
        ('\u04bd', '\u04bd'), ('\u04bf', '\u04bf'), ('\u04c2', '\u04c2'), ('\u04c4', '\u04c4'),
        ('\u04c6', '\u04c6'), ('\u04c8', '\u04c8'), ('\u04ca', '\u04ca'), ('\u04cc', '\u04cc'),
        ('\u04ce', '\u04cf'), ('\u04d1', '\u04d1'), ('\u04d3', '\u04d3'), ('\u04d5', '\u04d5'),
        ('\u04d7', '\u04d7'), ('\u04d9', '\u04d9'), ('\u04db', '\u04db'), ('\u04dd', '\u04dd'),
        ('\u04df', '\u04df'), ('\u04e1', '\u04e1'), ('\u04e3', '\u04e3'), ('\u04e5', '\u04e5'),
        ('\u04e7', '\u04e7'), ('\u04e9', '\u04e9'), ('\u04eb', '\u04eb'), ('\u04ed', '\u04ed'),
        ('\u04ef', '\u04ef'), ('\u04f1', '\u04f1'), ('\u04f3', '\u04f3'), ('\u04f5', '\u04f5'),
        ('\u04f7', '\u04f7'), ('\u04f9', '\u04f9'), ('\u04fb', '\u04fb'), ('\u04fd', '\u04fd'),
        ('\u04ff', '\u04ff'), ('\u0501', '\u0501'), ('\u0503', '\u0503'), ('\u0505', '\u0505'),
        ('\u0507', '\u0507'), ('\u0509', '\u0509'), ('\u050b', '\u050b'), ('\u050d', '\u050d'),
        ('\u050f', '\u050f'), ('\u0511', '\u0511'), ('\u0513', '\u0513'), ('\u0515', '\u0515'),
        ('\u0517', '\u0517'), ('\u0519', '\u0519'), ('\u051b', '\u051b'), ('\u051d', '\u051d'),
        ('\u051f', '\u051f'), ('\u0521', '\u0521'), ('\u0523', '\u0523'), ('\u0525', '\u0525'),
        ('\u0527', '\u0527'), ('\u0529', '\u0529'), ('\u052b', '\u052b'), ('\u052d', '\u052d'),
        ('\u052f', '\u052f'), ('\u0561', '\u0587'), ('\u1d00', '\u1d2b'), ('\u1d6b', '\u1d77'),
        ('\u1d79', '\u1d9a'), ('\u1e01', '\u1e01'), ('\u1e03', '\u1e03'), ('\u1e05', '\u1e05'),
        ('\u1e07', '\u1e07'), ('\u1e09', '\u1e09'), ('\u1e0b', '\u1e0b'), ('\u1e0d', '\u1e0d'),
        ('\u1e0f', '\u1e0f'), ('\u1e11', '\u1e11'), ('\u1e13', '\u1e13'), ('\u1e15', '\u1e15'),
        ('\u1e17', '\u1e17'), ('\u1e19', '\u1e19'), ('\u1e1b', '\u1e1b'), ('\u1e1d', '\u1e1d'),
        ('\u1e1f', '\u1e1f'), ('\u1e21', '\u1e21'), ('\u1e23', '\u1e23'), ('\u1e25', '\u1e25'),
        ('\u1e27', '\u1e27'), ('\u1e29', '\u1e29'), ('\u1e2b', '\u1e2b'), ('\u1e2d', '\u1e2d'),
        ('\u1e2f', '\u1e2f'), ('\u1e31', '\u1e31'), ('\u1e33', '\u1e33'), ('\u1e35', '\u1e35'),
        ('\u1e37', '\u1e37'), ('\u1e39', '\u1e39'), ('\u1e3b', '\u1e3b'), ('\u1e3d', '\u1e3d'),
        ('\u1e3f', '\u1e3f'), ('\u1e41', '\u1e41'), ('\u1e43', '\u1e43'), ('\u1e45', '\u1e45'),
        ('\u1e47', '\u1e47'), ('\u1e49', '\u1e49'), ('\u1e4b', '\u1e4b'), ('\u1e4d', '\u1e4d'),
        ('\u1e4f', '\u1e4f'), ('\u1e51', '\u1e51'), ('\u1e53', '\u1e53'), ('\u1e55', '\u1e55'),
        ('\u1e57', '\u1e57'), ('\u1e59', '\u1e59'), ('\u1e5b', '\u1e5b'), ('\u1e5d', '\u1e5d'),
        ('\u1e5f', '\u1e5f'), ('\u1e61', '\u1e61'), ('\u1e63', '\u1e63'), ('\u1e65', '\u1e65'),
        ('\u1e67', '\u1e67'), ('\u1e69', '\u1e69'), ('\u1e6b', '\u1e6b'), ('\u1e6d', '\u1e6d'),
        ('\u1e6f', '\u1e6f'), ('\u1e71', '\u1e71'), ('\u1e73', '\u1e73'), ('\u1e75', '\u1e75'),
        ('\u1e77', '\u1e77'), ('\u1e79', '\u1e79'), ('\u1e7b', '\u1e7b'), ('\u1e7d', '\u1e7d'),
        ('\u1e7f', '\u1e7f'), ('\u1e81', '\u1e81'), ('\u1e83', '\u1e83'), ('\u1e85', '\u1e85'),
        ('\u1e87', '\u1e87'), ('\u1e89', '\u1e89'), ('\u1e8b', '\u1e8b'), ('\u1e8d', '\u1e8d'),
        ('\u1e8f', '\u1e8f'), ('\u1e91', '\u1e91'), ('\u1e93', '\u1e93'), ('\u1e95', '\u1e9d'),
        ('\u1e9f', '\u1e9f'), ('\u1ea1', '\u1ea1'), ('\u1ea3', '\u1ea3'), ('\u1ea5', '\u1ea5'),
        ('\u1ea7', '\u1ea7'), ('\u1ea9', '\u1ea9'), ('\u1eab', '\u1eab'), ('\u1ead', '\u1ead'),
        ('\u1eaf', '\u1eaf'), ('\u1eb1', '\u1eb1'), ('\u1eb3', '\u1eb3'), ('\u1eb5', '\u1eb5'),
        ('\u1eb7', '\u1eb7'), ('\u1eb9', '\u1eb9'), ('\u1ebb', '\u1ebb'), ('\u1ebd', '\u1ebd'),
        ('\u1ebf', '\u1ebf'), ('\u1ec1', '\u1ec1'), ('\u1ec3', '\u1ec3'), ('\u1ec5', '\u1ec5'),
        ('\u1ec7', '\u1ec7'), ('\u1ec9', '\u1ec9'), ('\u1ecb', '\u1ecb'), ('\u1ecd', '\u1ecd'),
        ('\u1ecf', '\u1ecf'), ('\u1ed1', '\u1ed1'), ('\u1ed3', '\u1ed3'), ('\u1ed5', '\u1ed5'),
        ('\u1ed7', '\u1ed7'), ('\u1ed9', '\u1ed9'), ('\u1edb', '\u1edb'), ('\u1edd', '\u1edd'),
        ('\u1edf', '\u1edf'), ('\u1ee1', '\u1ee1'), ('\u1ee3', '\u1ee3'), ('\u1ee5', '\u1ee5'),
        ('\u1ee7', '\u1ee7'), ('\u1ee9', '\u1ee9'), ('\u1eeb', '\u1eeb'), ('\u1eed', '\u1eed'),
        ('\u1eef', '\u1eef'), ('\u1ef1', '\u1ef1'), ('\u1ef3', '\u1ef3'), ('\u1ef5', '\u1ef5'),
        ('\u1ef7', '\u1ef7'), ('\u1ef9', '\u1ef9'), ('\u1efb', '\u1efb'), ('\u1efd', '\u1efd'),
        ('\u1eff', '\u1f07'), ('\u1f10', '\u1f15'), ('\u1f20', '\u1f27'), ('\u1f30', '\u1f37'),
        ('\u1f40', '\u1f45'), ('\u1f50', '\u1f57'), ('\u1f60', '\u1f67'), ('\u1f70', '\u1f7d'),
        ('\u1f80', '\u1f87'), ('\u1f90', '\u1f97'), ('\u1fa0', '\u1fa7'), ('\u1fb0', '\u1fb4'),
        ('\u1fb6', '\u1fb7'), ('\u1fbe', '\u1fbe'), ('\u1fc2', '\u1fc4'), ('\u1fc6', '\u1fc7'),
        ('\u1fd0', '\u1fd3'), ('\u1fd6', '\u1fd7'), ('\u1fe0', '\u1fe7'), ('\u1ff2', '\u1ff4'),
        ('\u1ff6', '\u1ff7'), ('\u210a', '\u210a'), ('\u210e', '\u210f'), ('\u2113', '\u2113'),
        ('\u212f', '\u212f'), ('\u2134', '\u2134'), ('\u2139', '\u2139'), ('\u213c', '\u213d'),
        ('\u2146', '\u2149'), ('\u214e', '\u214e'), ('\u2184', '\u2184'), ('\u2c30', '\u2c5e'),
        ('\u2c61', '\u2c61'), ('\u2c65', '\u2c66'), ('\u2c68', '\u2c68'), ('\u2c6a', '\u2c6a'),
        ('\u2c6c', '\u2c6c'), ('\u2c71', '\u2c71'), ('\u2c73', '\u2c74'), ('\u2c76', '\u2c7b'),
        ('\u2c81', '\u2c81'), ('\u2c83', '\u2c83'), ('\u2c85', '\u2c85'), ('\u2c87', '\u2c87'),
        ('\u2c89', '\u2c89'), ('\u2c8b', '\u2c8b'), ('\u2c8d', '\u2c8d'), ('\u2c8f', '\u2c8f'),
        ('\u2c91', '\u2c91'), ('\u2c93', '\u2c93'), ('\u2c95', '\u2c95'), ('\u2c97', '\u2c97'),
        ('\u2c99', '\u2c99'), ('\u2c9b', '\u2c9b'), ('\u2c9d', '\u2c9d'), ('\u2c9f', '\u2c9f'),
        ('\u2ca1', '\u2ca1'), ('\u2ca3', '\u2ca3'), ('\u2ca5', '\u2ca5'), ('\u2ca7', '\u2ca7'),
        ('\u2ca9', '\u2ca9'), ('\u2cab', '\u2cab'), ('\u2cad', '\u2cad'), ('\u2caf', '\u2caf'),
        ('\u2cb1', '\u2cb1'), ('\u2cb3', '\u2cb3'), ('\u2cb5', '\u2cb5'), ('\u2cb7', '\u2cb7'),
        ('\u2cb9', '\u2cb9'), ('\u2cbb', '\u2cbb'), ('\u2cbd', '\u2cbd'), ('\u2cbf', '\u2cbf'),
        ('\u2cc1', '\u2cc1'), ('\u2cc3', '\u2cc3'), ('\u2cc5', '\u2cc5'), ('\u2cc7', '\u2cc7'),
        ('\u2cc9', '\u2cc9'), ('\u2ccb', '\u2ccb'), ('\u2ccd', '\u2ccd'), ('\u2ccf', '\u2ccf'),
        ('\u2cd1', '\u2cd1'), ('\u2cd3', '\u2cd3'), ('\u2cd5', '\u2cd5'), ('\u2cd7', '\u2cd7'),
        ('\u2cd9', '\u2cd9'), ('\u2cdb', '\u2cdb'), ('\u2cdd', '\u2cdd'), ('\u2cdf', '\u2cdf'),
        ('\u2ce1', '\u2ce1'), ('\u2ce3', '\u2ce4'), ('\u2cec', '\u2cec'), ('\u2cee', '\u2cee'),
        ('\u2cf3', '\u2cf3'), ('\u2d00', '\u2d25'), ('\u2d27', '\u2d27'), ('\u2d2d', '\u2d2d'),
        ('\ua641', '\ua641'), ('\ua643', '\ua643'), ('\ua645', '\ua645'), ('\ua647', '\ua647'),
        ('\ua649', '\ua649'), ('\ua64b', '\ua64b'), ('\ua64d', '\ua64d'), ('\ua64f', '\ua64f'),
        ('\ua651', '\ua651'), ('\ua653', '\ua653'), ('\ua655', '\ua655'), ('\ua657', '\ua657'),
        ('\ua659', '\ua659'), ('\ua65b', '\ua65b'), ('\ua65d', '\ua65d'), ('\ua65f', '\ua65f'),
        ('\ua661', '\ua661'), ('\ua663', '\ua663'), ('\ua665', '\ua665'), ('\ua667', '\ua667'),
        ('\ua669', '\ua669'), ('\ua66b', '\ua66b'), ('\ua66d', '\ua66d'), ('\ua681', '\ua681'),
        ('\ua683', '\ua683'), ('\ua685', '\ua685'), ('\ua687', '\ua687'), ('\ua689', '\ua689'),
        ('\ua68b', '\ua68b'), ('\ua68d', '\ua68d'), ('\ua68f', '\ua68f'), ('\ua691', '\ua691'),
        ('\ua693', '\ua693'), ('\ua695', '\ua695'), ('\ua697', '\ua697'), ('\ua699', '\ua699'),
        ('\ua69b', '\ua69b'), ('\ua723', '\ua723'), ('\ua725', '\ua725'), ('\ua727', '\ua727'),
        ('\ua729', '\ua729'), ('\ua72b', '\ua72b'), ('\ua72d', '\ua72d'), ('\ua72f', '\ua731'),
        ('\ua733', '\ua733'), ('\ua735', '\ua735'), ('\ua737', '\ua737'), ('\ua739', '\ua739'),
        ('\ua73b', '\ua73b'), ('\ua73d', '\ua73d'), ('\ua73f', '\ua73f'), ('\ua741', '\ua741'),
        ('\ua743', '\ua743'), ('\ua745', '\ua745'), ('\ua747', '\ua747'), ('\ua749', '\ua749'),
        ('\ua74b', '\ua74b'), ('\ua74d', '\ua74d'), ('\ua74f', '\ua74f'), ('\ua751', '\ua751'),
        ('\ua753', '\ua753'), ('\ua755', '\ua755'), ('\ua757', '\ua757'), ('\ua759', '\ua759'),
        ('\ua75b', '\ua75b'), ('\ua75d', '\ua75d'), ('\ua75f', '\ua75f'), ('\ua761', '\ua761'),
        ('\ua763', '\ua763'), ('\ua765', '\ua765'), ('\ua767', '\ua767'), ('\ua769', '\ua769'),
        ('\ua76b', '\ua76b'), ('\ua76d', '\ua76d'), ('\ua76f', '\ua76f'), ('\ua771', '\ua778'),
        ('\ua77a', '\ua77a'), ('\ua77c', '\ua77c'), ('\ua77f', '\ua77f'), ('\ua781', '\ua781'),
        ('\ua783', '\ua783'), ('\ua785', '\ua785'), ('\ua787', '\ua787'), ('\ua78c', '\ua78c'),
        ('\ua78e', '\ua78e'), ('\ua791', '\ua791'), ('\ua793', '\ua795'), ('\ua797', '\ua797'),
        ('\ua799', '\ua799'), ('\ua79b', '\ua79b'), ('\ua79d', '\ua79d'), ('\ua79f', '\ua79f'),
        ('\ua7a1', '\ua7a1'), ('\ua7a3', '\ua7a3'), ('\ua7a5', '\ua7a5'), ('\ua7a7', '\ua7a7'),
        ('\ua7a9', '\ua7a9'), ('\ua7fa', '\ua7fa'), ('\uab30', '\uab5a'), ('\uab64', '\uab65'),
        ('\ufb00', '\ufb06'), ('\ufb13', '\ufb17'), ('\uff41', '\uff5a'), ('\U00010428',
        '\U0001044f'), ('\U000118c0', '\U000118df'), ('\U0001d41a', '\U0001d433'), ('\U0001d44e',
        '\U0001d454'), ('\U0001d456', '\U0001d467'), ('\U0001d482', '\U0001d49b'), ('\U0001d4b6',
        '\U0001d4b9'), ('\U0001d4bb', '\U0001d4bb'), ('\U0001d4bd', '\U0001d4c3'), ('\U0001d4c5',
        '\U0001d4cf'), ('\U0001d4ea', '\U0001d503'), ('\U0001d51e', '\U0001d537'), ('\U0001d552',
        '\U0001d56b'), ('\U0001d586', '\U0001d59f'), ('\U0001d5ba', '\U0001d5d3'), ('\U0001d5ee',
        '\U0001d607'), ('\U0001d622', '\U0001d63b'), ('\U0001d656', '\U0001d66f'), ('\U0001d68a',
        '\U0001d6a5'), ('\U0001d6c2', '\U0001d6da'), ('\U0001d6dc', '\U0001d6e1'), ('\U0001d6fc',
        '\U0001d714'), ('\U0001d716', '\U0001d71b'), ('\U0001d736', '\U0001d74e'), ('\U0001d750',
        '\U0001d755'), ('\U0001d770', '\U0001d788'), ('\U0001d78a', '\U0001d78f'), ('\U0001d7aa',
        '\U0001d7c2'), ('\U0001d7c4', '\U0001d7c9'), ('\U0001d7cb', '\U0001d7cb')
    ];

    pub static Lm_table: &'static [(char, char)] = &[
        ('\u02b0', '\u02c1'), ('\u02c6', '\u02d1'), ('\u02e0', '\u02e4'), ('\u02ec', '\u02ec'),
        ('\u02ee', '\u02ee'), ('\u0374', '\u0374'), ('\u037a', '\u037a'), ('\u0559', '\u0559'),
        ('\u0640', '\u0640'), ('\u06e5', '\u06e6'), ('\u07f4', '\u07f5'), ('\u07fa', '\u07fa'),
        ('\u081a', '\u081a'), ('\u0824', '\u0824'), ('\u0828', '\u0828'), ('\u0971', '\u0971'),
        ('\u0e46', '\u0e46'), ('\u0ec6', '\u0ec6'), ('\u10fc', '\u10fc'), ('\u17d7', '\u17d7'),
        ('\u1843', '\u1843'), ('\u1aa7', '\u1aa7'), ('\u1c78', '\u1c7d'), ('\u1d2c', '\u1d6a'),
        ('\u1d78', '\u1d78'), ('\u1d9b', '\u1dbf'), ('\u2071', '\u2071'), ('\u207f', '\u207f'),
        ('\u2090', '\u209c'), ('\u2c7c', '\u2c7d'), ('\u2d6f', '\u2d6f'), ('\u2e2f', '\u2e2f'),
        ('\u3005', '\u3005'), ('\u3031', '\u3035'), ('\u303b', '\u303b'), ('\u309d', '\u309e'),
        ('\u30fc', '\u30fe'), ('\ua015', '\ua015'), ('\ua4f8', '\ua4fd'), ('\ua60c', '\ua60c'),
        ('\ua67f', '\ua67f'), ('\ua69c', '\ua69d'), ('\ua717', '\ua71f'), ('\ua770', '\ua770'),
        ('\ua788', '\ua788'), ('\ua7f8', '\ua7f9'), ('\ua9cf', '\ua9cf'), ('\ua9e6', '\ua9e6'),
        ('\uaa70', '\uaa70'), ('\uaadd', '\uaadd'), ('\uaaf3', '\uaaf4'), ('\uab5c', '\uab5f'),
        ('\uff70', '\uff70'), ('\uff9e', '\uff9f'), ('\U00016b40', '\U00016b43'), ('\U00016f93',
        '\U00016f9f')
    ];

    pub static Lo_table: &'static [(char, char)] = &[
        ('\u00aa', '\u00aa'), ('\u00ba', '\u00ba'), ('\u01bb', '\u01bb'), ('\u01c0', '\u01c3'),
        ('\u0294', '\u0294'), ('\u05d0', '\u05ea'), ('\u05f0', '\u05f2'), ('\u0620', '\u063f'),
        ('\u0641', '\u064a'), ('\u066e', '\u066f'), ('\u0671', '\u06d3'), ('\u06d5', '\u06d5'),
        ('\u06ee', '\u06ef'), ('\u06fa', '\u06fc'), ('\u06ff', '\u06ff'), ('\u0710', '\u0710'),
        ('\u0712', '\u072f'), ('\u074d', '\u07a5'), ('\u07b1', '\u07b1'), ('\u07ca', '\u07ea'),
        ('\u0800', '\u0815'), ('\u0840', '\u0858'), ('\u08a0', '\u08b2'), ('\u0904', '\u0939'),
        ('\u093d', '\u093d'), ('\u0950', '\u0950'), ('\u0958', '\u0961'), ('\u0972', '\u0980'),
        ('\u0985', '\u098c'), ('\u098f', '\u0990'), ('\u0993', '\u09a8'), ('\u09aa', '\u09b0'),
        ('\u09b2', '\u09b2'), ('\u09b6', '\u09b9'), ('\u09bd', '\u09bd'), ('\u09ce', '\u09ce'),
        ('\u09dc', '\u09dd'), ('\u09df', '\u09e1'), ('\u09f0', '\u09f1'), ('\u0a05', '\u0a0a'),
        ('\u0a0f', '\u0a10'), ('\u0a13', '\u0a28'), ('\u0a2a', '\u0a30'), ('\u0a32', '\u0a33'),
        ('\u0a35', '\u0a36'), ('\u0a38', '\u0a39'), ('\u0a59', '\u0a5c'), ('\u0a5e', '\u0a5e'),
        ('\u0a72', '\u0a74'), ('\u0a85', '\u0a8d'), ('\u0a8f', '\u0a91'), ('\u0a93', '\u0aa8'),
        ('\u0aaa', '\u0ab0'), ('\u0ab2', '\u0ab3'), ('\u0ab5', '\u0ab9'), ('\u0abd', '\u0abd'),
        ('\u0ad0', '\u0ad0'), ('\u0ae0', '\u0ae1'), ('\u0b05', '\u0b0c'), ('\u0b0f', '\u0b10'),
        ('\u0b13', '\u0b28'), ('\u0b2a', '\u0b30'), ('\u0b32', '\u0b33'), ('\u0b35', '\u0b39'),
        ('\u0b3d', '\u0b3d'), ('\u0b5c', '\u0b5d'), ('\u0b5f', '\u0b61'), ('\u0b71', '\u0b71'),
        ('\u0b83', '\u0b83'), ('\u0b85', '\u0b8a'), ('\u0b8e', '\u0b90'), ('\u0b92', '\u0b95'),
        ('\u0b99', '\u0b9a'), ('\u0b9c', '\u0b9c'), ('\u0b9e', '\u0b9f'), ('\u0ba3', '\u0ba4'),
        ('\u0ba8', '\u0baa'), ('\u0bae', '\u0bb9'), ('\u0bd0', '\u0bd0'), ('\u0c05', '\u0c0c'),
        ('\u0c0e', '\u0c10'), ('\u0c12', '\u0c28'), ('\u0c2a', '\u0c39'), ('\u0c3d', '\u0c3d'),
        ('\u0c58', '\u0c59'), ('\u0c60', '\u0c61'), ('\u0c85', '\u0c8c'), ('\u0c8e', '\u0c90'),
        ('\u0c92', '\u0ca8'), ('\u0caa', '\u0cb3'), ('\u0cb5', '\u0cb9'), ('\u0cbd', '\u0cbd'),
        ('\u0cde', '\u0cde'), ('\u0ce0', '\u0ce1'), ('\u0cf1', '\u0cf2'), ('\u0d05', '\u0d0c'),
        ('\u0d0e', '\u0d10'), ('\u0d12', '\u0d3a'), ('\u0d3d', '\u0d3d'), ('\u0d4e', '\u0d4e'),
        ('\u0d60', '\u0d61'), ('\u0d7a', '\u0d7f'), ('\u0d85', '\u0d96'), ('\u0d9a', '\u0db1'),
        ('\u0db3', '\u0dbb'), ('\u0dbd', '\u0dbd'), ('\u0dc0', '\u0dc6'), ('\u0e01', '\u0e30'),
        ('\u0e32', '\u0e33'), ('\u0e40', '\u0e45'), ('\u0e81', '\u0e82'), ('\u0e84', '\u0e84'),
        ('\u0e87', '\u0e88'), ('\u0e8a', '\u0e8a'), ('\u0e8d', '\u0e8d'), ('\u0e94', '\u0e97'),
        ('\u0e99', '\u0e9f'), ('\u0ea1', '\u0ea3'), ('\u0ea5', '\u0ea5'), ('\u0ea7', '\u0ea7'),
        ('\u0eaa', '\u0eab'), ('\u0ead', '\u0eb0'), ('\u0eb2', '\u0eb3'), ('\u0ebd', '\u0ebd'),
        ('\u0ec0', '\u0ec4'), ('\u0edc', '\u0edf'), ('\u0f00', '\u0f00'), ('\u0f40', '\u0f47'),
        ('\u0f49', '\u0f6c'), ('\u0f88', '\u0f8c'), ('\u1000', '\u102a'), ('\u103f', '\u103f'),
        ('\u1050', '\u1055'), ('\u105a', '\u105d'), ('\u1061', '\u1061'), ('\u1065', '\u1066'),
        ('\u106e', '\u1070'), ('\u1075', '\u1081'), ('\u108e', '\u108e'), ('\u10d0', '\u10fa'),
        ('\u10fd', '\u1248'), ('\u124a', '\u124d'), ('\u1250', '\u1256'), ('\u1258', '\u1258'),
        ('\u125a', '\u125d'), ('\u1260', '\u1288'), ('\u128a', '\u128d'), ('\u1290', '\u12b0'),
        ('\u12b2', '\u12b5'), ('\u12b8', '\u12be'), ('\u12c0', '\u12c0'), ('\u12c2', '\u12c5'),
        ('\u12c8', '\u12d6'), ('\u12d8', '\u1310'), ('\u1312', '\u1315'), ('\u1318', '\u135a'),
        ('\u1380', '\u138f'), ('\u13a0', '\u13f4'), ('\u1401', '\u166c'), ('\u166f', '\u167f'),
        ('\u1681', '\u169a'), ('\u16a0', '\u16ea'), ('\u16f1', '\u16f8'), ('\u1700', '\u170c'),
        ('\u170e', '\u1711'), ('\u1720', '\u1731'), ('\u1740', '\u1751'), ('\u1760', '\u176c'),
        ('\u176e', '\u1770'), ('\u1780', '\u17b3'), ('\u17dc', '\u17dc'), ('\u1820', '\u1842'),
        ('\u1844', '\u1877'), ('\u1880', '\u18a8'), ('\u18aa', '\u18aa'), ('\u18b0', '\u18f5'),
        ('\u1900', '\u191e'), ('\u1950', '\u196d'), ('\u1970', '\u1974'), ('\u1980', '\u19ab'),
        ('\u19c1', '\u19c7'), ('\u1a00', '\u1a16'), ('\u1a20', '\u1a54'), ('\u1b05', '\u1b33'),
        ('\u1b45', '\u1b4b'), ('\u1b83', '\u1ba0'), ('\u1bae', '\u1baf'), ('\u1bba', '\u1be5'),
        ('\u1c00', '\u1c23'), ('\u1c4d', '\u1c4f'), ('\u1c5a', '\u1c77'), ('\u1ce9', '\u1cec'),
        ('\u1cee', '\u1cf1'), ('\u1cf5', '\u1cf6'), ('\u2135', '\u2138'), ('\u2d30', '\u2d67'),
        ('\u2d80', '\u2d96'), ('\u2da0', '\u2da6'), ('\u2da8', '\u2dae'), ('\u2db0', '\u2db6'),
        ('\u2db8', '\u2dbe'), ('\u2dc0', '\u2dc6'), ('\u2dc8', '\u2dce'), ('\u2dd0', '\u2dd6'),
        ('\u2dd8', '\u2dde'), ('\u3006', '\u3006'), ('\u303c', '\u303c'), ('\u3041', '\u3096'),
        ('\u309f', '\u309f'), ('\u30a1', '\u30fa'), ('\u30ff', '\u30ff'), ('\u3105', '\u312d'),
        ('\u3131', '\u318e'), ('\u31a0', '\u31ba'), ('\u31f0', '\u31ff'), ('\u3400', '\u3400'),
        ('\u4db5', '\u4db5'), ('\u4e00', '\u4e00'), ('\u9fcc', '\u9fcc'), ('\ua000', '\ua014'),
        ('\ua016', '\ua48c'), ('\ua4d0', '\ua4f7'), ('\ua500', '\ua60b'), ('\ua610', '\ua61f'),
        ('\ua62a', '\ua62b'), ('\ua66e', '\ua66e'), ('\ua6a0', '\ua6e5'), ('\ua7f7', '\ua7f7'),
        ('\ua7fb', '\ua801'), ('\ua803', '\ua805'), ('\ua807', '\ua80a'), ('\ua80c', '\ua822'),
        ('\ua840', '\ua873'), ('\ua882', '\ua8b3'), ('\ua8f2', '\ua8f7'), ('\ua8fb', '\ua8fb'),
        ('\ua90a', '\ua925'), ('\ua930', '\ua946'), ('\ua960', '\ua97c'), ('\ua984', '\ua9b2'),
        ('\ua9e0', '\ua9e4'), ('\ua9e7', '\ua9ef'), ('\ua9fa', '\ua9fe'), ('\uaa00', '\uaa28'),
        ('\uaa40', '\uaa42'), ('\uaa44', '\uaa4b'), ('\uaa60', '\uaa6f'), ('\uaa71', '\uaa76'),
        ('\uaa7a', '\uaa7a'), ('\uaa7e', '\uaaaf'), ('\uaab1', '\uaab1'), ('\uaab5', '\uaab6'),
        ('\uaab9', '\uaabd'), ('\uaac0', '\uaac0'), ('\uaac2', '\uaac2'), ('\uaadb', '\uaadc'),
        ('\uaae0', '\uaaea'), ('\uaaf2', '\uaaf2'), ('\uab01', '\uab06'), ('\uab09', '\uab0e'),
        ('\uab11', '\uab16'), ('\uab20', '\uab26'), ('\uab28', '\uab2e'), ('\uabc0', '\uabe2'),
        ('\uac00', '\uac00'), ('\ud7a3', '\ud7a3'), ('\ud7b0', '\ud7c6'), ('\ud7cb', '\ud7fb'),
        ('\uf900', '\ufa6d'), ('\ufa70', '\ufad9'), ('\ufb1d', '\ufb1d'), ('\ufb1f', '\ufb28'),
        ('\ufb2a', '\ufb36'), ('\ufb38', '\ufb3c'), ('\ufb3e', '\ufb3e'), ('\ufb40', '\ufb41'),
        ('\ufb43', '\ufb44'), ('\ufb46', '\ufbb1'), ('\ufbd3', '\ufd3d'), ('\ufd50', '\ufd8f'),
        ('\ufd92', '\ufdc7'), ('\ufdf0', '\ufdfb'), ('\ufe70', '\ufe74'), ('\ufe76', '\ufefc'),
        ('\uff66', '\uff6f'), ('\uff71', '\uff9d'), ('\uffa0', '\uffbe'), ('\uffc2', '\uffc7'),
        ('\uffca', '\uffcf'), ('\uffd2', '\uffd7'), ('\uffda', '\uffdc'), ('\U00010000',
        '\U0001000b'), ('\U0001000d', '\U00010026'), ('\U00010028', '\U0001003a'), ('\U0001003c',
        '\U0001003d'), ('\U0001003f', '\U0001004d'), ('\U00010050', '\U0001005d'), ('\U00010080',
        '\U000100fa'), ('\U00010280', '\U0001029c'), ('\U000102a0', '\U000102d0'), ('\U00010300',
        '\U0001031f'), ('\U00010330', '\U00010340'), ('\U00010342', '\U00010349'), ('\U00010350',
        '\U00010375'), ('\U00010380', '\U0001039d'), ('\U000103a0', '\U000103c3'), ('\U000103c8',
        '\U000103cf'), ('\U00010450', '\U0001049d'), ('\U00010500', '\U00010527'), ('\U00010530',
        '\U00010563'), ('\U00010600', '\U00010736'), ('\U00010740', '\U00010755'), ('\U00010760',
        '\U00010767'), ('\U00010800', '\U00010805'), ('\U00010808', '\U00010808'), ('\U0001080a',
        '\U00010835'), ('\U00010837', '\U00010838'), ('\U0001083c', '\U0001083c'), ('\U0001083f',
        '\U00010855'), ('\U00010860', '\U00010876'), ('\U00010880', '\U0001089e'), ('\U00010900',
        '\U00010915'), ('\U00010920', '\U00010939'), ('\U00010980', '\U000109b7'), ('\U000109be',
        '\U000109bf'), ('\U00010a00', '\U00010a00'), ('\U00010a10', '\U00010a13'), ('\U00010a15',
        '\U00010a17'), ('\U00010a19', '\U00010a33'), ('\U00010a60', '\U00010a7c'), ('\U00010a80',
        '\U00010a9c'), ('\U00010ac0', '\U00010ac7'), ('\U00010ac9', '\U00010ae4'), ('\U00010b00',
        '\U00010b35'), ('\U00010b40', '\U00010b55'), ('\U00010b60', '\U00010b72'), ('\U00010b80',
        '\U00010b91'), ('\U00010c00', '\U00010c48'), ('\U00011003', '\U00011037'), ('\U00011083',
        '\U000110af'), ('\U000110d0', '\U000110e8'), ('\U00011103', '\U00011126'), ('\U00011150',
        '\U00011172'), ('\U00011176', '\U00011176'), ('\U00011183', '\U000111b2'), ('\U000111c1',
        '\U000111c4'), ('\U000111da', '\U000111da'), ('\U00011200', '\U00011211'), ('\U00011213',
        '\U0001122b'), ('\U000112b0', '\U000112de'), ('\U00011305', '\U0001130c'), ('\U0001130f',
        '\U00011310'), ('\U00011313', '\U00011328'), ('\U0001132a', '\U00011330'), ('\U00011332',
        '\U00011333'), ('\U00011335', '\U00011339'), ('\U0001133d', '\U0001133d'), ('\U0001135d',
        '\U00011361'), ('\U00011480', '\U000114af'), ('\U000114c4', '\U000114c5'), ('\U000114c7',
        '\U000114c7'), ('\U00011580', '\U000115ae'), ('\U00011600', '\U0001162f'), ('\U00011644',
        '\U00011644'), ('\U00011680', '\U000116aa'), ('\U000118ff', '\U000118ff'), ('\U00011ac0',
        '\U00011af8'), ('\U00012000', '\U00012398'), ('\U00013000', '\U0001342e'), ('\U00016800',
        '\U00016a38'), ('\U00016a40', '\U00016a5e'), ('\U00016ad0', '\U00016aed'), ('\U00016b00',
        '\U00016b2f'), ('\U00016b63', '\U00016b77'), ('\U00016b7d', '\U00016b8f'), ('\U00016f00',
        '\U00016f44'), ('\U00016f50', '\U00016f50'), ('\U0001b000', '\U0001b001'), ('\U0001bc00',
        '\U0001bc6a'), ('\U0001bc70', '\U0001bc7c'), ('\U0001bc80', '\U0001bc88'), ('\U0001bc90',
        '\U0001bc99'), ('\U0001e800', '\U0001e8c4'), ('\U0001ee00', '\U0001ee03'), ('\U0001ee05',
        '\U0001ee1f'), ('\U0001ee21', '\U0001ee22'), ('\U0001ee24', '\U0001ee24'), ('\U0001ee27',
        '\U0001ee27'), ('\U0001ee29', '\U0001ee32'), ('\U0001ee34', '\U0001ee37'), ('\U0001ee39',
        '\U0001ee39'), ('\U0001ee3b', '\U0001ee3b'), ('\U0001ee42', '\U0001ee42'), ('\U0001ee47',
        '\U0001ee47'), ('\U0001ee49', '\U0001ee49'), ('\U0001ee4b', '\U0001ee4b'), ('\U0001ee4d',
        '\U0001ee4f'), ('\U0001ee51', '\U0001ee52'), ('\U0001ee54', '\U0001ee54'), ('\U0001ee57',
        '\U0001ee57'), ('\U0001ee59', '\U0001ee59'), ('\U0001ee5b', '\U0001ee5b'), ('\U0001ee5d',
        '\U0001ee5d'), ('\U0001ee5f', '\U0001ee5f'), ('\U0001ee61', '\U0001ee62'), ('\U0001ee64',
        '\U0001ee64'), ('\U0001ee67', '\U0001ee6a'), ('\U0001ee6c', '\U0001ee72'), ('\U0001ee74',
        '\U0001ee77'), ('\U0001ee79', '\U0001ee7c'), ('\U0001ee7e', '\U0001ee7e'), ('\U0001ee80',
        '\U0001ee89'), ('\U0001ee8b', '\U0001ee9b'), ('\U0001eea1', '\U0001eea3'), ('\U0001eea5',
        '\U0001eea9'), ('\U0001eeab', '\U0001eebb'), ('\U00020000', '\U00020000'), ('\U0002a6d6',
        '\U0002a6d6'), ('\U0002a700', '\U0002a700'), ('\U0002b734', '\U0002b734'), ('\U0002b740',
        '\U0002b740'), ('\U0002b81d', '\U0002b81d'), ('\U0002f800', '\U0002fa1d')
    ];

    pub static Lt_table: &'static [(char, char)] = &[
        ('\u01c5', '\u01c5'), ('\u01c8', '\u01c8'), ('\u01cb', '\u01cb'), ('\u01f2', '\u01f2'),
        ('\u1f88', '\u1f8f'), ('\u1f98', '\u1f9f'), ('\u1fa8', '\u1faf'), ('\u1fbc', '\u1fbc'),
        ('\u1fcc', '\u1fcc'), ('\u1ffc', '\u1ffc')
    ];

    pub static Lu_table: &'static [(char, char)] = &[
        ('\x41', '\x5a'), ('\u00c0', '\u00d6'), ('\u00d8', '\u00de'), ('\u0100', '\u0100'),
        ('\u0102', '\u0102'), ('\u0104', '\u0104'), ('\u0106', '\u0106'), ('\u0108', '\u0108'),
        ('\u010a', '\u010a'), ('\u010c', '\u010c'), ('\u010e', '\u010e'), ('\u0110', '\u0110'),
        ('\u0112', '\u0112'), ('\u0114', '\u0114'), ('\u0116', '\u0116'), ('\u0118', '\u0118'),
        ('\u011a', '\u011a'), ('\u011c', '\u011c'), ('\u011e', '\u011e'), ('\u0120', '\u0120'),
        ('\u0122', '\u0122'), ('\u0124', '\u0124'), ('\u0126', '\u0126'), ('\u0128', '\u0128'),
        ('\u012a', '\u012a'), ('\u012c', '\u012c'), ('\u012e', '\u012e'), ('\u0130', '\u0130'),
        ('\u0132', '\u0132'), ('\u0134', '\u0134'), ('\u0136', '\u0136'), ('\u0139', '\u0139'),
        ('\u013b', '\u013b'), ('\u013d', '\u013d'), ('\u013f', '\u013f'), ('\u0141', '\u0141'),
        ('\u0143', '\u0143'), ('\u0145', '\u0145'), ('\u0147', '\u0147'), ('\u014a', '\u014a'),
        ('\u014c', '\u014c'), ('\u014e', '\u014e'), ('\u0150', '\u0150'), ('\u0152', '\u0152'),
        ('\u0154', '\u0154'), ('\u0156', '\u0156'), ('\u0158', '\u0158'), ('\u015a', '\u015a'),
        ('\u015c', '\u015c'), ('\u015e', '\u015e'), ('\u0160', '\u0160'), ('\u0162', '\u0162'),
        ('\u0164', '\u0164'), ('\u0166', '\u0166'), ('\u0168', '\u0168'), ('\u016a', '\u016a'),
        ('\u016c', '\u016c'), ('\u016e', '\u016e'), ('\u0170', '\u0170'), ('\u0172', '\u0172'),
        ('\u0174', '\u0174'), ('\u0176', '\u0176'), ('\u0178', '\u0179'), ('\u017b', '\u017b'),
        ('\u017d', '\u017d'), ('\u0181', '\u0182'), ('\u0184', '\u0184'), ('\u0186', '\u0187'),
        ('\u0189', '\u018b'), ('\u018e', '\u0191'), ('\u0193', '\u0194'), ('\u0196', '\u0198'),
        ('\u019c', '\u019d'), ('\u019f', '\u01a0'), ('\u01a2', '\u01a2'), ('\u01a4', '\u01a4'),
        ('\u01a6', '\u01a7'), ('\u01a9', '\u01a9'), ('\u01ac', '\u01ac'), ('\u01ae', '\u01af'),
        ('\u01b1', '\u01b3'), ('\u01b5', '\u01b5'), ('\u01b7', '\u01b8'), ('\u01bc', '\u01bc'),
        ('\u01c4', '\u01c4'), ('\u01c7', '\u01c7'), ('\u01ca', '\u01ca'), ('\u01cd', '\u01cd'),
        ('\u01cf', '\u01cf'), ('\u01d1', '\u01d1'), ('\u01d3', '\u01d3'), ('\u01d5', '\u01d5'),
        ('\u01d7', '\u01d7'), ('\u01d9', '\u01d9'), ('\u01db', '\u01db'), ('\u01de', '\u01de'),
        ('\u01e0', '\u01e0'), ('\u01e2', '\u01e2'), ('\u01e4', '\u01e4'), ('\u01e6', '\u01e6'),
        ('\u01e8', '\u01e8'), ('\u01ea', '\u01ea'), ('\u01ec', '\u01ec'), ('\u01ee', '\u01ee'),
        ('\u01f1', '\u01f1'), ('\u01f4', '\u01f4'), ('\u01f6', '\u01f8'), ('\u01fa', '\u01fa'),
        ('\u01fc', '\u01fc'), ('\u01fe', '\u01fe'), ('\u0200', '\u0200'), ('\u0202', '\u0202'),
        ('\u0204', '\u0204'), ('\u0206', '\u0206'), ('\u0208', '\u0208'), ('\u020a', '\u020a'),
        ('\u020c', '\u020c'), ('\u020e', '\u020e'), ('\u0210', '\u0210'), ('\u0212', '\u0212'),
        ('\u0214', '\u0214'), ('\u0216', '\u0216'), ('\u0218', '\u0218'), ('\u021a', '\u021a'),
        ('\u021c', '\u021c'), ('\u021e', '\u021e'), ('\u0220', '\u0220'), ('\u0222', '\u0222'),
        ('\u0224', '\u0224'), ('\u0226', '\u0226'), ('\u0228', '\u0228'), ('\u022a', '\u022a'),
        ('\u022c', '\u022c'), ('\u022e', '\u022e'), ('\u0230', '\u0230'), ('\u0232', '\u0232'),
        ('\u023a', '\u023b'), ('\u023d', '\u023e'), ('\u0241', '\u0241'), ('\u0243', '\u0246'),
        ('\u0248', '\u0248'), ('\u024a', '\u024a'), ('\u024c', '\u024c'), ('\u024e', '\u024e'),
        ('\u0370', '\u0370'), ('\u0372', '\u0372'), ('\u0376', '\u0376'), ('\u037f', '\u037f'),
        ('\u0386', '\u0386'), ('\u0388', '\u038a'), ('\u038c', '\u038c'), ('\u038e', '\u038f'),
        ('\u0391', '\u03a1'), ('\u03a3', '\u03ab'), ('\u03cf', '\u03cf'), ('\u03d2', '\u03d4'),
        ('\u03d8', '\u03d8'), ('\u03da', '\u03da'), ('\u03dc', '\u03dc'), ('\u03de', '\u03de'),
        ('\u03e0', '\u03e0'), ('\u03e2', '\u03e2'), ('\u03e4', '\u03e4'), ('\u03e6', '\u03e6'),
        ('\u03e8', '\u03e8'), ('\u03ea', '\u03ea'), ('\u03ec', '\u03ec'), ('\u03ee', '\u03ee'),
        ('\u03f4', '\u03f4'), ('\u03f7', '\u03f7'), ('\u03f9', '\u03fa'), ('\u03fd', '\u042f'),
        ('\u0460', '\u0460'), ('\u0462', '\u0462'), ('\u0464', '\u0464'), ('\u0466', '\u0466'),
        ('\u0468', '\u0468'), ('\u046a', '\u046a'), ('\u046c', '\u046c'), ('\u046e', '\u046e'),
        ('\u0470', '\u0470'), ('\u0472', '\u0472'), ('\u0474', '\u0474'), ('\u0476', '\u0476'),
        ('\u0478', '\u0478'), ('\u047a', '\u047a'), ('\u047c', '\u047c'), ('\u047e', '\u047e'),
        ('\u0480', '\u0480'), ('\u048a', '\u048a'), ('\u048c', '\u048c'), ('\u048e', '\u048e'),
        ('\u0490', '\u0490'), ('\u0492', '\u0492'), ('\u0494', '\u0494'), ('\u0496', '\u0496'),
        ('\u0498', '\u0498'), ('\u049a', '\u049a'), ('\u049c', '\u049c'), ('\u049e', '\u049e'),
        ('\u04a0', '\u04a0'), ('\u04a2', '\u04a2'), ('\u04a4', '\u04a4'), ('\u04a6', '\u04a6'),
        ('\u04a8', '\u04a8'), ('\u04aa', '\u04aa'), ('\u04ac', '\u04ac'), ('\u04ae', '\u04ae'),
        ('\u04b0', '\u04b0'), ('\u04b2', '\u04b2'), ('\u04b4', '\u04b4'), ('\u04b6', '\u04b6'),
        ('\u04b8', '\u04b8'), ('\u04ba', '\u04ba'), ('\u04bc', '\u04bc'), ('\u04be', '\u04be'),
        ('\u04c0', '\u04c1'), ('\u04c3', '\u04c3'), ('\u04c5', '\u04c5'), ('\u04c7', '\u04c7'),
        ('\u04c9', '\u04c9'), ('\u04cb', '\u04cb'), ('\u04cd', '\u04cd'), ('\u04d0', '\u04d0'),
        ('\u04d2', '\u04d2'), ('\u04d4', '\u04d4'), ('\u04d6', '\u04d6'), ('\u04d8', '\u04d8'),
        ('\u04da', '\u04da'), ('\u04dc', '\u04dc'), ('\u04de', '\u04de'), ('\u04e0', '\u04e0'),
        ('\u04e2', '\u04e2'), ('\u04e4', '\u04e4'), ('\u04e6', '\u04e6'), ('\u04e8', '\u04e8'),
        ('\u04ea', '\u04ea'), ('\u04ec', '\u04ec'), ('\u04ee', '\u04ee'), ('\u04f0', '\u04f0'),
        ('\u04f2', '\u04f2'), ('\u04f4', '\u04f4'), ('\u04f6', '\u04f6'), ('\u04f8', '\u04f8'),
        ('\u04fa', '\u04fa'), ('\u04fc', '\u04fc'), ('\u04fe', '\u04fe'), ('\u0500', '\u0500'),
        ('\u0502', '\u0502'), ('\u0504', '\u0504'), ('\u0506', '\u0506'), ('\u0508', '\u0508'),
        ('\u050a', '\u050a'), ('\u050c', '\u050c'), ('\u050e', '\u050e'), ('\u0510', '\u0510'),
        ('\u0512', '\u0512'), ('\u0514', '\u0514'), ('\u0516', '\u0516'), ('\u0518', '\u0518'),
        ('\u051a', '\u051a'), ('\u051c', '\u051c'), ('\u051e', '\u051e'), ('\u0520', '\u0520'),
        ('\u0522', '\u0522'), ('\u0524', '\u0524'), ('\u0526', '\u0526'), ('\u0528', '\u0528'),
        ('\u052a', '\u052a'), ('\u052c', '\u052c'), ('\u052e', '\u052e'), ('\u0531', '\u0556'),
        ('\u10a0', '\u10c5'), ('\u10c7', '\u10c7'), ('\u10cd', '\u10cd'), ('\u1e00', '\u1e00'),
        ('\u1e02', '\u1e02'), ('\u1e04', '\u1e04'), ('\u1e06', '\u1e06'), ('\u1e08', '\u1e08'),
        ('\u1e0a', '\u1e0a'), ('\u1e0c', '\u1e0c'), ('\u1e0e', '\u1e0e'), ('\u1e10', '\u1e10'),
        ('\u1e12', '\u1e12'), ('\u1e14', '\u1e14'), ('\u1e16', '\u1e16'), ('\u1e18', '\u1e18'),
        ('\u1e1a', '\u1e1a'), ('\u1e1c', '\u1e1c'), ('\u1e1e', '\u1e1e'), ('\u1e20', '\u1e20'),
        ('\u1e22', '\u1e22'), ('\u1e24', '\u1e24'), ('\u1e26', '\u1e26'), ('\u1e28', '\u1e28'),
        ('\u1e2a', '\u1e2a'), ('\u1e2c', '\u1e2c'), ('\u1e2e', '\u1e2e'), ('\u1e30', '\u1e30'),
        ('\u1e32', '\u1e32'), ('\u1e34', '\u1e34'), ('\u1e36', '\u1e36'), ('\u1e38', '\u1e38'),
        ('\u1e3a', '\u1e3a'), ('\u1e3c', '\u1e3c'), ('\u1e3e', '\u1e3e'), ('\u1e40', '\u1e40'),
        ('\u1e42', '\u1e42'), ('\u1e44', '\u1e44'), ('\u1e46', '\u1e46'), ('\u1e48', '\u1e48'),
        ('\u1e4a', '\u1e4a'), ('\u1e4c', '\u1e4c'), ('\u1e4e', '\u1e4e'), ('\u1e50', '\u1e50'),
        ('\u1e52', '\u1e52'), ('\u1e54', '\u1e54'), ('\u1e56', '\u1e56'), ('\u1e58', '\u1e58'),
        ('\u1e5a', '\u1e5a'), ('\u1e5c', '\u1e5c'), ('\u1e5e', '\u1e5e'), ('\u1e60', '\u1e60'),
        ('\u1e62', '\u1e62'), ('\u1e64', '\u1e64'), ('\u1e66', '\u1e66'), ('\u1e68', '\u1e68'),
        ('\u1e6a', '\u1e6a'), ('\u1e6c', '\u1e6c'), ('\u1e6e', '\u1e6e'), ('\u1e70', '\u1e70'),
        ('\u1e72', '\u1e72'), ('\u1e74', '\u1e74'), ('\u1e76', '\u1e76'), ('\u1e78', '\u1e78'),
        ('\u1e7a', '\u1e7a'), ('\u1e7c', '\u1e7c'), ('\u1e7e', '\u1e7e'), ('\u1e80', '\u1e80'),
        ('\u1e82', '\u1e82'), ('\u1e84', '\u1e84'), ('\u1e86', '\u1e86'), ('\u1e88', '\u1e88'),
        ('\u1e8a', '\u1e8a'), ('\u1e8c', '\u1e8c'), ('\u1e8e', '\u1e8e'), ('\u1e90', '\u1e90'),
        ('\u1e92', '\u1e92'), ('\u1e94', '\u1e94'), ('\u1e9e', '\u1e9e'), ('\u1ea0', '\u1ea0'),
        ('\u1ea2', '\u1ea2'), ('\u1ea4', '\u1ea4'), ('\u1ea6', '\u1ea6'), ('\u1ea8', '\u1ea8'),
        ('\u1eaa', '\u1eaa'), ('\u1eac', '\u1eac'), ('\u1eae', '\u1eae'), ('\u1eb0', '\u1eb0'),
        ('\u1eb2', '\u1eb2'), ('\u1eb4', '\u1eb4'), ('\u1eb6', '\u1eb6'), ('\u1eb8', '\u1eb8'),
        ('\u1eba', '\u1eba'), ('\u1ebc', '\u1ebc'), ('\u1ebe', '\u1ebe'), ('\u1ec0', '\u1ec0'),
        ('\u1ec2', '\u1ec2'), ('\u1ec4', '\u1ec4'), ('\u1ec6', '\u1ec6'), ('\u1ec8', '\u1ec8'),
        ('\u1eca', '\u1eca'), ('\u1ecc', '\u1ecc'), ('\u1ece', '\u1ece'), ('\u1ed0', '\u1ed0'),
        ('\u1ed2', '\u1ed2'), ('\u1ed4', '\u1ed4'), ('\u1ed6', '\u1ed6'), ('\u1ed8', '\u1ed8'),
        ('\u1eda', '\u1eda'), ('\u1edc', '\u1edc'), ('\u1ede', '\u1ede'), ('\u1ee0', '\u1ee0'),
        ('\u1ee2', '\u1ee2'), ('\u1ee4', '\u1ee4'), ('\u1ee6', '\u1ee6'), ('\u1ee8', '\u1ee8'),
        ('\u1eea', '\u1eea'), ('\u1eec', '\u1eec'), ('\u1eee', '\u1eee'), ('\u1ef0', '\u1ef0'),
        ('\u1ef2', '\u1ef2'), ('\u1ef4', '\u1ef4'), ('\u1ef6', '\u1ef6'), ('\u1ef8', '\u1ef8'),
        ('\u1efa', '\u1efa'), ('\u1efc', '\u1efc'), ('\u1efe', '\u1efe'), ('\u1f08', '\u1f0f'),
        ('\u1f18', '\u1f1d'), ('\u1f28', '\u1f2f'), ('\u1f38', '\u1f3f'), ('\u1f48', '\u1f4d'),
        ('\u1f59', '\u1f59'), ('\u1f5b', '\u1f5b'), ('\u1f5d', '\u1f5d'), ('\u1f5f', '\u1f5f'),
        ('\u1f68', '\u1f6f'), ('\u1fb8', '\u1fbb'), ('\u1fc8', '\u1fcb'), ('\u1fd8', '\u1fdb'),
        ('\u1fe8', '\u1fec'), ('\u1ff8', '\u1ffb'), ('\u2102', '\u2102'), ('\u2107', '\u2107'),
        ('\u210b', '\u210d'), ('\u2110', '\u2112'), ('\u2115', '\u2115'), ('\u2119', '\u211d'),
        ('\u2124', '\u2124'), ('\u2126', '\u2126'), ('\u2128', '\u2128'), ('\u212a', '\u212d'),
        ('\u2130', '\u2133'), ('\u213e', '\u213f'), ('\u2145', '\u2145'), ('\u2183', '\u2183'),
        ('\u2c00', '\u2c2e'), ('\u2c60', '\u2c60'), ('\u2c62', '\u2c64'), ('\u2c67', '\u2c67'),
        ('\u2c69', '\u2c69'), ('\u2c6b', '\u2c6b'), ('\u2c6d', '\u2c70'), ('\u2c72', '\u2c72'),
        ('\u2c75', '\u2c75'), ('\u2c7e', '\u2c80'), ('\u2c82', '\u2c82'), ('\u2c84', '\u2c84'),
        ('\u2c86', '\u2c86'), ('\u2c88', '\u2c88'), ('\u2c8a', '\u2c8a'), ('\u2c8c', '\u2c8c'),
        ('\u2c8e', '\u2c8e'), ('\u2c90', '\u2c90'), ('\u2c92', '\u2c92'), ('\u2c94', '\u2c94'),
        ('\u2c96', '\u2c96'), ('\u2c98', '\u2c98'), ('\u2c9a', '\u2c9a'), ('\u2c9c', '\u2c9c'),
        ('\u2c9e', '\u2c9e'), ('\u2ca0', '\u2ca0'), ('\u2ca2', '\u2ca2'), ('\u2ca4', '\u2ca4'),
        ('\u2ca6', '\u2ca6'), ('\u2ca8', '\u2ca8'), ('\u2caa', '\u2caa'), ('\u2cac', '\u2cac'),
        ('\u2cae', '\u2cae'), ('\u2cb0', '\u2cb0'), ('\u2cb2', '\u2cb2'), ('\u2cb4', '\u2cb4'),
        ('\u2cb6', '\u2cb6'), ('\u2cb8', '\u2cb8'), ('\u2cba', '\u2cba'), ('\u2cbc', '\u2cbc'),
        ('\u2cbe', '\u2cbe'), ('\u2cc0', '\u2cc0'), ('\u2cc2', '\u2cc2'), ('\u2cc4', '\u2cc4'),
        ('\u2cc6', '\u2cc6'), ('\u2cc8', '\u2cc8'), ('\u2cca', '\u2cca'), ('\u2ccc', '\u2ccc'),
        ('\u2cce', '\u2cce'), ('\u2cd0', '\u2cd0'), ('\u2cd2', '\u2cd2'), ('\u2cd4', '\u2cd4'),
        ('\u2cd6', '\u2cd6'), ('\u2cd8', '\u2cd8'), ('\u2cda', '\u2cda'), ('\u2cdc', '\u2cdc'),
        ('\u2cde', '\u2cde'), ('\u2ce0', '\u2ce0'), ('\u2ce2', '\u2ce2'), ('\u2ceb', '\u2ceb'),
        ('\u2ced', '\u2ced'), ('\u2cf2', '\u2cf2'), ('\ua640', '\ua640'), ('\ua642', '\ua642'),
        ('\ua644', '\ua644'), ('\ua646', '\ua646'), ('\ua648', '\ua648'), ('\ua64a', '\ua64a'),
        ('\ua64c', '\ua64c'), ('\ua64e', '\ua64e'), ('\ua650', '\ua650'), ('\ua652', '\ua652'),
        ('\ua654', '\ua654'), ('\ua656', '\ua656'), ('\ua658', '\ua658'), ('\ua65a', '\ua65a'),
        ('\ua65c', '\ua65c'), ('\ua65e', '\ua65e'), ('\ua660', '\ua660'), ('\ua662', '\ua662'),
        ('\ua664', '\ua664'), ('\ua666', '\ua666'), ('\ua668', '\ua668'), ('\ua66a', '\ua66a'),
        ('\ua66c', '\ua66c'), ('\ua680', '\ua680'), ('\ua682', '\ua682'), ('\ua684', '\ua684'),
        ('\ua686', '\ua686'), ('\ua688', '\ua688'), ('\ua68a', '\ua68a'), ('\ua68c', '\ua68c'),
        ('\ua68e', '\ua68e'), ('\ua690', '\ua690'), ('\ua692', '\ua692'), ('\ua694', '\ua694'),
        ('\ua696', '\ua696'), ('\ua698', '\ua698'), ('\ua69a', '\ua69a'), ('\ua722', '\ua722'),
        ('\ua724', '\ua724'), ('\ua726', '\ua726'), ('\ua728', '\ua728'), ('\ua72a', '\ua72a'),
        ('\ua72c', '\ua72c'), ('\ua72e', '\ua72e'), ('\ua732', '\ua732'), ('\ua734', '\ua734'),
        ('\ua736', '\ua736'), ('\ua738', '\ua738'), ('\ua73a', '\ua73a'), ('\ua73c', '\ua73c'),
        ('\ua73e', '\ua73e'), ('\ua740', '\ua740'), ('\ua742', '\ua742'), ('\ua744', '\ua744'),
        ('\ua746', '\ua746'), ('\ua748', '\ua748'), ('\ua74a', '\ua74a'), ('\ua74c', '\ua74c'),
        ('\ua74e', '\ua74e'), ('\ua750', '\ua750'), ('\ua752', '\ua752'), ('\ua754', '\ua754'),
        ('\ua756', '\ua756'), ('\ua758', '\ua758'), ('\ua75a', '\ua75a'), ('\ua75c', '\ua75c'),
        ('\ua75e', '\ua75e'), ('\ua760', '\ua760'), ('\ua762', '\ua762'), ('\ua764', '\ua764'),
        ('\ua766', '\ua766'), ('\ua768', '\ua768'), ('\ua76a', '\ua76a'), ('\ua76c', '\ua76c'),
        ('\ua76e', '\ua76e'), ('\ua779', '\ua779'), ('\ua77b', '\ua77b'), ('\ua77d', '\ua77e'),
        ('\ua780', '\ua780'), ('\ua782', '\ua782'), ('\ua784', '\ua784'), ('\ua786', '\ua786'),
        ('\ua78b', '\ua78b'), ('\ua78d', '\ua78d'), ('\ua790', '\ua790'), ('\ua792', '\ua792'),
        ('\ua796', '\ua796'), ('\ua798', '\ua798'), ('\ua79a', '\ua79a'), ('\ua79c', '\ua79c'),
        ('\ua79e', '\ua79e'), ('\ua7a0', '\ua7a0'), ('\ua7a2', '\ua7a2'), ('\ua7a4', '\ua7a4'),
        ('\ua7a6', '\ua7a6'), ('\ua7a8', '\ua7a8'), ('\ua7aa', '\ua7ad'), ('\ua7b0', '\ua7b1'),
        ('\uff21', '\uff3a'), ('\U00010400', '\U00010427'), ('\U000118a0', '\U000118bf'),
        ('\U0001d400', '\U0001d419'), ('\U0001d434', '\U0001d44d'), ('\U0001d468', '\U0001d481'),
        ('\U0001d49c', '\U0001d49c'), ('\U0001d49e', '\U0001d49f'), ('\U0001d4a2', '\U0001d4a2'),
        ('\U0001d4a5', '\U0001d4a6'), ('\U0001d4a9', '\U0001d4ac'), ('\U0001d4ae', '\U0001d4b5'),
        ('\U0001d4d0', '\U0001d4e9'), ('\U0001d504', '\U0001d505'), ('\U0001d507', '\U0001d50a'),
        ('\U0001d50d', '\U0001d514'), ('\U0001d516', '\U0001d51c'), ('\U0001d538', '\U0001d539'),
        ('\U0001d53b', '\U0001d53e'), ('\U0001d540', '\U0001d544'), ('\U0001d546', '\U0001d546'),
        ('\U0001d54a', '\U0001d550'), ('\U0001d56c', '\U0001d585'), ('\U0001d5a0', '\U0001d5b9'),
        ('\U0001d5d4', '\U0001d5ed'), ('\U0001d608', '\U0001d621'), ('\U0001d63c', '\U0001d655'),
        ('\U0001d670', '\U0001d689'), ('\U0001d6a8', '\U0001d6c0'), ('\U0001d6e2', '\U0001d6fa'),
        ('\U0001d71c', '\U0001d734'), ('\U0001d756', '\U0001d76e'), ('\U0001d790', '\U0001d7a8'),
        ('\U0001d7ca', '\U0001d7ca')
    ];

    pub static M_table: &'static [(char, char)] = &[
        ('\u0300', '\u036f'), ('\u0483', '\u0489'), ('\u0591', '\u05bd'), ('\u05bf', '\u05bf'),
        ('\u05c1', '\u05c2'), ('\u05c4', '\u05c5'), ('\u05c7', '\u05c7'), ('\u0610', '\u061a'),
        ('\u064b', '\u065f'), ('\u0670', '\u0670'), ('\u06d6', '\u06dc'), ('\u06df', '\u06e4'),
        ('\u06e7', '\u06e8'), ('\u06ea', '\u06ed'), ('\u0711', '\u0711'), ('\u0730', '\u074a'),
        ('\u07a6', '\u07b0'), ('\u07eb', '\u07f3'), ('\u0816', '\u0819'), ('\u081b', '\u0823'),
        ('\u0825', '\u0827'), ('\u0829', '\u082d'), ('\u0859', '\u085b'), ('\u08e4', '\u0903'),
        ('\u093a', '\u093c'), ('\u093e', '\u094f'), ('\u0951', '\u0957'), ('\u0962', '\u0963'),
        ('\u0981', '\u0983'), ('\u09bc', '\u09bc'), ('\u09be', '\u09c4'), ('\u09c7', '\u09c8'),
        ('\u09cb', '\u09cd'), ('\u09d7', '\u09d7'), ('\u09e2', '\u09e3'), ('\u0a01', '\u0a03'),
        ('\u0a3c', '\u0a3c'), ('\u0a3e', '\u0a42'), ('\u0a47', '\u0a48'), ('\u0a4b', '\u0a4d'),
        ('\u0a51', '\u0a51'), ('\u0a70', '\u0a71'), ('\u0a75', '\u0a75'), ('\u0a81', '\u0a83'),
        ('\u0abc', '\u0abc'), ('\u0abe', '\u0ac5'), ('\u0ac7', '\u0ac9'), ('\u0acb', '\u0acd'),
        ('\u0ae2', '\u0ae3'), ('\u0b01', '\u0b03'), ('\u0b3c', '\u0b3c'), ('\u0b3e', '\u0b44'),
        ('\u0b47', '\u0b48'), ('\u0b4b', '\u0b4d'), ('\u0b56', '\u0b57'), ('\u0b62', '\u0b63'),
        ('\u0b82', '\u0b82'), ('\u0bbe', '\u0bc2'), ('\u0bc6', '\u0bc8'), ('\u0bca', '\u0bcd'),
        ('\u0bd7', '\u0bd7'), ('\u0c00', '\u0c03'), ('\u0c3e', '\u0c44'), ('\u0c46', '\u0c48'),
        ('\u0c4a', '\u0c4d'), ('\u0c55', '\u0c56'), ('\u0c62', '\u0c63'), ('\u0c81', '\u0c83'),
        ('\u0cbc', '\u0cbc'), ('\u0cbe', '\u0cc4'), ('\u0cc6', '\u0cc8'), ('\u0cca', '\u0ccd'),
        ('\u0cd5', '\u0cd6'), ('\u0ce2', '\u0ce3'), ('\u0d01', '\u0d03'), ('\u0d3e', '\u0d44'),
        ('\u0d46', '\u0d48'), ('\u0d4a', '\u0d4d'), ('\u0d57', '\u0d57'), ('\u0d62', '\u0d63'),
        ('\u0d82', '\u0d83'), ('\u0dca', '\u0dca'), ('\u0dcf', '\u0dd4'), ('\u0dd6', '\u0dd6'),
        ('\u0dd8', '\u0ddf'), ('\u0df2', '\u0df3'), ('\u0e31', '\u0e31'), ('\u0e34', '\u0e3a'),
        ('\u0e47', '\u0e4e'), ('\u0eb1', '\u0eb1'), ('\u0eb4', '\u0eb9'), ('\u0ebb', '\u0ebc'),
        ('\u0ec8', '\u0ecd'), ('\u0f18', '\u0f19'), ('\u0f35', '\u0f35'), ('\u0f37', '\u0f37'),
        ('\u0f39', '\u0f39'), ('\u0f3e', '\u0f3f'), ('\u0f71', '\u0f84'), ('\u0f86', '\u0f87'),
        ('\u0f8d', '\u0f97'), ('\u0f99', '\u0fbc'), ('\u0fc6', '\u0fc6'), ('\u102b', '\u103e'),
        ('\u1056', '\u1059'), ('\u105e', '\u1060'), ('\u1062', '\u1064'), ('\u1067', '\u106d'),
        ('\u1071', '\u1074'), ('\u1082', '\u108d'), ('\u108f', '\u108f'), ('\u109a', '\u109d'),
        ('\u135d', '\u135f'), ('\u1712', '\u1714'), ('\u1732', '\u1734'), ('\u1752', '\u1753'),
        ('\u1772', '\u1773'), ('\u17b4', '\u17d3'), ('\u17dd', '\u17dd'), ('\u180b', '\u180d'),
        ('\u18a9', '\u18a9'), ('\u1920', '\u192b'), ('\u1930', '\u193b'), ('\u19b0', '\u19c0'),
        ('\u19c8', '\u19c9'), ('\u1a17', '\u1a1b'), ('\u1a55', '\u1a5e'), ('\u1a60', '\u1a7c'),
        ('\u1a7f', '\u1a7f'), ('\u1ab0', '\u1abe'), ('\u1b00', '\u1b04'), ('\u1b34', '\u1b44'),
        ('\u1b6b', '\u1b73'), ('\u1b80', '\u1b82'), ('\u1ba1', '\u1bad'), ('\u1be6', '\u1bf3'),
        ('\u1c24', '\u1c37'), ('\u1cd0', '\u1cd2'), ('\u1cd4', '\u1ce8'), ('\u1ced', '\u1ced'),
        ('\u1cf2', '\u1cf4'), ('\u1cf8', '\u1cf9'), ('\u1dc0', '\u1df5'), ('\u1dfc', '\u1dff'),
        ('\u20d0', '\u20f0'), ('\u2cef', '\u2cf1'), ('\u2d7f', '\u2d7f'), ('\u2de0', '\u2dff'),
        ('\u302a', '\u302f'), ('\u3099', '\u309a'), ('\ua66f', '\ua672'), ('\ua674', '\ua67d'),
        ('\ua69f', '\ua69f'), ('\ua6f0', '\ua6f1'), ('\ua802', '\ua802'), ('\ua806', '\ua806'),
        ('\ua80b', '\ua80b'), ('\ua823', '\ua827'), ('\ua880', '\ua881'), ('\ua8b4', '\ua8c4'),
        ('\ua8e0', '\ua8f1'), ('\ua926', '\ua92d'), ('\ua947', '\ua953'), ('\ua980', '\ua983'),
        ('\ua9b3', '\ua9c0'), ('\ua9e5', '\ua9e5'), ('\uaa29', '\uaa36'), ('\uaa43', '\uaa43'),
        ('\uaa4c', '\uaa4d'), ('\uaa7b', '\uaa7d'), ('\uaab0', '\uaab0'), ('\uaab2', '\uaab4'),
        ('\uaab7', '\uaab8'), ('\uaabe', '\uaabf'), ('\uaac1', '\uaac1'), ('\uaaeb', '\uaaef'),
        ('\uaaf5', '\uaaf6'), ('\uabe3', '\uabea'), ('\uabec', '\uabed'), ('\ufb1e', '\ufb1e'),
        ('\ufe00', '\ufe0f'), ('\ufe20', '\ufe2d'), ('\U000101fd', '\U000101fd'), ('\U000102e0',
        '\U000102e0'), ('\U00010376', '\U0001037a'), ('\U00010a01', '\U00010a03'), ('\U00010a05',
        '\U00010a06'), ('\U00010a0c', '\U00010a0f'), ('\U00010a38', '\U00010a3a'), ('\U00010a3f',
        '\U00010a3f'), ('\U00010ae5', '\U00010ae6'), ('\U00011000', '\U00011002'), ('\U00011038',
        '\U00011046'), ('\U0001107f', '\U00011082'), ('\U000110b0', '\U000110ba'), ('\U00011100',
        '\U00011102'), ('\U00011127', '\U00011134'), ('\U00011173', '\U00011173'), ('\U00011180',
        '\U00011182'), ('\U000111b3', '\U000111c0'), ('\U0001122c', '\U00011237'), ('\U000112df',
        '\U000112ea'), ('\U00011301', '\U00011303'), ('\U0001133c', '\U0001133c'), ('\U0001133e',
        '\U00011344'), ('\U00011347', '\U00011348'), ('\U0001134b', '\U0001134d'), ('\U00011357',
        '\U00011357'), ('\U00011362', '\U00011363'), ('\U00011366', '\U0001136c'), ('\U00011370',
        '\U00011374'), ('\U000114b0', '\U000114c3'), ('\U000115af', '\U000115b5'), ('\U000115b8',
        '\U000115c0'), ('\U00011630', '\U00011640'), ('\U000116ab', '\U000116b7'), ('\U00016af0',
        '\U00016af4'), ('\U00016b30', '\U00016b36'), ('\U00016f51', '\U00016f7e'), ('\U00016f8f',
        '\U00016f92'), ('\U0001bc9d', '\U0001bc9e'), ('\U0001d165', '\U0001d169'), ('\U0001d16d',
        '\U0001d172'), ('\U0001d17b', '\U0001d182'), ('\U0001d185', '\U0001d18b'), ('\U0001d1aa',
        '\U0001d1ad'), ('\U0001d242', '\U0001d244'), ('\U0001e8d0', '\U0001e8d6'), ('\U000e0100',
        '\U000e01ef')
    ];

    pub static Mc_table: &'static [(char, char)] = &[
        ('\u0903', '\u0903'), ('\u093b', '\u093b'), ('\u093e', '\u0940'), ('\u0949', '\u094c'),
        ('\u094e', '\u094f'), ('\u0982', '\u0983'), ('\u09be', '\u09c0'), ('\u09c7', '\u09c8'),
        ('\u09cb', '\u09cc'), ('\u09d7', '\u09d7'), ('\u0a03', '\u0a03'), ('\u0a3e', '\u0a40'),
        ('\u0a83', '\u0a83'), ('\u0abe', '\u0ac0'), ('\u0ac9', '\u0ac9'), ('\u0acb', '\u0acc'),
        ('\u0b02', '\u0b03'), ('\u0b3e', '\u0b3e'), ('\u0b40', '\u0b40'), ('\u0b47', '\u0b48'),
        ('\u0b4b', '\u0b4c'), ('\u0b57', '\u0b57'), ('\u0bbe', '\u0bbf'), ('\u0bc1', '\u0bc2'),
        ('\u0bc6', '\u0bc8'), ('\u0bca', '\u0bcc'), ('\u0bd7', '\u0bd7'), ('\u0c01', '\u0c03'),
        ('\u0c41', '\u0c44'), ('\u0c82', '\u0c83'), ('\u0cbe', '\u0cbe'), ('\u0cc0', '\u0cc4'),
        ('\u0cc7', '\u0cc8'), ('\u0cca', '\u0ccb'), ('\u0cd5', '\u0cd6'), ('\u0d02', '\u0d03'),
        ('\u0d3e', '\u0d40'), ('\u0d46', '\u0d48'), ('\u0d4a', '\u0d4c'), ('\u0d57', '\u0d57'),
        ('\u0d82', '\u0d83'), ('\u0dcf', '\u0dd1'), ('\u0dd8', '\u0ddf'), ('\u0df2', '\u0df3'),
        ('\u0f3e', '\u0f3f'), ('\u0f7f', '\u0f7f'), ('\u102b', '\u102c'), ('\u1031', '\u1031'),
        ('\u1038', '\u1038'), ('\u103b', '\u103c'), ('\u1056', '\u1057'), ('\u1062', '\u1064'),
        ('\u1067', '\u106d'), ('\u1083', '\u1084'), ('\u1087', '\u108c'), ('\u108f', '\u108f'),
        ('\u109a', '\u109c'), ('\u17b6', '\u17b6'), ('\u17be', '\u17c5'), ('\u17c7', '\u17c8'),
        ('\u1923', '\u1926'), ('\u1929', '\u192b'), ('\u1930', '\u1931'), ('\u1933', '\u1938'),
        ('\u19b0', '\u19c0'), ('\u19c8', '\u19c9'), ('\u1a19', '\u1a1a'), ('\u1a55', '\u1a55'),
        ('\u1a57', '\u1a57'), ('\u1a61', '\u1a61'), ('\u1a63', '\u1a64'), ('\u1a6d', '\u1a72'),
        ('\u1b04', '\u1b04'), ('\u1b35', '\u1b35'), ('\u1b3b', '\u1b3b'), ('\u1b3d', '\u1b41'),
        ('\u1b43', '\u1b44'), ('\u1b82', '\u1b82'), ('\u1ba1', '\u1ba1'), ('\u1ba6', '\u1ba7'),
        ('\u1baa', '\u1baa'), ('\u1be7', '\u1be7'), ('\u1bea', '\u1bec'), ('\u1bee', '\u1bee'),
        ('\u1bf2', '\u1bf3'), ('\u1c24', '\u1c2b'), ('\u1c34', '\u1c35'), ('\u1ce1', '\u1ce1'),
        ('\u1cf2', '\u1cf3'), ('\u302e', '\u302f'), ('\ua823', '\ua824'), ('\ua827', '\ua827'),
        ('\ua880', '\ua881'), ('\ua8b4', '\ua8c3'), ('\ua952', '\ua953'), ('\ua983', '\ua983'),
        ('\ua9b4', '\ua9b5'), ('\ua9ba', '\ua9bb'), ('\ua9bd', '\ua9c0'), ('\uaa2f', '\uaa30'),
        ('\uaa33', '\uaa34'), ('\uaa4d', '\uaa4d'), ('\uaa7b', '\uaa7b'), ('\uaa7d', '\uaa7d'),
        ('\uaaeb', '\uaaeb'), ('\uaaee', '\uaaef'), ('\uaaf5', '\uaaf5'), ('\uabe3', '\uabe4'),
        ('\uabe6', '\uabe7'), ('\uabe9', '\uabea'), ('\uabec', '\uabec'), ('\U00011000',
        '\U00011000'), ('\U00011002', '\U00011002'), ('\U00011082', '\U00011082'), ('\U000110b0',
        '\U000110b2'), ('\U000110b7', '\U000110b8'), ('\U0001112c', '\U0001112c'), ('\U00011182',
        '\U00011182'), ('\U000111b3', '\U000111b5'), ('\U000111bf', '\U000111c0'), ('\U0001122c',
        '\U0001122e'), ('\U00011232', '\U00011233'), ('\U00011235', '\U00011235'), ('\U000112e0',
        '\U000112e2'), ('\U00011302', '\U00011303'), ('\U0001133e', '\U0001133f'), ('\U00011341',
        '\U00011344'), ('\U00011347', '\U00011348'), ('\U0001134b', '\U0001134d'), ('\U00011357',
        '\U00011357'), ('\U00011362', '\U00011363'), ('\U000114b0', '\U000114b2'), ('\U000114b9',
        '\U000114b9'), ('\U000114bb', '\U000114be'), ('\U000114c1', '\U000114c1'), ('\U000115af',
        '\U000115b1'), ('\U000115b8', '\U000115bb'), ('\U000115be', '\U000115be'), ('\U00011630',
        '\U00011632'), ('\U0001163b', '\U0001163c'), ('\U0001163e', '\U0001163e'), ('\U000116ac',
        '\U000116ac'), ('\U000116ae', '\U000116af'), ('\U000116b6', '\U000116b6'), ('\U00016f51',
        '\U00016f7e'), ('\U0001d165', '\U0001d166'), ('\U0001d16d', '\U0001d172')
    ];

    pub static Me_table: &'static [(char, char)] = &[
        ('\u0488', '\u0489'), ('\u1abe', '\u1abe'), ('\u20dd', '\u20e0'), ('\u20e2', '\u20e4'),
        ('\ua670', '\ua672')
    ];

    pub static Mn_table: &'static [(char, char)] = &[
        ('\u0300', '\u036f'), ('\u0483', '\u0487'), ('\u0591', '\u05bd'), ('\u05bf', '\u05bf'),
        ('\u05c1', '\u05c2'), ('\u05c4', '\u05c5'), ('\u05c7', '\u05c7'), ('\u0610', '\u061a'),
        ('\u064b', '\u065f'), ('\u0670', '\u0670'), ('\u06d6', '\u06dc'), ('\u06df', '\u06e4'),
        ('\u06e7', '\u06e8'), ('\u06ea', '\u06ed'), ('\u0711', '\u0711'), ('\u0730', '\u074a'),
        ('\u07a6', '\u07b0'), ('\u07eb', '\u07f3'), ('\u0816', '\u0819'), ('\u081b', '\u0823'),
        ('\u0825', '\u0827'), ('\u0829', '\u082d'), ('\u0859', '\u085b'), ('\u08e4', '\u0902'),
        ('\u093a', '\u093a'), ('\u093c', '\u093c'), ('\u0941', '\u0948'), ('\u094d', '\u094d'),
        ('\u0951', '\u0957'), ('\u0962', '\u0963'), ('\u0981', '\u0981'), ('\u09bc', '\u09bc'),
        ('\u09c1', '\u09c4'), ('\u09cd', '\u09cd'), ('\u09e2', '\u09e3'), ('\u0a01', '\u0a02'),
        ('\u0a3c', '\u0a3c'), ('\u0a41', '\u0a42'), ('\u0a47', '\u0a48'), ('\u0a4b', '\u0a4d'),
        ('\u0a51', '\u0a51'), ('\u0a70', '\u0a71'), ('\u0a75', '\u0a75'), ('\u0a81', '\u0a82'),
        ('\u0abc', '\u0abc'), ('\u0ac1', '\u0ac5'), ('\u0ac7', '\u0ac8'), ('\u0acd', '\u0acd'),
        ('\u0ae2', '\u0ae3'), ('\u0b01', '\u0b01'), ('\u0b3c', '\u0b3c'), ('\u0b3f', '\u0b3f'),
        ('\u0b41', '\u0b44'), ('\u0b4d', '\u0b4d'), ('\u0b56', '\u0b56'), ('\u0b62', '\u0b63'),
        ('\u0b82', '\u0b82'), ('\u0bc0', '\u0bc0'), ('\u0bcd', '\u0bcd'), ('\u0c00', '\u0c00'),
        ('\u0c3e', '\u0c40'), ('\u0c46', '\u0c48'), ('\u0c4a', '\u0c4d'), ('\u0c55', '\u0c56'),
        ('\u0c62', '\u0c63'), ('\u0c81', '\u0c81'), ('\u0cbc', '\u0cbc'), ('\u0cbf', '\u0cbf'),
        ('\u0cc6', '\u0cc6'), ('\u0ccc', '\u0ccd'), ('\u0ce2', '\u0ce3'), ('\u0d01', '\u0d01'),
        ('\u0d41', '\u0d44'), ('\u0d4d', '\u0d4d'), ('\u0d62', '\u0d63'), ('\u0dca', '\u0dca'),
        ('\u0dd2', '\u0dd4'), ('\u0dd6', '\u0dd6'), ('\u0e31', '\u0e31'), ('\u0e34', '\u0e3a'),
        ('\u0e47', '\u0e4e'), ('\u0eb1', '\u0eb1'), ('\u0eb4', '\u0eb9'), ('\u0ebb', '\u0ebc'),
        ('\u0ec8', '\u0ecd'), ('\u0f18', '\u0f19'), ('\u0f35', '\u0f35'), ('\u0f37', '\u0f37'),
        ('\u0f39', '\u0f39'), ('\u0f71', '\u0f7e'), ('\u0f80', '\u0f84'), ('\u0f86', '\u0f87'),
        ('\u0f8d', '\u0f97'), ('\u0f99', '\u0fbc'), ('\u0fc6', '\u0fc6'), ('\u102d', '\u1030'),
        ('\u1032', '\u1037'), ('\u1039', '\u103a'), ('\u103d', '\u103e'), ('\u1058', '\u1059'),
        ('\u105e', '\u1060'), ('\u1071', '\u1074'), ('\u1082', '\u1082'), ('\u1085', '\u1086'),
        ('\u108d', '\u108d'), ('\u109d', '\u109d'), ('\u135d', '\u135f'), ('\u1712', '\u1714'),
        ('\u1732', '\u1734'), ('\u1752', '\u1753'), ('\u1772', '\u1773'), ('\u17b4', '\u17b5'),
        ('\u17b7', '\u17bd'), ('\u17c6', '\u17c6'), ('\u17c9', '\u17d3'), ('\u17dd', '\u17dd'),
        ('\u180b', '\u180d'), ('\u18a9', '\u18a9'), ('\u1920', '\u1922'), ('\u1927', '\u1928'),
        ('\u1932', '\u1932'), ('\u1939', '\u193b'), ('\u1a17', '\u1a18'), ('\u1a1b', '\u1a1b'),
        ('\u1a56', '\u1a56'), ('\u1a58', '\u1a5e'), ('\u1a60', '\u1a60'), ('\u1a62', '\u1a62'),
        ('\u1a65', '\u1a6c'), ('\u1a73', '\u1a7c'), ('\u1a7f', '\u1a7f'), ('\u1ab0', '\u1abd'),
        ('\u1b00', '\u1b03'), ('\u1b34', '\u1b34'), ('\u1b36', '\u1b3a'), ('\u1b3c', '\u1b3c'),
        ('\u1b42', '\u1b42'), ('\u1b6b', '\u1b73'), ('\u1b80', '\u1b81'), ('\u1ba2', '\u1ba5'),
        ('\u1ba8', '\u1ba9'), ('\u1bab', '\u1bad'), ('\u1be6', '\u1be6'), ('\u1be8', '\u1be9'),
        ('\u1bed', '\u1bed'), ('\u1bef', '\u1bf1'), ('\u1c2c', '\u1c33'), ('\u1c36', '\u1c37'),
        ('\u1cd0', '\u1cd2'), ('\u1cd4', '\u1ce0'), ('\u1ce2', '\u1ce8'), ('\u1ced', '\u1ced'),
        ('\u1cf4', '\u1cf4'), ('\u1cf8', '\u1cf9'), ('\u1dc0', '\u1df5'), ('\u1dfc', '\u1dff'),
        ('\u20d0', '\u20dc'), ('\u20e1', '\u20e1'), ('\u20e5', '\u20f0'), ('\u2cef', '\u2cf1'),
        ('\u2d7f', '\u2d7f'), ('\u2de0', '\u2dff'), ('\u302a', '\u302d'), ('\u3099', '\u309a'),
        ('\ua66f', '\ua66f'), ('\ua674', '\ua67d'), ('\ua69f', '\ua69f'), ('\ua6f0', '\ua6f1'),
        ('\ua802', '\ua802'), ('\ua806', '\ua806'), ('\ua80b', '\ua80b'), ('\ua825', '\ua826'),
        ('\ua8c4', '\ua8c4'), ('\ua8e0', '\ua8f1'), ('\ua926', '\ua92d'), ('\ua947', '\ua951'),
        ('\ua980', '\ua982'), ('\ua9b3', '\ua9b3'), ('\ua9b6', '\ua9b9'), ('\ua9bc', '\ua9bc'),
        ('\ua9e5', '\ua9e5'), ('\uaa29', '\uaa2e'), ('\uaa31', '\uaa32'), ('\uaa35', '\uaa36'),
        ('\uaa43', '\uaa43'), ('\uaa4c', '\uaa4c'), ('\uaa7c', '\uaa7c'), ('\uaab0', '\uaab0'),
        ('\uaab2', '\uaab4'), ('\uaab7', '\uaab8'), ('\uaabe', '\uaabf'), ('\uaac1', '\uaac1'),
        ('\uaaec', '\uaaed'), ('\uaaf6', '\uaaf6'), ('\uabe5', '\uabe5'), ('\uabe8', '\uabe8'),
        ('\uabed', '\uabed'), ('\ufb1e', '\ufb1e'), ('\ufe00', '\ufe0f'), ('\ufe20', '\ufe2d'),
        ('\U000101fd', '\U000101fd'), ('\U000102e0', '\U000102e0'), ('\U00010376', '\U0001037a'),
        ('\U00010a01', '\U00010a03'), ('\U00010a05', '\U00010a06'), ('\U00010a0c', '\U00010a0f'),
        ('\U00010a38', '\U00010a3a'), ('\U00010a3f', '\U00010a3f'), ('\U00010ae5', '\U00010ae6'),
        ('\U00011001', '\U00011001'), ('\U00011038', '\U00011046'), ('\U0001107f', '\U00011081'),
        ('\U000110b3', '\U000110b6'), ('\U000110b9', '\U000110ba'), ('\U00011100', '\U00011102'),
        ('\U00011127', '\U0001112b'), ('\U0001112d', '\U00011134'), ('\U00011173', '\U00011173'),
        ('\U00011180', '\U00011181'), ('\U000111b6', '\U000111be'), ('\U0001122f', '\U00011231'),
        ('\U00011234', '\U00011234'), ('\U00011236', '\U00011237'), ('\U000112df', '\U000112df'),
        ('\U000112e3', '\U000112ea'), ('\U00011301', '\U00011301'), ('\U0001133c', '\U0001133c'),
        ('\U00011340', '\U00011340'), ('\U00011366', '\U0001136c'), ('\U00011370', '\U00011374'),
        ('\U000114b3', '\U000114b8'), ('\U000114ba', '\U000114ba'), ('\U000114bf', '\U000114c0'),
        ('\U000114c2', '\U000114c3'), ('\U000115b2', '\U000115b5'), ('\U000115bc', '\U000115bd'),
        ('\U000115bf', '\U000115c0'), ('\U00011633', '\U0001163a'), ('\U0001163d', '\U0001163d'),
        ('\U0001163f', '\U00011640'), ('\U000116ab', '\U000116ab'), ('\U000116ad', '\U000116ad'),
        ('\U000116b0', '\U000116b5'), ('\U000116b7', '\U000116b7'), ('\U00016af0', '\U00016af4'),
        ('\U00016b30', '\U00016b36'), ('\U00016f8f', '\U00016f92'), ('\U0001bc9d', '\U0001bc9e'),
        ('\U0001d167', '\U0001d169'), ('\U0001d17b', '\U0001d182'), ('\U0001d185', '\U0001d18b'),
        ('\U0001d1aa', '\U0001d1ad'), ('\U0001d242', '\U0001d244'), ('\U0001e8d0', '\U0001e8d6'),
        ('\U000e0100', '\U000e01ef')
    ];

    pub static N_table: &'static [(char, char)] = &[
        ('\x30', '\x39'), ('\u0660', '\u0669'), ('\u06f0', '\u06f9'), ('\u07c0', '\u07c9'),
        ('\u0966', '\u096f'), ('\u09e6', '\u09ef'), ('\u0a66', '\u0a6f'), ('\u0ae6', '\u0aef'),
        ('\u0b66', '\u0b6f'), ('\u0be6', '\u0bef'), ('\u0c66', '\u0c6f'), ('\u0ce6', '\u0cef'),
        ('\u0d66', '\u0d6f'), ('\u0de6', '\u0def'), ('\u0e50', '\u0e59'), ('\u0ed0', '\u0ed9'),
        ('\u0f20', '\u0f29'), ('\u1040', '\u1049'), ('\u1090', '\u1099'), ('\u16ee', '\u16f0'),
        ('\u17e0', '\u17e9'), ('\u1810', '\u1819'), ('\u1946', '\u194f'), ('\u19d0', '\u19d9'),
        ('\u1a80', '\u1a89'), ('\u1a90', '\u1a99'), ('\u1b50', '\u1b59'), ('\u1bb0', '\u1bb9'),
        ('\u1c40', '\u1c49'), ('\u1c50', '\u1c59'), ('\u2160', '\u2182'), ('\u2185', '\u2188'),
        ('\u3007', '\u3007'), ('\u3021', '\u3029'), ('\u3038', '\u303a'), ('\ua620', '\ua629'),
        ('\ua6e6', '\ua6ef'), ('\ua8d0', '\ua8d9'), ('\ua900', '\ua909'), ('\ua9d0', '\ua9d9'),
        ('\ua9f0', '\ua9f9'), ('\uaa50', '\uaa59'), ('\uabf0', '\uabf9'), ('\uff10', '\uff19'),
        ('\U00010140', '\U00010174'), ('\U00010341', '\U00010341'), ('\U0001034a', '\U0001034a'),
        ('\U000103d1', '\U000103d5'), ('\U000104a0', '\U000104a9'), ('\U00011066', '\U0001106f'),
        ('\U000110f0', '\U000110f9'), ('\U00011136', '\U0001113f'), ('\U000111d0', '\U000111d9'),
        ('\U000112f0', '\U000112f9'), ('\U000114d0', '\U000114d9'), ('\U00011650', '\U00011659'),
        ('\U000116c0', '\U000116c9'), ('\U000118e0', '\U000118e9'), ('\U00012400', '\U0001246e'),
        ('\U00016a60', '\U00016a69'), ('\U00016b50', '\U00016b59'), ('\U0001d7ce', '\U0001d7ff')
    ];

    pub fn N(c: char) -> bool {
        super::bsearch_range_table(c, N_table)
    }

    pub static Nd_table: &'static [(char, char)] = &[
        ('\x30', '\x39'), ('\u0660', '\u0669'), ('\u06f0', '\u06f9'), ('\u07c0', '\u07c9'),
        ('\u0966', '\u096f'), ('\u09e6', '\u09ef'), ('\u0a66', '\u0a6f'), ('\u0ae6', '\u0aef'),
        ('\u0b66', '\u0b6f'), ('\u0be6', '\u0bef'), ('\u0c66', '\u0c6f'), ('\u0ce6', '\u0cef'),
        ('\u0d66', '\u0d6f'), ('\u0de6', '\u0def'), ('\u0e50', '\u0e59'), ('\u0ed0', '\u0ed9'),
        ('\u0f20', '\u0f29'), ('\u1040', '\u1049'), ('\u1090', '\u1099'), ('\u17e0', '\u17e9'),
        ('\u1810', '\u1819'), ('\u1946', '\u194f'), ('\u19d0', '\u19d9'), ('\u1a80', '\u1a89'),
        ('\u1a90', '\u1a99'), ('\u1b50', '\u1b59'), ('\u1bb0', '\u1bb9'), ('\u1c40', '\u1c49'),
        ('\u1c50', '\u1c59'), ('\ua620', '\ua629'), ('\ua8d0', '\ua8d9'), ('\ua900', '\ua909'),
        ('\ua9d0', '\ua9d9'), ('\ua9f0', '\ua9f9'), ('\uaa50', '\uaa59'), ('\uabf0', '\uabf9'),
        ('\uff10', '\uff19'), ('\U000104a0', '\U000104a9'), ('\U00011066', '\U0001106f'),
        ('\U000110f0', '\U000110f9'), ('\U00011136', '\U0001113f'), ('\U000111d0', '\U000111d9'),
        ('\U000112f0', '\U000112f9'), ('\U000114d0', '\U000114d9'), ('\U00011650', '\U00011659'),
        ('\U000116c0', '\U000116c9'), ('\U000118e0', '\U000118e9'), ('\U00016a60', '\U00016a69'),
        ('\U00016b50', '\U00016b59'), ('\U0001d7ce', '\U0001d7ff')
    ];

    pub static Nl_table: &'static [(char, char)] = &[
        ('\u16ee', '\u16f0'), ('\u2160', '\u2182'), ('\u2185', '\u2188'), ('\u3007', '\u3007'),
        ('\u3021', '\u3029'), ('\u3038', '\u303a'), ('\ua6e6', '\ua6ef'), ('\U00010140',
        '\U00010174'), ('\U00010341', '\U00010341'), ('\U0001034a', '\U0001034a'), ('\U000103d1',
        '\U000103d5'), ('\U00012400', '\U0001246e')
    ];

    pub static No_table: &'static [(char, char)] = &[
        ('\u00b2', '\u00b3'), ('\u00b9', '\u00b9'), ('\u00bc', '\u00be'), ('\u09f4', '\u09f9'),
        ('\u0b72', '\u0b77'), ('\u0bf0', '\u0bf2'), ('\u0c78', '\u0c7e'), ('\u0d70', '\u0d75'),
        ('\u0f2a', '\u0f33'), ('\u1369', '\u137c'), ('\u17f0', '\u17f9'), ('\u19da', '\u19da'),
        ('\u2070', '\u2070'), ('\u2074', '\u2079'), ('\u2080', '\u2089'), ('\u2150', '\u215f'),
        ('\u2189', '\u2189'), ('\u2460', '\u249b'), ('\u24ea', '\u24ff'), ('\u2776', '\u2793'),
        ('\u2cfd', '\u2cfd'), ('\u3192', '\u3195'), ('\u3220', '\u3229'), ('\u3248', '\u324f'),
        ('\u3251', '\u325f'), ('\u3280', '\u3289'), ('\u32b1', '\u32bf'), ('\ua830', '\ua835'),
        ('\U00010107', '\U00010133'), ('\U00010175', '\U00010178'), ('\U0001018a', '\U0001018b'),
        ('\U000102e1', '\U000102fb'), ('\U00010320', '\U00010323'), ('\U00010858', '\U0001085f'),
        ('\U00010879', '\U0001087f'), ('\U000108a7', '\U000108af'), ('\U00010916', '\U0001091b'),
        ('\U00010a40', '\U00010a47'), ('\U00010a7d', '\U00010a7e'), ('\U00010a9d', '\U00010a9f'),
        ('\U00010aeb', '\U00010aef'), ('\U00010b58', '\U00010b5f'), ('\U00010b78', '\U00010b7f'),
        ('\U00010ba9', '\U00010baf'), ('\U00010e60', '\U00010e7e'), ('\U00011052', '\U00011065'),
        ('\U000111e1', '\U000111f4'), ('\U000118ea', '\U000118f2'), ('\U00016b5b', '\U00016b61'),
        ('\U0001d360', '\U0001d371'), ('\U0001e8c7', '\U0001e8cf'), ('\U0001f100', '\U0001f10c')
    ];

    pub static P_table: &'static [(char, char)] = &[
        ('\x21', '\x23'), ('\x25', '\x2a'), ('\x2c', '\x2f'), ('\x3a', '\x3b'), ('\x3f', '\x40'),
        ('\x5b', '\x5d'), ('\x5f', '\x5f'), ('\x7b', '\x7b'), ('\x7d', '\x7d'), ('\u00a1',
        '\u00a1'), ('\u00a7', '\u00a7'), ('\u00ab', '\u00ab'), ('\u00b6', '\u00b7'), ('\u00bb',
        '\u00bb'), ('\u00bf', '\u00bf'), ('\u037e', '\u037e'), ('\u0387', '\u0387'), ('\u055a',
        '\u055f'), ('\u0589', '\u058a'), ('\u05be', '\u05be'), ('\u05c0', '\u05c0'), ('\u05c3',
        '\u05c3'), ('\u05c6', '\u05c6'), ('\u05f3', '\u05f4'), ('\u0609', '\u060a'), ('\u060c',
        '\u060d'), ('\u061b', '\u061b'), ('\u061e', '\u061f'), ('\u066a', '\u066d'), ('\u06d4',
        '\u06d4'), ('\u0700', '\u070d'), ('\u07f7', '\u07f9'), ('\u0830', '\u083e'), ('\u085e',
        '\u085e'), ('\u0964', '\u0965'), ('\u0970', '\u0970'), ('\u0af0', '\u0af0'), ('\u0df4',
        '\u0df4'), ('\u0e4f', '\u0e4f'), ('\u0e5a', '\u0e5b'), ('\u0f04', '\u0f12'), ('\u0f14',
        '\u0f14'), ('\u0f3a', '\u0f3d'), ('\u0f85', '\u0f85'), ('\u0fd0', '\u0fd4'), ('\u0fd9',
        '\u0fda'), ('\u104a', '\u104f'), ('\u10fb', '\u10fb'), ('\u1360', '\u1368'), ('\u1400',
        '\u1400'), ('\u166d', '\u166e'), ('\u169b', '\u169c'), ('\u16eb', '\u16ed'), ('\u1735',
        '\u1736'), ('\u17d4', '\u17d6'), ('\u17d8', '\u17da'), ('\u1800', '\u180a'), ('\u1944',
        '\u1945'), ('\u1a1e', '\u1a1f'), ('\u1aa0', '\u1aa6'), ('\u1aa8', '\u1aad'), ('\u1b5a',
        '\u1b60'), ('\u1bfc', '\u1bff'), ('\u1c3b', '\u1c3f'), ('\u1c7e', '\u1c7f'), ('\u1cc0',
        '\u1cc7'), ('\u1cd3', '\u1cd3'), ('\u2010', '\u2027'), ('\u2030', '\u2043'), ('\u2045',
        '\u2051'), ('\u2053', '\u205e'), ('\u207d', '\u207e'), ('\u208d', '\u208e'), ('\u2308',
        '\u230b'), ('\u2329', '\u232a'), ('\u2768', '\u2775'), ('\u27c5', '\u27c6'), ('\u27e6',
        '\u27ef'), ('\u2983', '\u2998'), ('\u29d8', '\u29db'), ('\u29fc', '\u29fd'), ('\u2cf9',
        '\u2cfc'), ('\u2cfe', '\u2cff'), ('\u2d70', '\u2d70'), ('\u2e00', '\u2e2e'), ('\u2e30',
        '\u2e42'), ('\u3001', '\u3003'), ('\u3008', '\u3011'), ('\u3014', '\u301f'), ('\u3030',
        '\u3030'), ('\u303d', '\u303d'), ('\u30a0', '\u30a0'), ('\u30fb', '\u30fb'), ('\ua4fe',
        '\ua4ff'), ('\ua60d', '\ua60f'), ('\ua673', '\ua673'), ('\ua67e', '\ua67e'), ('\ua6f2',
        '\ua6f7'), ('\ua874', '\ua877'), ('\ua8ce', '\ua8cf'), ('\ua8f8', '\ua8fa'), ('\ua92e',
        '\ua92f'), ('\ua95f', '\ua95f'), ('\ua9c1', '\ua9cd'), ('\ua9de', '\ua9df'), ('\uaa5c',
        '\uaa5f'), ('\uaade', '\uaadf'), ('\uaaf0', '\uaaf1'), ('\uabeb', '\uabeb'), ('\ufd3e',
        '\ufd3f'), ('\ufe10', '\ufe19'), ('\ufe30', '\ufe52'), ('\ufe54', '\ufe61'), ('\ufe63',
        '\ufe63'), ('\ufe68', '\ufe68'), ('\ufe6a', '\ufe6b'), ('\uff01', '\uff03'), ('\uff05',
        '\uff0a'), ('\uff0c', '\uff0f'), ('\uff1a', '\uff1b'), ('\uff1f', '\uff20'), ('\uff3b',
        '\uff3d'), ('\uff3f', '\uff3f'), ('\uff5b', '\uff5b'), ('\uff5d', '\uff5d'), ('\uff5f',
        '\uff65'), ('\U00010100', '\U00010102'), ('\U0001039f', '\U0001039f'), ('\U000103d0',
        '\U000103d0'), ('\U0001056f', '\U0001056f'), ('\U00010857', '\U00010857'), ('\U0001091f',
        '\U0001091f'), ('\U0001093f', '\U0001093f'), ('\U00010a50', '\U00010a58'), ('\U00010a7f',
        '\U00010a7f'), ('\U00010af0', '\U00010af6'), ('\U00010b39', '\U00010b3f'), ('\U00010b99',
        '\U00010b9c'), ('\U00011047', '\U0001104d'), ('\U000110bb', '\U000110bc'), ('\U000110be',
        '\U000110c1'), ('\U00011140', '\U00011143'), ('\U00011174', '\U00011175'), ('\U000111c5',
        '\U000111c8'), ('\U000111cd', '\U000111cd'), ('\U00011238', '\U0001123d'), ('\U000114c6',
        '\U000114c6'), ('\U000115c1', '\U000115c9'), ('\U00011641', '\U00011643'), ('\U00012470',
        '\U00012474'), ('\U00016a6e', '\U00016a6f'), ('\U00016af5', '\U00016af5'), ('\U00016b37',
        '\U00016b3b'), ('\U00016b44', '\U00016b44'), ('\U0001bc9f', '\U0001bc9f')
    ];

    pub static Pc_table: &'static [(char, char)] = &[
        ('\x5f', '\x5f'), ('\u203f', '\u2040'), ('\u2054', '\u2054'), ('\ufe33', '\ufe34'),
        ('\ufe4d', '\ufe4f'), ('\uff3f', '\uff3f')
    ];

    pub static Pd_table: &'static [(char, char)] = &[
        ('\x2d', '\x2d'), ('\u058a', '\u058a'), ('\u05be', '\u05be'), ('\u1400', '\u1400'),
        ('\u1806', '\u1806'), ('\u2010', '\u2015'), ('\u2e17', '\u2e17'), ('\u2e1a', '\u2e1a'),
        ('\u2e3a', '\u2e3b'), ('\u2e40', '\u2e40'), ('\u301c', '\u301c'), ('\u3030', '\u3030'),
        ('\u30a0', '\u30a0'), ('\ufe31', '\ufe32'), ('\ufe58', '\ufe58'), ('\ufe63', '\ufe63'),
        ('\uff0d', '\uff0d')
    ];

    pub static Pe_table: &'static [(char, char)] = &[
        ('\x29', '\x29'), ('\x5d', '\x5d'), ('\x7d', '\x7d'), ('\u0f3b', '\u0f3b'), ('\u0f3d',
        '\u0f3d'), ('\u169c', '\u169c'), ('\u2046', '\u2046'), ('\u207e', '\u207e'), ('\u208e',
        '\u208e'), ('\u2309', '\u2309'), ('\u230b', '\u230b'), ('\u232a', '\u232a'), ('\u2769',
        '\u2769'), ('\u276b', '\u276b'), ('\u276d', '\u276d'), ('\u276f', '\u276f'), ('\u2771',
        '\u2771'), ('\u2773', '\u2773'), ('\u2775', '\u2775'), ('\u27c6', '\u27c6'), ('\u27e7',
        '\u27e7'), ('\u27e9', '\u27e9'), ('\u27eb', '\u27eb'), ('\u27ed', '\u27ed'), ('\u27ef',
        '\u27ef'), ('\u2984', '\u2984'), ('\u2986', '\u2986'), ('\u2988', '\u2988'), ('\u298a',
        '\u298a'), ('\u298c', '\u298c'), ('\u298e', '\u298e'), ('\u2990', '\u2990'), ('\u2992',
        '\u2992'), ('\u2994', '\u2994'), ('\u2996', '\u2996'), ('\u2998', '\u2998'), ('\u29d9',
        '\u29d9'), ('\u29db', '\u29db'), ('\u29fd', '\u29fd'), ('\u2e23', '\u2e23'), ('\u2e25',
        '\u2e25'), ('\u2e27', '\u2e27'), ('\u2e29', '\u2e29'), ('\u3009', '\u3009'), ('\u300b',
        '\u300b'), ('\u300d', '\u300d'), ('\u300f', '\u300f'), ('\u3011', '\u3011'), ('\u3015',
        '\u3015'), ('\u3017', '\u3017'), ('\u3019', '\u3019'), ('\u301b', '\u301b'), ('\u301e',
        '\u301f'), ('\ufd3e', '\ufd3e'), ('\ufe18', '\ufe18'), ('\ufe36', '\ufe36'), ('\ufe38',
        '\ufe38'), ('\ufe3a', '\ufe3a'), ('\ufe3c', '\ufe3c'), ('\ufe3e', '\ufe3e'), ('\ufe40',
        '\ufe40'), ('\ufe42', '\ufe42'), ('\ufe44', '\ufe44'), ('\ufe48', '\ufe48'), ('\ufe5a',
        '\ufe5a'), ('\ufe5c', '\ufe5c'), ('\ufe5e', '\ufe5e'), ('\uff09', '\uff09'), ('\uff3d',
        '\uff3d'), ('\uff5d', '\uff5d'), ('\uff60', '\uff60'), ('\uff63', '\uff63')
    ];

    pub static Pf_table: &'static [(char, char)] = &[
        ('\u00bb', '\u00bb'), ('\u2019', '\u2019'), ('\u201d', '\u201d'), ('\u203a', '\u203a'),
        ('\u2e03', '\u2e03'), ('\u2e05', '\u2e05'), ('\u2e0a', '\u2e0a'), ('\u2e0d', '\u2e0d'),
        ('\u2e1d', '\u2e1d'), ('\u2e21', '\u2e21')
    ];

    pub static Pi_table: &'static [(char, char)] = &[
        ('\u00ab', '\u00ab'), ('\u2018', '\u2018'), ('\u201b', '\u201c'), ('\u201f', '\u201f'),
        ('\u2039', '\u2039'), ('\u2e02', '\u2e02'), ('\u2e04', '\u2e04'), ('\u2e09', '\u2e09'),
        ('\u2e0c', '\u2e0c'), ('\u2e1c', '\u2e1c'), ('\u2e20', '\u2e20')
    ];

    pub static Po_table: &'static [(char, char)] = &[
        ('\x21', '\x23'), ('\x25', '\x27'), ('\x2a', '\x2a'), ('\x2c', '\x2c'), ('\x2e', '\x2f'),
        ('\x3a', '\x3b'), ('\x3f', '\x40'), ('\x5c', '\x5c'), ('\u00a1', '\u00a1'), ('\u00a7',
        '\u00a7'), ('\u00b6', '\u00b7'), ('\u00bf', '\u00bf'), ('\u037e', '\u037e'), ('\u0387',
        '\u0387'), ('\u055a', '\u055f'), ('\u0589', '\u0589'), ('\u05c0', '\u05c0'), ('\u05c3',
        '\u05c3'), ('\u05c6', '\u05c6'), ('\u05f3', '\u05f4'), ('\u0609', '\u060a'), ('\u060c',
        '\u060d'), ('\u061b', '\u061b'), ('\u061e', '\u061f'), ('\u066a', '\u066d'), ('\u06d4',
        '\u06d4'), ('\u0700', '\u070d'), ('\u07f7', '\u07f9'), ('\u0830', '\u083e'), ('\u085e',
        '\u085e'), ('\u0964', '\u0965'), ('\u0970', '\u0970'), ('\u0af0', '\u0af0'), ('\u0df4',
        '\u0df4'), ('\u0e4f', '\u0e4f'), ('\u0e5a', '\u0e5b'), ('\u0f04', '\u0f12'), ('\u0f14',
        '\u0f14'), ('\u0f85', '\u0f85'), ('\u0fd0', '\u0fd4'), ('\u0fd9', '\u0fda'), ('\u104a',
        '\u104f'), ('\u10fb', '\u10fb'), ('\u1360', '\u1368'), ('\u166d', '\u166e'), ('\u16eb',
        '\u16ed'), ('\u1735', '\u1736'), ('\u17d4', '\u17d6'), ('\u17d8', '\u17da'), ('\u1800',
        '\u1805'), ('\u1807', '\u180a'), ('\u1944', '\u1945'), ('\u1a1e', '\u1a1f'), ('\u1aa0',
        '\u1aa6'), ('\u1aa8', '\u1aad'), ('\u1b5a', '\u1b60'), ('\u1bfc', '\u1bff'), ('\u1c3b',
        '\u1c3f'), ('\u1c7e', '\u1c7f'), ('\u1cc0', '\u1cc7'), ('\u1cd3', '\u1cd3'), ('\u2016',
        '\u2017'), ('\u2020', '\u2027'), ('\u2030', '\u2038'), ('\u203b', '\u203e'), ('\u2041',
        '\u2043'), ('\u2047', '\u2051'), ('\u2053', '\u2053'), ('\u2055', '\u205e'), ('\u2cf9',
        '\u2cfc'), ('\u2cfe', '\u2cff'), ('\u2d70', '\u2d70'), ('\u2e00', '\u2e01'), ('\u2e06',
        '\u2e08'), ('\u2e0b', '\u2e0b'), ('\u2e0e', '\u2e16'), ('\u2e18', '\u2e19'), ('\u2e1b',
        '\u2e1b'), ('\u2e1e', '\u2e1f'), ('\u2e2a', '\u2e2e'), ('\u2e30', '\u2e39'), ('\u2e3c',
        '\u2e3f'), ('\u2e41', '\u2e41'), ('\u3001', '\u3003'), ('\u303d', '\u303d'), ('\u30fb',
        '\u30fb'), ('\ua4fe', '\ua4ff'), ('\ua60d', '\ua60f'), ('\ua673', '\ua673'), ('\ua67e',
        '\ua67e'), ('\ua6f2', '\ua6f7'), ('\ua874', '\ua877'), ('\ua8ce', '\ua8cf'), ('\ua8f8',
        '\ua8fa'), ('\ua92e', '\ua92f'), ('\ua95f', '\ua95f'), ('\ua9c1', '\ua9cd'), ('\ua9de',
        '\ua9df'), ('\uaa5c', '\uaa5f'), ('\uaade', '\uaadf'), ('\uaaf0', '\uaaf1'), ('\uabeb',
        '\uabeb'), ('\ufe10', '\ufe16'), ('\ufe19', '\ufe19'), ('\ufe30', '\ufe30'), ('\ufe45',
        '\ufe46'), ('\ufe49', '\ufe4c'), ('\ufe50', '\ufe52'), ('\ufe54', '\ufe57'), ('\ufe5f',
        '\ufe61'), ('\ufe68', '\ufe68'), ('\ufe6a', '\ufe6b'), ('\uff01', '\uff03'), ('\uff05',
        '\uff07'), ('\uff0a', '\uff0a'), ('\uff0c', '\uff0c'), ('\uff0e', '\uff0f'), ('\uff1a',
        '\uff1b'), ('\uff1f', '\uff20'), ('\uff3c', '\uff3c'), ('\uff61', '\uff61'), ('\uff64',
        '\uff65'), ('\U00010100', '\U00010102'), ('\U0001039f', '\U0001039f'), ('\U000103d0',
        '\U000103d0'), ('\U0001056f', '\U0001056f'), ('\U00010857', '\U00010857'), ('\U0001091f',
        '\U0001091f'), ('\U0001093f', '\U0001093f'), ('\U00010a50', '\U00010a58'), ('\U00010a7f',
        '\U00010a7f'), ('\U00010af0', '\U00010af6'), ('\U00010b39', '\U00010b3f'), ('\U00010b99',
        '\U00010b9c'), ('\U00011047', '\U0001104d'), ('\U000110bb', '\U000110bc'), ('\U000110be',
        '\U000110c1'), ('\U00011140', '\U00011143'), ('\U00011174', '\U00011175'), ('\U000111c5',
        '\U000111c8'), ('\U000111cd', '\U000111cd'), ('\U00011238', '\U0001123d'), ('\U000114c6',
        '\U000114c6'), ('\U000115c1', '\U000115c9'), ('\U00011641', '\U00011643'), ('\U00012470',
        '\U00012474'), ('\U00016a6e', '\U00016a6f'), ('\U00016af5', '\U00016af5'), ('\U00016b37',
        '\U00016b3b'), ('\U00016b44', '\U00016b44'), ('\U0001bc9f', '\U0001bc9f')
    ];

    pub static Ps_table: &'static [(char, char)] = &[
        ('\x28', '\x28'), ('\x5b', '\x5b'), ('\x7b', '\x7b'), ('\u0f3a', '\u0f3a'), ('\u0f3c',
        '\u0f3c'), ('\u169b', '\u169b'), ('\u201a', '\u201a'), ('\u201e', '\u201e'), ('\u2045',
        '\u2045'), ('\u207d', '\u207d'), ('\u208d', '\u208d'), ('\u2308', '\u2308'), ('\u230a',
        '\u230a'), ('\u2329', '\u2329'), ('\u2768', '\u2768'), ('\u276a', '\u276a'), ('\u276c',
        '\u276c'), ('\u276e', '\u276e'), ('\u2770', '\u2770'), ('\u2772', '\u2772'), ('\u2774',
        '\u2774'), ('\u27c5', '\u27c5'), ('\u27e6', '\u27e6'), ('\u27e8', '\u27e8'), ('\u27ea',
        '\u27ea'), ('\u27ec', '\u27ec'), ('\u27ee', '\u27ee'), ('\u2983', '\u2983'), ('\u2985',
        '\u2985'), ('\u2987', '\u2987'), ('\u2989', '\u2989'), ('\u298b', '\u298b'), ('\u298d',
        '\u298d'), ('\u298f', '\u298f'), ('\u2991', '\u2991'), ('\u2993', '\u2993'), ('\u2995',
        '\u2995'), ('\u2997', '\u2997'), ('\u29d8', '\u29d8'), ('\u29da', '\u29da'), ('\u29fc',
        '\u29fc'), ('\u2e22', '\u2e22'), ('\u2e24', '\u2e24'), ('\u2e26', '\u2e26'), ('\u2e28',
        '\u2e28'), ('\u2e42', '\u2e42'), ('\u3008', '\u3008'), ('\u300a', '\u300a'), ('\u300c',
        '\u300c'), ('\u300e', '\u300e'), ('\u3010', '\u3010'), ('\u3014', '\u3014'), ('\u3016',
        '\u3016'), ('\u3018', '\u3018'), ('\u301a', '\u301a'), ('\u301d', '\u301d'), ('\ufd3f',
        '\ufd3f'), ('\ufe17', '\ufe17'), ('\ufe35', '\ufe35'), ('\ufe37', '\ufe37'), ('\ufe39',
        '\ufe39'), ('\ufe3b', '\ufe3b'), ('\ufe3d', '\ufe3d'), ('\ufe3f', '\ufe3f'), ('\ufe41',
        '\ufe41'), ('\ufe43', '\ufe43'), ('\ufe47', '\ufe47'), ('\ufe59', '\ufe59'), ('\ufe5b',
        '\ufe5b'), ('\ufe5d', '\ufe5d'), ('\uff08', '\uff08'), ('\uff3b', '\uff3b'), ('\uff5b',
        '\uff5b'), ('\uff5f', '\uff5f'), ('\uff62', '\uff62')
    ];

    pub static S_table: &'static [(char, char)] = &[
        ('\x24', '\x24'), ('\x2b', '\x2b'), ('\x3c', '\x3e'), ('\x5e', '\x5e'), ('\x60', '\x60'),
        ('\x7c', '\x7c'), ('\x7e', '\x7e'), ('\u00a2', '\u00a6'), ('\u00a8', '\u00a9'), ('\u00ac',
        '\u00ac'), ('\u00ae', '\u00b1'), ('\u00b4', '\u00b4'), ('\u00b8', '\u00b8'), ('\u00d7',
        '\u00d7'), ('\u00f7', '\u00f7'), ('\u02c2', '\u02c5'), ('\u02d2', '\u02df'), ('\u02e5',
        '\u02eb'), ('\u02ed', '\u02ed'), ('\u02ef', '\u02ff'), ('\u0375', '\u0375'), ('\u0384',
        '\u0385'), ('\u03f6', '\u03f6'), ('\u0482', '\u0482'), ('\u058d', '\u058f'), ('\u0606',
        '\u0608'), ('\u060b', '\u060b'), ('\u060e', '\u060f'), ('\u06de', '\u06de'), ('\u06e9',
        '\u06e9'), ('\u06fd', '\u06fe'), ('\u07f6', '\u07f6'), ('\u09f2', '\u09f3'), ('\u09fa',
        '\u09fb'), ('\u0af1', '\u0af1'), ('\u0b70', '\u0b70'), ('\u0bf3', '\u0bfa'), ('\u0c7f',
        '\u0c7f'), ('\u0d79', '\u0d79'), ('\u0e3f', '\u0e3f'), ('\u0f01', '\u0f03'), ('\u0f13',
        '\u0f13'), ('\u0f15', '\u0f17'), ('\u0f1a', '\u0f1f'), ('\u0f34', '\u0f34'), ('\u0f36',
        '\u0f36'), ('\u0f38', '\u0f38'), ('\u0fbe', '\u0fc5'), ('\u0fc7', '\u0fcc'), ('\u0fce',
        '\u0fcf'), ('\u0fd5', '\u0fd8'), ('\u109e', '\u109f'), ('\u1390', '\u1399'), ('\u17db',
        '\u17db'), ('\u1940', '\u1940'), ('\u19de', '\u19ff'), ('\u1b61', '\u1b6a'), ('\u1b74',
        '\u1b7c'), ('\u1fbd', '\u1fbd'), ('\u1fbf', '\u1fc1'), ('\u1fcd', '\u1fcf'), ('\u1fdd',
        '\u1fdf'), ('\u1fed', '\u1fef'), ('\u1ffd', '\u1ffe'), ('\u2044', '\u2044'), ('\u2052',
        '\u2052'), ('\u207a', '\u207c'), ('\u208a', '\u208c'), ('\u20a0', '\u20bd'), ('\u2100',
        '\u2101'), ('\u2103', '\u2106'), ('\u2108', '\u2109'), ('\u2114', '\u2114'), ('\u2116',
        '\u2118'), ('\u211e', '\u2123'), ('\u2125', '\u2125'), ('\u2127', '\u2127'), ('\u2129',
        '\u2129'), ('\u212e', '\u212e'), ('\u213a', '\u213b'), ('\u2140', '\u2144'), ('\u214a',
        '\u214d'), ('\u214f', '\u214f'), ('\u2190', '\u2307'), ('\u230c', '\u2328'), ('\u232b',
        '\u23fa'), ('\u2400', '\u2426'), ('\u2440', '\u244a'), ('\u249c', '\u24e9'), ('\u2500',
        '\u2767'), ('\u2794', '\u27c4'), ('\u27c7', '\u27e5'), ('\u27f0', '\u2982'), ('\u2999',
        '\u29d7'), ('\u29dc', '\u29fb'), ('\u29fe', '\u2b73'), ('\u2b76', '\u2b95'), ('\u2b98',
        '\u2bb9'), ('\u2bbd', '\u2bc8'), ('\u2bca', '\u2bd1'), ('\u2ce5', '\u2cea'), ('\u2e80',
        '\u2e99'), ('\u2e9b', '\u2ef3'), ('\u2f00', '\u2fd5'), ('\u2ff0', '\u2ffb'), ('\u3004',
        '\u3004'), ('\u3012', '\u3013'), ('\u3020', '\u3020'), ('\u3036', '\u3037'), ('\u303e',
        '\u303f'), ('\u309b', '\u309c'), ('\u3190', '\u3191'), ('\u3196', '\u319f'), ('\u31c0',
        '\u31e3'), ('\u3200', '\u321e'), ('\u322a', '\u3247'), ('\u3250', '\u3250'), ('\u3260',
        '\u327f'), ('\u328a', '\u32b0'), ('\u32c0', '\u32fe'), ('\u3300', '\u33ff'), ('\u4dc0',
        '\u4dff'), ('\ua490', '\ua4c6'), ('\ua700', '\ua716'), ('\ua720', '\ua721'), ('\ua789',
        '\ua78a'), ('\ua828', '\ua82b'), ('\ua836', '\ua839'), ('\uaa77', '\uaa79'), ('\uab5b',
        '\uab5b'), ('\ufb29', '\ufb29'), ('\ufbb2', '\ufbc1'), ('\ufdfc', '\ufdfd'), ('\ufe62',
        '\ufe62'), ('\ufe64', '\ufe66'), ('\ufe69', '\ufe69'), ('\uff04', '\uff04'), ('\uff0b',
        '\uff0b'), ('\uff1c', '\uff1e'), ('\uff3e', '\uff3e'), ('\uff40', '\uff40'), ('\uff5c',
        '\uff5c'), ('\uff5e', '\uff5e'), ('\uffe0', '\uffe6'), ('\uffe8', '\uffee'), ('\ufffc',
        '\ufffd'), ('\U00010137', '\U0001013f'), ('\U00010179', '\U00010189'), ('\U0001018c',
        '\U0001018c'), ('\U00010190', '\U0001019b'), ('\U000101a0', '\U000101a0'), ('\U000101d0',
        '\U000101fc'), ('\U00010877', '\U00010878'), ('\U00010ac8', '\U00010ac8'), ('\U00016b3c',
        '\U00016b3f'), ('\U00016b45', '\U00016b45'), ('\U0001bc9c', '\U0001bc9c'), ('\U0001d000',
        '\U0001d0f5'), ('\U0001d100', '\U0001d126'), ('\U0001d129', '\U0001d164'), ('\U0001d16a',
        '\U0001d16c'), ('\U0001d183', '\U0001d184'), ('\U0001d18c', '\U0001d1a9'), ('\U0001d1ae',
        '\U0001d1dd'), ('\U0001d200', '\U0001d241'), ('\U0001d245', '\U0001d245'), ('\U0001d300',
        '\U0001d356'), ('\U0001d6c1', '\U0001d6c1'), ('\U0001d6db', '\U0001d6db'), ('\U0001d6fb',
        '\U0001d6fb'), ('\U0001d715', '\U0001d715'), ('\U0001d735', '\U0001d735'), ('\U0001d74f',
        '\U0001d74f'), ('\U0001d76f', '\U0001d76f'), ('\U0001d789', '\U0001d789'), ('\U0001d7a9',
        '\U0001d7a9'), ('\U0001d7c3', '\U0001d7c3'), ('\U0001eef0', '\U0001eef1'), ('\U0001f000',
        '\U0001f02b'), ('\U0001f030', '\U0001f093'), ('\U0001f0a0', '\U0001f0ae'), ('\U0001f0b1',
        '\U0001f0bf'), ('\U0001f0c1', '\U0001f0cf'), ('\U0001f0d1', '\U0001f0f5'), ('\U0001f110',
        '\U0001f12e'), ('\U0001f130', '\U0001f16b'), ('\U0001f170', '\U0001f19a'), ('\U0001f1e6',
        '\U0001f202'), ('\U0001f210', '\U0001f23a'), ('\U0001f240', '\U0001f248'), ('\U0001f250',
        '\U0001f251'), ('\U0001f300', '\U0001f32c'), ('\U0001f330', '\U0001f37d'), ('\U0001f380',
        '\U0001f3ce'), ('\U0001f3d4', '\U0001f3f7'), ('\U0001f400', '\U0001f4fe'), ('\U0001f500',
        '\U0001f54a'), ('\U0001f550', '\U0001f579'), ('\U0001f57b', '\U0001f5a3'), ('\U0001f5a5',
        '\U0001f642'), ('\U0001f645', '\U0001f6cf'), ('\U0001f6e0', '\U0001f6ec'), ('\U0001f6f0',
        '\U0001f6f3'), ('\U0001f700', '\U0001f773'), ('\U0001f780', '\U0001f7d4'), ('\U0001f800',
        '\U0001f80b'), ('\U0001f810', '\U0001f847'), ('\U0001f850', '\U0001f859'), ('\U0001f860',
        '\U0001f887'), ('\U0001f890', '\U0001f8ad')
    ];

    pub static Sc_table: &'static [(char, char)] = &[
        ('\x24', '\x24'), ('\u00a2', '\u00a5'), ('\u058f', '\u058f'), ('\u060b', '\u060b'),
        ('\u09f2', '\u09f3'), ('\u09fb', '\u09fb'), ('\u0af1', '\u0af1'), ('\u0bf9', '\u0bf9'),
        ('\u0e3f', '\u0e3f'), ('\u17db', '\u17db'), ('\u20a0', '\u20bd'), ('\ua838', '\ua838'),
        ('\ufdfc', '\ufdfc'), ('\ufe69', '\ufe69'), ('\uff04', '\uff04'), ('\uffe0', '\uffe1'),
        ('\uffe5', '\uffe6')
    ];

    pub static Sk_table: &'static [(char, char)] = &[
        ('\x5e', '\x5e'), ('\x60', '\x60'), ('\u00a8', '\u00a8'), ('\u00af', '\u00af'), ('\u00b4',
        '\u00b4'), ('\u00b8', '\u00b8'), ('\u02c2', '\u02c5'), ('\u02d2', '\u02df'), ('\u02e5',
        '\u02eb'), ('\u02ed', '\u02ed'), ('\u02ef', '\u02ff'), ('\u0375', '\u0375'), ('\u0384',
        '\u0385'), ('\u1fbd', '\u1fbd'), ('\u1fbf', '\u1fc1'), ('\u1fcd', '\u1fcf'), ('\u1fdd',
        '\u1fdf'), ('\u1fed', '\u1fef'), ('\u1ffd', '\u1ffe'), ('\u309b', '\u309c'), ('\ua700',
        '\ua716'), ('\ua720', '\ua721'), ('\ua789', '\ua78a'), ('\uab5b', '\uab5b'), ('\ufbb2',
        '\ufbc1'), ('\uff3e', '\uff3e'), ('\uff40', '\uff40'), ('\uffe3', '\uffe3')
    ];

    pub static Sm_table: &'static [(char, char)] = &[
        ('\x2b', '\x2b'), ('\x3c', '\x3e'), ('\x7c', '\x7c'), ('\x7e', '\x7e'), ('\u00ac',
        '\u00ac'), ('\u00b1', '\u00b1'), ('\u00d7', '\u00d7'), ('\u00f7', '\u00f7'), ('\u03f6',
        '\u03f6'), ('\u0606', '\u0608'), ('\u2044', '\u2044'), ('\u2052', '\u2052'), ('\u207a',
        '\u207c'), ('\u208a', '\u208c'), ('\u2118', '\u2118'), ('\u2140', '\u2144'), ('\u214b',
        '\u214b'), ('\u2190', '\u2194'), ('\u219a', '\u219b'), ('\u21a0', '\u21a0'), ('\u21a3',
        '\u21a3'), ('\u21a6', '\u21a6'), ('\u21ae', '\u21ae'), ('\u21ce', '\u21cf'), ('\u21d2',
        '\u21d2'), ('\u21d4', '\u21d4'), ('\u21f4', '\u22ff'), ('\u2320', '\u2321'), ('\u237c',
        '\u237c'), ('\u239b', '\u23b3'), ('\u23dc', '\u23e1'), ('\u25b7', '\u25b7'), ('\u25c1',
        '\u25c1'), ('\u25f8', '\u25ff'), ('\u266f', '\u266f'), ('\u27c0', '\u27c4'), ('\u27c7',
        '\u27e5'), ('\u27f0', '\u27ff'), ('\u2900', '\u2982'), ('\u2999', '\u29d7'), ('\u29dc',
        '\u29fb'), ('\u29fe', '\u2aff'), ('\u2b30', '\u2b44'), ('\u2b47', '\u2b4c'), ('\ufb29',
        '\ufb29'), ('\ufe62', '\ufe62'), ('\ufe64', '\ufe66'), ('\uff0b', '\uff0b'), ('\uff1c',
        '\uff1e'), ('\uff5c', '\uff5c'), ('\uff5e', '\uff5e'), ('\uffe2', '\uffe2'), ('\uffe9',
        '\uffec'), ('\U0001d6c1', '\U0001d6c1'), ('\U0001d6db', '\U0001d6db'), ('\U0001d6fb',
        '\U0001d6fb'), ('\U0001d715', '\U0001d715'), ('\U0001d735', '\U0001d735'), ('\U0001d74f',
        '\U0001d74f'), ('\U0001d76f', '\U0001d76f'), ('\U0001d789', '\U0001d789'), ('\U0001d7a9',
        '\U0001d7a9'), ('\U0001d7c3', '\U0001d7c3'), ('\U0001eef0', '\U0001eef1')
    ];

    pub static So_table: &'static [(char, char)] = &[
        ('\u00a6', '\u00a6'), ('\u00a9', '\u00a9'), ('\u00ae', '\u00ae'), ('\u00b0', '\u00b0'),
        ('\u0482', '\u0482'), ('\u058d', '\u058e'), ('\u060e', '\u060f'), ('\u06de', '\u06de'),
        ('\u06e9', '\u06e9'), ('\u06fd', '\u06fe'), ('\u07f6', '\u07f6'), ('\u09fa', '\u09fa'),
        ('\u0b70', '\u0b70'), ('\u0bf3', '\u0bf8'), ('\u0bfa', '\u0bfa'), ('\u0c7f', '\u0c7f'),
        ('\u0d79', '\u0d79'), ('\u0f01', '\u0f03'), ('\u0f13', '\u0f13'), ('\u0f15', '\u0f17'),
        ('\u0f1a', '\u0f1f'), ('\u0f34', '\u0f34'), ('\u0f36', '\u0f36'), ('\u0f38', '\u0f38'),
        ('\u0fbe', '\u0fc5'), ('\u0fc7', '\u0fcc'), ('\u0fce', '\u0fcf'), ('\u0fd5', '\u0fd8'),
        ('\u109e', '\u109f'), ('\u1390', '\u1399'), ('\u1940', '\u1940'), ('\u19de', '\u19ff'),
        ('\u1b61', '\u1b6a'), ('\u1b74', '\u1b7c'), ('\u2100', '\u2101'), ('\u2103', '\u2106'),
        ('\u2108', '\u2109'), ('\u2114', '\u2114'), ('\u2116', '\u2117'), ('\u211e', '\u2123'),
        ('\u2125', '\u2125'), ('\u2127', '\u2127'), ('\u2129', '\u2129'), ('\u212e', '\u212e'),
        ('\u213a', '\u213b'), ('\u214a', '\u214a'), ('\u214c', '\u214d'), ('\u214f', '\u214f'),
        ('\u2195', '\u2199'), ('\u219c', '\u219f'), ('\u21a1', '\u21a2'), ('\u21a4', '\u21a5'),
        ('\u21a7', '\u21ad'), ('\u21af', '\u21cd'), ('\u21d0', '\u21d1'), ('\u21d3', '\u21d3'),
        ('\u21d5', '\u21f3'), ('\u2300', '\u2307'), ('\u230c', '\u231f'), ('\u2322', '\u2328'),
        ('\u232b', '\u237b'), ('\u237d', '\u239a'), ('\u23b4', '\u23db'), ('\u23e2', '\u23fa'),
        ('\u2400', '\u2426'), ('\u2440', '\u244a'), ('\u249c', '\u24e9'), ('\u2500', '\u25b6'),
        ('\u25b8', '\u25c0'), ('\u25c2', '\u25f7'), ('\u2600', '\u266e'), ('\u2670', '\u2767'),
        ('\u2794', '\u27bf'), ('\u2800', '\u28ff'), ('\u2b00', '\u2b2f'), ('\u2b45', '\u2b46'),
        ('\u2b4d', '\u2b73'), ('\u2b76', '\u2b95'), ('\u2b98', '\u2bb9'), ('\u2bbd', '\u2bc8'),
        ('\u2bca', '\u2bd1'), ('\u2ce5', '\u2cea'), ('\u2e80', '\u2e99'), ('\u2e9b', '\u2ef3'),
        ('\u2f00', '\u2fd5'), ('\u2ff0', '\u2ffb'), ('\u3004', '\u3004'), ('\u3012', '\u3013'),
        ('\u3020', '\u3020'), ('\u3036', '\u3037'), ('\u303e', '\u303f'), ('\u3190', '\u3191'),
        ('\u3196', '\u319f'), ('\u31c0', '\u31e3'), ('\u3200', '\u321e'), ('\u322a', '\u3247'),
        ('\u3250', '\u3250'), ('\u3260', '\u327f'), ('\u328a', '\u32b0'), ('\u32c0', '\u32fe'),
        ('\u3300', '\u33ff'), ('\u4dc0', '\u4dff'), ('\ua490', '\ua4c6'), ('\ua828', '\ua82b'),
        ('\ua836', '\ua837'), ('\ua839', '\ua839'), ('\uaa77', '\uaa79'), ('\ufdfd', '\ufdfd'),
        ('\uffe4', '\uffe4'), ('\uffe8', '\uffe8'), ('\uffed', '\uffee'), ('\ufffc', '\ufffd'),
        ('\U00010137', '\U0001013f'), ('\U00010179', '\U00010189'), ('\U0001018c', '\U0001018c'),
        ('\U00010190', '\U0001019b'), ('\U000101a0', '\U000101a0'), ('\U000101d0', '\U000101fc'),
        ('\U00010877', '\U00010878'), ('\U00010ac8', '\U00010ac8'), ('\U00016b3c', '\U00016b3f'),
        ('\U00016b45', '\U00016b45'), ('\U0001bc9c', '\U0001bc9c'), ('\U0001d000', '\U0001d0f5'),
        ('\U0001d100', '\U0001d126'), ('\U0001d129', '\U0001d164'), ('\U0001d16a', '\U0001d16c'),
        ('\U0001d183', '\U0001d184'), ('\U0001d18c', '\U0001d1a9'), ('\U0001d1ae', '\U0001d1dd'),
        ('\U0001d200', '\U0001d241'), ('\U0001d245', '\U0001d245'), ('\U0001d300', '\U0001d356'),
        ('\U0001f000', '\U0001f02b'), ('\U0001f030', '\U0001f093'), ('\U0001f0a0', '\U0001f0ae'),
        ('\U0001f0b1', '\U0001f0bf'), ('\U0001f0c1', '\U0001f0cf'), ('\U0001f0d1', '\U0001f0f5'),
        ('\U0001f110', '\U0001f12e'), ('\U0001f130', '\U0001f16b'), ('\U0001f170', '\U0001f19a'),
        ('\U0001f1e6', '\U0001f202'), ('\U0001f210', '\U0001f23a'), ('\U0001f240', '\U0001f248'),
        ('\U0001f250', '\U0001f251'), ('\U0001f300', '\U0001f32c'), ('\U0001f330', '\U0001f37d'),
        ('\U0001f380', '\U0001f3ce'), ('\U0001f3d4', '\U0001f3f7'), ('\U0001f400', '\U0001f4fe'),
        ('\U0001f500', '\U0001f54a'), ('\U0001f550', '\U0001f579'), ('\U0001f57b', '\U0001f5a3'),
        ('\U0001f5a5', '\U0001f642'), ('\U0001f645', '\U0001f6cf'), ('\U0001f6e0', '\U0001f6ec'),
        ('\U0001f6f0', '\U0001f6f3'), ('\U0001f700', '\U0001f773'), ('\U0001f780', '\U0001f7d4'),
        ('\U0001f800', '\U0001f80b'), ('\U0001f810', '\U0001f847'), ('\U0001f850', '\U0001f859'),
        ('\U0001f860', '\U0001f887'), ('\U0001f890', '\U0001f8ad')
    ];

    pub static Z_table: &'static [(char, char)] = &[
        ('\x20', '\x20'), ('\u00a0', '\u00a0'), ('\u1680', '\u1680'), ('\u2000', '\u200a'),
        ('\u2028', '\u2029'), ('\u202f', '\u202f'), ('\u205f', '\u205f'), ('\u3000', '\u3000')
    ];

    pub static Zl_table: &'static [(char, char)] = &[
        ('\u2028', '\u2028')
    ];

    pub static Zp_table: &'static [(char, char)] = &[
        ('\u2029', '\u2029')
    ];

    pub static Zs_table: &'static [(char, char)] = &[
        ('\x20', '\x20'), ('\u00a0', '\u00a0'), ('\u1680', '\u1680'), ('\u2000', '\u200a'),
        ('\u202f', '\u202f'), ('\u205f', '\u205f'), ('\u3000', '\u3000')
    ];

}

pub mod derived_property {
    pub static Alphabetic_table: &'static [(char, char)] = &[
        ('\x41', '\x5a'), ('\x61', '\x7a'), ('\u00aa', '\u00aa'), ('\u00b5', '\u00b5'), ('\u00ba',
        '\u00ba'), ('\u00c0', '\u00d6'), ('\u00d8', '\u00f6'), ('\u00f8', '\u01ba'), ('\u01bb',
        '\u01bb'), ('\u01bc', '\u01bf'), ('\u01c0', '\u01c3'), ('\u01c4', '\u0293'), ('\u0294',
        '\u0294'), ('\u0295', '\u02af'), ('\u02b0', '\u02c1'), ('\u02c6', '\u02d1'), ('\u02e0',
        '\u02e4'), ('\u02ec', '\u02ec'), ('\u02ee', '\u02ee'), ('\u0345', '\u0345'), ('\u0370',
        '\u0373'), ('\u0374', '\u0374'), ('\u0376', '\u0377'), ('\u037a', '\u037a'), ('\u037b',
        '\u037d'), ('\u037f', '\u037f'), ('\u0386', '\u0386'), ('\u0388', '\u038a'), ('\u038c',
        '\u038c'), ('\u038e', '\u03a1'), ('\u03a3', '\u03f5'), ('\u03f7', '\u0481'), ('\u048a',
        '\u052f'), ('\u0531', '\u0556'), ('\u0559', '\u0559'), ('\u0561', '\u0587'), ('\u05b0',
        '\u05bd'), ('\u05bf', '\u05bf'), ('\u05c1', '\u05c2'), ('\u05c4', '\u05c5'), ('\u05c7',
        '\u05c7'), ('\u05d0', '\u05ea'), ('\u05f0', '\u05f2'), ('\u0610', '\u061a'), ('\u0620',
        '\u063f'), ('\u0640', '\u0640'), ('\u0641', '\u064a'), ('\u064b', '\u0657'), ('\u0659',
        '\u065f'), ('\u066e', '\u066f'), ('\u0670', '\u0670'), ('\u0671', '\u06d3'), ('\u06d5',
        '\u06d5'), ('\u06d6', '\u06dc'), ('\u06e1', '\u06e4'), ('\u06e5', '\u06e6'), ('\u06e7',
        '\u06e8'), ('\u06ed', '\u06ed'), ('\u06ee', '\u06ef'), ('\u06fa', '\u06fc'), ('\u06ff',
        '\u06ff'), ('\u0710', '\u0710'), ('\u0711', '\u0711'), ('\u0712', '\u072f'), ('\u0730',
        '\u073f'), ('\u074d', '\u07a5'), ('\u07a6', '\u07b0'), ('\u07b1', '\u07b1'), ('\u07ca',
        '\u07ea'), ('\u07f4', '\u07f5'), ('\u07fa', '\u07fa'), ('\u0800', '\u0815'), ('\u0816',
        '\u0817'), ('\u081a', '\u081a'), ('\u081b', '\u0823'), ('\u0824', '\u0824'), ('\u0825',
        '\u0827'), ('\u0828', '\u0828'), ('\u0829', '\u082c'), ('\u0840', '\u0858'), ('\u08a0',
        '\u08b2'), ('\u08e4', '\u08e9'), ('\u08f0', '\u0902'), ('\u0903', '\u0903'), ('\u0904',
        '\u0939'), ('\u093a', '\u093a'), ('\u093b', '\u093b'), ('\u093d', '\u093d'), ('\u093e',
        '\u0940'), ('\u0941', '\u0948'), ('\u0949', '\u094c'), ('\u094e', '\u094f'), ('\u0950',
        '\u0950'), ('\u0955', '\u0957'), ('\u0958', '\u0961'), ('\u0962', '\u0963'), ('\u0971',
        '\u0971'), ('\u0972', '\u0980'), ('\u0981', '\u0981'), ('\u0982', '\u0983'), ('\u0985',
        '\u098c'), ('\u098f', '\u0990'), ('\u0993', '\u09a8'), ('\u09aa', '\u09b0'), ('\u09b2',
        '\u09b2'), ('\u09b6', '\u09b9'), ('\u09bd', '\u09bd'), ('\u09be', '\u09c0'), ('\u09c1',
        '\u09c4'), ('\u09c7', '\u09c8'), ('\u09cb', '\u09cc'), ('\u09ce', '\u09ce'), ('\u09d7',
        '\u09d7'), ('\u09dc', '\u09dd'), ('\u09df', '\u09e1'), ('\u09e2', '\u09e3'), ('\u09f0',
        '\u09f1'), ('\u0a01', '\u0a02'), ('\u0a03', '\u0a03'), ('\u0a05', '\u0a0a'), ('\u0a0f',
        '\u0a10'), ('\u0a13', '\u0a28'), ('\u0a2a', '\u0a30'), ('\u0a32', '\u0a33'), ('\u0a35',
        '\u0a36'), ('\u0a38', '\u0a39'), ('\u0a3e', '\u0a40'), ('\u0a41', '\u0a42'), ('\u0a47',
        '\u0a48'), ('\u0a4b', '\u0a4c'), ('\u0a51', '\u0a51'), ('\u0a59', '\u0a5c'), ('\u0a5e',
        '\u0a5e'), ('\u0a70', '\u0a71'), ('\u0a72', '\u0a74'), ('\u0a75', '\u0a75'), ('\u0a81',
        '\u0a82'), ('\u0a83', '\u0a83'), ('\u0a85', '\u0a8d'), ('\u0a8f', '\u0a91'), ('\u0a93',
        '\u0aa8'), ('\u0aaa', '\u0ab0'), ('\u0ab2', '\u0ab3'), ('\u0ab5', '\u0ab9'), ('\u0abd',
        '\u0abd'), ('\u0abe', '\u0ac0'), ('\u0ac1', '\u0ac5'), ('\u0ac7', '\u0ac8'), ('\u0ac9',
        '\u0ac9'), ('\u0acb', '\u0acc'), ('\u0ad0', '\u0ad0'), ('\u0ae0', '\u0ae1'), ('\u0ae2',
        '\u0ae3'), ('\u0b01', '\u0b01'), ('\u0b02', '\u0b03'), ('\u0b05', '\u0b0c'), ('\u0b0f',
        '\u0b10'), ('\u0b13', '\u0b28'), ('\u0b2a', '\u0b30'), ('\u0b32', '\u0b33'), ('\u0b35',
        '\u0b39'), ('\u0b3d', '\u0b3d'), ('\u0b3e', '\u0b3e'), ('\u0b3f', '\u0b3f'), ('\u0b40',
        '\u0b40'), ('\u0b41', '\u0b44'), ('\u0b47', '\u0b48'), ('\u0b4b', '\u0b4c'), ('\u0b56',
        '\u0b56'), ('\u0b57', '\u0b57'), ('\u0b5c', '\u0b5d'), ('\u0b5f', '\u0b61'), ('\u0b62',
        '\u0b63'), ('\u0b71', '\u0b71'), ('\u0b82', '\u0b82'), ('\u0b83', '\u0b83'), ('\u0b85',
        '\u0b8a'), ('\u0b8e', '\u0b90'), ('\u0b92', '\u0b95'), ('\u0b99', '\u0b9a'), ('\u0b9c',
        '\u0b9c'), ('\u0b9e', '\u0b9f'), ('\u0ba3', '\u0ba4'), ('\u0ba8', '\u0baa'), ('\u0bae',
        '\u0bb9'), ('\u0bbe', '\u0bbf'), ('\u0bc0', '\u0bc0'), ('\u0bc1', '\u0bc2'), ('\u0bc6',
        '\u0bc8'), ('\u0bca', '\u0bcc'), ('\u0bd0', '\u0bd0'), ('\u0bd7', '\u0bd7'), ('\u0c00',
        '\u0c00'), ('\u0c01', '\u0c03'), ('\u0c05', '\u0c0c'), ('\u0c0e', '\u0c10'), ('\u0c12',
        '\u0c28'), ('\u0c2a', '\u0c39'), ('\u0c3d', '\u0c3d'), ('\u0c3e', '\u0c40'), ('\u0c41',
        '\u0c44'), ('\u0c46', '\u0c48'), ('\u0c4a', '\u0c4c'), ('\u0c55', '\u0c56'), ('\u0c58',
        '\u0c59'), ('\u0c60', '\u0c61'), ('\u0c62', '\u0c63'), ('\u0c81', '\u0c81'), ('\u0c82',
        '\u0c83'), ('\u0c85', '\u0c8c'), ('\u0c8e', '\u0c90'), ('\u0c92', '\u0ca8'), ('\u0caa',
        '\u0cb3'), ('\u0cb5', '\u0cb9'), ('\u0cbd', '\u0cbd'), ('\u0cbe', '\u0cbe'), ('\u0cbf',
        '\u0cbf'), ('\u0cc0', '\u0cc4'), ('\u0cc6', '\u0cc6'), ('\u0cc7', '\u0cc8'), ('\u0cca',
        '\u0ccb'), ('\u0ccc', '\u0ccc'), ('\u0cd5', '\u0cd6'), ('\u0cde', '\u0cde'), ('\u0ce0',
        '\u0ce1'), ('\u0ce2', '\u0ce3'), ('\u0cf1', '\u0cf2'), ('\u0d01', '\u0d01'), ('\u0d02',
        '\u0d03'), ('\u0d05', '\u0d0c'), ('\u0d0e', '\u0d10'), ('\u0d12', '\u0d3a'), ('\u0d3d',
        '\u0d3d'), ('\u0d3e', '\u0d40'), ('\u0d41', '\u0d44'), ('\u0d46', '\u0d48'), ('\u0d4a',
        '\u0d4c'), ('\u0d4e', '\u0d4e'), ('\u0d57', '\u0d57'), ('\u0d60', '\u0d61'), ('\u0d62',
        '\u0d63'), ('\u0d7a', '\u0d7f'), ('\u0d82', '\u0d83'), ('\u0d85', '\u0d96'), ('\u0d9a',
        '\u0db1'), ('\u0db3', '\u0dbb'), ('\u0dbd', '\u0dbd'), ('\u0dc0', '\u0dc6'), ('\u0dcf',
        '\u0dd1'), ('\u0dd2', '\u0dd4'), ('\u0dd6', '\u0dd6'), ('\u0dd8', '\u0ddf'), ('\u0df2',
        '\u0df3'), ('\u0e01', '\u0e30'), ('\u0e31', '\u0e31'), ('\u0e32', '\u0e33'), ('\u0e34',
        '\u0e3a'), ('\u0e40', '\u0e45'), ('\u0e46', '\u0e46'), ('\u0e4d', '\u0e4d'), ('\u0e81',
        '\u0e82'), ('\u0e84', '\u0e84'), ('\u0e87', '\u0e88'), ('\u0e8a', '\u0e8a'), ('\u0e8d',
        '\u0e8d'), ('\u0e94', '\u0e97'), ('\u0e99', '\u0e9f'), ('\u0ea1', '\u0ea3'), ('\u0ea5',
        '\u0ea5'), ('\u0ea7', '\u0ea7'), ('\u0eaa', '\u0eab'), ('\u0ead', '\u0eb0'), ('\u0eb1',
        '\u0eb1'), ('\u0eb2', '\u0eb3'), ('\u0eb4', '\u0eb9'), ('\u0ebb', '\u0ebc'), ('\u0ebd',
        '\u0ebd'), ('\u0ec0', '\u0ec4'), ('\u0ec6', '\u0ec6'), ('\u0ecd', '\u0ecd'), ('\u0edc',
        '\u0edf'), ('\u0f00', '\u0f00'), ('\u0f40', '\u0f47'), ('\u0f49', '\u0f6c'), ('\u0f71',
        '\u0f7e'), ('\u0f7f', '\u0f7f'), ('\u0f80', '\u0f81'), ('\u0f88', '\u0f8c'), ('\u0f8d',
        '\u0f97'), ('\u0f99', '\u0fbc'), ('\u1000', '\u102a'), ('\u102b', '\u102c'), ('\u102d',
        '\u1030'), ('\u1031', '\u1031'), ('\u1032', '\u1036'), ('\u1038', '\u1038'), ('\u103b',
        '\u103c'), ('\u103d', '\u103e'), ('\u103f', '\u103f'), ('\u1050', '\u1055'), ('\u1056',
        '\u1057'), ('\u1058', '\u1059'), ('\u105a', '\u105d'), ('\u105e', '\u1060'), ('\u1061',
        '\u1061'), ('\u1062', '\u1062'), ('\u1065', '\u1066'), ('\u1067', '\u1068'), ('\u106e',
        '\u1070'), ('\u1071', '\u1074'), ('\u1075', '\u1081'), ('\u1082', '\u1082'), ('\u1083',
        '\u1084'), ('\u1085', '\u1086'), ('\u108e', '\u108e'), ('\u109c', '\u109c'), ('\u109d',
        '\u109d'), ('\u10a0', '\u10c5'), ('\u10c7', '\u10c7'), ('\u10cd', '\u10cd'), ('\u10d0',
        '\u10fa'), ('\u10fc', '\u10fc'), ('\u10fd', '\u1248'), ('\u124a', '\u124d'), ('\u1250',
        '\u1256'), ('\u1258', '\u1258'), ('\u125a', '\u125d'), ('\u1260', '\u1288'), ('\u128a',
        '\u128d'), ('\u1290', '\u12b0'), ('\u12b2', '\u12b5'), ('\u12b8', '\u12be'), ('\u12c0',
        '\u12c0'), ('\u12c2', '\u12c5'), ('\u12c8', '\u12d6'), ('\u12d8', '\u1310'), ('\u1312',
        '\u1315'), ('\u1318', '\u135a'), ('\u135f', '\u135f'), ('\u1380', '\u138f'), ('\u13a0',
        '\u13f4'), ('\u1401', '\u166c'), ('\u166f', '\u167f'), ('\u1681', '\u169a'), ('\u16a0',
        '\u16ea'), ('\u16ee', '\u16f0'), ('\u16f1', '\u16f8'), ('\u1700', '\u170c'), ('\u170e',
        '\u1711'), ('\u1712', '\u1713'), ('\u1720', '\u1731'), ('\u1732', '\u1733'), ('\u1740',
        '\u1751'), ('\u1752', '\u1753'), ('\u1760', '\u176c'), ('\u176e', '\u1770'), ('\u1772',
        '\u1773'), ('\u1780', '\u17b3'), ('\u17b6', '\u17b6'), ('\u17b7', '\u17bd'), ('\u17be',
        '\u17c5'), ('\u17c6', '\u17c6'), ('\u17c7', '\u17c8'), ('\u17d7', '\u17d7'), ('\u17dc',
        '\u17dc'), ('\u1820', '\u1842'), ('\u1843', '\u1843'), ('\u1844', '\u1877'), ('\u1880',
        '\u18a8'), ('\u18a9', '\u18a9'), ('\u18aa', '\u18aa'), ('\u18b0', '\u18f5'), ('\u1900',
        '\u191e'), ('\u1920', '\u1922'), ('\u1923', '\u1926'), ('\u1927', '\u1928'), ('\u1929',
        '\u192b'), ('\u1930', '\u1931'), ('\u1932', '\u1932'), ('\u1933', '\u1938'), ('\u1950',
        '\u196d'), ('\u1970', '\u1974'), ('\u1980', '\u19ab'), ('\u19b0', '\u19c0'), ('\u19c1',
        '\u19c7'), ('\u19c8', '\u19c9'), ('\u1a00', '\u1a16'), ('\u1a17', '\u1a18'), ('\u1a19',
        '\u1a1a'), ('\u1a1b', '\u1a1b'), ('\u1a20', '\u1a54'), ('\u1a55', '\u1a55'), ('\u1a56',
        '\u1a56'), ('\u1a57', '\u1a57'), ('\u1a58', '\u1a5e'), ('\u1a61', '\u1a61'), ('\u1a62',
        '\u1a62'), ('\u1a63', '\u1a64'), ('\u1a65', '\u1a6c'), ('\u1a6d', '\u1a72'), ('\u1a73',
        '\u1a74'), ('\u1aa7', '\u1aa7'), ('\u1b00', '\u1b03'), ('\u1b04', '\u1b04'), ('\u1b05',
        '\u1b33'), ('\u1b35', '\u1b35'), ('\u1b36', '\u1b3a'), ('\u1b3b', '\u1b3b'), ('\u1b3c',
        '\u1b3c'), ('\u1b3d', '\u1b41'), ('\u1b42', '\u1b42'), ('\u1b43', '\u1b43'), ('\u1b45',
        '\u1b4b'), ('\u1b80', '\u1b81'), ('\u1b82', '\u1b82'), ('\u1b83', '\u1ba0'), ('\u1ba1',
        '\u1ba1'), ('\u1ba2', '\u1ba5'), ('\u1ba6', '\u1ba7'), ('\u1ba8', '\u1ba9'), ('\u1bac',
        '\u1bad'), ('\u1bae', '\u1baf'), ('\u1bba', '\u1be5'), ('\u1be7', '\u1be7'), ('\u1be8',
        '\u1be9'), ('\u1bea', '\u1bec'), ('\u1bed', '\u1bed'), ('\u1bee', '\u1bee'), ('\u1bef',
        '\u1bf1'), ('\u1c00', '\u1c23'), ('\u1c24', '\u1c2b'), ('\u1c2c', '\u1c33'), ('\u1c34',
        '\u1c35'), ('\u1c4d', '\u1c4f'), ('\u1c5a', '\u1c77'), ('\u1c78', '\u1c7d'), ('\u1ce9',
        '\u1cec'), ('\u1cee', '\u1cf1'), ('\u1cf2', '\u1cf3'), ('\u1cf5', '\u1cf6'), ('\u1d00',
        '\u1d2b'), ('\u1d2c', '\u1d6a'), ('\u1d6b', '\u1d77'), ('\u1d78', '\u1d78'), ('\u1d79',
        '\u1d9a'), ('\u1d9b', '\u1dbf'), ('\u1de7', '\u1df4'), ('\u1e00', '\u1f15'), ('\u1f18',
        '\u1f1d'), ('\u1f20', '\u1f45'), ('\u1f48', '\u1f4d'), ('\u1f50', '\u1f57'), ('\u1f59',
        '\u1f59'), ('\u1f5b', '\u1f5b'), ('\u1f5d', '\u1f5d'), ('\u1f5f', '\u1f7d'), ('\u1f80',
        '\u1fb4'), ('\u1fb6', '\u1fbc'), ('\u1fbe', '\u1fbe'), ('\u1fc2', '\u1fc4'), ('\u1fc6',
        '\u1fcc'), ('\u1fd0', '\u1fd3'), ('\u1fd6', '\u1fdb'), ('\u1fe0', '\u1fec'), ('\u1ff2',
        '\u1ff4'), ('\u1ff6', '\u1ffc'), ('\u2071', '\u2071'), ('\u207f', '\u207f'), ('\u2090',
        '\u209c'), ('\u2102', '\u2102'), ('\u2107', '\u2107'), ('\u210a', '\u2113'), ('\u2115',
        '\u2115'), ('\u2119', '\u211d'), ('\u2124', '\u2124'), ('\u2126', '\u2126'), ('\u2128',
        '\u2128'), ('\u212a', '\u212d'), ('\u212f', '\u2134'), ('\u2135', '\u2138'), ('\u2139',
        '\u2139'), ('\u213c', '\u213f'), ('\u2145', '\u2149'), ('\u214e', '\u214e'), ('\u2160',
        '\u2182'), ('\u2183', '\u2184'), ('\u2185', '\u2188'), ('\u24b6', '\u24e9'), ('\u2c00',
        '\u2c2e'), ('\u2c30', '\u2c5e'), ('\u2c60', '\u2c7b'), ('\u2c7c', '\u2c7d'), ('\u2c7e',
        '\u2ce4'), ('\u2ceb', '\u2cee'), ('\u2cf2', '\u2cf3'), ('\u2d00', '\u2d25'), ('\u2d27',
        '\u2d27'), ('\u2d2d', '\u2d2d'), ('\u2d30', '\u2d67'), ('\u2d6f', '\u2d6f'), ('\u2d80',
        '\u2d96'), ('\u2da0', '\u2da6'), ('\u2da8', '\u2dae'), ('\u2db0', '\u2db6'), ('\u2db8',
        '\u2dbe'), ('\u2dc0', '\u2dc6'), ('\u2dc8', '\u2dce'), ('\u2dd0', '\u2dd6'), ('\u2dd8',
        '\u2dde'), ('\u2de0', '\u2dff'), ('\u2e2f', '\u2e2f'), ('\u3005', '\u3005'), ('\u3006',
        '\u3006'), ('\u3007', '\u3007'), ('\u3021', '\u3029'), ('\u3031', '\u3035'), ('\u3038',
        '\u303a'), ('\u303b', '\u303b'), ('\u303c', '\u303c'), ('\u3041', '\u3096'), ('\u309d',
        '\u309e'), ('\u309f', '\u309f'), ('\u30a1', '\u30fa'), ('\u30fc', '\u30fe'), ('\u30ff',
        '\u30ff'), ('\u3105', '\u312d'), ('\u3131', '\u318e'), ('\u31a0', '\u31ba'), ('\u31f0',
        '\u31ff'), ('\u3400', '\u4db5'), ('\u4e00', '\u9fcc'), ('\ua000', '\ua014'), ('\ua015',
        '\ua015'), ('\ua016', '\ua48c'), ('\ua4d0', '\ua4f7'), ('\ua4f8', '\ua4fd'), ('\ua500',
        '\ua60b'), ('\ua60c', '\ua60c'), ('\ua610', '\ua61f'), ('\ua62a', '\ua62b'), ('\ua640',
        '\ua66d'), ('\ua66e', '\ua66e'), ('\ua674', '\ua67b'), ('\ua67f', '\ua67f'), ('\ua680',
        '\ua69b'), ('\ua69c', '\ua69d'), ('\ua69f', '\ua69f'), ('\ua6a0', '\ua6e5'), ('\ua6e6',
        '\ua6ef'), ('\ua717', '\ua71f'), ('\ua722', '\ua76f'), ('\ua770', '\ua770'), ('\ua771',
        '\ua787'), ('\ua788', '\ua788'), ('\ua78b', '\ua78e'), ('\ua790', '\ua7ad'), ('\ua7b0',
        '\ua7b1'), ('\ua7f7', '\ua7f7'), ('\ua7f8', '\ua7f9'), ('\ua7fa', '\ua7fa'), ('\ua7fb',
        '\ua801'), ('\ua803', '\ua805'), ('\ua807', '\ua80a'), ('\ua80c', '\ua822'), ('\ua823',
        '\ua824'), ('\ua825', '\ua826'), ('\ua827', '\ua827'), ('\ua840', '\ua873'), ('\ua880',
        '\ua881'), ('\ua882', '\ua8b3'), ('\ua8b4', '\ua8c3'), ('\ua8f2', '\ua8f7'), ('\ua8fb',
        '\ua8fb'), ('\ua90a', '\ua925'), ('\ua926', '\ua92a'), ('\ua930', '\ua946'), ('\ua947',
        '\ua951'), ('\ua952', '\ua952'), ('\ua960', '\ua97c'), ('\ua980', '\ua982'), ('\ua983',
        '\ua983'), ('\ua984', '\ua9b2'), ('\ua9b4', '\ua9b5'), ('\ua9b6', '\ua9b9'), ('\ua9ba',
        '\ua9bb'), ('\ua9bc', '\ua9bc'), ('\ua9bd', '\ua9bf'), ('\ua9cf', '\ua9cf'), ('\ua9e0',
        '\ua9e4'), ('\ua9e6', '\ua9e6'), ('\ua9e7', '\ua9ef'), ('\ua9fa', '\ua9fe'), ('\uaa00',
        '\uaa28'), ('\uaa29', '\uaa2e'), ('\uaa2f', '\uaa30'), ('\uaa31', '\uaa32'), ('\uaa33',
        '\uaa34'), ('\uaa35', '\uaa36'), ('\uaa40', '\uaa42'), ('\uaa43', '\uaa43'), ('\uaa44',
        '\uaa4b'), ('\uaa4c', '\uaa4c'), ('\uaa4d', '\uaa4d'), ('\uaa60', '\uaa6f'), ('\uaa70',
        '\uaa70'), ('\uaa71', '\uaa76'), ('\uaa7a', '\uaa7a'), ('\uaa7e', '\uaaaf'), ('\uaab0',
        '\uaab0'), ('\uaab1', '\uaab1'), ('\uaab2', '\uaab4'), ('\uaab5', '\uaab6'), ('\uaab7',
        '\uaab8'), ('\uaab9', '\uaabd'), ('\uaabe', '\uaabe'), ('\uaac0', '\uaac0'), ('\uaac2',
        '\uaac2'), ('\uaadb', '\uaadc'), ('\uaadd', '\uaadd'), ('\uaae0', '\uaaea'), ('\uaaeb',
        '\uaaeb'), ('\uaaec', '\uaaed'), ('\uaaee', '\uaaef'), ('\uaaf2', '\uaaf2'), ('\uaaf3',
        '\uaaf4'), ('\uaaf5', '\uaaf5'), ('\uab01', '\uab06'), ('\uab09', '\uab0e'), ('\uab11',
        '\uab16'), ('\uab20', '\uab26'), ('\uab28', '\uab2e'), ('\uab30', '\uab5a'), ('\uab5c',
        '\uab5f'), ('\uab64', '\uab65'), ('\uabc0', '\uabe2'), ('\uabe3', '\uabe4'), ('\uabe5',
        '\uabe5'), ('\uabe6', '\uabe7'), ('\uabe8', '\uabe8'), ('\uabe9', '\uabea'), ('\uac00',
        '\ud7a3'), ('\ud7b0', '\ud7c6'), ('\ud7cb', '\ud7fb'), ('\uf900', '\ufa6d'), ('\ufa70',
        '\ufad9'), ('\ufb00', '\ufb06'), ('\ufb13', '\ufb17'), ('\ufb1d', '\ufb1d'), ('\ufb1e',
        '\ufb1e'), ('\ufb1f', '\ufb28'), ('\ufb2a', '\ufb36'), ('\ufb38', '\ufb3c'), ('\ufb3e',
        '\ufb3e'), ('\ufb40', '\ufb41'), ('\ufb43', '\ufb44'), ('\ufb46', '\ufbb1'), ('\ufbd3',
        '\ufd3d'), ('\ufd50', '\ufd8f'), ('\ufd92', '\ufdc7'), ('\ufdf0', '\ufdfb'), ('\ufe70',
        '\ufe74'), ('\ufe76', '\ufefc'), ('\uff21', '\uff3a'), ('\uff41', '\uff5a'), ('\uff66',
        '\uff6f'), ('\uff70', '\uff70'), ('\uff71', '\uff9d'), ('\uff9e', '\uff9f'), ('\uffa0',
        '\uffbe'), ('\uffc2', '\uffc7'), ('\uffca', '\uffcf'), ('\uffd2', '\uffd7'), ('\uffda',
        '\uffdc'), ('\U00010000', '\U0001000b'), ('\U0001000d', '\U00010026'), ('\U00010028',
        '\U0001003a'), ('\U0001003c', '\U0001003d'), ('\U0001003f', '\U0001004d'), ('\U00010050',
        '\U0001005d'), ('\U00010080', '\U000100fa'), ('\U00010140', '\U00010174'), ('\U00010280',
        '\U0001029c'), ('\U000102a0', '\U000102d0'), ('\U00010300', '\U0001031f'), ('\U00010330',
        '\U00010340'), ('\U00010341', '\U00010341'), ('\U00010342', '\U00010349'), ('\U0001034a',
        '\U0001034a'), ('\U00010350', '\U00010375'), ('\U00010376', '\U0001037a'), ('\U00010380',
        '\U0001039d'), ('\U000103a0', '\U000103c3'), ('\U000103c8', '\U000103cf'), ('\U000103d1',
        '\U000103d5'), ('\U00010400', '\U0001044f'), ('\U00010450', '\U0001049d'), ('\U00010500',
        '\U00010527'), ('\U00010530', '\U00010563'), ('\U00010600', '\U00010736'), ('\U00010740',
        '\U00010755'), ('\U00010760', '\U00010767'), ('\U00010800', '\U00010805'), ('\U00010808',
        '\U00010808'), ('\U0001080a', '\U00010835'), ('\U00010837', '\U00010838'), ('\U0001083c',
        '\U0001083c'), ('\U0001083f', '\U00010855'), ('\U00010860', '\U00010876'), ('\U00010880',
        '\U0001089e'), ('\U00010900', '\U00010915'), ('\U00010920', '\U00010939'), ('\U00010980',
        '\U000109b7'), ('\U000109be', '\U000109bf'), ('\U00010a00', '\U00010a00'), ('\U00010a01',
        '\U00010a03'), ('\U00010a05', '\U00010a06'), ('\U00010a0c', '\U00010a0f'), ('\U00010a10',
        '\U00010a13'), ('\U00010a15', '\U00010a17'), ('\U00010a19', '\U00010a33'), ('\U00010a60',
        '\U00010a7c'), ('\U00010a80', '\U00010a9c'), ('\U00010ac0', '\U00010ac7'), ('\U00010ac9',
        '\U00010ae4'), ('\U00010b00', '\U00010b35'), ('\U00010b40', '\U00010b55'), ('\U00010b60',
        '\U00010b72'), ('\U00010b80', '\U00010b91'), ('\U00010c00', '\U00010c48'), ('\U00011000',
        '\U00011000'), ('\U00011001', '\U00011001'), ('\U00011002', '\U00011002'), ('\U00011003',
        '\U00011037'), ('\U00011038', '\U00011045'), ('\U00011082', '\U00011082'), ('\U00011083',
        '\U000110af'), ('\U000110b0', '\U000110b2'), ('\U000110b3', '\U000110b6'), ('\U000110b7',
        '\U000110b8'), ('\U000110d0', '\U000110e8'), ('\U00011100', '\U00011102'), ('\U00011103',
        '\U00011126'), ('\U00011127', '\U0001112b'), ('\U0001112c', '\U0001112c'), ('\U0001112d',
        '\U00011132'), ('\U00011150', '\U00011172'), ('\U00011176', '\U00011176'), ('\U00011180',
        '\U00011181'), ('\U00011182', '\U00011182'), ('\U00011183', '\U000111b2'), ('\U000111b3',
        '\U000111b5'), ('\U000111b6', '\U000111be'), ('\U000111bf', '\U000111bf'), ('\U000111c1',
        '\U000111c4'), ('\U000111da', '\U000111da'), ('\U00011200', '\U00011211'), ('\U00011213',
        '\U0001122b'), ('\U0001122c', '\U0001122e'), ('\U0001122f', '\U00011231'), ('\U00011232',
        '\U00011233'), ('\U00011234', '\U00011234'), ('\U00011237', '\U00011237'), ('\U000112b0',
        '\U000112de'), ('\U000112df', '\U000112df'), ('\U000112e0', '\U000112e2'), ('\U000112e3',
        '\U000112e8'), ('\U00011301', '\U00011301'), ('\U00011302', '\U00011303'), ('\U00011305',
        '\U0001130c'), ('\U0001130f', '\U00011310'), ('\U00011313', '\U00011328'), ('\U0001132a',
        '\U00011330'), ('\U00011332', '\U00011333'), ('\U00011335', '\U00011339'), ('\U0001133d',
        '\U0001133d'), ('\U0001133e', '\U0001133f'), ('\U00011340', '\U00011340'), ('\U00011341',
        '\U00011344'), ('\U00011347', '\U00011348'), ('\U0001134b', '\U0001134c'), ('\U00011357',
        '\U00011357'), ('\U0001135d', '\U00011361'), ('\U00011362', '\U00011363'), ('\U00011480',
        '\U000114af'), ('\U000114b0', '\U000114b2'), ('\U000114b3', '\U000114b8'), ('\U000114b9',
        '\U000114b9'), ('\U000114ba', '\U000114ba'), ('\U000114bb', '\U000114be'), ('\U000114bf',
        '\U000114c0'), ('\U000114c1', '\U000114c1'), ('\U000114c4', '\U000114c5'), ('\U000114c7',
        '\U000114c7'), ('\U00011580', '\U000115ae'), ('\U000115af', '\U000115b1'), ('\U000115b2',
        '\U000115b5'), ('\U000115b8', '\U000115bb'), ('\U000115bc', '\U000115bd'), ('\U000115be',
        '\U000115be'), ('\U00011600', '\U0001162f'), ('\U00011630', '\U00011632'), ('\U00011633',
        '\U0001163a'), ('\U0001163b', '\U0001163c'), ('\U0001163d', '\U0001163d'), ('\U0001163e',
        '\U0001163e'), ('\U00011640', '\U00011640'), ('\U00011644', '\U00011644'), ('\U00011680',
        '\U000116aa'), ('\U000116ab', '\U000116ab'), ('\U000116ac', '\U000116ac'), ('\U000116ad',
        '\U000116ad'), ('\U000116ae', '\U000116af'), ('\U000116b0', '\U000116b5'), ('\U000118a0',
        '\U000118df'), ('\U000118ff', '\U000118ff'), ('\U00011ac0', '\U00011af8'), ('\U00012000',
        '\U00012398'), ('\U00012400', '\U0001246e'), ('\U00013000', '\U0001342e'), ('\U00016800',
        '\U00016a38'), ('\U00016a40', '\U00016a5e'), ('\U00016ad0', '\U00016aed'), ('\U00016b00',
        '\U00016b2f'), ('\U00016b30', '\U00016b36'), ('\U00016b40', '\U00016b43'), ('\U00016b63',
        '\U00016b77'), ('\U00016b7d', '\U00016b8f'), ('\U00016f00', '\U00016f44'), ('\U00016f50',
        '\U00016f50'), ('\U00016f51', '\U00016f7e'), ('\U00016f93', '\U00016f9f'), ('\U0001b000',
        '\U0001b001'), ('\U0001bc00', '\U0001bc6a'), ('\U0001bc70', '\U0001bc7c'), ('\U0001bc80',
        '\U0001bc88'), ('\U0001bc90', '\U0001bc99'), ('\U0001bc9e', '\U0001bc9e'), ('\U0001d400',
        '\U0001d454'), ('\U0001d456', '\U0001d49c'), ('\U0001d49e', '\U0001d49f'), ('\U0001d4a2',
        '\U0001d4a2'), ('\U0001d4a5', '\U0001d4a6'), ('\U0001d4a9', '\U0001d4ac'), ('\U0001d4ae',
        '\U0001d4b9'), ('\U0001d4bb', '\U0001d4bb'), ('\U0001d4bd', '\U0001d4c3'), ('\U0001d4c5',
        '\U0001d505'), ('\U0001d507', '\U0001d50a'), ('\U0001d50d', '\U0001d514'), ('\U0001d516',
        '\U0001d51c'), ('\U0001d51e', '\U0001d539'), ('\U0001d53b', '\U0001d53e'), ('\U0001d540',
        '\U0001d544'), ('\U0001d546', '\U0001d546'), ('\U0001d54a', '\U0001d550'), ('\U0001d552',
        '\U0001d6a5'), ('\U0001d6a8', '\U0001d6c0'), ('\U0001d6c2', '\U0001d6da'), ('\U0001d6dc',
        '\U0001d6fa'), ('\U0001d6fc', '\U0001d714'), ('\U0001d716', '\U0001d734'), ('\U0001d736',
        '\U0001d74e'), ('\U0001d750', '\U0001d76e'), ('\U0001d770', '\U0001d788'), ('\U0001d78a',
        '\U0001d7a8'), ('\U0001d7aa', '\U0001d7c2'), ('\U0001d7c4', '\U0001d7cb'), ('\U0001e800',
        '\U0001e8c4'), ('\U0001ee00', '\U0001ee03'), ('\U0001ee05', '\U0001ee1f'), ('\U0001ee21',
        '\U0001ee22'), ('\U0001ee24', '\U0001ee24'), ('\U0001ee27', '\U0001ee27'), ('\U0001ee29',
        '\U0001ee32'), ('\U0001ee34', '\U0001ee37'), ('\U0001ee39', '\U0001ee39'), ('\U0001ee3b',
        '\U0001ee3b'), ('\U0001ee42', '\U0001ee42'), ('\U0001ee47', '\U0001ee47'), ('\U0001ee49',
        '\U0001ee49'), ('\U0001ee4b', '\U0001ee4b'), ('\U0001ee4d', '\U0001ee4f'), ('\U0001ee51',
        '\U0001ee52'), ('\U0001ee54', '\U0001ee54'), ('\U0001ee57', '\U0001ee57'), ('\U0001ee59',
        '\U0001ee59'), ('\U0001ee5b', '\U0001ee5b'), ('\U0001ee5d', '\U0001ee5d'), ('\U0001ee5f',
        '\U0001ee5f'), ('\U0001ee61', '\U0001ee62'), ('\U0001ee64', '\U0001ee64'), ('\U0001ee67',
        '\U0001ee6a'), ('\U0001ee6c', '\U0001ee72'), ('\U0001ee74', '\U0001ee77'), ('\U0001ee79',
        '\U0001ee7c'), ('\U0001ee7e', '\U0001ee7e'), ('\U0001ee80', '\U0001ee89'), ('\U0001ee8b',
        '\U0001ee9b'), ('\U0001eea1', '\U0001eea3'), ('\U0001eea5', '\U0001eea9'), ('\U0001eeab',
        '\U0001eebb'), ('\U0001f130', '\U0001f149'), ('\U0001f150', '\U0001f169'), ('\U0001f170',
        '\U0001f189'), ('\U00020000', '\U0002a6d6'), ('\U0002a700', '\U0002b734'), ('\U0002b740',
        '\U0002b81d'), ('\U0002f800', '\U0002fa1d')
    ];

    pub fn Alphabetic(c: char) -> bool {
        super::bsearch_range_table(c, Alphabetic_table)
    }

    pub static Default_Ignorable_Code_Point_table: &'static [(char, char)] = &[
        ('\u00ad', '\u00ad'), ('\u034f', '\u034f'), ('\u061c', '\u061c'), ('\u115f', '\u1160'),
        ('\u17b4', '\u17b5'), ('\u180b', '\u180d'), ('\u180e', '\u180e'), ('\u200b', '\u200f'),
        ('\u202a', '\u202e'), ('\u2060', '\u2064'), ('\u2065', '\u2065'), ('\u2066', '\u206f'),
        ('\u3164', '\u3164'), ('\ufe00', '\ufe0f'), ('\ufeff', '\ufeff'), ('\uffa0', '\uffa0'),
        ('\ufff0', '\ufff8'), ('\U0001bca0', '\U0001bca3'), ('\U0001d173', '\U0001d17a'),
        ('\U000e0000', '\U000e0000'), ('\U000e0001', '\U000e0001'), ('\U000e0002', '\U000e001f'),
        ('\U000e0020', '\U000e007f'), ('\U000e0080', '\U000e00ff'), ('\U000e0100', '\U000e01ef'),
        ('\U000e01f0', '\U000e0fff')
    ];

    pub static Lowercase_table: &'static [(char, char)] = &[
        ('\x61', '\x7a'), ('\u00aa', '\u00aa'), ('\u00b5', '\u00b5'), ('\u00ba', '\u00ba'),
        ('\u00df', '\u00f6'), ('\u00f8', '\u00ff'), ('\u0101', '\u0101'), ('\u0103', '\u0103'),
        ('\u0105', '\u0105'), ('\u0107', '\u0107'), ('\u0109', '\u0109'), ('\u010b', '\u010b'),
        ('\u010d', '\u010d'), ('\u010f', '\u010f'), ('\u0111', '\u0111'), ('\u0113', '\u0113'),
        ('\u0115', '\u0115'), ('\u0117', '\u0117'), ('\u0119', '\u0119'), ('\u011b', '\u011b'),
        ('\u011d', '\u011d'), ('\u011f', '\u011f'), ('\u0121', '\u0121'), ('\u0123', '\u0123'),
        ('\u0125', '\u0125'), ('\u0127', '\u0127'), ('\u0129', '\u0129'), ('\u012b', '\u012b'),
        ('\u012d', '\u012d'), ('\u012f', '\u012f'), ('\u0131', '\u0131'), ('\u0133', '\u0133'),
        ('\u0135', '\u0135'), ('\u0137', '\u0138'), ('\u013a', '\u013a'), ('\u013c', '\u013c'),
        ('\u013e', '\u013e'), ('\u0140', '\u0140'), ('\u0142', '\u0142'), ('\u0144', '\u0144'),
        ('\u0146', '\u0146'), ('\u0148', '\u0149'), ('\u014b', '\u014b'), ('\u014d', '\u014d'),
        ('\u014f', '\u014f'), ('\u0151', '\u0151'), ('\u0153', '\u0153'), ('\u0155', '\u0155'),
        ('\u0157', '\u0157'), ('\u0159', '\u0159'), ('\u015b', '\u015b'), ('\u015d', '\u015d'),
        ('\u015f', '\u015f'), ('\u0161', '\u0161'), ('\u0163', '\u0163'), ('\u0165', '\u0165'),
        ('\u0167', '\u0167'), ('\u0169', '\u0169'), ('\u016b', '\u016b'), ('\u016d', '\u016d'),
        ('\u016f', '\u016f'), ('\u0171', '\u0171'), ('\u0173', '\u0173'), ('\u0175', '\u0175'),
        ('\u0177', '\u0177'), ('\u017a', '\u017a'), ('\u017c', '\u017c'), ('\u017e', '\u0180'),
        ('\u0183', '\u0183'), ('\u0185', '\u0185'), ('\u0188', '\u0188'), ('\u018c', '\u018d'),
        ('\u0192', '\u0192'), ('\u0195', '\u0195'), ('\u0199', '\u019b'), ('\u019e', '\u019e'),
        ('\u01a1', '\u01a1'), ('\u01a3', '\u01a3'), ('\u01a5', '\u01a5'), ('\u01a8', '\u01a8'),
        ('\u01aa', '\u01ab'), ('\u01ad', '\u01ad'), ('\u01b0', '\u01b0'), ('\u01b4', '\u01b4'),
        ('\u01b6', '\u01b6'), ('\u01b9', '\u01ba'), ('\u01bd', '\u01bf'), ('\u01c6', '\u01c6'),
        ('\u01c9', '\u01c9'), ('\u01cc', '\u01cc'), ('\u01ce', '\u01ce'), ('\u01d0', '\u01d0'),
        ('\u01d2', '\u01d2'), ('\u01d4', '\u01d4'), ('\u01d6', '\u01d6'), ('\u01d8', '\u01d8'),
        ('\u01da', '\u01da'), ('\u01dc', '\u01dd'), ('\u01df', '\u01df'), ('\u01e1', '\u01e1'),
        ('\u01e3', '\u01e3'), ('\u01e5', '\u01e5'), ('\u01e7', '\u01e7'), ('\u01e9', '\u01e9'),
        ('\u01eb', '\u01eb'), ('\u01ed', '\u01ed'), ('\u01ef', '\u01f0'), ('\u01f3', '\u01f3'),
        ('\u01f5', '\u01f5'), ('\u01f9', '\u01f9'), ('\u01fb', '\u01fb'), ('\u01fd', '\u01fd'),
        ('\u01ff', '\u01ff'), ('\u0201', '\u0201'), ('\u0203', '\u0203'), ('\u0205', '\u0205'),
        ('\u0207', '\u0207'), ('\u0209', '\u0209'), ('\u020b', '\u020b'), ('\u020d', '\u020d'),
        ('\u020f', '\u020f'), ('\u0211', '\u0211'), ('\u0213', '\u0213'), ('\u0215', '\u0215'),
        ('\u0217', '\u0217'), ('\u0219', '\u0219'), ('\u021b', '\u021b'), ('\u021d', '\u021d'),
        ('\u021f', '\u021f'), ('\u0221', '\u0221'), ('\u0223', '\u0223'), ('\u0225', '\u0225'),
        ('\u0227', '\u0227'), ('\u0229', '\u0229'), ('\u022b', '\u022b'), ('\u022d', '\u022d'),
        ('\u022f', '\u022f'), ('\u0231', '\u0231'), ('\u0233', '\u0239'), ('\u023c', '\u023c'),
        ('\u023f', '\u0240'), ('\u0242', '\u0242'), ('\u0247', '\u0247'), ('\u0249', '\u0249'),
        ('\u024b', '\u024b'), ('\u024d', '\u024d'), ('\u024f', '\u0293'), ('\u0295', '\u02af'),
        ('\u02b0', '\u02b8'), ('\u02c0', '\u02c1'), ('\u02e0', '\u02e4'), ('\u0345', '\u0345'),
        ('\u0371', '\u0371'), ('\u0373', '\u0373'), ('\u0377', '\u0377'), ('\u037a', '\u037a'),
        ('\u037b', '\u037d'), ('\u0390', '\u0390'), ('\u03ac', '\u03ce'), ('\u03d0', '\u03d1'),
        ('\u03d5', '\u03d7'), ('\u03d9', '\u03d9'), ('\u03db', '\u03db'), ('\u03dd', '\u03dd'),
        ('\u03df', '\u03df'), ('\u03e1', '\u03e1'), ('\u03e3', '\u03e3'), ('\u03e5', '\u03e5'),
        ('\u03e7', '\u03e7'), ('\u03e9', '\u03e9'), ('\u03eb', '\u03eb'), ('\u03ed', '\u03ed'),
        ('\u03ef', '\u03f3'), ('\u03f5', '\u03f5'), ('\u03f8', '\u03f8'), ('\u03fb', '\u03fc'),
        ('\u0430', '\u045f'), ('\u0461', '\u0461'), ('\u0463', '\u0463'), ('\u0465', '\u0465'),
        ('\u0467', '\u0467'), ('\u0469', '\u0469'), ('\u046b', '\u046b'), ('\u046d', '\u046d'),
        ('\u046f', '\u046f'), ('\u0471', '\u0471'), ('\u0473', '\u0473'), ('\u0475', '\u0475'),
        ('\u0477', '\u0477'), ('\u0479', '\u0479'), ('\u047b', '\u047b'), ('\u047d', '\u047d'),
        ('\u047f', '\u047f'), ('\u0481', '\u0481'), ('\u048b', '\u048b'), ('\u048d', '\u048d'),
        ('\u048f', '\u048f'), ('\u0491', '\u0491'), ('\u0493', '\u0493'), ('\u0495', '\u0495'),
        ('\u0497', '\u0497'), ('\u0499', '\u0499'), ('\u049b', '\u049b'), ('\u049d', '\u049d'),
        ('\u049f', '\u049f'), ('\u04a1', '\u04a1'), ('\u04a3', '\u04a3'), ('\u04a5', '\u04a5'),
        ('\u04a7', '\u04a7'), ('\u04a9', '\u04a9'), ('\u04ab', '\u04ab'), ('\u04ad', '\u04ad'),
        ('\u04af', '\u04af'), ('\u04b1', '\u04b1'), ('\u04b3', '\u04b3'), ('\u04b5', '\u04b5'),
        ('\u04b7', '\u04b7'), ('\u04b9', '\u04b9'), ('\u04bb', '\u04bb'), ('\u04bd', '\u04bd'),
        ('\u04bf', '\u04bf'), ('\u04c2', '\u04c2'), ('\u04c4', '\u04c4'), ('\u04c6', '\u04c6'),
        ('\u04c8', '\u04c8'), ('\u04ca', '\u04ca'), ('\u04cc', '\u04cc'), ('\u04ce', '\u04cf'),
        ('\u04d1', '\u04d1'), ('\u04d3', '\u04d3'), ('\u04d5', '\u04d5'), ('\u04d7', '\u04d7'),
        ('\u04d9', '\u04d9'), ('\u04db', '\u04db'), ('\u04dd', '\u04dd'), ('\u04df', '\u04df'),
        ('\u04e1', '\u04e1'), ('\u04e3', '\u04e3'), ('\u04e5', '\u04e5'), ('\u04e7', '\u04e7'),
        ('\u04e9', '\u04e9'), ('\u04eb', '\u04eb'), ('\u04ed', '\u04ed'), ('\u04ef', '\u04ef'),
        ('\u04f1', '\u04f1'), ('\u04f3', '\u04f3'), ('\u04f5', '\u04f5'), ('\u04f7', '\u04f7'),
        ('\u04f9', '\u04f9'), ('\u04fb', '\u04fb'), ('\u04fd', '\u04fd'), ('\u04ff', '\u04ff'),
        ('\u0501', '\u0501'), ('\u0503', '\u0503'), ('\u0505', '\u0505'), ('\u0507', '\u0507'),
        ('\u0509', '\u0509'), ('\u050b', '\u050b'), ('\u050d', '\u050d'), ('\u050f', '\u050f'),
        ('\u0511', '\u0511'), ('\u0513', '\u0513'), ('\u0515', '\u0515'), ('\u0517', '\u0517'),
        ('\u0519', '\u0519'), ('\u051b', '\u051b'), ('\u051d', '\u051d'), ('\u051f', '\u051f'),
        ('\u0521', '\u0521'), ('\u0523', '\u0523'), ('\u0525', '\u0525'), ('\u0527', '\u0527'),
        ('\u0529', '\u0529'), ('\u052b', '\u052b'), ('\u052d', '\u052d'), ('\u052f', '\u052f'),
        ('\u0561', '\u0587'), ('\u1d00', '\u1d2b'), ('\u1d2c', '\u1d6a'), ('\u1d6b', '\u1d77'),
        ('\u1d78', '\u1d78'), ('\u1d79', '\u1d9a'), ('\u1d9b', '\u1dbf'), ('\u1e01', '\u1e01'),
        ('\u1e03', '\u1e03'), ('\u1e05', '\u1e05'), ('\u1e07', '\u1e07'), ('\u1e09', '\u1e09'),
        ('\u1e0b', '\u1e0b'), ('\u1e0d', '\u1e0d'), ('\u1e0f', '\u1e0f'), ('\u1e11', '\u1e11'),
        ('\u1e13', '\u1e13'), ('\u1e15', '\u1e15'), ('\u1e17', '\u1e17'), ('\u1e19', '\u1e19'),
        ('\u1e1b', '\u1e1b'), ('\u1e1d', '\u1e1d'), ('\u1e1f', '\u1e1f'), ('\u1e21', '\u1e21'),
        ('\u1e23', '\u1e23'), ('\u1e25', '\u1e25'), ('\u1e27', '\u1e27'), ('\u1e29', '\u1e29'),
        ('\u1e2b', '\u1e2b'), ('\u1e2d', '\u1e2d'), ('\u1e2f', '\u1e2f'), ('\u1e31', '\u1e31'),
        ('\u1e33', '\u1e33'), ('\u1e35', '\u1e35'), ('\u1e37', '\u1e37'), ('\u1e39', '\u1e39'),
        ('\u1e3b', '\u1e3b'), ('\u1e3d', '\u1e3d'), ('\u1e3f', '\u1e3f'), ('\u1e41', '\u1e41'),
        ('\u1e43', '\u1e43'), ('\u1e45', '\u1e45'), ('\u1e47', '\u1e47'), ('\u1e49', '\u1e49'),
        ('\u1e4b', '\u1e4b'), ('\u1e4d', '\u1e4d'), ('\u1e4f', '\u1e4f'), ('\u1e51', '\u1e51'),
        ('\u1e53', '\u1e53'), ('\u1e55', '\u1e55'), ('\u1e57', '\u1e57'), ('\u1e59', '\u1e59'),
        ('\u1e5b', '\u1e5b'), ('\u1e5d', '\u1e5d'), ('\u1e5f', '\u1e5f'), ('\u1e61', '\u1e61'),
        ('\u1e63', '\u1e63'), ('\u1e65', '\u1e65'), ('\u1e67', '\u1e67'), ('\u1e69', '\u1e69'),
        ('\u1e6b', '\u1e6b'), ('\u1e6d', '\u1e6d'), ('\u1e6f', '\u1e6f'), ('\u1e71', '\u1e71'),
        ('\u1e73', '\u1e73'), ('\u1e75', '\u1e75'), ('\u1e77', '\u1e77'), ('\u1e79', '\u1e79'),
        ('\u1e7b', '\u1e7b'), ('\u1e7d', '\u1e7d'), ('\u1e7f', '\u1e7f'), ('\u1e81', '\u1e81'),
        ('\u1e83', '\u1e83'), ('\u1e85', '\u1e85'), ('\u1e87', '\u1e87'), ('\u1e89', '\u1e89'),
        ('\u1e8b', '\u1e8b'), ('\u1e8d', '\u1e8d'), ('\u1e8f', '\u1e8f'), ('\u1e91', '\u1e91'),
        ('\u1e93', '\u1e93'), ('\u1e95', '\u1e9d'), ('\u1e9f', '\u1e9f'), ('\u1ea1', '\u1ea1'),
        ('\u1ea3', '\u1ea3'), ('\u1ea5', '\u1ea5'), ('\u1ea7', '\u1ea7'), ('\u1ea9', '\u1ea9'),
        ('\u1eab', '\u1eab'), ('\u1ead', '\u1ead'), ('\u1eaf', '\u1eaf'), ('\u1eb1', '\u1eb1'),
        ('\u1eb3', '\u1eb3'), ('\u1eb5', '\u1eb5'), ('\u1eb7', '\u1eb7'), ('\u1eb9', '\u1eb9'),
        ('\u1ebb', '\u1ebb'), ('\u1ebd', '\u1ebd'), ('\u1ebf', '\u1ebf'), ('\u1ec1', '\u1ec1'),
        ('\u1ec3', '\u1ec3'), ('\u1ec5', '\u1ec5'), ('\u1ec7', '\u1ec7'), ('\u1ec9', '\u1ec9'),
        ('\u1ecb', '\u1ecb'), ('\u1ecd', '\u1ecd'), ('\u1ecf', '\u1ecf'), ('\u1ed1', '\u1ed1'),
        ('\u1ed3', '\u1ed3'), ('\u1ed5', '\u1ed5'), ('\u1ed7', '\u1ed7'), ('\u1ed9', '\u1ed9'),
        ('\u1edb', '\u1edb'), ('\u1edd', '\u1edd'), ('\u1edf', '\u1edf'), ('\u1ee1', '\u1ee1'),
        ('\u1ee3', '\u1ee3'), ('\u1ee5', '\u1ee5'), ('\u1ee7', '\u1ee7'), ('\u1ee9', '\u1ee9'),
        ('\u1eeb', '\u1eeb'), ('\u1eed', '\u1eed'), ('\u1eef', '\u1eef'), ('\u1ef1', '\u1ef1'),
        ('\u1ef3', '\u1ef3'), ('\u1ef5', '\u1ef5'), ('\u1ef7', '\u1ef7'), ('\u1ef9', '\u1ef9'),
        ('\u1efb', '\u1efb'), ('\u1efd', '\u1efd'), ('\u1eff', '\u1f07'), ('\u1f10', '\u1f15'),
        ('\u1f20', '\u1f27'), ('\u1f30', '\u1f37'), ('\u1f40', '\u1f45'), ('\u1f50', '\u1f57'),
        ('\u1f60', '\u1f67'), ('\u1f70', '\u1f7d'), ('\u1f80', '\u1f87'), ('\u1f90', '\u1f97'),
        ('\u1fa0', '\u1fa7'), ('\u1fb0', '\u1fb4'), ('\u1fb6', '\u1fb7'), ('\u1fbe', '\u1fbe'),
        ('\u1fc2', '\u1fc4'), ('\u1fc6', '\u1fc7'), ('\u1fd0', '\u1fd3'), ('\u1fd6', '\u1fd7'),
        ('\u1fe0', '\u1fe7'), ('\u1ff2', '\u1ff4'), ('\u1ff6', '\u1ff7'), ('\u2071', '\u2071'),
        ('\u207f', '\u207f'), ('\u2090', '\u209c'), ('\u210a', '\u210a'), ('\u210e', '\u210f'),
        ('\u2113', '\u2113'), ('\u212f', '\u212f'), ('\u2134', '\u2134'), ('\u2139', '\u2139'),
        ('\u213c', '\u213d'), ('\u2146', '\u2149'), ('\u214e', '\u214e'), ('\u2170', '\u217f'),
        ('\u2184', '\u2184'), ('\u24d0', '\u24e9'), ('\u2c30', '\u2c5e'), ('\u2c61', '\u2c61'),
        ('\u2c65', '\u2c66'), ('\u2c68', '\u2c68'), ('\u2c6a', '\u2c6a'), ('\u2c6c', '\u2c6c'),
        ('\u2c71', '\u2c71'), ('\u2c73', '\u2c74'), ('\u2c76', '\u2c7b'), ('\u2c7c', '\u2c7d'),
        ('\u2c81', '\u2c81'), ('\u2c83', '\u2c83'), ('\u2c85', '\u2c85'), ('\u2c87', '\u2c87'),
        ('\u2c89', '\u2c89'), ('\u2c8b', '\u2c8b'), ('\u2c8d', '\u2c8d'), ('\u2c8f', '\u2c8f'),
        ('\u2c91', '\u2c91'), ('\u2c93', '\u2c93'), ('\u2c95', '\u2c95'), ('\u2c97', '\u2c97'),
        ('\u2c99', '\u2c99'), ('\u2c9b', '\u2c9b'), ('\u2c9d', '\u2c9d'), ('\u2c9f', '\u2c9f'),
        ('\u2ca1', '\u2ca1'), ('\u2ca3', '\u2ca3'), ('\u2ca5', '\u2ca5'), ('\u2ca7', '\u2ca7'),
        ('\u2ca9', '\u2ca9'), ('\u2cab', '\u2cab'), ('\u2cad', '\u2cad'), ('\u2caf', '\u2caf'),
        ('\u2cb1', '\u2cb1'), ('\u2cb3', '\u2cb3'), ('\u2cb5', '\u2cb5'), ('\u2cb7', '\u2cb7'),
        ('\u2cb9', '\u2cb9'), ('\u2cbb', '\u2cbb'), ('\u2cbd', '\u2cbd'), ('\u2cbf', '\u2cbf'),
        ('\u2cc1', '\u2cc1'), ('\u2cc3', '\u2cc3'), ('\u2cc5', '\u2cc5'), ('\u2cc7', '\u2cc7'),
        ('\u2cc9', '\u2cc9'), ('\u2ccb', '\u2ccb'), ('\u2ccd', '\u2ccd'), ('\u2ccf', '\u2ccf'),
        ('\u2cd1', '\u2cd1'), ('\u2cd3', '\u2cd3'), ('\u2cd5', '\u2cd5'), ('\u2cd7', '\u2cd7'),
        ('\u2cd9', '\u2cd9'), ('\u2cdb', '\u2cdb'), ('\u2cdd', '\u2cdd'), ('\u2cdf', '\u2cdf'),
        ('\u2ce1', '\u2ce1'), ('\u2ce3', '\u2ce4'), ('\u2cec', '\u2cec'), ('\u2cee', '\u2cee'),
        ('\u2cf3', '\u2cf3'), ('\u2d00', '\u2d25'), ('\u2d27', '\u2d27'), ('\u2d2d', '\u2d2d'),
        ('\ua641', '\ua641'), ('\ua643', '\ua643'), ('\ua645', '\ua645'), ('\ua647', '\ua647'),
        ('\ua649', '\ua649'), ('\ua64b', '\ua64b'), ('\ua64d', '\ua64d'), ('\ua64f', '\ua64f'),
        ('\ua651', '\ua651'), ('\ua653', '\ua653'), ('\ua655', '\ua655'), ('\ua657', '\ua657'),
        ('\ua659', '\ua659'), ('\ua65b', '\ua65b'), ('\ua65d', '\ua65d'), ('\ua65f', '\ua65f'),
        ('\ua661', '\ua661'), ('\ua663', '\ua663'), ('\ua665', '\ua665'), ('\ua667', '\ua667'),
        ('\ua669', '\ua669'), ('\ua66b', '\ua66b'), ('\ua66d', '\ua66d'), ('\ua681', '\ua681'),
        ('\ua683', '\ua683'), ('\ua685', '\ua685'), ('\ua687', '\ua687'), ('\ua689', '\ua689'),
        ('\ua68b', '\ua68b'), ('\ua68d', '\ua68d'), ('\ua68f', '\ua68f'), ('\ua691', '\ua691'),
        ('\ua693', '\ua693'), ('\ua695', '\ua695'), ('\ua697', '\ua697'), ('\ua699', '\ua699'),
        ('\ua69b', '\ua69b'), ('\ua69c', '\ua69d'), ('\ua723', '\ua723'), ('\ua725', '\ua725'),
        ('\ua727', '\ua727'), ('\ua729', '\ua729'), ('\ua72b', '\ua72b'), ('\ua72d', '\ua72d'),
        ('\ua72f', '\ua731'), ('\ua733', '\ua733'), ('\ua735', '\ua735'), ('\ua737', '\ua737'),
        ('\ua739', '\ua739'), ('\ua73b', '\ua73b'), ('\ua73d', '\ua73d'), ('\ua73f', '\ua73f'),
        ('\ua741', '\ua741'), ('\ua743', '\ua743'), ('\ua745', '\ua745'), ('\ua747', '\ua747'),
        ('\ua749', '\ua749'), ('\ua74b', '\ua74b'), ('\ua74d', '\ua74d'), ('\ua74f', '\ua74f'),
        ('\ua751', '\ua751'), ('\ua753', '\ua753'), ('\ua755', '\ua755'), ('\ua757', '\ua757'),
        ('\ua759', '\ua759'), ('\ua75b', '\ua75b'), ('\ua75d', '\ua75d'), ('\ua75f', '\ua75f'),
        ('\ua761', '\ua761'), ('\ua763', '\ua763'), ('\ua765', '\ua765'), ('\ua767', '\ua767'),
        ('\ua769', '\ua769'), ('\ua76b', '\ua76b'), ('\ua76d', '\ua76d'), ('\ua76f', '\ua76f'),
        ('\ua770', '\ua770'), ('\ua771', '\ua778'), ('\ua77a', '\ua77a'), ('\ua77c', '\ua77c'),
        ('\ua77f', '\ua77f'), ('\ua781', '\ua781'), ('\ua783', '\ua783'), ('\ua785', '\ua785'),
        ('\ua787', '\ua787'), ('\ua78c', '\ua78c'), ('\ua78e', '\ua78e'), ('\ua791', '\ua791'),
        ('\ua793', '\ua795'), ('\ua797', '\ua797'), ('\ua799', '\ua799'), ('\ua79b', '\ua79b'),
        ('\ua79d', '\ua79d'), ('\ua79f', '\ua79f'), ('\ua7a1', '\ua7a1'), ('\ua7a3', '\ua7a3'),
        ('\ua7a5', '\ua7a5'), ('\ua7a7', '\ua7a7'), ('\ua7a9', '\ua7a9'), ('\ua7f8', '\ua7f9'),
        ('\ua7fa', '\ua7fa'), ('\uab30', '\uab5a'), ('\uab5c', '\uab5f'), ('\uab64', '\uab65'),
        ('\ufb00', '\ufb06'), ('\ufb13', '\ufb17'), ('\uff41', '\uff5a'), ('\U00010428',
        '\U0001044f'), ('\U000118c0', '\U000118df'), ('\U0001d41a', '\U0001d433'), ('\U0001d44e',
        '\U0001d454'), ('\U0001d456', '\U0001d467'), ('\U0001d482', '\U0001d49b'), ('\U0001d4b6',
        '\U0001d4b9'), ('\U0001d4bb', '\U0001d4bb'), ('\U0001d4bd', '\U0001d4c3'), ('\U0001d4c5',
        '\U0001d4cf'), ('\U0001d4ea', '\U0001d503'), ('\U0001d51e', '\U0001d537'), ('\U0001d552',
        '\U0001d56b'), ('\U0001d586', '\U0001d59f'), ('\U0001d5ba', '\U0001d5d3'), ('\U0001d5ee',
        '\U0001d607'), ('\U0001d622', '\U0001d63b'), ('\U0001d656', '\U0001d66f'), ('\U0001d68a',
        '\U0001d6a5'), ('\U0001d6c2', '\U0001d6da'), ('\U0001d6dc', '\U0001d6e1'), ('\U0001d6fc',
        '\U0001d714'), ('\U0001d716', '\U0001d71b'), ('\U0001d736', '\U0001d74e'), ('\U0001d750',
        '\U0001d755'), ('\U0001d770', '\U0001d788'), ('\U0001d78a', '\U0001d78f'), ('\U0001d7aa',
        '\U0001d7c2'), ('\U0001d7c4', '\U0001d7c9'), ('\U0001d7cb', '\U0001d7cb')
    ];

    pub fn Lowercase(c: char) -> bool {
        super::bsearch_range_table(c, Lowercase_table)
    }

    pub static Uppercase_table: &'static [(char, char)] = &[
        ('\x41', '\x5a'), ('\u00c0', '\u00d6'), ('\u00d8', '\u00de'), ('\u0100', '\u0100'),
        ('\u0102', '\u0102'), ('\u0104', '\u0104'), ('\u0106', '\u0106'), ('\u0108', '\u0108'),
        ('\u010a', '\u010a'), ('\u010c', '\u010c'), ('\u010e', '\u010e'), ('\u0110', '\u0110'),
        ('\u0112', '\u0112'), ('\u0114', '\u0114'), ('\u0116', '\u0116'), ('\u0118', '\u0118'),
        ('\u011a', '\u011a'), ('\u011c', '\u011c'), ('\u011e', '\u011e'), ('\u0120', '\u0120'),
        ('\u0122', '\u0122'), ('\u0124', '\u0124'), ('\u0126', '\u0126'), ('\u0128', '\u0128'),
        ('\u012a', '\u012a'), ('\u012c', '\u012c'), ('\u012e', '\u012e'), ('\u0130', '\u0130'),
        ('\u0132', '\u0132'), ('\u0134', '\u0134'), ('\u0136', '\u0136'), ('\u0139', '\u0139'),
        ('\u013b', '\u013b'), ('\u013d', '\u013d'), ('\u013f', '\u013f'), ('\u0141', '\u0141'),
        ('\u0143', '\u0143'), ('\u0145', '\u0145'), ('\u0147', '\u0147'), ('\u014a', '\u014a'),
        ('\u014c', '\u014c'), ('\u014e', '\u014e'), ('\u0150', '\u0150'), ('\u0152', '\u0152'),
        ('\u0154', '\u0154'), ('\u0156', '\u0156'), ('\u0158', '\u0158'), ('\u015a', '\u015a'),
        ('\u015c', '\u015c'), ('\u015e', '\u015e'), ('\u0160', '\u0160'), ('\u0162', '\u0162'),
        ('\u0164', '\u0164'), ('\u0166', '\u0166'), ('\u0168', '\u0168'), ('\u016a', '\u016a'),
        ('\u016c', '\u016c'), ('\u016e', '\u016e'), ('\u0170', '\u0170'), ('\u0172', '\u0172'),
        ('\u0174', '\u0174'), ('\u0176', '\u0176'), ('\u0178', '\u0179'), ('\u017b', '\u017b'),
        ('\u017d', '\u017d'), ('\u0181', '\u0182'), ('\u0184', '\u0184'), ('\u0186', '\u0187'),
        ('\u0189', '\u018b'), ('\u018e', '\u0191'), ('\u0193', '\u0194'), ('\u0196', '\u0198'),
        ('\u019c', '\u019d'), ('\u019f', '\u01a0'), ('\u01a2', '\u01a2'), ('\u01a4', '\u01a4'),
        ('\u01a6', '\u01a7'), ('\u01a9', '\u01a9'), ('\u01ac', '\u01ac'), ('\u01ae', '\u01af'),
        ('\u01b1', '\u01b3'), ('\u01b5', '\u01b5'), ('\u01b7', '\u01b8'), ('\u01bc', '\u01bc'),
        ('\u01c4', '\u01c4'), ('\u01c7', '\u01c7'), ('\u01ca', '\u01ca'), ('\u01cd', '\u01cd'),
        ('\u01cf', '\u01cf'), ('\u01d1', '\u01d1'), ('\u01d3', '\u01d3'), ('\u01d5', '\u01d5'),
        ('\u01d7', '\u01d7'), ('\u01d9', '\u01d9'), ('\u01db', '\u01db'), ('\u01de', '\u01de'),
        ('\u01e0', '\u01e0'), ('\u01e2', '\u01e2'), ('\u01e4', '\u01e4'), ('\u01e6', '\u01e6'),
        ('\u01e8', '\u01e8'), ('\u01ea', '\u01ea'), ('\u01ec', '\u01ec'), ('\u01ee', '\u01ee'),
        ('\u01f1', '\u01f1'), ('\u01f4', '\u01f4'), ('\u01f6', '\u01f8'), ('\u01fa', '\u01fa'),
        ('\u01fc', '\u01fc'), ('\u01fe', '\u01fe'), ('\u0200', '\u0200'), ('\u0202', '\u0202'),
        ('\u0204', '\u0204'), ('\u0206', '\u0206'), ('\u0208', '\u0208'), ('\u020a', '\u020a'),
        ('\u020c', '\u020c'), ('\u020e', '\u020e'), ('\u0210', '\u0210'), ('\u0212', '\u0212'),
        ('\u0214', '\u0214'), ('\u0216', '\u0216'), ('\u0218', '\u0218'), ('\u021a', '\u021a'),
        ('\u021c', '\u021c'), ('\u021e', '\u021e'), ('\u0220', '\u0220'), ('\u0222', '\u0222'),
        ('\u0224', '\u0224'), ('\u0226', '\u0226'), ('\u0228', '\u0228'), ('\u022a', '\u022a'),
        ('\u022c', '\u022c'), ('\u022e', '\u022e'), ('\u0230', '\u0230'), ('\u0232', '\u0232'),
        ('\u023a', '\u023b'), ('\u023d', '\u023e'), ('\u0241', '\u0241'), ('\u0243', '\u0246'),
        ('\u0248', '\u0248'), ('\u024a', '\u024a'), ('\u024c', '\u024c'), ('\u024e', '\u024e'),
        ('\u0370', '\u0370'), ('\u0372', '\u0372'), ('\u0376', '\u0376'), ('\u037f', '\u037f'),
        ('\u0386', '\u0386'), ('\u0388', '\u038a'), ('\u038c', '\u038c'), ('\u038e', '\u038f'),
        ('\u0391', '\u03a1'), ('\u03a3', '\u03ab'), ('\u03cf', '\u03cf'), ('\u03d2', '\u03d4'),
        ('\u03d8', '\u03d8'), ('\u03da', '\u03da'), ('\u03dc', '\u03dc'), ('\u03de', '\u03de'),
        ('\u03e0', '\u03e0'), ('\u03e2', '\u03e2'), ('\u03e4', '\u03e4'), ('\u03e6', '\u03e6'),
        ('\u03e8', '\u03e8'), ('\u03ea', '\u03ea'), ('\u03ec', '\u03ec'), ('\u03ee', '\u03ee'),
        ('\u03f4', '\u03f4'), ('\u03f7', '\u03f7'), ('\u03f9', '\u03fa'), ('\u03fd', '\u042f'),
        ('\u0460', '\u0460'), ('\u0462', '\u0462'), ('\u0464', '\u0464'), ('\u0466', '\u0466'),
        ('\u0468', '\u0468'), ('\u046a', '\u046a'), ('\u046c', '\u046c'), ('\u046e', '\u046e'),
        ('\u0470', '\u0470'), ('\u0472', '\u0472'), ('\u0474', '\u0474'), ('\u0476', '\u0476'),
        ('\u0478', '\u0478'), ('\u047a', '\u047a'), ('\u047c', '\u047c'), ('\u047e', '\u047e'),
        ('\u0480', '\u0480'), ('\u048a', '\u048a'), ('\u048c', '\u048c'), ('\u048e', '\u048e'),
        ('\u0490', '\u0490'), ('\u0492', '\u0492'), ('\u0494', '\u0494'), ('\u0496', '\u0496'),
        ('\u0498', '\u0498'), ('\u049a', '\u049a'), ('\u049c', '\u049c'), ('\u049e', '\u049e'),
        ('\u04a0', '\u04a0'), ('\u04a2', '\u04a2'), ('\u04a4', '\u04a4'), ('\u04a6', '\u04a6'),
        ('\u04a8', '\u04a8'), ('\u04aa', '\u04aa'), ('\u04ac', '\u04ac'), ('\u04ae', '\u04ae'),
        ('\u04b0', '\u04b0'), ('\u04b2', '\u04b2'), ('\u04b4', '\u04b4'), ('\u04b6', '\u04b6'),
        ('\u04b8', '\u04b8'), ('\u04ba', '\u04ba'), ('\u04bc', '\u04bc'), ('\u04be', '\u04be'),
        ('\u04c0', '\u04c1'), ('\u04c3', '\u04c3'), ('\u04c5', '\u04c5'), ('\u04c7', '\u04c7'),
        ('\u04c9', '\u04c9'), ('\u04cb', '\u04cb'), ('\u04cd', '\u04cd'), ('\u04d0', '\u04d0'),
        ('\u04d2', '\u04d2'), ('\u04d4', '\u04d4'), ('\u04d6', '\u04d6'), ('\u04d8', '\u04d8'),
        ('\u04da', '\u04da'), ('\u04dc', '\u04dc'), ('\u04de', '\u04de'), ('\u04e0', '\u04e0'),
        ('\u04e2', '\u04e2'), ('\u04e4', '\u04e4'), ('\u04e6', '\u04e6'), ('\u04e8', '\u04e8'),
        ('\u04ea', '\u04ea'), ('\u04ec', '\u04ec'), ('\u04ee', '\u04ee'), ('\u04f0', '\u04f0'),
        ('\u04f2', '\u04f2'), ('\u04f4', '\u04f4'), ('\u04f6', '\u04f6'), ('\u04f8', '\u04f8'),
        ('\u04fa', '\u04fa'), ('\u04fc', '\u04fc'), ('\u04fe', '\u04fe'), ('\u0500', '\u0500'),
        ('\u0502', '\u0502'), ('\u0504', '\u0504'), ('\u0506', '\u0506'), ('\u0508', '\u0508'),
        ('\u050a', '\u050a'), ('\u050c', '\u050c'), ('\u050e', '\u050e'), ('\u0510', '\u0510'),
        ('\u0512', '\u0512'), ('\u0514', '\u0514'), ('\u0516', '\u0516'), ('\u0518', '\u0518'),
        ('\u051a', '\u051a'), ('\u051c', '\u051c'), ('\u051e', '\u051e'), ('\u0520', '\u0520'),
        ('\u0522', '\u0522'), ('\u0524', '\u0524'), ('\u0526', '\u0526'), ('\u0528', '\u0528'),
        ('\u052a', '\u052a'), ('\u052c', '\u052c'), ('\u052e', '\u052e'), ('\u0531', '\u0556'),
        ('\u10a0', '\u10c5'), ('\u10c7', '\u10c7'), ('\u10cd', '\u10cd'), ('\u1e00', '\u1e00'),
        ('\u1e02', '\u1e02'), ('\u1e04', '\u1e04'), ('\u1e06', '\u1e06'), ('\u1e08', '\u1e08'),
        ('\u1e0a', '\u1e0a'), ('\u1e0c', '\u1e0c'), ('\u1e0e', '\u1e0e'), ('\u1e10', '\u1e10'),
        ('\u1e12', '\u1e12'), ('\u1e14', '\u1e14'), ('\u1e16', '\u1e16'), ('\u1e18', '\u1e18'),
        ('\u1e1a', '\u1e1a'), ('\u1e1c', '\u1e1c'), ('\u1e1e', '\u1e1e'), ('\u1e20', '\u1e20'),
        ('\u1e22', '\u1e22'), ('\u1e24', '\u1e24'), ('\u1e26', '\u1e26'), ('\u1e28', '\u1e28'),
        ('\u1e2a', '\u1e2a'), ('\u1e2c', '\u1e2c'), ('\u1e2e', '\u1e2e'), ('\u1e30', '\u1e30'),
        ('\u1e32', '\u1e32'), ('\u1e34', '\u1e34'), ('\u1e36', '\u1e36'), ('\u1e38', '\u1e38'),
        ('\u1e3a', '\u1e3a'), ('\u1e3c', '\u1e3c'), ('\u1e3e', '\u1e3e'), ('\u1e40', '\u1e40'),
        ('\u1e42', '\u1e42'), ('\u1e44', '\u1e44'), ('\u1e46', '\u1e46'), ('\u1e48', '\u1e48'),
        ('\u1e4a', '\u1e4a'), ('\u1e4c', '\u1e4c'), ('\u1e4e', '\u1e4e'), ('\u1e50', '\u1e50'),
        ('\u1e52', '\u1e52'), ('\u1e54', '\u1e54'), ('\u1e56', '\u1e56'), ('\u1e58', '\u1e58'),
        ('\u1e5a', '\u1e5a'), ('\u1e5c', '\u1e5c'), ('\u1e5e', '\u1e5e'), ('\u1e60', '\u1e60'),
        ('\u1e62', '\u1e62'), ('\u1e64', '\u1e64'), ('\u1e66', '\u1e66'), ('\u1e68', '\u1e68'),
        ('\u1e6a', '\u1e6a'), ('\u1e6c', '\u1e6c'), ('\u1e6e', '\u1e6e'), ('\u1e70', '\u1e70'),
        ('\u1e72', '\u1e72'), ('\u1e74', '\u1e74'), ('\u1e76', '\u1e76'), ('\u1e78', '\u1e78'),
        ('\u1e7a', '\u1e7a'), ('\u1e7c', '\u1e7c'), ('\u1e7e', '\u1e7e'), ('\u1e80', '\u1e80'),
        ('\u1e82', '\u1e82'), ('\u1e84', '\u1e84'), ('\u1e86', '\u1e86'), ('\u1e88', '\u1e88'),
        ('\u1e8a', '\u1e8a'), ('\u1e8c', '\u1e8c'), ('\u1e8e', '\u1e8e'), ('\u1e90', '\u1e90'),
        ('\u1e92', '\u1e92'), ('\u1e94', '\u1e94'), ('\u1e9e', '\u1e9e'), ('\u1ea0', '\u1ea0'),
        ('\u1ea2', '\u1ea2'), ('\u1ea4', '\u1ea4'), ('\u1ea6', '\u1ea6'), ('\u1ea8', '\u1ea8'),
        ('\u1eaa', '\u1eaa'), ('\u1eac', '\u1eac'), ('\u1eae', '\u1eae'), ('\u1eb0', '\u1eb0'),
        ('\u1eb2', '\u1eb2'), ('\u1eb4', '\u1eb4'), ('\u1eb6', '\u1eb6'), ('\u1eb8', '\u1eb8'),
        ('\u1eba', '\u1eba'), ('\u1ebc', '\u1ebc'), ('\u1ebe', '\u1ebe'), ('\u1ec0', '\u1ec0'),
        ('\u1ec2', '\u1ec2'), ('\u1ec4', '\u1ec4'), ('\u1ec6', '\u1ec6'), ('\u1ec8', '\u1ec8'),
        ('\u1eca', '\u1eca'), ('\u1ecc', '\u1ecc'), ('\u1ece', '\u1ece'), ('\u1ed0', '\u1ed0'),
        ('\u1ed2', '\u1ed2'), ('\u1ed4', '\u1ed4'), ('\u1ed6', '\u1ed6'), ('\u1ed8', '\u1ed8'),
        ('\u1eda', '\u1eda'), ('\u1edc', '\u1edc'), ('\u1ede', '\u1ede'), ('\u1ee0', '\u1ee0'),
        ('\u1ee2', '\u1ee2'), ('\u1ee4', '\u1ee4'), ('\u1ee6', '\u1ee6'), ('\u1ee8', '\u1ee8'),
        ('\u1eea', '\u1eea'), ('\u1eec', '\u1eec'), ('\u1eee', '\u1eee'), ('\u1ef0', '\u1ef0'),
        ('\u1ef2', '\u1ef2'), ('\u1ef4', '\u1ef4'), ('\u1ef6', '\u1ef6'), ('\u1ef8', '\u1ef8'),
        ('\u1efa', '\u1efa'), ('\u1efc', '\u1efc'), ('\u1efe', '\u1efe'), ('\u1f08', '\u1f0f'),
        ('\u1f18', '\u1f1d'), ('\u1f28', '\u1f2f'), ('\u1f38', '\u1f3f'), ('\u1f48', '\u1f4d'),
        ('\u1f59', '\u1f59'), ('\u1f5b', '\u1f5b'), ('\u1f5d', '\u1f5d'), ('\u1f5f', '\u1f5f'),
        ('\u1f68', '\u1f6f'), ('\u1fb8', '\u1fbb'), ('\u1fc8', '\u1fcb'), ('\u1fd8', '\u1fdb'),
        ('\u1fe8', '\u1fec'), ('\u1ff8', '\u1ffb'), ('\u2102', '\u2102'), ('\u2107', '\u2107'),
        ('\u210b', '\u210d'), ('\u2110', '\u2112'), ('\u2115', '\u2115'), ('\u2119', '\u211d'),
        ('\u2124', '\u2124'), ('\u2126', '\u2126'), ('\u2128', '\u2128'), ('\u212a', '\u212d'),
        ('\u2130', '\u2133'), ('\u213e', '\u213f'), ('\u2145', '\u2145'), ('\u2160', '\u216f'),
        ('\u2183', '\u2183'), ('\u24b6', '\u24cf'), ('\u2c00', '\u2c2e'), ('\u2c60', '\u2c60'),
        ('\u2c62', '\u2c64'), ('\u2c67', '\u2c67'), ('\u2c69', '\u2c69'), ('\u2c6b', '\u2c6b'),
        ('\u2c6d', '\u2c70'), ('\u2c72', '\u2c72'), ('\u2c75', '\u2c75'), ('\u2c7e', '\u2c80'),
        ('\u2c82', '\u2c82'), ('\u2c84', '\u2c84'), ('\u2c86', '\u2c86'), ('\u2c88', '\u2c88'),
        ('\u2c8a', '\u2c8a'), ('\u2c8c', '\u2c8c'), ('\u2c8e', '\u2c8e'), ('\u2c90', '\u2c90'),
        ('\u2c92', '\u2c92'), ('\u2c94', '\u2c94'), ('\u2c96', '\u2c96'), ('\u2c98', '\u2c98'),
        ('\u2c9a', '\u2c9a'), ('\u2c9c', '\u2c9c'), ('\u2c9e', '\u2c9e'), ('\u2ca0', '\u2ca0'),
        ('\u2ca2', '\u2ca2'), ('\u2ca4', '\u2ca4'), ('\u2ca6', '\u2ca6'), ('\u2ca8', '\u2ca8'),
        ('\u2caa', '\u2caa'), ('\u2cac', '\u2cac'), ('\u2cae', '\u2cae'), ('\u2cb0', '\u2cb0'),
        ('\u2cb2', '\u2cb2'), ('\u2cb4', '\u2cb4'), ('\u2cb6', '\u2cb6'), ('\u2cb8', '\u2cb8'),
        ('\u2cba', '\u2cba'), ('\u2cbc', '\u2cbc'), ('\u2cbe', '\u2cbe'), ('\u2cc0', '\u2cc0'),
        ('\u2cc2', '\u2cc2'), ('\u2cc4', '\u2cc4'), ('\u2cc6', '\u2cc6'), ('\u2cc8', '\u2cc8'),
        ('\u2cca', '\u2cca'), ('\u2ccc', '\u2ccc'), ('\u2cce', '\u2cce'), ('\u2cd0', '\u2cd0'),
        ('\u2cd2', '\u2cd2'), ('\u2cd4', '\u2cd4'), ('\u2cd6', '\u2cd6'), ('\u2cd8', '\u2cd8'),
        ('\u2cda', '\u2cda'), ('\u2cdc', '\u2cdc'), ('\u2cde', '\u2cde'), ('\u2ce0', '\u2ce0'),
        ('\u2ce2', '\u2ce2'), ('\u2ceb', '\u2ceb'), ('\u2ced', '\u2ced'), ('\u2cf2', '\u2cf2'),
        ('\ua640', '\ua640'), ('\ua642', '\ua642'), ('\ua644', '\ua644'), ('\ua646', '\ua646'),
        ('\ua648', '\ua648'), ('\ua64a', '\ua64a'), ('\ua64c', '\ua64c'), ('\ua64e', '\ua64e'),
        ('\ua650', '\ua650'), ('\ua652', '\ua652'), ('\ua654', '\ua654'), ('\ua656', '\ua656'),
        ('\ua658', '\ua658'), ('\ua65a', '\ua65a'), ('\ua65c', '\ua65c'), ('\ua65e', '\ua65e'),
        ('\ua660', '\ua660'), ('\ua662', '\ua662'), ('\ua664', '\ua664'), ('\ua666', '\ua666'),
        ('\ua668', '\ua668'), ('\ua66a', '\ua66a'), ('\ua66c', '\ua66c'), ('\ua680', '\ua680'),
        ('\ua682', '\ua682'), ('\ua684', '\ua684'), ('\ua686', '\ua686'), ('\ua688', '\ua688'),
        ('\ua68a', '\ua68a'), ('\ua68c', '\ua68c'), ('\ua68e', '\ua68e'), ('\ua690', '\ua690'),
        ('\ua692', '\ua692'), ('\ua694', '\ua694'), ('\ua696', '\ua696'), ('\ua698', '\ua698'),
        ('\ua69a', '\ua69a'), ('\ua722', '\ua722'), ('\ua724', '\ua724'), ('\ua726', '\ua726'),
        ('\ua728', '\ua728'), ('\ua72a', '\ua72a'), ('\ua72c', '\ua72c'), ('\ua72e', '\ua72e'),
        ('\ua732', '\ua732'), ('\ua734', '\ua734'), ('\ua736', '\ua736'), ('\ua738', '\ua738'),
        ('\ua73a', '\ua73a'), ('\ua73c', '\ua73c'), ('\ua73e', '\ua73e'), ('\ua740', '\ua740'),
        ('\ua742', '\ua742'), ('\ua744', '\ua744'), ('\ua746', '\ua746'), ('\ua748', '\ua748'),
        ('\ua74a', '\ua74a'), ('\ua74c', '\ua74c'), ('\ua74e', '\ua74e'), ('\ua750', '\ua750'),
        ('\ua752', '\ua752'), ('\ua754', '\ua754'), ('\ua756', '\ua756'), ('\ua758', '\ua758'),
        ('\ua75a', '\ua75a'), ('\ua75c', '\ua75c'), ('\ua75e', '\ua75e'), ('\ua760', '\ua760'),
        ('\ua762', '\ua762'), ('\ua764', '\ua764'), ('\ua766', '\ua766'), ('\ua768', '\ua768'),
        ('\ua76a', '\ua76a'), ('\ua76c', '\ua76c'), ('\ua76e', '\ua76e'), ('\ua779', '\ua779'),
        ('\ua77b', '\ua77b'), ('\ua77d', '\ua77e'), ('\ua780', '\ua780'), ('\ua782', '\ua782'),
        ('\ua784', '\ua784'), ('\ua786', '\ua786'), ('\ua78b', '\ua78b'), ('\ua78d', '\ua78d'),
        ('\ua790', '\ua790'), ('\ua792', '\ua792'), ('\ua796', '\ua796'), ('\ua798', '\ua798'),
        ('\ua79a', '\ua79a'), ('\ua79c', '\ua79c'), ('\ua79e', '\ua79e'), ('\ua7a0', '\ua7a0'),
        ('\ua7a2', '\ua7a2'), ('\ua7a4', '\ua7a4'), ('\ua7a6', '\ua7a6'), ('\ua7a8', '\ua7a8'),
        ('\ua7aa', '\ua7ad'), ('\ua7b0', '\ua7b1'), ('\uff21', '\uff3a'), ('\U00010400',
        '\U00010427'), ('\U000118a0', '\U000118bf'), ('\U0001d400', '\U0001d419'), ('\U0001d434',
        '\U0001d44d'), ('\U0001d468', '\U0001d481'), ('\U0001d49c', '\U0001d49c'), ('\U0001d49e',
        '\U0001d49f'), ('\U0001d4a2', '\U0001d4a2'), ('\U0001d4a5', '\U0001d4a6'), ('\U0001d4a9',
        '\U0001d4ac'), ('\U0001d4ae', '\U0001d4b5'), ('\U0001d4d0', '\U0001d4e9'), ('\U0001d504',
        '\U0001d505'), ('\U0001d507', '\U0001d50a'), ('\U0001d50d', '\U0001d514'), ('\U0001d516',
        '\U0001d51c'), ('\U0001d538', '\U0001d539'), ('\U0001d53b', '\U0001d53e'), ('\U0001d540',
        '\U0001d544'), ('\U0001d546', '\U0001d546'), ('\U0001d54a', '\U0001d550'), ('\U0001d56c',
        '\U0001d585'), ('\U0001d5a0', '\U0001d5b9'), ('\U0001d5d4', '\U0001d5ed'), ('\U0001d608',
        '\U0001d621'), ('\U0001d63c', '\U0001d655'), ('\U0001d670', '\U0001d689'), ('\U0001d6a8',
        '\U0001d6c0'), ('\U0001d6e2', '\U0001d6fa'), ('\U0001d71c', '\U0001d734'), ('\U0001d756',
        '\U0001d76e'), ('\U0001d790', '\U0001d7a8'), ('\U0001d7ca', '\U0001d7ca'), ('\U0001f130',
        '\U0001f149'), ('\U0001f150', '\U0001f169'), ('\U0001f170', '\U0001f189')
    ];

    pub fn Uppercase(c: char) -> bool {
        super::bsearch_range_table(c, Uppercase_table)
    }

    pub static XID_Continue_table: &'static [(char, char)] = &[
        ('\x30', '\x39'), ('\x41', '\x5a'), ('\x5f', '\x5f'), ('\x61', '\x7a'), ('\u00aa',
        '\u00aa'), ('\u00b5', '\u00b5'), ('\u00b7', '\u00b7'), ('\u00ba', '\u00ba'), ('\u00c0',
        '\u00d6'), ('\u00d8', '\u00f6'), ('\u00f8', '\u01ba'), ('\u01bb', '\u01bb'), ('\u01bc',
        '\u01bf'), ('\u01c0', '\u01c3'), ('\u01c4', '\u0293'), ('\u0294', '\u0294'), ('\u0295',
        '\u02af'), ('\u02b0', '\u02c1'), ('\u02c6', '\u02d1'), ('\u02e0', '\u02e4'), ('\u02ec',
        '\u02ec'), ('\u02ee', '\u02ee'), ('\u0300', '\u036f'), ('\u0370', '\u0373'), ('\u0374',
        '\u0374'), ('\u0376', '\u0377'), ('\u037b', '\u037d'), ('\u037f', '\u037f'), ('\u0386',
        '\u0386'), ('\u0387', '\u0387'), ('\u0388', '\u038a'), ('\u038c', '\u038c'), ('\u038e',
        '\u03a1'), ('\u03a3', '\u03f5'), ('\u03f7', '\u0481'), ('\u0483', '\u0487'), ('\u048a',
        '\u052f'), ('\u0531', '\u0556'), ('\u0559', '\u0559'), ('\u0561', '\u0587'), ('\u0591',
        '\u05bd'), ('\u05bf', '\u05bf'), ('\u05c1', '\u05c2'), ('\u05c4', '\u05c5'), ('\u05c7',
        '\u05c7'), ('\u05d0', '\u05ea'), ('\u05f0', '\u05f2'), ('\u0610', '\u061a'), ('\u0620',
        '\u063f'), ('\u0640', '\u0640'), ('\u0641', '\u064a'), ('\u064b', '\u065f'), ('\u0660',
        '\u0669'), ('\u066e', '\u066f'), ('\u0670', '\u0670'), ('\u0671', '\u06d3'), ('\u06d5',
        '\u06d5'), ('\u06d6', '\u06dc'), ('\u06df', '\u06e4'), ('\u06e5', '\u06e6'), ('\u06e7',
        '\u06e8'), ('\u06ea', '\u06ed'), ('\u06ee', '\u06ef'), ('\u06f0', '\u06f9'), ('\u06fa',
        '\u06fc'), ('\u06ff', '\u06ff'), ('\u0710', '\u0710'), ('\u0711', '\u0711'), ('\u0712',
        '\u072f'), ('\u0730', '\u074a'), ('\u074d', '\u07a5'), ('\u07a6', '\u07b0'), ('\u07b1',
        '\u07b1'), ('\u07c0', '\u07c9'), ('\u07ca', '\u07ea'), ('\u07eb', '\u07f3'), ('\u07f4',
        '\u07f5'), ('\u07fa', '\u07fa'), ('\u0800', '\u0815'), ('\u0816', '\u0819'), ('\u081a',
        '\u081a'), ('\u081b', '\u0823'), ('\u0824', '\u0824'), ('\u0825', '\u0827'), ('\u0828',
        '\u0828'), ('\u0829', '\u082d'), ('\u0840', '\u0858'), ('\u0859', '\u085b'), ('\u08a0',
        '\u08b2'), ('\u08e4', '\u0902'), ('\u0903', '\u0903'), ('\u0904', '\u0939'), ('\u093a',
        '\u093a'), ('\u093b', '\u093b'), ('\u093c', '\u093c'), ('\u093d', '\u093d'), ('\u093e',
        '\u0940'), ('\u0941', '\u0948'), ('\u0949', '\u094c'), ('\u094d', '\u094d'), ('\u094e',
        '\u094f'), ('\u0950', '\u0950'), ('\u0951', '\u0957'), ('\u0958', '\u0961'), ('\u0962',
        '\u0963'), ('\u0966', '\u096f'), ('\u0971', '\u0971'), ('\u0972', '\u0980'), ('\u0981',
        '\u0981'), ('\u0982', '\u0983'), ('\u0985', '\u098c'), ('\u098f', '\u0990'), ('\u0993',
        '\u09a8'), ('\u09aa', '\u09b0'), ('\u09b2', '\u09b2'), ('\u09b6', '\u09b9'), ('\u09bc',
        '\u09bc'), ('\u09bd', '\u09bd'), ('\u09be', '\u09c0'), ('\u09c1', '\u09c4'), ('\u09c7',
        '\u09c8'), ('\u09cb', '\u09cc'), ('\u09cd', '\u09cd'), ('\u09ce', '\u09ce'), ('\u09d7',
        '\u09d7'), ('\u09dc', '\u09dd'), ('\u09df', '\u09e1'), ('\u09e2', '\u09e3'), ('\u09e6',
        '\u09ef'), ('\u09f0', '\u09f1'), ('\u0a01', '\u0a02'), ('\u0a03', '\u0a03'), ('\u0a05',
        '\u0a0a'), ('\u0a0f', '\u0a10'), ('\u0a13', '\u0a28'), ('\u0a2a', '\u0a30'), ('\u0a32',
        '\u0a33'), ('\u0a35', '\u0a36'), ('\u0a38', '\u0a39'), ('\u0a3c', '\u0a3c'), ('\u0a3e',
        '\u0a40'), ('\u0a41', '\u0a42'), ('\u0a47', '\u0a48'), ('\u0a4b', '\u0a4d'), ('\u0a51',
        '\u0a51'), ('\u0a59', '\u0a5c'), ('\u0a5e', '\u0a5e'), ('\u0a66', '\u0a6f'), ('\u0a70',
        '\u0a71'), ('\u0a72', '\u0a74'), ('\u0a75', '\u0a75'), ('\u0a81', '\u0a82'), ('\u0a83',
        '\u0a83'), ('\u0a85', '\u0a8d'), ('\u0a8f', '\u0a91'), ('\u0a93', '\u0aa8'), ('\u0aaa',
        '\u0ab0'), ('\u0ab2', '\u0ab3'), ('\u0ab5', '\u0ab9'), ('\u0abc', '\u0abc'), ('\u0abd',
        '\u0abd'), ('\u0abe', '\u0ac0'), ('\u0ac1', '\u0ac5'), ('\u0ac7', '\u0ac8'), ('\u0ac9',
        '\u0ac9'), ('\u0acb', '\u0acc'), ('\u0acd', '\u0acd'), ('\u0ad0', '\u0ad0'), ('\u0ae0',
        '\u0ae1'), ('\u0ae2', '\u0ae3'), ('\u0ae6', '\u0aef'), ('\u0b01', '\u0b01'), ('\u0b02',
        '\u0b03'), ('\u0b05', '\u0b0c'), ('\u0b0f', '\u0b10'), ('\u0b13', '\u0b28'), ('\u0b2a',
        '\u0b30'), ('\u0b32', '\u0b33'), ('\u0b35', '\u0b39'), ('\u0b3c', '\u0b3c'), ('\u0b3d',
        '\u0b3d'), ('\u0b3e', '\u0b3e'), ('\u0b3f', '\u0b3f'), ('\u0b40', '\u0b40'), ('\u0b41',
        '\u0b44'), ('\u0b47', '\u0b48'), ('\u0b4b', '\u0b4c'), ('\u0b4d', '\u0b4d'), ('\u0b56',
        '\u0b56'), ('\u0b57', '\u0b57'), ('\u0b5c', '\u0b5d'), ('\u0b5f', '\u0b61'), ('\u0b62',
        '\u0b63'), ('\u0b66', '\u0b6f'), ('\u0b71', '\u0b71'), ('\u0b82', '\u0b82'), ('\u0b83',
        '\u0b83'), ('\u0b85', '\u0b8a'), ('\u0b8e', '\u0b90'), ('\u0b92', '\u0b95'), ('\u0b99',
        '\u0b9a'), ('\u0b9c', '\u0b9c'), ('\u0b9e', '\u0b9f'), ('\u0ba3', '\u0ba4'), ('\u0ba8',
        '\u0baa'), ('\u0bae', '\u0bb9'), ('\u0bbe', '\u0bbf'), ('\u0bc0', '\u0bc0'), ('\u0bc1',
        '\u0bc2'), ('\u0bc6', '\u0bc8'), ('\u0bca', '\u0bcc'), ('\u0bcd', '\u0bcd'), ('\u0bd0',
        '\u0bd0'), ('\u0bd7', '\u0bd7'), ('\u0be6', '\u0bef'), ('\u0c00', '\u0c00'), ('\u0c01',
        '\u0c03'), ('\u0c05', '\u0c0c'), ('\u0c0e', '\u0c10'), ('\u0c12', '\u0c28'), ('\u0c2a',
        '\u0c39'), ('\u0c3d', '\u0c3d'), ('\u0c3e', '\u0c40'), ('\u0c41', '\u0c44'), ('\u0c46',
        '\u0c48'), ('\u0c4a', '\u0c4d'), ('\u0c55', '\u0c56'), ('\u0c58', '\u0c59'), ('\u0c60',
        '\u0c61'), ('\u0c62', '\u0c63'), ('\u0c66', '\u0c6f'), ('\u0c81', '\u0c81'), ('\u0c82',
        '\u0c83'), ('\u0c85', '\u0c8c'), ('\u0c8e', '\u0c90'), ('\u0c92', '\u0ca8'), ('\u0caa',
        '\u0cb3'), ('\u0cb5', '\u0cb9'), ('\u0cbc', '\u0cbc'), ('\u0cbd', '\u0cbd'), ('\u0cbe',
        '\u0cbe'), ('\u0cbf', '\u0cbf'), ('\u0cc0', '\u0cc4'), ('\u0cc6', '\u0cc6'), ('\u0cc7',
        '\u0cc8'), ('\u0cca', '\u0ccb'), ('\u0ccc', '\u0ccd'), ('\u0cd5', '\u0cd6'), ('\u0cde',
        '\u0cde'), ('\u0ce0', '\u0ce1'), ('\u0ce2', '\u0ce3'), ('\u0ce6', '\u0cef'), ('\u0cf1',
        '\u0cf2'), ('\u0d01', '\u0d01'), ('\u0d02', '\u0d03'), ('\u0d05', '\u0d0c'), ('\u0d0e',
        '\u0d10'), ('\u0d12', '\u0d3a'), ('\u0d3d', '\u0d3d'), ('\u0d3e', '\u0d40'), ('\u0d41',
        '\u0d44'), ('\u0d46', '\u0d48'), ('\u0d4a', '\u0d4c'), ('\u0d4d', '\u0d4d'), ('\u0d4e',
        '\u0d4e'), ('\u0d57', '\u0d57'), ('\u0d60', '\u0d61'), ('\u0d62', '\u0d63'), ('\u0d66',
        '\u0d6f'), ('\u0d7a', '\u0d7f'), ('\u0d82', '\u0d83'), ('\u0d85', '\u0d96'), ('\u0d9a',
        '\u0db1'), ('\u0db3', '\u0dbb'), ('\u0dbd', '\u0dbd'), ('\u0dc0', '\u0dc6'), ('\u0dca',
        '\u0dca'), ('\u0dcf', '\u0dd1'), ('\u0dd2', '\u0dd4'), ('\u0dd6', '\u0dd6'), ('\u0dd8',
        '\u0ddf'), ('\u0de6', '\u0def'), ('\u0df2', '\u0df3'), ('\u0e01', '\u0e30'), ('\u0e31',
        '\u0e31'), ('\u0e32', '\u0e33'), ('\u0e34', '\u0e3a'), ('\u0e40', '\u0e45'), ('\u0e46',
        '\u0e46'), ('\u0e47', '\u0e4e'), ('\u0e50', '\u0e59'), ('\u0e81', '\u0e82'), ('\u0e84',
        '\u0e84'), ('\u0e87', '\u0e88'), ('\u0e8a', '\u0e8a'), ('\u0e8d', '\u0e8d'), ('\u0e94',
        '\u0e97'), ('\u0e99', '\u0e9f'), ('\u0ea1', '\u0ea3'), ('\u0ea5', '\u0ea5'), ('\u0ea7',
        '\u0ea7'), ('\u0eaa', '\u0eab'), ('\u0ead', '\u0eb0'), ('\u0eb1', '\u0eb1'), ('\u0eb2',
        '\u0eb3'), ('\u0eb4', '\u0eb9'), ('\u0ebb', '\u0ebc'), ('\u0ebd', '\u0ebd'), ('\u0ec0',
        '\u0ec4'), ('\u0ec6', '\u0ec6'), ('\u0ec8', '\u0ecd'), ('\u0ed0', '\u0ed9'), ('\u0edc',
        '\u0edf'), ('\u0f00', '\u0f00'), ('\u0f18', '\u0f19'), ('\u0f20', '\u0f29'), ('\u0f35',
        '\u0f35'), ('\u0f37', '\u0f37'), ('\u0f39', '\u0f39'), ('\u0f3e', '\u0f3f'), ('\u0f40',
        '\u0f47'), ('\u0f49', '\u0f6c'), ('\u0f71', '\u0f7e'), ('\u0f7f', '\u0f7f'), ('\u0f80',
        '\u0f84'), ('\u0f86', '\u0f87'), ('\u0f88', '\u0f8c'), ('\u0f8d', '\u0f97'), ('\u0f99',
        '\u0fbc'), ('\u0fc6', '\u0fc6'), ('\u1000', '\u102a'), ('\u102b', '\u102c'), ('\u102d',
        '\u1030'), ('\u1031', '\u1031'), ('\u1032', '\u1037'), ('\u1038', '\u1038'), ('\u1039',
        '\u103a'), ('\u103b', '\u103c'), ('\u103d', '\u103e'), ('\u103f', '\u103f'), ('\u1040',
        '\u1049'), ('\u1050', '\u1055'), ('\u1056', '\u1057'), ('\u1058', '\u1059'), ('\u105a',
        '\u105d'), ('\u105e', '\u1060'), ('\u1061', '\u1061'), ('\u1062', '\u1064'), ('\u1065',
        '\u1066'), ('\u1067', '\u106d'), ('\u106e', '\u1070'), ('\u1071', '\u1074'), ('\u1075',
        '\u1081'), ('\u1082', '\u1082'), ('\u1083', '\u1084'), ('\u1085', '\u1086'), ('\u1087',
        '\u108c'), ('\u108d', '\u108d'), ('\u108e', '\u108e'), ('\u108f', '\u108f'), ('\u1090',
        '\u1099'), ('\u109a', '\u109c'), ('\u109d', '\u109d'), ('\u10a0', '\u10c5'), ('\u10c7',
        '\u10c7'), ('\u10cd', '\u10cd'), ('\u10d0', '\u10fa'), ('\u10fc', '\u10fc'), ('\u10fd',
        '\u1248'), ('\u124a', '\u124d'), ('\u1250', '\u1256'), ('\u1258', '\u1258'), ('\u125a',
        '\u125d'), ('\u1260', '\u1288'), ('\u128a', '\u128d'), ('\u1290', '\u12b0'), ('\u12b2',
        '\u12b5'), ('\u12b8', '\u12be'), ('\u12c0', '\u12c0'), ('\u12c2', '\u12c5'), ('\u12c8',
        '\u12d6'), ('\u12d8', '\u1310'), ('\u1312', '\u1315'), ('\u1318', '\u135a'), ('\u135d',
        '\u135f'), ('\u1369', '\u1371'), ('\u1380', '\u138f'), ('\u13a0', '\u13f4'), ('\u1401',
        '\u166c'), ('\u166f', '\u167f'), ('\u1681', '\u169a'), ('\u16a0', '\u16ea'), ('\u16ee',
        '\u16f0'), ('\u16f1', '\u16f8'), ('\u1700', '\u170c'), ('\u170e', '\u1711'), ('\u1712',
        '\u1714'), ('\u1720', '\u1731'), ('\u1732', '\u1734'), ('\u1740', '\u1751'), ('\u1752',
        '\u1753'), ('\u1760', '\u176c'), ('\u176e', '\u1770'), ('\u1772', '\u1773'), ('\u1780',
        '\u17b3'), ('\u17b4', '\u17b5'), ('\u17b6', '\u17b6'), ('\u17b7', '\u17bd'), ('\u17be',
        '\u17c5'), ('\u17c6', '\u17c6'), ('\u17c7', '\u17c8'), ('\u17c9', '\u17d3'), ('\u17d7',
        '\u17d7'), ('\u17dc', '\u17dc'), ('\u17dd', '\u17dd'), ('\u17e0', '\u17e9'), ('\u180b',
        '\u180d'), ('\u1810', '\u1819'), ('\u1820', '\u1842'), ('\u1843', '\u1843'), ('\u1844',
        '\u1877'), ('\u1880', '\u18a8'), ('\u18a9', '\u18a9'), ('\u18aa', '\u18aa'), ('\u18b0',
        '\u18f5'), ('\u1900', '\u191e'), ('\u1920', '\u1922'), ('\u1923', '\u1926'), ('\u1927',
        '\u1928'), ('\u1929', '\u192b'), ('\u1930', '\u1931'), ('\u1932', '\u1932'), ('\u1933',
        '\u1938'), ('\u1939', '\u193b'), ('\u1946', '\u194f'), ('\u1950', '\u196d'), ('\u1970',
        '\u1974'), ('\u1980', '\u19ab'), ('\u19b0', '\u19c0'), ('\u19c1', '\u19c7'), ('\u19c8',
        '\u19c9'), ('\u19d0', '\u19d9'), ('\u19da', '\u19da'), ('\u1a00', '\u1a16'), ('\u1a17',
        '\u1a18'), ('\u1a19', '\u1a1a'), ('\u1a1b', '\u1a1b'), ('\u1a20', '\u1a54'), ('\u1a55',
        '\u1a55'), ('\u1a56', '\u1a56'), ('\u1a57', '\u1a57'), ('\u1a58', '\u1a5e'), ('\u1a60',
        '\u1a60'), ('\u1a61', '\u1a61'), ('\u1a62', '\u1a62'), ('\u1a63', '\u1a64'), ('\u1a65',
        '\u1a6c'), ('\u1a6d', '\u1a72'), ('\u1a73', '\u1a7c'), ('\u1a7f', '\u1a7f'), ('\u1a80',
        '\u1a89'), ('\u1a90', '\u1a99'), ('\u1aa7', '\u1aa7'), ('\u1ab0', '\u1abd'), ('\u1b00',
        '\u1b03'), ('\u1b04', '\u1b04'), ('\u1b05', '\u1b33'), ('\u1b34', '\u1b34'), ('\u1b35',
        '\u1b35'), ('\u1b36', '\u1b3a'), ('\u1b3b', '\u1b3b'), ('\u1b3c', '\u1b3c'), ('\u1b3d',
        '\u1b41'), ('\u1b42', '\u1b42'), ('\u1b43', '\u1b44'), ('\u1b45', '\u1b4b'), ('\u1b50',
        '\u1b59'), ('\u1b6b', '\u1b73'), ('\u1b80', '\u1b81'), ('\u1b82', '\u1b82'), ('\u1b83',
        '\u1ba0'), ('\u1ba1', '\u1ba1'), ('\u1ba2', '\u1ba5'), ('\u1ba6', '\u1ba7'), ('\u1ba8',
        '\u1ba9'), ('\u1baa', '\u1baa'), ('\u1bab', '\u1bad'), ('\u1bae', '\u1baf'), ('\u1bb0',
        '\u1bb9'), ('\u1bba', '\u1be5'), ('\u1be6', '\u1be6'), ('\u1be7', '\u1be7'), ('\u1be8',
        '\u1be9'), ('\u1bea', '\u1bec'), ('\u1bed', '\u1bed'), ('\u1bee', '\u1bee'), ('\u1bef',
        '\u1bf1'), ('\u1bf2', '\u1bf3'), ('\u1c00', '\u1c23'), ('\u1c24', '\u1c2b'), ('\u1c2c',
        '\u1c33'), ('\u1c34', '\u1c35'), ('\u1c36', '\u1c37'), ('\u1c40', '\u1c49'), ('\u1c4d',
        '\u1c4f'), ('\u1c50', '\u1c59'), ('\u1c5a', '\u1c77'), ('\u1c78', '\u1c7d'), ('\u1cd0',
        '\u1cd2'), ('\u1cd4', '\u1ce0'), ('\u1ce1', '\u1ce1'), ('\u1ce2', '\u1ce8'), ('\u1ce9',
        '\u1cec'), ('\u1ced', '\u1ced'), ('\u1cee', '\u1cf1'), ('\u1cf2', '\u1cf3'), ('\u1cf4',
        '\u1cf4'), ('\u1cf5', '\u1cf6'), ('\u1cf8', '\u1cf9'), ('\u1d00', '\u1d2b'), ('\u1d2c',
        '\u1d6a'), ('\u1d6b', '\u1d77'), ('\u1d78', '\u1d78'), ('\u1d79', '\u1d9a'), ('\u1d9b',
        '\u1dbf'), ('\u1dc0', '\u1df5'), ('\u1dfc', '\u1dff'), ('\u1e00', '\u1f15'), ('\u1f18',
        '\u1f1d'), ('\u1f20', '\u1f45'), ('\u1f48', '\u1f4d'), ('\u1f50', '\u1f57'), ('\u1f59',
        '\u1f59'), ('\u1f5b', '\u1f5b'), ('\u1f5d', '\u1f5d'), ('\u1f5f', '\u1f7d'), ('\u1f80',
        '\u1fb4'), ('\u1fb6', '\u1fbc'), ('\u1fbe', '\u1fbe'), ('\u1fc2', '\u1fc4'), ('\u1fc6',
        '\u1fcc'), ('\u1fd0', '\u1fd3'), ('\u1fd6', '\u1fdb'), ('\u1fe0', '\u1fec'), ('\u1ff2',
        '\u1ff4'), ('\u1ff6', '\u1ffc'), ('\u203f', '\u2040'), ('\u2054', '\u2054'), ('\u2071',
        '\u2071'), ('\u207f', '\u207f'), ('\u2090', '\u209c'), ('\u20d0', '\u20dc'), ('\u20e1',
        '\u20e1'), ('\u20e5', '\u20f0'), ('\u2102', '\u2102'), ('\u2107', '\u2107'), ('\u210a',
        '\u2113'), ('\u2115', '\u2115'), ('\u2118', '\u2118'), ('\u2119', '\u211d'), ('\u2124',
        '\u2124'), ('\u2126', '\u2126'), ('\u2128', '\u2128'), ('\u212a', '\u212d'), ('\u212e',
        '\u212e'), ('\u212f', '\u2134'), ('\u2135', '\u2138'), ('\u2139', '\u2139'), ('\u213c',
        '\u213f'), ('\u2145', '\u2149'), ('\u214e', '\u214e'), ('\u2160', '\u2182'), ('\u2183',
        '\u2184'), ('\u2185', '\u2188'), ('\u2c00', '\u2c2e'), ('\u2c30', '\u2c5e'), ('\u2c60',
        '\u2c7b'), ('\u2c7c', '\u2c7d'), ('\u2c7e', '\u2ce4'), ('\u2ceb', '\u2cee'), ('\u2cef',
        '\u2cf1'), ('\u2cf2', '\u2cf3'), ('\u2d00', '\u2d25'), ('\u2d27', '\u2d27'), ('\u2d2d',
        '\u2d2d'), ('\u2d30', '\u2d67'), ('\u2d6f', '\u2d6f'), ('\u2d7f', '\u2d7f'), ('\u2d80',
        '\u2d96'), ('\u2da0', '\u2da6'), ('\u2da8', '\u2dae'), ('\u2db0', '\u2db6'), ('\u2db8',
        '\u2dbe'), ('\u2dc0', '\u2dc6'), ('\u2dc8', '\u2dce'), ('\u2dd0', '\u2dd6'), ('\u2dd8',
        '\u2dde'), ('\u2de0', '\u2dff'), ('\u3005', '\u3005'), ('\u3006', '\u3006'), ('\u3007',
        '\u3007'), ('\u3021', '\u3029'), ('\u302a', '\u302d'), ('\u302e', '\u302f'), ('\u3031',
        '\u3035'), ('\u3038', '\u303a'), ('\u303b', '\u303b'), ('\u303c', '\u303c'), ('\u3041',
        '\u3096'), ('\u3099', '\u309a'), ('\u309d', '\u309e'), ('\u309f', '\u309f'), ('\u30a1',
        '\u30fa'), ('\u30fc', '\u30fe'), ('\u30ff', '\u30ff'), ('\u3105', '\u312d'), ('\u3131',
        '\u318e'), ('\u31a0', '\u31ba'), ('\u31f0', '\u31ff'), ('\u3400', '\u4db5'), ('\u4e00',
        '\u9fcc'), ('\ua000', '\ua014'), ('\ua015', '\ua015'), ('\ua016', '\ua48c'), ('\ua4d0',
        '\ua4f7'), ('\ua4f8', '\ua4fd'), ('\ua500', '\ua60b'), ('\ua60c', '\ua60c'), ('\ua610',
        '\ua61f'), ('\ua620', '\ua629'), ('\ua62a', '\ua62b'), ('\ua640', '\ua66d'), ('\ua66e',
        '\ua66e'), ('\ua66f', '\ua66f'), ('\ua674', '\ua67d'), ('\ua67f', '\ua67f'), ('\ua680',
        '\ua69b'), ('\ua69c', '\ua69d'), ('\ua69f', '\ua69f'), ('\ua6a0', '\ua6e5'), ('\ua6e6',
        '\ua6ef'), ('\ua6f0', '\ua6f1'), ('\ua717', '\ua71f'), ('\ua722', '\ua76f'), ('\ua770',
        '\ua770'), ('\ua771', '\ua787'), ('\ua788', '\ua788'), ('\ua78b', '\ua78e'), ('\ua790',
        '\ua7ad'), ('\ua7b0', '\ua7b1'), ('\ua7f7', '\ua7f7'), ('\ua7f8', '\ua7f9'), ('\ua7fa',
        '\ua7fa'), ('\ua7fb', '\ua801'), ('\ua802', '\ua802'), ('\ua803', '\ua805'), ('\ua806',
        '\ua806'), ('\ua807', '\ua80a'), ('\ua80b', '\ua80b'), ('\ua80c', '\ua822'), ('\ua823',
        '\ua824'), ('\ua825', '\ua826'), ('\ua827', '\ua827'), ('\ua840', '\ua873'), ('\ua880',
        '\ua881'), ('\ua882', '\ua8b3'), ('\ua8b4', '\ua8c3'), ('\ua8c4', '\ua8c4'), ('\ua8d0',
        '\ua8d9'), ('\ua8e0', '\ua8f1'), ('\ua8f2', '\ua8f7'), ('\ua8fb', '\ua8fb'), ('\ua900',
        '\ua909'), ('\ua90a', '\ua925'), ('\ua926', '\ua92d'), ('\ua930', '\ua946'), ('\ua947',
        '\ua951'), ('\ua952', '\ua953'), ('\ua960', '\ua97c'), ('\ua980', '\ua982'), ('\ua983',
        '\ua983'), ('\ua984', '\ua9b2'), ('\ua9b3', '\ua9b3'), ('\ua9b4', '\ua9b5'), ('\ua9b6',
        '\ua9b9'), ('\ua9ba', '\ua9bb'), ('\ua9bc', '\ua9bc'), ('\ua9bd', '\ua9c0'), ('\ua9cf',
        '\ua9cf'), ('\ua9d0', '\ua9d9'), ('\ua9e0', '\ua9e4'), ('\ua9e5', '\ua9e5'), ('\ua9e6',
        '\ua9e6'), ('\ua9e7', '\ua9ef'), ('\ua9f0', '\ua9f9'), ('\ua9fa', '\ua9fe'), ('\uaa00',
        '\uaa28'), ('\uaa29', '\uaa2e'), ('\uaa2f', '\uaa30'), ('\uaa31', '\uaa32'), ('\uaa33',
        '\uaa34'), ('\uaa35', '\uaa36'), ('\uaa40', '\uaa42'), ('\uaa43', '\uaa43'), ('\uaa44',
        '\uaa4b'), ('\uaa4c', '\uaa4c'), ('\uaa4d', '\uaa4d'), ('\uaa50', '\uaa59'), ('\uaa60',
        '\uaa6f'), ('\uaa70', '\uaa70'), ('\uaa71', '\uaa76'), ('\uaa7a', '\uaa7a'), ('\uaa7b',
        '\uaa7b'), ('\uaa7c', '\uaa7c'), ('\uaa7d', '\uaa7d'), ('\uaa7e', '\uaaaf'), ('\uaab0',
        '\uaab0'), ('\uaab1', '\uaab1'), ('\uaab2', '\uaab4'), ('\uaab5', '\uaab6'), ('\uaab7',
        '\uaab8'), ('\uaab9', '\uaabd'), ('\uaabe', '\uaabf'), ('\uaac0', '\uaac0'), ('\uaac1',
        '\uaac1'), ('\uaac2', '\uaac2'), ('\uaadb', '\uaadc'), ('\uaadd', '\uaadd'), ('\uaae0',
        '\uaaea'), ('\uaaeb', '\uaaeb'), ('\uaaec', '\uaaed'), ('\uaaee', '\uaaef'), ('\uaaf2',
        '\uaaf2'), ('\uaaf3', '\uaaf4'), ('\uaaf5', '\uaaf5'), ('\uaaf6', '\uaaf6'), ('\uab01',
        '\uab06'), ('\uab09', '\uab0e'), ('\uab11', '\uab16'), ('\uab20', '\uab26'), ('\uab28',
        '\uab2e'), ('\uab30', '\uab5a'), ('\uab5c', '\uab5f'), ('\uab64', '\uab65'), ('\uabc0',
        '\uabe2'), ('\uabe3', '\uabe4'), ('\uabe5', '\uabe5'), ('\uabe6', '\uabe7'), ('\uabe8',
        '\uabe8'), ('\uabe9', '\uabea'), ('\uabec', '\uabec'), ('\uabed', '\uabed'), ('\uabf0',
        '\uabf9'), ('\uac00', '\ud7a3'), ('\ud7b0', '\ud7c6'), ('\ud7cb', '\ud7fb'), ('\uf900',
        '\ufa6d'), ('\ufa70', '\ufad9'), ('\ufb00', '\ufb06'), ('\ufb13', '\ufb17'), ('\ufb1d',
        '\ufb1d'), ('\ufb1e', '\ufb1e'), ('\ufb1f', '\ufb28'), ('\ufb2a', '\ufb36'), ('\ufb38',
        '\ufb3c'), ('\ufb3e', '\ufb3e'), ('\ufb40', '\ufb41'), ('\ufb43', '\ufb44'), ('\ufb46',
        '\ufbb1'), ('\ufbd3', '\ufc5d'), ('\ufc64', '\ufd3d'), ('\ufd50', '\ufd8f'), ('\ufd92',
        '\ufdc7'), ('\ufdf0', '\ufdf9'), ('\ufe00', '\ufe0f'), ('\ufe20', '\ufe2d'), ('\ufe33',
        '\ufe34'), ('\ufe4d', '\ufe4f'), ('\ufe71', '\ufe71'), ('\ufe73', '\ufe73'), ('\ufe77',
        '\ufe77'), ('\ufe79', '\ufe79'), ('\ufe7b', '\ufe7b'), ('\ufe7d', '\ufe7d'), ('\ufe7f',
        '\ufefc'), ('\uff10', '\uff19'), ('\uff21', '\uff3a'), ('\uff3f', '\uff3f'), ('\uff41',
        '\uff5a'), ('\uff66', '\uff6f'), ('\uff70', '\uff70'), ('\uff71', '\uff9d'), ('\uff9e',
        '\uff9f'), ('\uffa0', '\uffbe'), ('\uffc2', '\uffc7'), ('\uffca', '\uffcf'), ('\uffd2',
        '\uffd7'), ('\uffda', '\uffdc'), ('\U00010000', '\U0001000b'), ('\U0001000d', '\U00010026'),
        ('\U00010028', '\U0001003a'), ('\U0001003c', '\U0001003d'), ('\U0001003f', '\U0001004d'),
        ('\U00010050', '\U0001005d'), ('\U00010080', '\U000100fa'), ('\U00010140', '\U00010174'),
        ('\U000101fd', '\U000101fd'), ('\U00010280', '\U0001029c'), ('\U000102a0', '\U000102d0'),
        ('\U000102e0', '\U000102e0'), ('\U00010300', '\U0001031f'), ('\U00010330', '\U00010340'),
        ('\U00010341', '\U00010341'), ('\U00010342', '\U00010349'), ('\U0001034a', '\U0001034a'),
        ('\U00010350', '\U00010375'), ('\U00010376', '\U0001037a'), ('\U00010380', '\U0001039d'),
        ('\U000103a0', '\U000103c3'), ('\U000103c8', '\U000103cf'), ('\U000103d1', '\U000103d5'),
        ('\U00010400', '\U0001044f'), ('\U00010450', '\U0001049d'), ('\U000104a0', '\U000104a9'),
        ('\U00010500', '\U00010527'), ('\U00010530', '\U00010563'), ('\U00010600', '\U00010736'),
        ('\U00010740', '\U00010755'), ('\U00010760', '\U00010767'), ('\U00010800', '\U00010805'),
        ('\U00010808', '\U00010808'), ('\U0001080a', '\U00010835'), ('\U00010837', '\U00010838'),
        ('\U0001083c', '\U0001083c'), ('\U0001083f', '\U00010855'), ('\U00010860', '\U00010876'),
        ('\U00010880', '\U0001089e'), ('\U00010900', '\U00010915'), ('\U00010920', '\U00010939'),
        ('\U00010980', '\U000109b7'), ('\U000109be', '\U000109bf'), ('\U00010a00', '\U00010a00'),
        ('\U00010a01', '\U00010a03'), ('\U00010a05', '\U00010a06'), ('\U00010a0c', '\U00010a0f'),
        ('\U00010a10', '\U00010a13'), ('\U00010a15', '\U00010a17'), ('\U00010a19', '\U00010a33'),
        ('\U00010a38', '\U00010a3a'), ('\U00010a3f', '\U00010a3f'), ('\U00010a60', '\U00010a7c'),
        ('\U00010a80', '\U00010a9c'), ('\U00010ac0', '\U00010ac7'), ('\U00010ac9', '\U00010ae4'),
        ('\U00010ae5', '\U00010ae6'), ('\U00010b00', '\U00010b35'), ('\U00010b40', '\U00010b55'),
        ('\U00010b60', '\U00010b72'), ('\U00010b80', '\U00010b91'), ('\U00010c00', '\U00010c48'),
        ('\U00011000', '\U00011000'), ('\U00011001', '\U00011001'), ('\U00011002', '\U00011002'),
        ('\U00011003', '\U00011037'), ('\U00011038', '\U00011046'), ('\U00011066', '\U0001106f'),
        ('\U0001107f', '\U00011081'), ('\U00011082', '\U00011082'), ('\U00011083', '\U000110af'),
        ('\U000110b0', '\U000110b2'), ('\U000110b3', '\U000110b6'), ('\U000110b7', '\U000110b8'),
        ('\U000110b9', '\U000110ba'), ('\U000110d0', '\U000110e8'), ('\U000110f0', '\U000110f9'),
        ('\U00011100', '\U00011102'), ('\U00011103', '\U00011126'), ('\U00011127', '\U0001112b'),
        ('\U0001112c', '\U0001112c'), ('\U0001112d', '\U00011134'), ('\U00011136', '\U0001113f'),
        ('\U00011150', '\U00011172'), ('\U00011173', '\U00011173'), ('\U00011176', '\U00011176'),
        ('\U00011180', '\U00011181'), ('\U00011182', '\U00011182'), ('\U00011183', '\U000111b2'),
        ('\U000111b3', '\U000111b5'), ('\U000111b6', '\U000111be'), ('\U000111bf', '\U000111c0'),
        ('\U000111c1', '\U000111c4'), ('\U000111d0', '\U000111d9'), ('\U000111da', '\U000111da'),
        ('\U00011200', '\U00011211'), ('\U00011213', '\U0001122b'), ('\U0001122c', '\U0001122e'),
        ('\U0001122f', '\U00011231'), ('\U00011232', '\U00011233'), ('\U00011234', '\U00011234'),
        ('\U00011235', '\U00011235'), ('\U00011236', '\U00011237'), ('\U000112b0', '\U000112de'),
        ('\U000112df', '\U000112df'), ('\U000112e0', '\U000112e2'), ('\U000112e3', '\U000112ea'),
        ('\U000112f0', '\U000112f9'), ('\U00011301', '\U00011301'), ('\U00011302', '\U00011303'),
        ('\U00011305', '\U0001130c'), ('\U0001130f', '\U00011310'), ('\U00011313', '\U00011328'),
        ('\U0001132a', '\U00011330'), ('\U00011332', '\U00011333'), ('\U00011335', '\U00011339'),
        ('\U0001133c', '\U0001133c'), ('\U0001133d', '\U0001133d'), ('\U0001133e', '\U0001133f'),
        ('\U00011340', '\U00011340'), ('\U00011341', '\U00011344'), ('\U00011347', '\U00011348'),
        ('\U0001134b', '\U0001134d'), ('\U00011357', '\U00011357'), ('\U0001135d', '\U00011361'),
        ('\U00011362', '\U00011363'), ('\U00011366', '\U0001136c'), ('\U00011370', '\U00011374'),
        ('\U00011480', '\U000114af'), ('\U000114b0', '\U000114b2'), ('\U000114b3', '\U000114b8'),
        ('\U000114b9', '\U000114b9'), ('\U000114ba', '\U000114ba'), ('\U000114bb', '\U000114be'),
        ('\U000114bf', '\U000114c0'), ('\U000114c1', '\U000114c1'), ('\U000114c2', '\U000114c3'),
        ('\U000114c4', '\U000114c5'), ('\U000114c7', '\U000114c7'), ('\U000114d0', '\U000114d9'),
        ('\U00011580', '\U000115ae'), ('\U000115af', '\U000115b1'), ('\U000115b2', '\U000115b5'),
        ('\U000115b8', '\U000115bb'), ('\U000115bc', '\U000115bd'), ('\U000115be', '\U000115be'),
        ('\U000115bf', '\U000115c0'), ('\U00011600', '\U0001162f'), ('\U00011630', '\U00011632'),
        ('\U00011633', '\U0001163a'), ('\U0001163b', '\U0001163c'), ('\U0001163d', '\U0001163d'),
        ('\U0001163e', '\U0001163e'), ('\U0001163f', '\U00011640'), ('\U00011644', '\U00011644'),
        ('\U00011650', '\U00011659'), ('\U00011680', '\U000116aa'), ('\U000116ab', '\U000116ab'),
        ('\U000116ac', '\U000116ac'), ('\U000116ad', '\U000116ad'), ('\U000116ae', '\U000116af'),
        ('\U000116b0', '\U000116b5'), ('\U000116b6', '\U000116b6'), ('\U000116b7', '\U000116b7'),
        ('\U000116c0', '\U000116c9'), ('\U000118a0', '\U000118df'), ('\U000118e0', '\U000118e9'),
        ('\U000118ff', '\U000118ff'), ('\U00011ac0', '\U00011af8'), ('\U00012000', '\U00012398'),
        ('\U00012400', '\U0001246e'), ('\U00013000', '\U0001342e'), ('\U00016800', '\U00016a38'),
        ('\U00016a40', '\U00016a5e'), ('\U00016a60', '\U00016a69'), ('\U00016ad0', '\U00016aed'),
        ('\U00016af0', '\U00016af4'), ('\U00016b00', '\U00016b2f'), ('\U00016b30', '\U00016b36'),
        ('\U00016b40', '\U00016b43'), ('\U00016b50', '\U00016b59'), ('\U00016b63', '\U00016b77'),
        ('\U00016b7d', '\U00016b8f'), ('\U00016f00', '\U00016f44'), ('\U00016f50', '\U00016f50'),
        ('\U00016f51', '\U00016f7e'), ('\U00016f8f', '\U00016f92'), ('\U00016f93', '\U00016f9f'),
        ('\U0001b000', '\U0001b001'), ('\U0001bc00', '\U0001bc6a'), ('\U0001bc70', '\U0001bc7c'),
        ('\U0001bc80', '\U0001bc88'), ('\U0001bc90', '\U0001bc99'), ('\U0001bc9d', '\U0001bc9e'),
        ('\U0001d165', '\U0001d166'), ('\U0001d167', '\U0001d169'), ('\U0001d16d', '\U0001d172'),
        ('\U0001d17b', '\U0001d182'), ('\U0001d185', '\U0001d18b'), ('\U0001d1aa', '\U0001d1ad'),
        ('\U0001d242', '\U0001d244'), ('\U0001d400', '\U0001d454'), ('\U0001d456', '\U0001d49c'),
        ('\U0001d49e', '\U0001d49f'), ('\U0001d4a2', '\U0001d4a2'), ('\U0001d4a5', '\U0001d4a6'),
        ('\U0001d4a9', '\U0001d4ac'), ('\U0001d4ae', '\U0001d4b9'), ('\U0001d4bb', '\U0001d4bb'),
        ('\U0001d4bd', '\U0001d4c3'), ('\U0001d4c5', '\U0001d505'), ('\U0001d507', '\U0001d50a'),
        ('\U0001d50d', '\U0001d514'), ('\U0001d516', '\U0001d51c'), ('\U0001d51e', '\U0001d539'),
        ('\U0001d53b', '\U0001d53e'), ('\U0001d540', '\U0001d544'), ('\U0001d546', '\U0001d546'),
        ('\U0001d54a', '\U0001d550'), ('\U0001d552', '\U0001d6a5'), ('\U0001d6a8', '\U0001d6c0'),
        ('\U0001d6c2', '\U0001d6da'), ('\U0001d6dc', '\U0001d6fa'), ('\U0001d6fc', '\U0001d714'),
        ('\U0001d716', '\U0001d734'), ('\U0001d736', '\U0001d74e'), ('\U0001d750', '\U0001d76e'),
        ('\U0001d770', '\U0001d788'), ('\U0001d78a', '\U0001d7a8'), ('\U0001d7aa', '\U0001d7c2'),
        ('\U0001d7c4', '\U0001d7cb'), ('\U0001d7ce', '\U0001d7ff'), ('\U0001e800', '\U0001e8c4'),
        ('\U0001e8d0', '\U0001e8d6'), ('\U0001ee00', '\U0001ee03'), ('\U0001ee05', '\U0001ee1f'),
        ('\U0001ee21', '\U0001ee22'), ('\U0001ee24', '\U0001ee24'), ('\U0001ee27', '\U0001ee27'),
        ('\U0001ee29', '\U0001ee32'), ('\U0001ee34', '\U0001ee37'), ('\U0001ee39', '\U0001ee39'),
        ('\U0001ee3b', '\U0001ee3b'), ('\U0001ee42', '\U0001ee42'), ('\U0001ee47', '\U0001ee47'),
        ('\U0001ee49', '\U0001ee49'), ('\U0001ee4b', '\U0001ee4b'), ('\U0001ee4d', '\U0001ee4f'),
        ('\U0001ee51', '\U0001ee52'), ('\U0001ee54', '\U0001ee54'), ('\U0001ee57', '\U0001ee57'),
        ('\U0001ee59', '\U0001ee59'), ('\U0001ee5b', '\U0001ee5b'), ('\U0001ee5d', '\U0001ee5d'),
        ('\U0001ee5f', '\U0001ee5f'), ('\U0001ee61', '\U0001ee62'), ('\U0001ee64', '\U0001ee64'),
        ('\U0001ee67', '\U0001ee6a'), ('\U0001ee6c', '\U0001ee72'), ('\U0001ee74', '\U0001ee77'),
        ('\U0001ee79', '\U0001ee7c'), ('\U0001ee7e', '\U0001ee7e'), ('\U0001ee80', '\U0001ee89'),
        ('\U0001ee8b', '\U0001ee9b'), ('\U0001eea1', '\U0001eea3'), ('\U0001eea5', '\U0001eea9'),
        ('\U0001eeab', '\U0001eebb'), ('\U00020000', '\U0002a6d6'), ('\U0002a700', '\U0002b734'),
        ('\U0002b740', '\U0002b81d'), ('\U0002f800', '\U0002fa1d'), ('\U000e0100', '\U000e01ef')
    ];

    pub fn XID_Continue(c: char) -> bool {
        super::bsearch_range_table(c, XID_Continue_table)
    }

    pub static XID_Start_table: &'static [(char, char)] = &[
        ('\x41', '\x5a'), ('\x61', '\x7a'), ('\u00aa', '\u00aa'), ('\u00b5', '\u00b5'), ('\u00ba',
        '\u00ba'), ('\u00c0', '\u00d6'), ('\u00d8', '\u00f6'), ('\u00f8', '\u01ba'), ('\u01bb',
        '\u01bb'), ('\u01bc', '\u01bf'), ('\u01c0', '\u01c3'), ('\u01c4', '\u0293'), ('\u0294',
        '\u0294'), ('\u0295', '\u02af'), ('\u02b0', '\u02c1'), ('\u02c6', '\u02d1'), ('\u02e0',
        '\u02e4'), ('\u02ec', '\u02ec'), ('\u02ee', '\u02ee'), ('\u0370', '\u0373'), ('\u0374',
        '\u0374'), ('\u0376', '\u0377'), ('\u037b', '\u037d'), ('\u037f', '\u037f'), ('\u0386',
        '\u0386'), ('\u0388', '\u038a'), ('\u038c', '\u038c'), ('\u038e', '\u03a1'), ('\u03a3',
        '\u03f5'), ('\u03f7', '\u0481'), ('\u048a', '\u052f'), ('\u0531', '\u0556'), ('\u0559',
        '\u0559'), ('\u0561', '\u0587'), ('\u05d0', '\u05ea'), ('\u05f0', '\u05f2'), ('\u0620',
        '\u063f'), ('\u0640', '\u0640'), ('\u0641', '\u064a'), ('\u066e', '\u066f'), ('\u0671',
        '\u06d3'), ('\u06d5', '\u06d5'), ('\u06e5', '\u06e6'), ('\u06ee', '\u06ef'), ('\u06fa',
        '\u06fc'), ('\u06ff', '\u06ff'), ('\u0710', '\u0710'), ('\u0712', '\u072f'), ('\u074d',
        '\u07a5'), ('\u07b1', '\u07b1'), ('\u07ca', '\u07ea'), ('\u07f4', '\u07f5'), ('\u07fa',
        '\u07fa'), ('\u0800', '\u0815'), ('\u081a', '\u081a'), ('\u0824', '\u0824'), ('\u0828',
        '\u0828'), ('\u0840', '\u0858'), ('\u08a0', '\u08b2'), ('\u0904', '\u0939'), ('\u093d',
        '\u093d'), ('\u0950', '\u0950'), ('\u0958', '\u0961'), ('\u0971', '\u0971'), ('\u0972',
        '\u0980'), ('\u0985', '\u098c'), ('\u098f', '\u0990'), ('\u0993', '\u09a8'), ('\u09aa',
        '\u09b0'), ('\u09b2', '\u09b2'), ('\u09b6', '\u09b9'), ('\u09bd', '\u09bd'), ('\u09ce',
        '\u09ce'), ('\u09dc', '\u09dd'), ('\u09df', '\u09e1'), ('\u09f0', '\u09f1'), ('\u0a05',
        '\u0a0a'), ('\u0a0f', '\u0a10'), ('\u0a13', '\u0a28'), ('\u0a2a', '\u0a30'), ('\u0a32',
        '\u0a33'), ('\u0a35', '\u0a36'), ('\u0a38', '\u0a39'), ('\u0a59', '\u0a5c'), ('\u0a5e',
        '\u0a5e'), ('\u0a72', '\u0a74'), ('\u0a85', '\u0a8d'), ('\u0a8f', '\u0a91'), ('\u0a93',
        '\u0aa8'), ('\u0aaa', '\u0ab0'), ('\u0ab2', '\u0ab3'), ('\u0ab5', '\u0ab9'), ('\u0abd',
        '\u0abd'), ('\u0ad0', '\u0ad0'), ('\u0ae0', '\u0ae1'), ('\u0b05', '\u0b0c'), ('\u0b0f',
        '\u0b10'), ('\u0b13', '\u0b28'), ('\u0b2a', '\u0b30'), ('\u0b32', '\u0b33'), ('\u0b35',
        '\u0b39'), ('\u0b3d', '\u0b3d'), ('\u0b5c', '\u0b5d'), ('\u0b5f', '\u0b61'), ('\u0b71',
        '\u0b71'), ('\u0b83', '\u0b83'), ('\u0b85', '\u0b8a'), ('\u0b8e', '\u0b90'), ('\u0b92',
        '\u0b95'), ('\u0b99', '\u0b9a'), ('\u0b9c', '\u0b9c'), ('\u0b9e', '\u0b9f'), ('\u0ba3',
        '\u0ba4'), ('\u0ba8', '\u0baa'), ('\u0bae', '\u0bb9'), ('\u0bd0', '\u0bd0'), ('\u0c05',
        '\u0c0c'), ('\u0c0e', '\u0c10'), ('\u0c12', '\u0c28'), ('\u0c2a', '\u0c39'), ('\u0c3d',
        '\u0c3d'), ('\u0c58', '\u0c59'), ('\u0c60', '\u0c61'), ('\u0c85', '\u0c8c'), ('\u0c8e',
        '\u0c90'), ('\u0c92', '\u0ca8'), ('\u0caa', '\u0cb3'), ('\u0cb5', '\u0cb9'), ('\u0cbd',
        '\u0cbd'), ('\u0cde', '\u0cde'), ('\u0ce0', '\u0ce1'), ('\u0cf1', '\u0cf2'), ('\u0d05',
        '\u0d0c'), ('\u0d0e', '\u0d10'), ('\u0d12', '\u0d3a'), ('\u0d3d', '\u0d3d'), ('\u0d4e',
        '\u0d4e'), ('\u0d60', '\u0d61'), ('\u0d7a', '\u0d7f'), ('\u0d85', '\u0d96'), ('\u0d9a',
        '\u0db1'), ('\u0db3', '\u0dbb'), ('\u0dbd', '\u0dbd'), ('\u0dc0', '\u0dc6'), ('\u0e01',
        '\u0e30'), ('\u0e32', '\u0e32'), ('\u0e40', '\u0e45'), ('\u0e46', '\u0e46'), ('\u0e81',
        '\u0e82'), ('\u0e84', '\u0e84'), ('\u0e87', '\u0e88'), ('\u0e8a', '\u0e8a'), ('\u0e8d',
        '\u0e8d'), ('\u0e94', '\u0e97'), ('\u0e99', '\u0e9f'), ('\u0ea1', '\u0ea3'), ('\u0ea5',
        '\u0ea5'), ('\u0ea7', '\u0ea7'), ('\u0eaa', '\u0eab'), ('\u0ead', '\u0eb0'), ('\u0eb2',
        '\u0eb2'), ('\u0ebd', '\u0ebd'), ('\u0ec0', '\u0ec4'), ('\u0ec6', '\u0ec6'), ('\u0edc',
        '\u0edf'), ('\u0f00', '\u0f00'), ('\u0f40', '\u0f47'), ('\u0f49', '\u0f6c'), ('\u0f88',
        '\u0f8c'), ('\u1000', '\u102a'), ('\u103f', '\u103f'), ('\u1050', '\u1055'), ('\u105a',
        '\u105d'), ('\u1061', '\u1061'), ('\u1065', '\u1066'), ('\u106e', '\u1070'), ('\u1075',
        '\u1081'), ('\u108e', '\u108e'), ('\u10a0', '\u10c5'), ('\u10c7', '\u10c7'), ('\u10cd',
        '\u10cd'), ('\u10d0', '\u10fa'), ('\u10fc', '\u10fc'), ('\u10fd', '\u1248'), ('\u124a',
        '\u124d'), ('\u1250', '\u1256'), ('\u1258', '\u1258'), ('\u125a', '\u125d'), ('\u1260',
        '\u1288'), ('\u128a', '\u128d'), ('\u1290', '\u12b0'), ('\u12b2', '\u12b5'), ('\u12b8',
        '\u12be'), ('\u12c0', '\u12c0'), ('\u12c2', '\u12c5'), ('\u12c8', '\u12d6'), ('\u12d8',
        '\u1310'), ('\u1312', '\u1315'), ('\u1318', '\u135a'), ('\u1380', '\u138f'), ('\u13a0',
        '\u13f4'), ('\u1401', '\u166c'), ('\u166f', '\u167f'), ('\u1681', '\u169a'), ('\u16a0',
        '\u16ea'), ('\u16ee', '\u16f0'), ('\u16f1', '\u16f8'), ('\u1700', '\u170c'), ('\u170e',
        '\u1711'), ('\u1720', '\u1731'), ('\u1740', '\u1751'), ('\u1760', '\u176c'), ('\u176e',
        '\u1770'), ('\u1780', '\u17b3'), ('\u17d7', '\u17d7'), ('\u17dc', '\u17dc'), ('\u1820',
        '\u1842'), ('\u1843', '\u1843'), ('\u1844', '\u1877'), ('\u1880', '\u18a8'), ('\u18aa',
        '\u18aa'), ('\u18b0', '\u18f5'), ('\u1900', '\u191e'), ('\u1950', '\u196d'), ('\u1970',
        '\u1974'), ('\u1980', '\u19ab'), ('\u19c1', '\u19c7'), ('\u1a00', '\u1a16'), ('\u1a20',
        '\u1a54'), ('\u1aa7', '\u1aa7'), ('\u1b05', '\u1b33'), ('\u1b45', '\u1b4b'), ('\u1b83',
        '\u1ba0'), ('\u1bae', '\u1baf'), ('\u1bba', '\u1be5'), ('\u1c00', '\u1c23'), ('\u1c4d',
        '\u1c4f'), ('\u1c5a', '\u1c77'), ('\u1c78', '\u1c7d'), ('\u1ce9', '\u1cec'), ('\u1cee',
        '\u1cf1'), ('\u1cf5', '\u1cf6'), ('\u1d00', '\u1d2b'), ('\u1d2c', '\u1d6a'), ('\u1d6b',
        '\u1d77'), ('\u1d78', '\u1d78'), ('\u1d79', '\u1d9a'), ('\u1d9b', '\u1dbf'), ('\u1e00',
        '\u1f15'), ('\u1f18', '\u1f1d'), ('\u1f20', '\u1f45'), ('\u1f48', '\u1f4d'), ('\u1f50',
        '\u1f57'), ('\u1f59', '\u1f59'), ('\u1f5b', '\u1f5b'), ('\u1f5d', '\u1f5d'), ('\u1f5f',
        '\u1f7d'), ('\u1f80', '\u1fb4'), ('\u1fb6', '\u1fbc'), ('\u1fbe', '\u1fbe'), ('\u1fc2',
        '\u1fc4'), ('\u1fc6', '\u1fcc'), ('\u1fd0', '\u1fd3'), ('\u1fd6', '\u1fdb'), ('\u1fe0',
        '\u1fec'), ('\u1ff2', '\u1ff4'), ('\u1ff6', '\u1ffc'), ('\u2071', '\u2071'), ('\u207f',
        '\u207f'), ('\u2090', '\u209c'), ('\u2102', '\u2102'), ('\u2107', '\u2107'), ('\u210a',
        '\u2113'), ('\u2115', '\u2115'), ('\u2118', '\u2118'), ('\u2119', '\u211d'), ('\u2124',
        '\u2124'), ('\u2126', '\u2126'), ('\u2128', '\u2128'), ('\u212a', '\u212d'), ('\u212e',
        '\u212e'), ('\u212f', '\u2134'), ('\u2135', '\u2138'), ('\u2139', '\u2139'), ('\u213c',
        '\u213f'), ('\u2145', '\u2149'), ('\u214e', '\u214e'), ('\u2160', '\u2182'), ('\u2183',
        '\u2184'), ('\u2185', '\u2188'), ('\u2c00', '\u2c2e'), ('\u2c30', '\u2c5e'), ('\u2c60',
        '\u2c7b'), ('\u2c7c', '\u2c7d'), ('\u2c7e', '\u2ce4'), ('\u2ceb', '\u2cee'), ('\u2cf2',
        '\u2cf3'), ('\u2d00', '\u2d25'), ('\u2d27', '\u2d27'), ('\u2d2d', '\u2d2d'), ('\u2d30',
        '\u2d67'), ('\u2d6f', '\u2d6f'), ('\u2d80', '\u2d96'), ('\u2da0', '\u2da6'), ('\u2da8',
        '\u2dae'), ('\u2db0', '\u2db6'), ('\u2db8', '\u2dbe'), ('\u2dc0', '\u2dc6'), ('\u2dc8',
        '\u2dce'), ('\u2dd0', '\u2dd6'), ('\u2dd8', '\u2dde'), ('\u3005', '\u3005'), ('\u3006',
        '\u3006'), ('\u3007', '\u3007'), ('\u3021', '\u3029'), ('\u3031', '\u3035'), ('\u3038',
        '\u303a'), ('\u303b', '\u303b'), ('\u303c', '\u303c'), ('\u3041', '\u3096'), ('\u309d',
        '\u309e'), ('\u309f', '\u309f'), ('\u30a1', '\u30fa'), ('\u30fc', '\u30fe'), ('\u30ff',
        '\u30ff'), ('\u3105', '\u312d'), ('\u3131', '\u318e'), ('\u31a0', '\u31ba'), ('\u31f0',
        '\u31ff'), ('\u3400', '\u4db5'), ('\u4e00', '\u9fcc'), ('\ua000', '\ua014'), ('\ua015',
        '\ua015'), ('\ua016', '\ua48c'), ('\ua4d0', '\ua4f7'), ('\ua4f8', '\ua4fd'), ('\ua500',
        '\ua60b'), ('\ua60c', '\ua60c'), ('\ua610', '\ua61f'), ('\ua62a', '\ua62b'), ('\ua640',
        '\ua66d'), ('\ua66e', '\ua66e'), ('\ua67f', '\ua67f'), ('\ua680', '\ua69b'), ('\ua69c',
        '\ua69d'), ('\ua6a0', '\ua6e5'), ('\ua6e6', '\ua6ef'), ('\ua717', '\ua71f'), ('\ua722',
        '\ua76f'), ('\ua770', '\ua770'), ('\ua771', '\ua787'), ('\ua788', '\ua788'), ('\ua78b',
        '\ua78e'), ('\ua790', '\ua7ad'), ('\ua7b0', '\ua7b1'), ('\ua7f7', '\ua7f7'), ('\ua7f8',
        '\ua7f9'), ('\ua7fa', '\ua7fa'), ('\ua7fb', '\ua801'), ('\ua803', '\ua805'), ('\ua807',
        '\ua80a'), ('\ua80c', '\ua822'), ('\ua840', '\ua873'), ('\ua882', '\ua8b3'), ('\ua8f2',
        '\ua8f7'), ('\ua8fb', '\ua8fb'), ('\ua90a', '\ua925'), ('\ua930', '\ua946'), ('\ua960',
        '\ua97c'), ('\ua984', '\ua9b2'), ('\ua9cf', '\ua9cf'), ('\ua9e0', '\ua9e4'), ('\ua9e6',
        '\ua9e6'), ('\ua9e7', '\ua9ef'), ('\ua9fa', '\ua9fe'), ('\uaa00', '\uaa28'), ('\uaa40',
        '\uaa42'), ('\uaa44', '\uaa4b'), ('\uaa60', '\uaa6f'), ('\uaa70', '\uaa70'), ('\uaa71',
        '\uaa76'), ('\uaa7a', '\uaa7a'), ('\uaa7e', '\uaaaf'), ('\uaab1', '\uaab1'), ('\uaab5',
        '\uaab6'), ('\uaab9', '\uaabd'), ('\uaac0', '\uaac0'), ('\uaac2', '\uaac2'), ('\uaadb',
        '\uaadc'), ('\uaadd', '\uaadd'), ('\uaae0', '\uaaea'), ('\uaaf2', '\uaaf2'), ('\uaaf3',
        '\uaaf4'), ('\uab01', '\uab06'), ('\uab09', '\uab0e'), ('\uab11', '\uab16'), ('\uab20',
        '\uab26'), ('\uab28', '\uab2e'), ('\uab30', '\uab5a'), ('\uab5c', '\uab5f'), ('\uab64',
        '\uab65'), ('\uabc0', '\uabe2'), ('\uac00', '\ud7a3'), ('\ud7b0', '\ud7c6'), ('\ud7cb',
        '\ud7fb'), ('\uf900', '\ufa6d'), ('\ufa70', '\ufad9'), ('\ufb00', '\ufb06'), ('\ufb13',
        '\ufb17'), ('\ufb1d', '\ufb1d'), ('\ufb1f', '\ufb28'), ('\ufb2a', '\ufb36'), ('\ufb38',
        '\ufb3c'), ('\ufb3e', '\ufb3e'), ('\ufb40', '\ufb41'), ('\ufb43', '\ufb44'), ('\ufb46',
        '\ufbb1'), ('\ufbd3', '\ufc5d'), ('\ufc64', '\ufd3d'), ('\ufd50', '\ufd8f'), ('\ufd92',
        '\ufdc7'), ('\ufdf0', '\ufdf9'), ('\ufe71', '\ufe71'), ('\ufe73', '\ufe73'), ('\ufe77',
        '\ufe77'), ('\ufe79', '\ufe79'), ('\ufe7b', '\ufe7b'), ('\ufe7d', '\ufe7d'), ('\ufe7f',
        '\ufefc'), ('\uff21', '\uff3a'), ('\uff41', '\uff5a'), ('\uff66', '\uff6f'), ('\uff70',
        '\uff70'), ('\uff71', '\uff9d'), ('\uffa0', '\uffbe'), ('\uffc2', '\uffc7'), ('\uffca',
        '\uffcf'), ('\uffd2', '\uffd7'), ('\uffda', '\uffdc'), ('\U00010000', '\U0001000b'),
        ('\U0001000d', '\U00010026'), ('\U00010028', '\U0001003a'), ('\U0001003c', '\U0001003d'),
        ('\U0001003f', '\U0001004d'), ('\U00010050', '\U0001005d'), ('\U00010080', '\U000100fa'),
        ('\U00010140', '\U00010174'), ('\U00010280', '\U0001029c'), ('\U000102a0', '\U000102d0'),
        ('\U00010300', '\U0001031f'), ('\U00010330', '\U00010340'), ('\U00010341', '\U00010341'),
        ('\U00010342', '\U00010349'), ('\U0001034a', '\U0001034a'), ('\U00010350', '\U00010375'),
        ('\U00010380', '\U0001039d'), ('\U000103a0', '\U000103c3'), ('\U000103c8', '\U000103cf'),
        ('\U000103d1', '\U000103d5'), ('\U00010400', '\U0001044f'), ('\U00010450', '\U0001049d'),
        ('\U00010500', '\U00010527'), ('\U00010530', '\U00010563'), ('\U00010600', '\U00010736'),
        ('\U00010740', '\U00010755'), ('\U00010760', '\U00010767'), ('\U00010800', '\U00010805'),
        ('\U00010808', '\U00010808'), ('\U0001080a', '\U00010835'), ('\U00010837', '\U00010838'),
        ('\U0001083c', '\U0001083c'), ('\U0001083f', '\U00010855'), ('\U00010860', '\U00010876'),
        ('\U00010880', '\U0001089e'), ('\U00010900', '\U00010915'), ('\U00010920', '\U00010939'),
        ('\U00010980', '\U000109b7'), ('\U000109be', '\U000109bf'), ('\U00010a00', '\U00010a00'),
        ('\U00010a10', '\U00010a13'), ('\U00010a15', '\U00010a17'), ('\U00010a19', '\U00010a33'),
        ('\U00010a60', '\U00010a7c'), ('\U00010a80', '\U00010a9c'), ('\U00010ac0', '\U00010ac7'),
        ('\U00010ac9', '\U00010ae4'), ('\U00010b00', '\U00010b35'), ('\U00010b40', '\U00010b55'),
        ('\U00010b60', '\U00010b72'), ('\U00010b80', '\U00010b91'), ('\U00010c00', '\U00010c48'),
        ('\U00011003', '\U00011037'), ('\U00011083', '\U000110af'), ('\U000110d0', '\U000110e8'),
        ('\U00011103', '\U00011126'), ('\U00011150', '\U00011172'), ('\U00011176', '\U00011176'),
        ('\U00011183', '\U000111b2'), ('\U000111c1', '\U000111c4'), ('\U000111da', '\U000111da'),
        ('\U00011200', '\U00011211'), ('\U00011213', '\U0001122b'), ('\U000112b0', '\U000112de'),
        ('\U00011305', '\U0001130c'), ('\U0001130f', '\U00011310'), ('\U00011313', '\U00011328'),
        ('\U0001132a', '\U00011330'), ('\U00011332', '\U00011333'), ('\U00011335', '\U00011339'),
        ('\U0001133d', '\U0001133d'), ('\U0001135d', '\U00011361'), ('\U00011480', '\U000114af'),
        ('\U000114c4', '\U000114c5'), ('\U000114c7', '\U000114c7'), ('\U00011580', '\U000115ae'),
        ('\U00011600', '\U0001162f'), ('\U00011644', '\U00011644'), ('\U00011680', '\U000116aa'),
        ('\U000118a0', '\U000118df'), ('\U000118ff', '\U000118ff'), ('\U00011ac0', '\U00011af8'),
        ('\U00012000', '\U00012398'), ('\U00012400', '\U0001246e'), ('\U00013000', '\U0001342e'),
        ('\U00016800', '\U00016a38'), ('\U00016a40', '\U00016a5e'), ('\U00016ad0', '\U00016aed'),
        ('\U00016b00', '\U00016b2f'), ('\U00016b40', '\U00016b43'), ('\U00016b63', '\U00016b77'),
        ('\U00016b7d', '\U00016b8f'), ('\U00016f00', '\U00016f44'), ('\U00016f50', '\U00016f50'),
        ('\U00016f93', '\U00016f9f'), ('\U0001b000', '\U0001b001'), ('\U0001bc00', '\U0001bc6a'),
        ('\U0001bc70', '\U0001bc7c'), ('\U0001bc80', '\U0001bc88'), ('\U0001bc90', '\U0001bc99'),
        ('\U0001d400', '\U0001d454'), ('\U0001d456', '\U0001d49c'), ('\U0001d49e', '\U0001d49f'),
        ('\U0001d4a2', '\U0001d4a2'), ('\U0001d4a5', '\U0001d4a6'), ('\U0001d4a9', '\U0001d4ac'),
        ('\U0001d4ae', '\U0001d4b9'), ('\U0001d4bb', '\U0001d4bb'), ('\U0001d4bd', '\U0001d4c3'),
        ('\U0001d4c5', '\U0001d505'), ('\U0001d507', '\U0001d50a'), ('\U0001d50d', '\U0001d514'),
        ('\U0001d516', '\U0001d51c'), ('\U0001d51e', '\U0001d539'), ('\U0001d53b', '\U0001d53e'),
        ('\U0001d540', '\U0001d544'), ('\U0001d546', '\U0001d546'), ('\U0001d54a', '\U0001d550'),
        ('\U0001d552', '\U0001d6a5'), ('\U0001d6a8', '\U0001d6c0'), ('\U0001d6c2', '\U0001d6da'),
        ('\U0001d6dc', '\U0001d6fa'), ('\U0001d6fc', '\U0001d714'), ('\U0001d716', '\U0001d734'),
        ('\U0001d736', '\U0001d74e'), ('\U0001d750', '\U0001d76e'), ('\U0001d770', '\U0001d788'),
        ('\U0001d78a', '\U0001d7a8'), ('\U0001d7aa', '\U0001d7c2'), ('\U0001d7c4', '\U0001d7cb'),
        ('\U0001e800', '\U0001e8c4'), ('\U0001ee00', '\U0001ee03'), ('\U0001ee05', '\U0001ee1f'),
        ('\U0001ee21', '\U0001ee22'), ('\U0001ee24', '\U0001ee24'), ('\U0001ee27', '\U0001ee27'),
        ('\U0001ee29', '\U0001ee32'), ('\U0001ee34', '\U0001ee37'), ('\U0001ee39', '\U0001ee39'),
        ('\U0001ee3b', '\U0001ee3b'), ('\U0001ee42', '\U0001ee42'), ('\U0001ee47', '\U0001ee47'),
        ('\U0001ee49', '\U0001ee49'), ('\U0001ee4b', '\U0001ee4b'), ('\U0001ee4d', '\U0001ee4f'),
        ('\U0001ee51', '\U0001ee52'), ('\U0001ee54', '\U0001ee54'), ('\U0001ee57', '\U0001ee57'),
        ('\U0001ee59', '\U0001ee59'), ('\U0001ee5b', '\U0001ee5b'), ('\U0001ee5d', '\U0001ee5d'),
        ('\U0001ee5f', '\U0001ee5f'), ('\U0001ee61', '\U0001ee62'), ('\U0001ee64', '\U0001ee64'),
        ('\U0001ee67', '\U0001ee6a'), ('\U0001ee6c', '\U0001ee72'), ('\U0001ee74', '\U0001ee77'),
        ('\U0001ee79', '\U0001ee7c'), ('\U0001ee7e', '\U0001ee7e'), ('\U0001ee80', '\U0001ee89'),
        ('\U0001ee8b', '\U0001ee9b'), ('\U0001eea1', '\U0001eea3'), ('\U0001eea5', '\U0001eea9'),
        ('\U0001eeab', '\U0001eebb'), ('\U00020000', '\U0002a6d6'), ('\U0002a700', '\U0002b734'),
        ('\U0002b740', '\U0002b81d'), ('\U0002f800', '\U0002fa1d')
    ];

    pub fn XID_Start(c: char) -> bool {
        super::bsearch_range_table(c, XID_Start_table)
    }

}

pub mod script {
    pub static Arabic_table: &'static [(char, char)] = &[
        ('\u0600', '\u0604'), ('\u0606', '\u0608'), ('\u0609', '\u060a'), ('\u060b', '\u060b'),
        ('\u060d', '\u060d'), ('\u060e', '\u060f'), ('\u0610', '\u061a'), ('\u061e', '\u061e'),
        ('\u0620', '\u063f'), ('\u0641', '\u064a'), ('\u0656', '\u065f'), ('\u066a', '\u066d'),
        ('\u066e', '\u066f'), ('\u0671', '\u06d3'), ('\u06d4', '\u06d4'), ('\u06d5', '\u06d5'),
        ('\u06d6', '\u06dc'), ('\u06de', '\u06de'), ('\u06df', '\u06e4'), ('\u06e5', '\u06e6'),
        ('\u06e7', '\u06e8'), ('\u06e9', '\u06e9'), ('\u06ea', '\u06ed'), ('\u06ee', '\u06ef'),
        ('\u06f0', '\u06f9'), ('\u06fa', '\u06fc'), ('\u06fd', '\u06fe'), ('\u06ff', '\u06ff'),
        ('\u0750', '\u077f'), ('\u08a0', '\u08b2'), ('\u08e4', '\u08ff'), ('\ufb50', '\ufbb1'),
        ('\ufbb2', '\ufbc1'), ('\ufbd3', '\ufd3d'), ('\ufd50', '\ufd8f'), ('\ufd92', '\ufdc7'),
        ('\ufdf0', '\ufdfb'), ('\ufdfc', '\ufdfc'), ('\ufdfd', '\ufdfd'), ('\ufe70', '\ufe74'),
        ('\ufe76', '\ufefc'), ('\U00010e60', '\U00010e7e'), ('\U0001ee00', '\U0001ee03'),
        ('\U0001ee05', '\U0001ee1f'), ('\U0001ee21', '\U0001ee22'), ('\U0001ee24', '\U0001ee24'),
        ('\U0001ee27', '\U0001ee27'), ('\U0001ee29', '\U0001ee32'), ('\U0001ee34', '\U0001ee37'),
        ('\U0001ee39', '\U0001ee39'), ('\U0001ee3b', '\U0001ee3b'), ('\U0001ee42', '\U0001ee42'),
        ('\U0001ee47', '\U0001ee47'), ('\U0001ee49', '\U0001ee49'), ('\U0001ee4b', '\U0001ee4b'),
        ('\U0001ee4d', '\U0001ee4f'), ('\U0001ee51', '\U0001ee52'), ('\U0001ee54', '\U0001ee54'),
        ('\U0001ee57', '\U0001ee57'), ('\U0001ee59', '\U0001ee59'), ('\U0001ee5b', '\U0001ee5b'),
        ('\U0001ee5d', '\U0001ee5d'), ('\U0001ee5f', '\U0001ee5f'), ('\U0001ee61', '\U0001ee62'),
        ('\U0001ee64', '\U0001ee64'), ('\U0001ee67', '\U0001ee6a'), ('\U0001ee6c', '\U0001ee72'),
        ('\U0001ee74', '\U0001ee77'), ('\U0001ee79', '\U0001ee7c'), ('\U0001ee7e', '\U0001ee7e'),
        ('\U0001ee80', '\U0001ee89'), ('\U0001ee8b', '\U0001ee9b'), ('\U0001eea1', '\U0001eea3'),
        ('\U0001eea5', '\U0001eea9'), ('\U0001eeab', '\U0001eebb'), ('\U0001eef0', '\U0001eef1')
    ];

    pub static Armenian_table: &'static [(char, char)] = &[
        ('\u0531', '\u0556'), ('\u0559', '\u0559'), ('\u055a', '\u055f'), ('\u0561', '\u0587'),
        ('\u058a', '\u058a'), ('\u058d', '\u058e'), ('\u058f', '\u058f'), ('\ufb13', '\ufb17')
    ];

    pub static Avestan_table: &'static [(char, char)] = &[
        ('\U00010b00', '\U00010b35'), ('\U00010b39', '\U00010b3f')
    ];

    pub static Balinese_table: &'static [(char, char)] = &[
        ('\u1b00', '\u1b03'), ('\u1b04', '\u1b04'), ('\u1b05', '\u1b33'), ('\u1b34', '\u1b34'),
        ('\u1b35', '\u1b35'), ('\u1b36', '\u1b3a'), ('\u1b3b', '\u1b3b'), ('\u1b3c', '\u1b3c'),
        ('\u1b3d', '\u1b41'), ('\u1b42', '\u1b42'), ('\u1b43', '\u1b44'), ('\u1b45', '\u1b4b'),
        ('\u1b50', '\u1b59'), ('\u1b5a', '\u1b60'), ('\u1b61', '\u1b6a'), ('\u1b6b', '\u1b73'),
        ('\u1b74', '\u1b7c')
    ];

    pub static Bamum_table: &'static [(char, char)] = &[
        ('\ua6a0', '\ua6e5'), ('\ua6e6', '\ua6ef'), ('\ua6f0', '\ua6f1'), ('\ua6f2', '\ua6f7'),
        ('\U00016800', '\U00016a38')
    ];

    pub static Bassa_Vah_table: &'static [(char, char)] = &[
        ('\U00016ad0', '\U00016aed'), ('\U00016af0', '\U00016af4'), ('\U00016af5', '\U00016af5')
    ];

    pub static Batak_table: &'static [(char, char)] = &[
        ('\u1bc0', '\u1be5'), ('\u1be6', '\u1be6'), ('\u1be7', '\u1be7'), ('\u1be8', '\u1be9'),
        ('\u1bea', '\u1bec'), ('\u1bed', '\u1bed'), ('\u1bee', '\u1bee'), ('\u1bef', '\u1bf1'),
        ('\u1bf2', '\u1bf3'), ('\u1bfc', '\u1bff')
    ];

    pub static Bengali_table: &'static [(char, char)] = &[
        ('\u0980', '\u0980'), ('\u0981', '\u0981'), ('\u0982', '\u0983'), ('\u0985', '\u098c'),
        ('\u098f', '\u0990'), ('\u0993', '\u09a8'), ('\u09aa', '\u09b0'), ('\u09b2', '\u09b2'),
        ('\u09b6', '\u09b9'), ('\u09bc', '\u09bc'), ('\u09bd', '\u09bd'), ('\u09be', '\u09c0'),
        ('\u09c1', '\u09c4'), ('\u09c7', '\u09c8'), ('\u09cb', '\u09cc'), ('\u09cd', '\u09cd'),
        ('\u09ce', '\u09ce'), ('\u09d7', '\u09d7'), ('\u09dc', '\u09dd'), ('\u09df', '\u09e1'),
        ('\u09e2', '\u09e3'), ('\u09e6', '\u09ef'), ('\u09f0', '\u09f1'), ('\u09f2', '\u09f3'),
        ('\u09f4', '\u09f9'), ('\u09fa', '\u09fa'), ('\u09fb', '\u09fb')
    ];

    pub static Bopomofo_table: &'static [(char, char)] = &[
        ('\u02ea', '\u02eb'), ('\u3105', '\u312d'), ('\u31a0', '\u31ba')
    ];

    pub static Brahmi_table: &'static [(char, char)] = &[
        ('\U00011000', '\U00011000'), ('\U00011001', '\U00011001'), ('\U00011002', '\U00011002'),
        ('\U00011003', '\U00011037'), ('\U00011038', '\U00011046'), ('\U00011047', '\U0001104d'),
        ('\U00011052', '\U00011065'), ('\U00011066', '\U0001106f'), ('\U0001107f', '\U0001107f')
    ];

    pub static Braille_table: &'static [(char, char)] = &[
        ('\u2800', '\u28ff')
    ];

    pub static Buginese_table: &'static [(char, char)] = &[
        ('\u1a00', '\u1a16'), ('\u1a17', '\u1a18'), ('\u1a19', '\u1a1a'), ('\u1a1b', '\u1a1b'),
        ('\u1a1e', '\u1a1f')
    ];

    pub static Buhid_table: &'static [(char, char)] = &[
        ('\u1740', '\u1751'), ('\u1752', '\u1753')
    ];

    pub static Canadian_Aboriginal_table: &'static [(char, char)] = &[
        ('\u1400', '\u1400'), ('\u1401', '\u166c'), ('\u166d', '\u166e'), ('\u166f', '\u167f'),
        ('\u18b0', '\u18f5')
    ];

    pub static Carian_table: &'static [(char, char)] = &[
        ('\U000102a0', '\U000102d0')
    ];

    pub static Caucasian_Albanian_table: &'static [(char, char)] = &[
        ('\U00010530', '\U00010563'), ('\U0001056f', '\U0001056f')
    ];

    pub static Chakma_table: &'static [(char, char)] = &[
        ('\U00011100', '\U00011102'), ('\U00011103', '\U00011126'), ('\U00011127', '\U0001112b'),
        ('\U0001112c', '\U0001112c'), ('\U0001112d', '\U00011134'), ('\U00011136', '\U0001113f'),
        ('\U00011140', '\U00011143')
    ];

    pub static Cham_table: &'static [(char, char)] = &[
        ('\uaa00', '\uaa28'), ('\uaa29', '\uaa2e'), ('\uaa2f', '\uaa30'), ('\uaa31', '\uaa32'),
        ('\uaa33', '\uaa34'), ('\uaa35', '\uaa36'), ('\uaa40', '\uaa42'), ('\uaa43', '\uaa43'),
        ('\uaa44', '\uaa4b'), ('\uaa4c', '\uaa4c'), ('\uaa4d', '\uaa4d'), ('\uaa50', '\uaa59'),
        ('\uaa5c', '\uaa5f')
    ];

    pub static Cherokee_table: &'static [(char, char)] = &[
        ('\u13a0', '\u13f4')
    ];

    pub static Common_table: &'static [(char, char)] = &[
        ('\x00', '\x1f'), ('\x20', '\x20'), ('\x21', '\x23'), ('\x24', '\x24'), ('\x25', '\x27'),
        ('\x28', '\x28'), ('\x29', '\x29'), ('\x2a', '\x2a'), ('\x2b', '\x2b'), ('\x2c', '\x2c'),
        ('\x2d', '\x2d'), ('\x2e', '\x2f'), ('\x30', '\x39'), ('\x3a', '\x3b'), ('\x3c', '\x3e'),
        ('\x3f', '\x40'), ('\x5b', '\x5b'), ('\x5c', '\x5c'), ('\x5d', '\x5d'), ('\x5e', '\x5e'),
        ('\x5f', '\x5f'), ('\x60', '\x60'), ('\x7b', '\x7b'), ('\x7c', '\x7c'), ('\x7d', '\x7d'),
        ('\x7e', '\x7e'), ('\x7f', '\u009f'), ('\u00a0', '\u00a0'), ('\u00a1', '\u00a1'), ('\u00a2',
        '\u00a5'), ('\u00a6', '\u00a6'), ('\u00a7', '\u00a7'), ('\u00a8', '\u00a8'), ('\u00a9',
        '\u00a9'), ('\u00ab', '\u00ab'), ('\u00ac', '\u00ac'), ('\u00ad', '\u00ad'), ('\u00ae',
        '\u00ae'), ('\u00af', '\u00af'), ('\u00b0', '\u00b0'), ('\u00b1', '\u00b1'), ('\u00b2',
        '\u00b3'), ('\u00b4', '\u00b4'), ('\u00b5', '\u00b5'), ('\u00b6', '\u00b7'), ('\u00b8',
        '\u00b8'), ('\u00b9', '\u00b9'), ('\u00bb', '\u00bb'), ('\u00bc', '\u00be'), ('\u00bf',
        '\u00bf'), ('\u00d7', '\u00d7'), ('\u00f7', '\u00f7'), ('\u02b9', '\u02c1'), ('\u02c2',
        '\u02c5'), ('\u02c6', '\u02d1'), ('\u02d2', '\u02df'), ('\u02e5', '\u02e9'), ('\u02ec',
        '\u02ec'), ('\u02ed', '\u02ed'), ('\u02ee', '\u02ee'), ('\u02ef', '\u02ff'), ('\u0374',
        '\u0374'), ('\u037e', '\u037e'), ('\u0385', '\u0385'), ('\u0387', '\u0387'), ('\u0589',
        '\u0589'), ('\u0605', '\u0605'), ('\u060c', '\u060c'), ('\u061b', '\u061b'), ('\u061c',
        '\u061c'), ('\u061f', '\u061f'), ('\u0640', '\u0640'), ('\u0660', '\u0669'), ('\u06dd',
        '\u06dd'), ('\u0964', '\u0965'), ('\u0e3f', '\u0e3f'), ('\u0fd5', '\u0fd8'), ('\u10fb',
        '\u10fb'), ('\u16eb', '\u16ed'), ('\u1735', '\u1736'), ('\u1802', '\u1803'), ('\u1805',
        '\u1805'), ('\u1cd3', '\u1cd3'), ('\u1ce1', '\u1ce1'), ('\u1ce9', '\u1cec'), ('\u1cee',
        '\u1cf1'), ('\u1cf2', '\u1cf3'), ('\u1cf5', '\u1cf6'), ('\u2000', '\u200a'), ('\u200b',
        '\u200b'), ('\u200e', '\u200f'), ('\u2010', '\u2015'), ('\u2016', '\u2017'), ('\u2018',
        '\u2018'), ('\u2019', '\u2019'), ('\u201a', '\u201a'), ('\u201b', '\u201c'), ('\u201d',
        '\u201d'), ('\u201e', '\u201e'), ('\u201f', '\u201f'), ('\u2020', '\u2027'), ('\u2028',
        '\u2028'), ('\u2029', '\u2029'), ('\u202a', '\u202e'), ('\u202f', '\u202f'), ('\u2030',
        '\u2038'), ('\u2039', '\u2039'), ('\u203a', '\u203a'), ('\u203b', '\u203e'), ('\u203f',
        '\u2040'), ('\u2041', '\u2043'), ('\u2044', '\u2044'), ('\u2045', '\u2045'), ('\u2046',
        '\u2046'), ('\u2047', '\u2051'), ('\u2052', '\u2052'), ('\u2053', '\u2053'), ('\u2054',
        '\u2054'), ('\u2055', '\u205e'), ('\u205f', '\u205f'), ('\u2060', '\u2064'), ('\u2066',
        '\u206f'), ('\u2070', '\u2070'), ('\u2074', '\u2079'), ('\u207a', '\u207c'), ('\u207d',
        '\u207d'), ('\u207e', '\u207e'), ('\u2080', '\u2089'), ('\u208a', '\u208c'), ('\u208d',
        '\u208d'), ('\u208e', '\u208e'), ('\u20a0', '\u20bd'), ('\u2100', '\u2101'), ('\u2102',
        '\u2102'), ('\u2103', '\u2106'), ('\u2107', '\u2107'), ('\u2108', '\u2109'), ('\u210a',
        '\u2113'), ('\u2114', '\u2114'), ('\u2115', '\u2115'), ('\u2116', '\u2117'), ('\u2118',
        '\u2118'), ('\u2119', '\u211d'), ('\u211e', '\u2123'), ('\u2124', '\u2124'), ('\u2125',
        '\u2125'), ('\u2127', '\u2127'), ('\u2128', '\u2128'), ('\u2129', '\u2129'), ('\u212c',
        '\u212d'), ('\u212e', '\u212e'), ('\u212f', '\u2131'), ('\u2133', '\u2134'), ('\u2135',
        '\u2138'), ('\u2139', '\u2139'), ('\u213a', '\u213b'), ('\u213c', '\u213f'), ('\u2140',
        '\u2144'), ('\u2145', '\u2149'), ('\u214a', '\u214a'), ('\u214b', '\u214b'), ('\u214c',
        '\u214d'), ('\u214f', '\u214f'), ('\u2150', '\u215f'), ('\u2189', '\u2189'), ('\u2190',
        '\u2194'), ('\u2195', '\u2199'), ('\u219a', '\u219b'), ('\u219c', '\u219f'), ('\u21a0',
        '\u21a0'), ('\u21a1', '\u21a2'), ('\u21a3', '\u21a3'), ('\u21a4', '\u21a5'), ('\u21a6',
        '\u21a6'), ('\u21a7', '\u21ad'), ('\u21ae', '\u21ae'), ('\u21af', '\u21cd'), ('\u21ce',
        '\u21cf'), ('\u21d0', '\u21d1'), ('\u21d2', '\u21d2'), ('\u21d3', '\u21d3'), ('\u21d4',
        '\u21d4'), ('\u21d5', '\u21f3'), ('\u21f4', '\u22ff'), ('\u2300', '\u2307'), ('\u2308',
        '\u2308'), ('\u2309', '\u2309'), ('\u230a', '\u230a'), ('\u230b', '\u230b'), ('\u230c',
        '\u231f'), ('\u2320', '\u2321'), ('\u2322', '\u2328'), ('\u2329', '\u2329'), ('\u232a',
        '\u232a'), ('\u232b', '\u237b'), ('\u237c', '\u237c'), ('\u237d', '\u239a'), ('\u239b',
        '\u23b3'), ('\u23b4', '\u23db'), ('\u23dc', '\u23e1'), ('\u23e2', '\u23fa'), ('\u2400',
        '\u2426'), ('\u2440', '\u244a'), ('\u2460', '\u249b'), ('\u249c', '\u24e9'), ('\u24ea',
        '\u24ff'), ('\u2500', '\u25b6'), ('\u25b7', '\u25b7'), ('\u25b8', '\u25c0'), ('\u25c1',
        '\u25c1'), ('\u25c2', '\u25f7'), ('\u25f8', '\u25ff'), ('\u2600', '\u266e'), ('\u266f',
        '\u266f'), ('\u2670', '\u2767'), ('\u2768', '\u2768'), ('\u2769', '\u2769'), ('\u276a',
        '\u276a'), ('\u276b', '\u276b'), ('\u276c', '\u276c'), ('\u276d', '\u276d'), ('\u276e',
        '\u276e'), ('\u276f', '\u276f'), ('\u2770', '\u2770'), ('\u2771', '\u2771'), ('\u2772',
        '\u2772'), ('\u2773', '\u2773'), ('\u2774', '\u2774'), ('\u2775', '\u2775'), ('\u2776',
        '\u2793'), ('\u2794', '\u27bf'), ('\u27c0', '\u27c4'), ('\u27c5', '\u27c5'), ('\u27c6',
        '\u27c6'), ('\u27c7', '\u27e5'), ('\u27e6', '\u27e6'), ('\u27e7', '\u27e7'), ('\u27e8',
        '\u27e8'), ('\u27e9', '\u27e9'), ('\u27ea', '\u27ea'), ('\u27eb', '\u27eb'), ('\u27ec',
        '\u27ec'), ('\u27ed', '\u27ed'), ('\u27ee', '\u27ee'), ('\u27ef', '\u27ef'), ('\u27f0',
        '\u27ff'), ('\u2900', '\u2982'), ('\u2983', '\u2983'), ('\u2984', '\u2984'), ('\u2985',
        '\u2985'), ('\u2986', '\u2986'), ('\u2987', '\u2987'), ('\u2988', '\u2988'), ('\u2989',
        '\u2989'), ('\u298a', '\u298a'), ('\u298b', '\u298b'), ('\u298c', '\u298c'), ('\u298d',
        '\u298d'), ('\u298e', '\u298e'), ('\u298f', '\u298f'), ('\u2990', '\u2990'), ('\u2991',
        '\u2991'), ('\u2992', '\u2992'), ('\u2993', '\u2993'), ('\u2994', '\u2994'), ('\u2995',
        '\u2995'), ('\u2996', '\u2996'), ('\u2997', '\u2997'), ('\u2998', '\u2998'), ('\u2999',
        '\u29d7'), ('\u29d8', '\u29d8'), ('\u29d9', '\u29d9'), ('\u29da', '\u29da'), ('\u29db',
        '\u29db'), ('\u29dc', '\u29fb'), ('\u29fc', '\u29fc'), ('\u29fd', '\u29fd'), ('\u29fe',
        '\u2aff'), ('\u2b00', '\u2b2f'), ('\u2b30', '\u2b44'), ('\u2b45', '\u2b46'), ('\u2b47',
        '\u2b4c'), ('\u2b4d', '\u2b73'), ('\u2b76', '\u2b95'), ('\u2b98', '\u2bb9'), ('\u2bbd',
        '\u2bc8'), ('\u2bca', '\u2bd1'), ('\u2e00', '\u2e01'), ('\u2e02', '\u2e02'), ('\u2e03',
        '\u2e03'), ('\u2e04', '\u2e04'), ('\u2e05', '\u2e05'), ('\u2e06', '\u2e08'), ('\u2e09',
        '\u2e09'), ('\u2e0a', '\u2e0a'), ('\u2e0b', '\u2e0b'), ('\u2e0c', '\u2e0c'), ('\u2e0d',
        '\u2e0d'), ('\u2e0e', '\u2e16'), ('\u2e17', '\u2e17'), ('\u2e18', '\u2e19'), ('\u2e1a',
        '\u2e1a'), ('\u2e1b', '\u2e1b'), ('\u2e1c', '\u2e1c'), ('\u2e1d', '\u2e1d'), ('\u2e1e',
        '\u2e1f'), ('\u2e20', '\u2e20'), ('\u2e21', '\u2e21'), ('\u2e22', '\u2e22'), ('\u2e23',
        '\u2e23'), ('\u2e24', '\u2e24'), ('\u2e25', '\u2e25'), ('\u2e26', '\u2e26'), ('\u2e27',
        '\u2e27'), ('\u2e28', '\u2e28'), ('\u2e29', '\u2e29'), ('\u2e2a', '\u2e2e'), ('\u2e2f',
        '\u2e2f'), ('\u2e30', '\u2e39'), ('\u2e3a', '\u2e3b'), ('\u2e3c', '\u2e3f'), ('\u2e40',
        '\u2e40'), ('\u2e41', '\u2e41'), ('\u2e42', '\u2e42'), ('\u2ff0', '\u2ffb'), ('\u3000',
        '\u3000'), ('\u3001', '\u3003'), ('\u3004', '\u3004'), ('\u3006', '\u3006'), ('\u3008',
        '\u3008'), ('\u3009', '\u3009'), ('\u300a', '\u300a'), ('\u300b', '\u300b'), ('\u300c',
        '\u300c'), ('\u300d', '\u300d'), ('\u300e', '\u300e'), ('\u300f', '\u300f'), ('\u3010',
        '\u3010'), ('\u3011', '\u3011'), ('\u3012', '\u3013'), ('\u3014', '\u3014'), ('\u3015',
        '\u3015'), ('\u3016', '\u3016'), ('\u3017', '\u3017'), ('\u3018', '\u3018'), ('\u3019',
        '\u3019'), ('\u301a', '\u301a'), ('\u301b', '\u301b'), ('\u301c', '\u301c'), ('\u301d',
        '\u301d'), ('\u301e', '\u301f'), ('\u3020', '\u3020'), ('\u3030', '\u3030'), ('\u3031',
        '\u3035'), ('\u3036', '\u3037'), ('\u303c', '\u303c'), ('\u303d', '\u303d'), ('\u303e',
        '\u303f'), ('\u309b', '\u309c'), ('\u30a0', '\u30a0'), ('\u30fb', '\u30fb'), ('\u30fc',
        '\u30fc'), ('\u3190', '\u3191'), ('\u3192', '\u3195'), ('\u3196', '\u319f'), ('\u31c0',
        '\u31e3'), ('\u3220', '\u3229'), ('\u322a', '\u3247'), ('\u3248', '\u324f'), ('\u3250',
        '\u3250'), ('\u3251', '\u325f'), ('\u327f', '\u327f'), ('\u3280', '\u3289'), ('\u328a',
        '\u32b0'), ('\u32b1', '\u32bf'), ('\u32c0', '\u32cf'), ('\u3358', '\u33ff'), ('\u4dc0',
        '\u4dff'), ('\ua700', '\ua716'), ('\ua717', '\ua71f'), ('\ua720', '\ua721'), ('\ua788',
        '\ua788'), ('\ua789', '\ua78a'), ('\ua830', '\ua835'), ('\ua836', '\ua837'), ('\ua838',
        '\ua838'), ('\ua839', '\ua839'), ('\ua92e', '\ua92e'), ('\ua9cf', '\ua9cf'), ('\uab5b',
        '\uab5b'), ('\ufd3e', '\ufd3e'), ('\ufd3f', '\ufd3f'), ('\ufe10', '\ufe16'), ('\ufe17',
        '\ufe17'), ('\ufe18', '\ufe18'), ('\ufe19', '\ufe19'), ('\ufe30', '\ufe30'), ('\ufe31',
        '\ufe32'), ('\ufe33', '\ufe34'), ('\ufe35', '\ufe35'), ('\ufe36', '\ufe36'), ('\ufe37',
        '\ufe37'), ('\ufe38', '\ufe38'), ('\ufe39', '\ufe39'), ('\ufe3a', '\ufe3a'), ('\ufe3b',
        '\ufe3b'), ('\ufe3c', '\ufe3c'), ('\ufe3d', '\ufe3d'), ('\ufe3e', '\ufe3e'), ('\ufe3f',
        '\ufe3f'), ('\ufe40', '\ufe40'), ('\ufe41', '\ufe41'), ('\ufe42', '\ufe42'), ('\ufe43',
        '\ufe43'), ('\ufe44', '\ufe44'), ('\ufe45', '\ufe46'), ('\ufe47', '\ufe47'), ('\ufe48',
        '\ufe48'), ('\ufe49', '\ufe4c'), ('\ufe4d', '\ufe4f'), ('\ufe50', '\ufe52'), ('\ufe54',
        '\ufe57'), ('\ufe58', '\ufe58'), ('\ufe59', '\ufe59'), ('\ufe5a', '\ufe5a'), ('\ufe5b',
        '\ufe5b'), ('\ufe5c', '\ufe5c'), ('\ufe5d', '\ufe5d'), ('\ufe5e', '\ufe5e'), ('\ufe5f',
        '\ufe61'), ('\ufe62', '\ufe62'), ('\ufe63', '\ufe63'), ('\ufe64', '\ufe66'), ('\ufe68',
        '\ufe68'), ('\ufe69', '\ufe69'), ('\ufe6a', '\ufe6b'), ('\ufeff', '\ufeff'), ('\uff01',
        '\uff03'), ('\uff04', '\uff04'), ('\uff05', '\uff07'), ('\uff08', '\uff08'), ('\uff09',
        '\uff09'), ('\uff0a', '\uff0a'), ('\uff0b', '\uff0b'), ('\uff0c', '\uff0c'), ('\uff0d',
        '\uff0d'), ('\uff0e', '\uff0f'), ('\uff10', '\uff19'), ('\uff1a', '\uff1b'), ('\uff1c',
        '\uff1e'), ('\uff1f', '\uff20'), ('\uff3b', '\uff3b'), ('\uff3c', '\uff3c'), ('\uff3d',
        '\uff3d'), ('\uff3e', '\uff3e'), ('\uff3f', '\uff3f'), ('\uff40', '\uff40'), ('\uff5b',
        '\uff5b'), ('\uff5c', '\uff5c'), ('\uff5d', '\uff5d'), ('\uff5e', '\uff5e'), ('\uff5f',
        '\uff5f'), ('\uff60', '\uff60'), ('\uff61', '\uff61'), ('\uff62', '\uff62'), ('\uff63',
        '\uff63'), ('\uff64', '\uff65'), ('\uff70', '\uff70'), ('\uff9e', '\uff9f'), ('\uffe0',
        '\uffe1'), ('\uffe2', '\uffe2'), ('\uffe3', '\uffe3'), ('\uffe4', '\uffe4'), ('\uffe5',
        '\uffe6'), ('\uffe8', '\uffe8'), ('\uffe9', '\uffec'), ('\uffed', '\uffee'), ('\ufff9',
        '\ufffb'), ('\ufffc', '\ufffd'), ('\U00010100', '\U00010102'), ('\U00010107', '\U00010133'),
        ('\U00010137', '\U0001013f'), ('\U00010190', '\U0001019b'), ('\U000101d0', '\U000101fc'),
        ('\U000102e1', '\U000102fb'), ('\U0001bca0', '\U0001bca3'), ('\U0001d000', '\U0001d0f5'),
        ('\U0001d100', '\U0001d126'), ('\U0001d129', '\U0001d164'), ('\U0001d165', '\U0001d166'),
        ('\U0001d16a', '\U0001d16c'), ('\U0001d16d', '\U0001d172'), ('\U0001d173', '\U0001d17a'),
        ('\U0001d183', '\U0001d184'), ('\U0001d18c', '\U0001d1a9'), ('\U0001d1ae', '\U0001d1dd'),
        ('\U0001d300', '\U0001d356'), ('\U0001d360', '\U0001d371'), ('\U0001d400', '\U0001d454'),
        ('\U0001d456', '\U0001d49c'), ('\U0001d49e', '\U0001d49f'), ('\U0001d4a2', '\U0001d4a2'),
        ('\U0001d4a5', '\U0001d4a6'), ('\U0001d4a9', '\U0001d4ac'), ('\U0001d4ae', '\U0001d4b9'),
        ('\U0001d4bb', '\U0001d4bb'), ('\U0001d4bd', '\U0001d4c3'), ('\U0001d4c5', '\U0001d505'),
        ('\U0001d507', '\U0001d50a'), ('\U0001d50d', '\U0001d514'), ('\U0001d516', '\U0001d51c'),
        ('\U0001d51e', '\U0001d539'), ('\U0001d53b', '\U0001d53e'), ('\U0001d540', '\U0001d544'),
        ('\U0001d546', '\U0001d546'), ('\U0001d54a', '\U0001d550'), ('\U0001d552', '\U0001d6a5'),
        ('\U0001d6a8', '\U0001d6c0'), ('\U0001d6c1', '\U0001d6c1'), ('\U0001d6c2', '\U0001d6da'),
        ('\U0001d6db', '\U0001d6db'), ('\U0001d6dc', '\U0001d6fa'), ('\U0001d6fb', '\U0001d6fb'),
        ('\U0001d6fc', '\U0001d714'), ('\U0001d715', '\U0001d715'), ('\U0001d716', '\U0001d734'),
        ('\U0001d735', '\U0001d735'), ('\U0001d736', '\U0001d74e'), ('\U0001d74f', '\U0001d74f'),
        ('\U0001d750', '\U0001d76e'), ('\U0001d76f', '\U0001d76f'), ('\U0001d770', '\U0001d788'),
        ('\U0001d789', '\U0001d789'), ('\U0001d78a', '\U0001d7a8'), ('\U0001d7a9', '\U0001d7a9'),
        ('\U0001d7aa', '\U0001d7c2'), ('\U0001d7c3', '\U0001d7c3'), ('\U0001d7c4', '\U0001d7cb'),
        ('\U0001d7ce', '\U0001d7ff'), ('\U0001f000', '\U0001f02b'), ('\U0001f030', '\U0001f093'),
        ('\U0001f0a0', '\U0001f0ae'), ('\U0001f0b1', '\U0001f0bf'), ('\U0001f0c1', '\U0001f0cf'),
        ('\U0001f0d1', '\U0001f0f5'), ('\U0001f100', '\U0001f10c'), ('\U0001f110', '\U0001f12e'),
        ('\U0001f130', '\U0001f16b'), ('\U0001f170', '\U0001f19a'), ('\U0001f1e6', '\U0001f1ff'),
        ('\U0001f201', '\U0001f202'), ('\U0001f210', '\U0001f23a'), ('\U0001f240', '\U0001f248'),
        ('\U0001f250', '\U0001f251'), ('\U0001f300', '\U0001f32c'), ('\U0001f330', '\U0001f37d'),
        ('\U0001f380', '\U0001f3ce'), ('\U0001f3d4', '\U0001f3f7'), ('\U0001f400', '\U0001f4fe'),
        ('\U0001f500', '\U0001f54a'), ('\U0001f550', '\U0001f579'), ('\U0001f57b', '\U0001f5a3'),
        ('\U0001f5a5', '\U0001f642'), ('\U0001f645', '\U0001f6cf'), ('\U0001f6e0', '\U0001f6ec'),
        ('\U0001f6f0', '\U0001f6f3'), ('\U0001f700', '\U0001f773'), ('\U0001f780', '\U0001f7d4'),
        ('\U0001f800', '\U0001f80b'), ('\U0001f810', '\U0001f847'), ('\U0001f850', '\U0001f859'),
        ('\U0001f860', '\U0001f887'), ('\U0001f890', '\U0001f8ad'), ('\U000e0001', '\U000e0001'),
        ('\U000e0020', '\U000e007f')
    ];

    pub static Coptic_table: &'static [(char, char)] = &[
        ('\u03e2', '\u03ef'), ('\u2c80', '\u2ce4'), ('\u2ce5', '\u2cea'), ('\u2ceb', '\u2cee'),
        ('\u2cef', '\u2cf1'), ('\u2cf2', '\u2cf3'), ('\u2cf9', '\u2cfc'), ('\u2cfd', '\u2cfd'),
        ('\u2cfe', '\u2cff')
    ];

    pub static Cuneiform_table: &'static [(char, char)] = &[
        ('\U00012000', '\U00012398'), ('\U00012400', '\U0001246e'), ('\U00012470', '\U00012474')
    ];

    pub static Cypriot_table: &'static [(char, char)] = &[
        ('\U00010800', '\U00010805'), ('\U00010808', '\U00010808'), ('\U0001080a', '\U00010835'),
        ('\U00010837', '\U00010838'), ('\U0001083c', '\U0001083c'), ('\U0001083f', '\U0001083f')
    ];

    pub static Cyrillic_table: &'static [(char, char)] = &[
        ('\u0400', '\u0481'), ('\u0482', '\u0482'), ('\u0483', '\u0484'), ('\u0487', '\u0487'),
        ('\u0488', '\u0489'), ('\u048a', '\u052f'), ('\u1d2b', '\u1d2b'), ('\u1d78', '\u1d78'),
        ('\u2de0', '\u2dff'), ('\ua640', '\ua66d'), ('\ua66e', '\ua66e'), ('\ua66f', '\ua66f'),
        ('\ua670', '\ua672'), ('\ua673', '\ua673'), ('\ua674', '\ua67d'), ('\ua67e', '\ua67e'),
        ('\ua67f', '\ua67f'), ('\ua680', '\ua69b'), ('\ua69c', '\ua69d'), ('\ua69f', '\ua69f')
    ];

    pub static Deseret_table: &'static [(char, char)] = &[
        ('\U00010400', '\U0001044f')
    ];

    pub static Devanagari_table: &'static [(char, char)] = &[
        ('\u0900', '\u0902'), ('\u0903', '\u0903'), ('\u0904', '\u0939'), ('\u093a', '\u093a'),
        ('\u093b', '\u093b'), ('\u093c', '\u093c'), ('\u093d', '\u093d'), ('\u093e', '\u0940'),
        ('\u0941', '\u0948'), ('\u0949', '\u094c'), ('\u094d', '\u094d'), ('\u094e', '\u094f'),
        ('\u0950', '\u0950'), ('\u0953', '\u0957'), ('\u0958', '\u0961'), ('\u0962', '\u0963'),
        ('\u0966', '\u096f'), ('\u0970', '\u0970'), ('\u0971', '\u0971'), ('\u0972', '\u097f'),
        ('\ua8e0', '\ua8f1'), ('\ua8f2', '\ua8f7'), ('\ua8f8', '\ua8fa'), ('\ua8fb', '\ua8fb')
    ];

    pub static Duployan_table: &'static [(char, char)] = &[
        ('\U0001bc00', '\U0001bc6a'), ('\U0001bc70', '\U0001bc7c'), ('\U0001bc80', '\U0001bc88'),
        ('\U0001bc90', '\U0001bc99'), ('\U0001bc9c', '\U0001bc9c'), ('\U0001bc9d', '\U0001bc9e'),
        ('\U0001bc9f', '\U0001bc9f')
    ];

    pub static Egyptian_Hieroglyphs_table: &'static [(char, char)] = &[
        ('\U00013000', '\U0001342e')
    ];

    pub static Elbasan_table: &'static [(char, char)] = &[
        ('\U00010500', '\U00010527')
    ];

    pub static Ethiopic_table: &'static [(char, char)] = &[
        ('\u1200', '\u1248'), ('\u124a', '\u124d'), ('\u1250', '\u1256'), ('\u1258', '\u1258'),
        ('\u125a', '\u125d'), ('\u1260', '\u1288'), ('\u128a', '\u128d'), ('\u1290', '\u12b0'),
        ('\u12b2', '\u12b5'), ('\u12b8', '\u12be'), ('\u12c0', '\u12c0'), ('\u12c2', '\u12c5'),
        ('\u12c8', '\u12d6'), ('\u12d8', '\u1310'), ('\u1312', '\u1315'), ('\u1318', '\u135a'),
        ('\u135d', '\u135f'), ('\u1360', '\u1368'), ('\u1369', '\u137c'), ('\u1380', '\u138f'),
        ('\u1390', '\u1399'), ('\u2d80', '\u2d96'), ('\u2da0', '\u2da6'), ('\u2da8', '\u2dae'),
        ('\u2db0', '\u2db6'), ('\u2db8', '\u2dbe'), ('\u2dc0', '\u2dc6'), ('\u2dc8', '\u2dce'),
        ('\u2dd0', '\u2dd6'), ('\u2dd8', '\u2dde'), ('\uab01', '\uab06'), ('\uab09', '\uab0e'),
        ('\uab11', '\uab16'), ('\uab20', '\uab26'), ('\uab28', '\uab2e')
    ];

    pub static Georgian_table: &'static [(char, char)] = &[
        ('\u10a0', '\u10c5'), ('\u10c7', '\u10c7'), ('\u10cd', '\u10cd'), ('\u10d0', '\u10fa'),
        ('\u10fc', '\u10fc'), ('\u10fd', '\u10ff'), ('\u2d00', '\u2d25'), ('\u2d27', '\u2d27'),
        ('\u2d2d', '\u2d2d')
    ];

    pub static Glagolitic_table: &'static [(char, char)] = &[
        ('\u2c00', '\u2c2e'), ('\u2c30', '\u2c5e')
    ];

    pub static Gothic_table: &'static [(char, char)] = &[
        ('\U00010330', '\U00010340'), ('\U00010341', '\U00010341'), ('\U00010342', '\U00010349'),
        ('\U0001034a', '\U0001034a')
    ];

    pub static Grantha_table: &'static [(char, char)] = &[
        ('\U00011301', '\U00011301'), ('\U00011302', '\U00011303'), ('\U00011305', '\U0001130c'),
        ('\U0001130f', '\U00011310'), ('\U00011313', '\U00011328'), ('\U0001132a', '\U00011330'),
        ('\U00011332', '\U00011333'), ('\U00011335', '\U00011339'), ('\U0001133c', '\U0001133c'),
        ('\U0001133d', '\U0001133d'), ('\U0001133e', '\U0001133f'), ('\U00011340', '\U00011340'),
        ('\U00011341', '\U00011344'), ('\U00011347', '\U00011348'), ('\U0001134b', '\U0001134d'),
        ('\U00011357', '\U00011357'), ('\U0001135d', '\U00011361'), ('\U00011362', '\U00011363'),
        ('\U00011366', '\U0001136c'), ('\U00011370', '\U00011374')
    ];

    pub static Greek_table: &'static [(char, char)] = &[
        ('\u0370', '\u0373'), ('\u0375', '\u0375'), ('\u0376', '\u0377'), ('\u037a', '\u037a'),
        ('\u037b', '\u037d'), ('\u037f', '\u037f'), ('\u0384', '\u0384'), ('\u0386', '\u0386'),
        ('\u0388', '\u038a'), ('\u038c', '\u038c'), ('\u038e', '\u03a1'), ('\u03a3', '\u03e1'),
        ('\u03f0', '\u03f5'), ('\u03f6', '\u03f6'), ('\u03f7', '\u03ff'), ('\u1d26', '\u1d2a'),
        ('\u1d5d', '\u1d61'), ('\u1d66', '\u1d6a'), ('\u1dbf', '\u1dbf'), ('\u1f00', '\u1f15'),
        ('\u1f18', '\u1f1d'), ('\u1f20', '\u1f45'), ('\u1f48', '\u1f4d'), ('\u1f50', '\u1f57'),
        ('\u1f59', '\u1f59'), ('\u1f5b', '\u1f5b'), ('\u1f5d', '\u1f5d'), ('\u1f5f', '\u1f7d'),
        ('\u1f80', '\u1fb4'), ('\u1fb6', '\u1fbc'), ('\u1fbd', '\u1fbd'), ('\u1fbe', '\u1fbe'),
        ('\u1fbf', '\u1fc1'), ('\u1fc2', '\u1fc4'), ('\u1fc6', '\u1fcc'), ('\u1fcd', '\u1fcf'),
        ('\u1fd0', '\u1fd3'), ('\u1fd6', '\u1fdb'), ('\u1fdd', '\u1fdf'), ('\u1fe0', '\u1fec'),
        ('\u1fed', '\u1fef'), ('\u1ff2', '\u1ff4'), ('\u1ff6', '\u1ffc'), ('\u1ffd', '\u1ffe'),
        ('\u2126', '\u2126'), ('\uab65', '\uab65'), ('\U00010140', '\U00010174'), ('\U00010175',
        '\U00010178'), ('\U00010179', '\U00010189'), ('\U0001018a', '\U0001018b'), ('\U0001018c',
        '\U0001018c'), ('\U000101a0', '\U000101a0'), ('\U0001d200', '\U0001d241'), ('\U0001d242',
        '\U0001d244'), ('\U0001d245', '\U0001d245')
    ];

    pub static Gujarati_table: &'static [(char, char)] = &[
        ('\u0a81', '\u0a82'), ('\u0a83', '\u0a83'), ('\u0a85', '\u0a8d'), ('\u0a8f', '\u0a91'),
        ('\u0a93', '\u0aa8'), ('\u0aaa', '\u0ab0'), ('\u0ab2', '\u0ab3'), ('\u0ab5', '\u0ab9'),
        ('\u0abc', '\u0abc'), ('\u0abd', '\u0abd'), ('\u0abe', '\u0ac0'), ('\u0ac1', '\u0ac5'),
        ('\u0ac7', '\u0ac8'), ('\u0ac9', '\u0ac9'), ('\u0acb', '\u0acc'), ('\u0acd', '\u0acd'),
        ('\u0ad0', '\u0ad0'), ('\u0ae0', '\u0ae1'), ('\u0ae2', '\u0ae3'), ('\u0ae6', '\u0aef'),
        ('\u0af0', '\u0af0'), ('\u0af1', '\u0af1')
    ];

    pub static Gurmukhi_table: &'static [(char, char)] = &[
        ('\u0a01', '\u0a02'), ('\u0a03', '\u0a03'), ('\u0a05', '\u0a0a'), ('\u0a0f', '\u0a10'),
        ('\u0a13', '\u0a28'), ('\u0a2a', '\u0a30'), ('\u0a32', '\u0a33'), ('\u0a35', '\u0a36'),
        ('\u0a38', '\u0a39'), ('\u0a3c', '\u0a3c'), ('\u0a3e', '\u0a40'), ('\u0a41', '\u0a42'),
        ('\u0a47', '\u0a48'), ('\u0a4b', '\u0a4d'), ('\u0a51', '\u0a51'), ('\u0a59', '\u0a5c'),
        ('\u0a5e', '\u0a5e'), ('\u0a66', '\u0a6f'), ('\u0a70', '\u0a71'), ('\u0a72', '\u0a74'),
        ('\u0a75', '\u0a75')
    ];

    pub static Han_table: &'static [(char, char)] = &[
        ('\u2e80', '\u2e99'), ('\u2e9b', '\u2ef3'), ('\u2f00', '\u2fd5'), ('\u3005', '\u3005'),
        ('\u3007', '\u3007'), ('\u3021', '\u3029'), ('\u3038', '\u303a'), ('\u303b', '\u303b'),
        ('\u3400', '\u4db5'), ('\u4e00', '\u9fcc'), ('\uf900', '\ufa6d'), ('\ufa70', '\ufad9'),
        ('\U00020000', '\U0002a6d6'), ('\U0002a700', '\U0002b734'), ('\U0002b740', '\U0002b81d'),
        ('\U0002f800', '\U0002fa1d')
    ];

    pub static Hangul_table: &'static [(char, char)] = &[
        ('\u1100', '\u11ff'), ('\u302e', '\u302f'), ('\u3131', '\u318e'), ('\u3200', '\u321e'),
        ('\u3260', '\u327e'), ('\ua960', '\ua97c'), ('\uac00', '\ud7a3'), ('\ud7b0', '\ud7c6'),
        ('\ud7cb', '\ud7fb'), ('\uffa0', '\uffbe'), ('\uffc2', '\uffc7'), ('\uffca', '\uffcf'),
        ('\uffd2', '\uffd7'), ('\uffda', '\uffdc')
    ];

    pub static Hanunoo_table: &'static [(char, char)] = &[
        ('\u1720', '\u1731'), ('\u1732', '\u1734')
    ];

    pub static Hebrew_table: &'static [(char, char)] = &[
        ('\u0591', '\u05bd'), ('\u05be', '\u05be'), ('\u05bf', '\u05bf'), ('\u05c0', '\u05c0'),
        ('\u05c1', '\u05c2'), ('\u05c3', '\u05c3'), ('\u05c4', '\u05c5'), ('\u05c6', '\u05c6'),
        ('\u05c7', '\u05c7'), ('\u05d0', '\u05ea'), ('\u05f0', '\u05f2'), ('\u05f3', '\u05f4'),
        ('\ufb1d', '\ufb1d'), ('\ufb1e', '\ufb1e'), ('\ufb1f', '\ufb28'), ('\ufb29', '\ufb29'),
        ('\ufb2a', '\ufb36'), ('\ufb38', '\ufb3c'), ('\ufb3e', '\ufb3e'), ('\ufb40', '\ufb41'),
        ('\ufb43', '\ufb44'), ('\ufb46', '\ufb4f')
    ];

    pub static Hiragana_table: &'static [(char, char)] = &[
        ('\u3041', '\u3096'), ('\u309d', '\u309e'), ('\u309f', '\u309f'), ('\U0001b001',
        '\U0001b001'), ('\U0001f200', '\U0001f200')
    ];

    pub static Imperial_Aramaic_table: &'static [(char, char)] = &[
        ('\U00010840', '\U00010855'), ('\U00010857', '\U00010857'), ('\U00010858', '\U0001085f')
    ];

    pub static Inherited_table: &'static [(char, char)] = &[
        ('\u0300', '\u036f'), ('\u0485', '\u0486'), ('\u064b', '\u0655'), ('\u0670', '\u0670'),
        ('\u0951', '\u0952'), ('\u1ab0', '\u1abd'), ('\u1abe', '\u1abe'), ('\u1cd0', '\u1cd2'),
        ('\u1cd4', '\u1ce0'), ('\u1ce2', '\u1ce8'), ('\u1ced', '\u1ced'), ('\u1cf4', '\u1cf4'),
        ('\u1cf8', '\u1cf9'), ('\u1dc0', '\u1df5'), ('\u1dfc', '\u1dff'), ('\u200c', '\u200d'),
        ('\u20d0', '\u20dc'), ('\u20dd', '\u20e0'), ('\u20e1', '\u20e1'), ('\u20e2', '\u20e4'),
        ('\u20e5', '\u20f0'), ('\u302a', '\u302d'), ('\u3099', '\u309a'), ('\ufe00', '\ufe0f'),
        ('\ufe20', '\ufe2d'), ('\U000101fd', '\U000101fd'), ('\U000102e0', '\U000102e0'),
        ('\U0001d167', '\U0001d169'), ('\U0001d17b', '\U0001d182'), ('\U0001d185', '\U0001d18b'),
        ('\U0001d1aa', '\U0001d1ad'), ('\U000e0100', '\U000e01ef')
    ];

    pub static Inscriptional_Pahlavi_table: &'static [(char, char)] = &[
        ('\U00010b60', '\U00010b72'), ('\U00010b78', '\U00010b7f')
    ];

    pub static Inscriptional_Parthian_table: &'static [(char, char)] = &[
        ('\U00010b40', '\U00010b55'), ('\U00010b58', '\U00010b5f')
    ];

    pub static Javanese_table: &'static [(char, char)] = &[
        ('\ua980', '\ua982'), ('\ua983', '\ua983'), ('\ua984', '\ua9b2'), ('\ua9b3', '\ua9b3'),
        ('\ua9b4', '\ua9b5'), ('\ua9b6', '\ua9b9'), ('\ua9ba', '\ua9bb'), ('\ua9bc', '\ua9bc'),
        ('\ua9bd', '\ua9c0'), ('\ua9c1', '\ua9cd'), ('\ua9d0', '\ua9d9'), ('\ua9de', '\ua9df')
    ];

    pub static Kaithi_table: &'static [(char, char)] = &[
        ('\U00011080', '\U00011081'), ('\U00011082', '\U00011082'), ('\U00011083', '\U000110af'),
        ('\U000110b0', '\U000110b2'), ('\U000110b3', '\U000110b6'), ('\U000110b7', '\U000110b8'),
        ('\U000110b9', '\U000110ba'), ('\U000110bb', '\U000110bc'), ('\U000110bd', '\U000110bd'),
        ('\U000110be', '\U000110c1')
    ];

    pub static Kannada_table: &'static [(char, char)] = &[
        ('\u0c81', '\u0c81'), ('\u0c82', '\u0c83'), ('\u0c85', '\u0c8c'), ('\u0c8e', '\u0c90'),
        ('\u0c92', '\u0ca8'), ('\u0caa', '\u0cb3'), ('\u0cb5', '\u0cb9'), ('\u0cbc', '\u0cbc'),
        ('\u0cbd', '\u0cbd'), ('\u0cbe', '\u0cbe'), ('\u0cbf', '\u0cbf'), ('\u0cc0', '\u0cc4'),
        ('\u0cc6', '\u0cc6'), ('\u0cc7', '\u0cc8'), ('\u0cca', '\u0ccb'), ('\u0ccc', '\u0ccd'),
        ('\u0cd5', '\u0cd6'), ('\u0cde', '\u0cde'), ('\u0ce0', '\u0ce1'), ('\u0ce2', '\u0ce3'),
        ('\u0ce6', '\u0cef'), ('\u0cf1', '\u0cf2')
    ];

    pub static Katakana_table: &'static [(char, char)] = &[
        ('\u30a1', '\u30fa'), ('\u30fd', '\u30fe'), ('\u30ff', '\u30ff'), ('\u31f0', '\u31ff'),
        ('\u32d0', '\u32fe'), ('\u3300', '\u3357'), ('\uff66', '\uff6f'), ('\uff71', '\uff9d'),
        ('\U0001b000', '\U0001b000')
    ];

    pub static Kayah_Li_table: &'static [(char, char)] = &[
        ('\ua900', '\ua909'), ('\ua90a', '\ua925'), ('\ua926', '\ua92d'), ('\ua92f', '\ua92f')
    ];

    pub static Kharoshthi_table: &'static [(char, char)] = &[
        ('\U00010a00', '\U00010a00'), ('\U00010a01', '\U00010a03'), ('\U00010a05', '\U00010a06'),
        ('\U00010a0c', '\U00010a0f'), ('\U00010a10', '\U00010a13'), ('\U00010a15', '\U00010a17'),
        ('\U00010a19', '\U00010a33'), ('\U00010a38', '\U00010a3a'), ('\U00010a3f', '\U00010a3f'),
        ('\U00010a40', '\U00010a47'), ('\U00010a50', '\U00010a58')
    ];

    pub static Khmer_table: &'static [(char, char)] = &[
        ('\u1780', '\u17b3'), ('\u17b4', '\u17b5'), ('\u17b6', '\u17b6'), ('\u17b7', '\u17bd'),
        ('\u17be', '\u17c5'), ('\u17c6', '\u17c6'), ('\u17c7', '\u17c8'), ('\u17c9', '\u17d3'),
        ('\u17d4', '\u17d6'), ('\u17d7', '\u17d7'), ('\u17d8', '\u17da'), ('\u17db', '\u17db'),
        ('\u17dc', '\u17dc'), ('\u17dd', '\u17dd'), ('\u17e0', '\u17e9'), ('\u17f0', '\u17f9'),
        ('\u19e0', '\u19ff')
    ];

    pub static Khojki_table: &'static [(char, char)] = &[
        ('\U00011200', '\U00011211'), ('\U00011213', '\U0001122b'), ('\U0001122c', '\U0001122e'),
        ('\U0001122f', '\U00011231'), ('\U00011232', '\U00011233'), ('\U00011234', '\U00011234'),
        ('\U00011235', '\U00011235'), ('\U00011236', '\U00011237'), ('\U00011238', '\U0001123d')
    ];

    pub static Khudawadi_table: &'static [(char, char)] = &[
        ('\U000112b0', '\U000112de'), ('\U000112df', '\U000112df'), ('\U000112e0', '\U000112e2'),
        ('\U000112e3', '\U000112ea'), ('\U000112f0', '\U000112f9')
    ];

    pub static Lao_table: &'static [(char, char)] = &[
        ('\u0e81', '\u0e82'), ('\u0e84', '\u0e84'), ('\u0e87', '\u0e88'), ('\u0e8a', '\u0e8a'),
        ('\u0e8d', '\u0e8d'), ('\u0e94', '\u0e97'), ('\u0e99', '\u0e9f'), ('\u0ea1', '\u0ea3'),
        ('\u0ea5', '\u0ea5'), ('\u0ea7', '\u0ea7'), ('\u0eaa', '\u0eab'), ('\u0ead', '\u0eb0'),
        ('\u0eb1', '\u0eb1'), ('\u0eb2', '\u0eb3'), ('\u0eb4', '\u0eb9'), ('\u0ebb', '\u0ebc'),
        ('\u0ebd', '\u0ebd'), ('\u0ec0', '\u0ec4'), ('\u0ec6', '\u0ec6'), ('\u0ec8', '\u0ecd'),
        ('\u0ed0', '\u0ed9'), ('\u0edc', '\u0edf')
    ];

    pub static Latin_table: &'static [(char, char)] = &[
        ('\x41', '\x5a'), ('\x61', '\x7a'), ('\u00aa', '\u00aa'), ('\u00ba', '\u00ba'), ('\u00c0',
        '\u00d6'), ('\u00d8', '\u00f6'), ('\u00f8', '\u01ba'), ('\u01bb', '\u01bb'), ('\u01bc',
        '\u01bf'), ('\u01c0', '\u01c3'), ('\u01c4', '\u0293'), ('\u0294', '\u0294'), ('\u0295',
        '\u02af'), ('\u02b0', '\u02b8'), ('\u02e0', '\u02e4'), ('\u1d00', '\u1d25'), ('\u1d2c',
        '\u1d5c'), ('\u1d62', '\u1d65'), ('\u1d6b', '\u1d77'), ('\u1d79', '\u1d9a'), ('\u1d9b',
        '\u1dbe'), ('\u1e00', '\u1eff'), ('\u2071', '\u2071'), ('\u207f', '\u207f'), ('\u2090',
        '\u209c'), ('\u212a', '\u212b'), ('\u2132', '\u2132'), ('\u214e', '\u214e'), ('\u2160',
        '\u2182'), ('\u2183', '\u2184'), ('\u2185', '\u2188'), ('\u2c60', '\u2c7b'), ('\u2c7c',
        '\u2c7d'), ('\u2c7e', '\u2c7f'), ('\ua722', '\ua76f'), ('\ua770', '\ua770'), ('\ua771',
        '\ua787'), ('\ua78b', '\ua78e'), ('\ua790', '\ua7ad'), ('\ua7b0', '\ua7b1'), ('\ua7f7',
        '\ua7f7'), ('\ua7f8', '\ua7f9'), ('\ua7fa', '\ua7fa'), ('\ua7fb', '\ua7ff'), ('\uab30',
        '\uab5a'), ('\uab5c', '\uab5f'), ('\uab64', '\uab64'), ('\ufb00', '\ufb06'), ('\uff21',
        '\uff3a'), ('\uff41', '\uff5a')
    ];

    pub static Lepcha_table: &'static [(char, char)] = &[
        ('\u1c00', '\u1c23'), ('\u1c24', '\u1c2b'), ('\u1c2c', '\u1c33'), ('\u1c34', '\u1c35'),
        ('\u1c36', '\u1c37'), ('\u1c3b', '\u1c3f'), ('\u1c40', '\u1c49'), ('\u1c4d', '\u1c4f')
    ];

    pub static Limbu_table: &'static [(char, char)] = &[
        ('\u1900', '\u191e'), ('\u1920', '\u1922'), ('\u1923', '\u1926'), ('\u1927', '\u1928'),
        ('\u1929', '\u192b'), ('\u1930', '\u1931'), ('\u1932', '\u1932'), ('\u1933', '\u1938'),
        ('\u1939', '\u193b'), ('\u1940', '\u1940'), ('\u1944', '\u1945'), ('\u1946', '\u194f')
    ];

    pub static Linear_A_table: &'static [(char, char)] = &[
        ('\U00010600', '\U00010736'), ('\U00010740', '\U00010755'), ('\U00010760', '\U00010767')
    ];

    pub static Linear_B_table: &'static [(char, char)] = &[
        ('\U00010000', '\U0001000b'), ('\U0001000d', '\U00010026'), ('\U00010028', '\U0001003a'),
        ('\U0001003c', '\U0001003d'), ('\U0001003f', '\U0001004d'), ('\U00010050', '\U0001005d'),
        ('\U00010080', '\U000100fa')
    ];

    pub static Lisu_table: &'static [(char, char)] = &[
        ('\ua4d0', '\ua4f7'), ('\ua4f8', '\ua4fd'), ('\ua4fe', '\ua4ff')
    ];

    pub static Lycian_table: &'static [(char, char)] = &[
        ('\U00010280', '\U0001029c')
    ];

    pub static Lydian_table: &'static [(char, char)] = &[
        ('\U00010920', '\U00010939'), ('\U0001093f', '\U0001093f')
    ];

    pub static Mahajani_table: &'static [(char, char)] = &[
        ('\U00011150', '\U00011172'), ('\U00011173', '\U00011173'), ('\U00011174', '\U00011175'),
        ('\U00011176', '\U00011176')
    ];

    pub static Malayalam_table: &'static [(char, char)] = &[
        ('\u0d01', '\u0d01'), ('\u0d02', '\u0d03'), ('\u0d05', '\u0d0c'), ('\u0d0e', '\u0d10'),
        ('\u0d12', '\u0d3a'), ('\u0d3d', '\u0d3d'), ('\u0d3e', '\u0d40'), ('\u0d41', '\u0d44'),
        ('\u0d46', '\u0d48'), ('\u0d4a', '\u0d4c'), ('\u0d4d', '\u0d4d'), ('\u0d4e', '\u0d4e'),
        ('\u0d57', '\u0d57'), ('\u0d60', '\u0d61'), ('\u0d62', '\u0d63'), ('\u0d66', '\u0d6f'),
        ('\u0d70', '\u0d75'), ('\u0d79', '\u0d79'), ('\u0d7a', '\u0d7f')
    ];

    pub static Mandaic_table: &'static [(char, char)] = &[
        ('\u0840', '\u0858'), ('\u0859', '\u085b'), ('\u085e', '\u085e')
    ];

    pub static Manichaean_table: &'static [(char, char)] = &[
        ('\U00010ac0', '\U00010ac7'), ('\U00010ac8', '\U00010ac8'), ('\U00010ac9', '\U00010ae4'),
        ('\U00010ae5', '\U00010ae6'), ('\U00010aeb', '\U00010aef'), ('\U00010af0', '\U00010af6')
    ];

    pub static Meetei_Mayek_table: &'static [(char, char)] = &[
        ('\uaae0', '\uaaea'), ('\uaaeb', '\uaaeb'), ('\uaaec', '\uaaed'), ('\uaaee', '\uaaef'),
        ('\uaaf0', '\uaaf1'), ('\uaaf2', '\uaaf2'), ('\uaaf3', '\uaaf4'), ('\uaaf5', '\uaaf5'),
        ('\uaaf6', '\uaaf6'), ('\uabc0', '\uabe2'), ('\uabe3', '\uabe4'), ('\uabe5', '\uabe5'),
        ('\uabe6', '\uabe7'), ('\uabe8', '\uabe8'), ('\uabe9', '\uabea'), ('\uabeb', '\uabeb'),
        ('\uabec', '\uabec'), ('\uabed', '\uabed'), ('\uabf0', '\uabf9')
    ];

    pub static Mende_Kikakui_table: &'static [(char, char)] = &[
        ('\U0001e800', '\U0001e8c4'), ('\U0001e8c7', '\U0001e8cf'), ('\U0001e8d0', '\U0001e8d6')
    ];

    pub static Meroitic_Cursive_table: &'static [(char, char)] = &[
        ('\U000109a0', '\U000109b7'), ('\U000109be', '\U000109bf')
    ];

    pub static Meroitic_Hieroglyphs_table: &'static [(char, char)] = &[
        ('\U00010980', '\U0001099f')
    ];

    pub static Miao_table: &'static [(char, char)] = &[
        ('\U00016f00', '\U00016f44'), ('\U00016f50', '\U00016f50'), ('\U00016f51', '\U00016f7e'),
        ('\U00016f8f', '\U00016f92'), ('\U00016f93', '\U00016f9f')
    ];

    pub static Modi_table: &'static [(char, char)] = &[
        ('\U00011600', '\U0001162f'), ('\U00011630', '\U00011632'), ('\U00011633', '\U0001163a'),
        ('\U0001163b', '\U0001163c'), ('\U0001163d', '\U0001163d'), ('\U0001163e', '\U0001163e'),
        ('\U0001163f', '\U00011640'), ('\U00011641', '\U00011643'), ('\U00011644', '\U00011644'),
        ('\U00011650', '\U00011659')
    ];

    pub static Mongolian_table: &'static [(char, char)] = &[
        ('\u1800', '\u1801'), ('\u1804', '\u1804'), ('\u1806', '\u1806'), ('\u1807', '\u180a'),
        ('\u180b', '\u180d'), ('\u180e', '\u180e'), ('\u1810', '\u1819'), ('\u1820', '\u1842'),
        ('\u1843', '\u1843'), ('\u1844', '\u1877'), ('\u1880', '\u18a8'), ('\u18a9', '\u18a9'),
        ('\u18aa', '\u18aa')
    ];

    pub static Mro_table: &'static [(char, char)] = &[
        ('\U00016a40', '\U00016a5e'), ('\U00016a60', '\U00016a69'), ('\U00016a6e', '\U00016a6f')
    ];

    pub static Myanmar_table: &'static [(char, char)] = &[
        ('\u1000', '\u102a'), ('\u102b', '\u102c'), ('\u102d', '\u1030'), ('\u1031', '\u1031'),
        ('\u1032', '\u1037'), ('\u1038', '\u1038'), ('\u1039', '\u103a'), ('\u103b', '\u103c'),
        ('\u103d', '\u103e'), ('\u103f', '\u103f'), ('\u1040', '\u1049'), ('\u104a', '\u104f'),
        ('\u1050', '\u1055'), ('\u1056', '\u1057'), ('\u1058', '\u1059'), ('\u105a', '\u105d'),
        ('\u105e', '\u1060'), ('\u1061', '\u1061'), ('\u1062', '\u1064'), ('\u1065', '\u1066'),
        ('\u1067', '\u106d'), ('\u106e', '\u1070'), ('\u1071', '\u1074'), ('\u1075', '\u1081'),
        ('\u1082', '\u1082'), ('\u1083', '\u1084'), ('\u1085', '\u1086'), ('\u1087', '\u108c'),
        ('\u108d', '\u108d'), ('\u108e', '\u108e'), ('\u108f', '\u108f'), ('\u1090', '\u1099'),
        ('\u109a', '\u109c'), ('\u109d', '\u109d'), ('\u109e', '\u109f'), ('\ua9e0', '\ua9e4'),
        ('\ua9e5', '\ua9e5'), ('\ua9e6', '\ua9e6'), ('\ua9e7', '\ua9ef'), ('\ua9f0', '\ua9f9'),
        ('\ua9fa', '\ua9fe'), ('\uaa60', '\uaa6f'), ('\uaa70', '\uaa70'), ('\uaa71', '\uaa76'),
        ('\uaa77', '\uaa79'), ('\uaa7a', '\uaa7a'), ('\uaa7b', '\uaa7b'), ('\uaa7c', '\uaa7c'),
        ('\uaa7d', '\uaa7d'), ('\uaa7e', '\uaa7f')
    ];

    pub static Nabataean_table: &'static [(char, char)] = &[
        ('\U00010880', '\U0001089e'), ('\U000108a7', '\U000108af')
    ];

    pub static New_Tai_Lue_table: &'static [(char, char)] = &[
        ('\u1980', '\u19ab'), ('\u19b0', '\u19c0'), ('\u19c1', '\u19c7'), ('\u19c8', '\u19c9'),
        ('\u19d0', '\u19d9'), ('\u19da', '\u19da'), ('\u19de', '\u19df')
    ];

    pub static Nko_table: &'static [(char, char)] = &[
        ('\u07c0', '\u07c9'), ('\u07ca', '\u07ea'), ('\u07eb', '\u07f3'), ('\u07f4', '\u07f5'),
        ('\u07f6', '\u07f6'), ('\u07f7', '\u07f9'), ('\u07fa', '\u07fa')
    ];

    pub static Ogham_table: &'static [(char, char)] = &[
        ('\u1680', '\u1680'), ('\u1681', '\u169a'), ('\u169b', '\u169b'), ('\u169c', '\u169c')
    ];

    pub static Ol_Chiki_table: &'static [(char, char)] = &[
        ('\u1c50', '\u1c59'), ('\u1c5a', '\u1c77'), ('\u1c78', '\u1c7d'), ('\u1c7e', '\u1c7f')
    ];

    pub static Old_Italic_table: &'static [(char, char)] = &[
        ('\U00010300', '\U0001031f'), ('\U00010320', '\U00010323')
    ];

    pub static Old_North_Arabian_table: &'static [(char, char)] = &[
        ('\U00010a80', '\U00010a9c'), ('\U00010a9d', '\U00010a9f')
    ];

    pub static Old_Permic_table: &'static [(char, char)] = &[
        ('\U00010350', '\U00010375'), ('\U00010376', '\U0001037a')
    ];

    pub static Old_Persian_table: &'static [(char, char)] = &[
        ('\U000103a0', '\U000103c3'), ('\U000103c8', '\U000103cf'), ('\U000103d0', '\U000103d0'),
        ('\U000103d1', '\U000103d5')
    ];

    pub static Old_South_Arabian_table: &'static [(char, char)] = &[
        ('\U00010a60', '\U00010a7c'), ('\U00010a7d', '\U00010a7e'), ('\U00010a7f', '\U00010a7f')
    ];

    pub static Old_Turkic_table: &'static [(char, char)] = &[
        ('\U00010c00', '\U00010c48')
    ];

    pub static Oriya_table: &'static [(char, char)] = &[
        ('\u0b01', '\u0b01'), ('\u0b02', '\u0b03'), ('\u0b05', '\u0b0c'), ('\u0b0f', '\u0b10'),
        ('\u0b13', '\u0b28'), ('\u0b2a', '\u0b30'), ('\u0b32', '\u0b33'), ('\u0b35', '\u0b39'),
        ('\u0b3c', '\u0b3c'), ('\u0b3d', '\u0b3d'), ('\u0b3e', '\u0b3e'), ('\u0b3f', '\u0b3f'),
        ('\u0b40', '\u0b40'), ('\u0b41', '\u0b44'), ('\u0b47', '\u0b48'), ('\u0b4b', '\u0b4c'),
        ('\u0b4d', '\u0b4d'), ('\u0b56', '\u0b56'), ('\u0b57', '\u0b57'), ('\u0b5c', '\u0b5d'),
        ('\u0b5f', '\u0b61'), ('\u0b62', '\u0b63'), ('\u0b66', '\u0b6f'), ('\u0b70', '\u0b70'),
        ('\u0b71', '\u0b71'), ('\u0b72', '\u0b77')
    ];

    pub static Osmanya_table: &'static [(char, char)] = &[
        ('\U00010480', '\U0001049d'), ('\U000104a0', '\U000104a9')
    ];

    pub static Pahawh_Hmong_table: &'static [(char, char)] = &[
        ('\U00016b00', '\U00016b2f'), ('\U00016b30', '\U00016b36'), ('\U00016b37', '\U00016b3b'),
        ('\U00016b3c', '\U00016b3f'), ('\U00016b40', '\U00016b43'), ('\U00016b44', '\U00016b44'),
        ('\U00016b45', '\U00016b45'), ('\U00016b50', '\U00016b59'), ('\U00016b5b', '\U00016b61'),
        ('\U00016b63', '\U00016b77'), ('\U00016b7d', '\U00016b8f')
    ];

    pub static Palmyrene_table: &'static [(char, char)] = &[
        ('\U00010860', '\U00010876'), ('\U00010877', '\U00010878'), ('\U00010879', '\U0001087f')
    ];

    pub static Pau_Cin_Hau_table: &'static [(char, char)] = &[
        ('\U00011ac0', '\U00011af8')
    ];

    pub static Phags_Pa_table: &'static [(char, char)] = &[
        ('\ua840', '\ua873'), ('\ua874', '\ua877')
    ];

    pub static Phoenician_table: &'static [(char, char)] = &[
        ('\U00010900', '\U00010915'), ('\U00010916', '\U0001091b'), ('\U0001091f', '\U0001091f')
    ];

    pub static Psalter_Pahlavi_table: &'static [(char, char)] = &[
        ('\U00010b80', '\U00010b91'), ('\U00010b99', '\U00010b9c'), ('\U00010ba9', '\U00010baf')
    ];

    pub static Rejang_table: &'static [(char, char)] = &[
        ('\ua930', '\ua946'), ('\ua947', '\ua951'), ('\ua952', '\ua953'), ('\ua95f', '\ua95f')
    ];

    pub static Runic_table: &'static [(char, char)] = &[
        ('\u16a0', '\u16ea'), ('\u16ee', '\u16f0'), ('\u16f1', '\u16f8')
    ];

    pub static Samaritan_table: &'static [(char, char)] = &[
        ('\u0800', '\u0815'), ('\u0816', '\u0819'), ('\u081a', '\u081a'), ('\u081b', '\u0823'),
        ('\u0824', '\u0824'), ('\u0825', '\u0827'), ('\u0828', '\u0828'), ('\u0829', '\u082d'),
        ('\u0830', '\u083e')
    ];

    pub static Saurashtra_table: &'static [(char, char)] = &[
        ('\ua880', '\ua881'), ('\ua882', '\ua8b3'), ('\ua8b4', '\ua8c3'), ('\ua8c4', '\ua8c4'),
        ('\ua8ce', '\ua8cf'), ('\ua8d0', '\ua8d9')
    ];

    pub static Sharada_table: &'static [(char, char)] = &[
        ('\U00011180', '\U00011181'), ('\U00011182', '\U00011182'), ('\U00011183', '\U000111b2'),
        ('\U000111b3', '\U000111b5'), ('\U000111b6', '\U000111be'), ('\U000111bf', '\U000111c0'),
        ('\U000111c1', '\U000111c4'), ('\U000111c5', '\U000111c8'), ('\U000111cd', '\U000111cd'),
        ('\U000111d0', '\U000111d9'), ('\U000111da', '\U000111da')
    ];

    pub static Shavian_table: &'static [(char, char)] = &[
        ('\U00010450', '\U0001047f')
    ];

    pub static Siddham_table: &'static [(char, char)] = &[
        ('\U00011580', '\U000115ae'), ('\U000115af', '\U000115b1'), ('\U000115b2', '\U000115b5'),
        ('\U000115b8', '\U000115bb'), ('\U000115bc', '\U000115bd'), ('\U000115be', '\U000115be'),
        ('\U000115bf', '\U000115c0'), ('\U000115c1', '\U000115c9')
    ];

    pub static Sinhala_table: &'static [(char, char)] = &[
        ('\u0d82', '\u0d83'), ('\u0d85', '\u0d96'), ('\u0d9a', '\u0db1'), ('\u0db3', '\u0dbb'),
        ('\u0dbd', '\u0dbd'), ('\u0dc0', '\u0dc6'), ('\u0dca', '\u0dca'), ('\u0dcf', '\u0dd1'),
        ('\u0dd2', '\u0dd4'), ('\u0dd6', '\u0dd6'), ('\u0dd8', '\u0ddf'), ('\u0de6', '\u0def'),
        ('\u0df2', '\u0df3'), ('\u0df4', '\u0df4'), ('\U000111e1', '\U000111f4')
    ];

    pub static Sora_Sompeng_table: &'static [(char, char)] = &[
        ('\U000110d0', '\U000110e8'), ('\U000110f0', '\U000110f9')
    ];

    pub static Sundanese_table: &'static [(char, char)] = &[
        ('\u1b80', '\u1b81'), ('\u1b82', '\u1b82'), ('\u1b83', '\u1ba0'), ('\u1ba1', '\u1ba1'),
        ('\u1ba2', '\u1ba5'), ('\u1ba6', '\u1ba7'), ('\u1ba8', '\u1ba9'), ('\u1baa', '\u1baa'),
        ('\u1bab', '\u1bad'), ('\u1bae', '\u1baf'), ('\u1bb0', '\u1bb9'), ('\u1bba', '\u1bbf'),
        ('\u1cc0', '\u1cc7')
    ];

    pub static Syloti_Nagri_table: &'static [(char, char)] = &[
        ('\ua800', '\ua801'), ('\ua802', '\ua802'), ('\ua803', '\ua805'), ('\ua806', '\ua806'),
        ('\ua807', '\ua80a'), ('\ua80b', '\ua80b'), ('\ua80c', '\ua822'), ('\ua823', '\ua824'),
        ('\ua825', '\ua826'), ('\ua827', '\ua827'), ('\ua828', '\ua82b')
    ];

    pub static Syriac_table: &'static [(char, char)] = &[
        ('\u0700', '\u070d'), ('\u070f', '\u070f'), ('\u0710', '\u0710'), ('\u0711', '\u0711'),
        ('\u0712', '\u072f'), ('\u0730', '\u074a'), ('\u074d', '\u074f')
    ];

    pub static Tagalog_table: &'static [(char, char)] = &[
        ('\u1700', '\u170c'), ('\u170e', '\u1711'), ('\u1712', '\u1714')
    ];

    pub static Tagbanwa_table: &'static [(char, char)] = &[
        ('\u1760', '\u176c'), ('\u176e', '\u1770'), ('\u1772', '\u1773')
    ];

    pub static Tai_Le_table: &'static [(char, char)] = &[
        ('\u1950', '\u196d'), ('\u1970', '\u1974')
    ];

    pub static Tai_Tham_table: &'static [(char, char)] = &[
        ('\u1a20', '\u1a54'), ('\u1a55', '\u1a55'), ('\u1a56', '\u1a56'), ('\u1a57', '\u1a57'),
        ('\u1a58', '\u1a5e'), ('\u1a60', '\u1a60'), ('\u1a61', '\u1a61'), ('\u1a62', '\u1a62'),
        ('\u1a63', '\u1a64'), ('\u1a65', '\u1a6c'), ('\u1a6d', '\u1a72'), ('\u1a73', '\u1a7c'),
        ('\u1a7f', '\u1a7f'), ('\u1a80', '\u1a89'), ('\u1a90', '\u1a99'), ('\u1aa0', '\u1aa6'),
        ('\u1aa7', '\u1aa7'), ('\u1aa8', '\u1aad')
    ];

    pub static Tai_Viet_table: &'static [(char, char)] = &[
        ('\uaa80', '\uaaaf'), ('\uaab0', '\uaab0'), ('\uaab1', '\uaab1'), ('\uaab2', '\uaab4'),
        ('\uaab5', '\uaab6'), ('\uaab7', '\uaab8'), ('\uaab9', '\uaabd'), ('\uaabe', '\uaabf'),
        ('\uaac0', '\uaac0'), ('\uaac1', '\uaac1'), ('\uaac2', '\uaac2'), ('\uaadb', '\uaadc'),
        ('\uaadd', '\uaadd'), ('\uaade', '\uaadf')
    ];

    pub static Takri_table: &'static [(char, char)] = &[
        ('\U00011680', '\U000116aa'), ('\U000116ab', '\U000116ab'), ('\U000116ac', '\U000116ac'),
        ('\U000116ad', '\U000116ad'), ('\U000116ae', '\U000116af'), ('\U000116b0', '\U000116b5'),
        ('\U000116b6', '\U000116b6'), ('\U000116b7', '\U000116b7'), ('\U000116c0', '\U000116c9')
    ];

    pub static Tamil_table: &'static [(char, char)] = &[
        ('\u0b82', '\u0b82'), ('\u0b83', '\u0b83'), ('\u0b85', '\u0b8a'), ('\u0b8e', '\u0b90'),
        ('\u0b92', '\u0b95'), ('\u0b99', '\u0b9a'), ('\u0b9c', '\u0b9c'), ('\u0b9e', '\u0b9f'),
        ('\u0ba3', '\u0ba4'), ('\u0ba8', '\u0baa'), ('\u0bae', '\u0bb9'), ('\u0bbe', '\u0bbf'),
        ('\u0bc0', '\u0bc0'), ('\u0bc1', '\u0bc2'), ('\u0bc6', '\u0bc8'), ('\u0bca', '\u0bcc'),
        ('\u0bcd', '\u0bcd'), ('\u0bd0', '\u0bd0'), ('\u0bd7', '\u0bd7'), ('\u0be6', '\u0bef'),
        ('\u0bf0', '\u0bf2'), ('\u0bf3', '\u0bf8'), ('\u0bf9', '\u0bf9'), ('\u0bfa', '\u0bfa')
    ];

    pub static Telugu_table: &'static [(char, char)] = &[
        ('\u0c00', '\u0c00'), ('\u0c01', '\u0c03'), ('\u0c05', '\u0c0c'), ('\u0c0e', '\u0c10'),
        ('\u0c12', '\u0c28'), ('\u0c2a', '\u0c39'), ('\u0c3d', '\u0c3d'), ('\u0c3e', '\u0c40'),
        ('\u0c41', '\u0c44'), ('\u0c46', '\u0c48'), ('\u0c4a', '\u0c4d'), ('\u0c55', '\u0c56'),
        ('\u0c58', '\u0c59'), ('\u0c60', '\u0c61'), ('\u0c62', '\u0c63'), ('\u0c66', '\u0c6f'),
        ('\u0c78', '\u0c7e'), ('\u0c7f', '\u0c7f')
    ];

    pub static Thaana_table: &'static [(char, char)] = &[
        ('\u0780', '\u07a5'), ('\u07a6', '\u07b0'), ('\u07b1', '\u07b1')
    ];

    pub static Thai_table: &'static [(char, char)] = &[
        ('\u0e01', '\u0e30'), ('\u0e31', '\u0e31'), ('\u0e32', '\u0e33'), ('\u0e34', '\u0e3a'),
        ('\u0e40', '\u0e45'), ('\u0e46', '\u0e46'), ('\u0e47', '\u0e4e'), ('\u0e4f', '\u0e4f'),
        ('\u0e50', '\u0e59'), ('\u0e5a', '\u0e5b')
    ];

    pub static Tibetan_table: &'static [(char, char)] = &[
        ('\u0f00', '\u0f00'), ('\u0f01', '\u0f03'), ('\u0f04', '\u0f12'), ('\u0f13', '\u0f13'),
        ('\u0f14', '\u0f14'), ('\u0f15', '\u0f17'), ('\u0f18', '\u0f19'), ('\u0f1a', '\u0f1f'),
        ('\u0f20', '\u0f29'), ('\u0f2a', '\u0f33'), ('\u0f34', '\u0f34'), ('\u0f35', '\u0f35'),
        ('\u0f36', '\u0f36'), ('\u0f37', '\u0f37'), ('\u0f38', '\u0f38'), ('\u0f39', '\u0f39'),
        ('\u0f3a', '\u0f3a'), ('\u0f3b', '\u0f3b'), ('\u0f3c', '\u0f3c'), ('\u0f3d', '\u0f3d'),
        ('\u0f3e', '\u0f3f'), ('\u0f40', '\u0f47'), ('\u0f49', '\u0f6c'), ('\u0f71', '\u0f7e'),
        ('\u0f7f', '\u0f7f'), ('\u0f80', '\u0f84'), ('\u0f85', '\u0f85'), ('\u0f86', '\u0f87'),
        ('\u0f88', '\u0f8c'), ('\u0f8d', '\u0f97'), ('\u0f99', '\u0fbc'), ('\u0fbe', '\u0fc5'),
        ('\u0fc6', '\u0fc6'), ('\u0fc7', '\u0fcc'), ('\u0fce', '\u0fcf'), ('\u0fd0', '\u0fd4'),
        ('\u0fd9', '\u0fda')
    ];

    pub static Tifinagh_table: &'static [(char, char)] = &[
        ('\u2d30', '\u2d67'), ('\u2d6f', '\u2d6f'), ('\u2d70', '\u2d70'), ('\u2d7f', '\u2d7f')
    ];

    pub static Tirhuta_table: &'static [(char, char)] = &[
        ('\U00011480', '\U000114af'), ('\U000114b0', '\U000114b2'), ('\U000114b3', '\U000114b8'),
        ('\U000114b9', '\U000114b9'), ('\U000114ba', '\U000114ba'), ('\U000114bb', '\U000114be'),
        ('\U000114bf', '\U000114c0'), ('\U000114c1', '\U000114c1'), ('\U000114c2', '\U000114c3'),
        ('\U000114c4', '\U000114c5'), ('\U000114c6', '\U000114c6'), ('\U000114c7', '\U000114c7'),
        ('\U000114d0', '\U000114d9')
    ];

    pub static Ugaritic_table: &'static [(char, char)] = &[
        ('\U00010380', '\U0001039d'), ('\U0001039f', '\U0001039f')
    ];

    pub static Vai_table: &'static [(char, char)] = &[
        ('\ua500', '\ua60b'), ('\ua60c', '\ua60c'), ('\ua60d', '\ua60f'), ('\ua610', '\ua61f'),
        ('\ua620', '\ua629'), ('\ua62a', '\ua62b')
    ];

    pub static Warang_Citi_table: &'static [(char, char)] = &[
        ('\U000118a0', '\U000118df'), ('\U000118e0', '\U000118e9'), ('\U000118ea', '\U000118f2'),
        ('\U000118ff', '\U000118ff')
    ];

    pub static Yi_table: &'static [(char, char)] = &[
        ('\ua000', '\ua014'), ('\ua015', '\ua015'), ('\ua016', '\ua48c'), ('\ua490', '\ua4c6')
    ];

}

pub mod property {
    pub static Join_Control_table: &'static [(char, char)] = &[
        ('\u200c', '\u200d')
    ];

    pub static Noncharacter_Code_Point_table: &'static [(char, char)] = &[
        ('\ufdd0', '\ufdef'), ('\ufffe', '\uffff'), ('\U0001fffe', '\U0001ffff'), ('\U0002fffe',
        '\U0002ffff'), ('\U0003fffe', '\U0003ffff'), ('\U0004fffe', '\U0004ffff'), ('\U0005fffe',
        '\U0005ffff'), ('\U0006fffe', '\U0006ffff'), ('\U0007fffe', '\U0007ffff'), ('\U0008fffe',
        '\U0008ffff'), ('\U0009fffe', '\U0009ffff'), ('\U000afffe', '\U000affff'), ('\U000bfffe',
        '\U000bffff'), ('\U000cfffe', '\U000cffff'), ('\U000dfffe', '\U000dffff'), ('\U000efffe',
        '\U000effff'), ('\U000ffffe', '\U000fffff')
    ];

    pub static White_Space_table: &'static [(char, char)] = &[
        ('\x09', '\x0d'), ('\x20', '\x20'), ('\u0085', '\u0085'), ('\u00a0', '\u00a0'), ('\u1680',
        '\u1680'), ('\u2000', '\u200a'), ('\u2028', '\u2028'), ('\u2029', '\u2029'), ('\u202f',
        '\u202f'), ('\u205f', '\u205f'), ('\u3000', '\u3000')
    ];

    pub fn White_Space(c: char) -> bool {
        super::bsearch_range_table(c, White_Space_table)
    }

}

pub mod regex {
    pub static UNICODE_CLASSES: &'static [(&'static str, &'static &'static [(char, char)])] = &[
        ("Alphabetic", &super::derived_property::Alphabetic_table), ("Arabic",
        &super::script::Arabic_table), ("Armenian", &super::script::Armenian_table), ("Avestan",
        &super::script::Avestan_table), ("Balinese", &super::script::Balinese_table), ("Bamum",
        &super::script::Bamum_table), ("Bassa_Vah", &super::script::Bassa_Vah_table), ("Batak",
        &super::script::Batak_table), ("Bengali", &super::script::Bengali_table), ("Bopomofo",
        &super::script::Bopomofo_table), ("Brahmi", &super::script::Brahmi_table), ("Braille",
        &super::script::Braille_table), ("Buginese", &super::script::Buginese_table), ("Buhid",
        &super::script::Buhid_table), ("C", &super::general_category::C_table),
        ("Canadian_Aboriginal", &super::script::Canadian_Aboriginal_table), ("Carian",
        &super::script::Carian_table), ("Caucasian_Albanian",
        &super::script::Caucasian_Albanian_table), ("Cc", &super::general_category::Cc_table),
        ("Cf", &super::general_category::Cf_table), ("Chakma", &super::script::Chakma_table),
        ("Cham", &super::script::Cham_table), ("Cherokee", &super::script::Cherokee_table), ("Cn",
        &super::general_category::Cn_table), ("Co", &super::general_category::Co_table), ("Common",
        &super::script::Common_table), ("Coptic", &super::script::Coptic_table), ("Cuneiform",
        &super::script::Cuneiform_table), ("Cypriot", &super::script::Cypriot_table), ("Cyrillic",
        &super::script::Cyrillic_table), ("Default_Ignorable_Code_Point",
        &super::derived_property::Default_Ignorable_Code_Point_table), ("Deseret",
        &super::script::Deseret_table), ("Devanagari", &super::script::Devanagari_table),
        ("Duployan", &super::script::Duployan_table), ("Egyptian_Hieroglyphs",
        &super::script::Egyptian_Hieroglyphs_table), ("Elbasan", &super::script::Elbasan_table),
        ("Ethiopic", &super::script::Ethiopic_table), ("Georgian", &super::script::Georgian_table),
        ("Glagolitic", &super::script::Glagolitic_table), ("Gothic", &super::script::Gothic_table),
        ("Grantha", &super::script::Grantha_table), ("Greek", &super::script::Greek_table),
        ("Gujarati", &super::script::Gujarati_table), ("Gurmukhi", &super::script::Gurmukhi_table),
        ("Han", &super::script::Han_table), ("Hangul", &super::script::Hangul_table), ("Hanunoo",
        &super::script::Hanunoo_table), ("Hebrew", &super::script::Hebrew_table), ("Hiragana",
        &super::script::Hiragana_table), ("Imperial_Aramaic",
        &super::script::Imperial_Aramaic_table), ("Inherited", &super::script::Inherited_table),
        ("Inscriptional_Pahlavi", &super::script::Inscriptional_Pahlavi_table),
        ("Inscriptional_Parthian", &super::script::Inscriptional_Parthian_table), ("Javanese",
        &super::script::Javanese_table), ("Join_Control", &super::property::Join_Control_table),
        ("Kaithi", &super::script::Kaithi_table), ("Kannada", &super::script::Kannada_table),
        ("Katakana", &super::script::Katakana_table), ("Kayah_Li", &super::script::Kayah_Li_table),
        ("Kharoshthi", &super::script::Kharoshthi_table), ("Khmer", &super::script::Khmer_table),
        ("Khojki", &super::script::Khojki_table), ("Khudawadi", &super::script::Khudawadi_table),
        ("L", &super::general_category::L_table), ("LC", &super::general_category::LC_table),
        ("Lao", &super::script::Lao_table), ("Latin", &super::script::Latin_table), ("Lepcha",
        &super::script::Lepcha_table), ("Limbu", &super::script::Limbu_table), ("Linear_A",
        &super::script::Linear_A_table), ("Linear_B", &super::script::Linear_B_table), ("Lisu",
        &super::script::Lisu_table), ("Ll", &super::general_category::Ll_table), ("Lm",
        &super::general_category::Lm_table), ("Lo", &super::general_category::Lo_table),
        ("Lowercase", &super::derived_property::Lowercase_table), ("Lt",
        &super::general_category::Lt_table), ("Lu", &super::general_category::Lu_table), ("Lycian",
        &super::script::Lycian_table), ("Lydian", &super::script::Lydian_table), ("M",
        &super::general_category::M_table), ("Mahajani", &super::script::Mahajani_table),
        ("Malayalam", &super::script::Malayalam_table), ("Mandaic", &super::script::Mandaic_table),
        ("Manichaean", &super::script::Manichaean_table), ("Mc",
        &super::general_category::Mc_table), ("Me", &super::general_category::Me_table),
        ("Meetei_Mayek", &super::script::Meetei_Mayek_table), ("Mende_Kikakui",
        &super::script::Mende_Kikakui_table), ("Meroitic_Cursive",
        &super::script::Meroitic_Cursive_table), ("Meroitic_Hieroglyphs",
        &super::script::Meroitic_Hieroglyphs_table), ("Miao", &super::script::Miao_table), ("Mn",
        &super::general_category::Mn_table), ("Modi", &super::script::Modi_table), ("Mongolian",
        &super::script::Mongolian_table), ("Mro", &super::script::Mro_table), ("Myanmar",
        &super::script::Myanmar_table), ("N", &super::general_category::N_table), ("Nabataean",
        &super::script::Nabataean_table), ("Nd", &super::general_category::Nd_table),
        ("New_Tai_Lue", &super::script::New_Tai_Lue_table), ("Nko", &super::script::Nko_table),
        ("Nl", &super::general_category::Nl_table), ("No", &super::general_category::No_table),
        ("Noncharacter_Code_Point", &super::property::Noncharacter_Code_Point_table), ("Ogham",
        &super::script::Ogham_table), ("Ol_Chiki", &super::script::Ol_Chiki_table), ("Old_Italic",
        &super::script::Old_Italic_table), ("Old_North_Arabian",
        &super::script::Old_North_Arabian_table), ("Old_Permic", &super::script::Old_Permic_table),
        ("Old_Persian", &super::script::Old_Persian_table), ("Old_South_Arabian",
        &super::script::Old_South_Arabian_table), ("Old_Turkic", &super::script::Old_Turkic_table),
        ("Oriya", &super::script::Oriya_table), ("Osmanya", &super::script::Osmanya_table), ("P",
        &super::general_category::P_table), ("Pahawh_Hmong", &super::script::Pahawh_Hmong_table),
        ("Palmyrene", &super::script::Palmyrene_table), ("Pau_Cin_Hau",
        &super::script::Pau_Cin_Hau_table), ("Pc", &super::general_category::Pc_table), ("Pd",
        &super::general_category::Pd_table), ("Pe", &super::general_category::Pe_table), ("Pf",
        &super::general_category::Pf_table), ("Phags_Pa", &super::script::Phags_Pa_table),
        ("Phoenician", &super::script::Phoenician_table), ("Pi",
        &super::general_category::Pi_table), ("Po", &super::general_category::Po_table), ("Ps",
        &super::general_category::Ps_table), ("Psalter_Pahlavi",
        &super::script::Psalter_Pahlavi_table), ("Rejang", &super::script::Rejang_table), ("Runic",
        &super::script::Runic_table), ("S", &super::general_category::S_table), ("Samaritan",
        &super::script::Samaritan_table), ("Saurashtra", &super::script::Saurashtra_table), ("Sc",
        &super::general_category::Sc_table), ("Sharada", &super::script::Sharada_table), ("Shavian",
        &super::script::Shavian_table), ("Siddham", &super::script::Siddham_table), ("Sinhala",
        &super::script::Sinhala_table), ("Sk", &super::general_category::Sk_table), ("Sm",
        &super::general_category::Sm_table), ("So", &super::general_category::So_table),
        ("Sora_Sompeng", &super::script::Sora_Sompeng_table), ("Sundanese",
        &super::script::Sundanese_table), ("Syloti_Nagri", &super::script::Syloti_Nagri_table),
        ("Syriac", &super::script::Syriac_table), ("Tagalog", &super::script::Tagalog_table),
        ("Tagbanwa", &super::script::Tagbanwa_table), ("Tai_Le", &super::script::Tai_Le_table),
        ("Tai_Tham", &super::script::Tai_Tham_table), ("Tai_Viet", &super::script::Tai_Viet_table),
        ("Takri", &super::script::Takri_table), ("Tamil", &super::script::Tamil_table), ("Telugu",
        &super::script::Telugu_table), ("Thaana", &super::script::Thaana_table), ("Thai",
        &super::script::Thai_table), ("Tibetan", &super::script::Tibetan_table), ("Tifinagh",
        &super::script::Tifinagh_table), ("Tirhuta", &super::script::Tirhuta_table), ("Ugaritic",
        &super::script::Ugaritic_table), ("Uppercase", &super::derived_property::Uppercase_table),
        ("Vai", &super::script::Vai_table), ("Warang_Citi", &super::script::Warang_Citi_table),
        ("White_Space", &super::property::White_Space_table), ("XID_Continue",
        &super::derived_property::XID_Continue_table), ("XID_Start",
        &super::derived_property::XID_Start_table), ("Yi", &super::script::Yi_table), ("Z",
        &super::general_category::Z_table), ("Zl", &super::general_category::Zl_table), ("Zp",
        &super::general_category::Zp_table), ("Zs", &super::general_category::Zs_table)
    ];

    pub static PERLD: &'static &'static [(char, char)] = &super::general_category::Nd_table;

    pub static PERLS: &'static &'static [(char, char)] = &super::property::White_Space_table;

    pub static PERLW: &'static [(char, char)] = &[
        ('\x30', '\x39'), ('\x41', '\x5a'), ('\x5f', '\x5f'), ('\x61', '\x7a'), ('\u00aa',
        '\u00aa'), ('\u00b5', '\u00b5'), ('\u00ba', '\u00ba'), ('\u00c0', '\u00d6'), ('\u00d8',
        '\u00f6'), ('\u00f8', '\u02c1'), ('\u02c6', '\u02d1'), ('\u02e0', '\u02e4'), ('\u02ec',
        '\u02ec'), ('\u02ee', '\u02ee'), ('\u0300', '\u0374'), ('\u0376', '\u0377'), ('\u037a',
        '\u037d'), ('\u037f', '\u037f'), ('\u0386', '\u0386'), ('\u0388', '\u038a'), ('\u038c',
        '\u038c'), ('\u038e', '\u03a1'), ('\u03a3', '\u03f5'), ('\u03f7', '\u0481'), ('\u0483',
        '\u052f'), ('\u0531', '\u0556'), ('\u0559', '\u0559'), ('\u0561', '\u0587'), ('\u0591',
        '\u05bd'), ('\u05bf', '\u05bf'), ('\u05c1', '\u05c2'), ('\u05c4', '\u05c5'), ('\u05c7',
        '\u05c7'), ('\u05d0', '\u05ea'), ('\u05f0', '\u05f2'), ('\u0610', '\u061a'), ('\u0620',
        '\u0669'), ('\u066e', '\u06d3'), ('\u06d5', '\u06dc'), ('\u06df', '\u06e8'), ('\u06ea',
        '\u06fc'), ('\u06ff', '\u06ff'), ('\u0710', '\u074a'), ('\u074d', '\u07b1'), ('\u07c0',
        '\u07f5'), ('\u07fa', '\u07fa'), ('\u0800', '\u082d'), ('\u0840', '\u085b'), ('\u08a0',
        '\u08b2'), ('\u08e4', '\u0963'), ('\u0966', '\u096f'), ('\u0971', '\u0983'), ('\u0985',
        '\u098c'), ('\u098f', '\u0990'), ('\u0993', '\u09a8'), ('\u09aa', '\u09b0'), ('\u09b2',
        '\u09b2'), ('\u09b6', '\u09b9'), ('\u09bc', '\u09c4'), ('\u09c7', '\u09c8'), ('\u09cb',
        '\u09ce'), ('\u09d7', '\u09d7'), ('\u09dc', '\u09dd'), ('\u09df', '\u09e3'), ('\u09e6',
        '\u09f1'), ('\u0a01', '\u0a03'), ('\u0a05', '\u0a0a'), ('\u0a0f', '\u0a10'), ('\u0a13',
        '\u0a28'), ('\u0a2a', '\u0a30'), ('\u0a32', '\u0a33'), ('\u0a35', '\u0a36'), ('\u0a38',
        '\u0a39'), ('\u0a3c', '\u0a3c'), ('\u0a3e', '\u0a42'), ('\u0a47', '\u0a48'), ('\u0a4b',
        '\u0a4d'), ('\u0a51', '\u0a51'), ('\u0a59', '\u0a5c'), ('\u0a5e', '\u0a5e'), ('\u0a66',
        '\u0a75'), ('\u0a81', '\u0a83'), ('\u0a85', '\u0a8d'), ('\u0a8f', '\u0a91'), ('\u0a93',
        '\u0aa8'), ('\u0aaa', '\u0ab0'), ('\u0ab2', '\u0ab3'), ('\u0ab5', '\u0ab9'), ('\u0abc',
        '\u0ac5'), ('\u0ac7', '\u0ac9'), ('\u0acb', '\u0acd'), ('\u0ad0', '\u0ad0'), ('\u0ae0',
        '\u0ae3'), ('\u0ae6', '\u0aef'), ('\u0b01', '\u0b03'), ('\u0b05', '\u0b0c'), ('\u0b0f',
        '\u0b10'), ('\u0b13', '\u0b28'), ('\u0b2a', '\u0b30'), ('\u0b32', '\u0b33'), ('\u0b35',
        '\u0b39'), ('\u0b3c', '\u0b44'), ('\u0b47', '\u0b48'), ('\u0b4b', '\u0b4d'), ('\u0b56',
        '\u0b57'), ('\u0b5c', '\u0b5d'), ('\u0b5f', '\u0b63'), ('\u0b66', '\u0b6f'), ('\u0b71',
        '\u0b71'), ('\u0b82', '\u0b83'), ('\u0b85', '\u0b8a'), ('\u0b8e', '\u0b90'), ('\u0b92',
        '\u0b95'), ('\u0b99', '\u0b9a'), ('\u0b9c', '\u0b9c'), ('\u0b9e', '\u0b9f'), ('\u0ba3',
        '\u0ba4'), ('\u0ba8', '\u0baa'), ('\u0bae', '\u0bb9'), ('\u0bbe', '\u0bc2'), ('\u0bc6',
        '\u0bc8'), ('\u0bca', '\u0bcd'), ('\u0bd0', '\u0bd0'), ('\u0bd7', '\u0bd7'), ('\u0be6',
        '\u0bef'), ('\u0c00', '\u0c03'), ('\u0c05', '\u0c0c'), ('\u0c0e', '\u0c10'), ('\u0c12',
        '\u0c28'), ('\u0c2a', '\u0c39'), ('\u0c3d', '\u0c44'), ('\u0c46', '\u0c48'), ('\u0c4a',
        '\u0c4d'), ('\u0c55', '\u0c56'), ('\u0c58', '\u0c59'), ('\u0c60', '\u0c63'), ('\u0c66',
        '\u0c6f'), ('\u0c81', '\u0c83'), ('\u0c85', '\u0c8c'), ('\u0c8e', '\u0c90'), ('\u0c92',
        '\u0ca8'), ('\u0caa', '\u0cb3'), ('\u0cb5', '\u0cb9'), ('\u0cbc', '\u0cc4'), ('\u0cc6',
        '\u0cc8'), ('\u0cca', '\u0ccd'), ('\u0cd5', '\u0cd6'), ('\u0cde', '\u0cde'), ('\u0ce0',
        '\u0ce3'), ('\u0ce6', '\u0cef'), ('\u0cf1', '\u0cf2'), ('\u0d01', '\u0d03'), ('\u0d05',
        '\u0d0c'), ('\u0d0e', '\u0d10'), ('\u0d12', '\u0d3a'), ('\u0d3d', '\u0d44'), ('\u0d46',
        '\u0d48'), ('\u0d4a', '\u0d4e'), ('\u0d57', '\u0d57'), ('\u0d60', '\u0d63'), ('\u0d66',
        '\u0d6f'), ('\u0d7a', '\u0d7f'), ('\u0d82', '\u0d83'), ('\u0d85', '\u0d96'), ('\u0d9a',
        '\u0db1'), ('\u0db3', '\u0dbb'), ('\u0dbd', '\u0dbd'), ('\u0dc0', '\u0dc6'), ('\u0dca',
        '\u0dca'), ('\u0dcf', '\u0dd4'), ('\u0dd6', '\u0dd6'), ('\u0dd8', '\u0ddf'), ('\u0de6',
        '\u0def'), ('\u0df2', '\u0df3'), ('\u0e01', '\u0e3a'), ('\u0e40', '\u0e4e'), ('\u0e50',
        '\u0e59'), ('\u0e81', '\u0e82'), ('\u0e84', '\u0e84'), ('\u0e87', '\u0e88'), ('\u0e8a',
        '\u0e8a'), ('\u0e8d', '\u0e8d'), ('\u0e94', '\u0e97'), ('\u0e99', '\u0e9f'), ('\u0ea1',
        '\u0ea3'), ('\u0ea5', '\u0ea5'), ('\u0ea7', '\u0ea7'), ('\u0eaa', '\u0eab'), ('\u0ead',
        '\u0eb9'), ('\u0ebb', '\u0ebd'), ('\u0ec0', '\u0ec4'), ('\u0ec6', '\u0ec6'), ('\u0ec8',
        '\u0ecd'), ('\u0ed0', '\u0ed9'), ('\u0edc', '\u0edf'), ('\u0f00', '\u0f00'), ('\u0f18',
        '\u0f19'), ('\u0f20', '\u0f29'), ('\u0f35', '\u0f35'), ('\u0f37', '\u0f37'), ('\u0f39',
        '\u0f39'), ('\u0f3e', '\u0f47'), ('\u0f49', '\u0f6c'), ('\u0f71', '\u0f84'), ('\u0f86',
        '\u0f97'), ('\u0f99', '\u0fbc'), ('\u0fc6', '\u0fc6'), ('\u1000', '\u1049'), ('\u1050',
        '\u109d'), ('\u10a0', '\u10c5'), ('\u10c7', '\u10c7'), ('\u10cd', '\u10cd'), ('\u10d0',
        '\u10fa'), ('\u10fc', '\u1248'), ('\u124a', '\u124d'), ('\u1250', '\u1256'), ('\u1258',
        '\u1258'), ('\u125a', '\u125d'), ('\u1260', '\u1288'), ('\u128a', '\u128d'), ('\u1290',
        '\u12b0'), ('\u12b2', '\u12b5'), ('\u12b8', '\u12be'), ('\u12c0', '\u12c0'), ('\u12c2',
        '\u12c5'), ('\u12c8', '\u12d6'), ('\u12d8', '\u1310'), ('\u1312', '\u1315'), ('\u1318',
        '\u135a'), ('\u135d', '\u135f'), ('\u1380', '\u138f'), ('\u13a0', '\u13f4'), ('\u1401',
        '\u166c'), ('\u166f', '\u167f'), ('\u1681', '\u169a'), ('\u16a0', '\u16ea'), ('\u16ee',
        '\u16f8'), ('\u1700', '\u170c'), ('\u170e', '\u1714'), ('\u1720', '\u1734'), ('\u1740',
        '\u1753'), ('\u1760', '\u176c'), ('\u176e', '\u1770'), ('\u1772', '\u1773'), ('\u1780',
        '\u17d3'), ('\u17d7', '\u17d7'), ('\u17dc', '\u17dd'), ('\u17e0', '\u17e9'), ('\u180b',
        '\u180d'), ('\u1810', '\u1819'), ('\u1820', '\u1877'), ('\u1880', '\u18aa'), ('\u18b0',
        '\u18f5'), ('\u1900', '\u191e'), ('\u1920', '\u192b'), ('\u1930', '\u193b'), ('\u1946',
        '\u196d'), ('\u1970', '\u1974'), ('\u1980', '\u19ab'), ('\u19b0', '\u19c9'), ('\u19d0',
        '\u19d9'), ('\u1a00', '\u1a1b'), ('\u1a20', '\u1a5e'), ('\u1a60', '\u1a7c'), ('\u1a7f',
        '\u1a89'), ('\u1a90', '\u1a99'), ('\u1aa7', '\u1aa7'), ('\u1ab0', '\u1abe'), ('\u1b00',
        '\u1b4b'), ('\u1b50', '\u1b59'), ('\u1b6b', '\u1b73'), ('\u1b80', '\u1bf3'), ('\u1c00',
        '\u1c37'), ('\u1c40', '\u1c49'), ('\u1c4d', '\u1c7d'), ('\u1cd0', '\u1cd2'), ('\u1cd4',
        '\u1cf6'), ('\u1cf8', '\u1cf9'), ('\u1d00', '\u1df5'), ('\u1dfc', '\u1f15'), ('\u1f18',
        '\u1f1d'), ('\u1f20', '\u1f45'), ('\u1f48', '\u1f4d'), ('\u1f50', '\u1f57'), ('\u1f59',
        '\u1f59'), ('\u1f5b', '\u1f5b'), ('\u1f5d', '\u1f5d'), ('\u1f5f', '\u1f7d'), ('\u1f80',
        '\u1fb4'), ('\u1fb6', '\u1fbc'), ('\u1fbe', '\u1fbe'), ('\u1fc2', '\u1fc4'), ('\u1fc6',
        '\u1fcc'), ('\u1fd0', '\u1fd3'), ('\u1fd6', '\u1fdb'), ('\u1fe0', '\u1fec'), ('\u1ff2',
        '\u1ff4'), ('\u1ff6', '\u1ffc'), ('\u200c', '\u200d'), ('\u203f', '\u2040'), ('\u2054',
        '\u2054'), ('\u2071', '\u2071'), ('\u207f', '\u207f'), ('\u2090', '\u209c'), ('\u20d0',
        '\u20f0'), ('\u2102', '\u2102'), ('\u2107', '\u2107'), ('\u210a', '\u2113'), ('\u2115',
        '\u2115'), ('\u2119', '\u211d'), ('\u2124', '\u2124'), ('\u2126', '\u2126'), ('\u2128',
        '\u2128'), ('\u212a', '\u212d'), ('\u212f', '\u2139'), ('\u213c', '\u213f'), ('\u2145',
        '\u2149'), ('\u214e', '\u214e'), ('\u2160', '\u2188'), ('\u24b6', '\u24e9'), ('\u2c00',
        '\u2c2e'), ('\u2c30', '\u2c5e'), ('\u2c60', '\u2ce4'), ('\u2ceb', '\u2cf3'), ('\u2d00',
        '\u2d25'), ('\u2d27', '\u2d27'), ('\u2d2d', '\u2d2d'), ('\u2d30', '\u2d67'), ('\u2d6f',
        '\u2d6f'), ('\u2d7f', '\u2d96'), ('\u2da0', '\u2da6'), ('\u2da8', '\u2dae'), ('\u2db0',
        '\u2db6'), ('\u2db8', '\u2dbe'), ('\u2dc0', '\u2dc6'), ('\u2dc8', '\u2dce'), ('\u2dd0',
        '\u2dd6'), ('\u2dd8', '\u2dde'), ('\u2de0', '\u2dff'), ('\u2e2f', '\u2e2f'), ('\u3005',
        '\u3007'), ('\u3021', '\u302f'), ('\u3031', '\u3035'), ('\u3038', '\u303c'), ('\u3041',
        '\u3096'), ('\u3099', '\u309a'), ('\u309d', '\u309f'), ('\u30a1', '\u30fa'), ('\u30fc',
        '\u30ff'), ('\u3105', '\u312d'), ('\u3131', '\u318e'), ('\u31a0', '\u31ba'), ('\u31f0',
        '\u31ff'), ('\u3400', '\u4db5'), ('\u4e00', '\u9fcc'), ('\ua000', '\ua48c'), ('\ua4d0',
        '\ua4fd'), ('\ua500', '\ua60c'), ('\ua610', '\ua62b'), ('\ua640', '\ua672'), ('\ua674',
        '\ua67d'), ('\ua67f', '\ua69d'), ('\ua69f', '\ua6f1'), ('\ua717', '\ua71f'), ('\ua722',
        '\ua788'), ('\ua78b', '\ua78e'), ('\ua790', '\ua7ad'), ('\ua7b0', '\ua7b1'), ('\ua7f7',
        '\ua827'), ('\ua840', '\ua873'), ('\ua880', '\ua8c4'), ('\ua8d0', '\ua8d9'), ('\ua8e0',
        '\ua8f7'), ('\ua8fb', '\ua8fb'), ('\ua900', '\ua92d'), ('\ua930', '\ua953'), ('\ua960',
        '\ua97c'), ('\ua980', '\ua9c0'), ('\ua9cf', '\ua9d9'), ('\ua9e0', '\ua9fe'), ('\uaa00',
        '\uaa36'), ('\uaa40', '\uaa4d'), ('\uaa50', '\uaa59'), ('\uaa60', '\uaa76'), ('\uaa7a',
        '\uaac2'), ('\uaadb', '\uaadd'), ('\uaae0', '\uaaef'), ('\uaaf2', '\uaaf6'), ('\uab01',
        '\uab06'), ('\uab09', '\uab0e'), ('\uab11', '\uab16'), ('\uab20', '\uab26'), ('\uab28',
        '\uab2e'), ('\uab30', '\uab5a'), ('\uab5c', '\uab5f'), ('\uab64', '\uab65'), ('\uabc0',
        '\uabea'), ('\uabec', '\uabed'), ('\uabf0', '\uabf9'), ('\uac00', '\ud7a3'), ('\ud7b0',
        '\ud7c6'), ('\ud7cb', '\ud7fb'), ('\uf900', '\ufa6d'), ('\ufa70', '\ufad9'), ('\ufb00',
        '\ufb06'), ('\ufb13', '\ufb17'), ('\ufb1d', '\ufb28'), ('\ufb2a', '\ufb36'), ('\ufb38',
        '\ufb3c'), ('\ufb3e', '\ufb3e'), ('\ufb40', '\ufb41'), ('\ufb43', '\ufb44'), ('\ufb46',
        '\ufbb1'), ('\ufbd3', '\ufd3d'), ('\ufd50', '\ufd8f'), ('\ufd92', '\ufdc7'), ('\ufdf0',
        '\ufdfb'), ('\ufe00', '\ufe0f'), ('\ufe20', '\ufe2d'), ('\ufe33', '\ufe34'), ('\ufe4d',
        '\ufe4f'), ('\ufe70', '\ufe74'), ('\ufe76', '\ufefc'), ('\uff10', '\uff19'), ('\uff21',
        '\uff3a'), ('\uff3f', '\uff3f'), ('\uff41', '\uff5a'), ('\uff66', '\uffbe'), ('\uffc2',
        '\uffc7'), ('\uffca', '\uffcf'), ('\uffd2', '\uffd7'), ('\uffda', '\uffdc'), ('\U00010000',
        '\U0001000b'), ('\U0001000d', '\U00010026'), ('\U00010028', '\U0001003a'), ('\U0001003c',
        '\U0001003d'), ('\U0001003f', '\U0001004d'), ('\U00010050', '\U0001005d'), ('\U00010080',
        '\U000100fa'), ('\U00010140', '\U00010174'), ('\U000101fd', '\U000101fd'), ('\U00010280',
        '\U0001029c'), ('\U000102a0', '\U000102d0'), ('\U000102e0', '\U000102e0'), ('\U00010300',
        '\U0001031f'), ('\U00010330', '\U0001034a'), ('\U00010350', '\U0001037a'), ('\U00010380',
        '\U0001039d'), ('\U000103a0', '\U000103c3'), ('\U000103c8', '\U000103cf'), ('\U000103d1',
        '\U000103d5'), ('\U00010400', '\U0001049d'), ('\U000104a0', '\U000104a9'), ('\U00010500',
        '\U00010527'), ('\U00010530', '\U00010563'), ('\U00010600', '\U00010736'), ('\U00010740',
        '\U00010755'), ('\U00010760', '\U00010767'), ('\U00010800', '\U00010805'), ('\U00010808',
        '\U00010808'), ('\U0001080a', '\U00010835'), ('\U00010837', '\U00010838'), ('\U0001083c',
        '\U0001083c'), ('\U0001083f', '\U00010855'), ('\U00010860', '\U00010876'), ('\U00010880',
        '\U0001089e'), ('\U00010900', '\U00010915'), ('\U00010920', '\U00010939'), ('\U00010980',
        '\U000109b7'), ('\U000109be', '\U000109bf'), ('\U00010a00', '\U00010a03'), ('\U00010a05',
        '\U00010a06'), ('\U00010a0c', '\U00010a13'), ('\U00010a15', '\U00010a17'), ('\U00010a19',
        '\U00010a33'), ('\U00010a38', '\U00010a3a'), ('\U00010a3f', '\U00010a3f'), ('\U00010a60',
        '\U00010a7c'), ('\U00010a80', '\U00010a9c'), ('\U00010ac0', '\U00010ac7'), ('\U00010ac9',
        '\U00010ae6'), ('\U00010b00', '\U00010b35'), ('\U00010b40', '\U00010b55'), ('\U00010b60',
        '\U00010b72'), ('\U00010b80', '\U00010b91'), ('\U00010c00', '\U00010c48'), ('\U00011000',
        '\U00011046'), ('\U00011066', '\U0001106f'), ('\U0001107f', '\U000110ba'), ('\U000110d0',
        '\U000110e8'), ('\U000110f0', '\U000110f9'), ('\U00011100', '\U00011134'), ('\U00011136',
        '\U0001113f'), ('\U00011150', '\U00011173'), ('\U00011176', '\U00011176'), ('\U00011180',
        '\U000111c4'), ('\U000111d0', '\U000111da'), ('\U00011200', '\U00011211'), ('\U00011213',
        '\U00011237'), ('\U000112b0', '\U000112ea'), ('\U000112f0', '\U000112f9'), ('\U00011301',
        '\U00011303'), ('\U00011305', '\U0001130c'), ('\U0001130f', '\U00011310'), ('\U00011313',
        '\U00011328'), ('\U0001132a', '\U00011330'), ('\U00011332', '\U00011333'), ('\U00011335',
        '\U00011339'), ('\U0001133c', '\U00011344'), ('\U00011347', '\U00011348'), ('\U0001134b',
        '\U0001134d'), ('\U00011357', '\U00011357'), ('\U0001135d', '\U00011363'), ('\U00011366',
        '\U0001136c'), ('\U00011370', '\U00011374'), ('\U00011480', '\U000114c5'), ('\U000114c7',
        '\U000114c7'), ('\U000114d0', '\U000114d9'), ('\U00011580', '\U000115b5'), ('\U000115b8',
        '\U000115c0'), ('\U00011600', '\U00011640'), ('\U00011644', '\U00011644'), ('\U00011650',
        '\U00011659'), ('\U00011680', '\U000116b7'), ('\U000116c0', '\U000116c9'), ('\U000118a0',
        '\U000118e9'), ('\U000118ff', '\U000118ff'), ('\U00011ac0', '\U00011af8'), ('\U00012000',
        '\U00012398'), ('\U00012400', '\U0001246e'), ('\U00013000', '\U0001342e'), ('\U00016800',
        '\U00016a38'), ('\U00016a40', '\U00016a5e'), ('\U00016a60', '\U00016a69'), ('\U00016ad0',
        '\U00016aed'), ('\U00016af0', '\U00016af4'), ('\U00016b00', '\U00016b36'), ('\U00016b40',
        '\U00016b43'), ('\U00016b50', '\U00016b59'), ('\U00016b63', '\U00016b77'), ('\U00016b7d',
        '\U00016b8f'), ('\U00016f00', '\U00016f44'), ('\U00016f50', '\U00016f7e'), ('\U00016f8f',
        '\U00016f9f'), ('\U0001b000', '\U0001b001'), ('\U0001bc00', '\U0001bc6a'), ('\U0001bc70',
        '\U0001bc7c'), ('\U0001bc80', '\U0001bc88'), ('\U0001bc90', '\U0001bc99'), ('\U0001bc9d',
        '\U0001bc9e'), ('\U0001d165', '\U0001d169'), ('\U0001d16d', '\U0001d172'), ('\U0001d17b',
        '\U0001d182'), ('\U0001d185', '\U0001d18b'), ('\U0001d1aa', '\U0001d1ad'), ('\U0001d242',
        '\U0001d244'), ('\U0001d400', '\U0001d454'), ('\U0001d456', '\U0001d49c'), ('\U0001d49e',
        '\U0001d49f'), ('\U0001d4a2', '\U0001d4a2'), ('\U0001d4a5', '\U0001d4a6'), ('\U0001d4a9',
        '\U0001d4ac'), ('\U0001d4ae', '\U0001d4b9'), ('\U0001d4bb', '\U0001d4bb'), ('\U0001d4bd',
        '\U0001d4c3'), ('\U0001d4c5', '\U0001d505'), ('\U0001d507', '\U0001d50a'), ('\U0001d50d',
        '\U0001d514'), ('\U0001d516', '\U0001d51c'), ('\U0001d51e', '\U0001d539'), ('\U0001d53b',
        '\U0001d53e'), ('\U0001d540', '\U0001d544'), ('\U0001d546', '\U0001d546'), ('\U0001d54a',
        '\U0001d550'), ('\U0001d552', '\U0001d6a5'), ('\U0001d6a8', '\U0001d6c0'), ('\U0001d6c2',
        '\U0001d6da'), ('\U0001d6dc', '\U0001d6fa'), ('\U0001d6fc', '\U0001d714'), ('\U0001d716',
        '\U0001d734'), ('\U0001d736', '\U0001d74e'), ('\U0001d750', '\U0001d76e'), ('\U0001d770',
        '\U0001d788'), ('\U0001d78a', '\U0001d7a8'), ('\U0001d7aa', '\U0001d7c2'), ('\U0001d7c4',
        '\U0001d7cb'), ('\U0001d7ce', '\U0001d7ff'), ('\U0001e800', '\U0001e8c4'), ('\U0001e8d0',
        '\U0001e8d6'), ('\U0001ee00', '\U0001ee03'), ('\U0001ee05', '\U0001ee1f'), ('\U0001ee21',
        '\U0001ee22'), ('\U0001ee24', '\U0001ee24'), ('\U0001ee27', '\U0001ee27'), ('\U0001ee29',
        '\U0001ee32'), ('\U0001ee34', '\U0001ee37'), ('\U0001ee39', '\U0001ee39'), ('\U0001ee3b',
        '\U0001ee3b'), ('\U0001ee42', '\U0001ee42'), ('\U0001ee47', '\U0001ee47'), ('\U0001ee49',
        '\U0001ee49'), ('\U0001ee4b', '\U0001ee4b'), ('\U0001ee4d', '\U0001ee4f'), ('\U0001ee51',
        '\U0001ee52'), ('\U0001ee54', '\U0001ee54'), ('\U0001ee57', '\U0001ee57'), ('\U0001ee59',
        '\U0001ee59'), ('\U0001ee5b', '\U0001ee5b'), ('\U0001ee5d', '\U0001ee5d'), ('\U0001ee5f',
        '\U0001ee5f'), ('\U0001ee61', '\U0001ee62'), ('\U0001ee64', '\U0001ee64'), ('\U0001ee67',
        '\U0001ee6a'), ('\U0001ee6c', '\U0001ee72'), ('\U0001ee74', '\U0001ee77'), ('\U0001ee79',
        '\U0001ee7c'), ('\U0001ee7e', '\U0001ee7e'), ('\U0001ee80', '\U0001ee89'), ('\U0001ee8b',
        '\U0001ee9b'), ('\U0001eea1', '\U0001eea3'), ('\U0001eea5', '\U0001eea9'), ('\U0001eeab',
        '\U0001eebb'), ('\U0001f130', '\U0001f149'), ('\U0001f150', '\U0001f169'), ('\U0001f170',
        '\U0001f189'), ('\U00020000', '\U0002a6d6'), ('\U0002a700', '\U0002b734'), ('\U0002b740',
        '\U0002b81d'), ('\U0002f800', '\U0002fa1d'), ('\U000e0100', '\U000e01ef')
    ];

}

pub mod normalization {
    // Canonical decompositions
    pub static canonical_table: &'static [(char, &'static [char])] = &[
        ('\u00c0', &['\x41', '\u0300']), ('\u00c1', &['\x41', '\u0301']), ('\u00c2', &['\x41',
        '\u0302']), ('\u00c3', &['\x41', '\u0303']), ('\u00c4', &['\x41', '\u0308']), ('\u00c5',
        &['\x41', '\u030a']), ('\u00c7', &['\x43', '\u0327']), ('\u00c8', &['\x45', '\u0300']),
        ('\u00c9', &['\x45', '\u0301']), ('\u00ca', &['\x45', '\u0302']), ('\u00cb', &['\x45',
        '\u0308']), ('\u00cc', &['\x49', '\u0300']), ('\u00cd', &['\x49', '\u0301']), ('\u00ce',
        &['\x49', '\u0302']), ('\u00cf', &['\x49', '\u0308']), ('\u00d1', &['\x4e', '\u0303']),
        ('\u00d2', &['\x4f', '\u0300']), ('\u00d3', &['\x4f', '\u0301']), ('\u00d4', &['\x4f',
        '\u0302']), ('\u00d5', &['\x4f', '\u0303']), ('\u00d6', &['\x4f', '\u0308']), ('\u00d9',
        &['\x55', '\u0300']), ('\u00da', &['\x55', '\u0301']), ('\u00db', &['\x55', '\u0302']),
        ('\u00dc', &['\x55', '\u0308']), ('\u00dd', &['\x59', '\u0301']), ('\u00e0', &['\x61',
        '\u0300']), ('\u00e1', &['\x61', '\u0301']), ('\u00e2', &['\x61', '\u0302']), ('\u00e3',
        &['\x61', '\u0303']), ('\u00e4', &['\x61', '\u0308']), ('\u00e5', &['\x61', '\u030a']),
        ('\u00e7', &['\x63', '\u0327']), ('\u00e8', &['\x65', '\u0300']), ('\u00e9', &['\x65',
        '\u0301']), ('\u00ea', &['\x65', '\u0302']), ('\u00eb', &['\x65', '\u0308']), ('\u00ec',
        &['\x69', '\u0300']), ('\u00ed', &['\x69', '\u0301']), ('\u00ee', &['\x69', '\u0302']),
        ('\u00ef', &['\x69', '\u0308']), ('\u00f1', &['\x6e', '\u0303']), ('\u00f2', &['\x6f',
        '\u0300']), ('\u00f3', &['\x6f', '\u0301']), ('\u00f4', &['\x6f', '\u0302']), ('\u00f5',
        &['\x6f', '\u0303']), ('\u00f6', &['\x6f', '\u0308']), ('\u00f9', &['\x75', '\u0300']),
        ('\u00fa', &['\x75', '\u0301']), ('\u00fb', &['\x75', '\u0302']), ('\u00fc', &['\x75',
        '\u0308']), ('\u00fd', &['\x79', '\u0301']), ('\u00ff', &['\x79', '\u0308']), ('\u0100',
        &['\x41', '\u0304']), ('\u0101', &['\x61', '\u0304']), ('\u0102', &['\x41', '\u0306']),
        ('\u0103', &['\x61', '\u0306']), ('\u0104', &['\x41', '\u0328']), ('\u0105', &['\x61',
        '\u0328']), ('\u0106', &['\x43', '\u0301']), ('\u0107', &['\x63', '\u0301']), ('\u0108',
        &['\x43', '\u0302']), ('\u0109', &['\x63', '\u0302']), ('\u010a', &['\x43', '\u0307']),
        ('\u010b', &['\x63', '\u0307']), ('\u010c', &['\x43', '\u030c']), ('\u010d', &['\x63',
        '\u030c']), ('\u010e', &['\x44', '\u030c']), ('\u010f', &['\x64', '\u030c']), ('\u0112',
        &['\x45', '\u0304']), ('\u0113', &['\x65', '\u0304']), ('\u0114', &['\x45', '\u0306']),
        ('\u0115', &['\x65', '\u0306']), ('\u0116', &['\x45', '\u0307']), ('\u0117', &['\x65',
        '\u0307']), ('\u0118', &['\x45', '\u0328']), ('\u0119', &['\x65', '\u0328']), ('\u011a',
        &['\x45', '\u030c']), ('\u011b', &['\x65', '\u030c']), ('\u011c', &['\x47', '\u0302']),
        ('\u011d', &['\x67', '\u0302']), ('\u011e', &['\x47', '\u0306']), ('\u011f', &['\x67',
        '\u0306']), ('\u0120', &['\x47', '\u0307']), ('\u0121', &['\x67', '\u0307']), ('\u0122',
        &['\x47', '\u0327']), ('\u0123', &['\x67', '\u0327']), ('\u0124', &['\x48', '\u0302']),
        ('\u0125', &['\x68', '\u0302']), ('\u0128', &['\x49', '\u0303']), ('\u0129', &['\x69',
        '\u0303']), ('\u012a', &['\x49', '\u0304']), ('\u012b', &['\x69', '\u0304']), ('\u012c',
        &['\x49', '\u0306']), ('\u012d', &['\x69', '\u0306']), ('\u012e', &['\x49', '\u0328']),
        ('\u012f', &['\x69', '\u0328']), ('\u0130', &['\x49', '\u0307']), ('\u0134', &['\x4a',
        '\u0302']), ('\u0135', &['\x6a', '\u0302']), ('\u0136', &['\x4b', '\u0327']), ('\u0137',
        &['\x6b', '\u0327']), ('\u0139', &['\x4c', '\u0301']), ('\u013a', &['\x6c', '\u0301']),
        ('\u013b', &['\x4c', '\u0327']), ('\u013c', &['\x6c', '\u0327']), ('\u013d', &['\x4c',
        '\u030c']), ('\u013e', &['\x6c', '\u030c']), ('\u0143', &['\x4e', '\u0301']), ('\u0144',
        &['\x6e', '\u0301']), ('\u0145', &['\x4e', '\u0327']), ('\u0146', &['\x6e', '\u0327']),
        ('\u0147', &['\x4e', '\u030c']), ('\u0148', &['\x6e', '\u030c']), ('\u014c', &['\x4f',
        '\u0304']), ('\u014d', &['\x6f', '\u0304']), ('\u014e', &['\x4f', '\u0306']), ('\u014f',
        &['\x6f', '\u0306']), ('\u0150', &['\x4f', '\u030b']), ('\u0151', &['\x6f', '\u030b']),
        ('\u0154', &['\x52', '\u0301']), ('\u0155', &['\x72', '\u0301']), ('\u0156', &['\x52',
        '\u0327']), ('\u0157', &['\x72', '\u0327']), ('\u0158', &['\x52', '\u030c']), ('\u0159',
        &['\x72', '\u030c']), ('\u015a', &['\x53', '\u0301']), ('\u015b', &['\x73', '\u0301']),
        ('\u015c', &['\x53', '\u0302']), ('\u015d', &['\x73', '\u0302']), ('\u015e', &['\x53',
        '\u0327']), ('\u015f', &['\x73', '\u0327']), ('\u0160', &['\x53', '\u030c']), ('\u0161',
        &['\x73', '\u030c']), ('\u0162', &['\x54', '\u0327']), ('\u0163', &['\x74', '\u0327']),
        ('\u0164', &['\x54', '\u030c']), ('\u0165', &['\x74', '\u030c']), ('\u0168', &['\x55',
        '\u0303']), ('\u0169', &['\x75', '\u0303']), ('\u016a', &['\x55', '\u0304']), ('\u016b',
        &['\x75', '\u0304']), ('\u016c', &['\x55', '\u0306']), ('\u016d', &['\x75', '\u0306']),
        ('\u016e', &['\x55', '\u030a']), ('\u016f', &['\x75', '\u030a']), ('\u0170', &['\x55',
        '\u030b']), ('\u0171', &['\x75', '\u030b']), ('\u0172', &['\x55', '\u0328']), ('\u0173',
        &['\x75', '\u0328']), ('\u0174', &['\x57', '\u0302']), ('\u0175', &['\x77', '\u0302']),
        ('\u0176', &['\x59', '\u0302']), ('\u0177', &['\x79', '\u0302']), ('\u0178', &['\x59',
        '\u0308']), ('\u0179', &['\x5a', '\u0301']), ('\u017a', &['\x7a', '\u0301']), ('\u017b',
        &['\x5a', '\u0307']), ('\u017c', &['\x7a', '\u0307']), ('\u017d', &['\x5a', '\u030c']),
        ('\u017e', &['\x7a', '\u030c']), ('\u01a0', &['\x4f', '\u031b']), ('\u01a1', &['\x6f',
        '\u031b']), ('\u01af', &['\x55', '\u031b']), ('\u01b0', &['\x75', '\u031b']), ('\u01cd',
        &['\x41', '\u030c']), ('\u01ce', &['\x61', '\u030c']), ('\u01cf', &['\x49', '\u030c']),
        ('\u01d0', &['\x69', '\u030c']), ('\u01d1', &['\x4f', '\u030c']), ('\u01d2', &['\x6f',
        '\u030c']), ('\u01d3', &['\x55', '\u030c']), ('\u01d4', &['\x75', '\u030c']), ('\u01d5',
        &['\u00dc', '\u0304']), ('\u01d6', &['\u00fc', '\u0304']), ('\u01d7', &['\u00dc',
        '\u0301']), ('\u01d8', &['\u00fc', '\u0301']), ('\u01d9', &['\u00dc', '\u030c']), ('\u01da',
        &['\u00fc', '\u030c']), ('\u01db', &['\u00dc', '\u0300']), ('\u01dc', &['\u00fc',
        '\u0300']), ('\u01de', &['\u00c4', '\u0304']), ('\u01df', &['\u00e4', '\u0304']), ('\u01e0',
        &['\u0226', '\u0304']), ('\u01e1', &['\u0227', '\u0304']), ('\u01e2', &['\u00c6',
        '\u0304']), ('\u01e3', &['\u00e6', '\u0304']), ('\u01e6', &['\x47', '\u030c']), ('\u01e7',
        &['\x67', '\u030c']), ('\u01e8', &['\x4b', '\u030c']), ('\u01e9', &['\x6b', '\u030c']),
        ('\u01ea', &['\x4f', '\u0328']), ('\u01eb', &['\x6f', '\u0328']), ('\u01ec', &['\u01ea',
        '\u0304']), ('\u01ed', &['\u01eb', '\u0304']), ('\u01ee', &['\u01b7', '\u030c']), ('\u01ef',
        &['\u0292', '\u030c']), ('\u01f0', &['\x6a', '\u030c']), ('\u01f4', &['\x47', '\u0301']),
        ('\u01f5', &['\x67', '\u0301']), ('\u01f8', &['\x4e', '\u0300']), ('\u01f9', &['\x6e',
        '\u0300']), ('\u01fa', &['\u00c5', '\u0301']), ('\u01fb', &['\u00e5', '\u0301']), ('\u01fc',
        &['\u00c6', '\u0301']), ('\u01fd', &['\u00e6', '\u0301']), ('\u01fe', &['\u00d8',
        '\u0301']), ('\u01ff', &['\u00f8', '\u0301']), ('\u0200', &['\x41', '\u030f']), ('\u0201',
        &['\x61', '\u030f']), ('\u0202', &['\x41', '\u0311']), ('\u0203', &['\x61', '\u0311']),
        ('\u0204', &['\x45', '\u030f']), ('\u0205', &['\x65', '\u030f']), ('\u0206', &['\x45',
        '\u0311']), ('\u0207', &['\x65', '\u0311']), ('\u0208', &['\x49', '\u030f']), ('\u0209',
        &['\x69', '\u030f']), ('\u020a', &['\x49', '\u0311']), ('\u020b', &['\x69', '\u0311']),
        ('\u020c', &['\x4f', '\u030f']), ('\u020d', &['\x6f', '\u030f']), ('\u020e', &['\x4f',
        '\u0311']), ('\u020f', &['\x6f', '\u0311']), ('\u0210', &['\x52', '\u030f']), ('\u0211',
        &['\x72', '\u030f']), ('\u0212', &['\x52', '\u0311']), ('\u0213', &['\x72', '\u0311']),
        ('\u0214', &['\x55', '\u030f']), ('\u0215', &['\x75', '\u030f']), ('\u0216', &['\x55',
        '\u0311']), ('\u0217', &['\x75', '\u0311']), ('\u0218', &['\x53', '\u0326']), ('\u0219',
        &['\x73', '\u0326']), ('\u021a', &['\x54', '\u0326']), ('\u021b', &['\x74', '\u0326']),
        ('\u021e', &['\x48', '\u030c']), ('\u021f', &['\x68', '\u030c']), ('\u0226', &['\x41',
        '\u0307']), ('\u0227', &['\x61', '\u0307']), ('\u0228', &['\x45', '\u0327']), ('\u0229',
        &['\x65', '\u0327']), ('\u022a', &['\u00d6', '\u0304']), ('\u022b', &['\u00f6', '\u0304']),
        ('\u022c', &['\u00d5', '\u0304']), ('\u022d', &['\u00f5', '\u0304']), ('\u022e', &['\x4f',
        '\u0307']), ('\u022f', &['\x6f', '\u0307']), ('\u0230', &['\u022e', '\u0304']), ('\u0231',
        &['\u022f', '\u0304']), ('\u0232', &['\x59', '\u0304']), ('\u0233', &['\x79', '\u0304']),
        ('\u0340', &['\u0300']), ('\u0341', &['\u0301']), ('\u0343', &['\u0313']), ('\u0344',
        &['\u0308', '\u0301']), ('\u0374', &['\u02b9']), ('\u037e', &['\x3b']), ('\u0385',
        &['\u00a8', '\u0301']), ('\u0386', &['\u0391', '\u0301']), ('\u0387', &['\u00b7']),
        ('\u0388', &['\u0395', '\u0301']), ('\u0389', &['\u0397', '\u0301']), ('\u038a', &['\u0399',
        '\u0301']), ('\u038c', &['\u039f', '\u0301']), ('\u038e', &['\u03a5', '\u0301']), ('\u038f',
        &['\u03a9', '\u0301']), ('\u0390', &['\u03ca', '\u0301']), ('\u03aa', &['\u0399',
        '\u0308']), ('\u03ab', &['\u03a5', '\u0308']), ('\u03ac', &['\u03b1', '\u0301']), ('\u03ad',
        &['\u03b5', '\u0301']), ('\u03ae', &['\u03b7', '\u0301']), ('\u03af', &['\u03b9',
        '\u0301']), ('\u03b0', &['\u03cb', '\u0301']), ('\u03ca', &['\u03b9', '\u0308']), ('\u03cb',
        &['\u03c5', '\u0308']), ('\u03cc', &['\u03bf', '\u0301']), ('\u03cd', &['\u03c5',
        '\u0301']), ('\u03ce', &['\u03c9', '\u0301']), ('\u03d3', &['\u03d2', '\u0301']), ('\u03d4',
        &['\u03d2', '\u0308']), ('\u0400', &['\u0415', '\u0300']), ('\u0401', &['\u0415',
        '\u0308']), ('\u0403', &['\u0413', '\u0301']), ('\u0407', &['\u0406', '\u0308']), ('\u040c',
        &['\u041a', '\u0301']), ('\u040d', &['\u0418', '\u0300']), ('\u040e', &['\u0423',
        '\u0306']), ('\u0419', &['\u0418', '\u0306']), ('\u0439', &['\u0438', '\u0306']), ('\u0450',
        &['\u0435', '\u0300']), ('\u0451', &['\u0435', '\u0308']), ('\u0453', &['\u0433',
        '\u0301']), ('\u0457', &['\u0456', '\u0308']), ('\u045c', &['\u043a', '\u0301']), ('\u045d',
        &['\u0438', '\u0300']), ('\u045e', &['\u0443', '\u0306']), ('\u0476', &['\u0474',
        '\u030f']), ('\u0477', &['\u0475', '\u030f']), ('\u04c1', &['\u0416', '\u0306']), ('\u04c2',
        &['\u0436', '\u0306']), ('\u04d0', &['\u0410', '\u0306']), ('\u04d1', &['\u0430',
        '\u0306']), ('\u04d2', &['\u0410', '\u0308']), ('\u04d3', &['\u0430', '\u0308']), ('\u04d6',
        &['\u0415', '\u0306']), ('\u04d7', &['\u0435', '\u0306']), ('\u04da', &['\u04d8',
        '\u0308']), ('\u04db', &['\u04d9', '\u0308']), ('\u04dc', &['\u0416', '\u0308']), ('\u04dd',
        &['\u0436', '\u0308']), ('\u04de', &['\u0417', '\u0308']), ('\u04df', &['\u0437',
        '\u0308']), ('\u04e2', &['\u0418', '\u0304']), ('\u04e3', &['\u0438', '\u0304']), ('\u04e4',
        &['\u0418', '\u0308']), ('\u04e5', &['\u0438', '\u0308']), ('\u04e6', &['\u041e',
        '\u0308']), ('\u04e7', &['\u043e', '\u0308']), ('\u04ea', &['\u04e8', '\u0308']), ('\u04eb',
        &['\u04e9', '\u0308']), ('\u04ec', &['\u042d', '\u0308']), ('\u04ed', &['\u044d',
        '\u0308']), ('\u04ee', &['\u0423', '\u0304']), ('\u04ef', &['\u0443', '\u0304']), ('\u04f0',
        &['\u0423', '\u0308']), ('\u04f1', &['\u0443', '\u0308']), ('\u04f2', &['\u0423',
        '\u030b']), ('\u04f3', &['\u0443', '\u030b']), ('\u04f4', &['\u0427', '\u0308']), ('\u04f5',
        &['\u0447', '\u0308']), ('\u04f8', &['\u042b', '\u0308']), ('\u04f9', &['\u044b',
        '\u0308']), ('\u0622', &['\u0627', '\u0653']), ('\u0623', &['\u0627', '\u0654']), ('\u0624',
        &['\u0648', '\u0654']), ('\u0625', &['\u0627', '\u0655']), ('\u0626', &['\u064a',
        '\u0654']), ('\u06c0', &['\u06d5', '\u0654']), ('\u06c2', &['\u06c1', '\u0654']), ('\u06d3',
        &['\u06d2', '\u0654']), ('\u0929', &['\u0928', '\u093c']), ('\u0931', &['\u0930',
        '\u093c']), ('\u0934', &['\u0933', '\u093c']), ('\u0958', &['\u0915', '\u093c']), ('\u0959',
        &['\u0916', '\u093c']), ('\u095a', &['\u0917', '\u093c']), ('\u095b', &['\u091c',
        '\u093c']), ('\u095c', &['\u0921', '\u093c']), ('\u095d', &['\u0922', '\u093c']), ('\u095e',
        &['\u092b', '\u093c']), ('\u095f', &['\u092f', '\u093c']), ('\u09cb', &['\u09c7',
        '\u09be']), ('\u09cc', &['\u09c7', '\u09d7']), ('\u09dc', &['\u09a1', '\u09bc']), ('\u09dd',
        &['\u09a2', '\u09bc']), ('\u09df', &['\u09af', '\u09bc']), ('\u0a33', &['\u0a32',
        '\u0a3c']), ('\u0a36', &['\u0a38', '\u0a3c']), ('\u0a59', &['\u0a16', '\u0a3c']), ('\u0a5a',
        &['\u0a17', '\u0a3c']), ('\u0a5b', &['\u0a1c', '\u0a3c']), ('\u0a5e', &['\u0a2b',
        '\u0a3c']), ('\u0b48', &['\u0b47', '\u0b56']), ('\u0b4b', &['\u0b47', '\u0b3e']), ('\u0b4c',
        &['\u0b47', '\u0b57']), ('\u0b5c', &['\u0b21', '\u0b3c']), ('\u0b5d', &['\u0b22',
        '\u0b3c']), ('\u0b94', &['\u0b92', '\u0bd7']), ('\u0bca', &['\u0bc6', '\u0bbe']), ('\u0bcb',
        &['\u0bc7', '\u0bbe']), ('\u0bcc', &['\u0bc6', '\u0bd7']), ('\u0c48', &['\u0c46',
        '\u0c56']), ('\u0cc0', &['\u0cbf', '\u0cd5']), ('\u0cc7', &['\u0cc6', '\u0cd5']), ('\u0cc8',
        &['\u0cc6', '\u0cd6']), ('\u0cca', &['\u0cc6', '\u0cc2']), ('\u0ccb', &['\u0cca',
        '\u0cd5']), ('\u0d4a', &['\u0d46', '\u0d3e']), ('\u0d4b', &['\u0d47', '\u0d3e']), ('\u0d4c',
        &['\u0d46', '\u0d57']), ('\u0dda', &['\u0dd9', '\u0dca']), ('\u0ddc', &['\u0dd9',
        '\u0dcf']), ('\u0ddd', &['\u0ddc', '\u0dca']), ('\u0dde', &['\u0dd9', '\u0ddf']), ('\u0f43',
        &['\u0f42', '\u0fb7']), ('\u0f4d', &['\u0f4c', '\u0fb7']), ('\u0f52', &['\u0f51',
        '\u0fb7']), ('\u0f57', &['\u0f56', '\u0fb7']), ('\u0f5c', &['\u0f5b', '\u0fb7']), ('\u0f69',
        &['\u0f40', '\u0fb5']), ('\u0f73', &['\u0f71', '\u0f72']), ('\u0f75', &['\u0f71',
        '\u0f74']), ('\u0f76', &['\u0fb2', '\u0f80']), ('\u0f78', &['\u0fb3', '\u0f80']), ('\u0f81',
        &['\u0f71', '\u0f80']), ('\u0f93', &['\u0f92', '\u0fb7']), ('\u0f9d', &['\u0f9c',
        '\u0fb7']), ('\u0fa2', &['\u0fa1', '\u0fb7']), ('\u0fa7', &['\u0fa6', '\u0fb7']), ('\u0fac',
        &['\u0fab', '\u0fb7']), ('\u0fb9', &['\u0f90', '\u0fb5']), ('\u1026', &['\u1025',
        '\u102e']), ('\u1b06', &['\u1b05', '\u1b35']), ('\u1b08', &['\u1b07', '\u1b35']), ('\u1b0a',
        &['\u1b09', '\u1b35']), ('\u1b0c', &['\u1b0b', '\u1b35']), ('\u1b0e', &['\u1b0d',
        '\u1b35']), ('\u1b12', &['\u1b11', '\u1b35']), ('\u1b3b', &['\u1b3a', '\u1b35']), ('\u1b3d',
        &['\u1b3c', '\u1b35']), ('\u1b40', &['\u1b3e', '\u1b35']), ('\u1b41', &['\u1b3f',
        '\u1b35']), ('\u1b43', &['\u1b42', '\u1b35']), ('\u1e00', &['\x41', '\u0325']), ('\u1e01',
        &['\x61', '\u0325']), ('\u1e02', &['\x42', '\u0307']), ('\u1e03', &['\x62', '\u0307']),
        ('\u1e04', &['\x42', '\u0323']), ('\u1e05', &['\x62', '\u0323']), ('\u1e06', &['\x42',
        '\u0331']), ('\u1e07', &['\x62', '\u0331']), ('\u1e08', &['\u00c7', '\u0301']), ('\u1e09',
        &['\u00e7', '\u0301']), ('\u1e0a', &['\x44', '\u0307']), ('\u1e0b', &['\x64', '\u0307']),
        ('\u1e0c', &['\x44', '\u0323']), ('\u1e0d', &['\x64', '\u0323']), ('\u1e0e', &['\x44',
        '\u0331']), ('\u1e0f', &['\x64', '\u0331']), ('\u1e10', &['\x44', '\u0327']), ('\u1e11',
        &['\x64', '\u0327']), ('\u1e12', &['\x44', '\u032d']), ('\u1e13', &['\x64', '\u032d']),
        ('\u1e14', &['\u0112', '\u0300']), ('\u1e15', &['\u0113', '\u0300']), ('\u1e16', &['\u0112',
        '\u0301']), ('\u1e17', &['\u0113', '\u0301']), ('\u1e18', &['\x45', '\u032d']), ('\u1e19',
        &['\x65', '\u032d']), ('\u1e1a', &['\x45', '\u0330']), ('\u1e1b', &['\x65', '\u0330']),
        ('\u1e1c', &['\u0228', '\u0306']), ('\u1e1d', &['\u0229', '\u0306']), ('\u1e1e', &['\x46',
        '\u0307']), ('\u1e1f', &['\x66', '\u0307']), ('\u1e20', &['\x47', '\u0304']), ('\u1e21',
        &['\x67', '\u0304']), ('\u1e22', &['\x48', '\u0307']), ('\u1e23', &['\x68', '\u0307']),
        ('\u1e24', &['\x48', '\u0323']), ('\u1e25', &['\x68', '\u0323']), ('\u1e26', &['\x48',
        '\u0308']), ('\u1e27', &['\x68', '\u0308']), ('\u1e28', &['\x48', '\u0327']), ('\u1e29',
        &['\x68', '\u0327']), ('\u1e2a', &['\x48', '\u032e']), ('\u1e2b', &['\x68', '\u032e']),
        ('\u1e2c', &['\x49', '\u0330']), ('\u1e2d', &['\x69', '\u0330']), ('\u1e2e', &['\u00cf',
        '\u0301']), ('\u1e2f', &['\u00ef', '\u0301']), ('\u1e30', &['\x4b', '\u0301']), ('\u1e31',
        &['\x6b', '\u0301']), ('\u1e32', &['\x4b', '\u0323']), ('\u1e33', &['\x6b', '\u0323']),
        ('\u1e34', &['\x4b', '\u0331']), ('\u1e35', &['\x6b', '\u0331']), ('\u1e36', &['\x4c',
        '\u0323']), ('\u1e37', &['\x6c', '\u0323']), ('\u1e38', &['\u1e36', '\u0304']), ('\u1e39',
        &['\u1e37', '\u0304']), ('\u1e3a', &['\x4c', '\u0331']), ('\u1e3b', &['\x6c', '\u0331']),
        ('\u1e3c', &['\x4c', '\u032d']), ('\u1e3d', &['\x6c', '\u032d']), ('\u1e3e', &['\x4d',
        '\u0301']), ('\u1e3f', &['\x6d', '\u0301']), ('\u1e40', &['\x4d', '\u0307']), ('\u1e41',
        &['\x6d', '\u0307']), ('\u1e42', &['\x4d', '\u0323']), ('\u1e43', &['\x6d', '\u0323']),
        ('\u1e44', &['\x4e', '\u0307']), ('\u1e45', &['\x6e', '\u0307']), ('\u1e46', &['\x4e',
        '\u0323']), ('\u1e47', &['\x6e', '\u0323']), ('\u1e48', &['\x4e', '\u0331']), ('\u1e49',
        &['\x6e', '\u0331']), ('\u1e4a', &['\x4e', '\u032d']), ('\u1e4b', &['\x6e', '\u032d']),
        ('\u1e4c', &['\u00d5', '\u0301']), ('\u1e4d', &['\u00f5', '\u0301']), ('\u1e4e', &['\u00d5',
        '\u0308']), ('\u1e4f', &['\u00f5', '\u0308']), ('\u1e50', &['\u014c', '\u0300']), ('\u1e51',
        &['\u014d', '\u0300']), ('\u1e52', &['\u014c', '\u0301']), ('\u1e53', &['\u014d',
        '\u0301']), ('\u1e54', &['\x50', '\u0301']), ('\u1e55', &['\x70', '\u0301']), ('\u1e56',
        &['\x50', '\u0307']), ('\u1e57', &['\x70', '\u0307']), ('\u1e58', &['\x52', '\u0307']),
        ('\u1e59', &['\x72', '\u0307']), ('\u1e5a', &['\x52', '\u0323']), ('\u1e5b', &['\x72',
        '\u0323']), ('\u1e5c', &['\u1e5a', '\u0304']), ('\u1e5d', &['\u1e5b', '\u0304']), ('\u1e5e',
        &['\x52', '\u0331']), ('\u1e5f', &['\x72', '\u0331']), ('\u1e60', &['\x53', '\u0307']),
        ('\u1e61', &['\x73', '\u0307']), ('\u1e62', &['\x53', '\u0323']), ('\u1e63', &['\x73',
        '\u0323']), ('\u1e64', &['\u015a', '\u0307']), ('\u1e65', &['\u015b', '\u0307']), ('\u1e66',
        &['\u0160', '\u0307']), ('\u1e67', &['\u0161', '\u0307']), ('\u1e68', &['\u1e62',
        '\u0307']), ('\u1e69', &['\u1e63', '\u0307']), ('\u1e6a', &['\x54', '\u0307']), ('\u1e6b',
        &['\x74', '\u0307']), ('\u1e6c', &['\x54', '\u0323']), ('\u1e6d', &['\x74', '\u0323']),
        ('\u1e6e', &['\x54', '\u0331']), ('\u1e6f', &['\x74', '\u0331']), ('\u1e70', &['\x54',
        '\u032d']), ('\u1e71', &['\x74', '\u032d']), ('\u1e72', &['\x55', '\u0324']), ('\u1e73',
        &['\x75', '\u0324']), ('\u1e74', &['\x55', '\u0330']), ('\u1e75', &['\x75', '\u0330']),
        ('\u1e76', &['\x55', '\u032d']), ('\u1e77', &['\x75', '\u032d']), ('\u1e78', &['\u0168',
        '\u0301']), ('\u1e79', &['\u0169', '\u0301']), ('\u1e7a', &['\u016a', '\u0308']), ('\u1e7b',
        &['\u016b', '\u0308']), ('\u1e7c', &['\x56', '\u0303']), ('\u1e7d', &['\x76', '\u0303']),
        ('\u1e7e', &['\x56', '\u0323']), ('\u1e7f', &['\x76', '\u0323']), ('\u1e80', &['\x57',
        '\u0300']), ('\u1e81', &['\x77', '\u0300']), ('\u1e82', &['\x57', '\u0301']), ('\u1e83',
        &['\x77', '\u0301']), ('\u1e84', &['\x57', '\u0308']), ('\u1e85', &['\x77', '\u0308']),
        ('\u1e86', &['\x57', '\u0307']), ('\u1e87', &['\x77', '\u0307']), ('\u1e88', &['\x57',
        '\u0323']), ('\u1e89', &['\x77', '\u0323']), ('\u1e8a', &['\x58', '\u0307']), ('\u1e8b',
        &['\x78', '\u0307']), ('\u1e8c', &['\x58', '\u0308']), ('\u1e8d', &['\x78', '\u0308']),
        ('\u1e8e', &['\x59', '\u0307']), ('\u1e8f', &['\x79', '\u0307']), ('\u1e90', &['\x5a',
        '\u0302']), ('\u1e91', &['\x7a', '\u0302']), ('\u1e92', &['\x5a', '\u0323']), ('\u1e93',
        &['\x7a', '\u0323']), ('\u1e94', &['\x5a', '\u0331']), ('\u1e95', &['\x7a', '\u0331']),
        ('\u1e96', &['\x68', '\u0331']), ('\u1e97', &['\x74', '\u0308']), ('\u1e98', &['\x77',
        '\u030a']), ('\u1e99', &['\x79', '\u030a']), ('\u1e9b', &['\u017f', '\u0307']), ('\u1ea0',
        &['\x41', '\u0323']), ('\u1ea1', &['\x61', '\u0323']), ('\u1ea2', &['\x41', '\u0309']),
        ('\u1ea3', &['\x61', '\u0309']), ('\u1ea4', &['\u00c2', '\u0301']), ('\u1ea5', &['\u00e2',
        '\u0301']), ('\u1ea6', &['\u00c2', '\u0300']), ('\u1ea7', &['\u00e2', '\u0300']), ('\u1ea8',
        &['\u00c2', '\u0309']), ('\u1ea9', &['\u00e2', '\u0309']), ('\u1eaa', &['\u00c2',
        '\u0303']), ('\u1eab', &['\u00e2', '\u0303']), ('\u1eac', &['\u1ea0', '\u0302']), ('\u1ead',
        &['\u1ea1', '\u0302']), ('\u1eae', &['\u0102', '\u0301']), ('\u1eaf', &['\u0103',
        '\u0301']), ('\u1eb0', &['\u0102', '\u0300']), ('\u1eb1', &['\u0103', '\u0300']), ('\u1eb2',
        &['\u0102', '\u0309']), ('\u1eb3', &['\u0103', '\u0309']), ('\u1eb4', &['\u0102',
        '\u0303']), ('\u1eb5', &['\u0103', '\u0303']), ('\u1eb6', &['\u1ea0', '\u0306']), ('\u1eb7',
        &['\u1ea1', '\u0306']), ('\u1eb8', &['\x45', '\u0323']), ('\u1eb9', &['\x65', '\u0323']),
        ('\u1eba', &['\x45', '\u0309']), ('\u1ebb', &['\x65', '\u0309']), ('\u1ebc', &['\x45',
        '\u0303']), ('\u1ebd', &['\x65', '\u0303']), ('\u1ebe', &['\u00ca', '\u0301']), ('\u1ebf',
        &['\u00ea', '\u0301']), ('\u1ec0', &['\u00ca', '\u0300']), ('\u1ec1', &['\u00ea',
        '\u0300']), ('\u1ec2', &['\u00ca', '\u0309']), ('\u1ec3', &['\u00ea', '\u0309']), ('\u1ec4',
        &['\u00ca', '\u0303']), ('\u1ec5', &['\u00ea', '\u0303']), ('\u1ec6', &['\u1eb8',
        '\u0302']), ('\u1ec7', &['\u1eb9', '\u0302']), ('\u1ec8', &['\x49', '\u0309']), ('\u1ec9',
        &['\x69', '\u0309']), ('\u1eca', &['\x49', '\u0323']), ('\u1ecb', &['\x69', '\u0323']),
        ('\u1ecc', &['\x4f', '\u0323']), ('\u1ecd', &['\x6f', '\u0323']), ('\u1ece', &['\x4f',
        '\u0309']), ('\u1ecf', &['\x6f', '\u0309']), ('\u1ed0', &['\u00d4', '\u0301']), ('\u1ed1',
        &['\u00f4', '\u0301']), ('\u1ed2', &['\u00d4', '\u0300']), ('\u1ed3', &['\u00f4',
        '\u0300']), ('\u1ed4', &['\u00d4', '\u0309']), ('\u1ed5', &['\u00f4', '\u0309']), ('\u1ed6',
        &['\u00d4', '\u0303']), ('\u1ed7', &['\u00f4', '\u0303']), ('\u1ed8', &['\u1ecc',
        '\u0302']), ('\u1ed9', &['\u1ecd', '\u0302']), ('\u1eda', &['\u01a0', '\u0301']), ('\u1edb',
        &['\u01a1', '\u0301']), ('\u1edc', &['\u01a0', '\u0300']), ('\u1edd', &['\u01a1',
        '\u0300']), ('\u1ede', &['\u01a0', '\u0309']), ('\u1edf', &['\u01a1', '\u0309']), ('\u1ee0',
        &['\u01a0', '\u0303']), ('\u1ee1', &['\u01a1', '\u0303']), ('\u1ee2', &['\u01a0',
        '\u0323']), ('\u1ee3', &['\u01a1', '\u0323']), ('\u1ee4', &['\x55', '\u0323']), ('\u1ee5',
        &['\x75', '\u0323']), ('\u1ee6', &['\x55', '\u0309']), ('\u1ee7', &['\x75', '\u0309']),
        ('\u1ee8', &['\u01af', '\u0301']), ('\u1ee9', &['\u01b0', '\u0301']), ('\u1eea', &['\u01af',
        '\u0300']), ('\u1eeb', &['\u01b0', '\u0300']), ('\u1eec', &['\u01af', '\u0309']), ('\u1eed',
        &['\u01b0', '\u0309']), ('\u1eee', &['\u01af', '\u0303']), ('\u1eef', &['\u01b0',
        '\u0303']), ('\u1ef0', &['\u01af', '\u0323']), ('\u1ef1', &['\u01b0', '\u0323']), ('\u1ef2',
        &['\x59', '\u0300']), ('\u1ef3', &['\x79', '\u0300']), ('\u1ef4', &['\x59', '\u0323']),
        ('\u1ef5', &['\x79', '\u0323']), ('\u1ef6', &['\x59', '\u0309']), ('\u1ef7', &['\x79',
        '\u0309']), ('\u1ef8', &['\x59', '\u0303']), ('\u1ef9', &['\x79', '\u0303']), ('\u1f00',
        &['\u03b1', '\u0313']), ('\u1f01', &['\u03b1', '\u0314']), ('\u1f02', &['\u1f00',
        '\u0300']), ('\u1f03', &['\u1f01', '\u0300']), ('\u1f04', &['\u1f00', '\u0301']), ('\u1f05',
        &['\u1f01', '\u0301']), ('\u1f06', &['\u1f00', '\u0342']), ('\u1f07', &['\u1f01',
        '\u0342']), ('\u1f08', &['\u0391', '\u0313']), ('\u1f09', &['\u0391', '\u0314']), ('\u1f0a',
        &['\u1f08', '\u0300']), ('\u1f0b', &['\u1f09', '\u0300']), ('\u1f0c', &['\u1f08',
        '\u0301']), ('\u1f0d', &['\u1f09', '\u0301']), ('\u1f0e', &['\u1f08', '\u0342']), ('\u1f0f',
        &['\u1f09', '\u0342']), ('\u1f10', &['\u03b5', '\u0313']), ('\u1f11', &['\u03b5',
        '\u0314']), ('\u1f12', &['\u1f10', '\u0300']), ('\u1f13', &['\u1f11', '\u0300']), ('\u1f14',
        &['\u1f10', '\u0301']), ('\u1f15', &['\u1f11', '\u0301']), ('\u1f18', &['\u0395',
        '\u0313']), ('\u1f19', &['\u0395', '\u0314']), ('\u1f1a', &['\u1f18', '\u0300']), ('\u1f1b',
        &['\u1f19', '\u0300']), ('\u1f1c', &['\u1f18', '\u0301']), ('\u1f1d', &['\u1f19',
        '\u0301']), ('\u1f20', &['\u03b7', '\u0313']), ('\u1f21', &['\u03b7', '\u0314']), ('\u1f22',
        &['\u1f20', '\u0300']), ('\u1f23', &['\u1f21', '\u0300']), ('\u1f24', &['\u1f20',
        '\u0301']), ('\u1f25', &['\u1f21', '\u0301']), ('\u1f26', &['\u1f20', '\u0342']), ('\u1f27',
        &['\u1f21', '\u0342']), ('\u1f28', &['\u0397', '\u0313']), ('\u1f29', &['\u0397',
        '\u0314']), ('\u1f2a', &['\u1f28', '\u0300']), ('\u1f2b', &['\u1f29', '\u0300']), ('\u1f2c',
        &['\u1f28', '\u0301']), ('\u1f2d', &['\u1f29', '\u0301']), ('\u1f2e', &['\u1f28',
        '\u0342']), ('\u1f2f', &['\u1f29', '\u0342']), ('\u1f30', &['\u03b9', '\u0313']), ('\u1f31',
        &['\u03b9', '\u0314']), ('\u1f32', &['\u1f30', '\u0300']), ('\u1f33', &['\u1f31',
        '\u0300']), ('\u1f34', &['\u1f30', '\u0301']), ('\u1f35', &['\u1f31', '\u0301']), ('\u1f36',
        &['\u1f30', '\u0342']), ('\u1f37', &['\u1f31', '\u0342']), ('\u1f38', &['\u0399',
        '\u0313']), ('\u1f39', &['\u0399', '\u0314']), ('\u1f3a', &['\u1f38', '\u0300']), ('\u1f3b',
        &['\u1f39', '\u0300']), ('\u1f3c', &['\u1f38', '\u0301']), ('\u1f3d', &['\u1f39',
        '\u0301']), ('\u1f3e', &['\u1f38', '\u0342']), ('\u1f3f', &['\u1f39', '\u0342']), ('\u1f40',
        &['\u03bf', '\u0313']), ('\u1f41', &['\u03bf', '\u0314']), ('\u1f42', &['\u1f40',
        '\u0300']), ('\u1f43', &['\u1f41', '\u0300']), ('\u1f44', &['\u1f40', '\u0301']), ('\u1f45',
        &['\u1f41', '\u0301']), ('\u1f48', &['\u039f', '\u0313']), ('\u1f49', &['\u039f',
        '\u0314']), ('\u1f4a', &['\u1f48', '\u0300']), ('\u1f4b', &['\u1f49', '\u0300']), ('\u1f4c',
        &['\u1f48', '\u0301']), ('\u1f4d', &['\u1f49', '\u0301']), ('\u1f50', &['\u03c5',
        '\u0313']), ('\u1f51', &['\u03c5', '\u0314']), ('\u1f52', &['\u1f50', '\u0300']), ('\u1f53',
        &['\u1f51', '\u0300']), ('\u1f54', &['\u1f50', '\u0301']), ('\u1f55', &['\u1f51',
        '\u0301']), ('\u1f56', &['\u1f50', '\u0342']), ('\u1f57', &['\u1f51', '\u0342']), ('\u1f59',
        &['\u03a5', '\u0314']), ('\u1f5b', &['\u1f59', '\u0300']), ('\u1f5d', &['\u1f59',
        '\u0301']), ('\u1f5f', &['\u1f59', '\u0342']), ('\u1f60', &['\u03c9', '\u0313']), ('\u1f61',
        &['\u03c9', '\u0314']), ('\u1f62', &['\u1f60', '\u0300']), ('\u1f63', &['\u1f61',
        '\u0300']), ('\u1f64', &['\u1f60', '\u0301']), ('\u1f65', &['\u1f61', '\u0301']), ('\u1f66',
        &['\u1f60', '\u0342']), ('\u1f67', &['\u1f61', '\u0342']), ('\u1f68', &['\u03a9',
        '\u0313']), ('\u1f69', &['\u03a9', '\u0314']), ('\u1f6a', &['\u1f68', '\u0300']), ('\u1f6b',
        &['\u1f69', '\u0300']), ('\u1f6c', &['\u1f68', '\u0301']), ('\u1f6d', &['\u1f69',
        '\u0301']), ('\u1f6e', &['\u1f68', '\u0342']), ('\u1f6f', &['\u1f69', '\u0342']), ('\u1f70',
        &['\u03b1', '\u0300']), ('\u1f71', &['\u03ac']), ('\u1f72', &['\u03b5', '\u0300']),
        ('\u1f73', &['\u03ad']), ('\u1f74', &['\u03b7', '\u0300']), ('\u1f75', &['\u03ae']),
        ('\u1f76', &['\u03b9', '\u0300']), ('\u1f77', &['\u03af']), ('\u1f78', &['\u03bf',
        '\u0300']), ('\u1f79', &['\u03cc']), ('\u1f7a', &['\u03c5', '\u0300']), ('\u1f7b',
        &['\u03cd']), ('\u1f7c', &['\u03c9', '\u0300']), ('\u1f7d', &['\u03ce']), ('\u1f80',
        &['\u1f00', '\u0345']), ('\u1f81', &['\u1f01', '\u0345']), ('\u1f82', &['\u1f02',
        '\u0345']), ('\u1f83', &['\u1f03', '\u0345']), ('\u1f84', &['\u1f04', '\u0345']), ('\u1f85',
        &['\u1f05', '\u0345']), ('\u1f86', &['\u1f06', '\u0345']), ('\u1f87', &['\u1f07',
        '\u0345']), ('\u1f88', &['\u1f08', '\u0345']), ('\u1f89', &['\u1f09', '\u0345']), ('\u1f8a',
        &['\u1f0a', '\u0345']), ('\u1f8b', &['\u1f0b', '\u0345']), ('\u1f8c', &['\u1f0c',
        '\u0345']), ('\u1f8d', &['\u1f0d', '\u0345']), ('\u1f8e', &['\u1f0e', '\u0345']), ('\u1f8f',
        &['\u1f0f', '\u0345']), ('\u1f90', &['\u1f20', '\u0345']), ('\u1f91', &['\u1f21',
        '\u0345']), ('\u1f92', &['\u1f22', '\u0345']), ('\u1f93', &['\u1f23', '\u0345']), ('\u1f94',
        &['\u1f24', '\u0345']), ('\u1f95', &['\u1f25', '\u0345']), ('\u1f96', &['\u1f26',
        '\u0345']), ('\u1f97', &['\u1f27', '\u0345']), ('\u1f98', &['\u1f28', '\u0345']), ('\u1f99',
        &['\u1f29', '\u0345']), ('\u1f9a', &['\u1f2a', '\u0345']), ('\u1f9b', &['\u1f2b',
        '\u0345']), ('\u1f9c', &['\u1f2c', '\u0345']), ('\u1f9d', &['\u1f2d', '\u0345']), ('\u1f9e',
        &['\u1f2e', '\u0345']), ('\u1f9f', &['\u1f2f', '\u0345']), ('\u1fa0', &['\u1f60',
        '\u0345']), ('\u1fa1', &['\u1f61', '\u0345']), ('\u1fa2', &['\u1f62', '\u0345']), ('\u1fa3',
        &['\u1f63', '\u0345']), ('\u1fa4', &['\u1f64', '\u0345']), ('\u1fa5', &['\u1f65',
        '\u0345']), ('\u1fa6', &['\u1f66', '\u0345']), ('\u1fa7', &['\u1f67', '\u0345']), ('\u1fa8',
        &['\u1f68', '\u0345']), ('\u1fa9', &['\u1f69', '\u0345']), ('\u1faa', &['\u1f6a',
        '\u0345']), ('\u1fab', &['\u1f6b', '\u0345']), ('\u1fac', &['\u1f6c', '\u0345']), ('\u1fad',
        &['\u1f6d', '\u0345']), ('\u1fae', &['\u1f6e', '\u0345']), ('\u1faf', &['\u1f6f',
        '\u0345']), ('\u1fb0', &['\u03b1', '\u0306']), ('\u1fb1', &['\u03b1', '\u0304']), ('\u1fb2',
        &['\u1f70', '\u0345']), ('\u1fb3', &['\u03b1', '\u0345']), ('\u1fb4', &['\u03ac',
        '\u0345']), ('\u1fb6', &['\u03b1', '\u0342']), ('\u1fb7', &['\u1fb6', '\u0345']), ('\u1fb8',
        &['\u0391', '\u0306']), ('\u1fb9', &['\u0391', '\u0304']), ('\u1fba', &['\u0391',
        '\u0300']), ('\u1fbb', &['\u0386']), ('\u1fbc', &['\u0391', '\u0345']), ('\u1fbe',
        &['\u03b9']), ('\u1fc1', &['\u00a8', '\u0342']), ('\u1fc2', &['\u1f74', '\u0345']),
        ('\u1fc3', &['\u03b7', '\u0345']), ('\u1fc4', &['\u03ae', '\u0345']), ('\u1fc6', &['\u03b7',
        '\u0342']), ('\u1fc7', &['\u1fc6', '\u0345']), ('\u1fc8', &['\u0395', '\u0300']), ('\u1fc9',
        &['\u0388']), ('\u1fca', &['\u0397', '\u0300']), ('\u1fcb', &['\u0389']), ('\u1fcc',
        &['\u0397', '\u0345']), ('\u1fcd', &['\u1fbf', '\u0300']), ('\u1fce', &['\u1fbf',
        '\u0301']), ('\u1fcf', &['\u1fbf', '\u0342']), ('\u1fd0', &['\u03b9', '\u0306']), ('\u1fd1',
        &['\u03b9', '\u0304']), ('\u1fd2', &['\u03ca', '\u0300']), ('\u1fd3', &['\u0390']),
        ('\u1fd6', &['\u03b9', '\u0342']), ('\u1fd7', &['\u03ca', '\u0342']), ('\u1fd8', &['\u0399',
        '\u0306']), ('\u1fd9', &['\u0399', '\u0304']), ('\u1fda', &['\u0399', '\u0300']), ('\u1fdb',
        &['\u038a']), ('\u1fdd', &['\u1ffe', '\u0300']), ('\u1fde', &['\u1ffe', '\u0301']),
        ('\u1fdf', &['\u1ffe', '\u0342']), ('\u1fe0', &['\u03c5', '\u0306']), ('\u1fe1', &['\u03c5',
        '\u0304']), ('\u1fe2', &['\u03cb', '\u0300']), ('\u1fe3', &['\u03b0']), ('\u1fe4',
        &['\u03c1', '\u0313']), ('\u1fe5', &['\u03c1', '\u0314']), ('\u1fe6', &['\u03c5',
        '\u0342']), ('\u1fe7', &['\u03cb', '\u0342']), ('\u1fe8', &['\u03a5', '\u0306']), ('\u1fe9',
        &['\u03a5', '\u0304']), ('\u1fea', &['\u03a5', '\u0300']), ('\u1feb', &['\u038e']),
        ('\u1fec', &['\u03a1', '\u0314']), ('\u1fed', &['\u00a8', '\u0300']), ('\u1fee',
        &['\u0385']), ('\u1fef', &['\x60']), ('\u1ff2', &['\u1f7c', '\u0345']), ('\u1ff3',
        &['\u03c9', '\u0345']), ('\u1ff4', &['\u03ce', '\u0345']), ('\u1ff6', &['\u03c9',
        '\u0342']), ('\u1ff7', &['\u1ff6', '\u0345']), ('\u1ff8', &['\u039f', '\u0300']), ('\u1ff9',
        &['\u038c']), ('\u1ffa', &['\u03a9', '\u0300']), ('\u1ffb', &['\u038f']), ('\u1ffc',
        &['\u03a9', '\u0345']), ('\u1ffd', &['\u00b4']), ('\u2000', &['\u2002']), ('\u2001',
        &['\u2003']), ('\u2126', &['\u03a9']), ('\u212a', &['\x4b']), ('\u212b', &['\u00c5']),
        ('\u219a', &['\u2190', '\u0338']), ('\u219b', &['\u2192', '\u0338']), ('\u21ae', &['\u2194',
        '\u0338']), ('\u21cd', &['\u21d0', '\u0338']), ('\u21ce', &['\u21d4', '\u0338']), ('\u21cf',
        &['\u21d2', '\u0338']), ('\u2204', &['\u2203', '\u0338']), ('\u2209', &['\u2208',
        '\u0338']), ('\u220c', &['\u220b', '\u0338']), ('\u2224', &['\u2223', '\u0338']), ('\u2226',
        &['\u2225', '\u0338']), ('\u2241', &['\u223c', '\u0338']), ('\u2244', &['\u2243',
        '\u0338']), ('\u2247', &['\u2245', '\u0338']), ('\u2249', &['\u2248', '\u0338']), ('\u2260',
        &['\x3d', '\u0338']), ('\u2262', &['\u2261', '\u0338']), ('\u226d', &['\u224d', '\u0338']),
        ('\u226e', &['\x3c', '\u0338']), ('\u226f', &['\x3e', '\u0338']), ('\u2270', &['\u2264',
        '\u0338']), ('\u2271', &['\u2265', '\u0338']), ('\u2274', &['\u2272', '\u0338']), ('\u2275',
        &['\u2273', '\u0338']), ('\u2278', &['\u2276', '\u0338']), ('\u2279', &['\u2277',
        '\u0338']), ('\u2280', &['\u227a', '\u0338']), ('\u2281', &['\u227b', '\u0338']), ('\u2284',
        &['\u2282', '\u0338']), ('\u2285', &['\u2283', '\u0338']), ('\u2288', &['\u2286',
        '\u0338']), ('\u2289', &['\u2287', '\u0338']), ('\u22ac', &['\u22a2', '\u0338']), ('\u22ad',
        &['\u22a8', '\u0338']), ('\u22ae', &['\u22a9', '\u0338']), ('\u22af', &['\u22ab',
        '\u0338']), ('\u22e0', &['\u227c', '\u0338']), ('\u22e1', &['\u227d', '\u0338']), ('\u22e2',
        &['\u2291', '\u0338']), ('\u22e3', &['\u2292', '\u0338']), ('\u22ea', &['\u22b2',
        '\u0338']), ('\u22eb', &['\u22b3', '\u0338']), ('\u22ec', &['\u22b4', '\u0338']), ('\u22ed',
        &['\u22b5', '\u0338']), ('\u2329', &['\u3008']), ('\u232a', &['\u3009']), ('\u2adc',
        &['\u2add', '\u0338']), ('\u304c', &['\u304b', '\u3099']), ('\u304e', &['\u304d',
        '\u3099']), ('\u3050', &['\u304f', '\u3099']), ('\u3052', &['\u3051', '\u3099']), ('\u3054',
        &['\u3053', '\u3099']), ('\u3056', &['\u3055', '\u3099']), ('\u3058', &['\u3057',
        '\u3099']), ('\u305a', &['\u3059', '\u3099']), ('\u305c', &['\u305b', '\u3099']), ('\u305e',
        &['\u305d', '\u3099']), ('\u3060', &['\u305f', '\u3099']), ('\u3062', &['\u3061',
        '\u3099']), ('\u3065', &['\u3064', '\u3099']), ('\u3067', &['\u3066', '\u3099']), ('\u3069',
        &['\u3068', '\u3099']), ('\u3070', &['\u306f', '\u3099']), ('\u3071', &['\u306f',
        '\u309a']), ('\u3073', &['\u3072', '\u3099']), ('\u3074', &['\u3072', '\u309a']), ('\u3076',
        &['\u3075', '\u3099']), ('\u3077', &['\u3075', '\u309a']), ('\u3079', &['\u3078',
        '\u3099']), ('\u307a', &['\u3078', '\u309a']), ('\u307c', &['\u307b', '\u3099']), ('\u307d',
        &['\u307b', '\u309a']), ('\u3094', &['\u3046', '\u3099']), ('\u309e', &['\u309d',
        '\u3099']), ('\u30ac', &['\u30ab', '\u3099']), ('\u30ae', &['\u30ad', '\u3099']), ('\u30b0',
        &['\u30af', '\u3099']), ('\u30b2', &['\u30b1', '\u3099']), ('\u30b4', &['\u30b3',
        '\u3099']), ('\u30b6', &['\u30b5', '\u3099']), ('\u30b8', &['\u30b7', '\u3099']), ('\u30ba',
        &['\u30b9', '\u3099']), ('\u30bc', &['\u30bb', '\u3099']), ('\u30be', &['\u30bd',
        '\u3099']), ('\u30c0', &['\u30bf', '\u3099']), ('\u30c2', &['\u30c1', '\u3099']), ('\u30c5',
        &['\u30c4', '\u3099']), ('\u30c7', &['\u30c6', '\u3099']), ('\u30c9', &['\u30c8',
        '\u3099']), ('\u30d0', &['\u30cf', '\u3099']), ('\u30d1', &['\u30cf', '\u309a']), ('\u30d3',
        &['\u30d2', '\u3099']), ('\u30d4', &['\u30d2', '\u309a']), ('\u30d6', &['\u30d5',
        '\u3099']), ('\u30d7', &['\u30d5', '\u309a']), ('\u30d9', &['\u30d8', '\u3099']), ('\u30da',
        &['\u30d8', '\u309a']), ('\u30dc', &['\u30db', '\u3099']), ('\u30dd', &['\u30db',
        '\u309a']), ('\u30f4', &['\u30a6', '\u3099']), ('\u30f7', &['\u30ef', '\u3099']), ('\u30f8',
        &['\u30f0', '\u3099']), ('\u30f9', &['\u30f1', '\u3099']), ('\u30fa', &['\u30f2',
        '\u3099']), ('\u30fe', &['\u30fd', '\u3099']), ('\uf900', &['\u8c48']), ('\uf901',
        &['\u66f4']), ('\uf902', &['\u8eca']), ('\uf903', &['\u8cc8']), ('\uf904', &['\u6ed1']),
        ('\uf905', &['\u4e32']), ('\uf906', &['\u53e5']), ('\uf907', &['\u9f9c']), ('\uf908',
        &['\u9f9c']), ('\uf909', &['\u5951']), ('\uf90a', &['\u91d1']), ('\uf90b', &['\u5587']),
        ('\uf90c', &['\u5948']), ('\uf90d', &['\u61f6']), ('\uf90e', &['\u7669']), ('\uf90f',
        &['\u7f85']), ('\uf910', &['\u863f']), ('\uf911', &['\u87ba']), ('\uf912', &['\u88f8']),
        ('\uf913', &['\u908f']), ('\uf914', &['\u6a02']), ('\uf915', &['\u6d1b']), ('\uf916',
        &['\u70d9']), ('\uf917', &['\u73de']), ('\uf918', &['\u843d']), ('\uf919', &['\u916a']),
        ('\uf91a', &['\u99f1']), ('\uf91b', &['\u4e82']), ('\uf91c', &['\u5375']), ('\uf91d',
        &['\u6b04']), ('\uf91e', &['\u721b']), ('\uf91f', &['\u862d']), ('\uf920', &['\u9e1e']),
        ('\uf921', &['\u5d50']), ('\uf922', &['\u6feb']), ('\uf923', &['\u85cd']), ('\uf924',
        &['\u8964']), ('\uf925', &['\u62c9']), ('\uf926', &['\u81d8']), ('\uf927', &['\u881f']),
        ('\uf928', &['\u5eca']), ('\uf929', &['\u6717']), ('\uf92a', &['\u6d6a']), ('\uf92b',
        &['\u72fc']), ('\uf92c', &['\u90ce']), ('\uf92d', &['\u4f86']), ('\uf92e', &['\u51b7']),
        ('\uf92f', &['\u52de']), ('\uf930', &['\u64c4']), ('\uf931', &['\u6ad3']), ('\uf932',
        &['\u7210']), ('\uf933', &['\u76e7']), ('\uf934', &['\u8001']), ('\uf935', &['\u8606']),
        ('\uf936', &['\u865c']), ('\uf937', &['\u8def']), ('\uf938', &['\u9732']), ('\uf939',
        &['\u9b6f']), ('\uf93a', &['\u9dfa']), ('\uf93b', &['\u788c']), ('\uf93c', &['\u797f']),
        ('\uf93d', &['\u7da0']), ('\uf93e', &['\u83c9']), ('\uf93f', &['\u9304']), ('\uf940',
        &['\u9e7f']), ('\uf941', &['\u8ad6']), ('\uf942', &['\u58df']), ('\uf943', &['\u5f04']),
        ('\uf944', &['\u7c60']), ('\uf945', &['\u807e']), ('\uf946', &['\u7262']), ('\uf947',
        &['\u78ca']), ('\uf948', &['\u8cc2']), ('\uf949', &['\u96f7']), ('\uf94a', &['\u58d8']),
        ('\uf94b', &['\u5c62']), ('\uf94c', &['\u6a13']), ('\uf94d', &['\u6dda']), ('\uf94e',
        &['\u6f0f']), ('\uf94f', &['\u7d2f']), ('\uf950', &['\u7e37']), ('\uf951', &['\u964b']),
        ('\uf952', &['\u52d2']), ('\uf953', &['\u808b']), ('\uf954', &['\u51dc']), ('\uf955',
        &['\u51cc']), ('\uf956', &['\u7a1c']), ('\uf957', &['\u7dbe']), ('\uf958', &['\u83f1']),
        ('\uf959', &['\u9675']), ('\uf95a', &['\u8b80']), ('\uf95b', &['\u62cf']), ('\uf95c',
        &['\u6a02']), ('\uf95d', &['\u8afe']), ('\uf95e', &['\u4e39']), ('\uf95f', &['\u5be7']),
        ('\uf960', &['\u6012']), ('\uf961', &['\u7387']), ('\uf962', &['\u7570']), ('\uf963',
        &['\u5317']), ('\uf964', &['\u78fb']), ('\uf965', &['\u4fbf']), ('\uf966', &['\u5fa9']),
        ('\uf967', &['\u4e0d']), ('\uf968', &['\u6ccc']), ('\uf969', &['\u6578']), ('\uf96a',
        &['\u7d22']), ('\uf96b', &['\u53c3']), ('\uf96c', &['\u585e']), ('\uf96d', &['\u7701']),
        ('\uf96e', &['\u8449']), ('\uf96f', &['\u8aaa']), ('\uf970', &['\u6bba']), ('\uf971',
        &['\u8fb0']), ('\uf972', &['\u6c88']), ('\uf973', &['\u62fe']), ('\uf974', &['\u82e5']),
        ('\uf975', &['\u63a0']), ('\uf976', &['\u7565']), ('\uf977', &['\u4eae']), ('\uf978',
        &['\u5169']), ('\uf979', &['\u51c9']), ('\uf97a', &['\u6881']), ('\uf97b', &['\u7ce7']),
        ('\uf97c', &['\u826f']), ('\uf97d', &['\u8ad2']), ('\uf97e', &['\u91cf']), ('\uf97f',
        &['\u52f5']), ('\uf980', &['\u5442']), ('\uf981', &['\u5973']), ('\uf982', &['\u5eec']),
        ('\uf983', &['\u65c5']), ('\uf984', &['\u6ffe']), ('\uf985', &['\u792a']), ('\uf986',
        &['\u95ad']), ('\uf987', &['\u9a6a']), ('\uf988', &['\u9e97']), ('\uf989', &['\u9ece']),
        ('\uf98a', &['\u529b']), ('\uf98b', &['\u66c6']), ('\uf98c', &['\u6b77']), ('\uf98d',
        &['\u8f62']), ('\uf98e', &['\u5e74']), ('\uf98f', &['\u6190']), ('\uf990', &['\u6200']),
        ('\uf991', &['\u649a']), ('\uf992', &['\u6f23']), ('\uf993', &['\u7149']), ('\uf994',
        &['\u7489']), ('\uf995', &['\u79ca']), ('\uf996', &['\u7df4']), ('\uf997', &['\u806f']),
        ('\uf998', &['\u8f26']), ('\uf999', &['\u84ee']), ('\uf99a', &['\u9023']), ('\uf99b',
        &['\u934a']), ('\uf99c', &['\u5217']), ('\uf99d', &['\u52a3']), ('\uf99e', &['\u54bd']),
        ('\uf99f', &['\u70c8']), ('\uf9a0', &['\u88c2']), ('\uf9a1', &['\u8aaa']), ('\uf9a2',
        &['\u5ec9']), ('\uf9a3', &['\u5ff5']), ('\uf9a4', &['\u637b']), ('\uf9a5', &['\u6bae']),
        ('\uf9a6', &['\u7c3e']), ('\uf9a7', &['\u7375']), ('\uf9a8', &['\u4ee4']), ('\uf9a9',
        &['\u56f9']), ('\uf9aa', &['\u5be7']), ('\uf9ab', &['\u5dba']), ('\uf9ac', &['\u601c']),
        ('\uf9ad', &['\u73b2']), ('\uf9ae', &['\u7469']), ('\uf9af', &['\u7f9a']), ('\uf9b0',
        &['\u8046']), ('\uf9b1', &['\u9234']), ('\uf9b2', &['\u96f6']), ('\uf9b3', &['\u9748']),
        ('\uf9b4', &['\u9818']), ('\uf9b5', &['\u4f8b']), ('\uf9b6', &['\u79ae']), ('\uf9b7',
        &['\u91b4']), ('\uf9b8', &['\u96b8']), ('\uf9b9', &['\u60e1']), ('\uf9ba', &['\u4e86']),
        ('\uf9bb', &['\u50da']), ('\uf9bc', &['\u5bee']), ('\uf9bd', &['\u5c3f']), ('\uf9be',
        &['\u6599']), ('\uf9bf', &['\u6a02']), ('\uf9c0', &['\u71ce']), ('\uf9c1', &['\u7642']),
        ('\uf9c2', &['\u84fc']), ('\uf9c3', &['\u907c']), ('\uf9c4', &['\u9f8d']), ('\uf9c5',
        &['\u6688']), ('\uf9c6', &['\u962e']), ('\uf9c7', &['\u5289']), ('\uf9c8', &['\u677b']),
        ('\uf9c9', &['\u67f3']), ('\uf9ca', &['\u6d41']), ('\uf9cb', &['\u6e9c']), ('\uf9cc',
        &['\u7409']), ('\uf9cd', &['\u7559']), ('\uf9ce', &['\u786b']), ('\uf9cf', &['\u7d10']),
        ('\uf9d0', &['\u985e']), ('\uf9d1', &['\u516d']), ('\uf9d2', &['\u622e']), ('\uf9d3',
        &['\u9678']), ('\uf9d4', &['\u502b']), ('\uf9d5', &['\u5d19']), ('\uf9d6', &['\u6dea']),
        ('\uf9d7', &['\u8f2a']), ('\uf9d8', &['\u5f8b']), ('\uf9d9', &['\u6144']), ('\uf9da',
        &['\u6817']), ('\uf9db', &['\u7387']), ('\uf9dc', &['\u9686']), ('\uf9dd', &['\u5229']),
        ('\uf9de', &['\u540f']), ('\uf9df', &['\u5c65']), ('\uf9e0', &['\u6613']), ('\uf9e1',
        &['\u674e']), ('\uf9e2', &['\u68a8']), ('\uf9e3', &['\u6ce5']), ('\uf9e4', &['\u7406']),
        ('\uf9e5', &['\u75e2']), ('\uf9e6', &['\u7f79']), ('\uf9e7', &['\u88cf']), ('\uf9e8',
        &['\u88e1']), ('\uf9e9', &['\u91cc']), ('\uf9ea', &['\u96e2']), ('\uf9eb', &['\u533f']),
        ('\uf9ec', &['\u6eba']), ('\uf9ed', &['\u541d']), ('\uf9ee', &['\u71d0']), ('\uf9ef',
        &['\u7498']), ('\uf9f0', &['\u85fa']), ('\uf9f1', &['\u96a3']), ('\uf9f2', &['\u9c57']),
        ('\uf9f3', &['\u9e9f']), ('\uf9f4', &['\u6797']), ('\uf9f5', &['\u6dcb']), ('\uf9f6',
        &['\u81e8']), ('\uf9f7', &['\u7acb']), ('\uf9f8', &['\u7b20']), ('\uf9f9', &['\u7c92']),
        ('\uf9fa', &['\u72c0']), ('\uf9fb', &['\u7099']), ('\uf9fc', &['\u8b58']), ('\uf9fd',
        &['\u4ec0']), ('\uf9fe', &['\u8336']), ('\uf9ff', &['\u523a']), ('\ufa00', &['\u5207']),
        ('\ufa01', &['\u5ea6']), ('\ufa02', &['\u62d3']), ('\ufa03', &['\u7cd6']), ('\ufa04',
        &['\u5b85']), ('\ufa05', &['\u6d1e']), ('\ufa06', &['\u66b4']), ('\ufa07', &['\u8f3b']),
        ('\ufa08', &['\u884c']), ('\ufa09', &['\u964d']), ('\ufa0a', &['\u898b']), ('\ufa0b',
        &['\u5ed3']), ('\ufa0c', &['\u5140']), ('\ufa0d', &['\u55c0']), ('\ufa10', &['\u585a']),
        ('\ufa12', &['\u6674']), ('\ufa15', &['\u51de']), ('\ufa16', &['\u732a']), ('\ufa17',
        &['\u76ca']), ('\ufa18', &['\u793c']), ('\ufa19', &['\u795e']), ('\ufa1a', &['\u7965']),
        ('\ufa1b', &['\u798f']), ('\ufa1c', &['\u9756']), ('\ufa1d', &['\u7cbe']), ('\ufa1e',
        &['\u7fbd']), ('\ufa20', &['\u8612']), ('\ufa22', &['\u8af8']), ('\ufa25', &['\u9038']),
        ('\ufa26', &['\u90fd']), ('\ufa2a', &['\u98ef']), ('\ufa2b', &['\u98fc']), ('\ufa2c',
        &['\u9928']), ('\ufa2d', &['\u9db4']), ('\ufa2e', &['\u90de']), ('\ufa2f', &['\u96b7']),
        ('\ufa30', &['\u4fae']), ('\ufa31', &['\u50e7']), ('\ufa32', &['\u514d']), ('\ufa33',
        &['\u52c9']), ('\ufa34', &['\u52e4']), ('\ufa35', &['\u5351']), ('\ufa36', &['\u559d']),
        ('\ufa37', &['\u5606']), ('\ufa38', &['\u5668']), ('\ufa39', &['\u5840']), ('\ufa3a',
        &['\u58a8']), ('\ufa3b', &['\u5c64']), ('\ufa3c', &['\u5c6e']), ('\ufa3d', &['\u6094']),
        ('\ufa3e', &['\u6168']), ('\ufa3f', &['\u618e']), ('\ufa40', &['\u61f2']), ('\ufa41',
        &['\u654f']), ('\ufa42', &['\u65e2']), ('\ufa43', &['\u6691']), ('\ufa44', &['\u6885']),
        ('\ufa45', &['\u6d77']), ('\ufa46', &['\u6e1a']), ('\ufa47', &['\u6f22']), ('\ufa48',
        &['\u716e']), ('\ufa49', &['\u722b']), ('\ufa4a', &['\u7422']), ('\ufa4b', &['\u7891']),
        ('\ufa4c', &['\u793e']), ('\ufa4d', &['\u7949']), ('\ufa4e', &['\u7948']), ('\ufa4f',
        &['\u7950']), ('\ufa50', &['\u7956']), ('\ufa51', &['\u795d']), ('\ufa52', &['\u798d']),
        ('\ufa53', &['\u798e']), ('\ufa54', &['\u7a40']), ('\ufa55', &['\u7a81']), ('\ufa56',
        &['\u7bc0']), ('\ufa57', &['\u7df4']), ('\ufa58', &['\u7e09']), ('\ufa59', &['\u7e41']),
        ('\ufa5a', &['\u7f72']), ('\ufa5b', &['\u8005']), ('\ufa5c', &['\u81ed']), ('\ufa5d',
        &['\u8279']), ('\ufa5e', &['\u8279']), ('\ufa5f', &['\u8457']), ('\ufa60', &['\u8910']),
        ('\ufa61', &['\u8996']), ('\ufa62', &['\u8b01']), ('\ufa63', &['\u8b39']), ('\ufa64',
        &['\u8cd3']), ('\ufa65', &['\u8d08']), ('\ufa66', &['\u8fb6']), ('\ufa67', &['\u9038']),
        ('\ufa68', &['\u96e3']), ('\ufa69', &['\u97ff']), ('\ufa6a', &['\u983b']), ('\ufa6b',
        &['\u6075']), ('\ufa6c', &['\U000242ee']), ('\ufa6d', &['\u8218']), ('\ufa70', &['\u4e26']),
        ('\ufa71', &['\u51b5']), ('\ufa72', &['\u5168']), ('\ufa73', &['\u4f80']), ('\ufa74',
        &['\u5145']), ('\ufa75', &['\u5180']), ('\ufa76', &['\u52c7']), ('\ufa77', &['\u52fa']),
        ('\ufa78', &['\u559d']), ('\ufa79', &['\u5555']), ('\ufa7a', &['\u5599']), ('\ufa7b',
        &['\u55e2']), ('\ufa7c', &['\u585a']), ('\ufa7d', &['\u58b3']), ('\ufa7e', &['\u5944']),
        ('\ufa7f', &['\u5954']), ('\ufa80', &['\u5a62']), ('\ufa81', &['\u5b28']), ('\ufa82',
        &['\u5ed2']), ('\ufa83', &['\u5ed9']), ('\ufa84', &['\u5f69']), ('\ufa85', &['\u5fad']),
        ('\ufa86', &['\u60d8']), ('\ufa87', &['\u614e']), ('\ufa88', &['\u6108']), ('\ufa89',
        &['\u618e']), ('\ufa8a', &['\u6160']), ('\ufa8b', &['\u61f2']), ('\ufa8c', &['\u6234']),
        ('\ufa8d', &['\u63c4']), ('\ufa8e', &['\u641c']), ('\ufa8f', &['\u6452']), ('\ufa90',
        &['\u6556']), ('\ufa91', &['\u6674']), ('\ufa92', &['\u6717']), ('\ufa93', &['\u671b']),
        ('\ufa94', &['\u6756']), ('\ufa95', &['\u6b79']), ('\ufa96', &['\u6bba']), ('\ufa97',
        &['\u6d41']), ('\ufa98', &['\u6edb']), ('\ufa99', &['\u6ecb']), ('\ufa9a', &['\u6f22']),
        ('\ufa9b', &['\u701e']), ('\ufa9c', &['\u716e']), ('\ufa9d', &['\u77a7']), ('\ufa9e',
        &['\u7235']), ('\ufa9f', &['\u72af']), ('\ufaa0', &['\u732a']), ('\ufaa1', &['\u7471']),
        ('\ufaa2', &['\u7506']), ('\ufaa3', &['\u753b']), ('\ufaa4', &['\u761d']), ('\ufaa5',
        &['\u761f']), ('\ufaa6', &['\u76ca']), ('\ufaa7', &['\u76db']), ('\ufaa8', &['\u76f4']),
        ('\ufaa9', &['\u774a']), ('\ufaaa', &['\u7740']), ('\ufaab', &['\u78cc']), ('\ufaac',
        &['\u7ab1']), ('\ufaad', &['\u7bc0']), ('\ufaae', &['\u7c7b']), ('\ufaaf', &['\u7d5b']),
        ('\ufab0', &['\u7df4']), ('\ufab1', &['\u7f3e']), ('\ufab2', &['\u8005']), ('\ufab3',
        &['\u8352']), ('\ufab4', &['\u83ef']), ('\ufab5', &['\u8779']), ('\ufab6', &['\u8941']),
        ('\ufab7', &['\u8986']), ('\ufab8', &['\u8996']), ('\ufab9', &['\u8abf']), ('\ufaba',
        &['\u8af8']), ('\ufabb', &['\u8acb']), ('\ufabc', &['\u8b01']), ('\ufabd', &['\u8afe']),
        ('\ufabe', &['\u8aed']), ('\ufabf', &['\u8b39']), ('\ufac0', &['\u8b8a']), ('\ufac1',
        &['\u8d08']), ('\ufac2', &['\u8f38']), ('\ufac3', &['\u9072']), ('\ufac4', &['\u9199']),
        ('\ufac5', &['\u9276']), ('\ufac6', &['\u967c']), ('\ufac7', &['\u96e3']), ('\ufac8',
        &['\u9756']), ('\ufac9', &['\u97db']), ('\ufaca', &['\u97ff']), ('\ufacb', &['\u980b']),
        ('\ufacc', &['\u983b']), ('\ufacd', &['\u9b12']), ('\uface', &['\u9f9c']), ('\ufacf',
        &['\U0002284a']), ('\ufad0', &['\U00022844']), ('\ufad1', &['\U000233d5']), ('\ufad2',
        &['\u3b9d']), ('\ufad3', &['\u4018']), ('\ufad4', &['\u4039']), ('\ufad5', &['\U00025249']),
        ('\ufad6', &['\U00025cd0']), ('\ufad7', &['\U00027ed3']), ('\ufad8', &['\u9f43']),
        ('\ufad9', &['\u9f8e']), ('\ufb1d', &['\u05d9', '\u05b4']), ('\ufb1f', &['\u05f2',
        '\u05b7']), ('\ufb2a', &['\u05e9', '\u05c1']), ('\ufb2b', &['\u05e9', '\u05c2']), ('\ufb2c',
        &['\ufb49', '\u05c1']), ('\ufb2d', &['\ufb49', '\u05c2']), ('\ufb2e', &['\u05d0',
        '\u05b7']), ('\ufb2f', &['\u05d0', '\u05b8']), ('\ufb30', &['\u05d0', '\u05bc']), ('\ufb31',
        &['\u05d1', '\u05bc']), ('\ufb32', &['\u05d2', '\u05bc']), ('\ufb33', &['\u05d3',
        '\u05bc']), ('\ufb34', &['\u05d4', '\u05bc']), ('\ufb35', &['\u05d5', '\u05bc']), ('\ufb36',
        &['\u05d6', '\u05bc']), ('\ufb38', &['\u05d8', '\u05bc']), ('\ufb39', &['\u05d9',
        '\u05bc']), ('\ufb3a', &['\u05da', '\u05bc']), ('\ufb3b', &['\u05db', '\u05bc']), ('\ufb3c',
        &['\u05dc', '\u05bc']), ('\ufb3e', &['\u05de', '\u05bc']), ('\ufb40', &['\u05e0',
        '\u05bc']), ('\ufb41', &['\u05e1', '\u05bc']), ('\ufb43', &['\u05e3', '\u05bc']), ('\ufb44',
        &['\u05e4', '\u05bc']), ('\ufb46', &['\u05e6', '\u05bc']), ('\ufb47', &['\u05e7',
        '\u05bc']), ('\ufb48', &['\u05e8', '\u05bc']), ('\ufb49', &['\u05e9', '\u05bc']), ('\ufb4a',
        &['\u05ea', '\u05bc']), ('\ufb4b', &['\u05d5', '\u05b9']), ('\ufb4c', &['\u05d1',
        '\u05bf']), ('\ufb4d', &['\u05db', '\u05bf']), ('\ufb4e', &['\u05e4', '\u05bf']),
        ('\U0001109a', &['\U00011099', '\U000110ba']), ('\U0001109c', &['\U0001109b',
        '\U000110ba']), ('\U000110ab', &['\U000110a5', '\U000110ba']), ('\U0001112e',
        &['\U00011131', '\U00011127']), ('\U0001112f', &['\U00011132', '\U00011127']),
        ('\U0001134b', &['\U00011347', '\U0001133e']), ('\U0001134c', &['\U00011347',
        '\U00011357']), ('\U000114bb', &['\U000114b9', '\U000114ba']), ('\U000114bc',
        &['\U000114b9', '\U000114b0']), ('\U000114be', &['\U000114b9', '\U000114bd']),
        ('\U000115ba', &['\U000115b8', '\U000115af']), ('\U000115bb', &['\U000115b9',
        '\U000115af']), ('\U0001d15e', &['\U0001d157', '\U0001d165']), ('\U0001d15f',
        &['\U0001d158', '\U0001d165']), ('\U0001d160', &['\U0001d15f', '\U0001d16e']),
        ('\U0001d161', &['\U0001d15f', '\U0001d16f']), ('\U0001d162', &['\U0001d15f',
        '\U0001d170']), ('\U0001d163', &['\U0001d15f', '\U0001d171']), ('\U0001d164',
        &['\U0001d15f', '\U0001d172']), ('\U0001d1bb', &['\U0001d1b9', '\U0001d165']),
        ('\U0001d1bc', &['\U0001d1ba', '\U0001d165']), ('\U0001d1bd', &['\U0001d1bb',
        '\U0001d16e']), ('\U0001d1be', &['\U0001d1bc', '\U0001d16e']), ('\U0001d1bf',
        &['\U0001d1bb', '\U0001d16f']), ('\U0001d1c0', &['\U0001d1bc', '\U0001d16f']),
        ('\U0002f800', &['\u4e3d']), ('\U0002f801', &['\u4e38']), ('\U0002f802', &['\u4e41']),
        ('\U0002f803', &['\U00020122']), ('\U0002f804', &['\u4f60']), ('\U0002f805', &['\u4fae']),
        ('\U0002f806', &['\u4fbb']), ('\U0002f807', &['\u5002']), ('\U0002f808', &['\u507a']),
        ('\U0002f809', &['\u5099']), ('\U0002f80a', &['\u50e7']), ('\U0002f80b', &['\u50cf']),
        ('\U0002f80c', &['\u349e']), ('\U0002f80d', &['\U0002063a']), ('\U0002f80e', &['\u514d']),
        ('\U0002f80f', &['\u5154']), ('\U0002f810', &['\u5164']), ('\U0002f811', &['\u5177']),
        ('\U0002f812', &['\U0002051c']), ('\U0002f813', &['\u34b9']), ('\U0002f814', &['\u5167']),
        ('\U0002f815', &['\u518d']), ('\U0002f816', &['\U0002054b']), ('\U0002f817', &['\u5197']),
        ('\U0002f818', &['\u51a4']), ('\U0002f819', &['\u4ecc']), ('\U0002f81a', &['\u51ac']),
        ('\U0002f81b', &['\u51b5']), ('\U0002f81c', &['\U000291df']), ('\U0002f81d', &['\u51f5']),
        ('\U0002f81e', &['\u5203']), ('\U0002f81f', &['\u34df']), ('\U0002f820', &['\u523b']),
        ('\U0002f821', &['\u5246']), ('\U0002f822', &['\u5272']), ('\U0002f823', &['\u5277']),
        ('\U0002f824', &['\u3515']), ('\U0002f825', &['\u52c7']), ('\U0002f826', &['\u52c9']),
        ('\U0002f827', &['\u52e4']), ('\U0002f828', &['\u52fa']), ('\U0002f829', &['\u5305']),
        ('\U0002f82a', &['\u5306']), ('\U0002f82b', &['\u5317']), ('\U0002f82c', &['\u5349']),
        ('\U0002f82d', &['\u5351']), ('\U0002f82e', &['\u535a']), ('\U0002f82f', &['\u5373']),
        ('\U0002f830', &['\u537d']), ('\U0002f831', &['\u537f']), ('\U0002f832', &['\u537f']),
        ('\U0002f833', &['\u537f']), ('\U0002f834', &['\U00020a2c']), ('\U0002f835', &['\u7070']),
        ('\U0002f836', &['\u53ca']), ('\U0002f837', &['\u53df']), ('\U0002f838', &['\U00020b63']),
        ('\U0002f839', &['\u53eb']), ('\U0002f83a', &['\u53f1']), ('\U0002f83b', &['\u5406']),
        ('\U0002f83c', &['\u549e']), ('\U0002f83d', &['\u5438']), ('\U0002f83e', &['\u5448']),
        ('\U0002f83f', &['\u5468']), ('\U0002f840', &['\u54a2']), ('\U0002f841', &['\u54f6']),
        ('\U0002f842', &['\u5510']), ('\U0002f843', &['\u5553']), ('\U0002f844', &['\u5563']),
        ('\U0002f845', &['\u5584']), ('\U0002f846', &['\u5584']), ('\U0002f847', &['\u5599']),
        ('\U0002f848', &['\u55ab']), ('\U0002f849', &['\u55b3']), ('\U0002f84a', &['\u55c2']),
        ('\U0002f84b', &['\u5716']), ('\U0002f84c', &['\u5606']), ('\U0002f84d', &['\u5717']),
        ('\U0002f84e', &['\u5651']), ('\U0002f84f', &['\u5674']), ('\U0002f850', &['\u5207']),
        ('\U0002f851', &['\u58ee']), ('\U0002f852', &['\u57ce']), ('\U0002f853', &['\u57f4']),
        ('\U0002f854', &['\u580d']), ('\U0002f855', &['\u578b']), ('\U0002f856', &['\u5832']),
        ('\U0002f857', &['\u5831']), ('\U0002f858', &['\u58ac']), ('\U0002f859', &['\U000214e4']),
        ('\U0002f85a', &['\u58f2']), ('\U0002f85b', &['\u58f7']), ('\U0002f85c', &['\u5906']),
        ('\U0002f85d', &['\u591a']), ('\U0002f85e', &['\u5922']), ('\U0002f85f', &['\u5962']),
        ('\U0002f860', &['\U000216a8']), ('\U0002f861', &['\U000216ea']), ('\U0002f862',
        &['\u59ec']), ('\U0002f863', &['\u5a1b']), ('\U0002f864', &['\u5a27']), ('\U0002f865',
        &['\u59d8']), ('\U0002f866', &['\u5a66']), ('\U0002f867', &['\u36ee']), ('\U0002f868',
        &['\u36fc']), ('\U0002f869', &['\u5b08']), ('\U0002f86a', &['\u5b3e']), ('\U0002f86b',
        &['\u5b3e']), ('\U0002f86c', &['\U000219c8']), ('\U0002f86d', &['\u5bc3']), ('\U0002f86e',
        &['\u5bd8']), ('\U0002f86f', &['\u5be7']), ('\U0002f870', &['\u5bf3']), ('\U0002f871',
        &['\U00021b18']), ('\U0002f872', &['\u5bff']), ('\U0002f873', &['\u5c06']), ('\U0002f874',
        &['\u5f53']), ('\U0002f875', &['\u5c22']), ('\U0002f876', &['\u3781']), ('\U0002f877',
        &['\u5c60']), ('\U0002f878', &['\u5c6e']), ('\U0002f879', &['\u5cc0']), ('\U0002f87a',
        &['\u5c8d']), ('\U0002f87b', &['\U00021de4']), ('\U0002f87c', &['\u5d43']), ('\U0002f87d',
        &['\U00021de6']), ('\U0002f87e', &['\u5d6e']), ('\U0002f87f', &['\u5d6b']), ('\U0002f880',
        &['\u5d7c']), ('\U0002f881', &['\u5de1']), ('\U0002f882', &['\u5de2']), ('\U0002f883',
        &['\u382f']), ('\U0002f884', &['\u5dfd']), ('\U0002f885', &['\u5e28']), ('\U0002f886',
        &['\u5e3d']), ('\U0002f887', &['\u5e69']), ('\U0002f888', &['\u3862']), ('\U0002f889',
        &['\U00022183']), ('\U0002f88a', &['\u387c']), ('\U0002f88b', &['\u5eb0']), ('\U0002f88c',
        &['\u5eb3']), ('\U0002f88d', &['\u5eb6']), ('\U0002f88e', &['\u5eca']), ('\U0002f88f',
        &['\U0002a392']), ('\U0002f890', &['\u5efe']), ('\U0002f891', &['\U00022331']),
        ('\U0002f892', &['\U00022331']), ('\U0002f893', &['\u8201']), ('\U0002f894', &['\u5f22']),
        ('\U0002f895', &['\u5f22']), ('\U0002f896', &['\u38c7']), ('\U0002f897', &['\U000232b8']),
        ('\U0002f898', &['\U000261da']), ('\U0002f899', &['\u5f62']), ('\U0002f89a', &['\u5f6b']),
        ('\U0002f89b', &['\u38e3']), ('\U0002f89c', &['\u5f9a']), ('\U0002f89d', &['\u5fcd']),
        ('\U0002f89e', &['\u5fd7']), ('\U0002f89f', &['\u5ff9']), ('\U0002f8a0', &['\u6081']),
        ('\U0002f8a1', &['\u393a']), ('\U0002f8a2', &['\u391c']), ('\U0002f8a3', &['\u6094']),
        ('\U0002f8a4', &['\U000226d4']), ('\U0002f8a5', &['\u60c7']), ('\U0002f8a6', &['\u6148']),
        ('\U0002f8a7', &['\u614c']), ('\U0002f8a8', &['\u614e']), ('\U0002f8a9', &['\u614c']),
        ('\U0002f8aa', &['\u617a']), ('\U0002f8ab', &['\u618e']), ('\U0002f8ac', &['\u61b2']),
        ('\U0002f8ad', &['\u61a4']), ('\U0002f8ae', &['\u61af']), ('\U0002f8af', &['\u61de']),
        ('\U0002f8b0', &['\u61f2']), ('\U0002f8b1', &['\u61f6']), ('\U0002f8b2', &['\u6210']),
        ('\U0002f8b3', &['\u621b']), ('\U0002f8b4', &['\u625d']), ('\U0002f8b5', &['\u62b1']),
        ('\U0002f8b6', &['\u62d4']), ('\U0002f8b7', &['\u6350']), ('\U0002f8b8', &['\U00022b0c']),
        ('\U0002f8b9', &['\u633d']), ('\U0002f8ba', &['\u62fc']), ('\U0002f8bb', &['\u6368']),
        ('\U0002f8bc', &['\u6383']), ('\U0002f8bd', &['\u63e4']), ('\U0002f8be', &['\U00022bf1']),
        ('\U0002f8bf', &['\u6422']), ('\U0002f8c0', &['\u63c5']), ('\U0002f8c1', &['\u63a9']),
        ('\U0002f8c2', &['\u3a2e']), ('\U0002f8c3', &['\u6469']), ('\U0002f8c4', &['\u647e']),
        ('\U0002f8c5', &['\u649d']), ('\U0002f8c6', &['\u6477']), ('\U0002f8c7', &['\u3a6c']),
        ('\U0002f8c8', &['\u654f']), ('\U0002f8c9', &['\u656c']), ('\U0002f8ca', &['\U0002300a']),
        ('\U0002f8cb', &['\u65e3']), ('\U0002f8cc', &['\u66f8']), ('\U0002f8cd', &['\u6649']),
        ('\U0002f8ce', &['\u3b19']), ('\U0002f8cf', &['\u6691']), ('\U0002f8d0', &['\u3b08']),
        ('\U0002f8d1', &['\u3ae4']), ('\U0002f8d2', &['\u5192']), ('\U0002f8d3', &['\u5195']),
        ('\U0002f8d4', &['\u6700']), ('\U0002f8d5', &['\u669c']), ('\U0002f8d6', &['\u80ad']),
        ('\U0002f8d7', &['\u43d9']), ('\U0002f8d8', &['\u6717']), ('\U0002f8d9', &['\u671b']),
        ('\U0002f8da', &['\u6721']), ('\U0002f8db', &['\u675e']), ('\U0002f8dc', &['\u6753']),
        ('\U0002f8dd', &['\U000233c3']), ('\U0002f8de', &['\u3b49']), ('\U0002f8df', &['\u67fa']),
        ('\U0002f8e0', &['\u6785']), ('\U0002f8e1', &['\u6852']), ('\U0002f8e2', &['\u6885']),
        ('\U0002f8e3', &['\U0002346d']), ('\U0002f8e4', &['\u688e']), ('\U0002f8e5', &['\u681f']),
        ('\U0002f8e6', &['\u6914']), ('\U0002f8e7', &['\u3b9d']), ('\U0002f8e8', &['\u6942']),
        ('\U0002f8e9', &['\u69a3']), ('\U0002f8ea', &['\u69ea']), ('\U0002f8eb', &['\u6aa8']),
        ('\U0002f8ec', &['\U000236a3']), ('\U0002f8ed', &['\u6adb']), ('\U0002f8ee', &['\u3c18']),
        ('\U0002f8ef', &['\u6b21']), ('\U0002f8f0', &['\U000238a7']), ('\U0002f8f1', &['\u6b54']),
        ('\U0002f8f2', &['\u3c4e']), ('\U0002f8f3', &['\u6b72']), ('\U0002f8f4', &['\u6b9f']),
        ('\U0002f8f5', &['\u6bba']), ('\U0002f8f6', &['\u6bbb']), ('\U0002f8f7', &['\U00023a8d']),
        ('\U0002f8f8', &['\U00021d0b']), ('\U0002f8f9', &['\U00023afa']), ('\U0002f8fa',
        &['\u6c4e']), ('\U0002f8fb', &['\U00023cbc']), ('\U0002f8fc', &['\u6cbf']), ('\U0002f8fd',
        &['\u6ccd']), ('\U0002f8fe', &['\u6c67']), ('\U0002f8ff', &['\u6d16']), ('\U0002f900',
        &['\u6d3e']), ('\U0002f901', &['\u6d77']), ('\U0002f902', &['\u6d41']), ('\U0002f903',
        &['\u6d69']), ('\U0002f904', &['\u6d78']), ('\U0002f905', &['\u6d85']), ('\U0002f906',
        &['\U00023d1e']), ('\U0002f907', &['\u6d34']), ('\U0002f908', &['\u6e2f']), ('\U0002f909',
        &['\u6e6e']), ('\U0002f90a', &['\u3d33']), ('\U0002f90b', &['\u6ecb']), ('\U0002f90c',
        &['\u6ec7']), ('\U0002f90d', &['\U00023ed1']), ('\U0002f90e', &['\u6df9']), ('\U0002f90f',
        &['\u6f6e']), ('\U0002f910', &['\U00023f5e']), ('\U0002f911', &['\U00023f8e']),
        ('\U0002f912', &['\u6fc6']), ('\U0002f913', &['\u7039']), ('\U0002f914', &['\u701e']),
        ('\U0002f915', &['\u701b']), ('\U0002f916', &['\u3d96']), ('\U0002f917', &['\u704a']),
        ('\U0002f918', &['\u707d']), ('\U0002f919', &['\u7077']), ('\U0002f91a', &['\u70ad']),
        ('\U0002f91b', &['\U00020525']), ('\U0002f91c', &['\u7145']), ('\U0002f91d',
        &['\U00024263']), ('\U0002f91e', &['\u719c']), ('\U0002f91f', &['\U000243ab']),
        ('\U0002f920', &['\u7228']), ('\U0002f921', &['\u7235']), ('\U0002f922', &['\u7250']),
        ('\U0002f923', &['\U00024608']), ('\U0002f924', &['\u7280']), ('\U0002f925', &['\u7295']),
        ('\U0002f926', &['\U00024735']), ('\U0002f927', &['\U00024814']), ('\U0002f928',
        &['\u737a']), ('\U0002f929', &['\u738b']), ('\U0002f92a', &['\u3eac']), ('\U0002f92b',
        &['\u73a5']), ('\U0002f92c', &['\u3eb8']), ('\U0002f92d', &['\u3eb8']), ('\U0002f92e',
        &['\u7447']), ('\U0002f92f', &['\u745c']), ('\U0002f930', &['\u7471']), ('\U0002f931',
        &['\u7485']), ('\U0002f932', &['\u74ca']), ('\U0002f933', &['\u3f1b']), ('\U0002f934',
        &['\u7524']), ('\U0002f935', &['\U00024c36']), ('\U0002f936', &['\u753e']), ('\U0002f937',
        &['\U00024c92']), ('\U0002f938', &['\u7570']), ('\U0002f939', &['\U0002219f']),
        ('\U0002f93a', &['\u7610']), ('\U0002f93b', &['\U00024fa1']), ('\U0002f93c',
        &['\U00024fb8']), ('\U0002f93d', &['\U00025044']), ('\U0002f93e', &['\u3ffc']),
        ('\U0002f93f', &['\u4008']), ('\U0002f940', &['\u76f4']), ('\U0002f941', &['\U000250f3']),
        ('\U0002f942', &['\U000250f2']), ('\U0002f943', &['\U00025119']), ('\U0002f944',
        &['\U00025133']), ('\U0002f945', &['\u771e']), ('\U0002f946', &['\u771f']), ('\U0002f947',
        &['\u771f']), ('\U0002f948', &['\u774a']), ('\U0002f949', &['\u4039']), ('\U0002f94a',
        &['\u778b']), ('\U0002f94b', &['\u4046']), ('\U0002f94c', &['\u4096']), ('\U0002f94d',
        &['\U0002541d']), ('\U0002f94e', &['\u784e']), ('\U0002f94f', &['\u788c']), ('\U0002f950',
        &['\u78cc']), ('\U0002f951', &['\u40e3']), ('\U0002f952', &['\U00025626']), ('\U0002f953',
        &['\u7956']), ('\U0002f954', &['\U0002569a']), ('\U0002f955', &['\U000256c5']),
        ('\U0002f956', &['\u798f']), ('\U0002f957', &['\u79eb']), ('\U0002f958', &['\u412f']),
        ('\U0002f959', &['\u7a40']), ('\U0002f95a', &['\u7a4a']), ('\U0002f95b', &['\u7a4f']),
        ('\U0002f95c', &['\U0002597c']), ('\U0002f95d', &['\U00025aa7']), ('\U0002f95e',
        &['\U00025aa7']), ('\U0002f95f', &['\u7aee']), ('\U0002f960', &['\u4202']), ('\U0002f961',
        &['\U00025bab']), ('\U0002f962', &['\u7bc6']), ('\U0002f963', &['\u7bc9']), ('\U0002f964',
        &['\u4227']), ('\U0002f965', &['\U00025c80']), ('\U0002f966', &['\u7cd2']), ('\U0002f967',
        &['\u42a0']), ('\U0002f968', &['\u7ce8']), ('\U0002f969', &['\u7ce3']), ('\U0002f96a',
        &['\u7d00']), ('\U0002f96b', &['\U00025f86']), ('\U0002f96c', &['\u7d63']), ('\U0002f96d',
        &['\u4301']), ('\U0002f96e', &['\u7dc7']), ('\U0002f96f', &['\u7e02']), ('\U0002f970',
        &['\u7e45']), ('\U0002f971', &['\u4334']), ('\U0002f972', &['\U00026228']), ('\U0002f973',
        &['\U00026247']), ('\U0002f974', &['\u4359']), ('\U0002f975', &['\U000262d9']),
        ('\U0002f976', &['\u7f7a']), ('\U0002f977', &['\U0002633e']), ('\U0002f978', &['\u7f95']),
        ('\U0002f979', &['\u7ffa']), ('\U0002f97a', &['\u8005']), ('\U0002f97b', &['\U000264da']),
        ('\U0002f97c', &['\U00026523']), ('\U0002f97d', &['\u8060']), ('\U0002f97e',
        &['\U000265a8']), ('\U0002f97f', &['\u8070']), ('\U0002f980', &['\U0002335f']),
        ('\U0002f981', &['\u43d5']), ('\U0002f982', &['\u80b2']), ('\U0002f983', &['\u8103']),
        ('\U0002f984', &['\u440b']), ('\U0002f985', &['\u813e']), ('\U0002f986', &['\u5ab5']),
        ('\U0002f987', &['\U000267a7']), ('\U0002f988', &['\U000267b5']), ('\U0002f989',
        &['\U00023393']), ('\U0002f98a', &['\U0002339c']), ('\U0002f98b', &['\u8201']),
        ('\U0002f98c', &['\u8204']), ('\U0002f98d', &['\u8f9e']), ('\U0002f98e', &['\u446b']),
        ('\U0002f98f', &['\u8291']), ('\U0002f990', &['\u828b']), ('\U0002f991', &['\u829d']),
        ('\U0002f992', &['\u52b3']), ('\U0002f993', &['\u82b1']), ('\U0002f994', &['\u82b3']),
        ('\U0002f995', &['\u82bd']), ('\U0002f996', &['\u82e6']), ('\U0002f997', &['\U00026b3c']),
        ('\U0002f998', &['\u82e5']), ('\U0002f999', &['\u831d']), ('\U0002f99a', &['\u8363']),
        ('\U0002f99b', &['\u83ad']), ('\U0002f99c', &['\u8323']), ('\U0002f99d', &['\u83bd']),
        ('\U0002f99e', &['\u83e7']), ('\U0002f99f', &['\u8457']), ('\U0002f9a0', &['\u8353']),
        ('\U0002f9a1', &['\u83ca']), ('\U0002f9a2', &['\u83cc']), ('\U0002f9a3', &['\u83dc']),
        ('\U0002f9a4', &['\U00026c36']), ('\U0002f9a5', &['\U00026d6b']), ('\U0002f9a6',
        &['\U00026cd5']), ('\U0002f9a7', &['\u452b']), ('\U0002f9a8', &['\u84f1']), ('\U0002f9a9',
        &['\u84f3']), ('\U0002f9aa', &['\u8516']), ('\U0002f9ab', &['\U000273ca']), ('\U0002f9ac',
        &['\u8564']), ('\U0002f9ad', &['\U00026f2c']), ('\U0002f9ae', &['\u455d']), ('\U0002f9af',
        &['\u4561']), ('\U0002f9b0', &['\U00026fb1']), ('\U0002f9b1', &['\U000270d2']),
        ('\U0002f9b2', &['\u456b']), ('\U0002f9b3', &['\u8650']), ('\U0002f9b4', &['\u865c']),
        ('\U0002f9b5', &['\u8667']), ('\U0002f9b6', &['\u8669']), ('\U0002f9b7', &['\u86a9']),
        ('\U0002f9b8', &['\u8688']), ('\U0002f9b9', &['\u870e']), ('\U0002f9ba', &['\u86e2']),
        ('\U0002f9bb', &['\u8779']), ('\U0002f9bc', &['\u8728']), ('\U0002f9bd', &['\u876b']),
        ('\U0002f9be', &['\u8786']), ('\U0002f9bf', &['\u45d7']), ('\U0002f9c0', &['\u87e1']),
        ('\U0002f9c1', &['\u8801']), ('\U0002f9c2', &['\u45f9']), ('\U0002f9c3', &['\u8860']),
        ('\U0002f9c4', &['\u8863']), ('\U0002f9c5', &['\U00027667']), ('\U0002f9c6', &['\u88d7']),
        ('\U0002f9c7', &['\u88de']), ('\U0002f9c8', &['\u4635']), ('\U0002f9c9', &['\u88fa']),
        ('\U0002f9ca', &['\u34bb']), ('\U0002f9cb', &['\U000278ae']), ('\U0002f9cc',
        &['\U00027966']), ('\U0002f9cd', &['\u46be']), ('\U0002f9ce', &['\u46c7']), ('\U0002f9cf',
        &['\u8aa0']), ('\U0002f9d0', &['\u8aed']), ('\U0002f9d1', &['\u8b8a']), ('\U0002f9d2',
        &['\u8c55']), ('\U0002f9d3', &['\U00027ca8']), ('\U0002f9d4', &['\u8cab']), ('\U0002f9d5',
        &['\u8cc1']), ('\U0002f9d6', &['\u8d1b']), ('\U0002f9d7', &['\u8d77']), ('\U0002f9d8',
        &['\U00027f2f']), ('\U0002f9d9', &['\U00020804']), ('\U0002f9da', &['\u8dcb']),
        ('\U0002f9db', &['\u8dbc']), ('\U0002f9dc', &['\u8df0']), ('\U0002f9dd', &['\U000208de']),
        ('\U0002f9de', &['\u8ed4']), ('\U0002f9df', &['\u8f38']), ('\U0002f9e0', &['\U000285d2']),
        ('\U0002f9e1', &['\U000285ed']), ('\U0002f9e2', &['\u9094']), ('\U0002f9e3', &['\u90f1']),
        ('\U0002f9e4', &['\u9111']), ('\U0002f9e5', &['\U0002872e']), ('\U0002f9e6', &['\u911b']),
        ('\U0002f9e7', &['\u9238']), ('\U0002f9e8', &['\u92d7']), ('\U0002f9e9', &['\u92d8']),
        ('\U0002f9ea', &['\u927c']), ('\U0002f9eb', &['\u93f9']), ('\U0002f9ec', &['\u9415']),
        ('\U0002f9ed', &['\U00028bfa']), ('\U0002f9ee', &['\u958b']), ('\U0002f9ef', &['\u4995']),
        ('\U0002f9f0', &['\u95b7']), ('\U0002f9f1', &['\U00028d77']), ('\U0002f9f2', &['\u49e6']),
        ('\U0002f9f3', &['\u96c3']), ('\U0002f9f4', &['\u5db2']), ('\U0002f9f5', &['\u9723']),
        ('\U0002f9f6', &['\U00029145']), ('\U0002f9f7', &['\U0002921a']), ('\U0002f9f8',
        &['\u4a6e']), ('\U0002f9f9', &['\u4a76']), ('\U0002f9fa', &['\u97e0']), ('\U0002f9fb',
        &['\U0002940a']), ('\U0002f9fc', &['\u4ab2']), ('\U0002f9fd', &['\U00029496']),
        ('\U0002f9fe', &['\u980b']), ('\U0002f9ff', &['\u980b']), ('\U0002fa00', &['\u9829']),
        ('\U0002fa01', &['\U000295b6']), ('\U0002fa02', &['\u98e2']), ('\U0002fa03', &['\u4b33']),
        ('\U0002fa04', &['\u9929']), ('\U0002fa05', &['\u99a7']), ('\U0002fa06', &['\u99c2']),
        ('\U0002fa07', &['\u99fe']), ('\U0002fa08', &['\u4bce']), ('\U0002fa09', &['\U00029b30']),
        ('\U0002fa0a', &['\u9b12']), ('\U0002fa0b', &['\u9c40']), ('\U0002fa0c', &['\u9cfd']),
        ('\U0002fa0d', &['\u4cce']), ('\U0002fa0e', &['\u4ced']), ('\U0002fa0f', &['\u9d67']),
        ('\U0002fa10', &['\U0002a0ce']), ('\U0002fa11', &['\u4cf8']), ('\U0002fa12',
        &['\U0002a105']), ('\U0002fa13', &['\U0002a20e']), ('\U0002fa14', &['\U0002a291']),
        ('\U0002fa15', &['\u9ebb']), ('\U0002fa16', &['\u4d56']), ('\U0002fa17', &['\u9ef9']),
        ('\U0002fa18', &['\u9efe']), ('\U0002fa19', &['\u9f05']), ('\U0002fa1a', &['\u9f0f']),
        ('\U0002fa1b', &['\u9f16']), ('\U0002fa1c', &['\u9f3b']), ('\U0002fa1d', &['\U0002a600'])
    ];

    // Compatibility decompositions
    pub static compatibility_table: &'static [(char, &'static [char])] = &[
        ('\u00a0', &['\x20']), ('\u00a8', &['\x20', '\u0308']), ('\u00aa', &['\x61']), ('\u00af',
        &['\x20', '\u0304']), ('\u00b2', &['\x32']), ('\u00b3', &['\x33']), ('\u00b4', &['\x20',
        '\u0301']), ('\u00b5', &['\u03bc']), ('\u00b8', &['\x20', '\u0327']), ('\u00b9', &['\x31']),
        ('\u00ba', &['\x6f']), ('\u00bc', &['\x31', '\u2044', '\x34']), ('\u00bd', &['\x31',
        '\u2044', '\x32']), ('\u00be', &['\x33', '\u2044', '\x34']), ('\u0132', &['\x49', '\x4a']),
        ('\u0133', &['\x69', '\x6a']), ('\u013f', &['\x4c', '\u00b7']), ('\u0140', &['\x6c',
        '\u00b7']), ('\u0149', &['\u02bc', '\x6e']), ('\u017f', &['\x73']), ('\u01c4', &['\x44',
        '\u017d']), ('\u01c5', &['\x44', '\u017e']), ('\u01c6', &['\x64', '\u017e']), ('\u01c7',
        &['\x4c', '\x4a']), ('\u01c8', &['\x4c', '\x6a']), ('\u01c9', &['\x6c', '\x6a']), ('\u01ca',
        &['\x4e', '\x4a']), ('\u01cb', &['\x4e', '\x6a']), ('\u01cc', &['\x6e', '\x6a']), ('\u01f1',
        &['\x44', '\x5a']), ('\u01f2', &['\x44', '\x7a']), ('\u01f3', &['\x64', '\x7a']), ('\u02b0',
        &['\x68']), ('\u02b1', &['\u0266']), ('\u02b2', &['\x6a']), ('\u02b3', &['\x72']),
        ('\u02b4', &['\u0279']), ('\u02b5', &['\u027b']), ('\u02b6', &['\u0281']), ('\u02b7',
        &['\x77']), ('\u02b8', &['\x79']), ('\u02d8', &['\x20', '\u0306']), ('\u02d9', &['\x20',
        '\u0307']), ('\u02da', &['\x20', '\u030a']), ('\u02db', &['\x20', '\u0328']), ('\u02dc',
        &['\x20', '\u0303']), ('\u02dd', &['\x20', '\u030b']), ('\u02e0', &['\u0263']), ('\u02e1',
        &['\x6c']), ('\u02e2', &['\x73']), ('\u02e3', &['\x78']), ('\u02e4', &['\u0295']),
        ('\u037a', &['\x20', '\u0345']), ('\u0384', &['\x20', '\u0301']), ('\u03d0', &['\u03b2']),
        ('\u03d1', &['\u03b8']), ('\u03d2', &['\u03a5']), ('\u03d5', &['\u03c6']), ('\u03d6',
        &['\u03c0']), ('\u03f0', &['\u03ba']), ('\u03f1', &['\u03c1']), ('\u03f2', &['\u03c2']),
        ('\u03f4', &['\u0398']), ('\u03f5', &['\u03b5']), ('\u03f9', &['\u03a3']), ('\u0587',
        &['\u0565', '\u0582']), ('\u0675', &['\u0627', '\u0674']), ('\u0676', &['\u0648',
        '\u0674']), ('\u0677', &['\u06c7', '\u0674']), ('\u0678', &['\u064a', '\u0674']), ('\u0e33',
        &['\u0e4d', '\u0e32']), ('\u0eb3', &['\u0ecd', '\u0eb2']), ('\u0edc', &['\u0eab',
        '\u0e99']), ('\u0edd', &['\u0eab', '\u0ea1']), ('\u0f0c', &['\u0f0b']), ('\u0f77',
        &['\u0fb2', '\u0f81']), ('\u0f79', &['\u0fb3', '\u0f81']), ('\u10fc', &['\u10dc']),
        ('\u1d2c', &['\x41']), ('\u1d2d', &['\u00c6']), ('\u1d2e', &['\x42']), ('\u1d30',
        &['\x44']), ('\u1d31', &['\x45']), ('\u1d32', &['\u018e']), ('\u1d33', &['\x47']),
        ('\u1d34', &['\x48']), ('\u1d35', &['\x49']), ('\u1d36', &['\x4a']), ('\u1d37', &['\x4b']),
        ('\u1d38', &['\x4c']), ('\u1d39', &['\x4d']), ('\u1d3a', &['\x4e']), ('\u1d3c', &['\x4f']),
        ('\u1d3d', &['\u0222']), ('\u1d3e', &['\x50']), ('\u1d3f', &['\x52']), ('\u1d40',
        &['\x54']), ('\u1d41', &['\x55']), ('\u1d42', &['\x57']), ('\u1d43', &['\x61']), ('\u1d44',
        &['\u0250']), ('\u1d45', &['\u0251']), ('\u1d46', &['\u1d02']), ('\u1d47', &['\x62']),
        ('\u1d48', &['\x64']), ('\u1d49', &['\x65']), ('\u1d4a', &['\u0259']), ('\u1d4b',
        &['\u025b']), ('\u1d4c', &['\u025c']), ('\u1d4d', &['\x67']), ('\u1d4f', &['\x6b']),
        ('\u1d50', &['\x6d']), ('\u1d51', &['\u014b']), ('\u1d52', &['\x6f']), ('\u1d53',
        &['\u0254']), ('\u1d54', &['\u1d16']), ('\u1d55', &['\u1d17']), ('\u1d56', &['\x70']),
        ('\u1d57', &['\x74']), ('\u1d58', &['\x75']), ('\u1d59', &['\u1d1d']), ('\u1d5a',
        &['\u026f']), ('\u1d5b', &['\x76']), ('\u1d5c', &['\u1d25']), ('\u1d5d', &['\u03b2']),
        ('\u1d5e', &['\u03b3']), ('\u1d5f', &['\u03b4']), ('\u1d60', &['\u03c6']), ('\u1d61',
        &['\u03c7']), ('\u1d62', &['\x69']), ('\u1d63', &['\x72']), ('\u1d64', &['\x75']),
        ('\u1d65', &['\x76']), ('\u1d66', &['\u03b2']), ('\u1d67', &['\u03b3']), ('\u1d68',
        &['\u03c1']), ('\u1d69', &['\u03c6']), ('\u1d6a', &['\u03c7']), ('\u1d78', &['\u043d']),
        ('\u1d9b', &['\u0252']), ('\u1d9c', &['\x63']), ('\u1d9d', &['\u0255']), ('\u1d9e',
        &['\u00f0']), ('\u1d9f', &['\u025c']), ('\u1da0', &['\x66']), ('\u1da1', &['\u025f']),
        ('\u1da2', &['\u0261']), ('\u1da3', &['\u0265']), ('\u1da4', &['\u0268']), ('\u1da5',
        &['\u0269']), ('\u1da6', &['\u026a']), ('\u1da7', &['\u1d7b']), ('\u1da8', &['\u029d']),
        ('\u1da9', &['\u026d']), ('\u1daa', &['\u1d85']), ('\u1dab', &['\u029f']), ('\u1dac',
        &['\u0271']), ('\u1dad', &['\u0270']), ('\u1dae', &['\u0272']), ('\u1daf', &['\u0273']),
        ('\u1db0', &['\u0274']), ('\u1db1', &['\u0275']), ('\u1db2', &['\u0278']), ('\u1db3',
        &['\u0282']), ('\u1db4', &['\u0283']), ('\u1db5', &['\u01ab']), ('\u1db6', &['\u0289']),
        ('\u1db7', &['\u028a']), ('\u1db8', &['\u1d1c']), ('\u1db9', &['\u028b']), ('\u1dba',
        &['\u028c']), ('\u1dbb', &['\x7a']), ('\u1dbc', &['\u0290']), ('\u1dbd', &['\u0291']),
        ('\u1dbe', &['\u0292']), ('\u1dbf', &['\u03b8']), ('\u1e9a', &['\x61', '\u02be']),
        ('\u1fbd', &['\x20', '\u0313']), ('\u1fbf', &['\x20', '\u0313']), ('\u1fc0', &['\x20',
        '\u0342']), ('\u1ffe', &['\x20', '\u0314']), ('\u2002', &['\x20']), ('\u2003', &['\x20']),
        ('\u2004', &['\x20']), ('\u2005', &['\x20']), ('\u2006', &['\x20']), ('\u2007', &['\x20']),
        ('\u2008', &['\x20']), ('\u2009', &['\x20']), ('\u200a', &['\x20']), ('\u2011',
        &['\u2010']), ('\u2017', &['\x20', '\u0333']), ('\u2024', &['\x2e']), ('\u2025', &['\x2e',
        '\x2e']), ('\u2026', &['\x2e', '\x2e', '\x2e']), ('\u202f', &['\x20']), ('\u2033',
        &['\u2032', '\u2032']), ('\u2034', &['\u2032', '\u2032', '\u2032']), ('\u2036', &['\u2035',
        '\u2035']), ('\u2037', &['\u2035', '\u2035', '\u2035']), ('\u203c', &['\x21', '\x21']),
        ('\u203e', &['\x20', '\u0305']), ('\u2047', &['\x3f', '\x3f']), ('\u2048', &['\x3f',
        '\x21']), ('\u2049', &['\x21', '\x3f']), ('\u2057', &['\u2032', '\u2032', '\u2032',
        '\u2032']), ('\u205f', &['\x20']), ('\u2070', &['\x30']), ('\u2071', &['\x69']), ('\u2074',
        &['\x34']), ('\u2075', &['\x35']), ('\u2076', &['\x36']), ('\u2077', &['\x37']), ('\u2078',
        &['\x38']), ('\u2079', &['\x39']), ('\u207a', &['\x2b']), ('\u207b', &['\u2212']),
        ('\u207c', &['\x3d']), ('\u207d', &['\x28']), ('\u207e', &['\x29']), ('\u207f', &['\x6e']),
        ('\u2080', &['\x30']), ('\u2081', &['\x31']), ('\u2082', &['\x32']), ('\u2083', &['\x33']),
        ('\u2084', &['\x34']), ('\u2085', &['\x35']), ('\u2086', &['\x36']), ('\u2087', &['\x37']),
        ('\u2088', &['\x38']), ('\u2089', &['\x39']), ('\u208a', &['\x2b']), ('\u208b',
        &['\u2212']), ('\u208c', &['\x3d']), ('\u208d', &['\x28']), ('\u208e', &['\x29']),
        ('\u2090', &['\x61']), ('\u2091', &['\x65']), ('\u2092', &['\x6f']), ('\u2093', &['\x78']),
        ('\u2094', &['\u0259']), ('\u2095', &['\x68']), ('\u2096', &['\x6b']), ('\u2097',
        &['\x6c']), ('\u2098', &['\x6d']), ('\u2099', &['\x6e']), ('\u209a', &['\x70']), ('\u209b',
        &['\x73']), ('\u209c', &['\x74']), ('\u20a8', &['\x52', '\x73']), ('\u2100', &['\x61',
        '\x2f', '\x63']), ('\u2101', &['\x61', '\x2f', '\x73']), ('\u2102', &['\x43']), ('\u2103',
        &['\u00b0', '\x43']), ('\u2105', &['\x63', '\x2f', '\x6f']), ('\u2106', &['\x63', '\x2f',
        '\x75']), ('\u2107', &['\u0190']), ('\u2109', &['\u00b0', '\x46']), ('\u210a', &['\x67']),
        ('\u210b', &['\x48']), ('\u210c', &['\x48']), ('\u210d', &['\x48']), ('\u210e', &['\x68']),
        ('\u210f', &['\u0127']), ('\u2110', &['\x49']), ('\u2111', &['\x49']), ('\u2112',
        &['\x4c']), ('\u2113', &['\x6c']), ('\u2115', &['\x4e']), ('\u2116', &['\x4e', '\x6f']),
        ('\u2119', &['\x50']), ('\u211a', &['\x51']), ('\u211b', &['\x52']), ('\u211c', &['\x52']),
        ('\u211d', &['\x52']), ('\u2120', &['\x53', '\x4d']), ('\u2121', &['\x54', '\x45', '\x4c']),
        ('\u2122', &['\x54', '\x4d']), ('\u2124', &['\x5a']), ('\u2128', &['\x5a']), ('\u212c',
        &['\x42']), ('\u212d', &['\x43']), ('\u212f', &['\x65']), ('\u2130', &['\x45']), ('\u2131',
        &['\x46']), ('\u2133', &['\x4d']), ('\u2134', &['\x6f']), ('\u2135', &['\u05d0']),
        ('\u2136', &['\u05d1']), ('\u2137', &['\u05d2']), ('\u2138', &['\u05d3']), ('\u2139',
        &['\x69']), ('\u213b', &['\x46', '\x41', '\x58']), ('\u213c', &['\u03c0']), ('\u213d',
        &['\u03b3']), ('\u213e', &['\u0393']), ('\u213f', &['\u03a0']), ('\u2140', &['\u2211']),
        ('\u2145', &['\x44']), ('\u2146', &['\x64']), ('\u2147', &['\x65']), ('\u2148', &['\x69']),
        ('\u2149', &['\x6a']), ('\u2150', &['\x31', '\u2044', '\x37']), ('\u2151', &['\x31',
        '\u2044', '\x39']), ('\u2152', &['\x31', '\u2044', '\x31', '\x30']), ('\u2153', &['\x31',
        '\u2044', '\x33']), ('\u2154', &['\x32', '\u2044', '\x33']), ('\u2155', &['\x31', '\u2044',
        '\x35']), ('\u2156', &['\x32', '\u2044', '\x35']), ('\u2157', &['\x33', '\u2044', '\x35']),
        ('\u2158', &['\x34', '\u2044', '\x35']), ('\u2159', &['\x31', '\u2044', '\x36']), ('\u215a',
        &['\x35', '\u2044', '\x36']), ('\u215b', &['\x31', '\u2044', '\x38']), ('\u215c', &['\x33',
        '\u2044', '\x38']), ('\u215d', &['\x35', '\u2044', '\x38']), ('\u215e', &['\x37', '\u2044',
        '\x38']), ('\u215f', &['\x31', '\u2044']), ('\u2160', &['\x49']), ('\u2161', &['\x49',
        '\x49']), ('\u2162', &['\x49', '\x49', '\x49']), ('\u2163', &['\x49', '\x56']), ('\u2164',
        &['\x56']), ('\u2165', &['\x56', '\x49']), ('\u2166', &['\x56', '\x49', '\x49']), ('\u2167',
        &['\x56', '\x49', '\x49', '\x49']), ('\u2168', &['\x49', '\x58']), ('\u2169', &['\x58']),
        ('\u216a', &['\x58', '\x49']), ('\u216b', &['\x58', '\x49', '\x49']), ('\u216c', &['\x4c']),
        ('\u216d', &['\x43']), ('\u216e', &['\x44']), ('\u216f', &['\x4d']), ('\u2170', &['\x69']),
        ('\u2171', &['\x69', '\x69']), ('\u2172', &['\x69', '\x69', '\x69']), ('\u2173', &['\x69',
        '\x76']), ('\u2174', &['\x76']), ('\u2175', &['\x76', '\x69']), ('\u2176', &['\x76', '\x69',
        '\x69']), ('\u2177', &['\x76', '\x69', '\x69', '\x69']), ('\u2178', &['\x69', '\x78']),
        ('\u2179', &['\x78']), ('\u217a', &['\x78', '\x69']), ('\u217b', &['\x78', '\x69', '\x69']),
        ('\u217c', &['\x6c']), ('\u217d', &['\x63']), ('\u217e', &['\x64']), ('\u217f', &['\x6d']),
        ('\u2189', &['\x30', '\u2044', '\x33']), ('\u222c', &['\u222b', '\u222b']), ('\u222d',
        &['\u222b', '\u222b', '\u222b']), ('\u222f', &['\u222e', '\u222e']), ('\u2230', &['\u222e',
        '\u222e', '\u222e']), ('\u2460', &['\x31']), ('\u2461', &['\x32']), ('\u2462', &['\x33']),
        ('\u2463', &['\x34']), ('\u2464', &['\x35']), ('\u2465', &['\x36']), ('\u2466', &['\x37']),
        ('\u2467', &['\x38']), ('\u2468', &['\x39']), ('\u2469', &['\x31', '\x30']), ('\u246a',
        &['\x31', '\x31']), ('\u246b', &['\x31', '\x32']), ('\u246c', &['\x31', '\x33']), ('\u246d',
        &['\x31', '\x34']), ('\u246e', &['\x31', '\x35']), ('\u246f', &['\x31', '\x36']), ('\u2470',
        &['\x31', '\x37']), ('\u2471', &['\x31', '\x38']), ('\u2472', &['\x31', '\x39']), ('\u2473',
        &['\x32', '\x30']), ('\u2474', &['\x28', '\x31', '\x29']), ('\u2475', &['\x28', '\x32',
        '\x29']), ('\u2476', &['\x28', '\x33', '\x29']), ('\u2477', &['\x28', '\x34', '\x29']),
        ('\u2478', &['\x28', '\x35', '\x29']), ('\u2479', &['\x28', '\x36', '\x29']), ('\u247a',
        &['\x28', '\x37', '\x29']), ('\u247b', &['\x28', '\x38', '\x29']), ('\u247c', &['\x28',
        '\x39', '\x29']), ('\u247d', &['\x28', '\x31', '\x30', '\x29']), ('\u247e', &['\x28',
        '\x31', '\x31', '\x29']), ('\u247f', &['\x28', '\x31', '\x32', '\x29']), ('\u2480',
        &['\x28', '\x31', '\x33', '\x29']), ('\u2481', &['\x28', '\x31', '\x34', '\x29']),
        ('\u2482', &['\x28', '\x31', '\x35', '\x29']), ('\u2483', &['\x28', '\x31', '\x36',
        '\x29']), ('\u2484', &['\x28', '\x31', '\x37', '\x29']), ('\u2485', &['\x28', '\x31',
        '\x38', '\x29']), ('\u2486', &['\x28', '\x31', '\x39', '\x29']), ('\u2487', &['\x28',
        '\x32', '\x30', '\x29']), ('\u2488', &['\x31', '\x2e']), ('\u2489', &['\x32', '\x2e']),
        ('\u248a', &['\x33', '\x2e']), ('\u248b', &['\x34', '\x2e']), ('\u248c', &['\x35', '\x2e']),
        ('\u248d', &['\x36', '\x2e']), ('\u248e', &['\x37', '\x2e']), ('\u248f', &['\x38', '\x2e']),
        ('\u2490', &['\x39', '\x2e']), ('\u2491', &['\x31', '\x30', '\x2e']), ('\u2492', &['\x31',
        '\x31', '\x2e']), ('\u2493', &['\x31', '\x32', '\x2e']), ('\u2494', &['\x31', '\x33',
        '\x2e']), ('\u2495', &['\x31', '\x34', '\x2e']), ('\u2496', &['\x31', '\x35', '\x2e']),
        ('\u2497', &['\x31', '\x36', '\x2e']), ('\u2498', &['\x31', '\x37', '\x2e']), ('\u2499',
        &['\x31', '\x38', '\x2e']), ('\u249a', &['\x31', '\x39', '\x2e']), ('\u249b', &['\x32',
        '\x30', '\x2e']), ('\u249c', &['\x28', '\x61', '\x29']), ('\u249d', &['\x28', '\x62',
        '\x29']), ('\u249e', &['\x28', '\x63', '\x29']), ('\u249f', &['\x28', '\x64', '\x29']),
        ('\u24a0', &['\x28', '\x65', '\x29']), ('\u24a1', &['\x28', '\x66', '\x29']), ('\u24a2',
        &['\x28', '\x67', '\x29']), ('\u24a3', &['\x28', '\x68', '\x29']), ('\u24a4', &['\x28',
        '\x69', '\x29']), ('\u24a5', &['\x28', '\x6a', '\x29']), ('\u24a6', &['\x28', '\x6b',
        '\x29']), ('\u24a7', &['\x28', '\x6c', '\x29']), ('\u24a8', &['\x28', '\x6d', '\x29']),
        ('\u24a9', &['\x28', '\x6e', '\x29']), ('\u24aa', &['\x28', '\x6f', '\x29']), ('\u24ab',
        &['\x28', '\x70', '\x29']), ('\u24ac', &['\x28', '\x71', '\x29']), ('\u24ad', &['\x28',
        '\x72', '\x29']), ('\u24ae', &['\x28', '\x73', '\x29']), ('\u24af', &['\x28', '\x74',
        '\x29']), ('\u24b0', &['\x28', '\x75', '\x29']), ('\u24b1', &['\x28', '\x76', '\x29']),
        ('\u24b2', &['\x28', '\x77', '\x29']), ('\u24b3', &['\x28', '\x78', '\x29']), ('\u24b4',
        &['\x28', '\x79', '\x29']), ('\u24b5', &['\x28', '\x7a', '\x29']), ('\u24b6', &['\x41']),
        ('\u24b7', &['\x42']), ('\u24b8', &['\x43']), ('\u24b9', &['\x44']), ('\u24ba', &['\x45']),
        ('\u24bb', &['\x46']), ('\u24bc', &['\x47']), ('\u24bd', &['\x48']), ('\u24be', &['\x49']),
        ('\u24bf', &['\x4a']), ('\u24c0', &['\x4b']), ('\u24c1', &['\x4c']), ('\u24c2', &['\x4d']),
        ('\u24c3', &['\x4e']), ('\u24c4', &['\x4f']), ('\u24c5', &['\x50']), ('\u24c6', &['\x51']),
        ('\u24c7', &['\x52']), ('\u24c8', &['\x53']), ('\u24c9', &['\x54']), ('\u24ca', &['\x55']),
        ('\u24cb', &['\x56']), ('\u24cc', &['\x57']), ('\u24cd', &['\x58']), ('\u24ce', &['\x59']),
        ('\u24cf', &['\x5a']), ('\u24d0', &['\x61']), ('\u24d1', &['\x62']), ('\u24d2', &['\x63']),
        ('\u24d3', &['\x64']), ('\u24d4', &['\x65']), ('\u24d5', &['\x66']), ('\u24d6', &['\x67']),
        ('\u24d7', &['\x68']), ('\u24d8', &['\x69']), ('\u24d9', &['\x6a']), ('\u24da', &['\x6b']),
        ('\u24db', &['\x6c']), ('\u24dc', &['\x6d']), ('\u24dd', &['\x6e']), ('\u24de', &['\x6f']),
        ('\u24df', &['\x70']), ('\u24e0', &['\x71']), ('\u24e1', &['\x72']), ('\u24e2', &['\x73']),
        ('\u24e3', &['\x74']), ('\u24e4', &['\x75']), ('\u24e5', &['\x76']), ('\u24e6', &['\x77']),
        ('\u24e7', &['\x78']), ('\u24e8', &['\x79']), ('\u24e9', &['\x7a']), ('\u24ea', &['\x30']),
        ('\u2a0c', &['\u222b', '\u222b', '\u222b', '\u222b']), ('\u2a74', &['\x3a', '\x3a',
        '\x3d']), ('\u2a75', &['\x3d', '\x3d']), ('\u2a76', &['\x3d', '\x3d', '\x3d']), ('\u2c7c',
        &['\x6a']), ('\u2c7d', &['\x56']), ('\u2d6f', &['\u2d61']), ('\u2e9f', &['\u6bcd']),
        ('\u2ef3', &['\u9f9f']), ('\u2f00', &['\u4e00']), ('\u2f01', &['\u4e28']), ('\u2f02',
        &['\u4e36']), ('\u2f03', &['\u4e3f']), ('\u2f04', &['\u4e59']), ('\u2f05', &['\u4e85']),
        ('\u2f06', &['\u4e8c']), ('\u2f07', &['\u4ea0']), ('\u2f08', &['\u4eba']), ('\u2f09',
        &['\u513f']), ('\u2f0a', &['\u5165']), ('\u2f0b', &['\u516b']), ('\u2f0c', &['\u5182']),
        ('\u2f0d', &['\u5196']), ('\u2f0e', &['\u51ab']), ('\u2f0f', &['\u51e0']), ('\u2f10',
        &['\u51f5']), ('\u2f11', &['\u5200']), ('\u2f12', &['\u529b']), ('\u2f13', &['\u52f9']),
        ('\u2f14', &['\u5315']), ('\u2f15', &['\u531a']), ('\u2f16', &['\u5338']), ('\u2f17',
        &['\u5341']), ('\u2f18', &['\u535c']), ('\u2f19', &['\u5369']), ('\u2f1a', &['\u5382']),
        ('\u2f1b', &['\u53b6']), ('\u2f1c', &['\u53c8']), ('\u2f1d', &['\u53e3']), ('\u2f1e',
        &['\u56d7']), ('\u2f1f', &['\u571f']), ('\u2f20', &['\u58eb']), ('\u2f21', &['\u5902']),
        ('\u2f22', &['\u590a']), ('\u2f23', &['\u5915']), ('\u2f24', &['\u5927']), ('\u2f25',
        &['\u5973']), ('\u2f26', &['\u5b50']), ('\u2f27', &['\u5b80']), ('\u2f28', &['\u5bf8']),
        ('\u2f29', &['\u5c0f']), ('\u2f2a', &['\u5c22']), ('\u2f2b', &['\u5c38']), ('\u2f2c',
        &['\u5c6e']), ('\u2f2d', &['\u5c71']), ('\u2f2e', &['\u5ddb']), ('\u2f2f', &['\u5de5']),
        ('\u2f30', &['\u5df1']), ('\u2f31', &['\u5dfe']), ('\u2f32', &['\u5e72']), ('\u2f33',
        &['\u5e7a']), ('\u2f34', &['\u5e7f']), ('\u2f35', &['\u5ef4']), ('\u2f36', &['\u5efe']),
        ('\u2f37', &['\u5f0b']), ('\u2f38', &['\u5f13']), ('\u2f39', &['\u5f50']), ('\u2f3a',
        &['\u5f61']), ('\u2f3b', &['\u5f73']), ('\u2f3c', &['\u5fc3']), ('\u2f3d', &['\u6208']),
        ('\u2f3e', &['\u6236']), ('\u2f3f', &['\u624b']), ('\u2f40', &['\u652f']), ('\u2f41',
        &['\u6534']), ('\u2f42', &['\u6587']), ('\u2f43', &['\u6597']), ('\u2f44', &['\u65a4']),
        ('\u2f45', &['\u65b9']), ('\u2f46', &['\u65e0']), ('\u2f47', &['\u65e5']), ('\u2f48',
        &['\u66f0']), ('\u2f49', &['\u6708']), ('\u2f4a', &['\u6728']), ('\u2f4b', &['\u6b20']),
        ('\u2f4c', &['\u6b62']), ('\u2f4d', &['\u6b79']), ('\u2f4e', &['\u6bb3']), ('\u2f4f',
        &['\u6bcb']), ('\u2f50', &['\u6bd4']), ('\u2f51', &['\u6bdb']), ('\u2f52', &['\u6c0f']),
        ('\u2f53', &['\u6c14']), ('\u2f54', &['\u6c34']), ('\u2f55', &['\u706b']), ('\u2f56',
        &['\u722a']), ('\u2f57', &['\u7236']), ('\u2f58', &['\u723b']), ('\u2f59', &['\u723f']),
        ('\u2f5a', &['\u7247']), ('\u2f5b', &['\u7259']), ('\u2f5c', &['\u725b']), ('\u2f5d',
        &['\u72ac']), ('\u2f5e', &['\u7384']), ('\u2f5f', &['\u7389']), ('\u2f60', &['\u74dc']),
        ('\u2f61', &['\u74e6']), ('\u2f62', &['\u7518']), ('\u2f63', &['\u751f']), ('\u2f64',
        &['\u7528']), ('\u2f65', &['\u7530']), ('\u2f66', &['\u758b']), ('\u2f67', &['\u7592']),
        ('\u2f68', &['\u7676']), ('\u2f69', &['\u767d']), ('\u2f6a', &['\u76ae']), ('\u2f6b',
        &['\u76bf']), ('\u2f6c', &['\u76ee']), ('\u2f6d', &['\u77db']), ('\u2f6e', &['\u77e2']),
        ('\u2f6f', &['\u77f3']), ('\u2f70', &['\u793a']), ('\u2f71', &['\u79b8']), ('\u2f72',
        &['\u79be']), ('\u2f73', &['\u7a74']), ('\u2f74', &['\u7acb']), ('\u2f75', &['\u7af9']),
        ('\u2f76', &['\u7c73']), ('\u2f77', &['\u7cf8']), ('\u2f78', &['\u7f36']), ('\u2f79',
        &['\u7f51']), ('\u2f7a', &['\u7f8a']), ('\u2f7b', &['\u7fbd']), ('\u2f7c', &['\u8001']),
        ('\u2f7d', &['\u800c']), ('\u2f7e', &['\u8012']), ('\u2f7f', &['\u8033']), ('\u2f80',
        &['\u807f']), ('\u2f81', &['\u8089']), ('\u2f82', &['\u81e3']), ('\u2f83', &['\u81ea']),
        ('\u2f84', &['\u81f3']), ('\u2f85', &['\u81fc']), ('\u2f86', &['\u820c']), ('\u2f87',
        &['\u821b']), ('\u2f88', &['\u821f']), ('\u2f89', &['\u826e']), ('\u2f8a', &['\u8272']),
        ('\u2f8b', &['\u8278']), ('\u2f8c', &['\u864d']), ('\u2f8d', &['\u866b']), ('\u2f8e',
        &['\u8840']), ('\u2f8f', &['\u884c']), ('\u2f90', &['\u8863']), ('\u2f91', &['\u897e']),
        ('\u2f92', &['\u898b']), ('\u2f93', &['\u89d2']), ('\u2f94', &['\u8a00']), ('\u2f95',
        &['\u8c37']), ('\u2f96', &['\u8c46']), ('\u2f97', &['\u8c55']), ('\u2f98', &['\u8c78']),
        ('\u2f99', &['\u8c9d']), ('\u2f9a', &['\u8d64']), ('\u2f9b', &['\u8d70']), ('\u2f9c',
        &['\u8db3']), ('\u2f9d', &['\u8eab']), ('\u2f9e', &['\u8eca']), ('\u2f9f', &['\u8f9b']),
        ('\u2fa0', &['\u8fb0']), ('\u2fa1', &['\u8fb5']), ('\u2fa2', &['\u9091']), ('\u2fa3',
        &['\u9149']), ('\u2fa4', &['\u91c6']), ('\u2fa5', &['\u91cc']), ('\u2fa6', &['\u91d1']),
        ('\u2fa7', &['\u9577']), ('\u2fa8', &['\u9580']), ('\u2fa9', &['\u961c']), ('\u2faa',
        &['\u96b6']), ('\u2fab', &['\u96b9']), ('\u2fac', &['\u96e8']), ('\u2fad', &['\u9751']),
        ('\u2fae', &['\u975e']), ('\u2faf', &['\u9762']), ('\u2fb0', &['\u9769']), ('\u2fb1',
        &['\u97cb']), ('\u2fb2', &['\u97ed']), ('\u2fb3', &['\u97f3']), ('\u2fb4', &['\u9801']),
        ('\u2fb5', &['\u98a8']), ('\u2fb6', &['\u98db']), ('\u2fb7', &['\u98df']), ('\u2fb8',
        &['\u9996']), ('\u2fb9', &['\u9999']), ('\u2fba', &['\u99ac']), ('\u2fbb', &['\u9aa8']),
        ('\u2fbc', &['\u9ad8']), ('\u2fbd', &['\u9adf']), ('\u2fbe', &['\u9b25']), ('\u2fbf',
        &['\u9b2f']), ('\u2fc0', &['\u9b32']), ('\u2fc1', &['\u9b3c']), ('\u2fc2', &['\u9b5a']),
        ('\u2fc3', &['\u9ce5']), ('\u2fc4', &['\u9e75']), ('\u2fc5', &['\u9e7f']), ('\u2fc6',
        &['\u9ea5']), ('\u2fc7', &['\u9ebb']), ('\u2fc8', &['\u9ec3']), ('\u2fc9', &['\u9ecd']),
        ('\u2fca', &['\u9ed1']), ('\u2fcb', &['\u9ef9']), ('\u2fcc', &['\u9efd']), ('\u2fcd',
        &['\u9f0e']), ('\u2fce', &['\u9f13']), ('\u2fcf', &['\u9f20']), ('\u2fd0', &['\u9f3b']),
        ('\u2fd1', &['\u9f4a']), ('\u2fd2', &['\u9f52']), ('\u2fd3', &['\u9f8d']), ('\u2fd4',
        &['\u9f9c']), ('\u2fd5', &['\u9fa0']), ('\u3000', &['\x20']), ('\u3036', &['\u3012']),
        ('\u3038', &['\u5341']), ('\u3039', &['\u5344']), ('\u303a', &['\u5345']), ('\u309b',
        &['\x20', '\u3099']), ('\u309c', &['\x20', '\u309a']), ('\u309f', &['\u3088', '\u308a']),
        ('\u30ff', &['\u30b3', '\u30c8']), ('\u3131', &['\u1100']), ('\u3132', &['\u1101']),
        ('\u3133', &['\u11aa']), ('\u3134', &['\u1102']), ('\u3135', &['\u11ac']), ('\u3136',
        &['\u11ad']), ('\u3137', &['\u1103']), ('\u3138', &['\u1104']), ('\u3139', &['\u1105']),
        ('\u313a', &['\u11b0']), ('\u313b', &['\u11b1']), ('\u313c', &['\u11b2']), ('\u313d',
        &['\u11b3']), ('\u313e', &['\u11b4']), ('\u313f', &['\u11b5']), ('\u3140', &['\u111a']),
        ('\u3141', &['\u1106']), ('\u3142', &['\u1107']), ('\u3143', &['\u1108']), ('\u3144',
        &['\u1121']), ('\u3145', &['\u1109']), ('\u3146', &['\u110a']), ('\u3147', &['\u110b']),
        ('\u3148', &['\u110c']), ('\u3149', &['\u110d']), ('\u314a', &['\u110e']), ('\u314b',
        &['\u110f']), ('\u314c', &['\u1110']), ('\u314d', &['\u1111']), ('\u314e', &['\u1112']),
        ('\u314f', &['\u1161']), ('\u3150', &['\u1162']), ('\u3151', &['\u1163']), ('\u3152',
        &['\u1164']), ('\u3153', &['\u1165']), ('\u3154', &['\u1166']), ('\u3155', &['\u1167']),
        ('\u3156', &['\u1168']), ('\u3157', &['\u1169']), ('\u3158', &['\u116a']), ('\u3159',
        &['\u116b']), ('\u315a', &['\u116c']), ('\u315b', &['\u116d']), ('\u315c', &['\u116e']),
        ('\u315d', &['\u116f']), ('\u315e', &['\u1170']), ('\u315f', &['\u1171']), ('\u3160',
        &['\u1172']), ('\u3161', &['\u1173']), ('\u3162', &['\u1174']), ('\u3163', &['\u1175']),
        ('\u3164', &['\u1160']), ('\u3165', &['\u1114']), ('\u3166', &['\u1115']), ('\u3167',
        &['\u11c7']), ('\u3168', &['\u11c8']), ('\u3169', &['\u11cc']), ('\u316a', &['\u11ce']),
        ('\u316b', &['\u11d3']), ('\u316c', &['\u11d7']), ('\u316d', &['\u11d9']), ('\u316e',
        &['\u111c']), ('\u316f', &['\u11dd']), ('\u3170', &['\u11df']), ('\u3171', &['\u111d']),
        ('\u3172', &['\u111e']), ('\u3173', &['\u1120']), ('\u3174', &['\u1122']), ('\u3175',
        &['\u1123']), ('\u3176', &['\u1127']), ('\u3177', &['\u1129']), ('\u3178', &['\u112b']),
        ('\u3179', &['\u112c']), ('\u317a', &['\u112d']), ('\u317b', &['\u112e']), ('\u317c',
        &['\u112f']), ('\u317d', &['\u1132']), ('\u317e', &['\u1136']), ('\u317f', &['\u1140']),
        ('\u3180', &['\u1147']), ('\u3181', &['\u114c']), ('\u3182', &['\u11f1']), ('\u3183',
        &['\u11f2']), ('\u3184', &['\u1157']), ('\u3185', &['\u1158']), ('\u3186', &['\u1159']),
        ('\u3187', &['\u1184']), ('\u3188', &['\u1185']), ('\u3189', &['\u1188']), ('\u318a',
        &['\u1191']), ('\u318b', &['\u1192']), ('\u318c', &['\u1194']), ('\u318d', &['\u119e']),
        ('\u318e', &['\u11a1']), ('\u3192', &['\u4e00']), ('\u3193', &['\u4e8c']), ('\u3194',
        &['\u4e09']), ('\u3195', &['\u56db']), ('\u3196', &['\u4e0a']), ('\u3197', &['\u4e2d']),
        ('\u3198', &['\u4e0b']), ('\u3199', &['\u7532']), ('\u319a', &['\u4e59']), ('\u319b',
        &['\u4e19']), ('\u319c', &['\u4e01']), ('\u319d', &['\u5929']), ('\u319e', &['\u5730']),
        ('\u319f', &['\u4eba']), ('\u3200', &['\x28', '\u1100', '\x29']), ('\u3201', &['\x28',
        '\u1102', '\x29']), ('\u3202', &['\x28', '\u1103', '\x29']), ('\u3203', &['\x28', '\u1105',
        '\x29']), ('\u3204', &['\x28', '\u1106', '\x29']), ('\u3205', &['\x28', '\u1107', '\x29']),
        ('\u3206', &['\x28', '\u1109', '\x29']), ('\u3207', &['\x28', '\u110b', '\x29']), ('\u3208',
        &['\x28', '\u110c', '\x29']), ('\u3209', &['\x28', '\u110e', '\x29']), ('\u320a', &['\x28',
        '\u110f', '\x29']), ('\u320b', &['\x28', '\u1110', '\x29']), ('\u320c', &['\x28', '\u1111',
        '\x29']), ('\u320d', &['\x28', '\u1112', '\x29']), ('\u320e', &['\x28', '\u1100', '\u1161',
        '\x29']), ('\u320f', &['\x28', '\u1102', '\u1161', '\x29']), ('\u3210', &['\x28', '\u1103',
        '\u1161', '\x29']), ('\u3211', &['\x28', '\u1105', '\u1161', '\x29']), ('\u3212', &['\x28',
        '\u1106', '\u1161', '\x29']), ('\u3213', &['\x28', '\u1107', '\u1161', '\x29']), ('\u3214',
        &['\x28', '\u1109', '\u1161', '\x29']), ('\u3215', &['\x28', '\u110b', '\u1161', '\x29']),
        ('\u3216', &['\x28', '\u110c', '\u1161', '\x29']), ('\u3217', &['\x28', '\u110e', '\u1161',
        '\x29']), ('\u3218', &['\x28', '\u110f', '\u1161', '\x29']), ('\u3219', &['\x28', '\u1110',
        '\u1161', '\x29']), ('\u321a', &['\x28', '\u1111', '\u1161', '\x29']), ('\u321b', &['\x28',
        '\u1112', '\u1161', '\x29']), ('\u321c', &['\x28', '\u110c', '\u116e', '\x29']), ('\u321d',
        &['\x28', '\u110b', '\u1169', '\u110c', '\u1165', '\u11ab', '\x29']), ('\u321e', &['\x28',
        '\u110b', '\u1169', '\u1112', '\u116e', '\x29']), ('\u3220', &['\x28', '\u4e00', '\x29']),
        ('\u3221', &['\x28', '\u4e8c', '\x29']), ('\u3222', &['\x28', '\u4e09', '\x29']), ('\u3223',
        &['\x28', '\u56db', '\x29']), ('\u3224', &['\x28', '\u4e94', '\x29']), ('\u3225', &['\x28',
        '\u516d', '\x29']), ('\u3226', &['\x28', '\u4e03', '\x29']), ('\u3227', &['\x28', '\u516b',
        '\x29']), ('\u3228', &['\x28', '\u4e5d', '\x29']), ('\u3229', &['\x28', '\u5341', '\x29']),
        ('\u322a', &['\x28', '\u6708', '\x29']), ('\u322b', &['\x28', '\u706b', '\x29']), ('\u322c',
        &['\x28', '\u6c34', '\x29']), ('\u322d', &['\x28', '\u6728', '\x29']), ('\u322e', &['\x28',
        '\u91d1', '\x29']), ('\u322f', &['\x28', '\u571f', '\x29']), ('\u3230', &['\x28', '\u65e5',
        '\x29']), ('\u3231', &['\x28', '\u682a', '\x29']), ('\u3232', &['\x28', '\u6709', '\x29']),
        ('\u3233', &['\x28', '\u793e', '\x29']), ('\u3234', &['\x28', '\u540d', '\x29']), ('\u3235',
        &['\x28', '\u7279', '\x29']), ('\u3236', &['\x28', '\u8ca1', '\x29']), ('\u3237', &['\x28',
        '\u795d', '\x29']), ('\u3238', &['\x28', '\u52b4', '\x29']), ('\u3239', &['\x28', '\u4ee3',
        '\x29']), ('\u323a', &['\x28', '\u547c', '\x29']), ('\u323b', &['\x28', '\u5b66', '\x29']),
        ('\u323c', &['\x28', '\u76e3', '\x29']), ('\u323d', &['\x28', '\u4f01', '\x29']), ('\u323e',
        &['\x28', '\u8cc7', '\x29']), ('\u323f', &['\x28', '\u5354', '\x29']), ('\u3240', &['\x28',
        '\u796d', '\x29']), ('\u3241', &['\x28', '\u4f11', '\x29']), ('\u3242', &['\x28', '\u81ea',
        '\x29']), ('\u3243', &['\x28', '\u81f3', '\x29']), ('\u3244', &['\u554f']), ('\u3245',
        &['\u5e7c']), ('\u3246', &['\u6587']), ('\u3247', &['\u7b8f']), ('\u3250', &['\x50', '\x54',
        '\x45']), ('\u3251', &['\x32', '\x31']), ('\u3252', &['\x32', '\x32']), ('\u3253', &['\x32',
        '\x33']), ('\u3254', &['\x32', '\x34']), ('\u3255', &['\x32', '\x35']), ('\u3256', &['\x32',
        '\x36']), ('\u3257', &['\x32', '\x37']), ('\u3258', &['\x32', '\x38']), ('\u3259', &['\x32',
        '\x39']), ('\u325a', &['\x33', '\x30']), ('\u325b', &['\x33', '\x31']), ('\u325c', &['\x33',
        '\x32']), ('\u325d', &['\x33', '\x33']), ('\u325e', &['\x33', '\x34']), ('\u325f', &['\x33',
        '\x35']), ('\u3260', &['\u1100']), ('\u3261', &['\u1102']), ('\u3262', &['\u1103']),
        ('\u3263', &['\u1105']), ('\u3264', &['\u1106']), ('\u3265', &['\u1107']), ('\u3266',
        &['\u1109']), ('\u3267', &['\u110b']), ('\u3268', &['\u110c']), ('\u3269', &['\u110e']),
        ('\u326a', &['\u110f']), ('\u326b', &['\u1110']), ('\u326c', &['\u1111']), ('\u326d',
        &['\u1112']), ('\u326e', &['\u1100', '\u1161']), ('\u326f', &['\u1102', '\u1161']),
        ('\u3270', &['\u1103', '\u1161']), ('\u3271', &['\u1105', '\u1161']), ('\u3272', &['\u1106',
        '\u1161']), ('\u3273', &['\u1107', '\u1161']), ('\u3274', &['\u1109', '\u1161']), ('\u3275',
        &['\u110b', '\u1161']), ('\u3276', &['\u110c', '\u1161']), ('\u3277', &['\u110e',
        '\u1161']), ('\u3278', &['\u110f', '\u1161']), ('\u3279', &['\u1110', '\u1161']), ('\u327a',
        &['\u1111', '\u1161']), ('\u327b', &['\u1112', '\u1161']), ('\u327c', &['\u110e', '\u1161',
        '\u11b7', '\u1100', '\u1169']), ('\u327d', &['\u110c', '\u116e', '\u110b', '\u1174']),
        ('\u327e', &['\u110b', '\u116e']), ('\u3280', &['\u4e00']), ('\u3281', &['\u4e8c']),
        ('\u3282', &['\u4e09']), ('\u3283', &['\u56db']), ('\u3284', &['\u4e94']), ('\u3285',
        &['\u516d']), ('\u3286', &['\u4e03']), ('\u3287', &['\u516b']), ('\u3288', &['\u4e5d']),
        ('\u3289', &['\u5341']), ('\u328a', &['\u6708']), ('\u328b', &['\u706b']), ('\u328c',
        &['\u6c34']), ('\u328d', &['\u6728']), ('\u328e', &['\u91d1']), ('\u328f', &['\u571f']),
        ('\u3290', &['\u65e5']), ('\u3291', &['\u682a']), ('\u3292', &['\u6709']), ('\u3293',
        &['\u793e']), ('\u3294', &['\u540d']), ('\u3295', &['\u7279']), ('\u3296', &['\u8ca1']),
        ('\u3297', &['\u795d']), ('\u3298', &['\u52b4']), ('\u3299', &['\u79d8']), ('\u329a',
        &['\u7537']), ('\u329b', &['\u5973']), ('\u329c', &['\u9069']), ('\u329d', &['\u512a']),
        ('\u329e', &['\u5370']), ('\u329f', &['\u6ce8']), ('\u32a0', &['\u9805']), ('\u32a1',
        &['\u4f11']), ('\u32a2', &['\u5199']), ('\u32a3', &['\u6b63']), ('\u32a4', &['\u4e0a']),
        ('\u32a5', &['\u4e2d']), ('\u32a6', &['\u4e0b']), ('\u32a7', &['\u5de6']), ('\u32a8',
        &['\u53f3']), ('\u32a9', &['\u533b']), ('\u32aa', &['\u5b97']), ('\u32ab', &['\u5b66']),
        ('\u32ac', &['\u76e3']), ('\u32ad', &['\u4f01']), ('\u32ae', &['\u8cc7']), ('\u32af',
        &['\u5354']), ('\u32b0', &['\u591c']), ('\u32b1', &['\x33', '\x36']), ('\u32b2', &['\x33',
        '\x37']), ('\u32b3', &['\x33', '\x38']), ('\u32b4', &['\x33', '\x39']), ('\u32b5', &['\x34',
        '\x30']), ('\u32b6', &['\x34', '\x31']), ('\u32b7', &['\x34', '\x32']), ('\u32b8', &['\x34',
        '\x33']), ('\u32b9', &['\x34', '\x34']), ('\u32ba', &['\x34', '\x35']), ('\u32bb', &['\x34',
        '\x36']), ('\u32bc', &['\x34', '\x37']), ('\u32bd', &['\x34', '\x38']), ('\u32be', &['\x34',
        '\x39']), ('\u32bf', &['\x35', '\x30']), ('\u32c0', &['\x31', '\u6708']), ('\u32c1',
        &['\x32', '\u6708']), ('\u32c2', &['\x33', '\u6708']), ('\u32c3', &['\x34', '\u6708']),
        ('\u32c4', &['\x35', '\u6708']), ('\u32c5', &['\x36', '\u6708']), ('\u32c6', &['\x37',
        '\u6708']), ('\u32c7', &['\x38', '\u6708']), ('\u32c8', &['\x39', '\u6708']), ('\u32c9',
        &['\x31', '\x30', '\u6708']), ('\u32ca', &['\x31', '\x31', '\u6708']), ('\u32cb', &['\x31',
        '\x32', '\u6708']), ('\u32cc', &['\x48', '\x67']), ('\u32cd', &['\x65', '\x72', '\x67']),
        ('\u32ce', &['\x65', '\x56']), ('\u32cf', &['\x4c', '\x54', '\x44']), ('\u32d0',
        &['\u30a2']), ('\u32d1', &['\u30a4']), ('\u32d2', &['\u30a6']), ('\u32d3', &['\u30a8']),
        ('\u32d4', &['\u30aa']), ('\u32d5', &['\u30ab']), ('\u32d6', &['\u30ad']), ('\u32d7',
        &['\u30af']), ('\u32d8', &['\u30b1']), ('\u32d9', &['\u30b3']), ('\u32da', &['\u30b5']),
        ('\u32db', &['\u30b7']), ('\u32dc', &['\u30b9']), ('\u32dd', &['\u30bb']), ('\u32de',
        &['\u30bd']), ('\u32df', &['\u30bf']), ('\u32e0', &['\u30c1']), ('\u32e1', &['\u30c4']),
        ('\u32e2', &['\u30c6']), ('\u32e3', &['\u30c8']), ('\u32e4', &['\u30ca']), ('\u32e5',
        &['\u30cb']), ('\u32e6', &['\u30cc']), ('\u32e7', &['\u30cd']), ('\u32e8', &['\u30ce']),
        ('\u32e9', &['\u30cf']), ('\u32ea', &['\u30d2']), ('\u32eb', &['\u30d5']), ('\u32ec',
        &['\u30d8']), ('\u32ed', &['\u30db']), ('\u32ee', &['\u30de']), ('\u32ef', &['\u30df']),
        ('\u32f0', &['\u30e0']), ('\u32f1', &['\u30e1']), ('\u32f2', &['\u30e2']), ('\u32f3',
        &['\u30e4']), ('\u32f4', &['\u30e6']), ('\u32f5', &['\u30e8']), ('\u32f6', &['\u30e9']),
        ('\u32f7', &['\u30ea']), ('\u32f8', &['\u30eb']), ('\u32f9', &['\u30ec']), ('\u32fa',
        &['\u30ed']), ('\u32fb', &['\u30ef']), ('\u32fc', &['\u30f0']), ('\u32fd', &['\u30f1']),
        ('\u32fe', &['\u30f2']), ('\u3300', &['\u30a2', '\u30d1', '\u30fc', '\u30c8']), ('\u3301',
        &['\u30a2', '\u30eb', '\u30d5', '\u30a1']), ('\u3302', &['\u30a2', '\u30f3', '\u30da',
        '\u30a2']), ('\u3303', &['\u30a2', '\u30fc', '\u30eb']), ('\u3304', &['\u30a4', '\u30cb',
        '\u30f3', '\u30b0']), ('\u3305', &['\u30a4', '\u30f3', '\u30c1']), ('\u3306', &['\u30a6',
        '\u30a9', '\u30f3']), ('\u3307', &['\u30a8', '\u30b9', '\u30af', '\u30fc', '\u30c9']),
        ('\u3308', &['\u30a8', '\u30fc', '\u30ab', '\u30fc']), ('\u3309', &['\u30aa', '\u30f3',
        '\u30b9']), ('\u330a', &['\u30aa', '\u30fc', '\u30e0']), ('\u330b', &['\u30ab', '\u30a4',
        '\u30ea']), ('\u330c', &['\u30ab', '\u30e9', '\u30c3', '\u30c8']), ('\u330d', &['\u30ab',
        '\u30ed', '\u30ea', '\u30fc']), ('\u330e', &['\u30ac', '\u30ed', '\u30f3']), ('\u330f',
        &['\u30ac', '\u30f3', '\u30de']), ('\u3310', &['\u30ae', '\u30ac']), ('\u3311', &['\u30ae',
        '\u30cb', '\u30fc']), ('\u3312', &['\u30ad', '\u30e5', '\u30ea', '\u30fc']), ('\u3313',
        &['\u30ae', '\u30eb', '\u30c0', '\u30fc']), ('\u3314', &['\u30ad', '\u30ed']), ('\u3315',
        &['\u30ad', '\u30ed', '\u30b0', '\u30e9', '\u30e0']), ('\u3316', &['\u30ad', '\u30ed',
        '\u30e1', '\u30fc', '\u30c8', '\u30eb']), ('\u3317', &['\u30ad', '\u30ed', '\u30ef',
        '\u30c3', '\u30c8']), ('\u3318', &['\u30b0', '\u30e9', '\u30e0']), ('\u3319', &['\u30b0',
        '\u30e9', '\u30e0', '\u30c8', '\u30f3']), ('\u331a', &['\u30af', '\u30eb', '\u30bc',
        '\u30a4', '\u30ed']), ('\u331b', &['\u30af', '\u30ed', '\u30fc', '\u30cd']), ('\u331c',
        &['\u30b1', '\u30fc', '\u30b9']), ('\u331d', &['\u30b3', '\u30eb', '\u30ca']), ('\u331e',
        &['\u30b3', '\u30fc', '\u30dd']), ('\u331f', &['\u30b5', '\u30a4', '\u30af', '\u30eb']),
        ('\u3320', &['\u30b5', '\u30f3', '\u30c1', '\u30fc', '\u30e0']), ('\u3321', &['\u30b7',
        '\u30ea', '\u30f3', '\u30b0']), ('\u3322', &['\u30bb', '\u30f3', '\u30c1']), ('\u3323',
        &['\u30bb', '\u30f3', '\u30c8']), ('\u3324', &['\u30c0', '\u30fc', '\u30b9']), ('\u3325',
        &['\u30c7', '\u30b7']), ('\u3326', &['\u30c9', '\u30eb']), ('\u3327', &['\u30c8',
        '\u30f3']), ('\u3328', &['\u30ca', '\u30ce']), ('\u3329', &['\u30ce', '\u30c3', '\u30c8']),
        ('\u332a', &['\u30cf', '\u30a4', '\u30c4']), ('\u332b', &['\u30d1', '\u30fc', '\u30bb',
        '\u30f3', '\u30c8']), ('\u332c', &['\u30d1', '\u30fc', '\u30c4']), ('\u332d', &['\u30d0',
        '\u30fc', '\u30ec', '\u30eb']), ('\u332e', &['\u30d4', '\u30a2', '\u30b9', '\u30c8',
        '\u30eb']), ('\u332f', &['\u30d4', '\u30af', '\u30eb']), ('\u3330', &['\u30d4', '\u30b3']),
        ('\u3331', &['\u30d3', '\u30eb']), ('\u3332', &['\u30d5', '\u30a1', '\u30e9', '\u30c3',
        '\u30c9']), ('\u3333', &['\u30d5', '\u30a3', '\u30fc', '\u30c8']), ('\u3334', &['\u30d6',
        '\u30c3', '\u30b7', '\u30a7', '\u30eb']), ('\u3335', &['\u30d5', '\u30e9', '\u30f3']),
        ('\u3336', &['\u30d8', '\u30af', '\u30bf', '\u30fc', '\u30eb']), ('\u3337', &['\u30da',
        '\u30bd']), ('\u3338', &['\u30da', '\u30cb', '\u30d2']), ('\u3339', &['\u30d8', '\u30eb',
        '\u30c4']), ('\u333a', &['\u30da', '\u30f3', '\u30b9']), ('\u333b', &['\u30da', '\u30fc',
        '\u30b8']), ('\u333c', &['\u30d9', '\u30fc', '\u30bf']), ('\u333d', &['\u30dd', '\u30a4',
        '\u30f3', '\u30c8']), ('\u333e', &['\u30dc', '\u30eb', '\u30c8']), ('\u333f', &['\u30db',
        '\u30f3']), ('\u3340', &['\u30dd', '\u30f3', '\u30c9']), ('\u3341', &['\u30db', '\u30fc',
        '\u30eb']), ('\u3342', &['\u30db', '\u30fc', '\u30f3']), ('\u3343', &['\u30de', '\u30a4',
        '\u30af', '\u30ed']), ('\u3344', &['\u30de', '\u30a4', '\u30eb']), ('\u3345', &['\u30de',
        '\u30c3', '\u30cf']), ('\u3346', &['\u30de', '\u30eb', '\u30af']), ('\u3347', &['\u30de',
        '\u30f3', '\u30b7', '\u30e7', '\u30f3']), ('\u3348', &['\u30df', '\u30af', '\u30ed',
        '\u30f3']), ('\u3349', &['\u30df', '\u30ea']), ('\u334a', &['\u30df', '\u30ea', '\u30d0',
        '\u30fc', '\u30eb']), ('\u334b', &['\u30e1', '\u30ac']), ('\u334c', &['\u30e1', '\u30ac',
        '\u30c8', '\u30f3']), ('\u334d', &['\u30e1', '\u30fc', '\u30c8', '\u30eb']), ('\u334e',
        &['\u30e4', '\u30fc', '\u30c9']), ('\u334f', &['\u30e4', '\u30fc', '\u30eb']), ('\u3350',
        &['\u30e6', '\u30a2', '\u30f3']), ('\u3351', &['\u30ea', '\u30c3', '\u30c8', '\u30eb']),
        ('\u3352', &['\u30ea', '\u30e9']), ('\u3353', &['\u30eb', '\u30d4', '\u30fc']), ('\u3354',
        &['\u30eb', '\u30fc', '\u30d6', '\u30eb']), ('\u3355', &['\u30ec', '\u30e0']), ('\u3356',
        &['\u30ec', '\u30f3', '\u30c8', '\u30b2', '\u30f3']), ('\u3357', &['\u30ef', '\u30c3',
        '\u30c8']), ('\u3358', &['\x30', '\u70b9']), ('\u3359', &['\x31', '\u70b9']), ('\u335a',
        &['\x32', '\u70b9']), ('\u335b', &['\x33', '\u70b9']), ('\u335c', &['\x34', '\u70b9']),
        ('\u335d', &['\x35', '\u70b9']), ('\u335e', &['\x36', '\u70b9']), ('\u335f', &['\x37',
        '\u70b9']), ('\u3360', &['\x38', '\u70b9']), ('\u3361', &['\x39', '\u70b9']), ('\u3362',
        &['\x31', '\x30', '\u70b9']), ('\u3363', &['\x31', '\x31', '\u70b9']), ('\u3364', &['\x31',
        '\x32', '\u70b9']), ('\u3365', &['\x31', '\x33', '\u70b9']), ('\u3366', &['\x31', '\x34',
        '\u70b9']), ('\u3367', &['\x31', '\x35', '\u70b9']), ('\u3368', &['\x31', '\x36',
        '\u70b9']), ('\u3369', &['\x31', '\x37', '\u70b9']), ('\u336a', &['\x31', '\x38',
        '\u70b9']), ('\u336b', &['\x31', '\x39', '\u70b9']), ('\u336c', &['\x32', '\x30',
        '\u70b9']), ('\u336d', &['\x32', '\x31', '\u70b9']), ('\u336e', &['\x32', '\x32',
        '\u70b9']), ('\u336f', &['\x32', '\x33', '\u70b9']), ('\u3370', &['\x32', '\x34',
        '\u70b9']), ('\u3371', &['\x68', '\x50', '\x61']), ('\u3372', &['\x64', '\x61']), ('\u3373',
        &['\x41', '\x55']), ('\u3374', &['\x62', '\x61', '\x72']), ('\u3375', &['\x6f', '\x56']),
        ('\u3376', &['\x70', '\x63']), ('\u3377', &['\x64', '\x6d']), ('\u3378', &['\x64', '\x6d',
        '\u00b2']), ('\u3379', &['\x64', '\x6d', '\u00b3']), ('\u337a', &['\x49', '\x55']),
        ('\u337b', &['\u5e73', '\u6210']), ('\u337c', &['\u662d', '\u548c']), ('\u337d', &['\u5927',
        '\u6b63']), ('\u337e', &['\u660e', '\u6cbb']), ('\u337f', &['\u682a', '\u5f0f', '\u4f1a',
        '\u793e']), ('\u3380', &['\x70', '\x41']), ('\u3381', &['\x6e', '\x41']), ('\u3382',
        &['\u03bc', '\x41']), ('\u3383', &['\x6d', '\x41']), ('\u3384', &['\x6b', '\x41']),
        ('\u3385', &['\x4b', '\x42']), ('\u3386', &['\x4d', '\x42']), ('\u3387', &['\x47', '\x42']),
        ('\u3388', &['\x63', '\x61', '\x6c']), ('\u3389', &['\x6b', '\x63', '\x61', '\x6c']),
        ('\u338a', &['\x70', '\x46']), ('\u338b', &['\x6e', '\x46']), ('\u338c', &['\u03bc',
        '\x46']), ('\u338d', &['\u03bc', '\x67']), ('\u338e', &['\x6d', '\x67']), ('\u338f',
        &['\x6b', '\x67']), ('\u3390', &['\x48', '\x7a']), ('\u3391', &['\x6b', '\x48', '\x7a']),
        ('\u3392', &['\x4d', '\x48', '\x7a']), ('\u3393', &['\x47', '\x48', '\x7a']), ('\u3394',
        &['\x54', '\x48', '\x7a']), ('\u3395', &['\u03bc', '\u2113']), ('\u3396', &['\x6d',
        '\u2113']), ('\u3397', &['\x64', '\u2113']), ('\u3398', &['\x6b', '\u2113']), ('\u3399',
        &['\x66', '\x6d']), ('\u339a', &['\x6e', '\x6d']), ('\u339b', &['\u03bc', '\x6d']),
        ('\u339c', &['\x6d', '\x6d']), ('\u339d', &['\x63', '\x6d']), ('\u339e', &['\x6b', '\x6d']),
        ('\u339f', &['\x6d', '\x6d', '\u00b2']), ('\u33a0', &['\x63', '\x6d', '\u00b2']), ('\u33a1',
        &['\x6d', '\u00b2']), ('\u33a2', &['\x6b', '\x6d', '\u00b2']), ('\u33a3', &['\x6d', '\x6d',
        '\u00b3']), ('\u33a4', &['\x63', '\x6d', '\u00b3']), ('\u33a5', &['\x6d', '\u00b3']),
        ('\u33a6', &['\x6b', '\x6d', '\u00b3']), ('\u33a7', &['\x6d', '\u2215', '\x73']), ('\u33a8',
        &['\x6d', '\u2215', '\x73', '\u00b2']), ('\u33a9', &['\x50', '\x61']), ('\u33aa', &['\x6b',
        '\x50', '\x61']), ('\u33ab', &['\x4d', '\x50', '\x61']), ('\u33ac', &['\x47', '\x50',
        '\x61']), ('\u33ad', &['\x72', '\x61', '\x64']), ('\u33ae', &['\x72', '\x61', '\x64',
        '\u2215', '\x73']), ('\u33af', &['\x72', '\x61', '\x64', '\u2215', '\x73', '\u00b2']),
        ('\u33b0', &['\x70', '\x73']), ('\u33b1', &['\x6e', '\x73']), ('\u33b2', &['\u03bc',
        '\x73']), ('\u33b3', &['\x6d', '\x73']), ('\u33b4', &['\x70', '\x56']), ('\u33b5', &['\x6e',
        '\x56']), ('\u33b6', &['\u03bc', '\x56']), ('\u33b7', &['\x6d', '\x56']), ('\u33b8',
        &['\x6b', '\x56']), ('\u33b9', &['\x4d', '\x56']), ('\u33ba', &['\x70', '\x57']), ('\u33bb',
        &['\x6e', '\x57']), ('\u33bc', &['\u03bc', '\x57']), ('\u33bd', &['\x6d', '\x57']),
        ('\u33be', &['\x6b', '\x57']), ('\u33bf', &['\x4d', '\x57']), ('\u33c0', &['\x6b',
        '\u03a9']), ('\u33c1', &['\x4d', '\u03a9']), ('\u33c2', &['\x61', '\x2e', '\x6d', '\x2e']),
        ('\u33c3', &['\x42', '\x71']), ('\u33c4', &['\x63', '\x63']), ('\u33c5', &['\x63', '\x64']),
        ('\u33c6', &['\x43', '\u2215', '\x6b', '\x67']), ('\u33c7', &['\x43', '\x6f', '\x2e']),
        ('\u33c8', &['\x64', '\x42']), ('\u33c9', &['\x47', '\x79']), ('\u33ca', &['\x68', '\x61']),
        ('\u33cb', &['\x48', '\x50']), ('\u33cc', &['\x69', '\x6e']), ('\u33cd', &['\x4b', '\x4b']),
        ('\u33ce', &['\x4b', '\x4d']), ('\u33cf', &['\x6b', '\x74']), ('\u33d0', &['\x6c', '\x6d']),
        ('\u33d1', &['\x6c', '\x6e']), ('\u33d2', &['\x6c', '\x6f', '\x67']), ('\u33d3', &['\x6c',
        '\x78']), ('\u33d4', &['\x6d', '\x62']), ('\u33d5', &['\x6d', '\x69', '\x6c']), ('\u33d6',
        &['\x6d', '\x6f', '\x6c']), ('\u33d7', &['\x50', '\x48']), ('\u33d8', &['\x70', '\x2e',
        '\x6d', '\x2e']), ('\u33d9', &['\x50', '\x50', '\x4d']), ('\u33da', &['\x50', '\x52']),
        ('\u33db', &['\x73', '\x72']), ('\u33dc', &['\x53', '\x76']), ('\u33dd', &['\x57', '\x62']),
        ('\u33de', &['\x56', '\u2215', '\x6d']), ('\u33df', &['\x41', '\u2215', '\x6d']), ('\u33e0',
        &['\x31', '\u65e5']), ('\u33e1', &['\x32', '\u65e5']), ('\u33e2', &['\x33', '\u65e5']),
        ('\u33e3', &['\x34', '\u65e5']), ('\u33e4', &['\x35', '\u65e5']), ('\u33e5', &['\x36',
        '\u65e5']), ('\u33e6', &['\x37', '\u65e5']), ('\u33e7', &['\x38', '\u65e5']), ('\u33e8',
        &['\x39', '\u65e5']), ('\u33e9', &['\x31', '\x30', '\u65e5']), ('\u33ea', &['\x31', '\x31',
        '\u65e5']), ('\u33eb', &['\x31', '\x32', '\u65e5']), ('\u33ec', &['\x31', '\x33',
        '\u65e5']), ('\u33ed', &['\x31', '\x34', '\u65e5']), ('\u33ee', &['\x31', '\x35',
        '\u65e5']), ('\u33ef', &['\x31', '\x36', '\u65e5']), ('\u33f0', &['\x31', '\x37',
        '\u65e5']), ('\u33f1', &['\x31', '\x38', '\u65e5']), ('\u33f2', &['\x31', '\x39',
        '\u65e5']), ('\u33f3', &['\x32', '\x30', '\u65e5']), ('\u33f4', &['\x32', '\x31',
        '\u65e5']), ('\u33f5', &['\x32', '\x32', '\u65e5']), ('\u33f6', &['\x32', '\x33',
        '\u65e5']), ('\u33f7', &['\x32', '\x34', '\u65e5']), ('\u33f8', &['\x32', '\x35',
        '\u65e5']), ('\u33f9', &['\x32', '\x36', '\u65e5']), ('\u33fa', &['\x32', '\x37',
        '\u65e5']), ('\u33fb', &['\x32', '\x38', '\u65e5']), ('\u33fc', &['\x32', '\x39',
        '\u65e5']), ('\u33fd', &['\x33', '\x30', '\u65e5']), ('\u33fe', &['\x33', '\x31',
        '\u65e5']), ('\u33ff', &['\x67', '\x61', '\x6c']), ('\ua69c', &['\u044a']), ('\ua69d',
        &['\u044c']), ('\ua770', &['\ua76f']), ('\ua7f8', &['\u0126']), ('\ua7f9', &['\u0153']),
        ('\uab5c', &['\ua727']), ('\uab5d', &['\uab37']), ('\uab5e', &['\u026b']), ('\uab5f',
        &['\uab52']), ('\ufb00', &['\x66', '\x66']), ('\ufb01', &['\x66', '\x69']), ('\ufb02',
        &['\x66', '\x6c']), ('\ufb03', &['\x66', '\x66', '\x69']), ('\ufb04', &['\x66', '\x66',
        '\x6c']), ('\ufb05', &['\u017f', '\x74']), ('\ufb06', &['\x73', '\x74']), ('\ufb13',
        &['\u0574', '\u0576']), ('\ufb14', &['\u0574', '\u0565']), ('\ufb15', &['\u0574',
        '\u056b']), ('\ufb16', &['\u057e', '\u0576']), ('\ufb17', &['\u0574', '\u056d']), ('\ufb20',
        &['\u05e2']), ('\ufb21', &['\u05d0']), ('\ufb22', &['\u05d3']), ('\ufb23', &['\u05d4']),
        ('\ufb24', &['\u05db']), ('\ufb25', &['\u05dc']), ('\ufb26', &['\u05dd']), ('\ufb27',
        &['\u05e8']), ('\ufb28', &['\u05ea']), ('\ufb29', &['\x2b']), ('\ufb4f', &['\u05d0',
        '\u05dc']), ('\ufb50', &['\u0671']), ('\ufb51', &['\u0671']), ('\ufb52', &['\u067b']),
        ('\ufb53', &['\u067b']), ('\ufb54', &['\u067b']), ('\ufb55', &['\u067b']), ('\ufb56',
        &['\u067e']), ('\ufb57', &['\u067e']), ('\ufb58', &['\u067e']), ('\ufb59', &['\u067e']),
        ('\ufb5a', &['\u0680']), ('\ufb5b', &['\u0680']), ('\ufb5c', &['\u0680']), ('\ufb5d',
        &['\u0680']), ('\ufb5e', &['\u067a']), ('\ufb5f', &['\u067a']), ('\ufb60', &['\u067a']),
        ('\ufb61', &['\u067a']), ('\ufb62', &['\u067f']), ('\ufb63', &['\u067f']), ('\ufb64',
        &['\u067f']), ('\ufb65', &['\u067f']), ('\ufb66', &['\u0679']), ('\ufb67', &['\u0679']),
        ('\ufb68', &['\u0679']), ('\ufb69', &['\u0679']), ('\ufb6a', &['\u06a4']), ('\ufb6b',
        &['\u06a4']), ('\ufb6c', &['\u06a4']), ('\ufb6d', &['\u06a4']), ('\ufb6e', &['\u06a6']),
        ('\ufb6f', &['\u06a6']), ('\ufb70', &['\u06a6']), ('\ufb71', &['\u06a6']), ('\ufb72',
        &['\u0684']), ('\ufb73', &['\u0684']), ('\ufb74', &['\u0684']), ('\ufb75', &['\u0684']),
        ('\ufb76', &['\u0683']), ('\ufb77', &['\u0683']), ('\ufb78', &['\u0683']), ('\ufb79',
        &['\u0683']), ('\ufb7a', &['\u0686']), ('\ufb7b', &['\u0686']), ('\ufb7c', &['\u0686']),
        ('\ufb7d', &['\u0686']), ('\ufb7e', &['\u0687']), ('\ufb7f', &['\u0687']), ('\ufb80',
        &['\u0687']), ('\ufb81', &['\u0687']), ('\ufb82', &['\u068d']), ('\ufb83', &['\u068d']),
        ('\ufb84', &['\u068c']), ('\ufb85', &['\u068c']), ('\ufb86', &['\u068e']), ('\ufb87',
        &['\u068e']), ('\ufb88', &['\u0688']), ('\ufb89', &['\u0688']), ('\ufb8a', &['\u0698']),
        ('\ufb8b', &['\u0698']), ('\ufb8c', &['\u0691']), ('\ufb8d', &['\u0691']), ('\ufb8e',
        &['\u06a9']), ('\ufb8f', &['\u06a9']), ('\ufb90', &['\u06a9']), ('\ufb91', &['\u06a9']),
        ('\ufb92', &['\u06af']), ('\ufb93', &['\u06af']), ('\ufb94', &['\u06af']), ('\ufb95',
        &['\u06af']), ('\ufb96', &['\u06b3']), ('\ufb97', &['\u06b3']), ('\ufb98', &['\u06b3']),
        ('\ufb99', &['\u06b3']), ('\ufb9a', &['\u06b1']), ('\ufb9b', &['\u06b1']), ('\ufb9c',
        &['\u06b1']), ('\ufb9d', &['\u06b1']), ('\ufb9e', &['\u06ba']), ('\ufb9f', &['\u06ba']),
        ('\ufba0', &['\u06bb']), ('\ufba1', &['\u06bb']), ('\ufba2', &['\u06bb']), ('\ufba3',
        &['\u06bb']), ('\ufba4', &['\u06c0']), ('\ufba5', &['\u06c0']), ('\ufba6', &['\u06c1']),
        ('\ufba7', &['\u06c1']), ('\ufba8', &['\u06c1']), ('\ufba9', &['\u06c1']), ('\ufbaa',
        &['\u06be']), ('\ufbab', &['\u06be']), ('\ufbac', &['\u06be']), ('\ufbad', &['\u06be']),
        ('\ufbae', &['\u06d2']), ('\ufbaf', &['\u06d2']), ('\ufbb0', &['\u06d3']), ('\ufbb1',
        &['\u06d3']), ('\ufbd3', &['\u06ad']), ('\ufbd4', &['\u06ad']), ('\ufbd5', &['\u06ad']),
        ('\ufbd6', &['\u06ad']), ('\ufbd7', &['\u06c7']), ('\ufbd8', &['\u06c7']), ('\ufbd9',
        &['\u06c6']), ('\ufbda', &['\u06c6']), ('\ufbdb', &['\u06c8']), ('\ufbdc', &['\u06c8']),
        ('\ufbdd', &['\u0677']), ('\ufbde', &['\u06cb']), ('\ufbdf', &['\u06cb']), ('\ufbe0',
        &['\u06c5']), ('\ufbe1', &['\u06c5']), ('\ufbe2', &['\u06c9']), ('\ufbe3', &['\u06c9']),
        ('\ufbe4', &['\u06d0']), ('\ufbe5', &['\u06d0']), ('\ufbe6', &['\u06d0']), ('\ufbe7',
        &['\u06d0']), ('\ufbe8', &['\u0649']), ('\ufbe9', &['\u0649']), ('\ufbea', &['\u0626',
        '\u0627']), ('\ufbeb', &['\u0626', '\u0627']), ('\ufbec', &['\u0626', '\u06d5']), ('\ufbed',
        &['\u0626', '\u06d5']), ('\ufbee', &['\u0626', '\u0648']), ('\ufbef', &['\u0626',
        '\u0648']), ('\ufbf0', &['\u0626', '\u06c7']), ('\ufbf1', &['\u0626', '\u06c7']), ('\ufbf2',
        &['\u0626', '\u06c6']), ('\ufbf3', &['\u0626', '\u06c6']), ('\ufbf4', &['\u0626',
        '\u06c8']), ('\ufbf5', &['\u0626', '\u06c8']), ('\ufbf6', &['\u0626', '\u06d0']), ('\ufbf7',
        &['\u0626', '\u06d0']), ('\ufbf8', &['\u0626', '\u06d0']), ('\ufbf9', &['\u0626',
        '\u0649']), ('\ufbfa', &['\u0626', '\u0649']), ('\ufbfb', &['\u0626', '\u0649']), ('\ufbfc',
        &['\u06cc']), ('\ufbfd', &['\u06cc']), ('\ufbfe', &['\u06cc']), ('\ufbff', &['\u06cc']),
        ('\ufc00', &['\u0626', '\u062c']), ('\ufc01', &['\u0626', '\u062d']), ('\ufc02', &['\u0626',
        '\u0645']), ('\ufc03', &['\u0626', '\u0649']), ('\ufc04', &['\u0626', '\u064a']), ('\ufc05',
        &['\u0628', '\u062c']), ('\ufc06', &['\u0628', '\u062d']), ('\ufc07', &['\u0628',
        '\u062e']), ('\ufc08', &['\u0628', '\u0645']), ('\ufc09', &['\u0628', '\u0649']), ('\ufc0a',
        &['\u0628', '\u064a']), ('\ufc0b', &['\u062a', '\u062c']), ('\ufc0c', &['\u062a',
        '\u062d']), ('\ufc0d', &['\u062a', '\u062e']), ('\ufc0e', &['\u062a', '\u0645']), ('\ufc0f',
        &['\u062a', '\u0649']), ('\ufc10', &['\u062a', '\u064a']), ('\ufc11', &['\u062b',
        '\u062c']), ('\ufc12', &['\u062b', '\u0645']), ('\ufc13', &['\u062b', '\u0649']), ('\ufc14',
        &['\u062b', '\u064a']), ('\ufc15', &['\u062c', '\u062d']), ('\ufc16', &['\u062c',
        '\u0645']), ('\ufc17', &['\u062d', '\u062c']), ('\ufc18', &['\u062d', '\u0645']), ('\ufc19',
        &['\u062e', '\u062c']), ('\ufc1a', &['\u062e', '\u062d']), ('\ufc1b', &['\u062e',
        '\u0645']), ('\ufc1c', &['\u0633', '\u062c']), ('\ufc1d', &['\u0633', '\u062d']), ('\ufc1e',
        &['\u0633', '\u062e']), ('\ufc1f', &['\u0633', '\u0645']), ('\ufc20', &['\u0635',
        '\u062d']), ('\ufc21', &['\u0635', '\u0645']), ('\ufc22', &['\u0636', '\u062c']), ('\ufc23',
        &['\u0636', '\u062d']), ('\ufc24', &['\u0636', '\u062e']), ('\ufc25', &['\u0636',
        '\u0645']), ('\ufc26', &['\u0637', '\u062d']), ('\ufc27', &['\u0637', '\u0645']), ('\ufc28',
        &['\u0638', '\u0645']), ('\ufc29', &['\u0639', '\u062c']), ('\ufc2a', &['\u0639',
        '\u0645']), ('\ufc2b', &['\u063a', '\u062c']), ('\ufc2c', &['\u063a', '\u0645']), ('\ufc2d',
        &['\u0641', '\u062c']), ('\ufc2e', &['\u0641', '\u062d']), ('\ufc2f', &['\u0641',
        '\u062e']), ('\ufc30', &['\u0641', '\u0645']), ('\ufc31', &['\u0641', '\u0649']), ('\ufc32',
        &['\u0641', '\u064a']), ('\ufc33', &['\u0642', '\u062d']), ('\ufc34', &['\u0642',
        '\u0645']), ('\ufc35', &['\u0642', '\u0649']), ('\ufc36', &['\u0642', '\u064a']), ('\ufc37',
        &['\u0643', '\u0627']), ('\ufc38', &['\u0643', '\u062c']), ('\ufc39', &['\u0643',
        '\u062d']), ('\ufc3a', &['\u0643', '\u062e']), ('\ufc3b', &['\u0643', '\u0644']), ('\ufc3c',
        &['\u0643', '\u0645']), ('\ufc3d', &['\u0643', '\u0649']), ('\ufc3e', &['\u0643',
        '\u064a']), ('\ufc3f', &['\u0644', '\u062c']), ('\ufc40', &['\u0644', '\u062d']), ('\ufc41',
        &['\u0644', '\u062e']), ('\ufc42', &['\u0644', '\u0645']), ('\ufc43', &['\u0644',
        '\u0649']), ('\ufc44', &['\u0644', '\u064a']), ('\ufc45', &['\u0645', '\u062c']), ('\ufc46',
        &['\u0645', '\u062d']), ('\ufc47', &['\u0645', '\u062e']), ('\ufc48', &['\u0645',
        '\u0645']), ('\ufc49', &['\u0645', '\u0649']), ('\ufc4a', &['\u0645', '\u064a']), ('\ufc4b',
        &['\u0646', '\u062c']), ('\ufc4c', &['\u0646', '\u062d']), ('\ufc4d', &['\u0646',
        '\u062e']), ('\ufc4e', &['\u0646', '\u0645']), ('\ufc4f', &['\u0646', '\u0649']), ('\ufc50',
        &['\u0646', '\u064a']), ('\ufc51', &['\u0647', '\u062c']), ('\ufc52', &['\u0647',
        '\u0645']), ('\ufc53', &['\u0647', '\u0649']), ('\ufc54', &['\u0647', '\u064a']), ('\ufc55',
        &['\u064a', '\u062c']), ('\ufc56', &['\u064a', '\u062d']), ('\ufc57', &['\u064a',
        '\u062e']), ('\ufc58', &['\u064a', '\u0645']), ('\ufc59', &['\u064a', '\u0649']), ('\ufc5a',
        &['\u064a', '\u064a']), ('\ufc5b', &['\u0630', '\u0670']), ('\ufc5c', &['\u0631',
        '\u0670']), ('\ufc5d', &['\u0649', '\u0670']), ('\ufc5e', &['\x20', '\u064c', '\u0651']),
        ('\ufc5f', &['\x20', '\u064d', '\u0651']), ('\ufc60', &['\x20', '\u064e', '\u0651']),
        ('\ufc61', &['\x20', '\u064f', '\u0651']), ('\ufc62', &['\x20', '\u0650', '\u0651']),
        ('\ufc63', &['\x20', '\u0651', '\u0670']), ('\ufc64', &['\u0626', '\u0631']), ('\ufc65',
        &['\u0626', '\u0632']), ('\ufc66', &['\u0626', '\u0645']), ('\ufc67', &['\u0626',
        '\u0646']), ('\ufc68', &['\u0626', '\u0649']), ('\ufc69', &['\u0626', '\u064a']), ('\ufc6a',
        &['\u0628', '\u0631']), ('\ufc6b', &['\u0628', '\u0632']), ('\ufc6c', &['\u0628',
        '\u0645']), ('\ufc6d', &['\u0628', '\u0646']), ('\ufc6e', &['\u0628', '\u0649']), ('\ufc6f',
        &['\u0628', '\u064a']), ('\ufc70', &['\u062a', '\u0631']), ('\ufc71', &['\u062a',
        '\u0632']), ('\ufc72', &['\u062a', '\u0645']), ('\ufc73', &['\u062a', '\u0646']), ('\ufc74',
        &['\u062a', '\u0649']), ('\ufc75', &['\u062a', '\u064a']), ('\ufc76', &['\u062b',
        '\u0631']), ('\ufc77', &['\u062b', '\u0632']), ('\ufc78', &['\u062b', '\u0645']), ('\ufc79',
        &['\u062b', '\u0646']), ('\ufc7a', &['\u062b', '\u0649']), ('\ufc7b', &['\u062b',
        '\u064a']), ('\ufc7c', &['\u0641', '\u0649']), ('\ufc7d', &['\u0641', '\u064a']), ('\ufc7e',
        &['\u0642', '\u0649']), ('\ufc7f', &['\u0642', '\u064a']), ('\ufc80', &['\u0643',
        '\u0627']), ('\ufc81', &['\u0643', '\u0644']), ('\ufc82', &['\u0643', '\u0645']), ('\ufc83',
        &['\u0643', '\u0649']), ('\ufc84', &['\u0643', '\u064a']), ('\ufc85', &['\u0644',
        '\u0645']), ('\ufc86', &['\u0644', '\u0649']), ('\ufc87', &['\u0644', '\u064a']), ('\ufc88',
        &['\u0645', '\u0627']), ('\ufc89', &['\u0645', '\u0645']), ('\ufc8a', &['\u0646',
        '\u0631']), ('\ufc8b', &['\u0646', '\u0632']), ('\ufc8c', &['\u0646', '\u0645']), ('\ufc8d',
        &['\u0646', '\u0646']), ('\ufc8e', &['\u0646', '\u0649']), ('\ufc8f', &['\u0646',
        '\u064a']), ('\ufc90', &['\u0649', '\u0670']), ('\ufc91', &['\u064a', '\u0631']), ('\ufc92',
        &['\u064a', '\u0632']), ('\ufc93', &['\u064a', '\u0645']), ('\ufc94', &['\u064a',
        '\u0646']), ('\ufc95', &['\u064a', '\u0649']), ('\ufc96', &['\u064a', '\u064a']), ('\ufc97',
        &['\u0626', '\u062c']), ('\ufc98', &['\u0626', '\u062d']), ('\ufc99', &['\u0626',
        '\u062e']), ('\ufc9a', &['\u0626', '\u0645']), ('\ufc9b', &['\u0626', '\u0647']), ('\ufc9c',
        &['\u0628', '\u062c']), ('\ufc9d', &['\u0628', '\u062d']), ('\ufc9e', &['\u0628',
        '\u062e']), ('\ufc9f', &['\u0628', '\u0645']), ('\ufca0', &['\u0628', '\u0647']), ('\ufca1',
        &['\u062a', '\u062c']), ('\ufca2', &['\u062a', '\u062d']), ('\ufca3', &['\u062a',
        '\u062e']), ('\ufca4', &['\u062a', '\u0645']), ('\ufca5', &['\u062a', '\u0647']), ('\ufca6',
        &['\u062b', '\u0645']), ('\ufca7', &['\u062c', '\u062d']), ('\ufca8', &['\u062c',
        '\u0645']), ('\ufca9', &['\u062d', '\u062c']), ('\ufcaa', &['\u062d', '\u0645']), ('\ufcab',
        &['\u062e', '\u062c']), ('\ufcac', &['\u062e', '\u0645']), ('\ufcad', &['\u0633',
        '\u062c']), ('\ufcae', &['\u0633', '\u062d']), ('\ufcaf', &['\u0633', '\u062e']), ('\ufcb0',
        &['\u0633', '\u0645']), ('\ufcb1', &['\u0635', '\u062d']), ('\ufcb2', &['\u0635',
        '\u062e']), ('\ufcb3', &['\u0635', '\u0645']), ('\ufcb4', &['\u0636', '\u062c']), ('\ufcb5',
        &['\u0636', '\u062d']), ('\ufcb6', &['\u0636', '\u062e']), ('\ufcb7', &['\u0636',
        '\u0645']), ('\ufcb8', &['\u0637', '\u062d']), ('\ufcb9', &['\u0638', '\u0645']), ('\ufcba',
        &['\u0639', '\u062c']), ('\ufcbb', &['\u0639', '\u0645']), ('\ufcbc', &['\u063a',
        '\u062c']), ('\ufcbd', &['\u063a', '\u0645']), ('\ufcbe', &['\u0641', '\u062c']), ('\ufcbf',
        &['\u0641', '\u062d']), ('\ufcc0', &['\u0641', '\u062e']), ('\ufcc1', &['\u0641',
        '\u0645']), ('\ufcc2', &['\u0642', '\u062d']), ('\ufcc3', &['\u0642', '\u0645']), ('\ufcc4',
        &['\u0643', '\u062c']), ('\ufcc5', &['\u0643', '\u062d']), ('\ufcc6', &['\u0643',
        '\u062e']), ('\ufcc7', &['\u0643', '\u0644']), ('\ufcc8', &['\u0643', '\u0645']), ('\ufcc9',
        &['\u0644', '\u062c']), ('\ufcca', &['\u0644', '\u062d']), ('\ufccb', &['\u0644',
        '\u062e']), ('\ufccc', &['\u0644', '\u0645']), ('\ufccd', &['\u0644', '\u0647']), ('\ufcce',
        &['\u0645', '\u062c']), ('\ufccf', &['\u0645', '\u062d']), ('\ufcd0', &['\u0645',
        '\u062e']), ('\ufcd1', &['\u0645', '\u0645']), ('\ufcd2', &['\u0646', '\u062c']), ('\ufcd3',
        &['\u0646', '\u062d']), ('\ufcd4', &['\u0646', '\u062e']), ('\ufcd5', &['\u0646',
        '\u0645']), ('\ufcd6', &['\u0646', '\u0647']), ('\ufcd7', &['\u0647', '\u062c']), ('\ufcd8',
        &['\u0647', '\u0645']), ('\ufcd9', &['\u0647', '\u0670']), ('\ufcda', &['\u064a',
        '\u062c']), ('\ufcdb', &['\u064a', '\u062d']), ('\ufcdc', &['\u064a', '\u062e']), ('\ufcdd',
        &['\u064a', '\u0645']), ('\ufcde', &['\u064a', '\u0647']), ('\ufcdf', &['\u0626',
        '\u0645']), ('\ufce0', &['\u0626', '\u0647']), ('\ufce1', &['\u0628', '\u0645']), ('\ufce2',
        &['\u0628', '\u0647']), ('\ufce3', &['\u062a', '\u0645']), ('\ufce4', &['\u062a',
        '\u0647']), ('\ufce5', &['\u062b', '\u0645']), ('\ufce6', &['\u062b', '\u0647']), ('\ufce7',
        &['\u0633', '\u0645']), ('\ufce8', &['\u0633', '\u0647']), ('\ufce9', &['\u0634',
        '\u0645']), ('\ufcea', &['\u0634', '\u0647']), ('\ufceb', &['\u0643', '\u0644']), ('\ufcec',
        &['\u0643', '\u0645']), ('\ufced', &['\u0644', '\u0645']), ('\ufcee', &['\u0646',
        '\u0645']), ('\ufcef', &['\u0646', '\u0647']), ('\ufcf0', &['\u064a', '\u0645']), ('\ufcf1',
        &['\u064a', '\u0647']), ('\ufcf2', &['\u0640', '\u064e', '\u0651']), ('\ufcf3', &['\u0640',
        '\u064f', '\u0651']), ('\ufcf4', &['\u0640', '\u0650', '\u0651']), ('\ufcf5', &['\u0637',
        '\u0649']), ('\ufcf6', &['\u0637', '\u064a']), ('\ufcf7', &['\u0639', '\u0649']), ('\ufcf8',
        &['\u0639', '\u064a']), ('\ufcf9', &['\u063a', '\u0649']), ('\ufcfa', &['\u063a',
        '\u064a']), ('\ufcfb', &['\u0633', '\u0649']), ('\ufcfc', &['\u0633', '\u064a']), ('\ufcfd',
        &['\u0634', '\u0649']), ('\ufcfe', &['\u0634', '\u064a']), ('\ufcff', &['\u062d',
        '\u0649']), ('\ufd00', &['\u062d', '\u064a']), ('\ufd01', &['\u062c', '\u0649']), ('\ufd02',
        &['\u062c', '\u064a']), ('\ufd03', &['\u062e', '\u0649']), ('\ufd04', &['\u062e',
        '\u064a']), ('\ufd05', &['\u0635', '\u0649']), ('\ufd06', &['\u0635', '\u064a']), ('\ufd07',
        &['\u0636', '\u0649']), ('\ufd08', &['\u0636', '\u064a']), ('\ufd09', &['\u0634',
        '\u062c']), ('\ufd0a', &['\u0634', '\u062d']), ('\ufd0b', &['\u0634', '\u062e']), ('\ufd0c',
        &['\u0634', '\u0645']), ('\ufd0d', &['\u0634', '\u0631']), ('\ufd0e', &['\u0633',
        '\u0631']), ('\ufd0f', &['\u0635', '\u0631']), ('\ufd10', &['\u0636', '\u0631']), ('\ufd11',
        &['\u0637', '\u0649']), ('\ufd12', &['\u0637', '\u064a']), ('\ufd13', &['\u0639',
        '\u0649']), ('\ufd14', &['\u0639', '\u064a']), ('\ufd15', &['\u063a', '\u0649']), ('\ufd16',
        &['\u063a', '\u064a']), ('\ufd17', &['\u0633', '\u0649']), ('\ufd18', &['\u0633',
        '\u064a']), ('\ufd19', &['\u0634', '\u0649']), ('\ufd1a', &['\u0634', '\u064a']), ('\ufd1b',
        &['\u062d', '\u0649']), ('\ufd1c', &['\u062d', '\u064a']), ('\ufd1d', &['\u062c',
        '\u0649']), ('\ufd1e', &['\u062c', '\u064a']), ('\ufd1f', &['\u062e', '\u0649']), ('\ufd20',
        &['\u062e', '\u064a']), ('\ufd21', &['\u0635', '\u0649']), ('\ufd22', &['\u0635',
        '\u064a']), ('\ufd23', &['\u0636', '\u0649']), ('\ufd24', &['\u0636', '\u064a']), ('\ufd25',
        &['\u0634', '\u062c']), ('\ufd26', &['\u0634', '\u062d']), ('\ufd27', &['\u0634',
        '\u062e']), ('\ufd28', &['\u0634', '\u0645']), ('\ufd29', &['\u0634', '\u0631']), ('\ufd2a',
        &['\u0633', '\u0631']), ('\ufd2b', &['\u0635', '\u0631']), ('\ufd2c', &['\u0636',
        '\u0631']), ('\ufd2d', &['\u0634', '\u062c']), ('\ufd2e', &['\u0634', '\u062d']), ('\ufd2f',
        &['\u0634', '\u062e']), ('\ufd30', &['\u0634', '\u0645']), ('\ufd31', &['\u0633',
        '\u0647']), ('\ufd32', &['\u0634', '\u0647']), ('\ufd33', &['\u0637', '\u0645']), ('\ufd34',
        &['\u0633', '\u062c']), ('\ufd35', &['\u0633', '\u062d']), ('\ufd36', &['\u0633',
        '\u062e']), ('\ufd37', &['\u0634', '\u062c']), ('\ufd38', &['\u0634', '\u062d']), ('\ufd39',
        &['\u0634', '\u062e']), ('\ufd3a', &['\u0637', '\u0645']), ('\ufd3b', &['\u0638',
        '\u0645']), ('\ufd3c', &['\u0627', '\u064b']), ('\ufd3d', &['\u0627', '\u064b']), ('\ufd50',
        &['\u062a', '\u062c', '\u0645']), ('\ufd51', &['\u062a', '\u062d', '\u062c']), ('\ufd52',
        &['\u062a', '\u062d', '\u062c']), ('\ufd53', &['\u062a', '\u062d', '\u0645']), ('\ufd54',
        &['\u062a', '\u062e', '\u0645']), ('\ufd55', &['\u062a', '\u0645', '\u062c']), ('\ufd56',
        &['\u062a', '\u0645', '\u062d']), ('\ufd57', &['\u062a', '\u0645', '\u062e']), ('\ufd58',
        &['\u062c', '\u0645', '\u062d']), ('\ufd59', &['\u062c', '\u0645', '\u062d']), ('\ufd5a',
        &['\u062d', '\u0645', '\u064a']), ('\ufd5b', &['\u062d', '\u0645', '\u0649']), ('\ufd5c',
        &['\u0633', '\u062d', '\u062c']), ('\ufd5d', &['\u0633', '\u062c', '\u062d']), ('\ufd5e',
        &['\u0633', '\u062c', '\u0649']), ('\ufd5f', &['\u0633', '\u0645', '\u062d']), ('\ufd60',
        &['\u0633', '\u0645', '\u062d']), ('\ufd61', &['\u0633', '\u0645', '\u062c']), ('\ufd62',
        &['\u0633', '\u0645', '\u0645']), ('\ufd63', &['\u0633', '\u0645', '\u0645']), ('\ufd64',
        &['\u0635', '\u062d', '\u062d']), ('\ufd65', &['\u0635', '\u062d', '\u062d']), ('\ufd66',
        &['\u0635', '\u0645', '\u0645']), ('\ufd67', &['\u0634', '\u062d', '\u0645']), ('\ufd68',
        &['\u0634', '\u062d', '\u0645']), ('\ufd69', &['\u0634', '\u062c', '\u064a']), ('\ufd6a',
        &['\u0634', '\u0645', '\u062e']), ('\ufd6b', &['\u0634', '\u0645', '\u062e']), ('\ufd6c',
        &['\u0634', '\u0645', '\u0645']), ('\ufd6d', &['\u0634', '\u0645', '\u0645']), ('\ufd6e',
        &['\u0636', '\u062d', '\u0649']), ('\ufd6f', &['\u0636', '\u062e', '\u0645']), ('\ufd70',
        &['\u0636', '\u062e', '\u0645']), ('\ufd71', &['\u0637', '\u0645', '\u062d']), ('\ufd72',
        &['\u0637', '\u0645', '\u062d']), ('\ufd73', &['\u0637', '\u0645', '\u0645']), ('\ufd74',
        &['\u0637', '\u0645', '\u064a']), ('\ufd75', &['\u0639', '\u062c', '\u0645']), ('\ufd76',
        &['\u0639', '\u0645', '\u0645']), ('\ufd77', &['\u0639', '\u0645', '\u0645']), ('\ufd78',
        &['\u0639', '\u0645', '\u0649']), ('\ufd79', &['\u063a', '\u0645', '\u0645']), ('\ufd7a',
        &['\u063a', '\u0645', '\u064a']), ('\ufd7b', &['\u063a', '\u0645', '\u0649']), ('\ufd7c',
        &['\u0641', '\u062e', '\u0645']), ('\ufd7d', &['\u0641', '\u062e', '\u0645']), ('\ufd7e',
        &['\u0642', '\u0645', '\u062d']), ('\ufd7f', &['\u0642', '\u0645', '\u0645']), ('\ufd80',
        &['\u0644', '\u062d', '\u0645']), ('\ufd81', &['\u0644', '\u062d', '\u064a']), ('\ufd82',
        &['\u0644', '\u062d', '\u0649']), ('\ufd83', &['\u0644', '\u062c', '\u062c']), ('\ufd84',
        &['\u0644', '\u062c', '\u062c']), ('\ufd85', &['\u0644', '\u062e', '\u0645']), ('\ufd86',
        &['\u0644', '\u062e', '\u0645']), ('\ufd87', &['\u0644', '\u0645', '\u062d']), ('\ufd88',
        &['\u0644', '\u0645', '\u062d']), ('\ufd89', &['\u0645', '\u062d', '\u062c']), ('\ufd8a',
        &['\u0645', '\u062d', '\u0645']), ('\ufd8b', &['\u0645', '\u062d', '\u064a']), ('\ufd8c',
        &['\u0645', '\u062c', '\u062d']), ('\ufd8d', &['\u0645', '\u062c', '\u0645']), ('\ufd8e',
        &['\u0645', '\u062e', '\u062c']), ('\ufd8f', &['\u0645', '\u062e', '\u0645']), ('\ufd92',
        &['\u0645', '\u062c', '\u062e']), ('\ufd93', &['\u0647', '\u0645', '\u062c']), ('\ufd94',
        &['\u0647', '\u0645', '\u0645']), ('\ufd95', &['\u0646', '\u062d', '\u0645']), ('\ufd96',
        &['\u0646', '\u062d', '\u0649']), ('\ufd97', &['\u0646', '\u062c', '\u0645']), ('\ufd98',
        &['\u0646', '\u062c', '\u0645']), ('\ufd99', &['\u0646', '\u062c', '\u0649']), ('\ufd9a',
        &['\u0646', '\u0645', '\u064a']), ('\ufd9b', &['\u0646', '\u0645', '\u0649']), ('\ufd9c',
        &['\u064a', '\u0645', '\u0645']), ('\ufd9d', &['\u064a', '\u0645', '\u0645']), ('\ufd9e',
        &['\u0628', '\u062e', '\u064a']), ('\ufd9f', &['\u062a', '\u062c', '\u064a']), ('\ufda0',
        &['\u062a', '\u062c', '\u0649']), ('\ufda1', &['\u062a', '\u062e', '\u064a']), ('\ufda2',
        &['\u062a', '\u062e', '\u0649']), ('\ufda3', &['\u062a', '\u0645', '\u064a']), ('\ufda4',
        &['\u062a', '\u0645', '\u0649']), ('\ufda5', &['\u062c', '\u0645', '\u064a']), ('\ufda6',
        &['\u062c', '\u062d', '\u0649']), ('\ufda7', &['\u062c', '\u0645', '\u0649']), ('\ufda8',
        &['\u0633', '\u062e', '\u0649']), ('\ufda9', &['\u0635', '\u062d', '\u064a']), ('\ufdaa',
        &['\u0634', '\u062d', '\u064a']), ('\ufdab', &['\u0636', '\u062d', '\u064a']), ('\ufdac',
        &['\u0644', '\u062c', '\u064a']), ('\ufdad', &['\u0644', '\u0645', '\u064a']), ('\ufdae',
        &['\u064a', '\u062d', '\u064a']), ('\ufdaf', &['\u064a', '\u062c', '\u064a']), ('\ufdb0',
        &['\u064a', '\u0645', '\u064a']), ('\ufdb1', &['\u0645', '\u0645', '\u064a']), ('\ufdb2',
        &['\u0642', '\u0645', '\u064a']), ('\ufdb3', &['\u0646', '\u062d', '\u064a']), ('\ufdb4',
        &['\u0642', '\u0645', '\u062d']), ('\ufdb5', &['\u0644', '\u062d', '\u0645']), ('\ufdb6',
        &['\u0639', '\u0645', '\u064a']), ('\ufdb7', &['\u0643', '\u0645', '\u064a']), ('\ufdb8',
        &['\u0646', '\u062c', '\u062d']), ('\ufdb9', &['\u0645', '\u062e', '\u064a']), ('\ufdba',
        &['\u0644', '\u062c', '\u0645']), ('\ufdbb', &['\u0643', '\u0645', '\u0645']), ('\ufdbc',
        &['\u0644', '\u062c', '\u0645']), ('\ufdbd', &['\u0646', '\u062c', '\u062d']), ('\ufdbe',
        &['\u062c', '\u062d', '\u064a']), ('\ufdbf', &['\u062d', '\u062c', '\u064a']), ('\ufdc0',
        &['\u0645', '\u062c', '\u064a']), ('\ufdc1', &['\u0641', '\u0645', '\u064a']), ('\ufdc2',
        &['\u0628', '\u062d', '\u064a']), ('\ufdc3', &['\u0643', '\u0645', '\u0645']), ('\ufdc4',
        &['\u0639', '\u062c', '\u0645']), ('\ufdc5', &['\u0635', '\u0645', '\u0645']), ('\ufdc6',
        &['\u0633', '\u062e', '\u064a']), ('\ufdc7', &['\u0646', '\u062c', '\u064a']), ('\ufdf0',
        &['\u0635', '\u0644', '\u06d2']), ('\ufdf1', &['\u0642', '\u0644', '\u06d2']), ('\ufdf2',
        &['\u0627', '\u0644', '\u0644', '\u0647']), ('\ufdf3', &['\u0627', '\u0643', '\u0628',
        '\u0631']), ('\ufdf4', &['\u0645', '\u062d', '\u0645', '\u062f']), ('\ufdf5', &['\u0635',
        '\u0644', '\u0639', '\u0645']), ('\ufdf6', &['\u0631', '\u0633', '\u0648', '\u0644']),
        ('\ufdf7', &['\u0639', '\u0644', '\u064a', '\u0647']), ('\ufdf8', &['\u0648', '\u0633',
        '\u0644', '\u0645']), ('\ufdf9', &['\u0635', '\u0644', '\u0649']), ('\ufdfa', &['\u0635',
        '\u0644', '\u0649', '\x20', '\u0627', '\u0644', '\u0644', '\u0647', '\x20', '\u0639',
        '\u0644', '\u064a', '\u0647', '\x20', '\u0648', '\u0633', '\u0644', '\u0645']), ('\ufdfb',
        &['\u062c', '\u0644', '\x20', '\u062c', '\u0644', '\u0627', '\u0644', '\u0647']), ('\ufdfc',
        &['\u0631', '\u06cc', '\u0627', '\u0644']), ('\ufe10', &['\x2c']), ('\ufe11', &['\u3001']),
        ('\ufe12', &['\u3002']), ('\ufe13', &['\x3a']), ('\ufe14', &['\x3b']), ('\ufe15',
        &['\x21']), ('\ufe16', &['\x3f']), ('\ufe17', &['\u3016']), ('\ufe18', &['\u3017']),
        ('\ufe19', &['\u2026']), ('\ufe30', &['\u2025']), ('\ufe31', &['\u2014']), ('\ufe32',
        &['\u2013']), ('\ufe33', &['\x5f']), ('\ufe34', &['\x5f']), ('\ufe35', &['\x28']),
        ('\ufe36', &['\x29']), ('\ufe37', &['\x7b']), ('\ufe38', &['\x7d']), ('\ufe39',
        &['\u3014']), ('\ufe3a', &['\u3015']), ('\ufe3b', &['\u3010']), ('\ufe3c', &['\u3011']),
        ('\ufe3d', &['\u300a']), ('\ufe3e', &['\u300b']), ('\ufe3f', &['\u3008']), ('\ufe40',
        &['\u3009']), ('\ufe41', &['\u300c']), ('\ufe42', &['\u300d']), ('\ufe43', &['\u300e']),
        ('\ufe44', &['\u300f']), ('\ufe47', &['\x5b']), ('\ufe48', &['\x5d']), ('\ufe49',
        &['\u203e']), ('\ufe4a', &['\u203e']), ('\ufe4b', &['\u203e']), ('\ufe4c', &['\u203e']),
        ('\ufe4d', &['\x5f']), ('\ufe4e', &['\x5f']), ('\ufe4f', &['\x5f']), ('\ufe50', &['\x2c']),
        ('\ufe51', &['\u3001']), ('\ufe52', &['\x2e']), ('\ufe54', &['\x3b']), ('\ufe55',
        &['\x3a']), ('\ufe56', &['\x3f']), ('\ufe57', &['\x21']), ('\ufe58', &['\u2014']),
        ('\ufe59', &['\x28']), ('\ufe5a', &['\x29']), ('\ufe5b', &['\x7b']), ('\ufe5c', &['\x7d']),
        ('\ufe5d', &['\u3014']), ('\ufe5e', &['\u3015']), ('\ufe5f', &['\x23']), ('\ufe60',
        &['\x26']), ('\ufe61', &['\x2a']), ('\ufe62', &['\x2b']), ('\ufe63', &['\x2d']), ('\ufe64',
        &['\x3c']), ('\ufe65', &['\x3e']), ('\ufe66', &['\x3d']), ('\ufe68', &['\x5c']), ('\ufe69',
        &['\x24']), ('\ufe6a', &['\x25']), ('\ufe6b', &['\x40']), ('\ufe70', &['\x20', '\u064b']),
        ('\ufe71', &['\u0640', '\u064b']), ('\ufe72', &['\x20', '\u064c']), ('\ufe74', &['\x20',
        '\u064d']), ('\ufe76', &['\x20', '\u064e']), ('\ufe77', &['\u0640', '\u064e']), ('\ufe78',
        &['\x20', '\u064f']), ('\ufe79', &['\u0640', '\u064f']), ('\ufe7a', &['\x20', '\u0650']),
        ('\ufe7b', &['\u0640', '\u0650']), ('\ufe7c', &['\x20', '\u0651']), ('\ufe7d', &['\u0640',
        '\u0651']), ('\ufe7e', &['\x20', '\u0652']), ('\ufe7f', &['\u0640', '\u0652']), ('\ufe80',
        &['\u0621']), ('\ufe81', &['\u0622']), ('\ufe82', &['\u0622']), ('\ufe83', &['\u0623']),
        ('\ufe84', &['\u0623']), ('\ufe85', &['\u0624']), ('\ufe86', &['\u0624']), ('\ufe87',
        &['\u0625']), ('\ufe88', &['\u0625']), ('\ufe89', &['\u0626']), ('\ufe8a', &['\u0626']),
        ('\ufe8b', &['\u0626']), ('\ufe8c', &['\u0626']), ('\ufe8d', &['\u0627']), ('\ufe8e',
        &['\u0627']), ('\ufe8f', &['\u0628']), ('\ufe90', &['\u0628']), ('\ufe91', &['\u0628']),
        ('\ufe92', &['\u0628']), ('\ufe93', &['\u0629']), ('\ufe94', &['\u0629']), ('\ufe95',
        &['\u062a']), ('\ufe96', &['\u062a']), ('\ufe97', &['\u062a']), ('\ufe98', &['\u062a']),
        ('\ufe99', &['\u062b']), ('\ufe9a', &['\u062b']), ('\ufe9b', &['\u062b']), ('\ufe9c',
        &['\u062b']), ('\ufe9d', &['\u062c']), ('\ufe9e', &['\u062c']), ('\ufe9f', &['\u062c']),
        ('\ufea0', &['\u062c']), ('\ufea1', &['\u062d']), ('\ufea2', &['\u062d']), ('\ufea3',
        &['\u062d']), ('\ufea4', &['\u062d']), ('\ufea5', &['\u062e']), ('\ufea6', &['\u062e']),
        ('\ufea7', &['\u062e']), ('\ufea8', &['\u062e']), ('\ufea9', &['\u062f']), ('\ufeaa',
        &['\u062f']), ('\ufeab', &['\u0630']), ('\ufeac', &['\u0630']), ('\ufead', &['\u0631']),
        ('\ufeae', &['\u0631']), ('\ufeaf', &['\u0632']), ('\ufeb0', &['\u0632']), ('\ufeb1',
        &['\u0633']), ('\ufeb2', &['\u0633']), ('\ufeb3', &['\u0633']), ('\ufeb4', &['\u0633']),
        ('\ufeb5', &['\u0634']), ('\ufeb6', &['\u0634']), ('\ufeb7', &['\u0634']), ('\ufeb8',
        &['\u0634']), ('\ufeb9', &['\u0635']), ('\ufeba', &['\u0635']), ('\ufebb', &['\u0635']),
        ('\ufebc', &['\u0635']), ('\ufebd', &['\u0636']), ('\ufebe', &['\u0636']), ('\ufebf',
        &['\u0636']), ('\ufec0', &['\u0636']), ('\ufec1', &['\u0637']), ('\ufec2', &['\u0637']),
        ('\ufec3', &['\u0637']), ('\ufec4', &['\u0637']), ('\ufec5', &['\u0638']), ('\ufec6',
        &['\u0638']), ('\ufec7', &['\u0638']), ('\ufec8', &['\u0638']), ('\ufec9', &['\u0639']),
        ('\ufeca', &['\u0639']), ('\ufecb', &['\u0639']), ('\ufecc', &['\u0639']), ('\ufecd',
        &['\u063a']), ('\ufece', &['\u063a']), ('\ufecf', &['\u063a']), ('\ufed0', &['\u063a']),
        ('\ufed1', &['\u0641']), ('\ufed2', &['\u0641']), ('\ufed3', &['\u0641']), ('\ufed4',
        &['\u0641']), ('\ufed5', &['\u0642']), ('\ufed6', &['\u0642']), ('\ufed7', &['\u0642']),
        ('\ufed8', &['\u0642']), ('\ufed9', &['\u0643']), ('\ufeda', &['\u0643']), ('\ufedb',
        &['\u0643']), ('\ufedc', &['\u0643']), ('\ufedd', &['\u0644']), ('\ufede', &['\u0644']),
        ('\ufedf', &['\u0644']), ('\ufee0', &['\u0644']), ('\ufee1', &['\u0645']), ('\ufee2',
        &['\u0645']), ('\ufee3', &['\u0645']), ('\ufee4', &['\u0645']), ('\ufee5', &['\u0646']),
        ('\ufee6', &['\u0646']), ('\ufee7', &['\u0646']), ('\ufee8', &['\u0646']), ('\ufee9',
        &['\u0647']), ('\ufeea', &['\u0647']), ('\ufeeb', &['\u0647']), ('\ufeec', &['\u0647']),
        ('\ufeed', &['\u0648']), ('\ufeee', &['\u0648']), ('\ufeef', &['\u0649']), ('\ufef0',
        &['\u0649']), ('\ufef1', &['\u064a']), ('\ufef2', &['\u064a']), ('\ufef3', &['\u064a']),
        ('\ufef4', &['\u064a']), ('\ufef5', &['\u0644', '\u0622']), ('\ufef6', &['\u0644',
        '\u0622']), ('\ufef7', &['\u0644', '\u0623']), ('\ufef8', &['\u0644', '\u0623']), ('\ufef9',
        &['\u0644', '\u0625']), ('\ufefa', &['\u0644', '\u0625']), ('\ufefb', &['\u0644',
        '\u0627']), ('\ufefc', &['\u0644', '\u0627']), ('\uff01', &['\x21']), ('\uff02', &['\x22']),
        ('\uff03', &['\x23']), ('\uff04', &['\x24']), ('\uff05', &['\x25']), ('\uff06', &['\x26']),
        ('\uff07', &['\x27']), ('\uff08', &['\x28']), ('\uff09', &['\x29']), ('\uff0a', &['\x2a']),
        ('\uff0b', &['\x2b']), ('\uff0c', &['\x2c']), ('\uff0d', &['\x2d']), ('\uff0e', &['\x2e']),
        ('\uff0f', &['\x2f']), ('\uff10', &['\x30']), ('\uff11', &['\x31']), ('\uff12', &['\x32']),
        ('\uff13', &['\x33']), ('\uff14', &['\x34']), ('\uff15', &['\x35']), ('\uff16', &['\x36']),
        ('\uff17', &['\x37']), ('\uff18', &['\x38']), ('\uff19', &['\x39']), ('\uff1a', &['\x3a']),
        ('\uff1b', &['\x3b']), ('\uff1c', &['\x3c']), ('\uff1d', &['\x3d']), ('\uff1e', &['\x3e']),
        ('\uff1f', &['\x3f']), ('\uff20', &['\x40']), ('\uff21', &['\x41']), ('\uff22', &['\x42']),
        ('\uff23', &['\x43']), ('\uff24', &['\x44']), ('\uff25', &['\x45']), ('\uff26', &['\x46']),
        ('\uff27', &['\x47']), ('\uff28', &['\x48']), ('\uff29', &['\x49']), ('\uff2a', &['\x4a']),
        ('\uff2b', &['\x4b']), ('\uff2c', &['\x4c']), ('\uff2d', &['\x4d']), ('\uff2e', &['\x4e']),
        ('\uff2f', &['\x4f']), ('\uff30', &['\x50']), ('\uff31', &['\x51']), ('\uff32', &['\x52']),
        ('\uff33', &['\x53']), ('\uff34', &['\x54']), ('\uff35', &['\x55']), ('\uff36', &['\x56']),
        ('\uff37', &['\x57']), ('\uff38', &['\x58']), ('\uff39', &['\x59']), ('\uff3a', &['\x5a']),
        ('\uff3b', &['\x5b']), ('\uff3c', &['\x5c']), ('\uff3d', &['\x5d']), ('\uff3e', &['\x5e']),
        ('\uff3f', &['\x5f']), ('\uff40', &['\x60']), ('\uff41', &['\x61']), ('\uff42', &['\x62']),
        ('\uff43', &['\x63']), ('\uff44', &['\x64']), ('\uff45', &['\x65']), ('\uff46', &['\x66']),
        ('\uff47', &['\x67']), ('\uff48', &['\x68']), ('\uff49', &['\x69']), ('\uff4a', &['\x6a']),
        ('\uff4b', &['\x6b']), ('\uff4c', &['\x6c']), ('\uff4d', &['\x6d']), ('\uff4e', &['\x6e']),
        ('\uff4f', &['\x6f']), ('\uff50', &['\x70']), ('\uff51', &['\x71']), ('\uff52', &['\x72']),
        ('\uff53', &['\x73']), ('\uff54', &['\x74']), ('\uff55', &['\x75']), ('\uff56', &['\x76']),
        ('\uff57', &['\x77']), ('\uff58', &['\x78']), ('\uff59', &['\x79']), ('\uff5a', &['\x7a']),
        ('\uff5b', &['\x7b']), ('\uff5c', &['\x7c']), ('\uff5d', &['\x7d']), ('\uff5e', &['\x7e']),
        ('\uff5f', &['\u2985']), ('\uff60', &['\u2986']), ('\uff61', &['\u3002']), ('\uff62',
        &['\u300c']), ('\uff63', &['\u300d']), ('\uff64', &['\u3001']), ('\uff65', &['\u30fb']),
        ('\uff66', &['\u30f2']), ('\uff67', &['\u30a1']), ('\uff68', &['\u30a3']), ('\uff69',
        &['\u30a5']), ('\uff6a', &['\u30a7']), ('\uff6b', &['\u30a9']), ('\uff6c', &['\u30e3']),
        ('\uff6d', &['\u30e5']), ('\uff6e', &['\u30e7']), ('\uff6f', &['\u30c3']), ('\uff70',
        &['\u30fc']), ('\uff71', &['\u30a2']), ('\uff72', &['\u30a4']), ('\uff73', &['\u30a6']),
        ('\uff74', &['\u30a8']), ('\uff75', &['\u30aa']), ('\uff76', &['\u30ab']), ('\uff77',
        &['\u30ad']), ('\uff78', &['\u30af']), ('\uff79', &['\u30b1']), ('\uff7a', &['\u30b3']),
        ('\uff7b', &['\u30b5']), ('\uff7c', &['\u30b7']), ('\uff7d', &['\u30b9']), ('\uff7e',
        &['\u30bb']), ('\uff7f', &['\u30bd']), ('\uff80', &['\u30bf']), ('\uff81', &['\u30c1']),
        ('\uff82', &['\u30c4']), ('\uff83', &['\u30c6']), ('\uff84', &['\u30c8']), ('\uff85',
        &['\u30ca']), ('\uff86', &['\u30cb']), ('\uff87', &['\u30cc']), ('\uff88', &['\u30cd']),
        ('\uff89', &['\u30ce']), ('\uff8a', &['\u30cf']), ('\uff8b', &['\u30d2']), ('\uff8c',
        &['\u30d5']), ('\uff8d', &['\u30d8']), ('\uff8e', &['\u30db']), ('\uff8f', &['\u30de']),
        ('\uff90', &['\u30df']), ('\uff91', &['\u30e0']), ('\uff92', &['\u30e1']), ('\uff93',
        &['\u30e2']), ('\uff94', &['\u30e4']), ('\uff95', &['\u30e6']), ('\uff96', &['\u30e8']),
        ('\uff97', &['\u30e9']), ('\uff98', &['\u30ea']), ('\uff99', &['\u30eb']), ('\uff9a',
        &['\u30ec']), ('\uff9b', &['\u30ed']), ('\uff9c', &['\u30ef']), ('\uff9d', &['\u30f3']),
        ('\uff9e', &['\u3099']), ('\uff9f', &['\u309a']), ('\uffa0', &['\u3164']), ('\uffa1',
        &['\u3131']), ('\uffa2', &['\u3132']), ('\uffa3', &['\u3133']), ('\uffa4', &['\u3134']),
        ('\uffa5', &['\u3135']), ('\uffa6', &['\u3136']), ('\uffa7', &['\u3137']), ('\uffa8',
        &['\u3138']), ('\uffa9', &['\u3139']), ('\uffaa', &['\u313a']), ('\uffab', &['\u313b']),
        ('\uffac', &['\u313c']), ('\uffad', &['\u313d']), ('\uffae', &['\u313e']), ('\uffaf',
        &['\u313f']), ('\uffb0', &['\u3140']), ('\uffb1', &['\u3141']), ('\uffb2', &['\u3142']),
        ('\uffb3', &['\u3143']), ('\uffb4', &['\u3144']), ('\uffb5', &['\u3145']), ('\uffb6',
        &['\u3146']), ('\uffb7', &['\u3147']), ('\uffb8', &['\u3148']), ('\uffb9', &['\u3149']),
        ('\uffba', &['\u314a']), ('\uffbb', &['\u314b']), ('\uffbc', &['\u314c']), ('\uffbd',
        &['\u314d']), ('\uffbe', &['\u314e']), ('\uffc2', &['\u314f']), ('\uffc3', &['\u3150']),
        ('\uffc4', &['\u3151']), ('\uffc5', &['\u3152']), ('\uffc6', &['\u3153']), ('\uffc7',
        &['\u3154']), ('\uffca', &['\u3155']), ('\uffcb', &['\u3156']), ('\uffcc', &['\u3157']),
        ('\uffcd', &['\u3158']), ('\uffce', &['\u3159']), ('\uffcf', &['\u315a']), ('\uffd2',
        &['\u315b']), ('\uffd3', &['\u315c']), ('\uffd4', &['\u315d']), ('\uffd5', &['\u315e']),
        ('\uffd6', &['\u315f']), ('\uffd7', &['\u3160']), ('\uffda', &['\u3161']), ('\uffdb',
        &['\u3162']), ('\uffdc', &['\u3163']), ('\uffe0', &['\u00a2']), ('\uffe1', &['\u00a3']),
        ('\uffe2', &['\u00ac']), ('\uffe3', &['\u00af']), ('\uffe4', &['\u00a6']), ('\uffe5',
        &['\u00a5']), ('\uffe6', &['\u20a9']), ('\uffe8', &['\u2502']), ('\uffe9', &['\u2190']),
        ('\uffea', &['\u2191']), ('\uffeb', &['\u2192']), ('\uffec', &['\u2193']), ('\uffed',
        &['\u25a0']), ('\uffee', &['\u25cb']), ('\U0001d400', &['\x41']), ('\U0001d401', &['\x42']),
        ('\U0001d402', &['\x43']), ('\U0001d403', &['\x44']), ('\U0001d404', &['\x45']),
        ('\U0001d405', &['\x46']), ('\U0001d406', &['\x47']), ('\U0001d407', &['\x48']),
        ('\U0001d408', &['\x49']), ('\U0001d409', &['\x4a']), ('\U0001d40a', &['\x4b']),
        ('\U0001d40b', &['\x4c']), ('\U0001d40c', &['\x4d']), ('\U0001d40d', &['\x4e']),
        ('\U0001d40e', &['\x4f']), ('\U0001d40f', &['\x50']), ('\U0001d410', &['\x51']),
        ('\U0001d411', &['\x52']), ('\U0001d412', &['\x53']), ('\U0001d413', &['\x54']),
        ('\U0001d414', &['\x55']), ('\U0001d415', &['\x56']), ('\U0001d416', &['\x57']),
        ('\U0001d417', &['\x58']), ('\U0001d418', &['\x59']), ('\U0001d419', &['\x5a']),
        ('\U0001d41a', &['\x61']), ('\U0001d41b', &['\x62']), ('\U0001d41c', &['\x63']),
        ('\U0001d41d', &['\x64']), ('\U0001d41e', &['\x65']), ('\U0001d41f', &['\x66']),
        ('\U0001d420', &['\x67']), ('\U0001d421', &['\x68']), ('\U0001d422', &['\x69']),
        ('\U0001d423', &['\x6a']), ('\U0001d424', &['\x6b']), ('\U0001d425', &['\x6c']),
        ('\U0001d426', &['\x6d']), ('\U0001d427', &['\x6e']), ('\U0001d428', &['\x6f']),
        ('\U0001d429', &['\x70']), ('\U0001d42a', &['\x71']), ('\U0001d42b', &['\x72']),
        ('\U0001d42c', &['\x73']), ('\U0001d42d', &['\x74']), ('\U0001d42e', &['\x75']),
        ('\U0001d42f', &['\x76']), ('\U0001d430', &['\x77']), ('\U0001d431', &['\x78']),
        ('\U0001d432', &['\x79']), ('\U0001d433', &['\x7a']), ('\U0001d434', &['\x41']),
        ('\U0001d435', &['\x42']), ('\U0001d436', &['\x43']), ('\U0001d437', &['\x44']),
        ('\U0001d438', &['\x45']), ('\U0001d439', &['\x46']), ('\U0001d43a', &['\x47']),
        ('\U0001d43b', &['\x48']), ('\U0001d43c', &['\x49']), ('\U0001d43d', &['\x4a']),
        ('\U0001d43e', &['\x4b']), ('\U0001d43f', &['\x4c']), ('\U0001d440', &['\x4d']),
        ('\U0001d441', &['\x4e']), ('\U0001d442', &['\x4f']), ('\U0001d443', &['\x50']),
        ('\U0001d444', &['\x51']), ('\U0001d445', &['\x52']), ('\U0001d446', &['\x53']),
        ('\U0001d447', &['\x54']), ('\U0001d448', &['\x55']), ('\U0001d449', &['\x56']),
        ('\U0001d44a', &['\x57']), ('\U0001d44b', &['\x58']), ('\U0001d44c', &['\x59']),
        ('\U0001d44d', &['\x5a']), ('\U0001d44e', &['\x61']), ('\U0001d44f', &['\x62']),
        ('\U0001d450', &['\x63']), ('\U0001d451', &['\x64']), ('\U0001d452', &['\x65']),
        ('\U0001d453', &['\x66']), ('\U0001d454', &['\x67']), ('\U0001d456', &['\x69']),
        ('\U0001d457', &['\x6a']), ('\U0001d458', &['\x6b']), ('\U0001d459', &['\x6c']),
        ('\U0001d45a', &['\x6d']), ('\U0001d45b', &['\x6e']), ('\U0001d45c', &['\x6f']),
        ('\U0001d45d', &['\x70']), ('\U0001d45e', &['\x71']), ('\U0001d45f', &['\x72']),
        ('\U0001d460', &['\x73']), ('\U0001d461', &['\x74']), ('\U0001d462', &['\x75']),
        ('\U0001d463', &['\x76']), ('\U0001d464', &['\x77']), ('\U0001d465', &['\x78']),
        ('\U0001d466', &['\x79']), ('\U0001d467', &['\x7a']), ('\U0001d468', &['\x41']),
        ('\U0001d469', &['\x42']), ('\U0001d46a', &['\x43']), ('\U0001d46b', &['\x44']),
        ('\U0001d46c', &['\x45']), ('\U0001d46d', &['\x46']), ('\U0001d46e', &['\x47']),
        ('\U0001d46f', &['\x48']), ('\U0001d470', &['\x49']), ('\U0001d471', &['\x4a']),
        ('\U0001d472', &['\x4b']), ('\U0001d473', &['\x4c']), ('\U0001d474', &['\x4d']),
        ('\U0001d475', &['\x4e']), ('\U0001d476', &['\x4f']), ('\U0001d477', &['\x50']),
        ('\U0001d478', &['\x51']), ('\U0001d479', &['\x52']), ('\U0001d47a', &['\x53']),
        ('\U0001d47b', &['\x54']), ('\U0001d47c', &['\x55']), ('\U0001d47d', &['\x56']),
        ('\U0001d47e', &['\x57']), ('\U0001d47f', &['\x58']), ('\U0001d480', &['\x59']),
        ('\U0001d481', &['\x5a']), ('\U0001d482', &['\x61']), ('\U0001d483', &['\x62']),
        ('\U0001d484', &['\x63']), ('\U0001d485', &['\x64']), ('\U0001d486', &['\x65']),
        ('\U0001d487', &['\x66']), ('\U0001d488', &['\x67']), ('\U0001d489', &['\x68']),
        ('\U0001d48a', &['\x69']), ('\U0001d48b', &['\x6a']), ('\U0001d48c', &['\x6b']),
        ('\U0001d48d', &['\x6c']), ('\U0001d48e', &['\x6d']), ('\U0001d48f', &['\x6e']),
        ('\U0001d490', &['\x6f']), ('\U0001d491', &['\x70']), ('\U0001d492', &['\x71']),
        ('\U0001d493', &['\x72']), ('\U0001d494', &['\x73']), ('\U0001d495', &['\x74']),
        ('\U0001d496', &['\x75']), ('\U0001d497', &['\x76']), ('\U0001d498', &['\x77']),
        ('\U0001d499', &['\x78']), ('\U0001d49a', &['\x79']), ('\U0001d49b', &['\x7a']),
        ('\U0001d49c', &['\x41']), ('\U0001d49e', &['\x43']), ('\U0001d49f', &['\x44']),
        ('\U0001d4a2', &['\x47']), ('\U0001d4a5', &['\x4a']), ('\U0001d4a6', &['\x4b']),
        ('\U0001d4a9', &['\x4e']), ('\U0001d4aa', &['\x4f']), ('\U0001d4ab', &['\x50']),
        ('\U0001d4ac', &['\x51']), ('\U0001d4ae', &['\x53']), ('\U0001d4af', &['\x54']),
        ('\U0001d4b0', &['\x55']), ('\U0001d4b1', &['\x56']), ('\U0001d4b2', &['\x57']),
        ('\U0001d4b3', &['\x58']), ('\U0001d4b4', &['\x59']), ('\U0001d4b5', &['\x5a']),
        ('\U0001d4b6', &['\x61']), ('\U0001d4b7', &['\x62']), ('\U0001d4b8', &['\x63']),
        ('\U0001d4b9', &['\x64']), ('\U0001d4bb', &['\x66']), ('\U0001d4bd', &['\x68']),
        ('\U0001d4be', &['\x69']), ('\U0001d4bf', &['\x6a']), ('\U0001d4c0', &['\x6b']),
        ('\U0001d4c1', &['\x6c']), ('\U0001d4c2', &['\x6d']), ('\U0001d4c3', &['\x6e']),
        ('\U0001d4c5', &['\x70']), ('\U0001d4c6', &['\x71']), ('\U0001d4c7', &['\x72']),
        ('\U0001d4c8', &['\x73']), ('\U0001d4c9', &['\x74']), ('\U0001d4ca', &['\x75']),
        ('\U0001d4cb', &['\x76']), ('\U0001d4cc', &['\x77']), ('\U0001d4cd', &['\x78']),
        ('\U0001d4ce', &['\x79']), ('\U0001d4cf', &['\x7a']), ('\U0001d4d0', &['\x41']),
        ('\U0001d4d1', &['\x42']), ('\U0001d4d2', &['\x43']), ('\U0001d4d3', &['\x44']),
        ('\U0001d4d4', &['\x45']), ('\U0001d4d5', &['\x46']), ('\U0001d4d6', &['\x47']),
        ('\U0001d4d7', &['\x48']), ('\U0001d4d8', &['\x49']), ('\U0001d4d9', &['\x4a']),
        ('\U0001d4da', &['\x4b']), ('\U0001d4db', &['\x4c']), ('\U0001d4dc', &['\x4d']),
        ('\U0001d4dd', &['\x4e']), ('\U0001d4de', &['\x4f']), ('\U0001d4df', &['\x50']),
        ('\U0001d4e0', &['\x51']), ('\U0001d4e1', &['\x52']), ('\U0001d4e2', &['\x53']),
        ('\U0001d4e3', &['\x54']), ('\U0001d4e4', &['\x55']), ('\U0001d4e5', &['\x56']),
        ('\U0001d4e6', &['\x57']), ('\U0001d4e7', &['\x58']), ('\U0001d4e8', &['\x59']),
        ('\U0001d4e9', &['\x5a']), ('\U0001d4ea', &['\x61']), ('\U0001d4eb', &['\x62']),
        ('\U0001d4ec', &['\x63']), ('\U0001d4ed', &['\x64']), ('\U0001d4ee', &['\x65']),
        ('\U0001d4ef', &['\x66']), ('\U0001d4f0', &['\x67']), ('\U0001d4f1', &['\x68']),
        ('\U0001d4f2', &['\x69']), ('\U0001d4f3', &['\x6a']), ('\U0001d4f4', &['\x6b']),
        ('\U0001d4f5', &['\x6c']), ('\U0001d4f6', &['\x6d']), ('\U0001d4f7', &['\x6e']),
        ('\U0001d4f8', &['\x6f']), ('\U0001d4f9', &['\x70']), ('\U0001d4fa', &['\x71']),
        ('\U0001d4fb', &['\x72']), ('\U0001d4fc', &['\x73']), ('\U0001d4fd', &['\x74']),
        ('\U0001d4fe', &['\x75']), ('\U0001d4ff', &['\x76']), ('\U0001d500', &['\x77']),
        ('\U0001d501', &['\x78']), ('\U0001d502', &['\x79']), ('\U0001d503', &['\x7a']),
        ('\U0001d504', &['\x41']), ('\U0001d505', &['\x42']), ('\U0001d507', &['\x44']),
        ('\U0001d508', &['\x45']), ('\U0001d509', &['\x46']), ('\U0001d50a', &['\x47']),
        ('\U0001d50d', &['\x4a']), ('\U0001d50e', &['\x4b']), ('\U0001d50f', &['\x4c']),
        ('\U0001d510', &['\x4d']), ('\U0001d511', &['\x4e']), ('\U0001d512', &['\x4f']),
        ('\U0001d513', &['\x50']), ('\U0001d514', &['\x51']), ('\U0001d516', &['\x53']),
        ('\U0001d517', &['\x54']), ('\U0001d518', &['\x55']), ('\U0001d519', &['\x56']),
        ('\U0001d51a', &['\x57']), ('\U0001d51b', &['\x58']), ('\U0001d51c', &['\x59']),
        ('\U0001d51e', &['\x61']), ('\U0001d51f', &['\x62']), ('\U0001d520', &['\x63']),
        ('\U0001d521', &['\x64']), ('\U0001d522', &['\x65']), ('\U0001d523', &['\x66']),
        ('\U0001d524', &['\x67']), ('\U0001d525', &['\x68']), ('\U0001d526', &['\x69']),
        ('\U0001d527', &['\x6a']), ('\U0001d528', &['\x6b']), ('\U0001d529', &['\x6c']),
        ('\U0001d52a', &['\x6d']), ('\U0001d52b', &['\x6e']), ('\U0001d52c', &['\x6f']),
        ('\U0001d52d', &['\x70']), ('\U0001d52e', &['\x71']), ('\U0001d52f', &['\x72']),
        ('\U0001d530', &['\x73']), ('\U0001d531', &['\x74']), ('\U0001d532', &['\x75']),
        ('\U0001d533', &['\x76']), ('\U0001d534', &['\x77']), ('\U0001d535', &['\x78']),
        ('\U0001d536', &['\x79']), ('\U0001d537', &['\x7a']), ('\U0001d538', &['\x41']),
        ('\U0001d539', &['\x42']), ('\U0001d53b', &['\x44']), ('\U0001d53c', &['\x45']),
        ('\U0001d53d', &['\x46']), ('\U0001d53e', &['\x47']), ('\U0001d540', &['\x49']),
        ('\U0001d541', &['\x4a']), ('\U0001d542', &['\x4b']), ('\U0001d543', &['\x4c']),
        ('\U0001d544', &['\x4d']), ('\U0001d546', &['\x4f']), ('\U0001d54a', &['\x53']),
        ('\U0001d54b', &['\x54']), ('\U0001d54c', &['\x55']), ('\U0001d54d', &['\x56']),
        ('\U0001d54e', &['\x57']), ('\U0001d54f', &['\x58']), ('\U0001d550', &['\x59']),
        ('\U0001d552', &['\x61']), ('\U0001d553', &['\x62']), ('\U0001d554', &['\x63']),
        ('\U0001d555', &['\x64']), ('\U0001d556', &['\x65']), ('\U0001d557', &['\x66']),
        ('\U0001d558', &['\x67']), ('\U0001d559', &['\x68']), ('\U0001d55a', &['\x69']),
        ('\U0001d55b', &['\x6a']), ('\U0001d55c', &['\x6b']), ('\U0001d55d', &['\x6c']),
        ('\U0001d55e', &['\x6d']), ('\U0001d55f', &['\x6e']), ('\U0001d560', &['\x6f']),
        ('\U0001d561', &['\x70']), ('\U0001d562', &['\x71']), ('\U0001d563', &['\x72']),
        ('\U0001d564', &['\x73']), ('\U0001d565', &['\x74']), ('\U0001d566', &['\x75']),
        ('\U0001d567', &['\x76']), ('\U0001d568', &['\x77']), ('\U0001d569', &['\x78']),
        ('\U0001d56a', &['\x79']), ('\U0001d56b', &['\x7a']), ('\U0001d56c', &['\x41']),
        ('\U0001d56d', &['\x42']), ('\U0001d56e', &['\x43']), ('\U0001d56f', &['\x44']),
        ('\U0001d570', &['\x45']), ('\U0001d571', &['\x46']), ('\U0001d572', &['\x47']),
        ('\U0001d573', &['\x48']), ('\U0001d574', &['\x49']), ('\U0001d575', &['\x4a']),
        ('\U0001d576', &['\x4b']), ('\U0001d577', &['\x4c']), ('\U0001d578', &['\x4d']),
        ('\U0001d579', &['\x4e']), ('\U0001d57a', &['\x4f']), ('\U0001d57b', &['\x50']),
        ('\U0001d57c', &['\x51']), ('\U0001d57d', &['\x52']), ('\U0001d57e', &['\x53']),
        ('\U0001d57f', &['\x54']), ('\U0001d580', &['\x55']), ('\U0001d581', &['\x56']),
        ('\U0001d582', &['\x57']), ('\U0001d583', &['\x58']), ('\U0001d584', &['\x59']),
        ('\U0001d585', &['\x5a']), ('\U0001d586', &['\x61']), ('\U0001d587', &['\x62']),
        ('\U0001d588', &['\x63']), ('\U0001d589', &['\x64']), ('\U0001d58a', &['\x65']),
        ('\U0001d58b', &['\x66']), ('\U0001d58c', &['\x67']), ('\U0001d58d', &['\x68']),
        ('\U0001d58e', &['\x69']), ('\U0001d58f', &['\x6a']), ('\U0001d590', &['\x6b']),
        ('\U0001d591', &['\x6c']), ('\U0001d592', &['\x6d']), ('\U0001d593', &['\x6e']),
        ('\U0001d594', &['\x6f']), ('\U0001d595', &['\x70']), ('\U0001d596', &['\x71']),
        ('\U0001d597', &['\x72']), ('\U0001d598', &['\x73']), ('\U0001d599', &['\x74']),
        ('\U0001d59a', &['\x75']), ('\U0001d59b', &['\x76']), ('\U0001d59c', &['\x77']),
        ('\U0001d59d', &['\x78']), ('\U0001d59e', &['\x79']), ('\U0001d59f', &['\x7a']),
        ('\U0001d5a0', &['\x41']), ('\U0001d5a1', &['\x42']), ('\U0001d5a2', &['\x43']),
        ('\U0001d5a3', &['\x44']), ('\U0001d5a4', &['\x45']), ('\U0001d5a5', &['\x46']),
        ('\U0001d5a6', &['\x47']), ('\U0001d5a7', &['\x48']), ('\U0001d5a8', &['\x49']),
        ('\U0001d5a9', &['\x4a']), ('\U0001d5aa', &['\x4b']), ('\U0001d5ab', &['\x4c']),
        ('\U0001d5ac', &['\x4d']), ('\U0001d5ad', &['\x4e']), ('\U0001d5ae', &['\x4f']),
        ('\U0001d5af', &['\x50']), ('\U0001d5b0', &['\x51']), ('\U0001d5b1', &['\x52']),
        ('\U0001d5b2', &['\x53']), ('\U0001d5b3', &['\x54']), ('\U0001d5b4', &['\x55']),
        ('\U0001d5b5', &['\x56']), ('\U0001d5b6', &['\x57']), ('\U0001d5b7', &['\x58']),
        ('\U0001d5b8', &['\x59']), ('\U0001d5b9', &['\x5a']), ('\U0001d5ba', &['\x61']),
        ('\U0001d5bb', &['\x62']), ('\U0001d5bc', &['\x63']), ('\U0001d5bd', &['\x64']),
        ('\U0001d5be', &['\x65']), ('\U0001d5bf', &['\x66']), ('\U0001d5c0', &['\x67']),
        ('\U0001d5c1', &['\x68']), ('\U0001d5c2', &['\x69']), ('\U0001d5c3', &['\x6a']),
        ('\U0001d5c4', &['\x6b']), ('\U0001d5c5', &['\x6c']), ('\U0001d5c6', &['\x6d']),
        ('\U0001d5c7', &['\x6e']), ('\U0001d5c8', &['\x6f']), ('\U0001d5c9', &['\x70']),
        ('\U0001d5ca', &['\x71']), ('\U0001d5cb', &['\x72']), ('\U0001d5cc', &['\x73']),
        ('\U0001d5cd', &['\x74']), ('\U0001d5ce', &['\x75']), ('\U0001d5cf', &['\x76']),
        ('\U0001d5d0', &['\x77']), ('\U0001d5d1', &['\x78']), ('\U0001d5d2', &['\x79']),
        ('\U0001d5d3', &['\x7a']), ('\U0001d5d4', &['\x41']), ('\U0001d5d5', &['\x42']),
        ('\U0001d5d6', &['\x43']), ('\U0001d5d7', &['\x44']), ('\U0001d5d8', &['\x45']),
        ('\U0001d5d9', &['\x46']), ('\U0001d5da', &['\x47']), ('\U0001d5db', &['\x48']),
        ('\U0001d5dc', &['\x49']), ('\U0001d5dd', &['\x4a']), ('\U0001d5de', &['\x4b']),
        ('\U0001d5df', &['\x4c']), ('\U0001d5e0', &['\x4d']), ('\U0001d5e1', &['\x4e']),
        ('\U0001d5e2', &['\x4f']), ('\U0001d5e3', &['\x50']), ('\U0001d5e4', &['\x51']),
        ('\U0001d5e5', &['\x52']), ('\U0001d5e6', &['\x53']), ('\U0001d5e7', &['\x54']),
        ('\U0001d5e8', &['\x55']), ('\U0001d5e9', &['\x56']), ('\U0001d5ea', &['\x57']),
        ('\U0001d5eb', &['\x58']), ('\U0001d5ec', &['\x59']), ('\U0001d5ed', &['\x5a']),
        ('\U0001d5ee', &['\x61']), ('\U0001d5ef', &['\x62']), ('\U0001d5f0', &['\x63']),
        ('\U0001d5f1', &['\x64']), ('\U0001d5f2', &['\x65']), ('\U0001d5f3', &['\x66']),
        ('\U0001d5f4', &['\x67']), ('\U0001d5f5', &['\x68']), ('\U0001d5f6', &['\x69']),
        ('\U0001d5f7', &['\x6a']), ('\U0001d5f8', &['\x6b']), ('\U0001d5f9', &['\x6c']),
        ('\U0001d5fa', &['\x6d']), ('\U0001d5fb', &['\x6e']), ('\U0001d5fc', &['\x6f']),
        ('\U0001d5fd', &['\x70']), ('\U0001d5fe', &['\x71']), ('\U0001d5ff', &['\x72']),
        ('\U0001d600', &['\x73']), ('\U0001d601', &['\x74']), ('\U0001d602', &['\x75']),
        ('\U0001d603', &['\x76']), ('\U0001d604', &['\x77']), ('\U0001d605', &['\x78']),
        ('\U0001d606', &['\x79']), ('\U0001d607', &['\x7a']), ('\U0001d608', &['\x41']),
        ('\U0001d609', &['\x42']), ('\U0001d60a', &['\x43']), ('\U0001d60b', &['\x44']),
        ('\U0001d60c', &['\x45']), ('\U0001d60d', &['\x46']), ('\U0001d60e', &['\x47']),
        ('\U0001d60f', &['\x48']), ('\U0001d610', &['\x49']), ('\U0001d611', &['\x4a']),
        ('\U0001d612', &['\x4b']), ('\U0001d613', &['\x4c']), ('\U0001d614', &['\x4d']),
        ('\U0001d615', &['\x4e']), ('\U0001d616', &['\x4f']), ('\U0001d617', &['\x50']),
        ('\U0001d618', &['\x51']), ('\U0001d619', &['\x52']), ('\U0001d61a', &['\x53']),
        ('\U0001d61b', &['\x54']), ('\U0001d61c', &['\x55']), ('\U0001d61d', &['\x56']),
        ('\U0001d61e', &['\x57']), ('\U0001d61f', &['\x58']), ('\U0001d620', &['\x59']),
        ('\U0001d621', &['\x5a']), ('\U0001d622', &['\x61']), ('\U0001d623', &['\x62']),
        ('\U0001d624', &['\x63']), ('\U0001d625', &['\x64']), ('\U0001d626', &['\x65']),
        ('\U0001d627', &['\x66']), ('\U0001d628', &['\x67']), ('\U0001d629', &['\x68']),
        ('\U0001d62a', &['\x69']), ('\U0001d62b', &['\x6a']), ('\U0001d62c', &['\x6b']),
        ('\U0001d62d', &['\x6c']), ('\U0001d62e', &['\x6d']), ('\U0001d62f', &['\x6e']),
        ('\U0001d630', &['\x6f']), ('\U0001d631', &['\x70']), ('\U0001d632', &['\x71']),
        ('\U0001d633', &['\x72']), ('\U0001d634', &['\x73']), ('\U0001d635', &['\x74']),
        ('\U0001d636', &['\x75']), ('\U0001d637', &['\x76']), ('\U0001d638', &['\x77']),
        ('\U0001d639', &['\x78']), ('\U0001d63a', &['\x79']), ('\U0001d63b', &['\x7a']),
        ('\U0001d63c', &['\x41']), ('\U0001d63d', &['\x42']), ('\U0001d63e', &['\x43']),
        ('\U0001d63f', &['\x44']), ('\U0001d640', &['\x45']), ('\U0001d641', &['\x46']),
        ('\U0001d642', &['\x47']), ('\U0001d643', &['\x48']), ('\U0001d644', &['\x49']),
        ('\U0001d645', &['\x4a']), ('\U0001d646', &['\x4b']), ('\U0001d647', &['\x4c']),
        ('\U0001d648', &['\x4d']), ('\U0001d649', &['\x4e']), ('\U0001d64a', &['\x4f']),
        ('\U0001d64b', &['\x50']), ('\U0001d64c', &['\x51']), ('\U0001d64d', &['\x52']),
        ('\U0001d64e', &['\x53']), ('\U0001d64f', &['\x54']), ('\U0001d650', &['\x55']),
        ('\U0001d651', &['\x56']), ('\U0001d652', &['\x57']), ('\U0001d653', &['\x58']),
        ('\U0001d654', &['\x59']), ('\U0001d655', &['\x5a']), ('\U0001d656', &['\x61']),
        ('\U0001d657', &['\x62']), ('\U0001d658', &['\x63']), ('\U0001d659', &['\x64']),
        ('\U0001d65a', &['\x65']), ('\U0001d65b', &['\x66']), ('\U0001d65c', &['\x67']),
        ('\U0001d65d', &['\x68']), ('\U0001d65e', &['\x69']), ('\U0001d65f', &['\x6a']),
        ('\U0001d660', &['\x6b']), ('\U0001d661', &['\x6c']), ('\U0001d662', &['\x6d']),
        ('\U0001d663', &['\x6e']), ('\U0001d664', &['\x6f']), ('\U0001d665', &['\x70']),
        ('\U0001d666', &['\x71']), ('\U0001d667', &['\x72']), ('\U0001d668', &['\x73']),
        ('\U0001d669', &['\x74']), ('\U0001d66a', &['\x75']), ('\U0001d66b', &['\x76']),
        ('\U0001d66c', &['\x77']), ('\U0001d66d', &['\x78']), ('\U0001d66e', &['\x79']),
        ('\U0001d66f', &['\x7a']), ('\U0001d670', &['\x41']), ('\U0001d671', &['\x42']),
        ('\U0001d672', &['\x43']), ('\U0001d673', &['\x44']), ('\U0001d674', &['\x45']),
        ('\U0001d675', &['\x46']), ('\U0001d676', &['\x47']), ('\U0001d677', &['\x48']),
        ('\U0001d678', &['\x49']), ('\U0001d679', &['\x4a']), ('\U0001d67a', &['\x4b']),
        ('\U0001d67b', &['\x4c']), ('\U0001d67c', &['\x4d']), ('\U0001d67d', &['\x4e']),
        ('\U0001d67e', &['\x4f']), ('\U0001d67f', &['\x50']), ('\U0001d680', &['\x51']),
        ('\U0001d681', &['\x52']), ('\U0001d682', &['\x53']), ('\U0001d683', &['\x54']),
        ('\U0001d684', &['\x55']), ('\U0001d685', &['\x56']), ('\U0001d686', &['\x57']),
        ('\U0001d687', &['\x58']), ('\U0001d688', &['\x59']), ('\U0001d689', &['\x5a']),
        ('\U0001d68a', &['\x61']), ('\U0001d68b', &['\x62']), ('\U0001d68c', &['\x63']),
        ('\U0001d68d', &['\x64']), ('\U0001d68e', &['\x65']), ('\U0001d68f', &['\x66']),
        ('\U0001d690', &['\x67']), ('\U0001d691', &['\x68']), ('\U0001d692', &['\x69']),
        ('\U0001d693', &['\x6a']), ('\U0001d694', &['\x6b']), ('\U0001d695', &['\x6c']),
        ('\U0001d696', &['\x6d']), ('\U0001d697', &['\x6e']), ('\U0001d698', &['\x6f']),
        ('\U0001d699', &['\x70']), ('\U0001d69a', &['\x71']), ('\U0001d69b', &['\x72']),
        ('\U0001d69c', &['\x73']), ('\U0001d69d', &['\x74']), ('\U0001d69e', &['\x75']),
        ('\U0001d69f', &['\x76']), ('\U0001d6a0', &['\x77']), ('\U0001d6a1', &['\x78']),
        ('\U0001d6a2', &['\x79']), ('\U0001d6a3', &['\x7a']), ('\U0001d6a4', &['\u0131']),
        ('\U0001d6a5', &['\u0237']), ('\U0001d6a8', &['\u0391']), ('\U0001d6a9', &['\u0392']),
        ('\U0001d6aa', &['\u0393']), ('\U0001d6ab', &['\u0394']), ('\U0001d6ac', &['\u0395']),
        ('\U0001d6ad', &['\u0396']), ('\U0001d6ae', &['\u0397']), ('\U0001d6af', &['\u0398']),
        ('\U0001d6b0', &['\u0399']), ('\U0001d6b1', &['\u039a']), ('\U0001d6b2', &['\u039b']),
        ('\U0001d6b3', &['\u039c']), ('\U0001d6b4', &['\u039d']), ('\U0001d6b5', &['\u039e']),
        ('\U0001d6b6', &['\u039f']), ('\U0001d6b7', &['\u03a0']), ('\U0001d6b8', &['\u03a1']),
        ('\U0001d6b9', &['\u03f4']), ('\U0001d6ba', &['\u03a3']), ('\U0001d6bb', &['\u03a4']),
        ('\U0001d6bc', &['\u03a5']), ('\U0001d6bd', &['\u03a6']), ('\U0001d6be', &['\u03a7']),
        ('\U0001d6bf', &['\u03a8']), ('\U0001d6c0', &['\u03a9']), ('\U0001d6c1', &['\u2207']),
        ('\U0001d6c2', &['\u03b1']), ('\U0001d6c3', &['\u03b2']), ('\U0001d6c4', &['\u03b3']),
        ('\U0001d6c5', &['\u03b4']), ('\U0001d6c6', &['\u03b5']), ('\U0001d6c7', &['\u03b6']),
        ('\U0001d6c8', &['\u03b7']), ('\U0001d6c9', &['\u03b8']), ('\U0001d6ca', &['\u03b9']),
        ('\U0001d6cb', &['\u03ba']), ('\U0001d6cc', &['\u03bb']), ('\U0001d6cd', &['\u03bc']),
        ('\U0001d6ce', &['\u03bd']), ('\U0001d6cf', &['\u03be']), ('\U0001d6d0', &['\u03bf']),
        ('\U0001d6d1', &['\u03c0']), ('\U0001d6d2', &['\u03c1']), ('\U0001d6d3', &['\u03c2']),
        ('\U0001d6d4', &['\u03c3']), ('\U0001d6d5', &['\u03c4']), ('\U0001d6d6', &['\u03c5']),
        ('\U0001d6d7', &['\u03c6']), ('\U0001d6d8', &['\u03c7']), ('\U0001d6d9', &['\u03c8']),
        ('\U0001d6da', &['\u03c9']), ('\U0001d6db', &['\u2202']), ('\U0001d6dc', &['\u03f5']),
        ('\U0001d6dd', &['\u03d1']), ('\U0001d6de', &['\u03f0']), ('\U0001d6df', &['\u03d5']),
        ('\U0001d6e0', &['\u03f1']), ('\U0001d6e1', &['\u03d6']), ('\U0001d6e2', &['\u0391']),
        ('\U0001d6e3', &['\u0392']), ('\U0001d6e4', &['\u0393']), ('\U0001d6e5', &['\u0394']),
        ('\U0001d6e6', &['\u0395']), ('\U0001d6e7', &['\u0396']), ('\U0001d6e8', &['\u0397']),
        ('\U0001d6e9', &['\u0398']), ('\U0001d6ea', &['\u0399']), ('\U0001d6eb', &['\u039a']),
        ('\U0001d6ec', &['\u039b']), ('\U0001d6ed', &['\u039c']), ('\U0001d6ee', &['\u039d']),
        ('\U0001d6ef', &['\u039e']), ('\U0001d6f0', &['\u039f']), ('\U0001d6f1', &['\u03a0']),
        ('\U0001d6f2', &['\u03a1']), ('\U0001d6f3', &['\u03f4']), ('\U0001d6f4', &['\u03a3']),
        ('\U0001d6f5', &['\u03a4']), ('\U0001d6f6', &['\u03a5']), ('\U0001d6f7', &['\u03a6']),
        ('\U0001d6f8', &['\u03a7']), ('\U0001d6f9', &['\u03a8']), ('\U0001d6fa', &['\u03a9']),
        ('\U0001d6fb', &['\u2207']), ('\U0001d6fc', &['\u03b1']), ('\U0001d6fd', &['\u03b2']),
        ('\U0001d6fe', &['\u03b3']), ('\U0001d6ff', &['\u03b4']), ('\U0001d700', &['\u03b5']),
        ('\U0001d701', &['\u03b6']), ('\U0001d702', &['\u03b7']), ('\U0001d703', &['\u03b8']),
        ('\U0001d704', &['\u03b9']), ('\U0001d705', &['\u03ba']), ('\U0001d706', &['\u03bb']),
        ('\U0001d707', &['\u03bc']), ('\U0001d708', &['\u03bd']), ('\U0001d709', &['\u03be']),
        ('\U0001d70a', &['\u03bf']), ('\U0001d70b', &['\u03c0']), ('\U0001d70c', &['\u03c1']),
        ('\U0001d70d', &['\u03c2']), ('\U0001d70e', &['\u03c3']), ('\U0001d70f', &['\u03c4']),
        ('\U0001d710', &['\u03c5']), ('\U0001d711', &['\u03c6']), ('\U0001d712', &['\u03c7']),
        ('\U0001d713', &['\u03c8']), ('\U0001d714', &['\u03c9']), ('\U0001d715', &['\u2202']),
        ('\U0001d716', &['\u03f5']), ('\U0001d717', &['\u03d1']), ('\U0001d718', &['\u03f0']),
        ('\U0001d719', &['\u03d5']), ('\U0001d71a', &['\u03f1']), ('\U0001d71b', &['\u03d6']),
        ('\U0001d71c', &['\u0391']), ('\U0001d71d', &['\u0392']), ('\U0001d71e', &['\u0393']),
        ('\U0001d71f', &['\u0394']), ('\U0001d720', &['\u0395']), ('\U0001d721', &['\u0396']),
        ('\U0001d722', &['\u0397']), ('\U0001d723', &['\u0398']), ('\U0001d724', &['\u0399']),
        ('\U0001d725', &['\u039a']), ('\U0001d726', &['\u039b']), ('\U0001d727', &['\u039c']),
        ('\U0001d728', &['\u039d']), ('\U0001d729', &['\u039e']), ('\U0001d72a', &['\u039f']),
        ('\U0001d72b', &['\u03a0']), ('\U0001d72c', &['\u03a1']), ('\U0001d72d', &['\u03f4']),
        ('\U0001d72e', &['\u03a3']), ('\U0001d72f', &['\u03a4']), ('\U0001d730', &['\u03a5']),
        ('\U0001d731', &['\u03a6']), ('\U0001d732', &['\u03a7']), ('\U0001d733', &['\u03a8']),
        ('\U0001d734', &['\u03a9']), ('\U0001d735', &['\u2207']), ('\U0001d736', &['\u03b1']),
        ('\U0001d737', &['\u03b2']), ('\U0001d738', &['\u03b3']), ('\U0001d739', &['\u03b4']),
        ('\U0001d73a', &['\u03b5']), ('\U0001d73b', &['\u03b6']), ('\U0001d73c', &['\u03b7']),
        ('\U0001d73d', &['\u03b8']), ('\U0001d73e', &['\u03b9']), ('\U0001d73f', &['\u03ba']),
        ('\U0001d740', &['\u03bb']), ('\U0001d741', &['\u03bc']), ('\U0001d742', &['\u03bd']),
        ('\U0001d743', &['\u03be']), ('\U0001d744', &['\u03bf']), ('\U0001d745', &['\u03c0']),
        ('\U0001d746', &['\u03c1']), ('\U0001d747', &['\u03c2']), ('\U0001d748', &['\u03c3']),
        ('\U0001d749', &['\u03c4']), ('\U0001d74a', &['\u03c5']), ('\U0001d74b', &['\u03c6']),
        ('\U0001d74c', &['\u03c7']), ('\U0001d74d', &['\u03c8']), ('\U0001d74e', &['\u03c9']),
        ('\U0001d74f', &['\u2202']), ('\U0001d750', &['\u03f5']), ('\U0001d751', &['\u03d1']),
        ('\U0001d752', &['\u03f0']), ('\U0001d753', &['\u03d5']), ('\U0001d754', &['\u03f1']),
        ('\U0001d755', &['\u03d6']), ('\U0001d756', &['\u0391']), ('\U0001d757', &['\u0392']),
        ('\U0001d758', &['\u0393']), ('\U0001d759', &['\u0394']), ('\U0001d75a', &['\u0395']),
        ('\U0001d75b', &['\u0396']), ('\U0001d75c', &['\u0397']), ('\U0001d75d', &['\u0398']),
        ('\U0001d75e', &['\u0399']), ('\U0001d75f', &['\u039a']), ('\U0001d760', &['\u039b']),
        ('\U0001d761', &['\u039c']), ('\U0001d762', &['\u039d']), ('\U0001d763', &['\u039e']),
        ('\U0001d764', &['\u039f']), ('\U0001d765', &['\u03a0']), ('\U0001d766', &['\u03a1']),
        ('\U0001d767', &['\u03f4']), ('\U0001d768', &['\u03a3']), ('\U0001d769', &['\u03a4']),
        ('\U0001d76a', &['\u03a5']), ('\U0001d76b', &['\u03a6']), ('\U0001d76c', &['\u03a7']),
        ('\U0001d76d', &['\u03a8']), ('\U0001d76e', &['\u03a9']), ('\U0001d76f', &['\u2207']),
        ('\U0001d770', &['\u03b1']), ('\U0001d771', &['\u03b2']), ('\U0001d772', &['\u03b3']),
        ('\U0001d773', &['\u03b4']), ('\U0001d774', &['\u03b5']), ('\U0001d775', &['\u03b6']),
        ('\U0001d776', &['\u03b7']), ('\U0001d777', &['\u03b8']), ('\U0001d778', &['\u03b9']),
        ('\U0001d779', &['\u03ba']), ('\U0001d77a', &['\u03bb']), ('\U0001d77b', &['\u03bc']),
        ('\U0001d77c', &['\u03bd']), ('\U0001d77d', &['\u03be']), ('\U0001d77e', &['\u03bf']),
        ('\U0001d77f', &['\u03c0']), ('\U0001d780', &['\u03c1']), ('\U0001d781', &['\u03c2']),
        ('\U0001d782', &['\u03c3']), ('\U0001d783', &['\u03c4']), ('\U0001d784', &['\u03c5']),
        ('\U0001d785', &['\u03c6']), ('\U0001d786', &['\u03c7']), ('\U0001d787', &['\u03c8']),
        ('\U0001d788', &['\u03c9']), ('\U0001d789', &['\u2202']), ('\U0001d78a', &['\u03f5']),
        ('\U0001d78b', &['\u03d1']), ('\U0001d78c', &['\u03f0']), ('\U0001d78d', &['\u03d5']),
        ('\U0001d78e', &['\u03f1']), ('\U0001d78f', &['\u03d6']), ('\U0001d790', &['\u0391']),
        ('\U0001d791', &['\u0392']), ('\U0001d792', &['\u0393']), ('\U0001d793', &['\u0394']),
        ('\U0001d794', &['\u0395']), ('\U0001d795', &['\u0396']), ('\U0001d796', &['\u0397']),
        ('\U0001d797', &['\u0398']), ('\U0001d798', &['\u0399']), ('\U0001d799', &['\u039a']),
        ('\U0001d79a', &['\u039b']), ('\U0001d79b', &['\u039c']), ('\U0001d79c', &['\u039d']),
        ('\U0001d79d', &['\u039e']), ('\U0001d79e', &['\u039f']), ('\U0001d79f', &['\u03a0']),
        ('\U0001d7a0', &['\u03a1']), ('\U0001d7a1', &['\u03f4']), ('\U0001d7a2', &['\u03a3']),
        ('\U0001d7a3', &['\u03a4']), ('\U0001d7a4', &['\u03a5']), ('\U0001d7a5', &['\u03a6']),
        ('\U0001d7a6', &['\u03a7']), ('\U0001d7a7', &['\u03a8']), ('\U0001d7a8', &['\u03a9']),
        ('\U0001d7a9', &['\u2207']), ('\U0001d7aa', &['\u03b1']), ('\U0001d7ab', &['\u03b2']),
        ('\U0001d7ac', &['\u03b3']), ('\U0001d7ad', &['\u03b4']), ('\U0001d7ae', &['\u03b5']),
        ('\U0001d7af', &['\u03b6']), ('\U0001d7b0', &['\u03b7']), ('\U0001d7b1', &['\u03b8']),
        ('\U0001d7b2', &['\u03b9']), ('\U0001d7b3', &['\u03ba']), ('\U0001d7b4', &['\u03bb']),
        ('\U0001d7b5', &['\u03bc']), ('\U0001d7b6', &['\u03bd']), ('\U0001d7b7', &['\u03be']),
        ('\U0001d7b8', &['\u03bf']), ('\U0001d7b9', &['\u03c0']), ('\U0001d7ba', &['\u03c1']),
        ('\U0001d7bb', &['\u03c2']), ('\U0001d7bc', &['\u03c3']), ('\U0001d7bd', &['\u03c4']),
        ('\U0001d7be', &['\u03c5']), ('\U0001d7bf', &['\u03c6']), ('\U0001d7c0', &['\u03c7']),
        ('\U0001d7c1', &['\u03c8']), ('\U0001d7c2', &['\u03c9']), ('\U0001d7c3', &['\u2202']),
        ('\U0001d7c4', &['\u03f5']), ('\U0001d7c5', &['\u03d1']), ('\U0001d7c6', &['\u03f0']),
        ('\U0001d7c7', &['\u03d5']), ('\U0001d7c8', &['\u03f1']), ('\U0001d7c9', &['\u03d6']),
        ('\U0001d7ca', &['\u03dc']), ('\U0001d7cb', &['\u03dd']), ('\U0001d7ce', &['\x30']),
        ('\U0001d7cf', &['\x31']), ('\U0001d7d0', &['\x32']), ('\U0001d7d1', &['\x33']),
        ('\U0001d7d2', &['\x34']), ('\U0001d7d3', &['\x35']), ('\U0001d7d4', &['\x36']),
        ('\U0001d7d5', &['\x37']), ('\U0001d7d6', &['\x38']), ('\U0001d7d7', &['\x39']),
        ('\U0001d7d8', &['\x30']), ('\U0001d7d9', &['\x31']), ('\U0001d7da', &['\x32']),
        ('\U0001d7db', &['\x33']), ('\U0001d7dc', &['\x34']), ('\U0001d7dd', &['\x35']),
        ('\U0001d7de', &['\x36']), ('\U0001d7df', &['\x37']), ('\U0001d7e0', &['\x38']),
        ('\U0001d7e1', &['\x39']), ('\U0001d7e2', &['\x30']), ('\U0001d7e3', &['\x31']),
        ('\U0001d7e4', &['\x32']), ('\U0001d7e5', &['\x33']), ('\U0001d7e6', &['\x34']),
        ('\U0001d7e7', &['\x35']), ('\U0001d7e8', &['\x36']), ('\U0001d7e9', &['\x37']),
        ('\U0001d7ea', &['\x38']), ('\U0001d7eb', &['\x39']), ('\U0001d7ec', &['\x30']),
        ('\U0001d7ed', &['\x31']), ('\U0001d7ee', &['\x32']), ('\U0001d7ef', &['\x33']),
        ('\U0001d7f0', &['\x34']), ('\U0001d7f1', &['\x35']), ('\U0001d7f2', &['\x36']),
        ('\U0001d7f3', &['\x37']), ('\U0001d7f4', &['\x38']), ('\U0001d7f5', &['\x39']),
        ('\U0001d7f6', &['\x30']), ('\U0001d7f7', &['\x31']), ('\U0001d7f8', &['\x32']),
        ('\U0001d7f9', &['\x33']), ('\U0001d7fa', &['\x34']), ('\U0001d7fb', &['\x35']),
        ('\U0001d7fc', &['\x36']), ('\U0001d7fd', &['\x37']), ('\U0001d7fe', &['\x38']),
        ('\U0001d7ff', &['\x39']), ('\U0001ee00', &['\u0627']), ('\U0001ee01', &['\u0628']),
        ('\U0001ee02', &['\u062c']), ('\U0001ee03', &['\u062f']), ('\U0001ee05', &['\u0648']),
        ('\U0001ee06', &['\u0632']), ('\U0001ee07', &['\u062d']), ('\U0001ee08', &['\u0637']),
        ('\U0001ee09', &['\u064a']), ('\U0001ee0a', &['\u0643']), ('\U0001ee0b', &['\u0644']),
        ('\U0001ee0c', &['\u0645']), ('\U0001ee0d', &['\u0646']), ('\U0001ee0e', &['\u0633']),
        ('\U0001ee0f', &['\u0639']), ('\U0001ee10', &['\u0641']), ('\U0001ee11', &['\u0635']),
        ('\U0001ee12', &['\u0642']), ('\U0001ee13', &['\u0631']), ('\U0001ee14', &['\u0634']),
        ('\U0001ee15', &['\u062a']), ('\U0001ee16', &['\u062b']), ('\U0001ee17', &['\u062e']),
        ('\U0001ee18', &['\u0630']), ('\U0001ee19', &['\u0636']), ('\U0001ee1a', &['\u0638']),
        ('\U0001ee1b', &['\u063a']), ('\U0001ee1c', &['\u066e']), ('\U0001ee1d', &['\u06ba']),
        ('\U0001ee1e', &['\u06a1']), ('\U0001ee1f', &['\u066f']), ('\U0001ee21', &['\u0628']),
        ('\U0001ee22', &['\u062c']), ('\U0001ee24', &['\u0647']), ('\U0001ee27', &['\u062d']),
        ('\U0001ee29', &['\u064a']), ('\U0001ee2a', &['\u0643']), ('\U0001ee2b', &['\u0644']),
        ('\U0001ee2c', &['\u0645']), ('\U0001ee2d', &['\u0646']), ('\U0001ee2e', &['\u0633']),
        ('\U0001ee2f', &['\u0639']), ('\U0001ee30', &['\u0641']), ('\U0001ee31', &['\u0635']),
        ('\U0001ee32', &['\u0642']), ('\U0001ee34', &['\u0634']), ('\U0001ee35', &['\u062a']),
        ('\U0001ee36', &['\u062b']), ('\U0001ee37', &['\u062e']), ('\U0001ee39', &['\u0636']),
        ('\U0001ee3b', &['\u063a']), ('\U0001ee42', &['\u062c']), ('\U0001ee47', &['\u062d']),
        ('\U0001ee49', &['\u064a']), ('\U0001ee4b', &['\u0644']), ('\U0001ee4d', &['\u0646']),
        ('\U0001ee4e', &['\u0633']), ('\U0001ee4f', &['\u0639']), ('\U0001ee51', &['\u0635']),
        ('\U0001ee52', &['\u0642']), ('\U0001ee54', &['\u0634']), ('\U0001ee57', &['\u062e']),
        ('\U0001ee59', &['\u0636']), ('\U0001ee5b', &['\u063a']), ('\U0001ee5d', &['\u06ba']),
        ('\U0001ee5f', &['\u066f']), ('\U0001ee61', &['\u0628']), ('\U0001ee62', &['\u062c']),
        ('\U0001ee64', &['\u0647']), ('\U0001ee67', &['\u062d']), ('\U0001ee68', &['\u0637']),
        ('\U0001ee69', &['\u064a']), ('\U0001ee6a', &['\u0643']), ('\U0001ee6c', &['\u0645']),
        ('\U0001ee6d', &['\u0646']), ('\U0001ee6e', &['\u0633']), ('\U0001ee6f', &['\u0639']),
        ('\U0001ee70', &['\u0641']), ('\U0001ee71', &['\u0635']), ('\U0001ee72', &['\u0642']),
        ('\U0001ee74', &['\u0634']), ('\U0001ee75', &['\u062a']), ('\U0001ee76', &['\u062b']),
        ('\U0001ee77', &['\u062e']), ('\U0001ee79', &['\u0636']), ('\U0001ee7a', &['\u0638']),
        ('\U0001ee7b', &['\u063a']), ('\U0001ee7c', &['\u066e']), ('\U0001ee7e', &['\u06a1']),
        ('\U0001ee80', &['\u0627']), ('\U0001ee81', &['\u0628']), ('\U0001ee82', &['\u062c']),
        ('\U0001ee83', &['\u062f']), ('\U0001ee84', &['\u0647']), ('\U0001ee85', &['\u0648']),
        ('\U0001ee86', &['\u0632']), ('\U0001ee87', &['\u062d']), ('\U0001ee88', &['\u0637']),
        ('\U0001ee89', &['\u064a']), ('\U0001ee8b', &['\u0644']), ('\U0001ee8c', &['\u0645']),
        ('\U0001ee8d', &['\u0646']), ('\U0001ee8e', &['\u0633']), ('\U0001ee8f', &['\u0639']),
        ('\U0001ee90', &['\u0641']), ('\U0001ee91', &['\u0635']), ('\U0001ee92', &['\u0642']),
        ('\U0001ee93', &['\u0631']), ('\U0001ee94', &['\u0634']), ('\U0001ee95', &['\u062a']),
        ('\U0001ee96', &['\u062b']), ('\U0001ee97', &['\u062e']), ('\U0001ee98', &['\u0630']),
        ('\U0001ee99', &['\u0636']), ('\U0001ee9a', &['\u0638']), ('\U0001ee9b', &['\u063a']),
        ('\U0001eea1', &['\u0628']), ('\U0001eea2', &['\u062c']), ('\U0001eea3', &['\u062f']),
        ('\U0001eea5', &['\u0648']), ('\U0001eea6', &['\u0632']), ('\U0001eea7', &['\u062d']),
        ('\U0001eea8', &['\u0637']), ('\U0001eea9', &['\u064a']), ('\U0001eeab', &['\u0644']),
        ('\U0001eeac', &['\u0645']), ('\U0001eead', &['\u0646']), ('\U0001eeae', &['\u0633']),
        ('\U0001eeaf', &['\u0639']), ('\U0001eeb0', &['\u0641']), ('\U0001eeb1', &['\u0635']),
        ('\U0001eeb2', &['\u0642']), ('\U0001eeb3', &['\u0631']), ('\U0001eeb4', &['\u0634']),
        ('\U0001eeb5', &['\u062a']), ('\U0001eeb6', &['\u062b']), ('\U0001eeb7', &['\u062e']),
        ('\U0001eeb8', &['\u0630']), ('\U0001eeb9', &['\u0636']), ('\U0001eeba', &['\u0638']),
        ('\U0001eebb', &['\u063a']), ('\U0001f100', &['\x30', '\x2e']), ('\U0001f101', &['\x30',
        '\x2c']), ('\U0001f102', &['\x31', '\x2c']), ('\U0001f103', &['\x32', '\x2c']),
        ('\U0001f104', &['\x33', '\x2c']), ('\U0001f105', &['\x34', '\x2c']), ('\U0001f106',
        &['\x35', '\x2c']), ('\U0001f107', &['\x36', '\x2c']), ('\U0001f108', &['\x37', '\x2c']),
        ('\U0001f109', &['\x38', '\x2c']), ('\U0001f10a', &['\x39', '\x2c']), ('\U0001f110',
        &['\x28', '\x41', '\x29']), ('\U0001f111', &['\x28', '\x42', '\x29']), ('\U0001f112',
        &['\x28', '\x43', '\x29']), ('\U0001f113', &['\x28', '\x44', '\x29']), ('\U0001f114',
        &['\x28', '\x45', '\x29']), ('\U0001f115', &['\x28', '\x46', '\x29']), ('\U0001f116',
        &['\x28', '\x47', '\x29']), ('\U0001f117', &['\x28', '\x48', '\x29']), ('\U0001f118',
        &['\x28', '\x49', '\x29']), ('\U0001f119', &['\x28', '\x4a', '\x29']), ('\U0001f11a',
        &['\x28', '\x4b', '\x29']), ('\U0001f11b', &['\x28', '\x4c', '\x29']), ('\U0001f11c',
        &['\x28', '\x4d', '\x29']), ('\U0001f11d', &['\x28', '\x4e', '\x29']), ('\U0001f11e',
        &['\x28', '\x4f', '\x29']), ('\U0001f11f', &['\x28', '\x50', '\x29']), ('\U0001f120',
        &['\x28', '\x51', '\x29']), ('\U0001f121', &['\x28', '\x52', '\x29']), ('\U0001f122',
        &['\x28', '\x53', '\x29']), ('\U0001f123', &['\x28', '\x54', '\x29']), ('\U0001f124',
        &['\x28', '\x55', '\x29']), ('\U0001f125', &['\x28', '\x56', '\x29']), ('\U0001f126',
        &['\x28', '\x57', '\x29']), ('\U0001f127', &['\x28', '\x58', '\x29']), ('\U0001f128',
        &['\x28', '\x59', '\x29']), ('\U0001f129', &['\x28', '\x5a', '\x29']), ('\U0001f12a',
        &['\u3014', '\x53', '\u3015']), ('\U0001f12b', &['\x43']), ('\U0001f12c', &['\x52']),
        ('\U0001f12d', &['\x43', '\x44']), ('\U0001f12e', &['\x57', '\x5a']), ('\U0001f130',
        &['\x41']), ('\U0001f131', &['\x42']), ('\U0001f132', &['\x43']), ('\U0001f133', &['\x44']),
        ('\U0001f134', &['\x45']), ('\U0001f135', &['\x46']), ('\U0001f136', &['\x47']),
        ('\U0001f137', &['\x48']), ('\U0001f138', &['\x49']), ('\U0001f139', &['\x4a']),
        ('\U0001f13a', &['\x4b']), ('\U0001f13b', &['\x4c']), ('\U0001f13c', &['\x4d']),
        ('\U0001f13d', &['\x4e']), ('\U0001f13e', &['\x4f']), ('\U0001f13f', &['\x50']),
        ('\U0001f140', &['\x51']), ('\U0001f141', &['\x52']), ('\U0001f142', &['\x53']),
        ('\U0001f143', &['\x54']), ('\U0001f144', &['\x55']), ('\U0001f145', &['\x56']),
        ('\U0001f146', &['\x57']), ('\U0001f147', &['\x58']), ('\U0001f148', &['\x59']),
        ('\U0001f149', &['\x5a']), ('\U0001f14a', &['\x48', '\x56']), ('\U0001f14b', &['\x4d',
        '\x56']), ('\U0001f14c', &['\x53', '\x44']), ('\U0001f14d', &['\x53', '\x53']),
        ('\U0001f14e', &['\x50', '\x50', '\x56']), ('\U0001f14f', &['\x57', '\x43']), ('\U0001f16a',
        &['\x4d', '\x43']), ('\U0001f16b', &['\x4d', '\x44']), ('\U0001f190', &['\x44', '\x4a']),
        ('\U0001f200', &['\u307b', '\u304b']), ('\U0001f201', &['\u30b3', '\u30b3']), ('\U0001f202',
        &['\u30b5']), ('\U0001f210', &['\u624b']), ('\U0001f211', &['\u5b57']), ('\U0001f212',
        &['\u53cc']), ('\U0001f213', &['\u30c7']), ('\U0001f214', &['\u4e8c']), ('\U0001f215',
        &['\u591a']), ('\U0001f216', &['\u89e3']), ('\U0001f217', &['\u5929']), ('\U0001f218',
        &['\u4ea4']), ('\U0001f219', &['\u6620']), ('\U0001f21a', &['\u7121']), ('\U0001f21b',
        &['\u6599']), ('\U0001f21c', &['\u524d']), ('\U0001f21d', &['\u5f8c']), ('\U0001f21e',
        &['\u518d']), ('\U0001f21f', &['\u65b0']), ('\U0001f220', &['\u521d']), ('\U0001f221',
        &['\u7d42']), ('\U0001f222', &['\u751f']), ('\U0001f223', &['\u8ca9']), ('\U0001f224',
        &['\u58f0']), ('\U0001f225', &['\u5439']), ('\U0001f226', &['\u6f14']), ('\U0001f227',
        &['\u6295']), ('\U0001f228', &['\u6355']), ('\U0001f229', &['\u4e00']), ('\U0001f22a',
        &['\u4e09']), ('\U0001f22b', &['\u904a']), ('\U0001f22c', &['\u5de6']), ('\U0001f22d',
        &['\u4e2d']), ('\U0001f22e', &['\u53f3']), ('\U0001f22f', &['\u6307']), ('\U0001f230',
        &['\u8d70']), ('\U0001f231', &['\u6253']), ('\U0001f232', &['\u7981']), ('\U0001f233',
        &['\u7a7a']), ('\U0001f234', &['\u5408']), ('\U0001f235', &['\u6e80']), ('\U0001f236',
        &['\u6709']), ('\U0001f237', &['\u6708']), ('\U0001f238', &['\u7533']), ('\U0001f239',
        &['\u5272']), ('\U0001f23a', &['\u55b6']), ('\U0001f240', &['\u3014', '\u672c', '\u3015']),
        ('\U0001f241', &['\u3014', '\u4e09', '\u3015']), ('\U0001f242', &['\u3014', '\u4e8c',
        '\u3015']), ('\U0001f243', &['\u3014', '\u5b89', '\u3015']), ('\U0001f244', &['\u3014',
        '\u70b9', '\u3015']), ('\U0001f245', &['\u3014', '\u6253', '\u3015']), ('\U0001f246',
        &['\u3014', '\u76d7', '\u3015']), ('\U0001f247', &['\u3014', '\u52dd', '\u3015']),
        ('\U0001f248', &['\u3014', '\u6557', '\u3015']), ('\U0001f250', &['\u5f97']), ('\U0001f251',
        &['\u53ef'])
    ];

    // Canonical compositions
    pub static composition_table: &'static [(char, &'static [(char, char)])] = &[
        ('\x3c', &[('\u0338', '\u226e')]), ('\x3d', &[('\u0338', '\u2260')]), ('\x3e', &[('\u0338',
        '\u226f')]), ('\x41', &[('\u0300', '\u00c0'), ('\u0301', '\u00c1'), ('\u0302', '\u00c2'),
        ('\u0303', '\u00c3'), ('\u0304', '\u0100'), ('\u0306', '\u0102'), ('\u0307', '\u0226'),
        ('\u0308', '\u00c4'), ('\u0309', '\u1ea2'), ('\u030a', '\u00c5'), ('\u030c', '\u01cd'),
        ('\u030f', '\u0200'), ('\u0311', '\u0202'), ('\u0323', '\u1ea0'), ('\u0325', '\u1e00'),
        ('\u0328', '\u0104')]), ('\x42', &[('\u0307', '\u1e02'), ('\u0323', '\u1e04'), ('\u0331',
        '\u1e06')]), ('\x43', &[('\u0301', '\u0106'), ('\u0302', '\u0108'), ('\u0307', '\u010a'),
        ('\u030c', '\u010c'), ('\u0327', '\u00c7')]), ('\x44', &[('\u0307', '\u1e0a'), ('\u030c',
        '\u010e'), ('\u0323', '\u1e0c'), ('\u0327', '\u1e10'), ('\u032d', '\u1e12'), ('\u0331',
        '\u1e0e')]), ('\x45', &[('\u0300', '\u00c8'), ('\u0301', '\u00c9'), ('\u0302', '\u00ca'),
        ('\u0303', '\u1ebc'), ('\u0304', '\u0112'), ('\u0306', '\u0114'), ('\u0307', '\u0116'),
        ('\u0308', '\u00cb'), ('\u0309', '\u1eba'), ('\u030c', '\u011a'), ('\u030f', '\u0204'),
        ('\u0311', '\u0206'), ('\u0323', '\u1eb8'), ('\u0327', '\u0228'), ('\u0328', '\u0118'),
        ('\u032d', '\u1e18'), ('\u0330', '\u1e1a')]), ('\x46', &[('\u0307', '\u1e1e')]), ('\x47',
        &[('\u0301', '\u01f4'), ('\u0302', '\u011c'), ('\u0304', '\u1e20'), ('\u0306', '\u011e'),
        ('\u0307', '\u0120'), ('\u030c', '\u01e6'), ('\u0327', '\u0122')]), ('\x48', &[('\u0302',
        '\u0124'), ('\u0307', '\u1e22'), ('\u0308', '\u1e26'), ('\u030c', '\u021e'), ('\u0323',
        '\u1e24'), ('\u0327', '\u1e28'), ('\u032e', '\u1e2a')]), ('\x49', &[('\u0300', '\u00cc'),
        ('\u0301', '\u00cd'), ('\u0302', '\u00ce'), ('\u0303', '\u0128'), ('\u0304', '\u012a'),
        ('\u0306', '\u012c'), ('\u0307', '\u0130'), ('\u0308', '\u00cf'), ('\u0309', '\u1ec8'),
        ('\u030c', '\u01cf'), ('\u030f', '\u0208'), ('\u0311', '\u020a'), ('\u0323', '\u1eca'),
        ('\u0328', '\u012e'), ('\u0330', '\u1e2c')]), ('\x4a', &[('\u0302', '\u0134')]), ('\x4b',
        &[('\u0301', '\u1e30'), ('\u030c', '\u01e8'), ('\u0323', '\u1e32'), ('\u0327', '\u0136'),
        ('\u0331', '\u1e34')]), ('\x4c', &[('\u0301', '\u0139'), ('\u030c', '\u013d'), ('\u0323',
        '\u1e36'), ('\u0327', '\u013b'), ('\u032d', '\u1e3c'), ('\u0331', '\u1e3a')]), ('\x4d',
        &[('\u0301', '\u1e3e'), ('\u0307', '\u1e40'), ('\u0323', '\u1e42')]), ('\x4e', &[('\u0300',
        '\u01f8'), ('\u0301', '\u0143'), ('\u0303', '\u00d1'), ('\u0307', '\u1e44'), ('\u030c',
        '\u0147'), ('\u0323', '\u1e46'), ('\u0327', '\u0145'), ('\u032d', '\u1e4a'), ('\u0331',
        '\u1e48')]), ('\x4f', &[('\u0300', '\u00d2'), ('\u0301', '\u00d3'), ('\u0302', '\u00d4'),
        ('\u0303', '\u00d5'), ('\u0304', '\u014c'), ('\u0306', '\u014e'), ('\u0307', '\u022e'),
        ('\u0308', '\u00d6'), ('\u0309', '\u1ece'), ('\u030b', '\u0150'), ('\u030c', '\u01d1'),
        ('\u030f', '\u020c'), ('\u0311', '\u020e'), ('\u031b', '\u01a0'), ('\u0323', '\u1ecc'),
        ('\u0328', '\u01ea')]), ('\x50', &[('\u0301', '\u1e54'), ('\u0307', '\u1e56')]), ('\x52',
        &[('\u0301', '\u0154'), ('\u0307', '\u1e58'), ('\u030c', '\u0158'), ('\u030f', '\u0210'),
        ('\u0311', '\u0212'), ('\u0323', '\u1e5a'), ('\u0327', '\u0156'), ('\u0331', '\u1e5e')]),
        ('\x53', &[('\u0301', '\u015a'), ('\u0302', '\u015c'), ('\u0307', '\u1e60'), ('\u030c',
        '\u0160'), ('\u0323', '\u1e62'), ('\u0326', '\u0218'), ('\u0327', '\u015e')]), ('\x54',
        &[('\u0307', '\u1e6a'), ('\u030c', '\u0164'), ('\u0323', '\u1e6c'), ('\u0326', '\u021a'),
        ('\u0327', '\u0162'), ('\u032d', '\u1e70'), ('\u0331', '\u1e6e')]), ('\x55', &[('\u0300',
        '\u00d9'), ('\u0301', '\u00da'), ('\u0302', '\u00db'), ('\u0303', '\u0168'), ('\u0304',
        '\u016a'), ('\u0306', '\u016c'), ('\u0308', '\u00dc'), ('\u0309', '\u1ee6'), ('\u030a',
        '\u016e'), ('\u030b', '\u0170'), ('\u030c', '\u01d3'), ('\u030f', '\u0214'), ('\u0311',
        '\u0216'), ('\u031b', '\u01af'), ('\u0323', '\u1ee4'), ('\u0324', '\u1e72'), ('\u0328',
        '\u0172'), ('\u032d', '\u1e76'), ('\u0330', '\u1e74')]), ('\x56', &[('\u0303', '\u1e7c'),
        ('\u0323', '\u1e7e')]), ('\x57', &[('\u0300', '\u1e80'), ('\u0301', '\u1e82'), ('\u0302',
        '\u0174'), ('\u0307', '\u1e86'), ('\u0308', '\u1e84'), ('\u0323', '\u1e88')]), ('\x58',
        &[('\u0307', '\u1e8a'), ('\u0308', '\u1e8c')]), ('\x59', &[('\u0300', '\u1ef2'), ('\u0301',
        '\u00dd'), ('\u0302', '\u0176'), ('\u0303', '\u1ef8'), ('\u0304', '\u0232'), ('\u0307',
        '\u1e8e'), ('\u0308', '\u0178'), ('\u0309', '\u1ef6'), ('\u0323', '\u1ef4')]), ('\x5a',
        &[('\u0301', '\u0179'), ('\u0302', '\u1e90'), ('\u0307', '\u017b'), ('\u030c', '\u017d'),
        ('\u0323', '\u1e92'), ('\u0331', '\u1e94')]), ('\x61', &[('\u0300', '\u00e0'), ('\u0301',
        '\u00e1'), ('\u0302', '\u00e2'), ('\u0303', '\u00e3'), ('\u0304', '\u0101'), ('\u0306',
        '\u0103'), ('\u0307', '\u0227'), ('\u0308', '\u00e4'), ('\u0309', '\u1ea3'), ('\u030a',
        '\u00e5'), ('\u030c', '\u01ce'), ('\u030f', '\u0201'), ('\u0311', '\u0203'), ('\u0323',
        '\u1ea1'), ('\u0325', '\u1e01'), ('\u0328', '\u0105')]), ('\x62', &[('\u0307', '\u1e03'),
        ('\u0323', '\u1e05'), ('\u0331', '\u1e07')]), ('\x63', &[('\u0301', '\u0107'), ('\u0302',
        '\u0109'), ('\u0307', '\u010b'), ('\u030c', '\u010d'), ('\u0327', '\u00e7')]), ('\x64',
        &[('\u0307', '\u1e0b'), ('\u030c', '\u010f'), ('\u0323', '\u1e0d'), ('\u0327', '\u1e11'),
        ('\u032d', '\u1e13'), ('\u0331', '\u1e0f')]), ('\x65', &[('\u0300', '\u00e8'), ('\u0301',
        '\u00e9'), ('\u0302', '\u00ea'), ('\u0303', '\u1ebd'), ('\u0304', '\u0113'), ('\u0306',
        '\u0115'), ('\u0307', '\u0117'), ('\u0308', '\u00eb'), ('\u0309', '\u1ebb'), ('\u030c',
        '\u011b'), ('\u030f', '\u0205'), ('\u0311', '\u0207'), ('\u0323', '\u1eb9'), ('\u0327',
        '\u0229'), ('\u0328', '\u0119'), ('\u032d', '\u1e19'), ('\u0330', '\u1e1b')]), ('\x66',
        &[('\u0307', '\u1e1f')]), ('\x67', &[('\u0301', '\u01f5'), ('\u0302', '\u011d'), ('\u0304',
        '\u1e21'), ('\u0306', '\u011f'), ('\u0307', '\u0121'), ('\u030c', '\u01e7'), ('\u0327',
        '\u0123')]), ('\x68', &[('\u0302', '\u0125'), ('\u0307', '\u1e23'), ('\u0308', '\u1e27'),
        ('\u030c', '\u021f'), ('\u0323', '\u1e25'), ('\u0327', '\u1e29'), ('\u032e', '\u1e2b'),
        ('\u0331', '\u1e96')]), ('\x69', &[('\u0300', '\u00ec'), ('\u0301', '\u00ed'), ('\u0302',
        '\u00ee'), ('\u0303', '\u0129'), ('\u0304', '\u012b'), ('\u0306', '\u012d'), ('\u0308',
        '\u00ef'), ('\u0309', '\u1ec9'), ('\u030c', '\u01d0'), ('\u030f', '\u0209'), ('\u0311',
        '\u020b'), ('\u0323', '\u1ecb'), ('\u0328', '\u012f'), ('\u0330', '\u1e2d')]), ('\x6a',
        &[('\u0302', '\u0135'), ('\u030c', '\u01f0')]), ('\x6b', &[('\u0301', '\u1e31'), ('\u030c',
        '\u01e9'), ('\u0323', '\u1e33'), ('\u0327', '\u0137'), ('\u0331', '\u1e35')]), ('\x6c',
        &[('\u0301', '\u013a'), ('\u030c', '\u013e'), ('\u0323', '\u1e37'), ('\u0327', '\u013c'),
        ('\u032d', '\u1e3d'), ('\u0331', '\u1e3b')]), ('\x6d', &[('\u0301', '\u1e3f'), ('\u0307',
        '\u1e41'), ('\u0323', '\u1e43')]), ('\x6e', &[('\u0300', '\u01f9'), ('\u0301', '\u0144'),
        ('\u0303', '\u00f1'), ('\u0307', '\u1e45'), ('\u030c', '\u0148'), ('\u0323', '\u1e47'),
        ('\u0327', '\u0146'), ('\u032d', '\u1e4b'), ('\u0331', '\u1e49')]), ('\x6f', &[('\u0300',
        '\u00f2'), ('\u0301', '\u00f3'), ('\u0302', '\u00f4'), ('\u0303', '\u00f5'), ('\u0304',
        '\u014d'), ('\u0306', '\u014f'), ('\u0307', '\u022f'), ('\u0308', '\u00f6'), ('\u0309',
        '\u1ecf'), ('\u030b', '\u0151'), ('\u030c', '\u01d2'), ('\u030f', '\u020d'), ('\u0311',
        '\u020f'), ('\u031b', '\u01a1'), ('\u0323', '\u1ecd'), ('\u0328', '\u01eb')]), ('\x70',
        &[('\u0301', '\u1e55'), ('\u0307', '\u1e57')]), ('\x72', &[('\u0301', '\u0155'), ('\u0307',
        '\u1e59'), ('\u030c', '\u0159'), ('\u030f', '\u0211'), ('\u0311', '\u0213'), ('\u0323',
        '\u1e5b'), ('\u0327', '\u0157'), ('\u0331', '\u1e5f')]), ('\x73', &[('\u0301', '\u015b'),
        ('\u0302', '\u015d'), ('\u0307', '\u1e61'), ('\u030c', '\u0161'), ('\u0323', '\u1e63'),
        ('\u0326', '\u0219'), ('\u0327', '\u015f')]), ('\x74', &[('\u0307', '\u1e6b'), ('\u0308',
        '\u1e97'), ('\u030c', '\u0165'), ('\u0323', '\u1e6d'), ('\u0326', '\u021b'), ('\u0327',
        '\u0163'), ('\u032d', '\u1e71'), ('\u0331', '\u1e6f')]), ('\x75', &[('\u0300', '\u00f9'),
        ('\u0301', '\u00fa'), ('\u0302', '\u00fb'), ('\u0303', '\u0169'), ('\u0304', '\u016b'),
        ('\u0306', '\u016d'), ('\u0308', '\u00fc'), ('\u0309', '\u1ee7'), ('\u030a', '\u016f'),
        ('\u030b', '\u0171'), ('\u030c', '\u01d4'), ('\u030f', '\u0215'), ('\u0311', '\u0217'),
        ('\u031b', '\u01b0'), ('\u0323', '\u1ee5'), ('\u0324', '\u1e73'), ('\u0328', '\u0173'),
        ('\u032d', '\u1e77'), ('\u0330', '\u1e75')]), ('\x76', &[('\u0303', '\u1e7d'), ('\u0323',
        '\u1e7f')]), ('\x77', &[('\u0300', '\u1e81'), ('\u0301', '\u1e83'), ('\u0302', '\u0175'),
        ('\u0307', '\u1e87'), ('\u0308', '\u1e85'), ('\u030a', '\u1e98'), ('\u0323', '\u1e89')]),
        ('\x78', &[('\u0307', '\u1e8b'), ('\u0308', '\u1e8d')]), ('\x79', &[('\u0300', '\u1ef3'),
        ('\u0301', '\u00fd'), ('\u0302', '\u0177'), ('\u0303', '\u1ef9'), ('\u0304', '\u0233'),
        ('\u0307', '\u1e8f'), ('\u0308', '\u00ff'), ('\u0309', '\u1ef7'), ('\u030a', '\u1e99'),
        ('\u0323', '\u1ef5')]), ('\x7a', &[('\u0301', '\u017a'), ('\u0302', '\u1e91'), ('\u0307',
        '\u017c'), ('\u030c', '\u017e'), ('\u0323', '\u1e93'), ('\u0331', '\u1e95')]), ('\u00a8',
        &[('\u0300', '\u1fed'), ('\u0301', '\u0385'), ('\u0342', '\u1fc1')]), ('\u00c2',
        &[('\u0300', '\u1ea6'), ('\u0301', '\u1ea4'), ('\u0303', '\u1eaa'), ('\u0309', '\u1ea8')]),
        ('\u00c4', &[('\u0304', '\u01de')]), ('\u00c5', &[('\u0301', '\u01fa')]), ('\u00c6',
        &[('\u0301', '\u01fc'), ('\u0304', '\u01e2')]), ('\u00c7', &[('\u0301', '\u1e08')]),
        ('\u00ca', &[('\u0300', '\u1ec0'), ('\u0301', '\u1ebe'), ('\u0303', '\u1ec4'), ('\u0309',
        '\u1ec2')]), ('\u00cf', &[('\u0301', '\u1e2e')]), ('\u00d4', &[('\u0300', '\u1ed2'),
        ('\u0301', '\u1ed0'), ('\u0303', '\u1ed6'), ('\u0309', '\u1ed4')]), ('\u00d5', &[('\u0301',
        '\u1e4c'), ('\u0304', '\u022c'), ('\u0308', '\u1e4e')]), ('\u00d6', &[('\u0304',
        '\u022a')]), ('\u00d8', &[('\u0301', '\u01fe')]), ('\u00dc', &[('\u0300', '\u01db'),
        ('\u0301', '\u01d7'), ('\u0304', '\u01d5'), ('\u030c', '\u01d9')]), ('\u00e2', &[('\u0300',
        '\u1ea7'), ('\u0301', '\u1ea5'), ('\u0303', '\u1eab'), ('\u0309', '\u1ea9')]), ('\u00e4',
        &[('\u0304', '\u01df')]), ('\u00e5', &[('\u0301', '\u01fb')]), ('\u00e6', &[('\u0301',
        '\u01fd'), ('\u0304', '\u01e3')]), ('\u00e7', &[('\u0301', '\u1e09')]), ('\u00ea',
        &[('\u0300', '\u1ec1'), ('\u0301', '\u1ebf'), ('\u0303', '\u1ec5'), ('\u0309', '\u1ec3')]),
        ('\u00ef', &[('\u0301', '\u1e2f')]), ('\u00f4', &[('\u0300', '\u1ed3'), ('\u0301',
        '\u1ed1'), ('\u0303', '\u1ed7'), ('\u0309', '\u1ed5')]), ('\u00f5', &[('\u0301', '\u1e4d'),
        ('\u0304', '\u022d'), ('\u0308', '\u1e4f')]), ('\u00f6', &[('\u0304', '\u022b')]),
        ('\u00f8', &[('\u0301', '\u01ff')]), ('\u00fc', &[('\u0300', '\u01dc'), ('\u0301',
        '\u01d8'), ('\u0304', '\u01d6'), ('\u030c', '\u01da')]), ('\u0102', &[('\u0300', '\u1eb0'),
        ('\u0301', '\u1eae'), ('\u0303', '\u1eb4'), ('\u0309', '\u1eb2')]), ('\u0103', &[('\u0300',
        '\u1eb1'), ('\u0301', '\u1eaf'), ('\u0303', '\u1eb5'), ('\u0309', '\u1eb3')]), ('\u0112',
        &[('\u0300', '\u1e14'), ('\u0301', '\u1e16')]), ('\u0113', &[('\u0300', '\u1e15'),
        ('\u0301', '\u1e17')]), ('\u014c', &[('\u0300', '\u1e50'), ('\u0301', '\u1e52')]),
        ('\u014d', &[('\u0300', '\u1e51'), ('\u0301', '\u1e53')]), ('\u015a', &[('\u0307',
        '\u1e64')]), ('\u015b', &[('\u0307', '\u1e65')]), ('\u0160', &[('\u0307', '\u1e66')]),
        ('\u0161', &[('\u0307', '\u1e67')]), ('\u0168', &[('\u0301', '\u1e78')]), ('\u0169',
        &[('\u0301', '\u1e79')]), ('\u016a', &[('\u0308', '\u1e7a')]), ('\u016b', &[('\u0308',
        '\u1e7b')]), ('\u017f', &[('\u0307', '\u1e9b')]), ('\u01a0', &[('\u0300', '\u1edc'),
        ('\u0301', '\u1eda'), ('\u0303', '\u1ee0'), ('\u0309', '\u1ede'), ('\u0323', '\u1ee2')]),
        ('\u01a1', &[('\u0300', '\u1edd'), ('\u0301', '\u1edb'), ('\u0303', '\u1ee1'), ('\u0309',
        '\u1edf'), ('\u0323', '\u1ee3')]), ('\u01af', &[('\u0300', '\u1eea'), ('\u0301', '\u1ee8'),
        ('\u0303', '\u1eee'), ('\u0309', '\u1eec'), ('\u0323', '\u1ef0')]), ('\u01b0', &[('\u0300',
        '\u1eeb'), ('\u0301', '\u1ee9'), ('\u0303', '\u1eef'), ('\u0309', '\u1eed'), ('\u0323',
        '\u1ef1')]), ('\u01b7', &[('\u030c', '\u01ee')]), ('\u01ea', &[('\u0304', '\u01ec')]),
        ('\u01eb', &[('\u0304', '\u01ed')]), ('\u0226', &[('\u0304', '\u01e0')]), ('\u0227',
        &[('\u0304', '\u01e1')]), ('\u0228', &[('\u0306', '\u1e1c')]), ('\u0229', &[('\u0306',
        '\u1e1d')]), ('\u022e', &[('\u0304', '\u0230')]), ('\u022f', &[('\u0304', '\u0231')]),
        ('\u0292', &[('\u030c', '\u01ef')]), ('\u0391', &[('\u0300', '\u1fba'), ('\u0301',
        '\u0386'), ('\u0304', '\u1fb9'), ('\u0306', '\u1fb8'), ('\u0313', '\u1f08'), ('\u0314',
        '\u1f09'), ('\u0345', '\u1fbc')]), ('\u0395', &[('\u0300', '\u1fc8'), ('\u0301', '\u0388'),
        ('\u0313', '\u1f18'), ('\u0314', '\u1f19')]), ('\u0397', &[('\u0300', '\u1fca'), ('\u0301',
        '\u0389'), ('\u0313', '\u1f28'), ('\u0314', '\u1f29'), ('\u0345', '\u1fcc')]), ('\u0399',
        &[('\u0300', '\u1fda'), ('\u0301', '\u038a'), ('\u0304', '\u1fd9'), ('\u0306', '\u1fd8'),
        ('\u0308', '\u03aa'), ('\u0313', '\u1f38'), ('\u0314', '\u1f39')]), ('\u039f', &[('\u0300',
        '\u1ff8'), ('\u0301', '\u038c'), ('\u0313', '\u1f48'), ('\u0314', '\u1f49')]), ('\u03a1',
        &[('\u0314', '\u1fec')]), ('\u03a5', &[('\u0300', '\u1fea'), ('\u0301', '\u038e'),
        ('\u0304', '\u1fe9'), ('\u0306', '\u1fe8'), ('\u0308', '\u03ab'), ('\u0314', '\u1f59')]),
        ('\u03a9', &[('\u0300', '\u1ffa'), ('\u0301', '\u038f'), ('\u0313', '\u1f68'), ('\u0314',
        '\u1f69'), ('\u0345', '\u1ffc')]), ('\u03ac', &[('\u0345', '\u1fb4')]), ('\u03ae',
        &[('\u0345', '\u1fc4')]), ('\u03b1', &[('\u0300', '\u1f70'), ('\u0301', '\u03ac'),
        ('\u0304', '\u1fb1'), ('\u0306', '\u1fb0'), ('\u0313', '\u1f00'), ('\u0314', '\u1f01'),
        ('\u0342', '\u1fb6'), ('\u0345', '\u1fb3')]), ('\u03b5', &[('\u0300', '\u1f72'), ('\u0301',
        '\u03ad'), ('\u0313', '\u1f10'), ('\u0314', '\u1f11')]), ('\u03b7', &[('\u0300', '\u1f74'),
        ('\u0301', '\u03ae'), ('\u0313', '\u1f20'), ('\u0314', '\u1f21'), ('\u0342', '\u1fc6'),
        ('\u0345', '\u1fc3')]), ('\u03b9', &[('\u0300', '\u1f76'), ('\u0301', '\u03af'), ('\u0304',
        '\u1fd1'), ('\u0306', '\u1fd0'), ('\u0308', '\u03ca'), ('\u0313', '\u1f30'), ('\u0314',
        '\u1f31'), ('\u0342', '\u1fd6')]), ('\u03bf', &[('\u0300', '\u1f78'), ('\u0301', '\u03cc'),
        ('\u0313', '\u1f40'), ('\u0314', '\u1f41')]), ('\u03c1', &[('\u0313', '\u1fe4'), ('\u0314',
        '\u1fe5')]), ('\u03c5', &[('\u0300', '\u1f7a'), ('\u0301', '\u03cd'), ('\u0304', '\u1fe1'),
        ('\u0306', '\u1fe0'), ('\u0308', '\u03cb'), ('\u0313', '\u1f50'), ('\u0314', '\u1f51'),
        ('\u0342', '\u1fe6')]), ('\u03c9', &[('\u0300', '\u1f7c'), ('\u0301', '\u03ce'), ('\u0313',
        '\u1f60'), ('\u0314', '\u1f61'), ('\u0342', '\u1ff6'), ('\u0345', '\u1ff3')]), ('\u03ca',
        &[('\u0300', '\u1fd2'), ('\u0301', '\u0390'), ('\u0342', '\u1fd7')]), ('\u03cb',
        &[('\u0300', '\u1fe2'), ('\u0301', '\u03b0'), ('\u0342', '\u1fe7')]), ('\u03ce',
        &[('\u0345', '\u1ff4')]), ('\u03d2', &[('\u0301', '\u03d3'), ('\u0308', '\u03d4')]),
        ('\u0406', &[('\u0308', '\u0407')]), ('\u0410', &[('\u0306', '\u04d0'), ('\u0308',
        '\u04d2')]), ('\u0413', &[('\u0301', '\u0403')]), ('\u0415', &[('\u0300', '\u0400'),
        ('\u0306', '\u04d6'), ('\u0308', '\u0401')]), ('\u0416', &[('\u0306', '\u04c1'), ('\u0308',
        '\u04dc')]), ('\u0417', &[('\u0308', '\u04de')]), ('\u0418', &[('\u0300', '\u040d'),
        ('\u0304', '\u04e2'), ('\u0306', '\u0419'), ('\u0308', '\u04e4')]), ('\u041a', &[('\u0301',
        '\u040c')]), ('\u041e', &[('\u0308', '\u04e6')]), ('\u0423', &[('\u0304', '\u04ee'),
        ('\u0306', '\u040e'), ('\u0308', '\u04f0'), ('\u030b', '\u04f2')]), ('\u0427', &[('\u0308',
        '\u04f4')]), ('\u042b', &[('\u0308', '\u04f8')]), ('\u042d', &[('\u0308', '\u04ec')]),
        ('\u0430', &[('\u0306', '\u04d1'), ('\u0308', '\u04d3')]), ('\u0433', &[('\u0301',
        '\u0453')]), ('\u0435', &[('\u0300', '\u0450'), ('\u0306', '\u04d7'), ('\u0308',
        '\u0451')]), ('\u0436', &[('\u0306', '\u04c2'), ('\u0308', '\u04dd')]), ('\u0437',
        &[('\u0308', '\u04df')]), ('\u0438', &[('\u0300', '\u045d'), ('\u0304', '\u04e3'),
        ('\u0306', '\u0439'), ('\u0308', '\u04e5')]), ('\u043a', &[('\u0301', '\u045c')]),
        ('\u043e', &[('\u0308', '\u04e7')]), ('\u0443', &[('\u0304', '\u04ef'), ('\u0306',
        '\u045e'), ('\u0308', '\u04f1'), ('\u030b', '\u04f3')]), ('\u0447', &[('\u0308',
        '\u04f5')]), ('\u044b', &[('\u0308', '\u04f9')]), ('\u044d', &[('\u0308', '\u04ed')]),
        ('\u0456', &[('\u0308', '\u0457')]), ('\u0474', &[('\u030f', '\u0476')]), ('\u0475',
        &[('\u030f', '\u0477')]), ('\u04d8', &[('\u0308', '\u04da')]), ('\u04d9', &[('\u0308',
        '\u04db')]), ('\u04e8', &[('\u0308', '\u04ea')]), ('\u04e9', &[('\u0308', '\u04eb')]),
        ('\u0627', &[('\u0653', '\u0622'), ('\u0654', '\u0623'), ('\u0655', '\u0625')]), ('\u0648',
        &[('\u0654', '\u0624')]), ('\u064a', &[('\u0654', '\u0626')]), ('\u06c1', &[('\u0654',
        '\u06c2')]), ('\u06d2', &[('\u0654', '\u06d3')]), ('\u06d5', &[('\u0654', '\u06c0')]),
        ('\u0928', &[('\u093c', '\u0929')]), ('\u0930', &[('\u093c', '\u0931')]), ('\u0933',
        &[('\u093c', '\u0934')]), ('\u09c7', &[('\u09be', '\u09cb'), ('\u09d7', '\u09cc')]),
        ('\u0b47', &[('\u0b3e', '\u0b4b'), ('\u0b56', '\u0b48'), ('\u0b57', '\u0b4c')]), ('\u0b92',
        &[('\u0bd7', '\u0b94')]), ('\u0bc6', &[('\u0bbe', '\u0bca'), ('\u0bd7', '\u0bcc')]),
        ('\u0bc7', &[('\u0bbe', '\u0bcb')]), ('\u0c46', &[('\u0c56', '\u0c48')]), ('\u0cbf',
        &[('\u0cd5', '\u0cc0')]), ('\u0cc6', &[('\u0cc2', '\u0cca'), ('\u0cd5', '\u0cc7'),
        ('\u0cd6', '\u0cc8')]), ('\u0cca', &[('\u0cd5', '\u0ccb')]), ('\u0d46', &[('\u0d3e',
        '\u0d4a'), ('\u0d57', '\u0d4c')]), ('\u0d47', &[('\u0d3e', '\u0d4b')]), ('\u0dd9',
        &[('\u0dca', '\u0dda'), ('\u0dcf', '\u0ddc'), ('\u0ddf', '\u0dde')]), ('\u0ddc',
        &[('\u0dca', '\u0ddd')]), ('\u1025', &[('\u102e', '\u1026')]), ('\u1b05', &[('\u1b35',
        '\u1b06')]), ('\u1b07', &[('\u1b35', '\u1b08')]), ('\u1b09', &[('\u1b35', '\u1b0a')]),
        ('\u1b0b', &[('\u1b35', '\u1b0c')]), ('\u1b0d', &[('\u1b35', '\u1b0e')]), ('\u1b11',
        &[('\u1b35', '\u1b12')]), ('\u1b3a', &[('\u1b35', '\u1b3b')]), ('\u1b3c', &[('\u1b35',
        '\u1b3d')]), ('\u1b3e', &[('\u1b35', '\u1b40')]), ('\u1b3f', &[('\u1b35', '\u1b41')]),
        ('\u1b42', &[('\u1b35', '\u1b43')]), ('\u1e36', &[('\u0304', '\u1e38')]), ('\u1e37',
        &[('\u0304', '\u1e39')]), ('\u1e5a', &[('\u0304', '\u1e5c')]), ('\u1e5b', &[('\u0304',
        '\u1e5d')]), ('\u1e62', &[('\u0307', '\u1e68')]), ('\u1e63', &[('\u0307', '\u1e69')]),
        ('\u1ea0', &[('\u0302', '\u1eac'), ('\u0306', '\u1eb6')]), ('\u1ea1', &[('\u0302',
        '\u1ead'), ('\u0306', '\u1eb7')]), ('\u1eb8', &[('\u0302', '\u1ec6')]), ('\u1eb9',
        &[('\u0302', '\u1ec7')]), ('\u1ecc', &[('\u0302', '\u1ed8')]), ('\u1ecd', &[('\u0302',
        '\u1ed9')]), ('\u1f00', &[('\u0300', '\u1f02'), ('\u0301', '\u1f04'), ('\u0342', '\u1f06'),
        ('\u0345', '\u1f80')]), ('\u1f01', &[('\u0300', '\u1f03'), ('\u0301', '\u1f05'), ('\u0342',
        '\u1f07'), ('\u0345', '\u1f81')]), ('\u1f02', &[('\u0345', '\u1f82')]), ('\u1f03',
        &[('\u0345', '\u1f83')]), ('\u1f04', &[('\u0345', '\u1f84')]), ('\u1f05', &[('\u0345',
        '\u1f85')]), ('\u1f06', &[('\u0345', '\u1f86')]), ('\u1f07', &[('\u0345', '\u1f87')]),
        ('\u1f08', &[('\u0300', '\u1f0a'), ('\u0301', '\u1f0c'), ('\u0342', '\u1f0e'), ('\u0345',
        '\u1f88')]), ('\u1f09', &[('\u0300', '\u1f0b'), ('\u0301', '\u1f0d'), ('\u0342', '\u1f0f'),
        ('\u0345', '\u1f89')]), ('\u1f0a', &[('\u0345', '\u1f8a')]), ('\u1f0b', &[('\u0345',
        '\u1f8b')]), ('\u1f0c', &[('\u0345', '\u1f8c')]), ('\u1f0d', &[('\u0345', '\u1f8d')]),
        ('\u1f0e', &[('\u0345', '\u1f8e')]), ('\u1f0f', &[('\u0345', '\u1f8f')]), ('\u1f10',
        &[('\u0300', '\u1f12'), ('\u0301', '\u1f14')]), ('\u1f11', &[('\u0300', '\u1f13'),
        ('\u0301', '\u1f15')]), ('\u1f18', &[('\u0300', '\u1f1a'), ('\u0301', '\u1f1c')]),
        ('\u1f19', &[('\u0300', '\u1f1b'), ('\u0301', '\u1f1d')]), ('\u1f20', &[('\u0300',
        '\u1f22'), ('\u0301', '\u1f24'), ('\u0342', '\u1f26'), ('\u0345', '\u1f90')]), ('\u1f21',
        &[('\u0300', '\u1f23'), ('\u0301', '\u1f25'), ('\u0342', '\u1f27'), ('\u0345', '\u1f91')]),
        ('\u1f22', &[('\u0345', '\u1f92')]), ('\u1f23', &[('\u0345', '\u1f93')]), ('\u1f24',
        &[('\u0345', '\u1f94')]), ('\u1f25', &[('\u0345', '\u1f95')]), ('\u1f26', &[('\u0345',
        '\u1f96')]), ('\u1f27', &[('\u0345', '\u1f97')]), ('\u1f28', &[('\u0300', '\u1f2a'),
        ('\u0301', '\u1f2c'), ('\u0342', '\u1f2e'), ('\u0345', '\u1f98')]), ('\u1f29', &[('\u0300',
        '\u1f2b'), ('\u0301', '\u1f2d'), ('\u0342', '\u1f2f'), ('\u0345', '\u1f99')]), ('\u1f2a',
        &[('\u0345', '\u1f9a')]), ('\u1f2b', &[('\u0345', '\u1f9b')]), ('\u1f2c', &[('\u0345',
        '\u1f9c')]), ('\u1f2d', &[('\u0345', '\u1f9d')]), ('\u1f2e', &[('\u0345', '\u1f9e')]),
        ('\u1f2f', &[('\u0345', '\u1f9f')]), ('\u1f30', &[('\u0300', '\u1f32'), ('\u0301',
        '\u1f34'), ('\u0342', '\u1f36')]), ('\u1f31', &[('\u0300', '\u1f33'), ('\u0301', '\u1f35'),
        ('\u0342', '\u1f37')]), ('\u1f38', &[('\u0300', '\u1f3a'), ('\u0301', '\u1f3c'), ('\u0342',
        '\u1f3e')]), ('\u1f39', &[('\u0300', '\u1f3b'), ('\u0301', '\u1f3d'), ('\u0342',
        '\u1f3f')]), ('\u1f40', &[('\u0300', '\u1f42'), ('\u0301', '\u1f44')]), ('\u1f41',
        &[('\u0300', '\u1f43'), ('\u0301', '\u1f45')]), ('\u1f48', &[('\u0300', '\u1f4a'),
        ('\u0301', '\u1f4c')]), ('\u1f49', &[('\u0300', '\u1f4b'), ('\u0301', '\u1f4d')]),
        ('\u1f50', &[('\u0300', '\u1f52'), ('\u0301', '\u1f54'), ('\u0342', '\u1f56')]), ('\u1f51',
        &[('\u0300', '\u1f53'), ('\u0301', '\u1f55'), ('\u0342', '\u1f57')]), ('\u1f59',
        &[('\u0300', '\u1f5b'), ('\u0301', '\u1f5d'), ('\u0342', '\u1f5f')]), ('\u1f60',
        &[('\u0300', '\u1f62'), ('\u0301', '\u1f64'), ('\u0342', '\u1f66'), ('\u0345', '\u1fa0')]),
        ('\u1f61', &[('\u0300', '\u1f63'), ('\u0301', '\u1f65'), ('\u0342', '\u1f67'), ('\u0345',
        '\u1fa1')]), ('\u1f62', &[('\u0345', '\u1fa2')]), ('\u1f63', &[('\u0345', '\u1fa3')]),
        ('\u1f64', &[('\u0345', '\u1fa4')]), ('\u1f65', &[('\u0345', '\u1fa5')]), ('\u1f66',
        &[('\u0345', '\u1fa6')]), ('\u1f67', &[('\u0345', '\u1fa7')]), ('\u1f68', &[('\u0300',
        '\u1f6a'), ('\u0301', '\u1f6c'), ('\u0342', '\u1f6e'), ('\u0345', '\u1fa8')]), ('\u1f69',
        &[('\u0300', '\u1f6b'), ('\u0301', '\u1f6d'), ('\u0342', '\u1f6f'), ('\u0345', '\u1fa9')]),
        ('\u1f6a', &[('\u0345', '\u1faa')]), ('\u1f6b', &[('\u0345', '\u1fab')]), ('\u1f6c',
        &[('\u0345', '\u1fac')]), ('\u1f6d', &[('\u0345', '\u1fad')]), ('\u1f6e', &[('\u0345',
        '\u1fae')]), ('\u1f6f', &[('\u0345', '\u1faf')]), ('\u1f70', &[('\u0345', '\u1fb2')]),
        ('\u1f74', &[('\u0345', '\u1fc2')]), ('\u1f7c', &[('\u0345', '\u1ff2')]), ('\u1fb6',
        &[('\u0345', '\u1fb7')]), ('\u1fbf', &[('\u0300', '\u1fcd'), ('\u0301', '\u1fce'),
        ('\u0342', '\u1fcf')]), ('\u1fc6', &[('\u0345', '\u1fc7')]), ('\u1ff6', &[('\u0345',
        '\u1ff7')]), ('\u1ffe', &[('\u0300', '\u1fdd'), ('\u0301', '\u1fde'), ('\u0342',
        '\u1fdf')]), ('\u2190', &[('\u0338', '\u219a')]), ('\u2192', &[('\u0338', '\u219b')]),
        ('\u2194', &[('\u0338', '\u21ae')]), ('\u21d0', &[('\u0338', '\u21cd')]), ('\u21d2',
        &[('\u0338', '\u21cf')]), ('\u21d4', &[('\u0338', '\u21ce')]), ('\u2203', &[('\u0338',
        '\u2204')]), ('\u2208', &[('\u0338', '\u2209')]), ('\u220b', &[('\u0338', '\u220c')]),
        ('\u2223', &[('\u0338', '\u2224')]), ('\u2225', &[('\u0338', '\u2226')]), ('\u223c',
        &[('\u0338', '\u2241')]), ('\u2243', &[('\u0338', '\u2244')]), ('\u2245', &[('\u0338',
        '\u2247')]), ('\u2248', &[('\u0338', '\u2249')]), ('\u224d', &[('\u0338', '\u226d')]),
        ('\u2261', &[('\u0338', '\u2262')]), ('\u2264', &[('\u0338', '\u2270')]), ('\u2265',
        &[('\u0338', '\u2271')]), ('\u2272', &[('\u0338', '\u2274')]), ('\u2273', &[('\u0338',
        '\u2275')]), ('\u2276', &[('\u0338', '\u2278')]), ('\u2277', &[('\u0338', '\u2279')]),
        ('\u227a', &[('\u0338', '\u2280')]), ('\u227b', &[('\u0338', '\u2281')]), ('\u227c',
        &[('\u0338', '\u22e0')]), ('\u227d', &[('\u0338', '\u22e1')]), ('\u2282', &[('\u0338',
        '\u2284')]), ('\u2283', &[('\u0338', '\u2285')]), ('\u2286', &[('\u0338', '\u2288')]),
        ('\u2287', &[('\u0338', '\u2289')]), ('\u2291', &[('\u0338', '\u22e2')]), ('\u2292',
        &[('\u0338', '\u22e3')]), ('\u22a2', &[('\u0338', '\u22ac')]), ('\u22a8', &[('\u0338',
        '\u22ad')]), ('\u22a9', &[('\u0338', '\u22ae')]), ('\u22ab', &[('\u0338', '\u22af')]),
        ('\u22b2', &[('\u0338', '\u22ea')]), ('\u22b3', &[('\u0338', '\u22eb')]), ('\u22b4',
        &[('\u0338', '\u22ec')]), ('\u22b5', &[('\u0338', '\u22ed')]), ('\u3046', &[('\u3099',
        '\u3094')]), ('\u304b', &[('\u3099', '\u304c')]), ('\u304d', &[('\u3099', '\u304e')]),
        ('\u304f', &[('\u3099', '\u3050')]), ('\u3051', &[('\u3099', '\u3052')]), ('\u3053',
        &[('\u3099', '\u3054')]), ('\u3055', &[('\u3099', '\u3056')]), ('\u3057', &[('\u3099',
        '\u3058')]), ('\u3059', &[('\u3099', '\u305a')]), ('\u305b', &[('\u3099', '\u305c')]),
        ('\u305d', &[('\u3099', '\u305e')]), ('\u305f', &[('\u3099', '\u3060')]), ('\u3061',
        &[('\u3099', '\u3062')]), ('\u3064', &[('\u3099', '\u3065')]), ('\u3066', &[('\u3099',
        '\u3067')]), ('\u3068', &[('\u3099', '\u3069')]), ('\u306f', &[('\u3099', '\u3070'),
        ('\u309a', '\u3071')]), ('\u3072', &[('\u3099', '\u3073'), ('\u309a', '\u3074')]),
        ('\u3075', &[('\u3099', '\u3076'), ('\u309a', '\u3077')]), ('\u3078', &[('\u3099',
        '\u3079'), ('\u309a', '\u307a')]), ('\u307b', &[('\u3099', '\u307c'), ('\u309a',
        '\u307d')]), ('\u309d', &[('\u3099', '\u309e')]), ('\u30a6', &[('\u3099', '\u30f4')]),
        ('\u30ab', &[('\u3099', '\u30ac')]), ('\u30ad', &[('\u3099', '\u30ae')]), ('\u30af',
        &[('\u3099', '\u30b0')]), ('\u30b1', &[('\u3099', '\u30b2')]), ('\u30b3', &[('\u3099',
        '\u30b4')]), ('\u30b5', &[('\u3099', '\u30b6')]), ('\u30b7', &[('\u3099', '\u30b8')]),
        ('\u30b9', &[('\u3099', '\u30ba')]), ('\u30bb', &[('\u3099', '\u30bc')]), ('\u30bd',
        &[('\u3099', '\u30be')]), ('\u30bf', &[('\u3099', '\u30c0')]), ('\u30c1', &[('\u3099',
        '\u30c2')]), ('\u30c4', &[('\u3099', '\u30c5')]), ('\u30c6', &[('\u3099', '\u30c7')]),
        ('\u30c8', &[('\u3099', '\u30c9')]), ('\u30cf', &[('\u3099', '\u30d0'), ('\u309a',
        '\u30d1')]), ('\u30d2', &[('\u3099', '\u30d3'), ('\u309a', '\u30d4')]), ('\u30d5',
        &[('\u3099', '\u30d6'), ('\u309a', '\u30d7')]), ('\u30d8', &[('\u3099', '\u30d9'),
        ('\u309a', '\u30da')]), ('\u30db', &[('\u3099', '\u30dc'), ('\u309a', '\u30dd')]),
        ('\u30ef', &[('\u3099', '\u30f7')]), ('\u30f0', &[('\u3099', '\u30f8')]), ('\u30f1',
        &[('\u3099', '\u30f9')]), ('\u30f2', &[('\u3099', '\u30fa')]), ('\u30fd', &[('\u3099',
        '\u30fe')]), ('\U00011099', &[('\U000110ba', '\U0001109a')]), ('\U0001109b',
        &[('\U000110ba', '\U0001109c')]), ('\U000110a5', &[('\U000110ba', '\U000110ab')]),
        ('\U00011131', &[('\U00011127', '\U0001112e')]), ('\U00011132', &[('\U00011127',
        '\U0001112f')]), ('\U00011347', &[('\U0001133e', '\U0001134b'), ('\U00011357',
        '\U0001134c')]), ('\U000114b9', &[('\U000114b0', '\U000114bc'), ('\U000114ba',
        '\U000114bb'), ('\U000114bd', '\U000114be')]), ('\U000115b8', &[('\U000115af',
        '\U000115ba')]), ('\U000115b9', &[('\U000115af', '\U000115bb')])
    ];


    fn bsearch_range_value_table(c: char, r: &'static [(char, char, u8)]) -> u8 {
        use core::cmp::{Equal, Less, Greater};
        use core::slice::SlicePrelude;
        use core::slice;
        match r.binary_search(|&(lo, hi, _)| {
            if lo <= c && c <= hi { Equal }
            else if hi < c { Less }
            else { Greater }
        }) {
            slice::Found(idx) => {
                let (_, _, result) = r[idx];
                result
            }
            slice::NotFound(_) => 0
        }
    }

    static combining_class_table: &'static [(char, char, u8)] = &[
        ('\u0300', '\u0314', 230), ('\u0315', '\u0315', 232), ('\u0316', '\u0319', 220), ('\u031a',
        '\u031a', 232), ('\u031b', '\u031b', 216), ('\u031c', '\u0320', 220), ('\u0321', '\u0322',
        202), ('\u0323', '\u0326', 220), ('\u0327', '\u0328', 202), ('\u0329', '\u0333', 220),
        ('\u0334', '\u0338', 1), ('\u0339', '\u033c', 220), ('\u033d', '\u0344', 230), ('\u0345',
        '\u0345', 240), ('\u0346', '\u0346', 230), ('\u0347', '\u0349', 220), ('\u034a', '\u034c',
        230), ('\u034d', '\u034e', 220), ('\u0350', '\u0352', 230), ('\u0353', '\u0356', 220),
        ('\u0357', '\u0357', 230), ('\u0358', '\u0358', 232), ('\u0359', '\u035a', 220), ('\u035b',
        '\u035b', 230), ('\u035c', '\u035c', 233), ('\u035d', '\u035e', 234), ('\u035f', '\u035f',
        233), ('\u0360', '\u0361', 234), ('\u0362', '\u0362', 233), ('\u0363', '\u036f', 230),
        ('\u0483', '\u0487', 230), ('\u0591', '\u0591', 220), ('\u0592', '\u0595', 230), ('\u0596',
        '\u0596', 220), ('\u0597', '\u0599', 230), ('\u059a', '\u059a', 222), ('\u059b', '\u059b',
        220), ('\u059c', '\u05a1', 230), ('\u05a2', '\u05a7', 220), ('\u05a8', '\u05a9', 230),
        ('\u05aa', '\u05aa', 220), ('\u05ab', '\u05ac', 230), ('\u05ad', '\u05ad', 222), ('\u05ae',
        '\u05ae', 228), ('\u05af', '\u05af', 230), ('\u05b0', '\u05b0', 10), ('\u05b1', '\u05b1',
        11), ('\u05b2', '\u05b2', 12), ('\u05b3', '\u05b3', 13), ('\u05b4', '\u05b4', 14),
        ('\u05b5', '\u05b5', 15), ('\u05b6', '\u05b6', 16), ('\u05b7', '\u05b7', 17), ('\u05b8',
        '\u05b8', 18), ('\u05b9', '\u05ba', 19), ('\u05bb', '\u05bb', 20), ('\u05bc', '\u05bc', 21),
        ('\u05bd', '\u05bd', 22), ('\u05bf', '\u05bf', 23), ('\u05c1', '\u05c1', 24), ('\u05c2',
        '\u05c2', 25), ('\u05c4', '\u05c4', 230), ('\u05c5', '\u05c5', 220), ('\u05c7', '\u05c7',
        18), ('\u0610', '\u0617', 230), ('\u0618', '\u0618', 30), ('\u0619', '\u0619', 31),
        ('\u061a', '\u061a', 32), ('\u064b', '\u064b', 27), ('\u064c', '\u064c', 28), ('\u064d',
        '\u064d', 29), ('\u064e', '\u064e', 30), ('\u064f', '\u064f', 31), ('\u0650', '\u0650', 32),
        ('\u0651', '\u0651', 33), ('\u0652', '\u0652', 34), ('\u0653', '\u0654', 230), ('\u0655',
        '\u0656', 220), ('\u0657', '\u065b', 230), ('\u065c', '\u065c', 220), ('\u065d', '\u065e',
        230), ('\u065f', '\u065f', 220), ('\u0670', '\u0670', 35), ('\u06d6', '\u06dc', 230),
        ('\u06df', '\u06e2', 230), ('\u06e3', '\u06e3', 220), ('\u06e4', '\u06e4', 230), ('\u06e7',
        '\u06e8', 230), ('\u06ea', '\u06ea', 220), ('\u06eb', '\u06ec', 230), ('\u06ed', '\u06ed',
        220), ('\u0711', '\u0711', 36), ('\u0730', '\u0730', 230), ('\u0731', '\u0731', 220),
        ('\u0732', '\u0733', 230), ('\u0734', '\u0734', 220), ('\u0735', '\u0736', 230), ('\u0737',
        '\u0739', 220), ('\u073a', '\u073a', 230), ('\u073b', '\u073c', 220), ('\u073d', '\u073d',
        230), ('\u073e', '\u073e', 220), ('\u073f', '\u0741', 230), ('\u0742', '\u0742', 220),
        ('\u0743', '\u0743', 230), ('\u0744', '\u0744', 220), ('\u0745', '\u0745', 230), ('\u0746',
        '\u0746', 220), ('\u0747', '\u0747', 230), ('\u0748', '\u0748', 220), ('\u0749', '\u074a',
        230), ('\u07eb', '\u07f1', 230), ('\u07f2', '\u07f2', 220), ('\u07f3', '\u07f3', 230),
        ('\u0816', '\u0819', 230), ('\u081b', '\u0823', 230), ('\u0825', '\u0827', 230), ('\u0829',
        '\u082d', 230), ('\u0859', '\u085b', 220), ('\u08e4', '\u08e5', 230), ('\u08e6', '\u08e6',
        220), ('\u08e7', '\u08e8', 230), ('\u08e9', '\u08e9', 220), ('\u08ea', '\u08ec', 230),
        ('\u08ed', '\u08ef', 220), ('\u08f0', '\u08f0', 27), ('\u08f1', '\u08f1', 28), ('\u08f2',
        '\u08f2', 29), ('\u08f3', '\u08f5', 230), ('\u08f6', '\u08f6', 220), ('\u08f7', '\u08f8',
        230), ('\u08f9', '\u08fa', 220), ('\u08fb', '\u08ff', 230), ('\u093c', '\u093c', 7),
        ('\u094d', '\u094d', 9), ('\u0951', '\u0951', 230), ('\u0952', '\u0952', 220), ('\u0953',
        '\u0954', 230), ('\u09bc', '\u09bc', 7), ('\u09cd', '\u09cd', 9), ('\u0a3c', '\u0a3c', 7),
        ('\u0a4d', '\u0a4d', 9), ('\u0abc', '\u0abc', 7), ('\u0acd', '\u0acd', 9), ('\u0b3c',
        '\u0b3c', 7), ('\u0b4d', '\u0b4d', 9), ('\u0bcd', '\u0bcd', 9), ('\u0c4d', '\u0c4d', 9),
        ('\u0c55', '\u0c55', 84), ('\u0c56', '\u0c56', 91), ('\u0cbc', '\u0cbc', 7), ('\u0ccd',
        '\u0ccd', 9), ('\u0d4d', '\u0d4d', 9), ('\u0dca', '\u0dca', 9), ('\u0e38', '\u0e39', 103),
        ('\u0e3a', '\u0e3a', 9), ('\u0e48', '\u0e4b', 107), ('\u0eb8', '\u0eb9', 118), ('\u0ec8',
        '\u0ecb', 122), ('\u0f18', '\u0f19', 220), ('\u0f35', '\u0f35', 220), ('\u0f37', '\u0f37',
        220), ('\u0f39', '\u0f39', 216), ('\u0f71', '\u0f71', 129), ('\u0f72', '\u0f72', 130),
        ('\u0f74', '\u0f74', 132), ('\u0f7a', '\u0f7d', 130), ('\u0f80', '\u0f80', 130), ('\u0f82',
        '\u0f83', 230), ('\u0f84', '\u0f84', 9), ('\u0f86', '\u0f87', 230), ('\u0fc6', '\u0fc6',
        220), ('\u1037', '\u1037', 7), ('\u1039', '\u103a', 9), ('\u108d', '\u108d', 220),
        ('\u135d', '\u135f', 230), ('\u1714', '\u1714', 9), ('\u1734', '\u1734', 9), ('\u17d2',
        '\u17d2', 9), ('\u17dd', '\u17dd', 230), ('\u18a9', '\u18a9', 228), ('\u1939', '\u1939',
        222), ('\u193a', '\u193a', 230), ('\u193b', '\u193b', 220), ('\u1a17', '\u1a17', 230),
        ('\u1a18', '\u1a18', 220), ('\u1a60', '\u1a60', 9), ('\u1a75', '\u1a7c', 230), ('\u1a7f',
        '\u1a7f', 220), ('\u1ab0', '\u1ab4', 230), ('\u1ab5', '\u1aba', 220), ('\u1abb', '\u1abc',
        230), ('\u1abd', '\u1abd', 220), ('\u1b34', '\u1b34', 7), ('\u1b44', '\u1b44', 9),
        ('\u1b6b', '\u1b6b', 230), ('\u1b6c', '\u1b6c', 220), ('\u1b6d', '\u1b73', 230), ('\u1baa',
        '\u1bab', 9), ('\u1be6', '\u1be6', 7), ('\u1bf2', '\u1bf3', 9), ('\u1c37', '\u1c37', 7),
        ('\u1cd0', '\u1cd2', 230), ('\u1cd4', '\u1cd4', 1), ('\u1cd5', '\u1cd9', 220), ('\u1cda',
        '\u1cdb', 230), ('\u1cdc', '\u1cdf', 220), ('\u1ce0', '\u1ce0', 230), ('\u1ce2', '\u1ce8',
        1), ('\u1ced', '\u1ced', 220), ('\u1cf4', '\u1cf4', 230), ('\u1cf8', '\u1cf9', 230),
        ('\u1dc0', '\u1dc1', 230), ('\u1dc2', '\u1dc2', 220), ('\u1dc3', '\u1dc9', 230), ('\u1dca',
        '\u1dca', 220), ('\u1dcb', '\u1dcc', 230), ('\u1dcd', '\u1dcd', 234), ('\u1dce', '\u1dce',
        214), ('\u1dcf', '\u1dcf', 220), ('\u1dd0', '\u1dd0', 202), ('\u1dd1', '\u1df5', 230),
        ('\u1dfc', '\u1dfc', 233), ('\u1dfd', '\u1dfd', 220), ('\u1dfe', '\u1dfe', 230), ('\u1dff',
        '\u1dff', 220), ('\u20d0', '\u20d1', 230), ('\u20d2', '\u20d3', 1), ('\u20d4', '\u20d7',
        230), ('\u20d8', '\u20da', 1), ('\u20db', '\u20dc', 230), ('\u20e1', '\u20e1', 230),
        ('\u20e5', '\u20e6', 1), ('\u20e7', '\u20e7', 230), ('\u20e8', '\u20e8', 220), ('\u20e9',
        '\u20e9', 230), ('\u20ea', '\u20eb', 1), ('\u20ec', '\u20ef', 220), ('\u20f0', '\u20f0',
        230), ('\u2cef', '\u2cf1', 230), ('\u2d7f', '\u2d7f', 9), ('\u2de0', '\u2dff', 230),
        ('\u302a', '\u302a', 218), ('\u302b', '\u302b', 228), ('\u302c', '\u302c', 232), ('\u302d',
        '\u302d', 222), ('\u302e', '\u302f', 224), ('\u3099', '\u309a', 8), ('\ua66f', '\ua66f',
        230), ('\ua674', '\ua67d', 230), ('\ua69f', '\ua69f', 230), ('\ua6f0', '\ua6f1', 230),
        ('\ua806', '\ua806', 9), ('\ua8c4', '\ua8c4', 9), ('\ua8e0', '\ua8f1', 230), ('\ua92b',
        '\ua92d', 220), ('\ua953', '\ua953', 9), ('\ua9b3', '\ua9b3', 7), ('\ua9c0', '\ua9c0', 9),
        ('\uaab0', '\uaab0', 230), ('\uaab2', '\uaab3', 230), ('\uaab4', '\uaab4', 220), ('\uaab7',
        '\uaab8', 230), ('\uaabe', '\uaabf', 230), ('\uaac1', '\uaac1', 230), ('\uaaf6', '\uaaf6',
        9), ('\uabed', '\uabed', 9), ('\ufb1e', '\ufb1e', 26), ('\ufe20', '\ufe26', 230), ('\ufe27',
        '\ufe2d', 220), ('\U000101fd', '\U000101fd', 220), ('\U000102e0', '\U000102e0', 220),
        ('\U00010376', '\U0001037a', 230), ('\U00010a0d', '\U00010a0d', 220), ('\U00010a0f',
        '\U00010a0f', 230), ('\U00010a38', '\U00010a38', 230), ('\U00010a39', '\U00010a39', 1),
        ('\U00010a3a', '\U00010a3a', 220), ('\U00010a3f', '\U00010a3f', 9), ('\U00010ae5',
        '\U00010ae5', 230), ('\U00010ae6', '\U00010ae6', 220), ('\U00011046', '\U00011046', 9),
        ('\U0001107f', '\U0001107f', 9), ('\U000110b9', '\U000110b9', 9), ('\U000110ba',
        '\U000110ba', 7), ('\U00011100', '\U00011102', 230), ('\U00011133', '\U00011134', 9),
        ('\U00011173', '\U00011173', 7), ('\U000111c0', '\U000111c0', 9), ('\U00011235',
        '\U00011235', 9), ('\U00011236', '\U00011236', 7), ('\U000112e9', '\U000112e9', 7),
        ('\U000112ea', '\U000112ea', 9), ('\U0001133c', '\U0001133c', 7), ('\U0001134d',
        '\U0001134d', 9), ('\U00011366', '\U0001136c', 230), ('\U00011370', '\U00011374', 230),
        ('\U000114c2', '\U000114c2', 9), ('\U000114c3', '\U000114c3', 7), ('\U000115bf',
        '\U000115bf', 9), ('\U000115c0', '\U000115c0', 7), ('\U0001163f', '\U0001163f', 9),
        ('\U000116b6', '\U000116b6', 9), ('\U000116b7', '\U000116b7', 7), ('\U00016af0',
        '\U00016af4', 1), ('\U00016b30', '\U00016b36', 230), ('\U0001bc9e', '\U0001bc9e', 1),
        ('\U0001d165', '\U0001d166', 216), ('\U0001d167', '\U0001d169', 1), ('\U0001d16d',
        '\U0001d16d', 226), ('\U0001d16e', '\U0001d172', 216), ('\U0001d17b', '\U0001d182', 220),
        ('\U0001d185', '\U0001d189', 230), ('\U0001d18a', '\U0001d18b', 220), ('\U0001d1aa',
        '\U0001d1ad', 230), ('\U0001d242', '\U0001d244', 230), ('\U0001e8d0', '\U0001e8d6', 220)
    ];

    pub fn canonical_combining_class(c: char) -> u8 {
        bsearch_range_value_table(c, combining_class_table)
    }

}

pub mod conversions {
    use core::cmp::{Equal, Less, Greater};
    use core::slice::SlicePrelude;
    use core::tuple::Tuple2;
    use core::option::{Option, Some, None};
    use core::slice;

    pub fn to_lower(c: char) -> char {
        match bsearch_case_table(c, LuLl_table) {
          None        => c,
          Some(index) => LuLl_table[index].val1()
        }
    }

    pub fn to_upper(c: char) -> char {
        match bsearch_case_table(c, LlLu_table) {
            None        => c,
            Some(index) => LlLu_table[index].val1()
        }
    }

    fn bsearch_case_table(c: char, table: &'static [(char, char)]) -> Option<uint> {
        match table.binary_search(|&(key, _)| {
            if c == key { Equal }
            else if key < c { Less }
            else { Greater }
        }) {
            slice::Found(i) => Some(i),
            slice::NotFound(_) => None,
        }
    }

    static LuLl_table: &'static [(char, char)] = &[
        ('\x41', '\x61'), ('\x42', '\x62'), ('\x43', '\x63'), ('\x44', '\x64'), ('\x45', '\x65'),
        ('\x46', '\x66'), ('\x47', '\x67'), ('\x48', '\x68'), ('\x49', '\x69'), ('\x4a', '\x6a'),
        ('\x4b', '\x6b'), ('\x4c', '\x6c'), ('\x4d', '\x6d'), ('\x4e', '\x6e'), ('\x4f', '\x6f'),
        ('\x50', '\x70'), ('\x51', '\x71'), ('\x52', '\x72'), ('\x53', '\x73'), ('\x54', '\x74'),
        ('\x55', '\x75'), ('\x56', '\x76'), ('\x57', '\x77'), ('\x58', '\x78'), ('\x59', '\x79'),
        ('\x5a', '\x7a'), ('\u00c0', '\u00e0'), ('\u00c1', '\u00e1'), ('\u00c2', '\u00e2'),
        ('\u00c3', '\u00e3'), ('\u00c4', '\u00e4'), ('\u00c5', '\u00e5'), ('\u00c6', '\u00e6'),
        ('\u00c7', '\u00e7'), ('\u00c8', '\u00e8'), ('\u00c9', '\u00e9'), ('\u00ca', '\u00ea'),
        ('\u00cb', '\u00eb'), ('\u00cc', '\u00ec'), ('\u00cd', '\u00ed'), ('\u00ce', '\u00ee'),
        ('\u00cf', '\u00ef'), ('\u00d0', '\u00f0'), ('\u00d1', '\u00f1'), ('\u00d2', '\u00f2'),
        ('\u00d3', '\u00f3'), ('\u00d4', '\u00f4'), ('\u00d5', '\u00f5'), ('\u00d6', '\u00f6'),
        ('\u00d8', '\u00f8'), ('\u00d9', '\u00f9'), ('\u00da', '\u00fa'), ('\u00db', '\u00fb'),
        ('\u00dc', '\u00fc'), ('\u00dd', '\u00fd'), ('\u00de', '\u00fe'), ('\u0100', '\u0101'),
        ('\u0102', '\u0103'), ('\u0104', '\u0105'), ('\u0106', '\u0107'), ('\u0108', '\u0109'),
        ('\u010a', '\u010b'), ('\u010c', '\u010d'), ('\u010e', '\u010f'), ('\u0110', '\u0111'),
        ('\u0112', '\u0113'), ('\u0114', '\u0115'), ('\u0116', '\u0117'), ('\u0118', '\u0119'),
        ('\u011a', '\u011b'), ('\u011c', '\u011d'), ('\u011e', '\u011f'), ('\u0120', '\u0121'),
        ('\u0122', '\u0123'), ('\u0124', '\u0125'), ('\u0126', '\u0127'), ('\u0128', '\u0129'),
        ('\u012a', '\u012b'), ('\u012c', '\u012d'), ('\u012e', '\u012f'), ('\u0130', '\x69'),
        ('\u0132', '\u0133'), ('\u0134', '\u0135'), ('\u0136', '\u0137'), ('\u0139', '\u013a'),
        ('\u013b', '\u013c'), ('\u013d', '\u013e'), ('\u013f', '\u0140'), ('\u0141', '\u0142'),
        ('\u0143', '\u0144'), ('\u0145', '\u0146'), ('\u0147', '\u0148'), ('\u014a', '\u014b'),
        ('\u014c', '\u014d'), ('\u014e', '\u014f'), ('\u0150', '\u0151'), ('\u0152', '\u0153'),
        ('\u0154', '\u0155'), ('\u0156', '\u0157'), ('\u0158', '\u0159'), ('\u015a', '\u015b'),
        ('\u015c', '\u015d'), ('\u015e', '\u015f'), ('\u0160', '\u0161'), ('\u0162', '\u0163'),
        ('\u0164', '\u0165'), ('\u0166', '\u0167'), ('\u0168', '\u0169'), ('\u016a', '\u016b'),
        ('\u016c', '\u016d'), ('\u016e', '\u016f'), ('\u0170', '\u0171'), ('\u0172', '\u0173'),
        ('\u0174', '\u0175'), ('\u0176', '\u0177'), ('\u0178', '\u00ff'), ('\u0179', '\u017a'),
        ('\u017b', '\u017c'), ('\u017d', '\u017e'), ('\u0181', '\u0253'), ('\u0182', '\u0183'),
        ('\u0184', '\u0185'), ('\u0186', '\u0254'), ('\u0187', '\u0188'), ('\u0189', '\u0256'),
        ('\u018a', '\u0257'), ('\u018b', '\u018c'), ('\u018e', '\u01dd'), ('\u018f', '\u0259'),
        ('\u0190', '\u025b'), ('\u0191', '\u0192'), ('\u0193', '\u0260'), ('\u0194', '\u0263'),
        ('\u0196', '\u0269'), ('\u0197', '\u0268'), ('\u0198', '\u0199'), ('\u019c', '\u026f'),
        ('\u019d', '\u0272'), ('\u019f', '\u0275'), ('\u01a0', '\u01a1'), ('\u01a2', '\u01a3'),
        ('\u01a4', '\u01a5'), ('\u01a6', '\u0280'), ('\u01a7', '\u01a8'), ('\u01a9', '\u0283'),
        ('\u01ac', '\u01ad'), ('\u01ae', '\u0288'), ('\u01af', '\u01b0'), ('\u01b1', '\u028a'),
        ('\u01b2', '\u028b'), ('\u01b3', '\u01b4'), ('\u01b5', '\u01b6'), ('\u01b7', '\u0292'),
        ('\u01b8', '\u01b9'), ('\u01bc', '\u01bd'), ('\u01c4', '\u01c6'), ('\u01c7', '\u01c9'),
        ('\u01ca', '\u01cc'), ('\u01cd', '\u01ce'), ('\u01cf', '\u01d0'), ('\u01d1', '\u01d2'),
        ('\u01d3', '\u01d4'), ('\u01d5', '\u01d6'), ('\u01d7', '\u01d8'), ('\u01d9', '\u01da'),
        ('\u01db', '\u01dc'), ('\u01de', '\u01df'), ('\u01e0', '\u01e1'), ('\u01e2', '\u01e3'),
        ('\u01e4', '\u01e5'), ('\u01e6', '\u01e7'), ('\u01e8', '\u01e9'), ('\u01ea', '\u01eb'),
        ('\u01ec', '\u01ed'), ('\u01ee', '\u01ef'), ('\u01f1', '\u01f3'), ('\u01f4', '\u01f5'),
        ('\u01f6', '\u0195'), ('\u01f7', '\u01bf'), ('\u01f8', '\u01f9'), ('\u01fa', '\u01fb'),
        ('\u01fc', '\u01fd'), ('\u01fe', '\u01ff'), ('\u0200', '\u0201'), ('\u0202', '\u0203'),
        ('\u0204', '\u0205'), ('\u0206', '\u0207'), ('\u0208', '\u0209'), ('\u020a', '\u020b'),
        ('\u020c', '\u020d'), ('\u020e', '\u020f'), ('\u0210', '\u0211'), ('\u0212', '\u0213'),
        ('\u0214', '\u0215'), ('\u0216', '\u0217'), ('\u0218', '\u0219'), ('\u021a', '\u021b'),
        ('\u021c', '\u021d'), ('\u021e', '\u021f'), ('\u0220', '\u019e'), ('\u0222', '\u0223'),
        ('\u0224', '\u0225'), ('\u0226', '\u0227'), ('\u0228', '\u0229'), ('\u022a', '\u022b'),
        ('\u022c', '\u022d'), ('\u022e', '\u022f'), ('\u0230', '\u0231'), ('\u0232', '\u0233'),
        ('\u023a', '\u2c65'), ('\u023b', '\u023c'), ('\u023d', '\u019a'), ('\u023e', '\u2c66'),
        ('\u0241', '\u0242'), ('\u0243', '\u0180'), ('\u0244', '\u0289'), ('\u0245', '\u028c'),
        ('\u0246', '\u0247'), ('\u0248', '\u0249'), ('\u024a', '\u024b'), ('\u024c', '\u024d'),
        ('\u024e', '\u024f'), ('\u0370', '\u0371'), ('\u0372', '\u0373'), ('\u0376', '\u0377'),
        ('\u037f', '\u03f3'), ('\u0386', '\u03ac'), ('\u0388', '\u03ad'), ('\u0389', '\u03ae'),
        ('\u038a', '\u03af'), ('\u038c', '\u03cc'), ('\u038e', '\u03cd'), ('\u038f', '\u03ce'),
        ('\u0391', '\u03b1'), ('\u0392', '\u03b2'), ('\u0393', '\u03b3'), ('\u0394', '\u03b4'),
        ('\u0395', '\u03b5'), ('\u0396', '\u03b6'), ('\u0397', '\u03b7'), ('\u0398', '\u03b8'),
        ('\u0399', '\u03b9'), ('\u039a', '\u03ba'), ('\u039b', '\u03bb'), ('\u039c', '\u03bc'),
        ('\u039d', '\u03bd'), ('\u039e', '\u03be'), ('\u039f', '\u03bf'), ('\u03a0', '\u03c0'),
        ('\u03a1', '\u03c1'), ('\u03a3', '\u03c3'), ('\u03a4', '\u03c4'), ('\u03a5', '\u03c5'),
        ('\u03a6', '\u03c6'), ('\u03a7', '\u03c7'), ('\u03a8', '\u03c8'), ('\u03a9', '\u03c9'),
        ('\u03aa', '\u03ca'), ('\u03ab', '\u03cb'), ('\u03cf', '\u03d7'), ('\u03d8', '\u03d9'),
        ('\u03da', '\u03db'), ('\u03dc', '\u03dd'), ('\u03de', '\u03df'), ('\u03e0', '\u03e1'),
        ('\u03e2', '\u03e3'), ('\u03e4', '\u03e5'), ('\u03e6', '\u03e7'), ('\u03e8', '\u03e9'),
        ('\u03ea', '\u03eb'), ('\u03ec', '\u03ed'), ('\u03ee', '\u03ef'), ('\u03f4', '\u03b8'),
        ('\u03f7', '\u03f8'), ('\u03f9', '\u03f2'), ('\u03fa', '\u03fb'), ('\u03fd', '\u037b'),
        ('\u03fe', '\u037c'), ('\u03ff', '\u037d'), ('\u0400', '\u0450'), ('\u0401', '\u0451'),
        ('\u0402', '\u0452'), ('\u0403', '\u0453'), ('\u0404', '\u0454'), ('\u0405', '\u0455'),
        ('\u0406', '\u0456'), ('\u0407', '\u0457'), ('\u0408', '\u0458'), ('\u0409', '\u0459'),
        ('\u040a', '\u045a'), ('\u040b', '\u045b'), ('\u040c', '\u045c'), ('\u040d', '\u045d'),
        ('\u040e', '\u045e'), ('\u040f', '\u045f'), ('\u0410', '\u0430'), ('\u0411', '\u0431'),
        ('\u0412', '\u0432'), ('\u0413', '\u0433'), ('\u0414', '\u0434'), ('\u0415', '\u0435'),
        ('\u0416', '\u0436'), ('\u0417', '\u0437'), ('\u0418', '\u0438'), ('\u0419', '\u0439'),
        ('\u041a', '\u043a'), ('\u041b', '\u043b'), ('\u041c', '\u043c'), ('\u041d', '\u043d'),
        ('\u041e', '\u043e'), ('\u041f', '\u043f'), ('\u0420', '\u0440'), ('\u0421', '\u0441'),
        ('\u0422', '\u0442'), ('\u0423', '\u0443'), ('\u0424', '\u0444'), ('\u0425', '\u0445'),
        ('\u0426', '\u0446'), ('\u0427', '\u0447'), ('\u0428', '\u0448'), ('\u0429', '\u0449'),
        ('\u042a', '\u044a'), ('\u042b', '\u044b'), ('\u042c', '\u044c'), ('\u042d', '\u044d'),
        ('\u042e', '\u044e'), ('\u042f', '\u044f'), ('\u0460', '\u0461'), ('\u0462', '\u0463'),
        ('\u0464', '\u0465'), ('\u0466', '\u0467'), ('\u0468', '\u0469'), ('\u046a', '\u046b'),
        ('\u046c', '\u046d'), ('\u046e', '\u046f'), ('\u0470', '\u0471'), ('\u0472', '\u0473'),
        ('\u0474', '\u0475'), ('\u0476', '\u0477'), ('\u0478', '\u0479'), ('\u047a', '\u047b'),
        ('\u047c', '\u047d'), ('\u047e', '\u047f'), ('\u0480', '\u0481'), ('\u048a', '\u048b'),
        ('\u048c', '\u048d'), ('\u048e', '\u048f'), ('\u0490', '\u0491'), ('\u0492', '\u0493'),
        ('\u0494', '\u0495'), ('\u0496', '\u0497'), ('\u0498', '\u0499'), ('\u049a', '\u049b'),
        ('\u049c', '\u049d'), ('\u049e', '\u049f'), ('\u04a0', '\u04a1'), ('\u04a2', '\u04a3'),
        ('\u04a4', '\u04a5'), ('\u04a6', '\u04a7'), ('\u04a8', '\u04a9'), ('\u04aa', '\u04ab'),
        ('\u04ac', '\u04ad'), ('\u04ae', '\u04af'), ('\u04b0', '\u04b1'), ('\u04b2', '\u04b3'),
        ('\u04b4', '\u04b5'), ('\u04b6', '\u04b7'), ('\u04b8', '\u04b9'), ('\u04ba', '\u04bb'),
        ('\u04bc', '\u04bd'), ('\u04be', '\u04bf'), ('\u04c0', '\u04cf'), ('\u04c1', '\u04c2'),
        ('\u04c3', '\u04c4'), ('\u04c5', '\u04c6'), ('\u04c7', '\u04c8'), ('\u04c9', '\u04ca'),
        ('\u04cb', '\u04cc'), ('\u04cd', '\u04ce'), ('\u04d0', '\u04d1'), ('\u04d2', '\u04d3'),
        ('\u04d4', '\u04d5'), ('\u04d6', '\u04d7'), ('\u04d8', '\u04d9'), ('\u04da', '\u04db'),
        ('\u04dc', '\u04dd'), ('\u04de', '\u04df'), ('\u04e0', '\u04e1'), ('\u04e2', '\u04e3'),
        ('\u04e4', '\u04e5'), ('\u04e6', '\u04e7'), ('\u04e8', '\u04e9'), ('\u04ea', '\u04eb'),
        ('\u04ec', '\u04ed'), ('\u04ee', '\u04ef'), ('\u04f0', '\u04f1'), ('\u04f2', '\u04f3'),
        ('\u04f4', '\u04f5'), ('\u04f6', '\u04f7'), ('\u04f8', '\u04f9'), ('\u04fa', '\u04fb'),
        ('\u04fc', '\u04fd'), ('\u04fe', '\u04ff'), ('\u0500', '\u0501'), ('\u0502', '\u0503'),
        ('\u0504', '\u0505'), ('\u0506', '\u0507'), ('\u0508', '\u0509'), ('\u050a', '\u050b'),
        ('\u050c', '\u050d'), ('\u050e', '\u050f'), ('\u0510', '\u0511'), ('\u0512', '\u0513'),
        ('\u0514', '\u0515'), ('\u0516', '\u0517'), ('\u0518', '\u0519'), ('\u051a', '\u051b'),
        ('\u051c', '\u051d'), ('\u051e', '\u051f'), ('\u0520', '\u0521'), ('\u0522', '\u0523'),
        ('\u0524', '\u0525'), ('\u0526', '\u0527'), ('\u0528', '\u0529'), ('\u052a', '\u052b'),
        ('\u052c', '\u052d'), ('\u052e', '\u052f'), ('\u0531', '\u0561'), ('\u0532', '\u0562'),
        ('\u0533', '\u0563'), ('\u0534', '\u0564'), ('\u0535', '\u0565'), ('\u0536', '\u0566'),
        ('\u0537', '\u0567'), ('\u0538', '\u0568'), ('\u0539', '\u0569'), ('\u053a', '\u056a'),
        ('\u053b', '\u056b'), ('\u053c', '\u056c'), ('\u053d', '\u056d'), ('\u053e', '\u056e'),
        ('\u053f', '\u056f'), ('\u0540', '\u0570'), ('\u0541', '\u0571'), ('\u0542', '\u0572'),
        ('\u0543', '\u0573'), ('\u0544', '\u0574'), ('\u0545', '\u0575'), ('\u0546', '\u0576'),
        ('\u0547', '\u0577'), ('\u0548', '\u0578'), ('\u0549', '\u0579'), ('\u054a', '\u057a'),
        ('\u054b', '\u057b'), ('\u054c', '\u057c'), ('\u054d', '\u057d'), ('\u054e', '\u057e'),
        ('\u054f', '\u057f'), ('\u0550', '\u0580'), ('\u0551', '\u0581'), ('\u0552', '\u0582'),
        ('\u0553', '\u0583'), ('\u0554', '\u0584'), ('\u0555', '\u0585'), ('\u0556', '\u0586'),
        ('\u10a0', '\u2d00'), ('\u10a1', '\u2d01'), ('\u10a2', '\u2d02'), ('\u10a3', '\u2d03'),
        ('\u10a4', '\u2d04'), ('\u10a5', '\u2d05'), ('\u10a6', '\u2d06'), ('\u10a7', '\u2d07'),
        ('\u10a8', '\u2d08'), ('\u10a9', '\u2d09'), ('\u10aa', '\u2d0a'), ('\u10ab', '\u2d0b'),
        ('\u10ac', '\u2d0c'), ('\u10ad', '\u2d0d'), ('\u10ae', '\u2d0e'), ('\u10af', '\u2d0f'),
        ('\u10b0', '\u2d10'), ('\u10b1', '\u2d11'), ('\u10b2', '\u2d12'), ('\u10b3', '\u2d13'),
        ('\u10b4', '\u2d14'), ('\u10b5', '\u2d15'), ('\u10b6', '\u2d16'), ('\u10b7', '\u2d17'),
        ('\u10b8', '\u2d18'), ('\u10b9', '\u2d19'), ('\u10ba', '\u2d1a'), ('\u10bb', '\u2d1b'),
        ('\u10bc', '\u2d1c'), ('\u10bd', '\u2d1d'), ('\u10be', '\u2d1e'), ('\u10bf', '\u2d1f'),
        ('\u10c0', '\u2d20'), ('\u10c1', '\u2d21'), ('\u10c2', '\u2d22'), ('\u10c3', '\u2d23'),
        ('\u10c4', '\u2d24'), ('\u10c5', '\u2d25'), ('\u10c7', '\u2d27'), ('\u10cd', '\u2d2d'),
        ('\u1e00', '\u1e01'), ('\u1e02', '\u1e03'), ('\u1e04', '\u1e05'), ('\u1e06', '\u1e07'),
        ('\u1e08', '\u1e09'), ('\u1e0a', '\u1e0b'), ('\u1e0c', '\u1e0d'), ('\u1e0e', '\u1e0f'),
        ('\u1e10', '\u1e11'), ('\u1e12', '\u1e13'), ('\u1e14', '\u1e15'), ('\u1e16', '\u1e17'),
        ('\u1e18', '\u1e19'), ('\u1e1a', '\u1e1b'), ('\u1e1c', '\u1e1d'), ('\u1e1e', '\u1e1f'),
        ('\u1e20', '\u1e21'), ('\u1e22', '\u1e23'), ('\u1e24', '\u1e25'), ('\u1e26', '\u1e27'),
        ('\u1e28', '\u1e29'), ('\u1e2a', '\u1e2b'), ('\u1e2c', '\u1e2d'), ('\u1e2e', '\u1e2f'),
        ('\u1e30', '\u1e31'), ('\u1e32', '\u1e33'), ('\u1e34', '\u1e35'), ('\u1e36', '\u1e37'),
        ('\u1e38', '\u1e39'), ('\u1e3a', '\u1e3b'), ('\u1e3c', '\u1e3d'), ('\u1e3e', '\u1e3f'),
        ('\u1e40', '\u1e41'), ('\u1e42', '\u1e43'), ('\u1e44', '\u1e45'), ('\u1e46', '\u1e47'),
        ('\u1e48', '\u1e49'), ('\u1e4a', '\u1e4b'), ('\u1e4c', '\u1e4d'), ('\u1e4e', '\u1e4f'),
        ('\u1e50', '\u1e51'), ('\u1e52', '\u1e53'), ('\u1e54', '\u1e55'), ('\u1e56', '\u1e57'),
        ('\u1e58', '\u1e59'), ('\u1e5a', '\u1e5b'), ('\u1e5c', '\u1e5d'), ('\u1e5e', '\u1e5f'),
        ('\u1e60', '\u1e61'), ('\u1e62', '\u1e63'), ('\u1e64', '\u1e65'), ('\u1e66', '\u1e67'),
        ('\u1e68', '\u1e69'), ('\u1e6a', '\u1e6b'), ('\u1e6c', '\u1e6d'), ('\u1e6e', '\u1e6f'),
        ('\u1e70', '\u1e71'), ('\u1e72', '\u1e73'), ('\u1e74', '\u1e75'), ('\u1e76', '\u1e77'),
        ('\u1e78', '\u1e79'), ('\u1e7a', '\u1e7b'), ('\u1e7c', '\u1e7d'), ('\u1e7e', '\u1e7f'),
        ('\u1e80', '\u1e81'), ('\u1e82', '\u1e83'), ('\u1e84', '\u1e85'), ('\u1e86', '\u1e87'),
        ('\u1e88', '\u1e89'), ('\u1e8a', '\u1e8b'), ('\u1e8c', '\u1e8d'), ('\u1e8e', '\u1e8f'),
        ('\u1e90', '\u1e91'), ('\u1e92', '\u1e93'), ('\u1e94', '\u1e95'), ('\u1e9e', '\u00df'),
        ('\u1ea0', '\u1ea1'), ('\u1ea2', '\u1ea3'), ('\u1ea4', '\u1ea5'), ('\u1ea6', '\u1ea7'),
        ('\u1ea8', '\u1ea9'), ('\u1eaa', '\u1eab'), ('\u1eac', '\u1ead'), ('\u1eae', '\u1eaf'),
        ('\u1eb0', '\u1eb1'), ('\u1eb2', '\u1eb3'), ('\u1eb4', '\u1eb5'), ('\u1eb6', '\u1eb7'),
        ('\u1eb8', '\u1eb9'), ('\u1eba', '\u1ebb'), ('\u1ebc', '\u1ebd'), ('\u1ebe', '\u1ebf'),
        ('\u1ec0', '\u1ec1'), ('\u1ec2', '\u1ec3'), ('\u1ec4', '\u1ec5'), ('\u1ec6', '\u1ec7'),
        ('\u1ec8', '\u1ec9'), ('\u1eca', '\u1ecb'), ('\u1ecc', '\u1ecd'), ('\u1ece', '\u1ecf'),
        ('\u1ed0', '\u1ed1'), ('\u1ed2', '\u1ed3'), ('\u1ed4', '\u1ed5'), ('\u1ed6', '\u1ed7'),
        ('\u1ed8', '\u1ed9'), ('\u1eda', '\u1edb'), ('\u1edc', '\u1edd'), ('\u1ede', '\u1edf'),
        ('\u1ee0', '\u1ee1'), ('\u1ee2', '\u1ee3'), ('\u1ee4', '\u1ee5'), ('\u1ee6', '\u1ee7'),
        ('\u1ee8', '\u1ee9'), ('\u1eea', '\u1eeb'), ('\u1eec', '\u1eed'), ('\u1eee', '\u1eef'),
        ('\u1ef0', '\u1ef1'), ('\u1ef2', '\u1ef3'), ('\u1ef4', '\u1ef5'), ('\u1ef6', '\u1ef7'),
        ('\u1ef8', '\u1ef9'), ('\u1efa', '\u1efb'), ('\u1efc', '\u1efd'), ('\u1efe', '\u1eff'),
        ('\u1f08', '\u1f00'), ('\u1f09', '\u1f01'), ('\u1f0a', '\u1f02'), ('\u1f0b', '\u1f03'),
        ('\u1f0c', '\u1f04'), ('\u1f0d', '\u1f05'), ('\u1f0e', '\u1f06'), ('\u1f0f', '\u1f07'),
        ('\u1f18', '\u1f10'), ('\u1f19', '\u1f11'), ('\u1f1a', '\u1f12'), ('\u1f1b', '\u1f13'),
        ('\u1f1c', '\u1f14'), ('\u1f1d', '\u1f15'), ('\u1f28', '\u1f20'), ('\u1f29', '\u1f21'),
        ('\u1f2a', '\u1f22'), ('\u1f2b', '\u1f23'), ('\u1f2c', '\u1f24'), ('\u1f2d', '\u1f25'),
        ('\u1f2e', '\u1f26'), ('\u1f2f', '\u1f27'), ('\u1f38', '\u1f30'), ('\u1f39', '\u1f31'),
        ('\u1f3a', '\u1f32'), ('\u1f3b', '\u1f33'), ('\u1f3c', '\u1f34'), ('\u1f3d', '\u1f35'),
        ('\u1f3e', '\u1f36'), ('\u1f3f', '\u1f37'), ('\u1f48', '\u1f40'), ('\u1f49', '\u1f41'),
        ('\u1f4a', '\u1f42'), ('\u1f4b', '\u1f43'), ('\u1f4c', '\u1f44'), ('\u1f4d', '\u1f45'),
        ('\u1f59', '\u1f51'), ('\u1f5b', '\u1f53'), ('\u1f5d', '\u1f55'), ('\u1f5f', '\u1f57'),
        ('\u1f68', '\u1f60'), ('\u1f69', '\u1f61'), ('\u1f6a', '\u1f62'), ('\u1f6b', '\u1f63'),
        ('\u1f6c', '\u1f64'), ('\u1f6d', '\u1f65'), ('\u1f6e', '\u1f66'), ('\u1f6f', '\u1f67'),
        ('\u1fb8', '\u1fb0'), ('\u1fb9', '\u1fb1'), ('\u1fba', '\u1f70'), ('\u1fbb', '\u1f71'),
        ('\u1fc8', '\u1f72'), ('\u1fc9', '\u1f73'), ('\u1fca', '\u1f74'), ('\u1fcb', '\u1f75'),
        ('\u1fd8', '\u1fd0'), ('\u1fd9', '\u1fd1'), ('\u1fda', '\u1f76'), ('\u1fdb', '\u1f77'),
        ('\u1fe8', '\u1fe0'), ('\u1fe9', '\u1fe1'), ('\u1fea', '\u1f7a'), ('\u1feb', '\u1f7b'),
        ('\u1fec', '\u1fe5'), ('\u1ff8', '\u1f78'), ('\u1ff9', '\u1f79'), ('\u1ffa', '\u1f7c'),
        ('\u1ffb', '\u1f7d'), ('\u2126', '\u03c9'), ('\u212a', '\x6b'), ('\u212b', '\u00e5'),
        ('\u2132', '\u214e'), ('\u2183', '\u2184'), ('\u2c00', '\u2c30'), ('\u2c01', '\u2c31'),
        ('\u2c02', '\u2c32'), ('\u2c03', '\u2c33'), ('\u2c04', '\u2c34'), ('\u2c05', '\u2c35'),
        ('\u2c06', '\u2c36'), ('\u2c07', '\u2c37'), ('\u2c08', '\u2c38'), ('\u2c09', '\u2c39'),
        ('\u2c0a', '\u2c3a'), ('\u2c0b', '\u2c3b'), ('\u2c0c', '\u2c3c'), ('\u2c0d', '\u2c3d'),
        ('\u2c0e', '\u2c3e'), ('\u2c0f', '\u2c3f'), ('\u2c10', '\u2c40'), ('\u2c11', '\u2c41'),
        ('\u2c12', '\u2c42'), ('\u2c13', '\u2c43'), ('\u2c14', '\u2c44'), ('\u2c15', '\u2c45'),
        ('\u2c16', '\u2c46'), ('\u2c17', '\u2c47'), ('\u2c18', '\u2c48'), ('\u2c19', '\u2c49'),
        ('\u2c1a', '\u2c4a'), ('\u2c1b', '\u2c4b'), ('\u2c1c', '\u2c4c'), ('\u2c1d', '\u2c4d'),
        ('\u2c1e', '\u2c4e'), ('\u2c1f', '\u2c4f'), ('\u2c20', '\u2c50'), ('\u2c21', '\u2c51'),
        ('\u2c22', '\u2c52'), ('\u2c23', '\u2c53'), ('\u2c24', '\u2c54'), ('\u2c25', '\u2c55'),
        ('\u2c26', '\u2c56'), ('\u2c27', '\u2c57'), ('\u2c28', '\u2c58'), ('\u2c29', '\u2c59'),
        ('\u2c2a', '\u2c5a'), ('\u2c2b', '\u2c5b'), ('\u2c2c', '\u2c5c'), ('\u2c2d', '\u2c5d'),
        ('\u2c2e', '\u2c5e'), ('\u2c60', '\u2c61'), ('\u2c62', '\u026b'), ('\u2c63', '\u1d7d'),
        ('\u2c64', '\u027d'), ('\u2c67', '\u2c68'), ('\u2c69', '\u2c6a'), ('\u2c6b', '\u2c6c'),
        ('\u2c6d', '\u0251'), ('\u2c6e', '\u0271'), ('\u2c6f', '\u0250'), ('\u2c70', '\u0252'),
        ('\u2c72', '\u2c73'), ('\u2c75', '\u2c76'), ('\u2c7e', '\u023f'), ('\u2c7f', '\u0240'),
        ('\u2c80', '\u2c81'), ('\u2c82', '\u2c83'), ('\u2c84', '\u2c85'), ('\u2c86', '\u2c87'),
        ('\u2c88', '\u2c89'), ('\u2c8a', '\u2c8b'), ('\u2c8c', '\u2c8d'), ('\u2c8e', '\u2c8f'),
        ('\u2c90', '\u2c91'), ('\u2c92', '\u2c93'), ('\u2c94', '\u2c95'), ('\u2c96', '\u2c97'),
        ('\u2c98', '\u2c99'), ('\u2c9a', '\u2c9b'), ('\u2c9c', '\u2c9d'), ('\u2c9e', '\u2c9f'),
        ('\u2ca0', '\u2ca1'), ('\u2ca2', '\u2ca3'), ('\u2ca4', '\u2ca5'), ('\u2ca6', '\u2ca7'),
        ('\u2ca8', '\u2ca9'), ('\u2caa', '\u2cab'), ('\u2cac', '\u2cad'), ('\u2cae', '\u2caf'),
        ('\u2cb0', '\u2cb1'), ('\u2cb2', '\u2cb3'), ('\u2cb4', '\u2cb5'), ('\u2cb6', '\u2cb7'),
        ('\u2cb8', '\u2cb9'), ('\u2cba', '\u2cbb'), ('\u2cbc', '\u2cbd'), ('\u2cbe', '\u2cbf'),
        ('\u2cc0', '\u2cc1'), ('\u2cc2', '\u2cc3'), ('\u2cc4', '\u2cc5'), ('\u2cc6', '\u2cc7'),
        ('\u2cc8', '\u2cc9'), ('\u2cca', '\u2ccb'), ('\u2ccc', '\u2ccd'), ('\u2cce', '\u2ccf'),
        ('\u2cd0', '\u2cd1'), ('\u2cd2', '\u2cd3'), ('\u2cd4', '\u2cd5'), ('\u2cd6', '\u2cd7'),
        ('\u2cd8', '\u2cd9'), ('\u2cda', '\u2cdb'), ('\u2cdc', '\u2cdd'), ('\u2cde', '\u2cdf'),
        ('\u2ce0', '\u2ce1'), ('\u2ce2', '\u2ce3'), ('\u2ceb', '\u2cec'), ('\u2ced', '\u2cee'),
        ('\u2cf2', '\u2cf3'), ('\ua640', '\ua641'), ('\ua642', '\ua643'), ('\ua644', '\ua645'),
        ('\ua646', '\ua647'), ('\ua648', '\ua649'), ('\ua64a', '\ua64b'), ('\ua64c', '\ua64d'),
        ('\ua64e', '\ua64f'), ('\ua650', '\ua651'), ('\ua652', '\ua653'), ('\ua654', '\ua655'),
        ('\ua656', '\ua657'), ('\ua658', '\ua659'), ('\ua65a', '\ua65b'), ('\ua65c', '\ua65d'),
        ('\ua65e', '\ua65f'), ('\ua660', '\ua661'), ('\ua662', '\ua663'), ('\ua664', '\ua665'),
        ('\ua666', '\ua667'), ('\ua668', '\ua669'), ('\ua66a', '\ua66b'), ('\ua66c', '\ua66d'),
        ('\ua680', '\ua681'), ('\ua682', '\ua683'), ('\ua684', '\ua685'), ('\ua686', '\ua687'),
        ('\ua688', '\ua689'), ('\ua68a', '\ua68b'), ('\ua68c', '\ua68d'), ('\ua68e', '\ua68f'),
        ('\ua690', '\ua691'), ('\ua692', '\ua693'), ('\ua694', '\ua695'), ('\ua696', '\ua697'),
        ('\ua698', '\ua699'), ('\ua69a', '\ua69b'), ('\ua722', '\ua723'), ('\ua724', '\ua725'),
        ('\ua726', '\ua727'), ('\ua728', '\ua729'), ('\ua72a', '\ua72b'), ('\ua72c', '\ua72d'),
        ('\ua72e', '\ua72f'), ('\ua732', '\ua733'), ('\ua734', '\ua735'), ('\ua736', '\ua737'),
        ('\ua738', '\ua739'), ('\ua73a', '\ua73b'), ('\ua73c', '\ua73d'), ('\ua73e', '\ua73f'),
        ('\ua740', '\ua741'), ('\ua742', '\ua743'), ('\ua744', '\ua745'), ('\ua746', '\ua747'),
        ('\ua748', '\ua749'), ('\ua74a', '\ua74b'), ('\ua74c', '\ua74d'), ('\ua74e', '\ua74f'),
        ('\ua750', '\ua751'), ('\ua752', '\ua753'), ('\ua754', '\ua755'), ('\ua756', '\ua757'),
        ('\ua758', '\ua759'), ('\ua75a', '\ua75b'), ('\ua75c', '\ua75d'), ('\ua75e', '\ua75f'),
        ('\ua760', '\ua761'), ('\ua762', '\ua763'), ('\ua764', '\ua765'), ('\ua766', '\ua767'),
        ('\ua768', '\ua769'), ('\ua76a', '\ua76b'), ('\ua76c', '\ua76d'), ('\ua76e', '\ua76f'),
        ('\ua779', '\ua77a'), ('\ua77b', '\ua77c'), ('\ua77d', '\u1d79'), ('\ua77e', '\ua77f'),
        ('\ua780', '\ua781'), ('\ua782', '\ua783'), ('\ua784', '\ua785'), ('\ua786', '\ua787'),
        ('\ua78b', '\ua78c'), ('\ua78d', '\u0265'), ('\ua790', '\ua791'), ('\ua792', '\ua793'),
        ('\ua796', '\ua797'), ('\ua798', '\ua799'), ('\ua79a', '\ua79b'), ('\ua79c', '\ua79d'),
        ('\ua79e', '\ua79f'), ('\ua7a0', '\ua7a1'), ('\ua7a2', '\ua7a3'), ('\ua7a4', '\ua7a5'),
        ('\ua7a6', '\ua7a7'), ('\ua7a8', '\ua7a9'), ('\ua7aa', '\u0266'), ('\ua7ab', '\u025c'),
        ('\ua7ac', '\u0261'), ('\ua7ad', '\u026c'), ('\ua7b0', '\u029e'), ('\ua7b1', '\u0287'),
        ('\uff21', '\uff41'), ('\uff22', '\uff42'), ('\uff23', '\uff43'), ('\uff24', '\uff44'),
        ('\uff25', '\uff45'), ('\uff26', '\uff46'), ('\uff27', '\uff47'), ('\uff28', '\uff48'),
        ('\uff29', '\uff49'), ('\uff2a', '\uff4a'), ('\uff2b', '\uff4b'), ('\uff2c', '\uff4c'),
        ('\uff2d', '\uff4d'), ('\uff2e', '\uff4e'), ('\uff2f', '\uff4f'), ('\uff30', '\uff50'),
        ('\uff31', '\uff51'), ('\uff32', '\uff52'), ('\uff33', '\uff53'), ('\uff34', '\uff54'),
        ('\uff35', '\uff55'), ('\uff36', '\uff56'), ('\uff37', '\uff57'), ('\uff38', '\uff58'),
        ('\uff39', '\uff59'), ('\uff3a', '\uff5a'), ('\U00010400', '\U00010428'), ('\U00010401',
        '\U00010429'), ('\U00010402', '\U0001042a'), ('\U00010403', '\U0001042b'), ('\U00010404',
        '\U0001042c'), ('\U00010405', '\U0001042d'), ('\U00010406', '\U0001042e'), ('\U00010407',
        '\U0001042f'), ('\U00010408', '\U00010430'), ('\U00010409', '\U00010431'), ('\U0001040a',
        '\U00010432'), ('\U0001040b', '\U00010433'), ('\U0001040c', '\U00010434'), ('\U0001040d',
        '\U00010435'), ('\U0001040e', '\U00010436'), ('\U0001040f', '\U00010437'), ('\U00010410',
        '\U00010438'), ('\U00010411', '\U00010439'), ('\U00010412', '\U0001043a'), ('\U00010413',
        '\U0001043b'), ('\U00010414', '\U0001043c'), ('\U00010415', '\U0001043d'), ('\U00010416',
        '\U0001043e'), ('\U00010417', '\U0001043f'), ('\U00010418', '\U00010440'), ('\U00010419',
        '\U00010441'), ('\U0001041a', '\U00010442'), ('\U0001041b', '\U00010443'), ('\U0001041c',
        '\U00010444'), ('\U0001041d', '\U00010445'), ('\U0001041e', '\U00010446'), ('\U0001041f',
        '\U00010447'), ('\U00010420', '\U00010448'), ('\U00010421', '\U00010449'), ('\U00010422',
        '\U0001044a'), ('\U00010423', '\U0001044b'), ('\U00010424', '\U0001044c'), ('\U00010425',
        '\U0001044d'), ('\U00010426', '\U0001044e'), ('\U00010427', '\U0001044f'), ('\U000118a0',
        '\U000118c0'), ('\U000118a1', '\U000118c1'), ('\U000118a2', '\U000118c2'), ('\U000118a3',
        '\U000118c3'), ('\U000118a4', '\U000118c4'), ('\U000118a5', '\U000118c5'), ('\U000118a6',
        '\U000118c6'), ('\U000118a7', '\U000118c7'), ('\U000118a8', '\U000118c8'), ('\U000118a9',
        '\U000118c9'), ('\U000118aa', '\U000118ca'), ('\U000118ab', '\U000118cb'), ('\U000118ac',
        '\U000118cc'), ('\U000118ad', '\U000118cd'), ('\U000118ae', '\U000118ce'), ('\U000118af',
        '\U000118cf'), ('\U000118b0', '\U000118d0'), ('\U000118b1', '\U000118d1'), ('\U000118b2',
        '\U000118d2'), ('\U000118b3', '\U000118d3'), ('\U000118b4', '\U000118d4'), ('\U000118b5',
        '\U000118d5'), ('\U000118b6', '\U000118d6'), ('\U000118b7', '\U000118d7'), ('\U000118b8',
        '\U000118d8'), ('\U000118b9', '\U000118d9'), ('\U000118ba', '\U000118da'), ('\U000118bb',
        '\U000118db'), ('\U000118bc', '\U000118dc'), ('\U000118bd', '\U000118dd'), ('\U000118be',
        '\U000118de'), ('\U000118bf', '\U000118df')
    ];

    static LlLu_table: &'static [(char, char)] = &[
        ('\x61', '\x41'), ('\x62', '\x42'), ('\x63', '\x43'), ('\x64', '\x44'), ('\x65', '\x45'),
        ('\x66', '\x46'), ('\x67', '\x47'), ('\x68', '\x48'), ('\x69', '\x49'), ('\x6a', '\x4a'),
        ('\x6b', '\x4b'), ('\x6c', '\x4c'), ('\x6d', '\x4d'), ('\x6e', '\x4e'), ('\x6f', '\x4f'),
        ('\x70', '\x50'), ('\x71', '\x51'), ('\x72', '\x52'), ('\x73', '\x53'), ('\x74', '\x54'),
        ('\x75', '\x55'), ('\x76', '\x56'), ('\x77', '\x57'), ('\x78', '\x58'), ('\x79', '\x59'),
        ('\x7a', '\x5a'), ('\u00b5', '\u039c'), ('\u00e0', '\u00c0'), ('\u00e1', '\u00c1'),
        ('\u00e2', '\u00c2'), ('\u00e3', '\u00c3'), ('\u00e4', '\u00c4'), ('\u00e5', '\u00c5'),
        ('\u00e6', '\u00c6'), ('\u00e7', '\u00c7'), ('\u00e8', '\u00c8'), ('\u00e9', '\u00c9'),
        ('\u00ea', '\u00ca'), ('\u00eb', '\u00cb'), ('\u00ec', '\u00cc'), ('\u00ed', '\u00cd'),
        ('\u00ee', '\u00ce'), ('\u00ef', '\u00cf'), ('\u00f0', '\u00d0'), ('\u00f1', '\u00d1'),
        ('\u00f2', '\u00d2'), ('\u00f3', '\u00d3'), ('\u00f4', '\u00d4'), ('\u00f5', '\u00d5'),
        ('\u00f6', '\u00d6'), ('\u00f8', '\u00d8'), ('\u00f9', '\u00d9'), ('\u00fa', '\u00da'),
        ('\u00fb', '\u00db'), ('\u00fc', '\u00dc'), ('\u00fd', '\u00dd'), ('\u00fe', '\u00de'),
        ('\u00ff', '\u0178'), ('\u0101', '\u0100'), ('\u0103', '\u0102'), ('\u0105', '\u0104'),
        ('\u0107', '\u0106'), ('\u0109', '\u0108'), ('\u010b', '\u010a'), ('\u010d', '\u010c'),
        ('\u010f', '\u010e'), ('\u0111', '\u0110'), ('\u0113', '\u0112'), ('\u0115', '\u0114'),
        ('\u0117', '\u0116'), ('\u0119', '\u0118'), ('\u011b', '\u011a'), ('\u011d', '\u011c'),
        ('\u011f', '\u011e'), ('\u0121', '\u0120'), ('\u0123', '\u0122'), ('\u0125', '\u0124'),
        ('\u0127', '\u0126'), ('\u0129', '\u0128'), ('\u012b', '\u012a'), ('\u012d', '\u012c'),
        ('\u012f', '\u012e'), ('\u0131', '\x49'), ('\u0133', '\u0132'), ('\u0135', '\u0134'),
        ('\u0137', '\u0136'), ('\u013a', '\u0139'), ('\u013c', '\u013b'), ('\u013e', '\u013d'),
        ('\u0140', '\u013f'), ('\u0142', '\u0141'), ('\u0144', '\u0143'), ('\u0146', '\u0145'),
        ('\u0148', '\u0147'), ('\u014b', '\u014a'), ('\u014d', '\u014c'), ('\u014f', '\u014e'),
        ('\u0151', '\u0150'), ('\u0153', '\u0152'), ('\u0155', '\u0154'), ('\u0157', '\u0156'),
        ('\u0159', '\u0158'), ('\u015b', '\u015a'), ('\u015d', '\u015c'), ('\u015f', '\u015e'),
        ('\u0161', '\u0160'), ('\u0163', '\u0162'), ('\u0165', '\u0164'), ('\u0167', '\u0166'),
        ('\u0169', '\u0168'), ('\u016b', '\u016a'), ('\u016d', '\u016c'), ('\u016f', '\u016e'),
        ('\u0171', '\u0170'), ('\u0173', '\u0172'), ('\u0175', '\u0174'), ('\u0177', '\u0176'),
        ('\u017a', '\u0179'), ('\u017c', '\u017b'), ('\u017e', '\u017d'), ('\u017f', '\x53'),
        ('\u0180', '\u0243'), ('\u0183', '\u0182'), ('\u0185', '\u0184'), ('\u0188', '\u0187'),
        ('\u018c', '\u018b'), ('\u0192', '\u0191'), ('\u0195', '\u01f6'), ('\u0199', '\u0198'),
        ('\u019a', '\u023d'), ('\u019e', '\u0220'), ('\u01a1', '\u01a0'), ('\u01a3', '\u01a2'),
        ('\u01a5', '\u01a4'), ('\u01a8', '\u01a7'), ('\u01ad', '\u01ac'), ('\u01b0', '\u01af'),
        ('\u01b4', '\u01b3'), ('\u01b6', '\u01b5'), ('\u01b9', '\u01b8'), ('\u01bd', '\u01bc'),
        ('\u01bf', '\u01f7'), ('\u01c6', '\u01c4'), ('\u01c9', '\u01c7'), ('\u01cc', '\u01ca'),
        ('\u01ce', '\u01cd'), ('\u01d0', '\u01cf'), ('\u01d2', '\u01d1'), ('\u01d4', '\u01d3'),
        ('\u01d6', '\u01d5'), ('\u01d8', '\u01d7'), ('\u01da', '\u01d9'), ('\u01dc', '\u01db'),
        ('\u01dd', '\u018e'), ('\u01df', '\u01de'), ('\u01e1', '\u01e0'), ('\u01e3', '\u01e2'),
        ('\u01e5', '\u01e4'), ('\u01e7', '\u01e6'), ('\u01e9', '\u01e8'), ('\u01eb', '\u01ea'),
        ('\u01ed', '\u01ec'), ('\u01ef', '\u01ee'), ('\u01f3', '\u01f1'), ('\u01f5', '\u01f4'),
        ('\u01f9', '\u01f8'), ('\u01fb', '\u01fa'), ('\u01fd', '\u01fc'), ('\u01ff', '\u01fe'),
        ('\u0201', '\u0200'), ('\u0203', '\u0202'), ('\u0205', '\u0204'), ('\u0207', '\u0206'),
        ('\u0209', '\u0208'), ('\u020b', '\u020a'), ('\u020d', '\u020c'), ('\u020f', '\u020e'),
        ('\u0211', '\u0210'), ('\u0213', '\u0212'), ('\u0215', '\u0214'), ('\u0217', '\u0216'),
        ('\u0219', '\u0218'), ('\u021b', '\u021a'), ('\u021d', '\u021c'), ('\u021f', '\u021e'),
        ('\u0223', '\u0222'), ('\u0225', '\u0224'), ('\u0227', '\u0226'), ('\u0229', '\u0228'),
        ('\u022b', '\u022a'), ('\u022d', '\u022c'), ('\u022f', '\u022e'), ('\u0231', '\u0230'),
        ('\u0233', '\u0232'), ('\u023c', '\u023b'), ('\u023f', '\u2c7e'), ('\u0240', '\u2c7f'),
        ('\u0242', '\u0241'), ('\u0247', '\u0246'), ('\u0249', '\u0248'), ('\u024b', '\u024a'),
        ('\u024d', '\u024c'), ('\u024f', '\u024e'), ('\u0250', '\u2c6f'), ('\u0251', '\u2c6d'),
        ('\u0252', '\u2c70'), ('\u0253', '\u0181'), ('\u0254', '\u0186'), ('\u0256', '\u0189'),
        ('\u0257', '\u018a'), ('\u0259', '\u018f'), ('\u025b', '\u0190'), ('\u025c', '\ua7ab'),
        ('\u0260', '\u0193'), ('\u0261', '\ua7ac'), ('\u0263', '\u0194'), ('\u0265', '\ua78d'),
        ('\u0266', '\ua7aa'), ('\u0268', '\u0197'), ('\u0269', '\u0196'), ('\u026b', '\u2c62'),
        ('\u026c', '\ua7ad'), ('\u026f', '\u019c'), ('\u0271', '\u2c6e'), ('\u0272', '\u019d'),
        ('\u0275', '\u019f'), ('\u027d', '\u2c64'), ('\u0280', '\u01a6'), ('\u0283', '\u01a9'),
        ('\u0287', '\ua7b1'), ('\u0288', '\u01ae'), ('\u0289', '\u0244'), ('\u028a', '\u01b1'),
        ('\u028b', '\u01b2'), ('\u028c', '\u0245'), ('\u0292', '\u01b7'), ('\u029e', '\ua7b0'),
        ('\u0371', '\u0370'), ('\u0373', '\u0372'), ('\u0377', '\u0376'), ('\u037b', '\u03fd'),
        ('\u037c', '\u03fe'), ('\u037d', '\u03ff'), ('\u03ac', '\u0386'), ('\u03ad', '\u0388'),
        ('\u03ae', '\u0389'), ('\u03af', '\u038a'), ('\u03b1', '\u0391'), ('\u03b2', '\u0392'),
        ('\u03b3', '\u0393'), ('\u03b4', '\u0394'), ('\u03b5', '\u0395'), ('\u03b6', '\u0396'),
        ('\u03b7', '\u0397'), ('\u03b8', '\u0398'), ('\u03b9', '\u0399'), ('\u03ba', '\u039a'),
        ('\u03bb', '\u039b'), ('\u03bc', '\u039c'), ('\u03bd', '\u039d'), ('\u03be', '\u039e'),
        ('\u03bf', '\u039f'), ('\u03c0', '\u03a0'), ('\u03c1', '\u03a1'), ('\u03c2', '\u03a3'),
        ('\u03c3', '\u03a3'), ('\u03c4', '\u03a4'), ('\u03c5', '\u03a5'), ('\u03c6', '\u03a6'),
        ('\u03c7', '\u03a7'), ('\u03c8', '\u03a8'), ('\u03c9', '\u03a9'), ('\u03ca', '\u03aa'),
        ('\u03cb', '\u03ab'), ('\u03cc', '\u038c'), ('\u03cd', '\u038e'), ('\u03ce', '\u038f'),
        ('\u03d0', '\u0392'), ('\u03d1', '\u0398'), ('\u03d5', '\u03a6'), ('\u03d6', '\u03a0'),
        ('\u03d7', '\u03cf'), ('\u03d9', '\u03d8'), ('\u03db', '\u03da'), ('\u03dd', '\u03dc'),
        ('\u03df', '\u03de'), ('\u03e1', '\u03e0'), ('\u03e3', '\u03e2'), ('\u03e5', '\u03e4'),
        ('\u03e7', '\u03e6'), ('\u03e9', '\u03e8'), ('\u03eb', '\u03ea'), ('\u03ed', '\u03ec'),
        ('\u03ef', '\u03ee'), ('\u03f0', '\u039a'), ('\u03f1', '\u03a1'), ('\u03f2', '\u03f9'),
        ('\u03f3', '\u037f'), ('\u03f5', '\u0395'), ('\u03f8', '\u03f7'), ('\u03fb', '\u03fa'),
        ('\u0430', '\u0410'), ('\u0431', '\u0411'), ('\u0432', '\u0412'), ('\u0433', '\u0413'),
        ('\u0434', '\u0414'), ('\u0435', '\u0415'), ('\u0436', '\u0416'), ('\u0437', '\u0417'),
        ('\u0438', '\u0418'), ('\u0439', '\u0419'), ('\u043a', '\u041a'), ('\u043b', '\u041b'),
        ('\u043c', '\u041c'), ('\u043d', '\u041d'), ('\u043e', '\u041e'), ('\u043f', '\u041f'),
        ('\u0440', '\u0420'), ('\u0441', '\u0421'), ('\u0442', '\u0422'), ('\u0443', '\u0423'),
        ('\u0444', '\u0424'), ('\u0445', '\u0425'), ('\u0446', '\u0426'), ('\u0447', '\u0427'),
        ('\u0448', '\u0428'), ('\u0449', '\u0429'), ('\u044a', '\u042a'), ('\u044b', '\u042b'),
        ('\u044c', '\u042c'), ('\u044d', '\u042d'), ('\u044e', '\u042e'), ('\u044f', '\u042f'),
        ('\u0450', '\u0400'), ('\u0451', '\u0401'), ('\u0452', '\u0402'), ('\u0453', '\u0403'),
        ('\u0454', '\u0404'), ('\u0455', '\u0405'), ('\u0456', '\u0406'), ('\u0457', '\u0407'),
        ('\u0458', '\u0408'), ('\u0459', '\u0409'), ('\u045a', '\u040a'), ('\u045b', '\u040b'),
        ('\u045c', '\u040c'), ('\u045d', '\u040d'), ('\u045e', '\u040e'), ('\u045f', '\u040f'),
        ('\u0461', '\u0460'), ('\u0463', '\u0462'), ('\u0465', '\u0464'), ('\u0467', '\u0466'),
        ('\u0469', '\u0468'), ('\u046b', '\u046a'), ('\u046d', '\u046c'), ('\u046f', '\u046e'),
        ('\u0471', '\u0470'), ('\u0473', '\u0472'), ('\u0475', '\u0474'), ('\u0477', '\u0476'),
        ('\u0479', '\u0478'), ('\u047b', '\u047a'), ('\u047d', '\u047c'), ('\u047f', '\u047e'),
        ('\u0481', '\u0480'), ('\u048b', '\u048a'), ('\u048d', '\u048c'), ('\u048f', '\u048e'),
        ('\u0491', '\u0490'), ('\u0493', '\u0492'), ('\u0495', '\u0494'), ('\u0497', '\u0496'),
        ('\u0499', '\u0498'), ('\u049b', '\u049a'), ('\u049d', '\u049c'), ('\u049f', '\u049e'),
        ('\u04a1', '\u04a0'), ('\u04a3', '\u04a2'), ('\u04a5', '\u04a4'), ('\u04a7', '\u04a6'),
        ('\u04a9', '\u04a8'), ('\u04ab', '\u04aa'), ('\u04ad', '\u04ac'), ('\u04af', '\u04ae'),
        ('\u04b1', '\u04b0'), ('\u04b3', '\u04b2'), ('\u04b5', '\u04b4'), ('\u04b7', '\u04b6'),
        ('\u04b9', '\u04b8'), ('\u04bb', '\u04ba'), ('\u04bd', '\u04bc'), ('\u04bf', '\u04be'),
        ('\u04c2', '\u04c1'), ('\u04c4', '\u04c3'), ('\u04c6', '\u04c5'), ('\u04c8', '\u04c7'),
        ('\u04ca', '\u04c9'), ('\u04cc', '\u04cb'), ('\u04ce', '\u04cd'), ('\u04cf', '\u04c0'),
        ('\u04d1', '\u04d0'), ('\u04d3', '\u04d2'), ('\u04d5', '\u04d4'), ('\u04d7', '\u04d6'),
        ('\u04d9', '\u04d8'), ('\u04db', '\u04da'), ('\u04dd', '\u04dc'), ('\u04df', '\u04de'),
        ('\u04e1', '\u04e0'), ('\u04e3', '\u04e2'), ('\u04e5', '\u04e4'), ('\u04e7', '\u04e6'),
        ('\u04e9', '\u04e8'), ('\u04eb', '\u04ea'), ('\u04ed', '\u04ec'), ('\u04ef', '\u04ee'),
        ('\u04f1', '\u04f0'), ('\u04f3', '\u04f2'), ('\u04f5', '\u04f4'), ('\u04f7', '\u04f6'),
        ('\u04f9', '\u04f8'), ('\u04fb', '\u04fa'), ('\u04fd', '\u04fc'), ('\u04ff', '\u04fe'),
        ('\u0501', '\u0500'), ('\u0503', '\u0502'), ('\u0505', '\u0504'), ('\u0507', '\u0506'),
        ('\u0509', '\u0508'), ('\u050b', '\u050a'), ('\u050d', '\u050c'), ('\u050f', '\u050e'),
        ('\u0511', '\u0510'), ('\u0513', '\u0512'), ('\u0515', '\u0514'), ('\u0517', '\u0516'),
        ('\u0519', '\u0518'), ('\u051b', '\u051a'), ('\u051d', '\u051c'), ('\u051f', '\u051e'),
        ('\u0521', '\u0520'), ('\u0523', '\u0522'), ('\u0525', '\u0524'), ('\u0527', '\u0526'),
        ('\u0529', '\u0528'), ('\u052b', '\u052a'), ('\u052d', '\u052c'), ('\u052f', '\u052e'),
        ('\u0561', '\u0531'), ('\u0562', '\u0532'), ('\u0563', '\u0533'), ('\u0564', '\u0534'),
        ('\u0565', '\u0535'), ('\u0566', '\u0536'), ('\u0567', '\u0537'), ('\u0568', '\u0538'),
        ('\u0569', '\u0539'), ('\u056a', '\u053a'), ('\u056b', '\u053b'), ('\u056c', '\u053c'),
        ('\u056d', '\u053d'), ('\u056e', '\u053e'), ('\u056f', '\u053f'), ('\u0570', '\u0540'),
        ('\u0571', '\u0541'), ('\u0572', '\u0542'), ('\u0573', '\u0543'), ('\u0574', '\u0544'),
        ('\u0575', '\u0545'), ('\u0576', '\u0546'), ('\u0577', '\u0547'), ('\u0578', '\u0548'),
        ('\u0579', '\u0549'), ('\u057a', '\u054a'), ('\u057b', '\u054b'), ('\u057c', '\u054c'),
        ('\u057d', '\u054d'), ('\u057e', '\u054e'), ('\u057f', '\u054f'), ('\u0580', '\u0550'),
        ('\u0581', '\u0551'), ('\u0582', '\u0552'), ('\u0583', '\u0553'), ('\u0584', '\u0554'),
        ('\u0585', '\u0555'), ('\u0586', '\u0556'), ('\u1d79', '\ua77d'), ('\u1d7d', '\u2c63'),
        ('\u1e01', '\u1e00'), ('\u1e03', '\u1e02'), ('\u1e05', '\u1e04'), ('\u1e07', '\u1e06'),
        ('\u1e09', '\u1e08'), ('\u1e0b', '\u1e0a'), ('\u1e0d', '\u1e0c'), ('\u1e0f', '\u1e0e'),
        ('\u1e11', '\u1e10'), ('\u1e13', '\u1e12'), ('\u1e15', '\u1e14'), ('\u1e17', '\u1e16'),
        ('\u1e19', '\u1e18'), ('\u1e1b', '\u1e1a'), ('\u1e1d', '\u1e1c'), ('\u1e1f', '\u1e1e'),
        ('\u1e21', '\u1e20'), ('\u1e23', '\u1e22'), ('\u1e25', '\u1e24'), ('\u1e27', '\u1e26'),
        ('\u1e29', '\u1e28'), ('\u1e2b', '\u1e2a'), ('\u1e2d', '\u1e2c'), ('\u1e2f', '\u1e2e'),
        ('\u1e31', '\u1e30'), ('\u1e33', '\u1e32'), ('\u1e35', '\u1e34'), ('\u1e37', '\u1e36'),
        ('\u1e39', '\u1e38'), ('\u1e3b', '\u1e3a'), ('\u1e3d', '\u1e3c'), ('\u1e3f', '\u1e3e'),
        ('\u1e41', '\u1e40'), ('\u1e43', '\u1e42'), ('\u1e45', '\u1e44'), ('\u1e47', '\u1e46'),
        ('\u1e49', '\u1e48'), ('\u1e4b', '\u1e4a'), ('\u1e4d', '\u1e4c'), ('\u1e4f', '\u1e4e'),
        ('\u1e51', '\u1e50'), ('\u1e53', '\u1e52'), ('\u1e55', '\u1e54'), ('\u1e57', '\u1e56'),
        ('\u1e59', '\u1e58'), ('\u1e5b', '\u1e5a'), ('\u1e5d', '\u1e5c'), ('\u1e5f', '\u1e5e'),
        ('\u1e61', '\u1e60'), ('\u1e63', '\u1e62'), ('\u1e65', '\u1e64'), ('\u1e67', '\u1e66'),
        ('\u1e69', '\u1e68'), ('\u1e6b', '\u1e6a'), ('\u1e6d', '\u1e6c'), ('\u1e6f', '\u1e6e'),
        ('\u1e71', '\u1e70'), ('\u1e73', '\u1e72'), ('\u1e75', '\u1e74'), ('\u1e77', '\u1e76'),
        ('\u1e79', '\u1e78'), ('\u1e7b', '\u1e7a'), ('\u1e7d', '\u1e7c'), ('\u1e7f', '\u1e7e'),
        ('\u1e81', '\u1e80'), ('\u1e83', '\u1e82'), ('\u1e85', '\u1e84'), ('\u1e87', '\u1e86'),
        ('\u1e89', '\u1e88'), ('\u1e8b', '\u1e8a'), ('\u1e8d', '\u1e8c'), ('\u1e8f', '\u1e8e'),
        ('\u1e91', '\u1e90'), ('\u1e93', '\u1e92'), ('\u1e95', '\u1e94'), ('\u1e9b', '\u1e60'),
        ('\u1ea1', '\u1ea0'), ('\u1ea3', '\u1ea2'), ('\u1ea5', '\u1ea4'), ('\u1ea7', '\u1ea6'),
        ('\u1ea9', '\u1ea8'), ('\u1eab', '\u1eaa'), ('\u1ead', '\u1eac'), ('\u1eaf', '\u1eae'),
        ('\u1eb1', '\u1eb0'), ('\u1eb3', '\u1eb2'), ('\u1eb5', '\u1eb4'), ('\u1eb7', '\u1eb6'),
        ('\u1eb9', '\u1eb8'), ('\u1ebb', '\u1eba'), ('\u1ebd', '\u1ebc'), ('\u1ebf', '\u1ebe'),
        ('\u1ec1', '\u1ec0'), ('\u1ec3', '\u1ec2'), ('\u1ec5', '\u1ec4'), ('\u1ec7', '\u1ec6'),
        ('\u1ec9', '\u1ec8'), ('\u1ecb', '\u1eca'), ('\u1ecd', '\u1ecc'), ('\u1ecf', '\u1ece'),
        ('\u1ed1', '\u1ed0'), ('\u1ed3', '\u1ed2'), ('\u1ed5', '\u1ed4'), ('\u1ed7', '\u1ed6'),
        ('\u1ed9', '\u1ed8'), ('\u1edb', '\u1eda'), ('\u1edd', '\u1edc'), ('\u1edf', '\u1ede'),
        ('\u1ee1', '\u1ee0'), ('\u1ee3', '\u1ee2'), ('\u1ee5', '\u1ee4'), ('\u1ee7', '\u1ee6'),
        ('\u1ee9', '\u1ee8'), ('\u1eeb', '\u1eea'), ('\u1eed', '\u1eec'), ('\u1eef', '\u1eee'),
        ('\u1ef1', '\u1ef0'), ('\u1ef3', '\u1ef2'), ('\u1ef5', '\u1ef4'), ('\u1ef7', '\u1ef6'),
        ('\u1ef9', '\u1ef8'), ('\u1efb', '\u1efa'), ('\u1efd', '\u1efc'), ('\u1eff', '\u1efe'),
        ('\u1f00', '\u1f08'), ('\u1f01', '\u1f09'), ('\u1f02', '\u1f0a'), ('\u1f03', '\u1f0b'),
        ('\u1f04', '\u1f0c'), ('\u1f05', '\u1f0d'), ('\u1f06', '\u1f0e'), ('\u1f07', '\u1f0f'),
        ('\u1f10', '\u1f18'), ('\u1f11', '\u1f19'), ('\u1f12', '\u1f1a'), ('\u1f13', '\u1f1b'),
        ('\u1f14', '\u1f1c'), ('\u1f15', '\u1f1d'), ('\u1f20', '\u1f28'), ('\u1f21', '\u1f29'),
        ('\u1f22', '\u1f2a'), ('\u1f23', '\u1f2b'), ('\u1f24', '\u1f2c'), ('\u1f25', '\u1f2d'),
        ('\u1f26', '\u1f2e'), ('\u1f27', '\u1f2f'), ('\u1f30', '\u1f38'), ('\u1f31', '\u1f39'),
        ('\u1f32', '\u1f3a'), ('\u1f33', '\u1f3b'), ('\u1f34', '\u1f3c'), ('\u1f35', '\u1f3d'),
        ('\u1f36', '\u1f3e'), ('\u1f37', '\u1f3f'), ('\u1f40', '\u1f48'), ('\u1f41', '\u1f49'),
        ('\u1f42', '\u1f4a'), ('\u1f43', '\u1f4b'), ('\u1f44', '\u1f4c'), ('\u1f45', '\u1f4d'),
        ('\u1f51', '\u1f59'), ('\u1f53', '\u1f5b'), ('\u1f55', '\u1f5d'), ('\u1f57', '\u1f5f'),
        ('\u1f60', '\u1f68'), ('\u1f61', '\u1f69'), ('\u1f62', '\u1f6a'), ('\u1f63', '\u1f6b'),
        ('\u1f64', '\u1f6c'), ('\u1f65', '\u1f6d'), ('\u1f66', '\u1f6e'), ('\u1f67', '\u1f6f'),
        ('\u1f70', '\u1fba'), ('\u1f71', '\u1fbb'), ('\u1f72', '\u1fc8'), ('\u1f73', '\u1fc9'),
        ('\u1f74', '\u1fca'), ('\u1f75', '\u1fcb'), ('\u1f76', '\u1fda'), ('\u1f77', '\u1fdb'),
        ('\u1f78', '\u1ff8'), ('\u1f79', '\u1ff9'), ('\u1f7a', '\u1fea'), ('\u1f7b', '\u1feb'),
        ('\u1f7c', '\u1ffa'), ('\u1f7d', '\u1ffb'), ('\u1f80', '\u1f88'), ('\u1f81', '\u1f89'),
        ('\u1f82', '\u1f8a'), ('\u1f83', '\u1f8b'), ('\u1f84', '\u1f8c'), ('\u1f85', '\u1f8d'),
        ('\u1f86', '\u1f8e'), ('\u1f87', '\u1f8f'), ('\u1f90', '\u1f98'), ('\u1f91', '\u1f99'),
        ('\u1f92', '\u1f9a'), ('\u1f93', '\u1f9b'), ('\u1f94', '\u1f9c'), ('\u1f95', '\u1f9d'),
        ('\u1f96', '\u1f9e'), ('\u1f97', '\u1f9f'), ('\u1fa0', '\u1fa8'), ('\u1fa1', '\u1fa9'),
        ('\u1fa2', '\u1faa'), ('\u1fa3', '\u1fab'), ('\u1fa4', '\u1fac'), ('\u1fa5', '\u1fad'),
        ('\u1fa6', '\u1fae'), ('\u1fa7', '\u1faf'), ('\u1fb0', '\u1fb8'), ('\u1fb1', '\u1fb9'),
        ('\u1fb3', '\u1fbc'), ('\u1fbe', '\u0399'), ('\u1fc3', '\u1fcc'), ('\u1fd0', '\u1fd8'),
        ('\u1fd1', '\u1fd9'), ('\u1fe0', '\u1fe8'), ('\u1fe1', '\u1fe9'), ('\u1fe5', '\u1fec'),
        ('\u1ff3', '\u1ffc'), ('\u214e', '\u2132'), ('\u2184', '\u2183'), ('\u2c30', '\u2c00'),
        ('\u2c31', '\u2c01'), ('\u2c32', '\u2c02'), ('\u2c33', '\u2c03'), ('\u2c34', '\u2c04'),
        ('\u2c35', '\u2c05'), ('\u2c36', '\u2c06'), ('\u2c37', '\u2c07'), ('\u2c38', '\u2c08'),
        ('\u2c39', '\u2c09'), ('\u2c3a', '\u2c0a'), ('\u2c3b', '\u2c0b'), ('\u2c3c', '\u2c0c'),
        ('\u2c3d', '\u2c0d'), ('\u2c3e', '\u2c0e'), ('\u2c3f', '\u2c0f'), ('\u2c40', '\u2c10'),
        ('\u2c41', '\u2c11'), ('\u2c42', '\u2c12'), ('\u2c43', '\u2c13'), ('\u2c44', '\u2c14'),
        ('\u2c45', '\u2c15'), ('\u2c46', '\u2c16'), ('\u2c47', '\u2c17'), ('\u2c48', '\u2c18'),
        ('\u2c49', '\u2c19'), ('\u2c4a', '\u2c1a'), ('\u2c4b', '\u2c1b'), ('\u2c4c', '\u2c1c'),
        ('\u2c4d', '\u2c1d'), ('\u2c4e', '\u2c1e'), ('\u2c4f', '\u2c1f'), ('\u2c50', '\u2c20'),
        ('\u2c51', '\u2c21'), ('\u2c52', '\u2c22'), ('\u2c53', '\u2c23'), ('\u2c54', '\u2c24'),
        ('\u2c55', '\u2c25'), ('\u2c56', '\u2c26'), ('\u2c57', '\u2c27'), ('\u2c58', '\u2c28'),
        ('\u2c59', '\u2c29'), ('\u2c5a', '\u2c2a'), ('\u2c5b', '\u2c2b'), ('\u2c5c', '\u2c2c'),
        ('\u2c5d', '\u2c2d'), ('\u2c5e', '\u2c2e'), ('\u2c61', '\u2c60'), ('\u2c65', '\u023a'),
        ('\u2c66', '\u023e'), ('\u2c68', '\u2c67'), ('\u2c6a', '\u2c69'), ('\u2c6c', '\u2c6b'),
        ('\u2c73', '\u2c72'), ('\u2c76', '\u2c75'), ('\u2c81', '\u2c80'), ('\u2c83', '\u2c82'),
        ('\u2c85', '\u2c84'), ('\u2c87', '\u2c86'), ('\u2c89', '\u2c88'), ('\u2c8b', '\u2c8a'),
        ('\u2c8d', '\u2c8c'), ('\u2c8f', '\u2c8e'), ('\u2c91', '\u2c90'), ('\u2c93', '\u2c92'),
        ('\u2c95', '\u2c94'), ('\u2c97', '\u2c96'), ('\u2c99', '\u2c98'), ('\u2c9b', '\u2c9a'),
        ('\u2c9d', '\u2c9c'), ('\u2c9f', '\u2c9e'), ('\u2ca1', '\u2ca0'), ('\u2ca3', '\u2ca2'),
        ('\u2ca5', '\u2ca4'), ('\u2ca7', '\u2ca6'), ('\u2ca9', '\u2ca8'), ('\u2cab', '\u2caa'),
        ('\u2cad', '\u2cac'), ('\u2caf', '\u2cae'), ('\u2cb1', '\u2cb0'), ('\u2cb3', '\u2cb2'),
        ('\u2cb5', '\u2cb4'), ('\u2cb7', '\u2cb6'), ('\u2cb9', '\u2cb8'), ('\u2cbb', '\u2cba'),
        ('\u2cbd', '\u2cbc'), ('\u2cbf', '\u2cbe'), ('\u2cc1', '\u2cc0'), ('\u2cc3', '\u2cc2'),
        ('\u2cc5', '\u2cc4'), ('\u2cc7', '\u2cc6'), ('\u2cc9', '\u2cc8'), ('\u2ccb', '\u2cca'),
        ('\u2ccd', '\u2ccc'), ('\u2ccf', '\u2cce'), ('\u2cd1', '\u2cd0'), ('\u2cd3', '\u2cd2'),
        ('\u2cd5', '\u2cd4'), ('\u2cd7', '\u2cd6'), ('\u2cd9', '\u2cd8'), ('\u2cdb', '\u2cda'),
        ('\u2cdd', '\u2cdc'), ('\u2cdf', '\u2cde'), ('\u2ce1', '\u2ce0'), ('\u2ce3', '\u2ce2'),
        ('\u2cec', '\u2ceb'), ('\u2cee', '\u2ced'), ('\u2cf3', '\u2cf2'), ('\u2d00', '\u10a0'),
        ('\u2d01', '\u10a1'), ('\u2d02', '\u10a2'), ('\u2d03', '\u10a3'), ('\u2d04', '\u10a4'),
        ('\u2d05', '\u10a5'), ('\u2d06', '\u10a6'), ('\u2d07', '\u10a7'), ('\u2d08', '\u10a8'),
        ('\u2d09', '\u10a9'), ('\u2d0a', '\u10aa'), ('\u2d0b', '\u10ab'), ('\u2d0c', '\u10ac'),
        ('\u2d0d', '\u10ad'), ('\u2d0e', '\u10ae'), ('\u2d0f', '\u10af'), ('\u2d10', '\u10b0'),
        ('\u2d11', '\u10b1'), ('\u2d12', '\u10b2'), ('\u2d13', '\u10b3'), ('\u2d14', '\u10b4'),
        ('\u2d15', '\u10b5'), ('\u2d16', '\u10b6'), ('\u2d17', '\u10b7'), ('\u2d18', '\u10b8'),
        ('\u2d19', '\u10b9'), ('\u2d1a', '\u10ba'), ('\u2d1b', '\u10bb'), ('\u2d1c', '\u10bc'),
        ('\u2d1d', '\u10bd'), ('\u2d1e', '\u10be'), ('\u2d1f', '\u10bf'), ('\u2d20', '\u10c0'),
        ('\u2d21', '\u10c1'), ('\u2d22', '\u10c2'), ('\u2d23', '\u10c3'), ('\u2d24', '\u10c4'),
        ('\u2d25', '\u10c5'), ('\u2d27', '\u10c7'), ('\u2d2d', '\u10cd'), ('\ua641', '\ua640'),
        ('\ua643', '\ua642'), ('\ua645', '\ua644'), ('\ua647', '\ua646'), ('\ua649', '\ua648'),
        ('\ua64b', '\ua64a'), ('\ua64d', '\ua64c'), ('\ua64f', '\ua64e'), ('\ua651', '\ua650'),
        ('\ua653', '\ua652'), ('\ua655', '\ua654'), ('\ua657', '\ua656'), ('\ua659', '\ua658'),
        ('\ua65b', '\ua65a'), ('\ua65d', '\ua65c'), ('\ua65f', '\ua65e'), ('\ua661', '\ua660'),
        ('\ua663', '\ua662'), ('\ua665', '\ua664'), ('\ua667', '\ua666'), ('\ua669', '\ua668'),
        ('\ua66b', '\ua66a'), ('\ua66d', '\ua66c'), ('\ua681', '\ua680'), ('\ua683', '\ua682'),
        ('\ua685', '\ua684'), ('\ua687', '\ua686'), ('\ua689', '\ua688'), ('\ua68b', '\ua68a'),
        ('\ua68d', '\ua68c'), ('\ua68f', '\ua68e'), ('\ua691', '\ua690'), ('\ua693', '\ua692'),
        ('\ua695', '\ua694'), ('\ua697', '\ua696'), ('\ua699', '\ua698'), ('\ua69b', '\ua69a'),
        ('\ua723', '\ua722'), ('\ua725', '\ua724'), ('\ua727', '\ua726'), ('\ua729', '\ua728'),
        ('\ua72b', '\ua72a'), ('\ua72d', '\ua72c'), ('\ua72f', '\ua72e'), ('\ua733', '\ua732'),
        ('\ua735', '\ua734'), ('\ua737', '\ua736'), ('\ua739', '\ua738'), ('\ua73b', '\ua73a'),
        ('\ua73d', '\ua73c'), ('\ua73f', '\ua73e'), ('\ua741', '\ua740'), ('\ua743', '\ua742'),
        ('\ua745', '\ua744'), ('\ua747', '\ua746'), ('\ua749', '\ua748'), ('\ua74b', '\ua74a'),
        ('\ua74d', '\ua74c'), ('\ua74f', '\ua74e'), ('\ua751', '\ua750'), ('\ua753', '\ua752'),
        ('\ua755', '\ua754'), ('\ua757', '\ua756'), ('\ua759', '\ua758'), ('\ua75b', '\ua75a'),
        ('\ua75d', '\ua75c'), ('\ua75f', '\ua75e'), ('\ua761', '\ua760'), ('\ua763', '\ua762'),
        ('\ua765', '\ua764'), ('\ua767', '\ua766'), ('\ua769', '\ua768'), ('\ua76b', '\ua76a'),
        ('\ua76d', '\ua76c'), ('\ua76f', '\ua76e'), ('\ua77a', '\ua779'), ('\ua77c', '\ua77b'),
        ('\ua77f', '\ua77e'), ('\ua781', '\ua780'), ('\ua783', '\ua782'), ('\ua785', '\ua784'),
        ('\ua787', '\ua786'), ('\ua78c', '\ua78b'), ('\ua791', '\ua790'), ('\ua793', '\ua792'),
        ('\ua797', '\ua796'), ('\ua799', '\ua798'), ('\ua79b', '\ua79a'), ('\ua79d', '\ua79c'),
        ('\ua79f', '\ua79e'), ('\ua7a1', '\ua7a0'), ('\ua7a3', '\ua7a2'), ('\ua7a5', '\ua7a4'),
        ('\ua7a7', '\ua7a6'), ('\ua7a9', '\ua7a8'), ('\uff41', '\uff21'), ('\uff42', '\uff22'),
        ('\uff43', '\uff23'), ('\uff44', '\uff24'), ('\uff45', '\uff25'), ('\uff46', '\uff26'),
        ('\uff47', '\uff27'), ('\uff48', '\uff28'), ('\uff49', '\uff29'), ('\uff4a', '\uff2a'),
        ('\uff4b', '\uff2b'), ('\uff4c', '\uff2c'), ('\uff4d', '\uff2d'), ('\uff4e', '\uff2e'),
        ('\uff4f', '\uff2f'), ('\uff50', '\uff30'), ('\uff51', '\uff31'), ('\uff52', '\uff32'),
        ('\uff53', '\uff33'), ('\uff54', '\uff34'), ('\uff55', '\uff35'), ('\uff56', '\uff36'),
        ('\uff57', '\uff37'), ('\uff58', '\uff38'), ('\uff59', '\uff39'), ('\uff5a', '\uff3a'),
        ('\U00010428', '\U00010400'), ('\U00010429', '\U00010401'), ('\U0001042a', '\U00010402'),
        ('\U0001042b', '\U00010403'), ('\U0001042c', '\U00010404'), ('\U0001042d', '\U00010405'),
        ('\U0001042e', '\U00010406'), ('\U0001042f', '\U00010407'), ('\U00010430', '\U00010408'),
        ('\U00010431', '\U00010409'), ('\U00010432', '\U0001040a'), ('\U00010433', '\U0001040b'),
        ('\U00010434', '\U0001040c'), ('\U00010435', '\U0001040d'), ('\U00010436', '\U0001040e'),
        ('\U00010437', '\U0001040f'), ('\U00010438', '\U00010410'), ('\U00010439', '\U00010411'),
        ('\U0001043a', '\U00010412'), ('\U0001043b', '\U00010413'), ('\U0001043c', '\U00010414'),
        ('\U0001043d', '\U00010415'), ('\U0001043e', '\U00010416'), ('\U0001043f', '\U00010417'),
        ('\U00010440', '\U00010418'), ('\U00010441', '\U00010419'), ('\U00010442', '\U0001041a'),
        ('\U00010443', '\U0001041b'), ('\U00010444', '\U0001041c'), ('\U00010445', '\U0001041d'),
        ('\U00010446', '\U0001041e'), ('\U00010447', '\U0001041f'), ('\U00010448', '\U00010420'),
        ('\U00010449', '\U00010421'), ('\U0001044a', '\U00010422'), ('\U0001044b', '\U00010423'),
        ('\U0001044c', '\U00010424'), ('\U0001044d', '\U00010425'), ('\U0001044e', '\U00010426'),
        ('\U0001044f', '\U00010427'), ('\U000118c0', '\U000118a0'), ('\U000118c1', '\U000118a1'),
        ('\U000118c2', '\U000118a2'), ('\U000118c3', '\U000118a3'), ('\U000118c4', '\U000118a4'),
        ('\U000118c5', '\U000118a5'), ('\U000118c6', '\U000118a6'), ('\U000118c7', '\U000118a7'),
        ('\U000118c8', '\U000118a8'), ('\U000118c9', '\U000118a9'), ('\U000118ca', '\U000118aa'),
        ('\U000118cb', '\U000118ab'), ('\U000118cc', '\U000118ac'), ('\U000118cd', '\U000118ad'),
        ('\U000118ce', '\U000118ae'), ('\U000118cf', '\U000118af'), ('\U000118d0', '\U000118b0'),
        ('\U000118d1', '\U000118b1'), ('\U000118d2', '\U000118b2'), ('\U000118d3', '\U000118b3'),
        ('\U000118d4', '\U000118b4'), ('\U000118d5', '\U000118b5'), ('\U000118d6', '\U000118b6'),
        ('\U000118d7', '\U000118b7'), ('\U000118d8', '\U000118b8'), ('\U000118d9', '\U000118b9'),
        ('\U000118da', '\U000118ba'), ('\U000118db', '\U000118bb'), ('\U000118dc', '\U000118bc'),
        ('\U000118dd', '\U000118bd'), ('\U000118de', '\U000118be'), ('\U000118df', '\U000118bf')
    ];

}

pub mod charwidth {
    use core::option::{Option, Some, None};
    use core::slice::SlicePrelude;
    use core::slice;

    fn bsearch_range_value_table(c: char, is_cjk: bool, r: &'static [(char, char, u8, u8)]) -> u8 {
        use core::cmp::{Equal, Less, Greater};
        match r.binary_search(|&(lo, hi, _, _)| {
            if lo <= c && c <= hi { Equal }
            else if hi < c { Less }
            else { Greater }
        }) {
            slice::Found(idx) => {
                let (_, _, r_ncjk, r_cjk) = r[idx];
                if is_cjk { r_cjk } else { r_ncjk }
            }
            slice::NotFound(_) => 1
        }
    }

    pub fn width(c: char, is_cjk: bool) -> Option<uint> {
        match c as uint {
            _c @ 0 => Some(0),          // null is zero width
            cu if cu < 0x20 => None,    // control sequences have no width
            cu if cu < 0x7F => Some(1), // ASCII
            cu if cu < 0xA0 => None,    // more control sequences
            _ => Some(bsearch_range_value_table(c, is_cjk, charwidth_table) as uint)
        }
    }

    // character width table. Based on Markus Kuhn's free wcwidth() implementation,
    //     http://www.cl.cam.ac.uk/~mgk25/ucs/wcwidth.c
    static charwidth_table: &'static [(char, char, u8, u8)] = &[
        ('\u00a1', '\u00a1', 1, 2), ('\u00a4', '\u00a4', 1, 2), ('\u00a7', '\u00a8', 1, 2),
        ('\u00aa', '\u00aa', 1, 2), ('\u00ae', '\u00ae', 1, 2), ('\u00b0', '\u00b4', 1, 2),
        ('\u00b6', '\u00ba', 1, 2), ('\u00bc', '\u00bf', 1, 2), ('\u00c6', '\u00c6', 1, 2),
        ('\u00d0', '\u00d0', 1, 2), ('\u00d7', '\u00d8', 1, 2), ('\u00de', '\u00e1', 1, 2),
        ('\u00e6', '\u00e6', 1, 2), ('\u00e8', '\u00ea', 1, 2), ('\u00ec', '\u00ed', 1, 2),
        ('\u00f0', '\u00f0', 1, 2), ('\u00f2', '\u00f3', 1, 2), ('\u00f7', '\u00fa', 1, 2),
        ('\u00fc', '\u00fc', 1, 2), ('\u00fe', '\u00fe', 1, 2), ('\u0101', '\u0101', 1, 2),
        ('\u0111', '\u0111', 1, 2), ('\u0113', '\u0113', 1, 2), ('\u011b', '\u011b', 1, 2),
        ('\u0126', '\u0127', 1, 2), ('\u012b', '\u012b', 1, 2), ('\u0131', '\u0133', 1, 2),
        ('\u0138', '\u0138', 1, 2), ('\u013f', '\u0142', 1, 2), ('\u0144', '\u0144', 1, 2),
        ('\u0148', '\u014b', 1, 2), ('\u014d', '\u014d', 1, 2), ('\u0152', '\u0153', 1, 2),
        ('\u0166', '\u0167', 1, 2), ('\u016b', '\u016b', 1, 2), ('\u01ce', '\u01ce', 1, 2),
        ('\u01d0', '\u01d0', 1, 2), ('\u01d2', '\u01d2', 1, 2), ('\u01d4', '\u01d4', 1, 2),
        ('\u01d6', '\u01d6', 1, 2), ('\u01d8', '\u01d8', 1, 2), ('\u01da', '\u01da', 1, 2),
        ('\u01dc', '\u01dc', 1, 2), ('\u0251', '\u0251', 1, 2), ('\u0261', '\u0261', 1, 2),
        ('\u02c4', '\u02c4', 1, 2), ('\u02c7', '\u02c7', 1, 2), ('\u02c9', '\u02cb', 1, 2),
        ('\u02cd', '\u02cd', 1, 2), ('\u02d0', '\u02d0', 1, 2), ('\u02d8', '\u02db', 1, 2),
        ('\u02dd', '\u02dd', 1, 2), ('\u02df', '\u02df', 1, 2), ('\u0300', '\u036f', 0, 0),
        ('\u0391', '\u03a1', 1, 2), ('\u03a3', '\u03a9', 1, 2), ('\u03b1', '\u03c1', 1, 2),
        ('\u03c3', '\u03c9', 1, 2), ('\u0401', '\u0401', 1, 2), ('\u0410', '\u044f', 1, 2),
        ('\u0451', '\u0451', 1, 2), ('\u0483', '\u0489', 0, 0), ('\u0591', '\u05bd', 0, 0),
        ('\u05bf', '\u05bf', 0, 0), ('\u05c1', '\u05c2', 0, 0), ('\u05c4', '\u05c5', 0, 0),
        ('\u05c7', '\u05c7', 0, 0), ('\u0600', '\u0605', 0, 0), ('\u0610', '\u061a', 0, 0),
        ('\u061c', '\u061c', 0, 0), ('\u064b', '\u065f', 0, 0), ('\u0670', '\u0670', 0, 0),
        ('\u06d6', '\u06dd', 0, 0), ('\u06df', '\u06e4', 0, 0), ('\u06e7', '\u06e8', 0, 0),
        ('\u06ea', '\u06ed', 0, 0), ('\u070f', '\u070f', 0, 0), ('\u0711', '\u0711', 0, 0),
        ('\u0730', '\u074a', 0, 0), ('\u07a6', '\u07b0', 0, 0), ('\u07eb', '\u07f3', 0, 0),
        ('\u0816', '\u0819', 0, 0), ('\u081b', '\u0823', 0, 0), ('\u0825', '\u0827', 0, 0),
        ('\u0829', '\u082d', 0, 0), ('\u0859', '\u085b', 0, 0), ('\u08e4', '\u0902', 0, 0),
        ('\u093a', '\u093a', 0, 0), ('\u093c', '\u093c', 0, 0), ('\u0941', '\u0948', 0, 0),
        ('\u094d', '\u094d', 0, 0), ('\u0951', '\u0957', 0, 0), ('\u0962', '\u0963', 0, 0),
        ('\u0981', '\u0981', 0, 0), ('\u09bc', '\u09bc', 0, 0), ('\u09c1', '\u09c4', 0, 0),
        ('\u09cd', '\u09cd', 0, 0), ('\u09e2', '\u09e3', 0, 0), ('\u0a01', '\u0a02', 0, 0),
        ('\u0a3c', '\u0a3c', 0, 0), ('\u0a41', '\u0a42', 0, 0), ('\u0a47', '\u0a48', 0, 0),
        ('\u0a4b', '\u0a4d', 0, 0), ('\u0a51', '\u0a51', 0, 0), ('\u0a70', '\u0a71', 0, 0),
        ('\u0a75', '\u0a75', 0, 0), ('\u0a81', '\u0a82', 0, 0), ('\u0abc', '\u0abc', 0, 0),
        ('\u0ac1', '\u0ac5', 0, 0), ('\u0ac7', '\u0ac8', 0, 0), ('\u0acd', '\u0acd', 0, 0),
        ('\u0ae2', '\u0ae3', 0, 0), ('\u0b01', '\u0b01', 0, 0), ('\u0b3c', '\u0b3c', 0, 0),
        ('\u0b3f', '\u0b3f', 0, 0), ('\u0b41', '\u0b44', 0, 0), ('\u0b4d', '\u0b4d', 0, 0),
        ('\u0b56', '\u0b56', 0, 0), ('\u0b62', '\u0b63', 0, 0), ('\u0b82', '\u0b82', 0, 0),
        ('\u0bc0', '\u0bc0', 0, 0), ('\u0bcd', '\u0bcd', 0, 0), ('\u0c00', '\u0c00', 0, 0),
        ('\u0c3e', '\u0c40', 0, 0), ('\u0c46', '\u0c48', 0, 0), ('\u0c4a', '\u0c4d', 0, 0),
        ('\u0c55', '\u0c56', 0, 0), ('\u0c62', '\u0c63', 0, 0), ('\u0c81', '\u0c81', 0, 0),
        ('\u0cbc', '\u0cbc', 0, 0), ('\u0cbf', '\u0cbf', 0, 0), ('\u0cc6', '\u0cc6', 0, 0),
        ('\u0ccc', '\u0ccd', 0, 0), ('\u0ce2', '\u0ce3', 0, 0), ('\u0d01', '\u0d01', 0, 0),
        ('\u0d41', '\u0d44', 0, 0), ('\u0d4d', '\u0d4d', 0, 0), ('\u0d62', '\u0d63', 0, 0),
        ('\u0dca', '\u0dca', 0, 0), ('\u0dd2', '\u0dd4', 0, 0), ('\u0dd6', '\u0dd6', 0, 0),
        ('\u0e31', '\u0e31', 0, 0), ('\u0e34', '\u0e3a', 0, 0), ('\u0e47', '\u0e4e', 0, 0),
        ('\u0eb1', '\u0eb1', 0, 0), ('\u0eb4', '\u0eb9', 0, 0), ('\u0ebb', '\u0ebc', 0, 0),
        ('\u0ec8', '\u0ecd', 0, 0), ('\u0f18', '\u0f19', 0, 0), ('\u0f35', '\u0f35', 0, 0),
        ('\u0f37', '\u0f37', 0, 0), ('\u0f39', '\u0f39', 0, 0), ('\u0f71', '\u0f7e', 0, 0),
        ('\u0f80', '\u0f84', 0, 0), ('\u0f86', '\u0f87', 0, 0), ('\u0f8d', '\u0f97', 0, 0),
        ('\u0f99', '\u0fbc', 0, 0), ('\u0fc6', '\u0fc6', 0, 0), ('\u102d', '\u1030', 0, 0),
        ('\u1032', '\u1037', 0, 0), ('\u1039', '\u103a', 0, 0), ('\u103d', '\u103e', 0, 0),
        ('\u1058', '\u1059', 0, 0), ('\u105e', '\u1060', 0, 0), ('\u1071', '\u1074', 0, 0),
        ('\u1082', '\u1082', 0, 0), ('\u1085', '\u1086', 0, 0), ('\u108d', '\u108d', 0, 0),
        ('\u109d', '\u109d', 0, 0), ('\u1100', '\u115f', 2, 2), ('\u1160', '\u11ff', 0, 0),
        ('\u135d', '\u135f', 0, 0), ('\u1712', '\u1714', 0, 0), ('\u1732', '\u1734', 0, 0),
        ('\u1752', '\u1753', 0, 0), ('\u1772', '\u1773', 0, 0), ('\u17b4', '\u17b5', 0, 0),
        ('\u17b7', '\u17bd', 0, 0), ('\u17c6', '\u17c6', 0, 0), ('\u17c9', '\u17d3', 0, 0),
        ('\u17dd', '\u17dd', 0, 0), ('\u180b', '\u180e', 0, 0), ('\u18a9', '\u18a9', 0, 0),
        ('\u1920', '\u1922', 0, 0), ('\u1927', '\u1928', 0, 0), ('\u1932', '\u1932', 0, 0),
        ('\u1939', '\u193b', 0, 0), ('\u1a17', '\u1a18', 0, 0), ('\u1a1b', '\u1a1b', 0, 0),
        ('\u1a56', '\u1a56', 0, 0), ('\u1a58', '\u1a5e', 0, 0), ('\u1a60', '\u1a60', 0, 0),
        ('\u1a62', '\u1a62', 0, 0), ('\u1a65', '\u1a6c', 0, 0), ('\u1a73', '\u1a7c', 0, 0),
        ('\u1a7f', '\u1a7f', 0, 0), ('\u1ab0', '\u1abe', 0, 0), ('\u1b00', '\u1b03', 0, 0),
        ('\u1b34', '\u1b34', 0, 0), ('\u1b36', '\u1b3a', 0, 0), ('\u1b3c', '\u1b3c', 0, 0),
        ('\u1b42', '\u1b42', 0, 0), ('\u1b6b', '\u1b73', 0, 0), ('\u1b80', '\u1b81', 0, 0),
        ('\u1ba2', '\u1ba5', 0, 0), ('\u1ba8', '\u1ba9', 0, 0), ('\u1bab', '\u1bad', 0, 0),
        ('\u1be6', '\u1be6', 0, 0), ('\u1be8', '\u1be9', 0, 0), ('\u1bed', '\u1bed', 0, 0),
        ('\u1bef', '\u1bf1', 0, 0), ('\u1c2c', '\u1c33', 0, 0), ('\u1c36', '\u1c37', 0, 0),
        ('\u1cd0', '\u1cd2', 0, 0), ('\u1cd4', '\u1ce0', 0, 0), ('\u1ce2', '\u1ce8', 0, 0),
        ('\u1ced', '\u1ced', 0, 0), ('\u1cf4', '\u1cf4', 0, 0), ('\u1cf8', '\u1cf9', 0, 0),
        ('\u1dc0', '\u1df5', 0, 0), ('\u1dfc', '\u1dff', 0, 0), ('\u200b', '\u200f', 0, 0),
        ('\u2010', '\u2010', 1, 2), ('\u2013', '\u2016', 1, 2), ('\u2018', '\u2019', 1, 2),
        ('\u201c', '\u201d', 1, 2), ('\u2020', '\u2022', 1, 2), ('\u2024', '\u2027', 1, 2),
        ('\u202a', '\u202e', 0, 0), ('\u2030', '\u2030', 1, 2), ('\u2032', '\u2033', 1, 2),
        ('\u2035', '\u2035', 1, 2), ('\u203b', '\u203b', 1, 2), ('\u203e', '\u203e', 1, 2),
        ('\u2060', '\u2064', 0, 0), ('\u2066', '\u206f', 0, 0), ('\u2074', '\u2074', 1, 2),
        ('\u207f', '\u207f', 1, 2), ('\u2081', '\u2084', 1, 2), ('\u20ac', '\u20ac', 1, 2),
        ('\u20d0', '\u20f0', 0, 0), ('\u2103', '\u2103', 1, 2), ('\u2105', '\u2105', 1, 2),
        ('\u2109', '\u2109', 1, 2), ('\u2113', '\u2113', 1, 2), ('\u2116', '\u2116', 1, 2),
        ('\u2121', '\u2122', 1, 2), ('\u2126', '\u2126', 1, 2), ('\u212b', '\u212b', 1, 2),
        ('\u2153', '\u2154', 1, 2), ('\u215b', '\u215e', 1, 2), ('\u2160', '\u216b', 1, 2),
        ('\u2170', '\u2179', 1, 2), ('\u2189', '\u2189', 1, 2), ('\u2190', '\u2199', 1, 2),
        ('\u21b8', '\u21b9', 1, 2), ('\u21d2', '\u21d2', 1, 2), ('\u21d4', '\u21d4', 1, 2),
        ('\u21e7', '\u21e7', 1, 2), ('\u2200', '\u2200', 1, 2), ('\u2202', '\u2203', 1, 2),
        ('\u2207', '\u2208', 1, 2), ('\u220b', '\u220b', 1, 2), ('\u220f', '\u220f', 1, 2),
        ('\u2211', '\u2211', 1, 2), ('\u2215', '\u2215', 1, 2), ('\u221a', '\u221a', 1, 2),
        ('\u221d', '\u2220', 1, 2), ('\u2223', '\u2223', 1, 2), ('\u2225', '\u2225', 1, 2),
        ('\u2227', '\u222c', 1, 2), ('\u222e', '\u222e', 1, 2), ('\u2234', '\u2237', 1, 2),
        ('\u223c', '\u223d', 1, 2), ('\u2248', '\u2248', 1, 2), ('\u224c', '\u224c', 1, 2),
        ('\u2252', '\u2252', 1, 2), ('\u2260', '\u2261', 1, 2), ('\u2264', '\u2267', 1, 2),
        ('\u226a', '\u226b', 1, 2), ('\u226e', '\u226f', 1, 2), ('\u2282', '\u2283', 1, 2),
        ('\u2286', '\u2287', 1, 2), ('\u2295', '\u2295', 1, 2), ('\u2299', '\u2299', 1, 2),
        ('\u22a5', '\u22a5', 1, 2), ('\u22bf', '\u22bf', 1, 2), ('\u2312', '\u2312', 1, 2),
        ('\u2329', '\u232a', 2, 2), ('\u2460', '\u24e9', 1, 2), ('\u24eb', '\u254b', 1, 2),
        ('\u2550', '\u2573', 1, 2), ('\u2580', '\u258f', 1, 2), ('\u2592', '\u2595', 1, 2),
        ('\u25a0', '\u25a1', 1, 2), ('\u25a3', '\u25a9', 1, 2), ('\u25b2', '\u25b3', 1, 2),
        ('\u25b6', '\u25b7', 1, 2), ('\u25bc', '\u25bd', 1, 2), ('\u25c0', '\u25c1', 1, 2),
        ('\u25c6', '\u25c8', 1, 2), ('\u25cb', '\u25cb', 1, 2), ('\u25ce', '\u25d1', 1, 2),
        ('\u25e2', '\u25e5', 1, 2), ('\u25ef', '\u25ef', 1, 2), ('\u2605', '\u2606', 1, 2),
        ('\u2609', '\u2609', 1, 2), ('\u260e', '\u260f', 1, 2), ('\u2614', '\u2615', 1, 2),
        ('\u261c', '\u261c', 1, 2), ('\u261e', '\u261e', 1, 2), ('\u2640', '\u2640', 1, 2),
        ('\u2642', '\u2642', 1, 2), ('\u2660', '\u2661', 1, 2), ('\u2663', '\u2665', 1, 2),
        ('\u2667', '\u266a', 1, 2), ('\u266c', '\u266d', 1, 2), ('\u266f', '\u266f', 1, 2),
        ('\u269e', '\u269f', 1, 2), ('\u26be', '\u26bf', 1, 2), ('\u26c4', '\u26cd', 1, 2),
        ('\u26cf', '\u26e1', 1, 2), ('\u26e3', '\u26e3', 1, 2), ('\u26e8', '\u26ff', 1, 2),
        ('\u273d', '\u273d', 1, 2), ('\u2757', '\u2757', 1, 2), ('\u2776', '\u277f', 1, 2),
        ('\u2b55', '\u2b59', 1, 2), ('\u2cef', '\u2cf1', 0, 0), ('\u2d7f', '\u2d7f', 0, 0),
        ('\u2de0', '\u2dff', 0, 0), ('\u2e80', '\u2e99', 2, 2), ('\u2e9b', '\u2ef3', 2, 2),
        ('\u2f00', '\u2fd5', 2, 2), ('\u2ff0', '\u2ffb', 2, 2), ('\u3000', '\u3029', 2, 2),
        ('\u302a', '\u302d', 0, 0), ('\u302e', '\u303e', 2, 2), ('\u3041', '\u3096', 2, 2),
        ('\u3099', '\u309a', 0, 0), ('\u309b', '\u30ff', 2, 2), ('\u3105', '\u312d', 2, 2),
        ('\u3131', '\u318e', 2, 2), ('\u3190', '\u31ba', 2, 2), ('\u31c0', '\u31e3', 2, 2),
        ('\u31f0', '\u321e', 2, 2), ('\u3220', '\u3247', 2, 2), ('\u3248', '\u324f', 1, 2),
        ('\u3250', '\u32fe', 2, 2), ('\u3300', '\u4dbf', 2, 2), ('\u4e00', '\ua48c', 2, 2),
        ('\ua490', '\ua4c6', 2, 2), ('\ua66f', '\ua672', 0, 0), ('\ua674', '\ua67d', 0, 0),
        ('\ua69f', '\ua69f', 0, 0), ('\ua6f0', '\ua6f1', 0, 0), ('\ua802', '\ua802', 0, 0),
        ('\ua806', '\ua806', 0, 0), ('\ua80b', '\ua80b', 0, 0), ('\ua825', '\ua826', 0, 0),
        ('\ua8c4', '\ua8c4', 0, 0), ('\ua8e0', '\ua8f1', 0, 0), ('\ua926', '\ua92d', 0, 0),
        ('\ua947', '\ua951', 0, 0), ('\ua960', '\ua97c', 2, 2), ('\ua980', '\ua982', 0, 0),
        ('\ua9b3', '\ua9b3', 0, 0), ('\ua9b6', '\ua9b9', 0, 0), ('\ua9bc', '\ua9bc', 0, 0),
        ('\ua9e5', '\ua9e5', 0, 0), ('\uaa29', '\uaa2e', 0, 0), ('\uaa31', '\uaa32', 0, 0),
        ('\uaa35', '\uaa36', 0, 0), ('\uaa43', '\uaa43', 0, 0), ('\uaa4c', '\uaa4c', 0, 0),
        ('\uaa7c', '\uaa7c', 0, 0), ('\uaab0', '\uaab0', 0, 0), ('\uaab2', '\uaab4', 0, 0),
        ('\uaab7', '\uaab8', 0, 0), ('\uaabe', '\uaabf', 0, 0), ('\uaac1', '\uaac1', 0, 0),
        ('\uaaec', '\uaaed', 0, 0), ('\uaaf6', '\uaaf6', 0, 0), ('\uabe5', '\uabe5', 0, 0),
        ('\uabe8', '\uabe8', 0, 0), ('\uabed', '\uabed', 0, 0), ('\uac00', '\ud7a3', 2, 2),
        ('\ue000', '\uf8ff', 1, 2), ('\uf900', '\ufaff', 2, 2), ('\ufb1e', '\ufb1e', 0, 0),
        ('\ufe00', '\ufe0f', 0, 0), ('\ufe10', '\ufe19', 2, 2), ('\ufe20', '\ufe2d', 0, 0),
        ('\ufe30', '\ufe52', 2, 2), ('\ufe54', '\ufe66', 2, 2), ('\ufe68', '\ufe6b', 2, 2),
        ('\ufeff', '\ufeff', 0, 0), ('\uff01', '\uff60', 2, 2), ('\uffe0', '\uffe6', 2, 2),
        ('\ufff9', '\ufffb', 0, 0), ('\ufffd', '\ufffd', 1, 2), ('\U000101fd', '\U000101fd', 0, 0),
        ('\U000102e0', '\U000102e0', 0, 0), ('\U00010376', '\U0001037a', 0, 0), ('\U00010a01',
        '\U00010a03', 0, 0), ('\U00010a05', '\U00010a06', 0, 0), ('\U00010a0c', '\U00010a0f', 0, 0),
        ('\U00010a38', '\U00010a3a', 0, 0), ('\U00010a3f', '\U00010a3f', 0, 0), ('\U00010ae5',
        '\U00010ae6', 0, 0), ('\U00011001', '\U00011001', 0, 0), ('\U00011038', '\U00011046', 0, 0),
        ('\U0001107f', '\U00011081', 0, 0), ('\U000110b3', '\U000110b6', 0, 0), ('\U000110b9',
        '\U000110ba', 0, 0), ('\U000110bd', '\U000110bd', 0, 0), ('\U00011100', '\U00011102', 0, 0),
        ('\U00011127', '\U0001112b', 0, 0), ('\U0001112d', '\U00011134', 0, 0), ('\U00011173',
        '\U00011173', 0, 0), ('\U00011180', '\U00011181', 0, 0), ('\U000111b6', '\U000111be', 0, 0),
        ('\U0001122f', '\U00011231', 0, 0), ('\U00011234', '\U00011234', 0, 0), ('\U00011236',
        '\U00011237', 0, 0), ('\U000112df', '\U000112df', 0, 0), ('\U000112e3', '\U000112ea', 0, 0),
        ('\U00011301', '\U00011301', 0, 0), ('\U0001133c', '\U0001133c', 0, 0), ('\U00011340',
        '\U00011340', 0, 0), ('\U00011366', '\U0001136c', 0, 0), ('\U00011370', '\U00011374', 0, 0),
        ('\U000114b3', '\U000114b8', 0, 0), ('\U000114ba', '\U000114ba', 0, 0), ('\U000114bf',
        '\U000114c0', 0, 0), ('\U000114c2', '\U000114c3', 0, 0), ('\U000115b2', '\U000115b5', 0, 0),
        ('\U000115bc', '\U000115bd', 0, 0), ('\U000115bf', '\U000115c0', 0, 0), ('\U00011633',
        '\U0001163a', 0, 0), ('\U0001163d', '\U0001163d', 0, 0), ('\U0001163f', '\U00011640', 0, 0),
        ('\U000116ab', '\U000116ab', 0, 0), ('\U000116ad', '\U000116ad', 0, 0), ('\U000116b0',
        '\U000116b5', 0, 0), ('\U000116b7', '\U000116b7', 0, 0), ('\U00016af0', '\U00016af4', 0, 0),
        ('\U00016b30', '\U00016b36', 0, 0), ('\U00016f8f', '\U00016f92', 0, 0), ('\U0001b000',
        '\U0001b001', 2, 2), ('\U0001bc9d', '\U0001bc9e', 0, 0), ('\U0001bca0', '\U0001bca3', 0, 0),
        ('\U0001d167', '\U0001d169', 0, 0), ('\U0001d173', '\U0001d182', 0, 0), ('\U0001d185',
        '\U0001d18b', 0, 0), ('\U0001d1aa', '\U0001d1ad', 0, 0), ('\U0001d242', '\U0001d244', 0, 0),
        ('\U0001e8d0', '\U0001e8d6', 0, 0), ('\U0001f100', '\U0001f10a', 1, 2), ('\U0001f110',
        '\U0001f12d', 1, 2), ('\U0001f130', '\U0001f169', 1, 2), ('\U0001f170', '\U0001f19a', 1, 2),
        ('\U0001f200', '\U0001f202', 2, 2), ('\U0001f210', '\U0001f23a', 2, 2), ('\U0001f240',
        '\U0001f248', 2, 2), ('\U0001f250', '\U0001f251', 2, 2), ('\U00020000', '\U0002fffd', 2, 2),
        ('\U00030000', '\U0003fffd', 2, 2), ('\U000e0001', '\U000e0001', 0, 0), ('\U000e0020',
        '\U000e007f', 0, 0), ('\U000e0100', '\U000e01ef', 0, 0), ('\U000f0000', '\U000ffffd', 1, 2),
        ('\U00100000', '\U0010fffd', 1, 2)
    ];

}

pub mod grapheme {
    pub use self::GraphemeCat::*;
    use core::slice::SlicePrelude;
    use core::slice;

    #[allow(non_camel_case_types)]
    #[deriving(Clone)]
    pub enum GraphemeCat {
        GC_LV,
        GC_LVT,
        GC_T,
        GC_Extend,
        GC_V,
        GC_Control,
        GC_SpacingMark,
        GC_L,
        GC_RegionalIndicator,
        GC_Any,
    }

    fn bsearch_range_value_table(c: char, r: &'static [(char, char, GraphemeCat)]) -> GraphemeCat {
        use core::cmp::{Equal, Less, Greater};
        match r.binary_search(|&(lo, hi, _)| {
            if lo <= c && c <= hi { Equal }
            else if hi < c { Less }
            else { Greater }
        }) {
            slice::Found(idx) => {
                let (_, _, cat) = r[idx];
                cat
            }
            slice::NotFound(_) => GC_Any
        }
    }

    pub fn grapheme_category(c: char) -> GraphemeCat {
        bsearch_range_value_table(c, grapheme_cat_table)
    }

    static grapheme_cat_table: &'static [(char, char, GraphemeCat)] = &[
        ('\x00', '\x1f', GC_Control), ('\x7f', '\u009f', GC_Control), ('\u00ad', '\u00ad',
        GC_Control), ('\u0300', '\u036f', GC_Extend), ('\u0483', '\u0487', GC_Extend), ('\u0488',
        '\u0489', GC_Extend), ('\u0591', '\u05bd', GC_Extend), ('\u05bf', '\u05bf', GC_Extend),
        ('\u05c1', '\u05c2', GC_Extend), ('\u05c4', '\u05c5', GC_Extend), ('\u05c7', '\u05c7',
        GC_Extend), ('\u0600', '\u0605', GC_Control), ('\u0610', '\u061a', GC_Extend), ('\u061c',
        '\u061c', GC_Control), ('\u064b', '\u065f', GC_Extend), ('\u0670', '\u0670', GC_Extend),
        ('\u06d6', '\u06dc', GC_Extend), ('\u06dd', '\u06dd', GC_Control), ('\u06df', '\u06e4',
        GC_Extend), ('\u06e7', '\u06e8', GC_Extend), ('\u06ea', '\u06ed', GC_Extend), ('\u070f',
        '\u070f', GC_Control), ('\u0711', '\u0711', GC_Extend), ('\u0730', '\u074a', GC_Extend),
        ('\u07a6', '\u07b0', GC_Extend), ('\u07eb', '\u07f3', GC_Extend), ('\u0816', '\u0819',
        GC_Extend), ('\u081b', '\u0823', GC_Extend), ('\u0825', '\u0827', GC_Extend), ('\u0829',
        '\u082d', GC_Extend), ('\u0859', '\u085b', GC_Extend), ('\u08e4', '\u0902', GC_Extend),
        ('\u0903', '\u0903', GC_SpacingMark), ('\u093a', '\u093a', GC_Extend), ('\u093b', '\u093b',
        GC_SpacingMark), ('\u093c', '\u093c', GC_Extend), ('\u093e', '\u0940', GC_SpacingMark),
        ('\u0941', '\u0948', GC_Extend), ('\u0949', '\u094c', GC_SpacingMark), ('\u094d', '\u094d',
        GC_Extend), ('\u094e', '\u094f', GC_SpacingMark), ('\u0951', '\u0957', GC_Extend),
        ('\u0962', '\u0963', GC_Extend), ('\u0981', '\u0981', GC_Extend), ('\u0982', '\u0983',
        GC_SpacingMark), ('\u09bc', '\u09bc', GC_Extend), ('\u09be', '\u09be', GC_Extend),
        ('\u09bf', '\u09c0', GC_SpacingMark), ('\u09c1', '\u09c4', GC_Extend), ('\u09c7', '\u09c8',
        GC_SpacingMark), ('\u09cb', '\u09cc', GC_SpacingMark), ('\u09cd', '\u09cd', GC_Extend),
        ('\u09d7', '\u09d7', GC_Extend), ('\u09e2', '\u09e3', GC_Extend), ('\u0a01', '\u0a02',
        GC_Extend), ('\u0a03', '\u0a03', GC_SpacingMark), ('\u0a3c', '\u0a3c', GC_Extend),
        ('\u0a3e', '\u0a40', GC_SpacingMark), ('\u0a41', '\u0a42', GC_Extend), ('\u0a47', '\u0a48',
        GC_Extend), ('\u0a4b', '\u0a4d', GC_Extend), ('\u0a51', '\u0a51', GC_Extend), ('\u0a70',
        '\u0a71', GC_Extend), ('\u0a75', '\u0a75', GC_Extend), ('\u0a81', '\u0a82', GC_Extend),
        ('\u0a83', '\u0a83', GC_SpacingMark), ('\u0abc', '\u0abc', GC_Extend), ('\u0abe', '\u0ac0',
        GC_SpacingMark), ('\u0ac1', '\u0ac5', GC_Extend), ('\u0ac7', '\u0ac8', GC_Extend),
        ('\u0ac9', '\u0ac9', GC_SpacingMark), ('\u0acb', '\u0acc', GC_SpacingMark), ('\u0acd',
        '\u0acd', GC_Extend), ('\u0ae2', '\u0ae3', GC_Extend), ('\u0b01', '\u0b01', GC_Extend),
        ('\u0b02', '\u0b03', GC_SpacingMark), ('\u0b3c', '\u0b3c', GC_Extend), ('\u0b3e', '\u0b3e',
        GC_Extend), ('\u0b3f', '\u0b3f', GC_Extend), ('\u0b40', '\u0b40', GC_SpacingMark),
        ('\u0b41', '\u0b44', GC_Extend), ('\u0b47', '\u0b48', GC_SpacingMark), ('\u0b4b', '\u0b4c',
        GC_SpacingMark), ('\u0b4d', '\u0b4d', GC_Extend), ('\u0b56', '\u0b56', GC_Extend),
        ('\u0b57', '\u0b57', GC_Extend), ('\u0b62', '\u0b63', GC_Extend), ('\u0b82', '\u0b82',
        GC_Extend), ('\u0bbe', '\u0bbe', GC_Extend), ('\u0bbf', '\u0bbf', GC_SpacingMark),
        ('\u0bc0', '\u0bc0', GC_Extend), ('\u0bc1', '\u0bc2', GC_SpacingMark), ('\u0bc6', '\u0bc8',
        GC_SpacingMark), ('\u0bca', '\u0bcc', GC_SpacingMark), ('\u0bcd', '\u0bcd', GC_Extend),
        ('\u0bd7', '\u0bd7', GC_Extend), ('\u0c00', '\u0c00', GC_Extend), ('\u0c01', '\u0c03',
        GC_SpacingMark), ('\u0c3e', '\u0c40', GC_Extend), ('\u0c41', '\u0c44', GC_SpacingMark),
        ('\u0c46', '\u0c48', GC_Extend), ('\u0c4a', '\u0c4d', GC_Extend), ('\u0c55', '\u0c56',
        GC_Extend), ('\u0c62', '\u0c63', GC_Extend), ('\u0c81', '\u0c81', GC_Extend), ('\u0c82',
        '\u0c83', GC_SpacingMark), ('\u0cbc', '\u0cbc', GC_Extend), ('\u0cbe', '\u0cbe',
        GC_SpacingMark), ('\u0cbf', '\u0cbf', GC_Extend), ('\u0cc0', '\u0cc1', GC_SpacingMark),
        ('\u0cc2', '\u0cc2', GC_Extend), ('\u0cc3', '\u0cc4', GC_SpacingMark), ('\u0cc6', '\u0cc6',
        GC_Extend), ('\u0cc7', '\u0cc8', GC_SpacingMark), ('\u0cca', '\u0ccb', GC_SpacingMark),
        ('\u0ccc', '\u0ccd', GC_Extend), ('\u0cd5', '\u0cd6', GC_Extend), ('\u0ce2', '\u0ce3',
        GC_Extend), ('\u0d01', '\u0d01', GC_Extend), ('\u0d02', '\u0d03', GC_SpacingMark),
        ('\u0d3e', '\u0d3e', GC_Extend), ('\u0d3f', '\u0d40', GC_SpacingMark), ('\u0d41', '\u0d44',
        GC_Extend), ('\u0d46', '\u0d48', GC_SpacingMark), ('\u0d4a', '\u0d4c', GC_SpacingMark),
        ('\u0d4d', '\u0d4d', GC_Extend), ('\u0d57', '\u0d57', GC_Extend), ('\u0d62', '\u0d63',
        GC_Extend), ('\u0d82', '\u0d83', GC_SpacingMark), ('\u0dca', '\u0dca', GC_Extend),
        ('\u0dcf', '\u0dcf', GC_Extend), ('\u0dd0', '\u0dd1', GC_SpacingMark), ('\u0dd2', '\u0dd4',
        GC_Extend), ('\u0dd6', '\u0dd6', GC_Extend), ('\u0dd8', '\u0dde', GC_SpacingMark),
        ('\u0ddf', '\u0ddf', GC_Extend), ('\u0df2', '\u0df3', GC_SpacingMark), ('\u0e31', '\u0e31',
        GC_Extend), ('\u0e33', '\u0e33', GC_SpacingMark), ('\u0e34', '\u0e3a', GC_Extend),
        ('\u0e47', '\u0e4e', GC_Extend), ('\u0eb1', '\u0eb1', GC_Extend), ('\u0eb3', '\u0eb3',
        GC_SpacingMark), ('\u0eb4', '\u0eb9', GC_Extend), ('\u0ebb', '\u0ebc', GC_Extend),
        ('\u0ec8', '\u0ecd', GC_Extend), ('\u0f18', '\u0f19', GC_Extend), ('\u0f35', '\u0f35',
        GC_Extend), ('\u0f37', '\u0f37', GC_Extend), ('\u0f39', '\u0f39', GC_Extend), ('\u0f3e',
        '\u0f3f', GC_SpacingMark), ('\u0f71', '\u0f7e', GC_Extend), ('\u0f7f', '\u0f7f',
        GC_SpacingMark), ('\u0f80', '\u0f84', GC_Extend), ('\u0f86', '\u0f87', GC_Extend),
        ('\u0f8d', '\u0f97', GC_Extend), ('\u0f99', '\u0fbc', GC_Extend), ('\u0fc6', '\u0fc6',
        GC_Extend), ('\u102b', '\u102c', GC_SpacingMark), ('\u102d', '\u1030', GC_Extend),
        ('\u1031', '\u1031', GC_SpacingMark), ('\u1032', '\u1037', GC_Extend), ('\u1038', '\u1038',
        GC_SpacingMark), ('\u1039', '\u103a', GC_Extend), ('\u103b', '\u103c', GC_SpacingMark),
        ('\u103d', '\u103e', GC_Extend), ('\u1056', '\u1057', GC_SpacingMark), ('\u1058', '\u1059',
        GC_Extend), ('\u105e', '\u1060', GC_Extend), ('\u1062', '\u1064', GC_SpacingMark),
        ('\u1067', '\u106d', GC_SpacingMark), ('\u1071', '\u1074', GC_Extend), ('\u1082', '\u1082',
        GC_Extend), ('\u1083', '\u1084', GC_SpacingMark), ('\u1085', '\u1086', GC_Extend),
        ('\u1087', '\u108c', GC_SpacingMark), ('\u108d', '\u108d', GC_Extend), ('\u108f', '\u108f',
        GC_SpacingMark), ('\u109a', '\u109c', GC_SpacingMark), ('\u109d', '\u109d', GC_Extend),
        ('\u1100', '\u115f', GC_L), ('\u1160', '\u11a7', GC_V), ('\u11a8', '\u11ff', GC_T),
        ('\u135d', '\u135f', GC_Extend), ('\u1712', '\u1714', GC_Extend), ('\u1732', '\u1734',
        GC_Extend), ('\u1752', '\u1753', GC_Extend), ('\u1772', '\u1773', GC_Extend), ('\u17b4',
        '\u17b5', GC_Extend), ('\u17b6', '\u17b6', GC_SpacingMark), ('\u17b7', '\u17bd', GC_Extend),
        ('\u17be', '\u17c5', GC_SpacingMark), ('\u17c6', '\u17c6', GC_Extend), ('\u17c7', '\u17c8',
        GC_SpacingMark), ('\u17c9', '\u17d3', GC_Extend), ('\u17dd', '\u17dd', GC_Extend),
        ('\u180b', '\u180d', GC_Extend), ('\u180e', '\u180e', GC_Control), ('\u18a9', '\u18a9',
        GC_Extend), ('\u1920', '\u1922', GC_Extend), ('\u1923', '\u1926', GC_SpacingMark),
        ('\u1927', '\u1928', GC_Extend), ('\u1929', '\u192b', GC_SpacingMark), ('\u1930', '\u1931',
        GC_SpacingMark), ('\u1932', '\u1932', GC_Extend), ('\u1933', '\u1938', GC_SpacingMark),
        ('\u1939', '\u193b', GC_Extend), ('\u19b0', '\u19c0', GC_SpacingMark), ('\u19c8', '\u19c9',
        GC_SpacingMark), ('\u1a17', '\u1a18', GC_Extend), ('\u1a19', '\u1a1a', GC_SpacingMark),
        ('\u1a1b', '\u1a1b', GC_Extend), ('\u1a55', '\u1a55', GC_SpacingMark), ('\u1a56', '\u1a56',
        GC_Extend), ('\u1a57', '\u1a57', GC_SpacingMark), ('\u1a58', '\u1a5e', GC_Extend),
        ('\u1a60', '\u1a60', GC_Extend), ('\u1a61', '\u1a61', GC_SpacingMark), ('\u1a62', '\u1a62',
        GC_Extend), ('\u1a63', '\u1a64', GC_SpacingMark), ('\u1a65', '\u1a6c', GC_Extend),
        ('\u1a6d', '\u1a72', GC_SpacingMark), ('\u1a73', '\u1a7c', GC_Extend), ('\u1a7f', '\u1a7f',
        GC_Extend), ('\u1ab0', '\u1abd', GC_Extend), ('\u1abe', '\u1abe', GC_Extend), ('\u1b00',
        '\u1b03', GC_Extend), ('\u1b04', '\u1b04', GC_SpacingMark), ('\u1b34', '\u1b34', GC_Extend),
        ('\u1b35', '\u1b35', GC_SpacingMark), ('\u1b36', '\u1b3a', GC_Extend), ('\u1b3b', '\u1b3b',
        GC_SpacingMark), ('\u1b3c', '\u1b3c', GC_Extend), ('\u1b3d', '\u1b41', GC_SpacingMark),
        ('\u1b42', '\u1b42', GC_Extend), ('\u1b43', '\u1b44', GC_SpacingMark), ('\u1b6b', '\u1b73',
        GC_Extend), ('\u1b80', '\u1b81', GC_Extend), ('\u1b82', '\u1b82', GC_SpacingMark),
        ('\u1ba1', '\u1ba1', GC_SpacingMark), ('\u1ba2', '\u1ba5', GC_Extend), ('\u1ba6', '\u1ba7',
        GC_SpacingMark), ('\u1ba8', '\u1ba9', GC_Extend), ('\u1baa', '\u1baa', GC_SpacingMark),
        ('\u1bab', '\u1bad', GC_Extend), ('\u1be6', '\u1be6', GC_Extend), ('\u1be7', '\u1be7',
        GC_SpacingMark), ('\u1be8', '\u1be9', GC_Extend), ('\u1bea', '\u1bec', GC_SpacingMark),
        ('\u1bed', '\u1bed', GC_Extend), ('\u1bee', '\u1bee', GC_SpacingMark), ('\u1bef', '\u1bf1',
        GC_Extend), ('\u1bf2', '\u1bf3', GC_SpacingMark), ('\u1c24', '\u1c2b', GC_SpacingMark),
        ('\u1c2c', '\u1c33', GC_Extend), ('\u1c34', '\u1c35', GC_SpacingMark), ('\u1c36', '\u1c37',
        GC_Extend), ('\u1cd0', '\u1cd2', GC_Extend), ('\u1cd4', '\u1ce0', GC_Extend), ('\u1ce1',
        '\u1ce1', GC_SpacingMark), ('\u1ce2', '\u1ce8', GC_Extend), ('\u1ced', '\u1ced', GC_Extend),
        ('\u1cf2', '\u1cf3', GC_SpacingMark), ('\u1cf4', '\u1cf4', GC_Extend), ('\u1cf8', '\u1cf9',
        GC_Extend), ('\u1dc0', '\u1df5', GC_Extend), ('\u1dfc', '\u1dff', GC_Extend), ('\u200b',
        '\u200b', GC_Control), ('\u200c', '\u200d', GC_Extend), ('\u200e', '\u200f', GC_Control),
        ('\u2028', '\u202e', GC_Control), ('\u2060', '\u206f', GC_Control), ('\u20d0', '\u20dc',
        GC_Extend), ('\u20dd', '\u20e0', GC_Extend), ('\u20e1', '\u20e1', GC_Extend), ('\u20e2',
        '\u20e4', GC_Extend), ('\u20e5', '\u20f0', GC_Extend), ('\u2cef', '\u2cf1', GC_Extend),
        ('\u2d7f', '\u2d7f', GC_Extend), ('\u2de0', '\u2dff', GC_Extend), ('\u302a', '\u302d',
        GC_Extend), ('\u302e', '\u302f', GC_Extend), ('\u3099', '\u309a', GC_Extend), ('\ua66f',
        '\ua66f', GC_Extend), ('\ua670', '\ua672', GC_Extend), ('\ua674', '\ua67d', GC_Extend),
        ('\ua69f', '\ua69f', GC_Extend), ('\ua6f0', '\ua6f1', GC_Extend), ('\ua802', '\ua802',
        GC_Extend), ('\ua806', '\ua806', GC_Extend), ('\ua80b', '\ua80b', GC_Extend), ('\ua823',
        '\ua824', GC_SpacingMark), ('\ua825', '\ua826', GC_Extend), ('\ua827', '\ua827',
        GC_SpacingMark), ('\ua880', '\ua881', GC_SpacingMark), ('\ua8b4', '\ua8c3', GC_SpacingMark),
        ('\ua8c4', '\ua8c4', GC_Extend), ('\ua8e0', '\ua8f1', GC_Extend), ('\ua926', '\ua92d',
        GC_Extend), ('\ua947', '\ua951', GC_Extend), ('\ua952', '\ua953', GC_SpacingMark),
        ('\ua960', '\ua97c', GC_L), ('\ua980', '\ua982', GC_Extend), ('\ua983', '\ua983',
        GC_SpacingMark), ('\ua9b3', '\ua9b3', GC_Extend), ('\ua9b4', '\ua9b5', GC_SpacingMark),
        ('\ua9b6', '\ua9b9', GC_Extend), ('\ua9ba', '\ua9bb', GC_SpacingMark), ('\ua9bc', '\ua9bc',
        GC_Extend), ('\ua9bd', '\ua9c0', GC_SpacingMark), ('\ua9e5', '\ua9e5', GC_Extend),
        ('\uaa29', '\uaa2e', GC_Extend), ('\uaa2f', '\uaa30', GC_SpacingMark), ('\uaa31', '\uaa32',
        GC_Extend), ('\uaa33', '\uaa34', GC_SpacingMark), ('\uaa35', '\uaa36', GC_Extend),
        ('\uaa43', '\uaa43', GC_Extend), ('\uaa4c', '\uaa4c', GC_Extend), ('\uaa4d', '\uaa4d',
        GC_SpacingMark), ('\uaa7b', '\uaa7b', GC_SpacingMark), ('\uaa7c', '\uaa7c', GC_Extend),
        ('\uaa7d', '\uaa7d', GC_SpacingMark), ('\uaab0', '\uaab0', GC_Extend), ('\uaab2', '\uaab4',
        GC_Extend), ('\uaab7', '\uaab8', GC_Extend), ('\uaabe', '\uaabf', GC_Extend), ('\uaac1',
        '\uaac1', GC_Extend), ('\uaaeb', '\uaaeb', GC_SpacingMark), ('\uaaec', '\uaaed', GC_Extend),
        ('\uaaee', '\uaaef', GC_SpacingMark), ('\uaaf5', '\uaaf5', GC_SpacingMark), ('\uaaf6',
        '\uaaf6', GC_Extend), ('\uabe3', '\uabe4', GC_SpacingMark), ('\uabe5', '\uabe5', GC_Extend),
        ('\uabe6', '\uabe7', GC_SpacingMark), ('\uabe8', '\uabe8', GC_Extend), ('\uabe9', '\uabea',
        GC_SpacingMark), ('\uabec', '\uabec', GC_SpacingMark), ('\uabed', '\uabed', GC_Extend),
        ('\uac00', '\uac00', GC_LV), ('\uac01', '\uac1b', GC_LVT), ('\uac1c', '\uac1c', GC_LV),
        ('\uac1d', '\uac37', GC_LVT), ('\uac38', '\uac38', GC_LV), ('\uac39', '\uac53', GC_LVT),
        ('\uac54', '\uac54', GC_LV), ('\uac55', '\uac6f', GC_LVT), ('\uac70', '\uac70', GC_LV),
        ('\uac71', '\uac8b', GC_LVT), ('\uac8c', '\uac8c', GC_LV), ('\uac8d', '\uaca7', GC_LVT),
        ('\uaca8', '\uaca8', GC_LV), ('\uaca9', '\uacc3', GC_LVT), ('\uacc4', '\uacc4', GC_LV),
        ('\uacc5', '\uacdf', GC_LVT), ('\uace0', '\uace0', GC_LV), ('\uace1', '\uacfb', GC_LVT),
        ('\uacfc', '\uacfc', GC_LV), ('\uacfd', '\uad17', GC_LVT), ('\uad18', '\uad18', GC_LV),
        ('\uad19', '\uad33', GC_LVT), ('\uad34', '\uad34', GC_LV), ('\uad35', '\uad4f', GC_LVT),
        ('\uad50', '\uad50', GC_LV), ('\uad51', '\uad6b', GC_LVT), ('\uad6c', '\uad6c', GC_LV),
        ('\uad6d', '\uad87', GC_LVT), ('\uad88', '\uad88', GC_LV), ('\uad89', '\uada3', GC_LVT),
        ('\uada4', '\uada4', GC_LV), ('\uada5', '\uadbf', GC_LVT), ('\uadc0', '\uadc0', GC_LV),
        ('\uadc1', '\uaddb', GC_LVT), ('\uaddc', '\uaddc', GC_LV), ('\uaddd', '\uadf7', GC_LVT),
        ('\uadf8', '\uadf8', GC_LV), ('\uadf9', '\uae13', GC_LVT), ('\uae14', '\uae14', GC_LV),
        ('\uae15', '\uae2f', GC_LVT), ('\uae30', '\uae30', GC_LV), ('\uae31', '\uae4b', GC_LVT),
        ('\uae4c', '\uae4c', GC_LV), ('\uae4d', '\uae67', GC_LVT), ('\uae68', '\uae68', GC_LV),
        ('\uae69', '\uae83', GC_LVT), ('\uae84', '\uae84', GC_LV), ('\uae85', '\uae9f', GC_LVT),
        ('\uaea0', '\uaea0', GC_LV), ('\uaea1', '\uaebb', GC_LVT), ('\uaebc', '\uaebc', GC_LV),
        ('\uaebd', '\uaed7', GC_LVT), ('\uaed8', '\uaed8', GC_LV), ('\uaed9', '\uaef3', GC_LVT),
        ('\uaef4', '\uaef4', GC_LV), ('\uaef5', '\uaf0f', GC_LVT), ('\uaf10', '\uaf10', GC_LV),
        ('\uaf11', '\uaf2b', GC_LVT), ('\uaf2c', '\uaf2c', GC_LV), ('\uaf2d', '\uaf47', GC_LVT),
        ('\uaf48', '\uaf48', GC_LV), ('\uaf49', '\uaf63', GC_LVT), ('\uaf64', '\uaf64', GC_LV),
        ('\uaf65', '\uaf7f', GC_LVT), ('\uaf80', '\uaf80', GC_LV), ('\uaf81', '\uaf9b', GC_LVT),
        ('\uaf9c', '\uaf9c', GC_LV), ('\uaf9d', '\uafb7', GC_LVT), ('\uafb8', '\uafb8', GC_LV),
        ('\uafb9', '\uafd3', GC_LVT), ('\uafd4', '\uafd4', GC_LV), ('\uafd5', '\uafef', GC_LVT),
        ('\uaff0', '\uaff0', GC_LV), ('\uaff1', '\ub00b', GC_LVT), ('\ub00c', '\ub00c', GC_LV),
        ('\ub00d', '\ub027', GC_LVT), ('\ub028', '\ub028', GC_LV), ('\ub029', '\ub043', GC_LVT),
        ('\ub044', '\ub044', GC_LV), ('\ub045', '\ub05f', GC_LVT), ('\ub060', '\ub060', GC_LV),
        ('\ub061', '\ub07b', GC_LVT), ('\ub07c', '\ub07c', GC_LV), ('\ub07d', '\ub097', GC_LVT),
        ('\ub098', '\ub098', GC_LV), ('\ub099', '\ub0b3', GC_LVT), ('\ub0b4', '\ub0b4', GC_LV),
        ('\ub0b5', '\ub0cf', GC_LVT), ('\ub0d0', '\ub0d0', GC_LV), ('\ub0d1', '\ub0eb', GC_LVT),
        ('\ub0ec', '\ub0ec', GC_LV), ('\ub0ed', '\ub107', GC_LVT), ('\ub108', '\ub108', GC_LV),
        ('\ub109', '\ub123', GC_LVT), ('\ub124', '\ub124', GC_LV), ('\ub125', '\ub13f', GC_LVT),
        ('\ub140', '\ub140', GC_LV), ('\ub141', '\ub15b', GC_LVT), ('\ub15c', '\ub15c', GC_LV),
        ('\ub15d', '\ub177', GC_LVT), ('\ub178', '\ub178', GC_LV), ('\ub179', '\ub193', GC_LVT),
        ('\ub194', '\ub194', GC_LV), ('\ub195', '\ub1af', GC_LVT), ('\ub1b0', '\ub1b0', GC_LV),
        ('\ub1b1', '\ub1cb', GC_LVT), ('\ub1cc', '\ub1cc', GC_LV), ('\ub1cd', '\ub1e7', GC_LVT),
        ('\ub1e8', '\ub1e8', GC_LV), ('\ub1e9', '\ub203', GC_LVT), ('\ub204', '\ub204', GC_LV),
        ('\ub205', '\ub21f', GC_LVT), ('\ub220', '\ub220', GC_LV), ('\ub221', '\ub23b', GC_LVT),
        ('\ub23c', '\ub23c', GC_LV), ('\ub23d', '\ub257', GC_LVT), ('\ub258', '\ub258', GC_LV),
        ('\ub259', '\ub273', GC_LVT), ('\ub274', '\ub274', GC_LV), ('\ub275', '\ub28f', GC_LVT),
        ('\ub290', '\ub290', GC_LV), ('\ub291', '\ub2ab', GC_LVT), ('\ub2ac', '\ub2ac', GC_LV),
        ('\ub2ad', '\ub2c7', GC_LVT), ('\ub2c8', '\ub2c8', GC_LV), ('\ub2c9', '\ub2e3', GC_LVT),
        ('\ub2e4', '\ub2e4', GC_LV), ('\ub2e5', '\ub2ff', GC_LVT), ('\ub300', '\ub300', GC_LV),
        ('\ub301', '\ub31b', GC_LVT), ('\ub31c', '\ub31c', GC_LV), ('\ub31d', '\ub337', GC_LVT),
        ('\ub338', '\ub338', GC_LV), ('\ub339', '\ub353', GC_LVT), ('\ub354', '\ub354', GC_LV),
        ('\ub355', '\ub36f', GC_LVT), ('\ub370', '\ub370', GC_LV), ('\ub371', '\ub38b', GC_LVT),
        ('\ub38c', '\ub38c', GC_LV), ('\ub38d', '\ub3a7', GC_LVT), ('\ub3a8', '\ub3a8', GC_LV),
        ('\ub3a9', '\ub3c3', GC_LVT), ('\ub3c4', '\ub3c4', GC_LV), ('\ub3c5', '\ub3df', GC_LVT),
        ('\ub3e0', '\ub3e0', GC_LV), ('\ub3e1', '\ub3fb', GC_LVT), ('\ub3fc', '\ub3fc', GC_LV),
        ('\ub3fd', '\ub417', GC_LVT), ('\ub418', '\ub418', GC_LV), ('\ub419', '\ub433', GC_LVT),
        ('\ub434', '\ub434', GC_LV), ('\ub435', '\ub44f', GC_LVT), ('\ub450', '\ub450', GC_LV),
        ('\ub451', '\ub46b', GC_LVT), ('\ub46c', '\ub46c', GC_LV), ('\ub46d', '\ub487', GC_LVT),
        ('\ub488', '\ub488', GC_LV), ('\ub489', '\ub4a3', GC_LVT), ('\ub4a4', '\ub4a4', GC_LV),
        ('\ub4a5', '\ub4bf', GC_LVT), ('\ub4c0', '\ub4c0', GC_LV), ('\ub4c1', '\ub4db', GC_LVT),
        ('\ub4dc', '\ub4dc', GC_LV), ('\ub4dd', '\ub4f7', GC_LVT), ('\ub4f8', '\ub4f8', GC_LV),
        ('\ub4f9', '\ub513', GC_LVT), ('\ub514', '\ub514', GC_LV), ('\ub515', '\ub52f', GC_LVT),
        ('\ub530', '\ub530', GC_LV), ('\ub531', '\ub54b', GC_LVT), ('\ub54c', '\ub54c', GC_LV),
        ('\ub54d', '\ub567', GC_LVT), ('\ub568', '\ub568', GC_LV), ('\ub569', '\ub583', GC_LVT),
        ('\ub584', '\ub584', GC_LV), ('\ub585', '\ub59f', GC_LVT), ('\ub5a0', '\ub5a0', GC_LV),
        ('\ub5a1', '\ub5bb', GC_LVT), ('\ub5bc', '\ub5bc', GC_LV), ('\ub5bd', '\ub5d7', GC_LVT),
        ('\ub5d8', '\ub5d8', GC_LV), ('\ub5d9', '\ub5f3', GC_LVT), ('\ub5f4', '\ub5f4', GC_LV),
        ('\ub5f5', '\ub60f', GC_LVT), ('\ub610', '\ub610', GC_LV), ('\ub611', '\ub62b', GC_LVT),
        ('\ub62c', '\ub62c', GC_LV), ('\ub62d', '\ub647', GC_LVT), ('\ub648', '\ub648', GC_LV),
        ('\ub649', '\ub663', GC_LVT), ('\ub664', '\ub664', GC_LV), ('\ub665', '\ub67f', GC_LVT),
        ('\ub680', '\ub680', GC_LV), ('\ub681', '\ub69b', GC_LVT), ('\ub69c', '\ub69c', GC_LV),
        ('\ub69d', '\ub6b7', GC_LVT), ('\ub6b8', '\ub6b8', GC_LV), ('\ub6b9', '\ub6d3', GC_LVT),
        ('\ub6d4', '\ub6d4', GC_LV), ('\ub6d5', '\ub6ef', GC_LVT), ('\ub6f0', '\ub6f0', GC_LV),
        ('\ub6f1', '\ub70b', GC_LVT), ('\ub70c', '\ub70c', GC_LV), ('\ub70d', '\ub727', GC_LVT),
        ('\ub728', '\ub728', GC_LV), ('\ub729', '\ub743', GC_LVT), ('\ub744', '\ub744', GC_LV),
        ('\ub745', '\ub75f', GC_LVT), ('\ub760', '\ub760', GC_LV), ('\ub761', '\ub77b', GC_LVT),
        ('\ub77c', '\ub77c', GC_LV), ('\ub77d', '\ub797', GC_LVT), ('\ub798', '\ub798', GC_LV),
        ('\ub799', '\ub7b3', GC_LVT), ('\ub7b4', '\ub7b4', GC_LV), ('\ub7b5', '\ub7cf', GC_LVT),
        ('\ub7d0', '\ub7d0', GC_LV), ('\ub7d1', '\ub7eb', GC_LVT), ('\ub7ec', '\ub7ec', GC_LV),
        ('\ub7ed', '\ub807', GC_LVT), ('\ub808', '\ub808', GC_LV), ('\ub809', '\ub823', GC_LVT),
        ('\ub824', '\ub824', GC_LV), ('\ub825', '\ub83f', GC_LVT), ('\ub840', '\ub840', GC_LV),
        ('\ub841', '\ub85b', GC_LVT), ('\ub85c', '\ub85c', GC_LV), ('\ub85d', '\ub877', GC_LVT),
        ('\ub878', '\ub878', GC_LV), ('\ub879', '\ub893', GC_LVT), ('\ub894', '\ub894', GC_LV),
        ('\ub895', '\ub8af', GC_LVT), ('\ub8b0', '\ub8b0', GC_LV), ('\ub8b1', '\ub8cb', GC_LVT),
        ('\ub8cc', '\ub8cc', GC_LV), ('\ub8cd', '\ub8e7', GC_LVT), ('\ub8e8', '\ub8e8', GC_LV),
        ('\ub8e9', '\ub903', GC_LVT), ('\ub904', '\ub904', GC_LV), ('\ub905', '\ub91f', GC_LVT),
        ('\ub920', '\ub920', GC_LV), ('\ub921', '\ub93b', GC_LVT), ('\ub93c', '\ub93c', GC_LV),
        ('\ub93d', '\ub957', GC_LVT), ('\ub958', '\ub958', GC_LV), ('\ub959', '\ub973', GC_LVT),
        ('\ub974', '\ub974', GC_LV), ('\ub975', '\ub98f', GC_LVT), ('\ub990', '\ub990', GC_LV),
        ('\ub991', '\ub9ab', GC_LVT), ('\ub9ac', '\ub9ac', GC_LV), ('\ub9ad', '\ub9c7', GC_LVT),
        ('\ub9c8', '\ub9c8', GC_LV), ('\ub9c9', '\ub9e3', GC_LVT), ('\ub9e4', '\ub9e4', GC_LV),
        ('\ub9e5', '\ub9ff', GC_LVT), ('\uba00', '\uba00', GC_LV), ('\uba01', '\uba1b', GC_LVT),
        ('\uba1c', '\uba1c', GC_LV), ('\uba1d', '\uba37', GC_LVT), ('\uba38', '\uba38', GC_LV),
        ('\uba39', '\uba53', GC_LVT), ('\uba54', '\uba54', GC_LV), ('\uba55', '\uba6f', GC_LVT),
        ('\uba70', '\uba70', GC_LV), ('\uba71', '\uba8b', GC_LVT), ('\uba8c', '\uba8c', GC_LV),
        ('\uba8d', '\ubaa7', GC_LVT), ('\ubaa8', '\ubaa8', GC_LV), ('\ubaa9', '\ubac3', GC_LVT),
        ('\ubac4', '\ubac4', GC_LV), ('\ubac5', '\ubadf', GC_LVT), ('\ubae0', '\ubae0', GC_LV),
        ('\ubae1', '\ubafb', GC_LVT), ('\ubafc', '\ubafc', GC_LV), ('\ubafd', '\ubb17', GC_LVT),
        ('\ubb18', '\ubb18', GC_LV), ('\ubb19', '\ubb33', GC_LVT), ('\ubb34', '\ubb34', GC_LV),
        ('\ubb35', '\ubb4f', GC_LVT), ('\ubb50', '\ubb50', GC_LV), ('\ubb51', '\ubb6b', GC_LVT),
        ('\ubb6c', '\ubb6c', GC_LV), ('\ubb6d', '\ubb87', GC_LVT), ('\ubb88', '\ubb88', GC_LV),
        ('\ubb89', '\ubba3', GC_LVT), ('\ubba4', '\ubba4', GC_LV), ('\ubba5', '\ubbbf', GC_LVT),
        ('\ubbc0', '\ubbc0', GC_LV), ('\ubbc1', '\ubbdb', GC_LVT), ('\ubbdc', '\ubbdc', GC_LV),
        ('\ubbdd', '\ubbf7', GC_LVT), ('\ubbf8', '\ubbf8', GC_LV), ('\ubbf9', '\ubc13', GC_LVT),
        ('\ubc14', '\ubc14', GC_LV), ('\ubc15', '\ubc2f', GC_LVT), ('\ubc30', '\ubc30', GC_LV),
        ('\ubc31', '\ubc4b', GC_LVT), ('\ubc4c', '\ubc4c', GC_LV), ('\ubc4d', '\ubc67', GC_LVT),
        ('\ubc68', '\ubc68', GC_LV), ('\ubc69', '\ubc83', GC_LVT), ('\ubc84', '\ubc84', GC_LV),
        ('\ubc85', '\ubc9f', GC_LVT), ('\ubca0', '\ubca0', GC_LV), ('\ubca1', '\ubcbb', GC_LVT),
        ('\ubcbc', '\ubcbc', GC_LV), ('\ubcbd', '\ubcd7', GC_LVT), ('\ubcd8', '\ubcd8', GC_LV),
        ('\ubcd9', '\ubcf3', GC_LVT), ('\ubcf4', '\ubcf4', GC_LV), ('\ubcf5', '\ubd0f', GC_LVT),
        ('\ubd10', '\ubd10', GC_LV), ('\ubd11', '\ubd2b', GC_LVT), ('\ubd2c', '\ubd2c', GC_LV),
        ('\ubd2d', '\ubd47', GC_LVT), ('\ubd48', '\ubd48', GC_LV), ('\ubd49', '\ubd63', GC_LVT),
        ('\ubd64', '\ubd64', GC_LV), ('\ubd65', '\ubd7f', GC_LVT), ('\ubd80', '\ubd80', GC_LV),
        ('\ubd81', '\ubd9b', GC_LVT), ('\ubd9c', '\ubd9c', GC_LV), ('\ubd9d', '\ubdb7', GC_LVT),
        ('\ubdb8', '\ubdb8', GC_LV), ('\ubdb9', '\ubdd3', GC_LVT), ('\ubdd4', '\ubdd4', GC_LV),
        ('\ubdd5', '\ubdef', GC_LVT), ('\ubdf0', '\ubdf0', GC_LV), ('\ubdf1', '\ube0b', GC_LVT),
        ('\ube0c', '\ube0c', GC_LV), ('\ube0d', '\ube27', GC_LVT), ('\ube28', '\ube28', GC_LV),
        ('\ube29', '\ube43', GC_LVT), ('\ube44', '\ube44', GC_LV), ('\ube45', '\ube5f', GC_LVT),
        ('\ube60', '\ube60', GC_LV), ('\ube61', '\ube7b', GC_LVT), ('\ube7c', '\ube7c', GC_LV),
        ('\ube7d', '\ube97', GC_LVT), ('\ube98', '\ube98', GC_LV), ('\ube99', '\ubeb3', GC_LVT),
        ('\ubeb4', '\ubeb4', GC_LV), ('\ubeb5', '\ubecf', GC_LVT), ('\ubed0', '\ubed0', GC_LV),
        ('\ubed1', '\ubeeb', GC_LVT), ('\ubeec', '\ubeec', GC_LV), ('\ubeed', '\ubf07', GC_LVT),
        ('\ubf08', '\ubf08', GC_LV), ('\ubf09', '\ubf23', GC_LVT), ('\ubf24', '\ubf24', GC_LV),
        ('\ubf25', '\ubf3f', GC_LVT), ('\ubf40', '\ubf40', GC_LV), ('\ubf41', '\ubf5b', GC_LVT),
        ('\ubf5c', '\ubf5c', GC_LV), ('\ubf5d', '\ubf77', GC_LVT), ('\ubf78', '\ubf78', GC_LV),
        ('\ubf79', '\ubf93', GC_LVT), ('\ubf94', '\ubf94', GC_LV), ('\ubf95', '\ubfaf', GC_LVT),
        ('\ubfb0', '\ubfb0', GC_LV), ('\ubfb1', '\ubfcb', GC_LVT), ('\ubfcc', '\ubfcc', GC_LV),
        ('\ubfcd', '\ubfe7', GC_LVT), ('\ubfe8', '\ubfe8', GC_LV), ('\ubfe9', '\uc003', GC_LVT),
        ('\uc004', '\uc004', GC_LV), ('\uc005', '\uc01f', GC_LVT), ('\uc020', '\uc020', GC_LV),
        ('\uc021', '\uc03b', GC_LVT), ('\uc03c', '\uc03c', GC_LV), ('\uc03d', '\uc057', GC_LVT),
        ('\uc058', '\uc058', GC_LV), ('\uc059', '\uc073', GC_LVT), ('\uc074', '\uc074', GC_LV),
        ('\uc075', '\uc08f', GC_LVT), ('\uc090', '\uc090', GC_LV), ('\uc091', '\uc0ab', GC_LVT),
        ('\uc0ac', '\uc0ac', GC_LV), ('\uc0ad', '\uc0c7', GC_LVT), ('\uc0c8', '\uc0c8', GC_LV),
        ('\uc0c9', '\uc0e3', GC_LVT), ('\uc0e4', '\uc0e4', GC_LV), ('\uc0e5', '\uc0ff', GC_LVT),
        ('\uc100', '\uc100', GC_LV), ('\uc101', '\uc11b', GC_LVT), ('\uc11c', '\uc11c', GC_LV),
        ('\uc11d', '\uc137', GC_LVT), ('\uc138', '\uc138', GC_LV), ('\uc139', '\uc153', GC_LVT),
        ('\uc154', '\uc154', GC_LV), ('\uc155', '\uc16f', GC_LVT), ('\uc170', '\uc170', GC_LV),
        ('\uc171', '\uc18b', GC_LVT), ('\uc18c', '\uc18c', GC_LV), ('\uc18d', '\uc1a7', GC_LVT),
        ('\uc1a8', '\uc1a8', GC_LV), ('\uc1a9', '\uc1c3', GC_LVT), ('\uc1c4', '\uc1c4', GC_LV),
        ('\uc1c5', '\uc1df', GC_LVT), ('\uc1e0', '\uc1e0', GC_LV), ('\uc1e1', '\uc1fb', GC_LVT),
        ('\uc1fc', '\uc1fc', GC_LV), ('\uc1fd', '\uc217', GC_LVT), ('\uc218', '\uc218', GC_LV),
        ('\uc219', '\uc233', GC_LVT), ('\uc234', '\uc234', GC_LV), ('\uc235', '\uc24f', GC_LVT),
        ('\uc250', '\uc250', GC_LV), ('\uc251', '\uc26b', GC_LVT), ('\uc26c', '\uc26c', GC_LV),
        ('\uc26d', '\uc287', GC_LVT), ('\uc288', '\uc288', GC_LV), ('\uc289', '\uc2a3', GC_LVT),
        ('\uc2a4', '\uc2a4', GC_LV), ('\uc2a5', '\uc2bf', GC_LVT), ('\uc2c0', '\uc2c0', GC_LV),
        ('\uc2c1', '\uc2db', GC_LVT), ('\uc2dc', '\uc2dc', GC_LV), ('\uc2dd', '\uc2f7', GC_LVT),
        ('\uc2f8', '\uc2f8', GC_LV), ('\uc2f9', '\uc313', GC_LVT), ('\uc314', '\uc314', GC_LV),
        ('\uc315', '\uc32f', GC_LVT), ('\uc330', '\uc330', GC_LV), ('\uc331', '\uc34b', GC_LVT),
        ('\uc34c', '\uc34c', GC_LV), ('\uc34d', '\uc367', GC_LVT), ('\uc368', '\uc368', GC_LV),
        ('\uc369', '\uc383', GC_LVT), ('\uc384', '\uc384', GC_LV), ('\uc385', '\uc39f', GC_LVT),
        ('\uc3a0', '\uc3a0', GC_LV), ('\uc3a1', '\uc3bb', GC_LVT), ('\uc3bc', '\uc3bc', GC_LV),
        ('\uc3bd', '\uc3d7', GC_LVT), ('\uc3d8', '\uc3d8', GC_LV), ('\uc3d9', '\uc3f3', GC_LVT),
        ('\uc3f4', '\uc3f4', GC_LV), ('\uc3f5', '\uc40f', GC_LVT), ('\uc410', '\uc410', GC_LV),
        ('\uc411', '\uc42b', GC_LVT), ('\uc42c', '\uc42c', GC_LV), ('\uc42d', '\uc447', GC_LVT),
        ('\uc448', '\uc448', GC_LV), ('\uc449', '\uc463', GC_LVT), ('\uc464', '\uc464', GC_LV),
        ('\uc465', '\uc47f', GC_LVT), ('\uc480', '\uc480', GC_LV), ('\uc481', '\uc49b', GC_LVT),
        ('\uc49c', '\uc49c', GC_LV), ('\uc49d', '\uc4b7', GC_LVT), ('\uc4b8', '\uc4b8', GC_LV),
        ('\uc4b9', '\uc4d3', GC_LVT), ('\uc4d4', '\uc4d4', GC_LV), ('\uc4d5', '\uc4ef', GC_LVT),
        ('\uc4f0', '\uc4f0', GC_LV), ('\uc4f1', '\uc50b', GC_LVT), ('\uc50c', '\uc50c', GC_LV),
        ('\uc50d', '\uc527', GC_LVT), ('\uc528', '\uc528', GC_LV), ('\uc529', '\uc543', GC_LVT),
        ('\uc544', '\uc544', GC_LV), ('\uc545', '\uc55f', GC_LVT), ('\uc560', '\uc560', GC_LV),
        ('\uc561', '\uc57b', GC_LVT), ('\uc57c', '\uc57c', GC_LV), ('\uc57d', '\uc597', GC_LVT),
        ('\uc598', '\uc598', GC_LV), ('\uc599', '\uc5b3', GC_LVT), ('\uc5b4', '\uc5b4', GC_LV),
        ('\uc5b5', '\uc5cf', GC_LVT), ('\uc5d0', '\uc5d0', GC_LV), ('\uc5d1', '\uc5eb', GC_LVT),
        ('\uc5ec', '\uc5ec', GC_LV), ('\uc5ed', '\uc607', GC_LVT), ('\uc608', '\uc608', GC_LV),
        ('\uc609', '\uc623', GC_LVT), ('\uc624', '\uc624', GC_LV), ('\uc625', '\uc63f', GC_LVT),
        ('\uc640', '\uc640', GC_LV), ('\uc641', '\uc65b', GC_LVT), ('\uc65c', '\uc65c', GC_LV),
        ('\uc65d', '\uc677', GC_LVT), ('\uc678', '\uc678', GC_LV), ('\uc679', '\uc693', GC_LVT),
        ('\uc694', '\uc694', GC_LV), ('\uc695', '\uc6af', GC_LVT), ('\uc6b0', '\uc6b0', GC_LV),
        ('\uc6b1', '\uc6cb', GC_LVT), ('\uc6cc', '\uc6cc', GC_LV), ('\uc6cd', '\uc6e7', GC_LVT),
        ('\uc6e8', '\uc6e8', GC_LV), ('\uc6e9', '\uc703', GC_LVT), ('\uc704', '\uc704', GC_LV),
        ('\uc705', '\uc71f', GC_LVT), ('\uc720', '\uc720', GC_LV), ('\uc721', '\uc73b', GC_LVT),
        ('\uc73c', '\uc73c', GC_LV), ('\uc73d', '\uc757', GC_LVT), ('\uc758', '\uc758', GC_LV),
        ('\uc759', '\uc773', GC_LVT), ('\uc774', '\uc774', GC_LV), ('\uc775', '\uc78f', GC_LVT),
        ('\uc790', '\uc790', GC_LV), ('\uc791', '\uc7ab', GC_LVT), ('\uc7ac', '\uc7ac', GC_LV),
        ('\uc7ad', '\uc7c7', GC_LVT), ('\uc7c8', '\uc7c8', GC_LV), ('\uc7c9', '\uc7e3', GC_LVT),
        ('\uc7e4', '\uc7e4', GC_LV), ('\uc7e5', '\uc7ff', GC_LVT), ('\uc800', '\uc800', GC_LV),
        ('\uc801', '\uc81b', GC_LVT), ('\uc81c', '\uc81c', GC_LV), ('\uc81d', '\uc837', GC_LVT),
        ('\uc838', '\uc838', GC_LV), ('\uc839', '\uc853', GC_LVT), ('\uc854', '\uc854', GC_LV),
        ('\uc855', '\uc86f', GC_LVT), ('\uc870', '\uc870', GC_LV), ('\uc871', '\uc88b', GC_LVT),
        ('\uc88c', '\uc88c', GC_LV), ('\uc88d', '\uc8a7', GC_LVT), ('\uc8a8', '\uc8a8', GC_LV),
        ('\uc8a9', '\uc8c3', GC_LVT), ('\uc8c4', '\uc8c4', GC_LV), ('\uc8c5', '\uc8df', GC_LVT),
        ('\uc8e0', '\uc8e0', GC_LV), ('\uc8e1', '\uc8fb', GC_LVT), ('\uc8fc', '\uc8fc', GC_LV),
        ('\uc8fd', '\uc917', GC_LVT), ('\uc918', '\uc918', GC_LV), ('\uc919', '\uc933', GC_LVT),
        ('\uc934', '\uc934', GC_LV), ('\uc935', '\uc94f', GC_LVT), ('\uc950', '\uc950', GC_LV),
        ('\uc951', '\uc96b', GC_LVT), ('\uc96c', '\uc96c', GC_LV), ('\uc96d', '\uc987', GC_LVT),
        ('\uc988', '\uc988', GC_LV), ('\uc989', '\uc9a3', GC_LVT), ('\uc9a4', '\uc9a4', GC_LV),
        ('\uc9a5', '\uc9bf', GC_LVT), ('\uc9c0', '\uc9c0', GC_LV), ('\uc9c1', '\uc9db', GC_LVT),
        ('\uc9dc', '\uc9dc', GC_LV), ('\uc9dd', '\uc9f7', GC_LVT), ('\uc9f8', '\uc9f8', GC_LV),
        ('\uc9f9', '\uca13', GC_LVT), ('\uca14', '\uca14', GC_LV), ('\uca15', '\uca2f', GC_LVT),
        ('\uca30', '\uca30', GC_LV), ('\uca31', '\uca4b', GC_LVT), ('\uca4c', '\uca4c', GC_LV),
        ('\uca4d', '\uca67', GC_LVT), ('\uca68', '\uca68', GC_LV), ('\uca69', '\uca83', GC_LVT),
        ('\uca84', '\uca84', GC_LV), ('\uca85', '\uca9f', GC_LVT), ('\ucaa0', '\ucaa0', GC_LV),
        ('\ucaa1', '\ucabb', GC_LVT), ('\ucabc', '\ucabc', GC_LV), ('\ucabd', '\ucad7', GC_LVT),
        ('\ucad8', '\ucad8', GC_LV), ('\ucad9', '\ucaf3', GC_LVT), ('\ucaf4', '\ucaf4', GC_LV),
        ('\ucaf5', '\ucb0f', GC_LVT), ('\ucb10', '\ucb10', GC_LV), ('\ucb11', '\ucb2b', GC_LVT),
        ('\ucb2c', '\ucb2c', GC_LV), ('\ucb2d', '\ucb47', GC_LVT), ('\ucb48', '\ucb48', GC_LV),
        ('\ucb49', '\ucb63', GC_LVT), ('\ucb64', '\ucb64', GC_LV), ('\ucb65', '\ucb7f', GC_LVT),
        ('\ucb80', '\ucb80', GC_LV), ('\ucb81', '\ucb9b', GC_LVT), ('\ucb9c', '\ucb9c', GC_LV),
        ('\ucb9d', '\ucbb7', GC_LVT), ('\ucbb8', '\ucbb8', GC_LV), ('\ucbb9', '\ucbd3', GC_LVT),
        ('\ucbd4', '\ucbd4', GC_LV), ('\ucbd5', '\ucbef', GC_LVT), ('\ucbf0', '\ucbf0', GC_LV),
        ('\ucbf1', '\ucc0b', GC_LVT), ('\ucc0c', '\ucc0c', GC_LV), ('\ucc0d', '\ucc27', GC_LVT),
        ('\ucc28', '\ucc28', GC_LV), ('\ucc29', '\ucc43', GC_LVT), ('\ucc44', '\ucc44', GC_LV),
        ('\ucc45', '\ucc5f', GC_LVT), ('\ucc60', '\ucc60', GC_LV), ('\ucc61', '\ucc7b', GC_LVT),
        ('\ucc7c', '\ucc7c', GC_LV), ('\ucc7d', '\ucc97', GC_LVT), ('\ucc98', '\ucc98', GC_LV),
        ('\ucc99', '\uccb3', GC_LVT), ('\uccb4', '\uccb4', GC_LV), ('\uccb5', '\ucccf', GC_LVT),
        ('\uccd0', '\uccd0', GC_LV), ('\uccd1', '\ucceb', GC_LVT), ('\uccec', '\uccec', GC_LV),
        ('\ucced', '\ucd07', GC_LVT), ('\ucd08', '\ucd08', GC_LV), ('\ucd09', '\ucd23', GC_LVT),
        ('\ucd24', '\ucd24', GC_LV), ('\ucd25', '\ucd3f', GC_LVT), ('\ucd40', '\ucd40', GC_LV),
        ('\ucd41', '\ucd5b', GC_LVT), ('\ucd5c', '\ucd5c', GC_LV), ('\ucd5d', '\ucd77', GC_LVT),
        ('\ucd78', '\ucd78', GC_LV), ('\ucd79', '\ucd93', GC_LVT), ('\ucd94', '\ucd94', GC_LV),
        ('\ucd95', '\ucdaf', GC_LVT), ('\ucdb0', '\ucdb0', GC_LV), ('\ucdb1', '\ucdcb', GC_LVT),
        ('\ucdcc', '\ucdcc', GC_LV), ('\ucdcd', '\ucde7', GC_LVT), ('\ucde8', '\ucde8', GC_LV),
        ('\ucde9', '\uce03', GC_LVT), ('\uce04', '\uce04', GC_LV), ('\uce05', '\uce1f', GC_LVT),
        ('\uce20', '\uce20', GC_LV), ('\uce21', '\uce3b', GC_LVT), ('\uce3c', '\uce3c', GC_LV),
        ('\uce3d', '\uce57', GC_LVT), ('\uce58', '\uce58', GC_LV), ('\uce59', '\uce73', GC_LVT),
        ('\uce74', '\uce74', GC_LV), ('\uce75', '\uce8f', GC_LVT), ('\uce90', '\uce90', GC_LV),
        ('\uce91', '\uceab', GC_LVT), ('\uceac', '\uceac', GC_LV), ('\ucead', '\ucec7', GC_LVT),
        ('\ucec8', '\ucec8', GC_LV), ('\ucec9', '\ucee3', GC_LVT), ('\ucee4', '\ucee4', GC_LV),
        ('\ucee5', '\uceff', GC_LVT), ('\ucf00', '\ucf00', GC_LV), ('\ucf01', '\ucf1b', GC_LVT),
        ('\ucf1c', '\ucf1c', GC_LV), ('\ucf1d', '\ucf37', GC_LVT), ('\ucf38', '\ucf38', GC_LV),
        ('\ucf39', '\ucf53', GC_LVT), ('\ucf54', '\ucf54', GC_LV), ('\ucf55', '\ucf6f', GC_LVT),
        ('\ucf70', '\ucf70', GC_LV), ('\ucf71', '\ucf8b', GC_LVT), ('\ucf8c', '\ucf8c', GC_LV),
        ('\ucf8d', '\ucfa7', GC_LVT), ('\ucfa8', '\ucfa8', GC_LV), ('\ucfa9', '\ucfc3', GC_LVT),
        ('\ucfc4', '\ucfc4', GC_LV), ('\ucfc5', '\ucfdf', GC_LVT), ('\ucfe0', '\ucfe0', GC_LV),
        ('\ucfe1', '\ucffb', GC_LVT), ('\ucffc', '\ucffc', GC_LV), ('\ucffd', '\ud017', GC_LVT),
        ('\ud018', '\ud018', GC_LV), ('\ud019', '\ud033', GC_LVT), ('\ud034', '\ud034', GC_LV),
        ('\ud035', '\ud04f', GC_LVT), ('\ud050', '\ud050', GC_LV), ('\ud051', '\ud06b', GC_LVT),
        ('\ud06c', '\ud06c', GC_LV), ('\ud06d', '\ud087', GC_LVT), ('\ud088', '\ud088', GC_LV),
        ('\ud089', '\ud0a3', GC_LVT), ('\ud0a4', '\ud0a4', GC_LV), ('\ud0a5', '\ud0bf', GC_LVT),
        ('\ud0c0', '\ud0c0', GC_LV), ('\ud0c1', '\ud0db', GC_LVT), ('\ud0dc', '\ud0dc', GC_LV),
        ('\ud0dd', '\ud0f7', GC_LVT), ('\ud0f8', '\ud0f8', GC_LV), ('\ud0f9', '\ud113', GC_LVT),
        ('\ud114', '\ud114', GC_LV), ('\ud115', '\ud12f', GC_LVT), ('\ud130', '\ud130', GC_LV),
        ('\ud131', '\ud14b', GC_LVT), ('\ud14c', '\ud14c', GC_LV), ('\ud14d', '\ud167', GC_LVT),
        ('\ud168', '\ud168', GC_LV), ('\ud169', '\ud183', GC_LVT), ('\ud184', '\ud184', GC_LV),
        ('\ud185', '\ud19f', GC_LVT), ('\ud1a0', '\ud1a0', GC_LV), ('\ud1a1', '\ud1bb', GC_LVT),
        ('\ud1bc', '\ud1bc', GC_LV), ('\ud1bd', '\ud1d7', GC_LVT), ('\ud1d8', '\ud1d8', GC_LV),
        ('\ud1d9', '\ud1f3', GC_LVT), ('\ud1f4', '\ud1f4', GC_LV), ('\ud1f5', '\ud20f', GC_LVT),
        ('\ud210', '\ud210', GC_LV), ('\ud211', '\ud22b', GC_LVT), ('\ud22c', '\ud22c', GC_LV),
        ('\ud22d', '\ud247', GC_LVT), ('\ud248', '\ud248', GC_LV), ('\ud249', '\ud263', GC_LVT),
        ('\ud264', '\ud264', GC_LV), ('\ud265', '\ud27f', GC_LVT), ('\ud280', '\ud280', GC_LV),
        ('\ud281', '\ud29b', GC_LVT), ('\ud29c', '\ud29c', GC_LV), ('\ud29d', '\ud2b7', GC_LVT),
        ('\ud2b8', '\ud2b8', GC_LV), ('\ud2b9', '\ud2d3', GC_LVT), ('\ud2d4', '\ud2d4', GC_LV),
        ('\ud2d5', '\ud2ef', GC_LVT), ('\ud2f0', '\ud2f0', GC_LV), ('\ud2f1', '\ud30b', GC_LVT),
        ('\ud30c', '\ud30c', GC_LV), ('\ud30d', '\ud327', GC_LVT), ('\ud328', '\ud328', GC_LV),
        ('\ud329', '\ud343', GC_LVT), ('\ud344', '\ud344', GC_LV), ('\ud345', '\ud35f', GC_LVT),
        ('\ud360', '\ud360', GC_LV), ('\ud361', '\ud37b', GC_LVT), ('\ud37c', '\ud37c', GC_LV),
        ('\ud37d', '\ud397', GC_LVT), ('\ud398', '\ud398', GC_LV), ('\ud399', '\ud3b3', GC_LVT),
        ('\ud3b4', '\ud3b4', GC_LV), ('\ud3b5', '\ud3cf', GC_LVT), ('\ud3d0', '\ud3d0', GC_LV),
        ('\ud3d1', '\ud3eb', GC_LVT), ('\ud3ec', '\ud3ec', GC_LV), ('\ud3ed', '\ud407', GC_LVT),
        ('\ud408', '\ud408', GC_LV), ('\ud409', '\ud423', GC_LVT), ('\ud424', '\ud424', GC_LV),
        ('\ud425', '\ud43f', GC_LVT), ('\ud440', '\ud440', GC_LV), ('\ud441', '\ud45b', GC_LVT),
        ('\ud45c', '\ud45c', GC_LV), ('\ud45d', '\ud477', GC_LVT), ('\ud478', '\ud478', GC_LV),
        ('\ud479', '\ud493', GC_LVT), ('\ud494', '\ud494', GC_LV), ('\ud495', '\ud4af', GC_LVT),
        ('\ud4b0', '\ud4b0', GC_LV), ('\ud4b1', '\ud4cb', GC_LVT), ('\ud4cc', '\ud4cc', GC_LV),
        ('\ud4cd', '\ud4e7', GC_LVT), ('\ud4e8', '\ud4e8', GC_LV), ('\ud4e9', '\ud503', GC_LVT),
        ('\ud504', '\ud504', GC_LV), ('\ud505', '\ud51f', GC_LVT), ('\ud520', '\ud520', GC_LV),
        ('\ud521', '\ud53b', GC_LVT), ('\ud53c', '\ud53c', GC_LV), ('\ud53d', '\ud557', GC_LVT),
        ('\ud558', '\ud558', GC_LV), ('\ud559', '\ud573', GC_LVT), ('\ud574', '\ud574', GC_LV),
        ('\ud575', '\ud58f', GC_LVT), ('\ud590', '\ud590', GC_LV), ('\ud591', '\ud5ab', GC_LVT),
        ('\ud5ac', '\ud5ac', GC_LV), ('\ud5ad', '\ud5c7', GC_LVT), ('\ud5c8', '\ud5c8', GC_LV),
        ('\ud5c9', '\ud5e3', GC_LVT), ('\ud5e4', '\ud5e4', GC_LV), ('\ud5e5', '\ud5ff', GC_LVT),
        ('\ud600', '\ud600', GC_LV), ('\ud601', '\ud61b', GC_LVT), ('\ud61c', '\ud61c', GC_LV),
        ('\ud61d', '\ud637', GC_LVT), ('\ud638', '\ud638', GC_LV), ('\ud639', '\ud653', GC_LVT),
        ('\ud654', '\ud654', GC_LV), ('\ud655', '\ud66f', GC_LVT), ('\ud670', '\ud670', GC_LV),
        ('\ud671', '\ud68b', GC_LVT), ('\ud68c', '\ud68c', GC_LV), ('\ud68d', '\ud6a7', GC_LVT),
        ('\ud6a8', '\ud6a8', GC_LV), ('\ud6a9', '\ud6c3', GC_LVT), ('\ud6c4', '\ud6c4', GC_LV),
        ('\ud6c5', '\ud6df', GC_LVT), ('\ud6e0', '\ud6e0', GC_LV), ('\ud6e1', '\ud6fb', GC_LVT),
        ('\ud6fc', '\ud6fc', GC_LV), ('\ud6fd', '\ud717', GC_LVT), ('\ud718', '\ud718', GC_LV),
        ('\ud719', '\ud733', GC_LVT), ('\ud734', '\ud734', GC_LV), ('\ud735', '\ud74f', GC_LVT),
        ('\ud750', '\ud750', GC_LV), ('\ud751', '\ud76b', GC_LVT), ('\ud76c', '\ud76c', GC_LV),
        ('\ud76d', '\ud787', GC_LVT), ('\ud788', '\ud788', GC_LV), ('\ud789', '\ud7a3', GC_LVT),
        ('\ud7b0', '\ud7c6', GC_V), ('\ud7cb', '\ud7fb', GC_T), ('\ufb1e', '\ufb1e', GC_Extend),
        ('\ufe00', '\ufe0f', GC_Extend), ('\ufe20', '\ufe2d', GC_Extend), ('\ufeff', '\ufeff',
        GC_Control), ('\uff9e', '\uff9f', GC_Extend), ('\ufff0', '\ufffb', GC_Control),
        ('\U000101fd', '\U000101fd', GC_Extend), ('\U000102e0', '\U000102e0', GC_Extend),
        ('\U00010376', '\U0001037a', GC_Extend), ('\U00010a01', '\U00010a03', GC_Extend),
        ('\U00010a05', '\U00010a06', GC_Extend), ('\U00010a0c', '\U00010a0f', GC_Extend),
        ('\U00010a38', '\U00010a3a', GC_Extend), ('\U00010a3f', '\U00010a3f', GC_Extend),
        ('\U00010ae5', '\U00010ae6', GC_Extend), ('\U00011000', '\U00011000', GC_SpacingMark),
        ('\U00011001', '\U00011001', GC_Extend), ('\U00011002', '\U00011002', GC_SpacingMark),
        ('\U00011038', '\U00011046', GC_Extend), ('\U0001107f', '\U00011081', GC_Extend),
        ('\U00011082', '\U00011082', GC_SpacingMark), ('\U000110b0', '\U000110b2', GC_SpacingMark),
        ('\U000110b3', '\U000110b6', GC_Extend), ('\U000110b7', '\U000110b8', GC_SpacingMark),
        ('\U000110b9', '\U000110ba', GC_Extend), ('\U000110bd', '\U000110bd', GC_Control),
        ('\U00011100', '\U00011102', GC_Extend), ('\U00011127', '\U0001112b', GC_Extend),
        ('\U0001112c', '\U0001112c', GC_SpacingMark), ('\U0001112d', '\U00011134', GC_Extend),
        ('\U00011173', '\U00011173', GC_Extend), ('\U00011180', '\U00011181', GC_Extend),
        ('\U00011182', '\U00011182', GC_SpacingMark), ('\U000111b3', '\U000111b5', GC_SpacingMark),
        ('\U000111b6', '\U000111be', GC_Extend), ('\U000111bf', '\U000111c0', GC_SpacingMark),
        ('\U0001122c', '\U0001122e', GC_SpacingMark), ('\U0001122f', '\U00011231', GC_Extend),
        ('\U00011232', '\U00011233', GC_SpacingMark), ('\U00011234', '\U00011234', GC_Extend),
        ('\U00011235', '\U00011235', GC_SpacingMark), ('\U00011236', '\U00011237', GC_Extend),
        ('\U000112df', '\U000112df', GC_Extend), ('\U000112e0', '\U000112e2', GC_SpacingMark),
        ('\U000112e3', '\U000112ea', GC_Extend), ('\U00011301', '\U00011301', GC_Extend),
        ('\U00011302', '\U00011303', GC_SpacingMark), ('\U0001133c', '\U0001133c', GC_Extend),
        ('\U0001133e', '\U0001133e', GC_Extend), ('\U0001133f', '\U0001133f', GC_SpacingMark),
        ('\U00011340', '\U00011340', GC_Extend), ('\U00011341', '\U00011344', GC_SpacingMark),
        ('\U00011347', '\U00011348', GC_SpacingMark), ('\U0001134b', '\U0001134d', GC_SpacingMark),
        ('\U00011357', '\U00011357', GC_Extend), ('\U00011362', '\U00011363', GC_SpacingMark),
        ('\U00011366', '\U0001136c', GC_Extend), ('\U00011370', '\U00011374', GC_Extend),
        ('\U000114b0', '\U000114b0', GC_Extend), ('\U000114b1', '\U000114b2', GC_SpacingMark),
        ('\U000114b3', '\U000114b8', GC_Extend), ('\U000114b9', '\U000114b9', GC_SpacingMark),
        ('\U000114ba', '\U000114ba', GC_Extend), ('\U000114bb', '\U000114bc', GC_SpacingMark),
        ('\U000114bd', '\U000114bd', GC_Extend), ('\U000114be', '\U000114be', GC_SpacingMark),
        ('\U000114bf', '\U000114c0', GC_Extend), ('\U000114c1', '\U000114c1', GC_SpacingMark),
        ('\U000114c2', '\U000114c3', GC_Extend), ('\U000115af', '\U000115af', GC_Extend),
        ('\U000115b0', '\U000115b1', GC_SpacingMark), ('\U000115b2', '\U000115b5', GC_Extend),
        ('\U000115b8', '\U000115bb', GC_SpacingMark), ('\U000115bc', '\U000115bd', GC_Extend),
        ('\U000115be', '\U000115be', GC_SpacingMark), ('\U000115bf', '\U000115c0', GC_Extend),
        ('\U00011630', '\U00011632', GC_SpacingMark), ('\U00011633', '\U0001163a', GC_Extend),
        ('\U0001163b', '\U0001163c', GC_SpacingMark), ('\U0001163d', '\U0001163d', GC_Extend),
        ('\U0001163e', '\U0001163e', GC_SpacingMark), ('\U0001163f', '\U00011640', GC_Extend),
        ('\U000116ab', '\U000116ab', GC_Extend), ('\U000116ac', '\U000116ac', GC_SpacingMark),
        ('\U000116ad', '\U000116ad', GC_Extend), ('\U000116ae', '\U000116af', GC_SpacingMark),
        ('\U000116b0', '\U000116b5', GC_Extend), ('\U000116b6', '\U000116b6', GC_SpacingMark),
        ('\U000116b7', '\U000116b7', GC_Extend), ('\U00016af0', '\U00016af4', GC_Extend),
        ('\U00016b30', '\U00016b36', GC_Extend), ('\U00016f51', '\U00016f7e', GC_SpacingMark),
        ('\U00016f8f', '\U00016f92', GC_Extend), ('\U0001bc9d', '\U0001bc9e', GC_Extend),
        ('\U0001bca0', '\U0001bca3', GC_Control), ('\U0001d165', '\U0001d165', GC_Extend),
        ('\U0001d166', '\U0001d166', GC_SpacingMark), ('\U0001d167', '\U0001d169', GC_Extend),
        ('\U0001d16d', '\U0001d16d', GC_SpacingMark), ('\U0001d16e', '\U0001d172', GC_Extend),
        ('\U0001d173', '\U0001d17a', GC_Control), ('\U0001d17b', '\U0001d182', GC_Extend),
        ('\U0001d185', '\U0001d18b', GC_Extend), ('\U0001d1aa', '\U0001d1ad', GC_Extend),
        ('\U0001d242', '\U0001d244', GC_Extend), ('\U0001e8d0', '\U0001e8d6', GC_Extend),
        ('\U0001f1e6', '\U0001f1ff', GC_RegionalIndicator), ('\U000e0000', '\U000e00ff',
        GC_Control), ('\U000e0100', '\U000e01ef', GC_Extend), ('\U000e01f0', '\U000e0fff',
        GC_Control)
    ];

}
